/**
 * @file common_debug.h
 * @brief 
 * @author Airead Fan <fgh1987168@gmail.com>
 * @date 2012  2月 21 16:38:00 CST
 */

#ifndef _COMMON_DEBUG_H
#define _COMMON_DEBUG_H

#include <stdio.h>

#define	    ESC_FG_BLACK   "\33[30m"
#define	    ESC_FG_RED   "\33[31m"
#define	    ESC_FG_GREEN   "\33[32m"
#define	    ESC_FG_YELLOW   "\33[33m"
#define	    ESC_FG_BLUE   "\33[34m"
#define	    ESC_FG_MAGENTA   "\33[35m"
#define	    ESC_FG_CYAN   "\33[36m"
#define	    ESC_FG_WHITE   "\33[37m"
#define	    ESC_FG_DEFAULT   "\33[39m"

#ifdef _DEBUG_COLOR
#define STEP_CHECK() \
          fprintf(stderr, ESC_FG_YELLOW "==step into %s:%s:%d\n" \
                  ESC_FG_DEFAULT, __FILE__, __func__, __LINE__)
#define PRINTERR(fmt, args...) \
          fprintf(stderr, ESC_FG_RED "%s:%s:%d: " fmt ESC_FG_DEFAULT,   \
                  __FILE__, __func__, __LINE__, ##args)

#define DBG(fmt, args...) \
          fprintf(stdout, ESC_FG_GREEN "%s:%s:%d: "fmt ESC_FG_DEFAULT, \
                  __FILE__, __func__, __LINE__, ##args)
#else
#define STEP_CHECK()
#define PRINTERR(fmt, args...) \
          fprintf(stderr, ESC_FG_RED "====%s:%s:%d:====\n>>" fmt ESC_FG_DEFAULT,   \
                  __FILE__, __func__, __LINE__, ##args)

#define DBG(fmt, args...) 
#endif

#endif  /* ifndef */
