/**
 * @file count_time.h
 * @brief 
 * @author Airead Fan <fgh1987168@gmail.com>
 * @date 2012/03/21 15:11:56
 */

#ifndef _COUNT_TIME_H_
#define _COUNT_TIME_H_

enum count_time_flag {
    COUNT_TIME_DISABLE,
    COUNT_TIME_NOTHING,
    COUNT_TIME_CHANGED,
    COUNT_TIME_TIMEOUT
};

/**
 * @brief struct count time
 */
struct count_time {
    int wait;                   /**< when is time out */
    int count_time;             /**< changed per seconds */
    long int dead_time;         /**< dead time */
    int last_count_time;        /**< need for chaned per second */
    enum count_time_flag flag; /**< 0 for nothing, 1 for changed, 2 for timeout */
};

int count_time_init(struct count_time *tw, int wait_time);
int count_time_check(struct count_time *tw);
int count_time_disable(struct count_time *ct);

#endif /* _COUNT_TIME_H_ */
