/**
 * @file select.h
 * @brief 
 * @author Airead Fan <fgh1987168@gmail.com>
 * @date 2012  2月 22 14:18:47 CST
 */

#ifndef _SELECT_H
#define _SELECT_H

#include <sys/select.h>

/**
 * @brief select_data, which include all parameters used by select.
 */
struct select_data {
    int nfds; /**< the highest-numbered file descriptor in any of the three sets, plus 1. */
    fd_set readfds; /**< independent sets of file descriptors are watched for readable */
    fd_set writefds; /**< independent sets of file descriptors are watched for writable */
    fd_set exceptfds; /**< independent sets of file descriptors are watched for exception */
    struct timeval timeout; /**< an  upper bound on the amount of time elapsed before select() returns. */
};

struct select_data *select_new(void);
int select_init(struct select_data *self);
int select_register_readfds(struct select_data *self, int connected_fd);

#endif
