/**
 * @file server_main.h
 * @brief 
 * @author Airead Fan <fgh1987168@gmail.com>
 * @date 2012  2月 21 15:25:40 CST
 */

#ifndef _SERVER_H
#define _SERVER_H

#include <sys/select.h>
#include "client.h"
#include "select.h"

#define MAX_CLIENT 10
#define BUFF_SIZE 512
#define COUNT_TIME_VALUE 5

enum server_command {
    CMD_GET_CLIENT_DATA,
    CMD_SEND_SERVER_DATA,
    CMD_SEND_CLIENT_DATA,
    CMD_COUNT_TIME
};

struct server_data {
    int count_time;
    int th;
};

struct command {
    enum server_command type;
    struct server_data server_data;
    struct client_data client_data;
};

/**
 * @brief server data struct
 */
struct server {
    int listen_socket;          /**< server listening socket */
    char *ip_addr;
    unsigned short port;        /**< server listening port */
    int input_fd;
    struct server_data data;
    int client_num;
    struct client c_array[MAX_CLIENT];      /**< client array */
};

int server_main(char *ip_addr, unsigned short port);
int server_get_listen_socket(struct server *self);
int server_add_client(struct server *self);
int server_remove_client(struct server *self, int id);
int server_register_select(struct server *self, struct select_data *sdata);
void server_print(struct server *self);
int server_get_result(struct server *self);

#endif
