/********************************************************
 * @author  Airead Fan <fgh1987168@gmail.com>
 * @date    2012  2月 20 13:50:17 CST
 ********************************************************/

#ifndef _CHAT_H
#define _CHAT_H

#define CLIENT_MAX 64
#define NAME_MAX 128
#define BUFFER_LINE 100
#define MESSAGE_MAX 1024

struct server {
    char name[NAME_MAX];
    char *ip;
    unsigned short port;
    int backlog;
    int listening_socket;
    char connfd_list[CLIENT_MAX];
    char *client_names[CLIENT_MAX];
};

struct client {
    char server_ip;
    char server_port;
    char client_name[NAME_MAX];
    char messages[MESSAGE_MAX];
};

struct chat_data {
    char server_name[NAME_MAX];
    char *client_name[CLIENT_MAX]; /* user name */
    char *chat_content[BUFFER_LINE];
};

struct select_data {
    int nfds;
    fd_set readfds;
    fd_set writefds;
    fd_set exceptfds;
    struct timeval timeout;
};

enum select_fdset_type {
    SELECT_DATA_READ,
    SELECT_DATA_WRITE,
    SELECT_DATA_EXCEPT
};

#endif
