/**
 * @file count_time.c
 * @brief 
 * @author Airead Fan <fgh1987168@gmail.com>
 * @date 2012/03/21 15:11:57
 */

#include <time.h>

#include "count_time.h"

int count_time_init(struct count_time *ct, int wait_time) 
{
    ct->wait = wait_time;
    ct->dead_time = time(NULL) + wait_time;
    ct->count_time = 0;
    ct->last_count_time = 0;
    ct->flag = COUNT_TIME_NOTHING;

    return 0;
}

/**
 * @brief time check
 * @param ct
 * @return 0 for nothing, 1 for count change, 2 for timeout
 */
int count_time_check(struct count_time *ct)
{
    long int t;

    if (ct->flag == COUNT_TIME_DISABLE) {
        return COUNT_TIME_DISABLE;
    }

 
    ct->flag = COUNT_TIME_NOTHING;

    t = time(NULL);
    ct->count_time = ct->dead_time - t;
    if (ct->count_time < 0) {
        ct->dead_time = t + ct->wait;
        ct->flag = COUNT_TIME_TIMEOUT;               /* timeout */
    }
    
    if (ct->count_time != ct->last_count_time && ct->count_time >= 0) {
        ct->last_count_time = ct->count_time;
        ct->flag = COUNT_TIME_CHANGED;                /* count changed */
    }

    return ct->flag;
}

int count_time_disable(struct count_time *ct)
{
    ct->flag = COUNT_TIME_DISABLE;

    return 0;
}
