/**
 * @file main.c
 * @brief switch server or client
 * @author Airead Fan <fgh1987168@gmail.com>
 * @date 2012  2月 21 15:04:30 CST
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "server.h"
#include "client.h"

/**
 * @brief main function
 * 
 * It is just a switch by which you chose to run server or client.
 *
 * @todo check ip address and port validity
 */
int main(int argc, char *argv[])
{
    char *ip_addr;
    unsigned short port;

    if (argc < 4) {
        fprintf(stderr, "usage: %s <server/client> <ip_addr> <port>\n", argv[0]);
        exit(1);
    }

    /* TODO: check ip address and port validity  */
    ip_addr = argv[2];
    port = strtol(argv[3], NULL, 10);
    
    if (strcmp(argv[1], "server") == 0
        || strcmp(argv[1], "s") == 0) {
        if (server_main(ip_addr, port) < 0) {
            fprintf(stderr, "start server_main failed\n");
            exit(1);
        }
    } else if (strcmp(argv[1], "client") == 0
               || strcmp(argv[1], "c") == 0) {
        if (client_main(ip_addr, port) < 0) {
            fprintf(stderr, "start server_main failed\n");
            exit(1);
        }
    } else {
        fprintf(stderr, "usage: %s <server/client> <ip_addr> <port>\n", argv[0]);
        exit(1);
    }
    
    return 0;
}
