//
//  runtime.h
//  FrameworkPrototype
//
//  Created by Robert Hoferkamp on 11/4/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#ifndef FrameworkPrototype_runtime_h
#define FrameworkPrototype_runtime_h

// constants

#define DEFAULT_RESOURCE_DIR "Game.app/Contents/Resources"

// structs

typedef struct
{
    // set by framework
	int screen_width;
	int screen_height;
    int fps;
    char* resource_dir_ptr;
    // set by runtime
	surface_ptr_t surface_ptr;
	int frames;
}
runtime_t;

// public

extern runtime_t runtime;

void runtime_init(void);
void runtime_run(void);
void runtime_exit(void);

void runtime_set_resource_dir(char* resource_dir_ptr);

// runtime functions necessary for sprites, text, menus (to be called by framework)

// surfaces
surface_ptr_t runtime_alloc_file_surface(char* file_name_ptr, color_ptr_t color_key_ptr);
surface_ptr_t runtime_alloc_color_surface(color_ptr_t color_ptr, int width, int height, color_ptr_t color_key_ptr);
surface_ptr_t runtime_alloc_font_surface(char* font_name_ptr, int font_size, color_ptr_t color_ptr, char* string_ptr);
void runtime_free_surface(surface_ptr_t* surface_ptr_ptr);

int runtime_surface_width(surface_ptr_t surface_ptr);
int runtime_surface_height(surface_ptr_t surface_ptr);

void runtime_blit_surface(surface_ptr_t surface_ptr, int x, int y);
void runtime_blit_surface_to_surface(surface_ptr_t src_surface_ptr, surface_ptr_t dest_surface_ptr, int x, int y);

surface_ptr_t runtime_scale_surface(surface_ptr_t surface_ptr, int width, int height);
void runtime_fill_surface(surface_ptr_t surface_ptr, color_ptr_t color_ptr);

// background
void runtime_clear_background(void);

// drawing
void runtime_draw_line(surface_ptr_t surface_ptr, int x1, int y1, int x2, int y2, color_ptr_t color_ptr);
void runtime_draw_circle(surface_ptr_t surface_ptr, int x, int y, int r, color_ptr_t color_ptr);

// misc
int runtime_rand(int range);

#endif
