//
//  options_screen.c
//  FrameworkPrototype
//
//  Created by Robert Hoferkamp on 12/17/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#include <stdio.h>
#include <stdbool.h>
#include <string.h>

#include "framework.h"
#include "runtime.h"
#include "game.h"
#include "options_screen.h"

#define OPTIONS_MENU_INDEX 0

screen_ptr_t options_screen_ptr;

void options_screen_alloc(screen_ptr_t screen_ptr)
{
    /*** debug ***/ fprintf(stdout, "[Trace] options_screen_alloc()\n");
    
    int x_res = runtime.screen_width;
    // int y_res = runtime.screen_height;

    // create trace text
    text_ptr_t trace_text_ptr = text_alloc("DejaVuSans", 24, &color_white, "Options", 0, 0, 0);
    trace_text_ptr->x = x_res / 2 - runtime_surface_width(trace_text_ptr->surface_ptr) / 2;
    trace_text_ptr->y = runtime_surface_height(trace_text_ptr->surface_ptr) / 4;
    screen_add_text(screen_ptr, trace_text_ptr);
    
    // create a menu [OPTIONS_MENU_INDEX]
    menu_ptr_t menu_ptr = menu_text_alloc("options", text_alloc("DejaVuSans", 32, &color_white, "Options", 0, 0, 0), 27, mod_key_none, anchor_center, 0, 0, true);
    screen_add_menu(screen_ptr, menu_ptr);
    
    // create a menu item
    menu_item_ptr_t menu_item_1_ptr = menu_item_text_alloc("return", text_alloc("DejaVuSans", 32, &color_white, "Return", 0, 0, 0), '1', mod_key_none, options_screen_menu_item_task);
    menu_add_menu_item(menu_ptr, menu_item_1_ptr);
}

void options_screen_init(screen_ptr_t screen_ptr)
{
    /*** debug ***/ fprintf(stdout, "[Trace] options_screen_init()\n");
}

void options_screen_input_task(screen_ptr_t screen_ptr, input_state_ptr_t input_state_ptr)
{
    /*** debug ***/ // fprintf(stdout, "[Trace] options_screen_input_task()\n");

    // ...
}

void options_screen_menu_item_task(menu_item_ptr_t menu_item_ptr, menu_ptr_t menu_ptr)
{
    /*** debug ***/ fprintf(stdout, "[Trace] options_screen_menu_item_task()\n");
    
    /*** debug ***/ fprintf(stdout, "[Debug] menu item string = %s\n", menu_item_ptr->string_ptr);
    
    if (strcmp(menu_item_ptr->string_ptr, "return") == 0)
    {
        game_set_screen(game.previous_screen_ptr);
    }
}

void options_screen_exit(screen_ptr_t screen_ptr)
{
    /*** debug ***/ fprintf(stdout, "[Trace] options_screen_exit()\n");
    
    // background, sprites, text and menus are freed by screen_free
}
