#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <fcntl.h>

#include <glib.h>

#include "ports.h"
#include "repository.h"
#include "driver_base.h"
#include "collection.h"
#include "package.h"
#include "debug.h"
#include "common.h"

#include <errno.h>

LogLevel LOGLEVEL;
char* LOGDIRECTORY;

void debug_log(LogLevel log_level, const char* format, ...)
{
	va_list pars;
	char message[16358];
	char line[16384];
	char now[80];
	char logfile[512];
	time_t logtime;
	struct tm* Now;
	int fh;

	time (&logtime);
	Now = localtime (&logtime);

	memset(message, 0, sizeof(message));
	memset(line, 0, sizeof(line));

	va_start (pars, format);
	(void)vsprintf (message, format, pars);
	va_end (pars);

	if (log_level <= LOGLEVEL) {
		strftime (now, sizeof(now)-1, "%Y-%m-%d %H:%M:%S", Now);
		memset (logfile, 0, sizeof (logfile));
		snprintf (logfile, sizeof (logfile), "%s/%s.log", LOGDIRECTORY, PACKAGE);
		fh = open (logfile, O_WRONLY|O_CREAT|O_APPEND, 0666);
		if (!fh) {
			LOGLEVEL = NONE;
			fprintf (stderr, "%s: [%d] %s\n", PACKAGE, errno, strerror (errno));
		} else {
			snprintf (line, sizeof (line), "[%s][%c] %s\n", now, loglevel2a(log_level), message);
			write (fh, line, strlen (line));
			close (fh);
		}
	}
}

