#ifndef __DRIVER_BASE_H__
#define __DRIVER_BASE_H__

typedef int (*load_config_file_func)(Repository* repository);
typedef int (*exec_func)(Ports* ports, const char* cmd, char** stdresult);

typedef struct {
	DriverType driver_type;
	char command[255];
	
	load_config_file_func load_config_file;
	exec_func exec;
	exec_func exec_shell;

	Ports* ports;
} DriverBase;

DriverBase* driver_base_new(DriverType driver_type);

int cvsup_driver_load_config_file(Repository* repository);

int httpup_driver_load_config_file(Repository* repository);

int rsync_driver_load_config_file(Repository* repository);

gint compare_collection_list_data(gconstpointer object1, gconstpointer object2);

#endif /* __DRIVER_BASE_H__ */
