#ifndef __INTERFACE_H__
#define __INTERFACE_H__

enum {
	INSTALLED_COLUMN,
	NAME_COLUMN,
	CURRENT_VERSION_COLUMN,
	NEW_VERSION_COLUMN,
	INFOS_COLUMN,
	CHECKED_COLUMN,
	N_COLUMNS
};

typedef struct {
	GtkWidget *win;
	Ports *ports;
	
	GtkWidget *update1;
	GtkWidget *diff1;
	GtkWidget *list1;
	GtkWidget *sysup1;
	GtkWidget *clean_all1;
	
	GtkWidget *update_tbt;
	GtkWidget *diff_tbt;
	GtkWidget *list_tbt;
	GtkWidget *installed_tbt;
	
	GtkWidget *ports_tree_view;
	GtkTreeStore* ports_tree_store;
	
	GtkWidget *infos_sb;
	GtkWidget *load_pb;
	
	GtkAccelGroup *accel_group;
	GtkTooltips *tooltips;
} MainWindow;

typedef struct {
	GtkWidget *dialog;
	
	GtkWidget *txt_result;
	GtkWidget *btn_close;
} ResultDialog;

ResultDialog* results_dlg;


MainWindow* create_main_window();
ResultDialog* create_results_dlg(MainWindow* main_win);
void show_main_window(MainWindow* main_win);

void do_events(void);
void add_results(const char* format, va_list va);

#endif /* __INTERFACE_H__ */
