#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <glib.h>

#include "ports.h"
#include "packages_db.h"
#include "repository.h"
#include "driver_base.h"
#include "collection.h"
#include "package.h"
#include "common.h"
#include "debug.h"

const char* pkg_db_file = "/var/lib/pkg/db\0";

GHashTable* load_packages_db_file()
{
	GHashTable* pkg_db = NULL;
	FILE* fh;
	char* buffer;
	int buflen = 0;
	char* newline;
	int step;
	char pkg_name[100];
	char pkg_version[100];

	fh = fopen(pkg_db_file, "r");
	if (!fh) {
		debug_log(ERROR, "load_packages_dg_file(): Could not open %s file", pkg_db_file);
		return NULL;
	}

	// Initialize context
	step = 0;
	memset(pkg_name, 0, sizeof(pkg_name));
	memset(pkg_version, 0, sizeof(pkg_version));
	pkg_db = g_hash_table_new(g_str_hash, g_str_equal);

	// Parse the installed ports db
	while (getline(&buffer, &buflen, fh) != -1) {
		newline = strchr(buffer, '\n');
		if (newline)
			*newline = 0;
		if (*buffer == 0)
			step = 0;
		else if (step == 0) {
			strcpy(pkg_name, buffer);
			step++;
		} else if (step == 1) {
			strcpy(pkg_version, buffer);
			g_hash_table_insert (pkg_db, strdup (pkg_name), strdup (pkg_version));
			step++;
		}
	}
	fclose(fh);
	if (buffer)
		free(buffer);

	return pkg_db;
}

void foreach_packages_db_printf(gpointer key, gpointer value, gpointer user_data)
{
	printf(PACKAGE_FORMAT_STRING, (char*)key, (char*)value, "", "");
}
