#ifndef __PORTS_H__
#define __PORTS_H__

typedef void (*print_func) (const char* format, va_list va);
typedef void (*refresh_func) (void);

typedef struct {
	GList* repositories;
	print_func print;
	refresh_func refresh;
} Ports;

void ports_list_packages(Ports* _ports);

void ports_list_differences(Ports* _ports);

void ports_list_installed(Ports* _ports);

void ports_update(Ports* _ports);

void ports_update_repository(Ports* _ports, const char* repo_name);

//void ports_clean(Ports* _ports);

//void ports_clean_package(Ports* _ports, const char* pkg_name);

void ports_on_refresh(Ports* _ports);

void ports_on_print(const Ports* _ports, const char* format, ...);

Ports* ports_new();

#endif /* __PORTS_H__ */
