/** @file nxt.h
 *  @brief Definitions of the NXT's hardware characteristics.
 */

/* Copyright (C) 2007 the NxOS developers
 *
 * See AUTHORS for a full list of the developers.
 *
 * Redistribution of this file is permitted under
 * the terms of the GNU Public License (GPL) version 2.
 */

#ifndef __NXOS_BASE_NXT_H__
#define __NXOS_BASE_NXT_H__

/** @addtogroup typesAndUtils */
/*@{*/

/** The number of motor ports on the NXT. */
#define NXT_N_MOTORS   3
/** The number of sensor ports on the NXT. */
#define NXT_N_SENSORS  4
/** The NXT's clock frequency, in Hz. */
#define NXT_CLOCK_FREQ 48000000

/*@}*/

#endif /* __NXOS_BASE_NXT_H__ */
