numal
=====

Numerical Algorithms in C

This is the complete code for the classic Numerical Algorithms in ALGOL
(NUMAL) library, translated to C.

I added some makefiles that allow it to compile on modern machines
(though only linux has been tested recently).

Many of the routines are no longer state-of-the-art, but the code is still
an interesting and useful reference. The library is also quite compact, and
it is easy to pick out individual files. I suspect it would be reasonably
fast and sufficiently accurate for many problems (except linear algebra;
I would stay away from chapter 3).

- CHAPTER1 — Basic vector, matrix, complex number, and long integer operations

- CHAPTER2 — Finite series and polynomials

- CHAPTER3 — Linear algebra

- CHAPTER4 — Analytic evaluations: infinite series, integrals, differentiation

- CHAPTER5 — Non-linear solvers, optimization, differential equations

- CHAPTER6 — Special functions

- CHAPTER7 — Interpolation and approximation
