/*
 * libtwitc - C Support Library for Twitter
 * Copyright (C) 2012 Orazio Briante orazio.briante@hotmail.it
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/** \mainpage libtwitc API documentation
 *
 *
 * <H2>README</H2>
 *
 * @verbinclude README
 *
 */

/**
 * @page ortpextension_readme README
 * @verbinclude README
 */

/**
 * @page ortpextension_install INSTALL
 * @verbinclude INSTALL
 */

/**
 * @page ortpextension_license COPYING
 * @verbinclude COPYING
 */

/**
 * @page ortpextension_changelog ChangeLog
 * @verbinclude ChangeLog
 */

/**
 * \file twitc.h
 * \brief The Main Header to Import
 *
 * This Header File Contain All library Imports
 **/

#ifndef TWCORE_H_
#define TWCORE_H_

#include <twitc/stdredef.h>
#include <twitc/functions.h>
#include <twitc/http.h>
#include <twitc/twitter.h>
#include <twitc/oauth.h>
#include <twitc/status.h>
#include <twitc/timeline.h>
#include <twitc/dm.h>
#include <twitc/favorites.h>
#include <twitc/twitcver.h>


#endif /* TWCORE_H_ */
