/*********************************************************************
 *
 * Copyright (C) 2001-2003,  Simon Kagstrom <ska@bth.se>
 *
 * Filename:      bitmaps.h
 * Description:   This file contains the bitmaps used in the
 *                arkanoid game.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *
 * $Id: bitmaps.h,v $
 *
 ********************************************************************/
#ifndef BITMAPS_H
#define BITMAPS_H
#include <sysdeps/typedefs.h>

uint8_t p_block_normal_bitmap[] =
{
  20, 10,
  0x00, 0x00, 0x00,
  0x3f, 0xff, 0xc0,
  0x5c, 0x00, 0x20,
  0x60, 0x00, 0x20,
  0x60, 0x00, 0x20,
  0x60, 0x00, 0x20,
  0x40, 0x00, 0x20,
  0x40, 0x00, 0x20,
  0x3f, 0xff, 0xc0,
  0x00, 0x00, 0x00,
};

uint8_t p_block_hard_bitmap[] =
{
  20, 10,
  0x00, 0x00, 0x00,
  0x3f, 0xff, 0xc0,
  0x7f, 0x40, 0x20,
  0x78, 0x00, 0x20,
  0x70, 0x00, 0x60,
  0x60, 0x00, 0x60,
  0x60, 0x01, 0xe0,
  0x40, 0x2f, 0xe0,
  0x3f, 0xff, 0xc0,
  0x00, 0x00, 0x00,
};

uint8_t p_block_impossible_bitmap[] =
{
  20, 10,
  0x00, 0x00, 0x00,
  0x3f, 0xff, 0xc0,
  0x7c, 0x03, 0xe0,
  0x60, 0x00, 0x60,
  0x7f, 0xff, 0xe0,
  0x7f, 0xff, 0xe0,
  0x60, 0x00, 0x60,
  0x7c, 0x03, 0xe0,
  0x3f, 0xff, 0xc0,
  0x00, 0x00, 0x00,
};

uint8_t p_paddle_normal_bitmap[] =
{
  24, 6,
  0x1f, 0xff, 0xf8,
  0x60, 0x00, 0x06,
  0x40, 0x00, 0x02,
  0x80, 0x00, 0x01,
  0xc0, 0x00, 0x03,
  0xff, 0xff, 0xff,

};

uint8_t p_paddle_short_bitmap[] =
{
  16, 6,
  0x1f, 0xf8,
  0x60, 0x06,
  0x40, 0x02,
  0x80, 0x01,
  0xc0, 0x03,
  0xff, 0xff,
};

uint8_t p_paddle_long_bitmap[] =
{
  32, 6,
  0x1f, 0xff, 0xff, 0xf8,
  0x60, 0x00, 0x00, 0x06,
  0x40, 0x00, 0x00, 0x02,
  0x80, 0x00, 0x00, 0x01,
  0xc0, 0x00, 0x00, 0x03,
  0xff, 0xff, 0xff, 0xff,
};

uint8_t p_ball_bitmap[] =
{
  4, 4,
  0x60,
  0xb0,
  0xf0,
  0x60,
};

uint8_t p_special_bitmap[] =
{
  6, 8,
  0x78,
  0xf4,
  0xc4,
  0xc4,
  0x84,
  0xc4,
  0x84,
  0x78,
};

#endif /* BITMAPS_H */
