/*********************************************************************
 * Copyright (C) 2002,  Simon Kagstrom
 *
 * Filename:      advgame_bitmaps.h
 * Description:   Bitmap data for things like buttons, common
 *                between games.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *
 * $Id: advgame_bitmaps.h 6264 2006-01-21 09:46:06Z ska $
 *
 *********************************************************************/

#ifndef ADVGAME_BITMAPS_H
#define ADVGAME_BITMAPS_H

#include "typedefs.h"

/* This will consume 384 bytes in the library. */
uint8_t button_bitmaps[] =
{
  /* Look */
  32, 16,
  0x7f, 0xff, 0xff, 0xfe,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x80, 0x08, 0x01,
  0x80, 0x80, 0x08, 0x01,
  0x80, 0x98, 0xc9, 0x01,
  0x80, 0xa5, 0x2a, 0x01,
  0x80, 0xa5, 0x2e, 0x01,
  0x80, 0xa5, 0x2a, 0x01,
  0x80, 0x98, 0xc9, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x7f, 0xff, 0xff, 0xfe,

  /* Use */
  32, 16,
  0x7f, 0xff, 0xff, 0xfe,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x49, 0xcc, 0x01,
  0x80, 0x4b, 0x12, 0x01,
  0x80, 0x49, 0x9e, 0x01,
  0x80, 0x48, 0xd0, 0x01,
  0x80, 0x3b, 0x8e, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x7f, 0xff, 0xff, 0xfe,

  /* Take */
  32, 16,
  0x7f, 0xff, 0xff, 0xfe,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x80, 0x80, 0x01,
  0x80, 0x80, 0x80, 0x01,
  0x80, 0xde, 0x93, 0x01,
  0x80, 0x82, 0xa4, 0x81,
  0x80, 0x8e, 0xe7, 0x81,
  0x80, 0x92, 0xa4, 0x01,
  0x80, 0xde, 0x93, 0x81,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x7f, 0xff, 0xff, 0xfe,

  /* Quit */
  32, 16,
  0x7f, 0xff, 0xff, 0xfe,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x14, 0x01,
  0x80, 0x00, 0x04, 0x01,
  0x80, 0x3a, 0x5e, 0x01,
  0x80, 0x4a, 0x54, 0x01,
  0x80, 0x4a, 0x54, 0x01,
  0x80, 0x4a, 0x54, 0x01,
  0x80, 0x39, 0xd6, 0x01,
  0x80, 0x08, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x80, 0x00, 0x00, 0x01,
  0x7f, 0xff, 0xff, 0xfe,
};

#endif /* ADVGAME_BITMAPS_H */
