/*********************************************************************
 * Copyright (C) 2002,  Simon Kagstrom
 *
 * Filename:      bitmap_hdr.h
 * Description:   GENERATED bitmap file. Do not change this!
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *
 *********************************************************************/

#ifndef BITMAPS_H
#define BITMAPS_H

#include "typedefs.h"

#define NR_TILES          37 /* The number of tiles*/
#define NR_OBJECTS         5 /* The total number of objects */
const uint8_t p_background_data[] =
{
  /* Grass (A) */
  16, 16,
  0x00, 0x00, 
  0x00, 0x00, 
  0x40, 0x00, 
  0xb0, 0x08, 
  0x00, 0x04, 
  0x00, 0x04, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x40, 
  0x00, 0x82, 
  0x00, 0x80, 
  0x10, 0x00, 
  0x28, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x01, 
  /* Road left (B) */
  16, 16,
  0x08, 0x00, 
  0x08, 0x00, 
  0x04, 0x00, 
  0x44, 0x00, 
  0xa4, 0x00, 
  0x0c, 0x00, 
  0x08, 0x20, 
  0x08, 0x00, 
  0x08, 0x00, 
  0x08, 0x00, 
  0x08, 0x00, 
  0x18, 0x00, 
  0x10, 0x00, 
  0x10, 0x00, 
  0x10, 0x00, 
  0x10, 0x00, 
  /* Road middle (C) */
  16, 16,
  0x00, 0x04, 
  0x00, 0x00, 
  0x00, 0x40, 
  0x00, 0xc0, 
  0x20, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x01, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x04, 
  0x00, 0x00, 
  0x10, 0x00, 
  /* Road right (D) */
  16, 16,
  0x00, 0x08, 
  0x00, 0x08, 
  0x80, 0x08, 
  0x00, 0x08, 
  0x00, 0x18, 
  0x00, 0x10, 
  0x00, 0x10, 
  0x00, 0x10, 
  0x00, 0x10, 
  0x04, 0x10, 
  0x00, 0x32, 
  0x00, 0x25, 
  0x00, 0x20, 
  0x00, 0x20, 
  0x00, 0x10, 
  0x00, 0x10, 
  /* Horizontal road up (E) */
  16, 16,
  0x00, 0x10, 
  0x00, 0x08, 
  0x00, 0x10, 
  0xf8, 0x00, 
  0x0f, 0xe3, 
  0x00, 0x3c, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x40, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  /* Horizontal road up (F) */
  16, 16,
  0x00, 0x04, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x02, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x3c, 0x00, 
  0xc7, 0xf0, 
  0x00, 0x1f, 
  0x08, 0x00, 
  0x04, 0x00, 
  0x08, 0x00, 
  /* Road vertical to horisontal up (G) */
  16, 16,
  0x00, 0x02, 
  0x00, 0x05, 
  0x00, 0x00, 
  0x01, 0xe0, 
  0xfe, 0x38, 
  0x00, 0x04, 
  0x00, 0x26, 
  0x00, 0x02, 
  0x40, 0x02, 
  0x00, 0x02, 
  0x00, 0x02, 
  0x00, 0x06, 
  0x00, 0x04, 
  0x00, 0x04, 
  0x10, 0x04, 
  0x00, 0x0c, 
  /* Road vertical to horisontal down (H) */
  16, 16,
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x02, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x30, 0x00, 
  0xc8, 0x00, 
  0x08, 0x02, 
  0x08, 0x00, 
  0x18, 0x80, 
  0x08, 0x00, 
  /* Road horisontal to vertical left (I) */
  16, 16,
  0x08, 0x00, 
  0x08, 0x00, 
  0x04, 0x00, 
  0x44, 0x00, 
  0xf8, 0x00, 
  0x00, 0x00, 
  0x00, 0x20, 
  0x00, 0x00, 
  0x40, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x10, 0x00, 
  0x00, 0x00, 
  /* Road horisontal to vertical right (J) */
  16, 16,
  0x00, 0x10, 
  0x01, 0x18, 
  0x00, 0x10, 
  0x40, 0x10, 
  0x00, 0x13, 
  0x00, 0x0c, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x40, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  /* House floor mid mid (K) */
  16, 16,
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x07, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x38, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x38, 0x00, 
  0x00, 0x0e, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  /* Rock (L) */
  16, 16,
  0x01, 0xc0, 
  0x07, 0x78, 
  0x08, 0x06, 
  0x10, 0x41, 
  0x21, 0xb1, 
  0x28, 0x82, 
  0x68, 0x82, 
  0x47, 0x19, 
  0x61, 0x81, 
  0xd0, 0x61, 
  0x90, 0x31, 
  0x91, 0x01, 
  0x42, 0x01, 
  0x3c, 0x2e, 
  0x07, 0xf0, 
  0x00, 0x00, 
  /* Tree (M) */
  16, 16,
  0x3f, 0xf8, 
  0x26, 0x08, 
  0x23, 0x0c, 
  0x60, 0x06, 
  0x40, 0x1e, 
  0x44, 0xf1, 
  0x67, 0x81, 
  0xb8, 0x03, 
  0x88, 0x02, 
  0xc0, 0x3e, 
  0x7d, 0xe4, 
  0x32, 0x08, 
  0x0f, 0xf0, 
  0x07, 0xe0, 
  0x07, 0xc0, 
  0x00, 0x00, 
  /* House down left (N) */
  16, 16,
  0x1f, 0xff, 
  0x10, 0x00, 
  0x10, 0x00, 
  0x10, 0x00, 
  0x10, 0x00, 
  0x10, 0x00, 
  0x10, 0x00, 
  0x20, 0x00, 
  0x20, 0x00, 
  0x20, 0x00, 
  0x20, 0x00, 
  0x3f, 0xff, 
  0x08, 0xe2, 
  0x11, 0xc2, 
  0x10, 0x04, 
  0x1f, 0xff, 
  /* House down right (O) */
  16, 16,
  0xff, 0xff, 
  0x00, 0x01, 
  0x00, 0x01, 
  0x00, 0x01, 
  0x00, 0x01, 
  0x00, 0x01, 
  0x00, 0x01, 
  0x00, 0x02, 
  0x00, 0x02, 
  0x00, 0x02, 
  0x00, 0x02, 
  0xff, 0xfe, 
  0x41, 0xc4, 
  0x43, 0x84, 
  0x80, 0x04, 
  0xff, 0xf8, 
  /* House up left (P) */
  16, 16,
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x18, 
  0x1c, 0x7c, 
  0x36, 0x5c, 
  0x23, 0x30, 
  0x2d, 0x00, 
  0x1b, 0x00, 
  0x00, 0x00, 
  0x3f, 0xff, 
  0x20, 0x00, 
  0x20, 0x00, 
  0x20, 0x00, 
  0x20, 0x00, 
  0x20, 0x00, 
  /* House up right (Q) */
  16, 16,
  0x00, 0xe0, 
  0x01, 0xb0, 
  0x01, 0x10, 
  0x01, 0xf0, 
  0x30, 0x00, 
  0x78, 0x0c, 
  0xc8, 0x3c, 
  0xbc, 0x24, 
  0xf0, 0x3e, 
  0x00, 0x00, 
  0xff, 0xfc, 
  0x00, 0x02, 
  0x00, 0x02, 
  0x00, 0x02, 
  0x00, 0x02, 
  0x00, 0x02, 
  /* Mountain up left (R) */
  16, 16,
  0x00, 0x00, 
  0x00, 0xf8, 
  0x03, 0x8d, 
  0x0f, 0x07, 
  0x18, 0x02, 
  0x30, 0x00, 
  0x20, 0x00, 
  0x60, 0x00, 
  0x83, 0x81, 
  0xc6, 0xc1, 
  0x44, 0x41, 
  0x60, 0x60, 
  0x20, 0x00, 
  0x20, 0x01, 
  0x60, 0x02, 
  0xc0, 0x02, 
  /* Mountain up middle (S) */
  16, 16,
  0xe0, 0x00, 
  0xb8, 0x1f, 
  0x8f, 0xe0, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x10, 0x78, 
  0x18, 0x88, 
  0x0c, 0x0d, 
  0x04, 0x04, 
  0x04, 0x00, 
  0x84, 0x00, 
  0x88, 0x00, 
  0x80, 0x30, 
  0x80, 0xe0, 
  0x01, 0x80, 
  0x03, 0x00, 
  /* Mountain up right (T) */
  16, 16,
  0x00, 0x00, 
  0x9f, 0x00, 
  0xf0, 0x80, 
  0x00, 0x60, 
  0x1c, 0x20, 
  0xf0, 0x18, 
  0x80, 0x0c, 
  0x83, 0x06, 
  0x01, 0x02, 
  0x00, 0xc2, 
  0x00, 0x62, 
  0x00, 0x24, 
  0x00, 0x36, 
  0x20, 0xe2, 
  0x20, 0x06, 
  0x40, 0x04, 
  /* Mountain middle left (U) */
  16, 16,
  0x81, 0x02, 
  0x81, 0x80, 
  0xc0, 0x80, 
  0x44, 0x80, 
  0x64, 0x80, 
  0x28, 0x87, 
  0x28, 0x00, 
  0x68, 0x00, 
  0x40, 0x00, 
  0x41, 0xe0, 
  0x43, 0x20, 
  0x42, 0x00, 
  0x68, 0x00, 
  0x28, 0x0e, 
  0x28, 0x98, 
  0x28, 0xb0, 
  /* Mountain middle middle (V) */
  16, 16,
  0x02, 0x00, 
  0x00, 0x01, 
  0x00, 0x02, 
  0x00, 0x06, 
  0x00, 0x08, 
  0xc0, 0x00, 
  0x78, 0x00, 
  0x04, 0x00, 
  0x04, 0x00, 
  0x04, 0x00, 
  0x00, 0x08, 
  0x00, 0x3c, 
  0x00, 0x26, 
  0x00, 0x01, 
  0x00, 0x00, 
  0x00, 0x00, 
  /* Mountain middle right (W) */
  16, 16,
  0x84, 0x0e, 
  0x84, 0x0a, 
  0x0c, 0x1a, 
  0x08, 0x32, 
  0x0c, 0x4a, 
  0x04, 0x02, 
  0x06, 0x02, 
  0x02, 0x22, 
  0x00, 0x0a, 
  0x00, 0x4e, 
  0x00, 0x43, 
  0x00, 0x41, 
  0x00, 0x42, 
  0x80, 0x42, 
  0x00, 0x02, 
  0x00, 0x22, 
  /* Mountain down left (X) */
  16, 16,
  0x28, 0xe0, 
  0x20, 0x00, 
  0x60, 0x00, 
  0x40, 0x00, 
  0xcc, 0x00, 
  0x90, 0x0c, 
  0xa7, 0xf8, 
  0x80, 0x00, 
  0x80, 0x00, 
  0xc0, 0x00, 
  0x60, 0x00, 
  0x20, 0x01, 
  0x21, 0xdf, 
  0x3f, 0x70, 
  0x00, 0x00, 
  0x00, 0x00, 
  /* Mountain down middle (Y) */
  16, 16,
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x0f, 0x80, 
  0x18, 0x81, 
  0x10, 0x82, 
  0x00, 0x86, 
  0x00, 0xc4, 
  0x00, 0x04, 
  0x00, 0x08, 
  0xe0, 0x00, 
  0xb0, 0x00, 
  0x1e, 0x18, 
  0x03, 0xec, 
  0x00, 0x07, 
  0x00, 0x00, 
  /* Mountain down right (Z) */
  16, 16,
  0x00, 0x26, 
  0x00, 0x24, 
  0x00, 0x64, 
  0x01, 0xc4, 
  0xe1, 0x04, 
  0x38, 0x02, 
  0x00, 0x06, 
  0x00, 0x04, 
  0x00, 0x0c, 
  0x00, 0x18, 
  0x00, 0x30, 
  0x0e, 0x60, 
  0x1b, 0xc0, 
  0x10, 0x00, 
  0xf0, 0x00, 
  0x00, 0x00, 
  /* House floor up left ([) */
  16, 16,
  0x8e, 0x00, 
  0x7f, 0xff, 
  0x40, 0x06, 
  0xaf, 0xff, 
  0x90, 0x40, 
  0x9f, 0xff, 
  0xa8, 0x00, 
  0xa9, 0xc0, 
  0xa8, 0x00, 
  0xe8, 0x00, 
  0xe8, 0x00, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xb8, 0x00, 
  0xe8, 0x0e, 
  0xe8, 0x00, 
  /* House floor up mid (\) */
  16, 16,
  0x70, 0x78, 
  0xff, 0xff, 
  0x00, 0x00, 
  0xff, 0xff, 
  0x08, 0x22, 
  0xff, 0xff, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0xe0, 0x00, 
  0x00, 0x70, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  /* House floor up right (]) */
  16, 16,
  0x0e, 0x0d, 
  0xff, 0xfe, 
  0x30, 0x02, 
  0xff, 0xf5, 
  0x00, 0x49, 
  0xff, 0xfb, 
  0x00, 0x17, 
  0x00, 0x17, 
  0x1c, 0x15, 
  0x00, 0x15, 
  0x00, 0x1d, 
  0x00, 0x15, 
  0x01, 0xd7, 
  0x00, 0x17, 
  0x00, 0x15, 
  0x70, 0x15, 
  /* House floor mid left (^) */
  16, 16,
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xb8, 0x00, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xab, 0x80, 
  0xe8, 0x00, 
  0xe8, 0x00, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xb8, 0x00, 
  0xe8, 0x00, 
  0xe8, 0x1c, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xb8, 0x00, 
  /* House floor mid right (_) */
  16, 16,
  0x00, 0x15, 
  0x00, 0x1d, 
  0x00, 0x15, 
  0x00, 0x15, 
  0x00, 0x1d, 
  0x00, 0x17, 
  0x00, 0x17, 
  0x00, 0x15, 
  0x00, 0x15, 
  0x0e, 0x15, 
  0x00, 0x15, 
  0x00, 0x15, 
  0x00, 0x1d, 
  0x00, 0x15, 
  0x1c, 0x17, 
  0x00, 0x17, 
  /* House floor down left (`) */
  16, 16,
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xe8, 0xe0, 
  0xe8, 0x00, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xb8, 0x03, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xa8, 0x00, 
  0xaf, 0xff, 
  0x90, 0x80, 
  0x6f, 0xff, 
  0x80, 0x0c, 
  /* House floor down mid (a) */
  16, 16,
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x00, 0x70, 
  0x00, 0x00, 
  0x00, 0x00, 
  0x80, 0x00, 
  0x01, 0xc0, 
  0x00, 0x00, 
  0x00, 0x00, 
  0xff, 0xff, 
  0x40, 0x00, 
  0xff, 0xff, 
  0x00, 0x38, 
  /* House floor down right (b) */
  16, 16,
  0x00, 0x15, 
  0x00, 0x1d, 
  0x03, 0x95, 
  0x00, 0x15, 
  0x00, 0x17, 
  0x1c, 0x17, 
  0x00, 0x15, 
  0x00, 0x15, 
  0x70, 0x15, 
  0x00, 0x17, 
  0x00, 0x1f, 
  0x00, 0x15, 
  0xff, 0xf5, 
  0x12, 0x09, 
  0xff, 0xf6, 
  0x00, 0x61, 
  /* Table (c) */
  16, 16,
  0x00, 0x00, 
  0x00, 0x00, 
  0xff, 0xff, 
  0x82, 0x01, 
  0xa0, 0x01, 
  0x80, 0x01, 
  0x80, 0xa3, 
  0x80, 0xe1, 
  0x80, 0x01, 
  0x80, 0x01, 
  0x80, 0x25, 
  0x80, 0x01, 
  0x80, 0x01, 
  0xff, 0xff, 
  0x40, 0x02, 
  0x00, 0x00, 
  /* Vertical able (d) */
  16, 16,
  0x41, 0xff, 
  0xb9, 0x01, 
  0xf9, 0x79, 
  0xb9, 0x49, 
  0x41, 0x79, 
  0x01, 0x01, 
  0x01, 0x01, 
  0x21, 0x01, 
  0x5d, 0x01, 
  0x7d, 0x01, 
  0x5d, 0x05, 
  0x21, 0x01, 
  0x01, 0x0b, 
  0x01, 0x01, 
  0x01, 0x01, 
  0x01, 0xff, 
};

const uint8_t p_player_bitmap[] =
{
  8, 8,
  0x7e, 
  0xdb, 
  0xff, 
  0xff, 
  0x7e, 
  0x3c, 
  0x1c, 
  0x08, 
};


const uint8_t p_player_mask_bitmap[] =
{
  8, 8,
  0x81, 
  0x00, 
  0x00, 
  0x00, 
  0x81, 
  0xc3, 
  0xe3, 
  0xf7, 
};


const uint8_t p_troll_bitmap[] =
{
  8, 8,
  0x3b, 
  0x64, 
  0x4a, 
  0x5e, 
  0x5e, 
  0x4a, 
  0x64, 
  0x3b, 
};


uint8_t p_objects_bitmap[] =
{
  /* Rope */
  8, 8,
  0x3c, 
  0x42, 
  0x39, 
  0x45, 
  0x49, 
  0x22, 
  0x1c, 
  0x00, 
  /* Fruit */
  8, 8,
  0x04, 
  0x3a, 
  0x44, 
  0x42, 
  0x4a, 
  0x42, 
  0x3c, 
  0x00, 
  /* Coins */
  8, 8,
  0x00, 
  0x38, 
  0x70, 
  0x38, 
  0x70, 
  0x1e, 
  0x38, 
  0x70, 
  /* Bottle */
  8, 8,
  0x00, 
  0x18, 
  0x34, 
  0x24, 
  0x72, 
  0x6a, 
  0x3c, 
  0x00, 
  /* Shining coins */
  8, 8,
  0x81, 
  0x38, 
  0x72, 
  0x38, 
  0x70, 
  0x1e, 
  0xb8, 
  0x31, 
};


#endif /* BITMAPS_H */
