/*
 * soliloque-server, an open source implementation of the TeamSpeak protocol.
 * Copyright (C) 2009 Hugo Camboulive <hugo.camboulive AT gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __REGISTRATION_H__
#define __REGISTRATION_H__

#include <openssl/sha.h>

struct registration
{
	char global_flags;	/* only serveradmin 0/1 */
	char name[30];
	char password[SHA256_DIGEST_LENGTH * 2 + 1];
	int db_id;
};

struct registration *new_registration(void);
void destroy_registration(struct registration *r);

#endif
