/*
 * Copyright © 2011
 * Andrea Costa <nukemup@hotmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 * or write to the Free Software Foundation, Inc., 51 Franklin St
 * Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __TEMP_NOTIFIER_H__
#define __TEMP_NOTIFIER_H__

#include "../lib/libui_gtk.h"
#include <stdlib.h>
#include <string.h>

#define IMAGE_LOGO "images/logo.png"
#define XML_FILE "temp-notifier.xml"
#define VERSION "2.0.0"

typedef struct
{
  /* GtkWidget */
  GtkWidget *window;
  GtkWidget *icon;
  GtkWidget *icon_menu;
  GtkWidget *quit_item;
  GtkWidget *about_item;
  GtkWidget *setting_item;

  int critical_temp;
  int cpu0_temp;
  int cpu1_temp;
  char *thermal_file_cpu0;
  char *thermal_file_cpu1;
  char *logo;
} temp_notifier_s;

#endif /* __TEMP_NOTIFIER_H__ */
