/*
 * Copyright © 2010 Andrea Costa <nukemup@hotmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 * or write to the Free Software Foundation, Inc., 51 Franklin St
 * Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include "temp_notifier.h"


/*
 Reads conf file and sets gadget init data
*/
gboolean
temp_notifier_conf_get_gadget_info (temp_notifier_core_s *temp_notifier_core)
{
	FILE *file;
	char *ptr;
	char string[512];
	
	file = fopen(g_strdup_printf("%s/%s", temp_notifier_core->cur_directory, GADGET_CONF_FILE), "r");
	if (file != NULL){
		while (fgets(string, sizeof(string) - 1, file) != NULL){
			if (strncmp(string, "GADGET-WIDTH:", 13) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->width = atoi (ptr);
			}
			if (strncmp(string, "GADGET-HEIGHT:", 14) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->height = atoi (ptr);
			}
			if (strncmp(string, "GADGET-RED:", 11) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->gadget_red = atof (ptr);
			}
			if (strncmp(string, "GADGET-GREEN:", 13) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->gadget_green = atof (ptr);
			}
			if (strncmp(string, "GADGET-BLUE:", 12) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->gadget_blue = atof (ptr);
			}
			if (strncmp(string, "GADGET-TRANSPARENCY:", 20) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->gadget_transparency = atof (ptr);
			}
			if (strncmp(string, "BORDER-TRANSPARENCY:", 20) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->border_transparency = atof (ptr);
			}
			if (strncmp(string, "CRITICAL-1-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_1.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-1-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_1.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-1-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_1.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-2-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_2.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-2-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_2.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-2-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_2.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-3-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_3.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-3-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_3.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-3-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_3.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-4-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_4.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-4-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_4.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-4-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_4.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-5-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_5.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-5-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_5.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-5-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_5.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-6-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_6.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-6-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_6.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-6-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_6.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-7-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_7.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-7-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_7.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-7-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_7.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-8-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_8.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-8-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_8.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-8-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_8.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-9-RED:", 15) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_9.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-9-GREEN:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_9.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-9-BLUE:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_9.blue = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-10-RED:", 16) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_10.red = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-10-GREEN:", 18) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_10.green = (atof (ptr) * 65535);
			}
			if (strncmp(string, "CRITICAL-10-BLUE:", 17) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->critical_10.blue = (atof (ptr) * 65535);
			}
		}
		fclose(file);
		return TRUE;
	}
	else 
		return FALSE;
}


/*
 If temp_notifier_conf_get_gadget_info fails, this func sets the heat colors
*/
void
temp_notifier_set_init_data_color_heat (temp_notifier_core_s *temp_notifier_core)
{
		temp_notifier_core->critical_1.red = 0.065263 * 65535;
		temp_notifier_core->critical_1.green = 0.772412 * 65535;
		temp_notifier_core->critical_1.blue = 0.0;
		temp_notifier_core->critical_2.red = 0.380026 * 65535;
		temp_notifier_core->critical_2.green = 0.798703 * 65535;
		temp_notifier_core->critical_2.blue = 0.0;
		temp_notifier_core->critical_3.red = 0.661494 * 65535;
		temp_notifier_core->critical_3.green = 0.971481 * 65535;
		temp_notifier_core->critical_3.blue = 0.0;
		temp_notifier_core->critical_4.red = 0.803586 * 65535;
		temp_notifier_core->critical_4.green = 1.0 * 65535;
		temp_notifier_core->critical_4.blue = 0.0;
		temp_notifier_core->critical_5.red = 1.0 * 65535;
		temp_notifier_core->critical_5.green = 0.944793 * 65535;
		temp_notifier_core->critical_5.blue = 0.0;
		temp_notifier_core->critical_6.red = 1.0 * 65535;
		temp_notifier_core->critical_6.green = 0.657313 * 65535;
		temp_notifier_core->critical_6.blue = 0.0;
		temp_notifier_core->critical_7.red = 1.0 * 65535;
		temp_notifier_core->critical_7.green = 0.518105 * 65535;
		temp_notifier_core->critical_7.blue = 0.0;
		temp_notifier_core->critical_8.red = 1.0 * 65535;
		temp_notifier_core->critical_8.green = 0.322057 * 65535;
		temp_notifier_core->critical_8.blue = 0.0;
		temp_notifier_core->critical_9.red = 1.0 * 65535;
		temp_notifier_core->critical_9.green = 0.212833 * 65535;
		temp_notifier_core->critical_9.blue = 0.0;
		temp_notifier_core->critical_10.red = 1.0 * 65535;
		temp_notifier_core->critical_10.green = 0.117281 * 65535;
		temp_notifier_core->critical_10.blue = 0.0;
}


/*
 Reads conf file and sets init thermal data
*/
gboolean
temp_notifier_conf_get_thermal_info (temp_notifier_core_s *temp_notifier_core)
{

	FILE *file;
	char *ptr;
	char string[512];
	
	file = fopen(g_strdup_printf("%s/%s", temp_notifier_core->cur_directory, THERMAL_CONF_FILE), "r");
	if (file != NULL){
		while (fgets(string, sizeof(string) - 1, file) != NULL){
			if (strncmp(string, "MAX_TEMP:", 9) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->max_temperature = atoi (ptr);
			}
			if (strncmp(string, "CPU0:", 5) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->thermal_file_cpu0 = ptr;
			}
			if (strncmp(string, "CPU1:", 5) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->thermal_file_cpu1 = ptr;
			}
		}
		fclose(file);
		return TRUE;
	}
	else 
		return FALSE;
}


/*
 Reads conf file and sets initial data position
*/ 
temp_notifier_conf_set_gadget_position (temp_notifier_core_s *temp_notifier_core)
{

	FILE *file;
	char *ptr;
	char string[512];
	
	file = fopen(g_strdup_printf("%s/%s", temp_notifier_core->cur_directory, POSITION_CONF_FILE), "r");
	if (file != NULL){
		while (fgets(string, sizeof(string) - 1, file) != NULL){
			if (strncmp(string, "X-WINDOW:", 9) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->x_window = atoi (ptr);
			}
			if (strncmp(string, "Y-WINDOW:", 9) == 0){
				ptr = (char *)double_split(string, ' ', '\n', 1);
				temp_notifier_core->y_window = atoi(ptr);
			}
		}
		fclose(file);
		return TRUE;
	}
	else 
		return FALSE;
}
