/**
  *****************************************************************************
  * @title   GPIO_Blink
  * @author  CooCox
  * @date    15 Mar 2011
  * @brief   This example describes how to use GPIO to control a LED.
  *
  *******************************************************************************
  */
////// The above comment is automatically generated by CoIDE ///////////////////

#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"

#define USER_KEYA GPIO_Pin_13 //port C
#define USER_KEYB GPIO_Pin_2 //port B
#define LED1 GPIO_Pin_0 //port B
#define LED2 GPIO_Pin_1 //port B


void GPIO_Blink(void)
{
    int i;
    /* Initialize Leds mounted on STM32 board */
    GPIO_InitTypeDef  GPIO_InitStructure;
    /* Initialize LED which connected to , Enable the Clock*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    /* Configure the GPIO_LED pin */
    GPIO_InitStructure.GPIO_Pin = LED1 | LED2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = USER_KEYB;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING; //floating becuse they re connected to power through resitatence
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    while (1)
    {
        GPIOB->ODR ^= LED1;
        for(i=0;i<0x100000;i++);

        if(GPIOB->IDR & USER_KEYB) {
			GPIOB->ODR ^= LED2;
			for (i = 0; i < 0x100000; i++);
        }
    }
}

int main()
{
	GPIO_Blink();
	return 0;
}
