#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "HF_Lib.h"

#define HF_MAIN_NAME_SIZE 30
#define HF_MAIN_EVENT_NAME_SIZE 60
#define HF_MAIN_DATE_SIZE 11

/*    Athlete*/
#define HF_MAIN_ATHLETE_REC_SIZE sizeof(int) + 2*(sizeof(char) * HF_MAIN_NAME_SIZE)

/*    Event*/
#define HF_MAIN_EVENT_REC_SIZE sizeof(int) + (sizeof(char) * HF_MAIN_EVENT_NAME_SIZE)

/*    Participation*/
#define HF_MAIN_PARTICIPATION_REC_SIZE 2*sizeof(int) + (sizeof(char) * HF_MAIN_DATE_SIZE)

/*   Athlete*/
void insertAthlete(int athletesFd, int athleteId, char *athleteSurname, char *athleteName);

/*   Event*/
void insertEvent(int eventsFd, int eventId, char *eventName);

/*   Participation*/
void insertParticipation(int partsFd, int athleteId, int eventId, char *partDate);

int main()
{
	int athletesFd;
	int eventsFd;
	int partsFd;

    /*   HF */
	HF_Init();

	/* 
	 * ------------- ATHLETES -------------
	 */
	/*   ATHLETES */
	if (HF_CreateFile("ATHLETES") != HFE_OK)
	{
		HF_PrintError("Error in HF_CreateFile called on ATHLETES.");
	}

	/*   ATHLETES */
	athletesFd = BF_OpenFile("ATHLETES");

	if (athletesFd < 0)
	{
		HF_PrintError("Error in BF_OpenFile called on ATHLETES.");
		return -1;
	}

	/*    Athlete */
	insertAthlete(athletesFd, 180, "TASKOYDHS", "APOSTOLOS");
	insertAthlete(athletesFd, 260, "GAZHS", "GEVRGIOS");
	insertAthlete(athletesFd, 104, "KVSTH", "ELENH");
	insertAthlete(athletesFd, 304, "KARASTAMATH", "MARIA");
	insertAthlete(athletesFd, 156, "TZEIMS", "SYKARAS");
	insertAthlete(athletesFd, 322, "KAFETZH", "GIANNOYLA");
	insertAthlete(athletesFd, 176, "BRYVNH", "MARIA-LOYIZA");
	insertAthlete(athletesFd, 179, "ASLANASBILI", "MPESIK");
	insertAthlete(athletesFd, 365, "PELEKANOY", "OLGA");
	insertAthlete(athletesFd, 220, "GIATRAKOY", "MARIA");
	insertAthlete(athletesFd, 50, "PAXOYMAS", "AUANASIOS");
	insertAthlete(athletesFd, 56, "KONTOGOYRHS", "GEVRGIOS");
	insertAthlete(athletesFd, 97, "KABARNOY", "EIRHNH");
	insertAthlete(athletesFd, 341, "DHMOTSIOS", "STYLIANOS");
	insertAthlete(athletesFd, 87, "KILIGKARIDHS", "ANDREAS");
	insertAthlete(athletesFd, 110, "LYMPERTA", "MARIANNA");
	insertAthlete(athletesFd, 223, "ELENH", "KATSAITH");
	insertAthlete(athletesFd, 346, "ARGYROPOYLOS", "GEVRGIOS");
	insertAthlete(athletesFd, 144, "ALEJANDROS", "MAHSTRALHS");
	insertAthlete(athletesFd, 193, "GKARAGKOYNH", "NIKH");
	insertAthlete(athletesFd, 29, "BOLAKAKH", "ARXONTIA");
	insertAthlete(athletesFd, 267, "GEVRGAKOPOYLOS", "DIONYSIOS");
	insertAthlete(athletesFd, 68, "STAXTIARH", "EIRHNH");
	insertAthlete(athletesFd, 187, "ARKOYDEAS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 173, "CAUA", "FANH");
	insertAthlete(athletesFd, 218, "GEVRGALHS", "DHMHTRIOS");
	insertAthlete(athletesFd, 158, "PANAGIVTHS", "XAISLER");
	insertAthlete(athletesFd, 34, "LEMAN", "GKERTA");
	insertAthlete(athletesFd, 310, "NTOBA", "DHMHTRA");
	insertAthlete(athletesFd, 221, "KABBADA", "ALEJANDRA");
	insertAthlete(athletesFd, 339, "KENTERHS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 332, "PERRA", "AUANASIA");
	insertAthlete(athletesFd, 195, "KIOSH", "ELENH");
	insertAthlete(athletesFd, 39, "ANTIKATZIDH", "MIKAELA-XAINTI");
	insertAthlete(athletesFd, 273, "ANTVNIADHS", "NIKOLAOS");
	insertAthlete(athletesFd, 7, "KASTRITSH", "XARIKLEIA");
	insertAthlete(athletesFd, 379, "PAPAIVANNOY", "XARALAMPOS");
	insertAthlete(athletesFd, 150, "MPRANTLH", "KVNSTANTINOS");
	insertAthlete(athletesFd, 215, "KVTOYLAS", "EMMANOYHL");
	insertAthlete(athletesFd, 177, "MPATZELAS", "NESTVRAS");
	insertAthlete(athletesFd, 313, "MANIANI", "MIRELA");
	insertAthlete(athletesFd, 234, "SMIU", "SOFIA-ANTVNIA");
	insertAthlete(athletesFd, 105, "MAXAIRA", "ANTVNIA");
	insertAthlete(athletesFd, 293, "SARA", "RENE");
	insertAthlete(athletesFd, 83, "FEREKIDH", "MARIA");
	insertAthlete(athletesFd, 35, "SOYRLA", "ALEJANDRA");
	insertAthlete(athletesFd, 79, "TSARTSARHS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 190, "UANOS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 214, "XRISTOFIDELHS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 229, "MOSXOY", "ILHANA");
	insertAthlete(athletesFd, 283, "LYN", "MPASOR");
	insertAthlete(athletesFd, 254, "STOLTIDHS", "IEROKLHS");
	insertAthlete(athletesFd, 255, "TARALIDHS", "IVANNHS");
	insertAthlete(athletesFd, 271, "LIOGRHS", "EYAGGELOS");
	insertAthlete(athletesFd, 375, "MPOYKOYBALA", "IOYLIETA");
	insertAthlete(athletesFd, 266, "KASOYMH", "AGAUH");
	insertAthlete(athletesFd, 93, "GABRIHLIDHS", "IVANNHS");
	insertAthlete(athletesFd, 298, "PAPAGIANNH", "AUHNA");
	insertAthlete(athletesFd, 311, "IAKVBOY", "XRYSOSTOMIA");
	insertAthlete(athletesFd, 200, "SAKKOYLA", "XARIKLEIA");
	insertAthlete(athletesFd, 21, "KAKIOY", "MARIA");
	insertAthlete(athletesFd, 377, "KOYRTELESH", "ALEJIA");
	insertAthlete(athletesFd, 317, "TSIKOYNA", "STYLIANH");
	insertAthlete(athletesFd, 334, "UEODVRIDHS", "GEVRGIOS");
	insertAthlete(athletesFd, 162, "SFYRH", "EYFROSYNH");
	insertAthlete(athletesFd, 123, "TSOLTOS", "ALEJANDROS");
	insertAthlete(athletesFd, 18, "MARAS", "BLASIOS");
	insertAthlete(athletesFd, 58, "GAREFHS", "XRHSTOS");
	insertAthlete(athletesFd, 43, "KRABARIVTH", "BIRGINIA");
	insertAthlete(athletesFd, 326, "TERZOGLOY", "EIRHNH");
	insertAthlete(athletesFd, 224, "KVNSTANTINA", "LAGOYMTZH");
	insertAthlete(athletesFd, 22, "MAGNHSALH", "BARBARA");
	insertAthlete(athletesFd, 57, "PASXALIDHS", "IORDANHS");
	insertAthlete(athletesFd, 291, "FARNGOYORU", "STEISI");
	insertAthlete(athletesFd, 238, "XATZHGIANNIDOY", "NATALIA");
	insertAthlete(athletesFd, 353, "POLIAS", "NIKOLAOS");
	insertAthlete(athletesFd, 170, "MANETAS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 210, "ROYMELIVTHS", "NIKOLAOS");
	insertAthlete(athletesFd, 194, "IORDANIDOY", "SOFIA");
	insertAthlete(athletesFd, 227, "GOYOLKER", "AMAL");
	insertAthlete(athletesFd, 51, "PORTOSALTE", "BASILEIOS");
	insertAthlete(athletesFd, 136, "OYEIN", "UEODVRAKOS");
	insertAthlete(athletesFd, 11, "MHTROY", "BIKTVR");
	insertAthlete(athletesFd, 174, "POYMPOYRIDOY", "SOFIA");
	insertAthlete(athletesFd, 302, "XALKIA", "FANH");
	insertAthlete(athletesFd, 323, "JANUOY", "NIKH");
	insertAthlete(athletesFd, 352, "EYAGGELOY", "MARIOS");
	insertAthlete(athletesFd, 309, "MPOYNTA", "XARIKLEIA");
	insertAthlete(athletesFd, 31, "GKIVNHS", "PANAGIVTHS");
	insertAthlete(athletesFd, 331, "DEBETZH", "XRYSOPHGH");
	insertAthlete(athletesFd, 207, "MPAEF", "TONTOR-ZLATKOB");
	insertAthlete(athletesFd, 278, "MARIA", "KARANTZA");
	insertAthlete(athletesFd, 225, "AGGELIKH", "LAZAROY");
	insertAthlete(athletesFd, 13, "MARKOYLAS", "GEVRGIOS");
	insertAthlete(athletesFd, 231, "PANTELEIADOY", "DHMHTRA");
	insertAthlete(athletesFd, 383, "ALEJANIDHS", "LAYRENTI");
	insertAthlete(athletesFd, 361, "GOYDA", "EYFROSYNH");
	insertAthlete(athletesFd, 372, "IVANNOY", "ELENH");
	insertAthlete(athletesFd, 354, "SERELHS", "DHMHTRIOS");
	insertAthlete(athletesFd, 24, "XRISTIDOY", "STYLIANH");
	insertAthlete(athletesFd, 378, "AKRITIDOY", "BARBARA");
	insertAthlete(athletesFd, 295, "RENTOYMH", "FLVRA");
	insertAthlete(athletesFd, 248, "LAGOS", "PANAGIVTHS");
	insertAthlete(athletesFd, 335, "XOIDHS", "XRISTOFOROS");
	insertAthlete(athletesFd, 262, "KLADOYXAS", "SPYRIDVN");
	insertAthlete(athletesFd, 364, "KOYTSOYDH", "EYGENIA");
	insertAthlete(athletesFd, 315, "BOGGOLH", "AIKATERINH");
	insertAthlete(athletesFd, 233, "POYRIDOY", "AUANASIA");
	insertAthlete(athletesFd, 371, "MOYROYTSOS", "MIXALHS");
	insertAthlete(athletesFd, 288, "TZEIMS", "LINTZY");
	insertAthlete(athletesFd, 243, "BYNTRA", "LOYKAS");
	insertAthlete(athletesFd, 77, "PAPANIKOLAOY", "DHMHTRHS");
	insertAthlete(athletesFd, 191, "BLAXOY", "IVANNA");
	insertAthlete(athletesFd, 203, "GKIOYRDAS", "MARIOS");
	insertAthlete(athletesFd, 329, "TSAMOGLOY", "EYDOKIA");
	insertAthlete(athletesFd, 206, "LAPPAS", "HLIAS");
	insertAthlete(athletesFd, 6, "KASAPH", "BASILIKH");
	insertAthlete(athletesFd, 212, "TSAKIROPOYLOS", "ANTVNIOS");
	insertAthlete(athletesFd, 276, "TZOANNA", "ANTALI");
	insertAthlete(athletesFd, 117, "DRYMVNAKOS", "IVANNHS");
	insertAthlete(athletesFd, 95, "MPIMHS", "UVMAS");
	insertAthlete(athletesFd, 256, "FVTAKHS", "GEVRGIOS");
	insertAthlete(athletesFd, 380, "HLIADHS", "BASILEIOS");
	insertAthlete(athletesFd, 166, "MAGKANOYDAKH", "DHMHTRA");
	insertAthlete(athletesFd, 319, "TSILIGKIRH", "GEVRGIA");
	insertAthlete(athletesFd, 349, "STROYMPAKOS", "PANAGIVTHS");
	insertAthlete(athletesFd, 241, "AMPARHS", "GEVRGIOS");
	insertAthlete(athletesFd, 112, "PASTRAS", "SVTHRIOS");
	insertAthlete(athletesFd, 217, "BASILOPOYLOS", "LAMPROS");
	insertAthlete(athletesFd, 239, "AGRITHS", "ANASTASIOS");
	insertAthlete(athletesFd, 88, "PAPANDREOY", "APOSTOLOS");
	insertAthlete(athletesFd, 253, "SAPANHS", "MILTIADHS");
	insertAthlete(athletesFd, 72, "DIAMANTIDHS", "DHMHTRIOS");
	insertAthlete(athletesFd, 3, "DANIHLIDOY", "ELENH");
	insertAthlete(athletesFd, 247, "KARYPIDHS", "XRHSTOS");
	insertAthlete(athletesFd, 230, "MPENSON", "ELENH-MARI");
	insertAthlete(athletesFd, 236, "STRATAKH", "KALLIOPH");
	insertAthlete(athletesFd, 245, "GIANNOY", "KLEOPAS");
	insertAthlete(athletesFd, 85, "DHMHTRIOY", "ALEJANDROS");
	insertAthlete(athletesFd, 75, "NTIKOYDHS", "DHMOSUENHS");
	insertAthlete(athletesFd, 10, "SAMPANHS", "LEVNIDAS");
	insertAthlete(athletesFd, 82, "XATZHBRETTAS", "NIKOLAOS");
	insertAthlete(athletesFd, 19, "TAMPAKOS", "DHMOSUENHS");
	insertAthlete(athletesFd, 263, "KARAFLOY", "MARINA");
	insertAthlete(athletesFd, 163, "MIXALOPOYLOS", "AUANASIOS");
	insertAthlete(athletesFd, 53, "XEIMVNAS", "EYAGGELOS");
	insertAthlete(athletesFd, 165, "RENTOYMH", "MARIA");
	insertAthlete(athletesFd, 282, "MPASOR", "TZESIKA");
	insertAthlete(athletesFd, 96, "SIRANIDHS", "NIKOLAOS");
	insertAthlete(athletesFd, 249, "MORAS", "EYAGGELOS");
	insertAthlete(athletesFd, 265, "FAKA", "MARIA");
	insertAthlete(athletesFd, 62, "KALENTZOY", "DHMHTRA");
	insertAthlete(athletesFd, 44, "FRAI", "AUHNA");
	insertAthlete(athletesFd, 213, "XATZHANTVNIOY", "UEODVROS");
	insertAthlete(athletesFd, 120, "GIANNIVTHS", "SPYRIDVN");
	insertAthlete(athletesFd, 226, "MARIA", "LOSENO");
	insertAthlete(athletesFd, 301, "GKOYNTENOYDH", "XRYSOYLA");
	insertAthlete(athletesFd, 32, "KREANGKA", "KALINIKOS");
	insertAthlete(athletesFd, 228, "MIXAHLIDOY", "EYTYXIA");
	insertAthlete(athletesFd, 321, "AMPATZIDOY", "GEVRGIA");
	insertAthlete(athletesFd, 94, "TRAKAS", "SVTHRIOS");
	insertAthlete(athletesFd, 178, "KARNTANOB", "AMIRAN");
	insertAthlete(athletesFd, 131, "PARTITS", "KATALIN-MPEAT");
	insertAthlete(athletesFd, 306, "PATOYLIDOY", "PARASKEYH");
	insertAthlete(athletesFd, 320, "STRATAKH", "ARGYRV");
	insertAthlete(athletesFd, 324, "PILATOY", "STYLIANH");
	insertAthlete(athletesFd, 157, "PANAGIVTHS", "SVTHROPOYLOS");
	insertAthlete(athletesFd, 198, "PAPAZOGLOY", "BASILIKH");
	insertAthlete(athletesFd, 199, "PRONIADOY", "ZANNA");
	insertAthlete(athletesFd, 124, "ANTVNOPOYLOS", "APOSTOLOS");
	insertAthlete(athletesFd, 151, "MPRAK", "ANDREAS-TZEHMS");
	insertAthlete(athletesFd, 303, "BASARMIDOY", "MARINA");
	insertAthlete(athletesFd, 67, "SAREGKOY", "POLYMNIA");
	insertAthlete(athletesFd, 89, "PAPPA-PAPABASILOPOYLOY", "EYTYXIA");
	insertAthlete(athletesFd, 357, "PAPADHMHTRIOY", "ALEJANDROS");
	insertAthlete(athletesFd, 294, "UANOY", "AIKATERINH");
	insertAthlete(athletesFd, 113, "PAPADOPOYLOS", "XRHSTOS");
	insertAthlete(athletesFd, 2, "ZAXARIADOY", "XRISTINA");
	insertAthlete(athletesFd, 279, "XRISTINA", "KOYTOYGKOY");
	insertAthlete(athletesFd, 336, "PIETRHS", "DHMHTRIOS");
	insertAthlete(athletesFd, 107, "TSAGKA", "EYAGGELIA");
	insertAthlete(athletesFd, 281, "AIKATERINH", "ELENH");
	insertAthlete(athletesFd, 337, "UANOPOYLOS", "ELEYUERIOS");
	insertAthlete(athletesFd, 261, "PAYLIDHS", "HLIAS");
	insertAthlete(athletesFd, 108, "MATSA", "MARUA");
	insertAthlete(athletesFd, 149, "KLEHTON", "MPOYRAS");
	insertAthlete(athletesFd, 145, "PHTER", "GKAS");
	insertAthlete(athletesFd, 42, "TSOYLFA", "AIMILIA");
	insertAthlete(athletesFd, 74, "KAKIOYZHS", "MIXAHL");
	insertAthlete(athletesFd, 47, "MANTZARAKH", "EYTYXIA");
	insertAthlete(athletesFd, 381, "ZINTIRIDHS", "REBAZI");
	insertAthlete(athletesFd, 289, "LVREN", "FARNGOYORU");
	insertAthlete(athletesFd, 314, "TSIOLAKOYDH", "AGGELIKH");
	insertAthlete(athletesFd, 316, "KELESIDOY", "ANASTASIA");
	insertAthlete(athletesFd, 92, "KOYTSOPETROY", "SVTHRIA");
	insertAthlete(athletesFd, 143, "MIXAHL", "KREMMYDAS");
	insertAthlete(athletesFd, 109, "NIANGKOYARA", "NERY-MANTEY");
	insertAthlete(athletesFd, 368, "AUANASOPOYLOY", "ARETH");
	insertAthlete(athletesFd, 41, "MPEKATVROY", "SOFIA");
	insertAthlete(athletesFd, 45, "GIAKOYMIDOY", "AIKATERINH");
	insertAthlete(athletesFd, 8, "TSAKIRH", "ANASTASIA");
	insertAthlete(athletesFd, 204, "KOYRNETAS", "BASILEIOS");
	insertAthlete(athletesFd, 184, "KOYTSIOYMPAS", "JENOFVN");
	insertAthlete(athletesFd, 64, "KVSTAKH", "ANASTASIA");
	insertAthlete(athletesFd, 33, "DEMIROPOYLOY", "AGLAIA");
	insertAthlete(athletesFd, 152, "PAPALYMPERHS", "ERIK-NTANIEL");
	insertAthlete(athletesFd, 342, "IAKVBAKHS", "PERIKLHS");
	insertAthlete(athletesFd, 274, "GEVRGANTA", "TZHNNY");
	insertAthlete(athletesFd, 373, "KARAGIANNOPOYLOY", "MARIA");
	insertAthlete(athletesFd, 185, "KIOYREGKIAN", "ARTIOM");
	insertAthlete(athletesFd, 264, "SMYRLH", "ALEJIA");
	insertAthlete(athletesFd, 1, "PATHS", "GEVRGIOS");
	insertAthlete(athletesFd, 59, "BASILEIOY", "ELENH");
	insertAthlete(athletesFd, 160, "KARANTASIOY", "BASILIKH");
	insertAthlete(athletesFd, 183, "LALIVTHS", "ALEJANDROS");
	insertAthlete(athletesFd, 86, "ALEJOPOYLOY", "AUHNA-UEODVRA");
	insertAthlete(athletesFd, 275, "MARI", "GKEIL");
	insertAthlete(athletesFd, 148, "ROSS", "MPELINTZER");
	insertAthlete(athletesFd, 242, "BALLAS", "SPYRIDVN");
	insertAthlete(athletesFd, 196, "MEMETZH", "ELENH");
	insertAthlete(athletesFd, 73, "ZHSHS", "NIKOLAOS");
	insertAthlete(athletesFd, 270, "SPYROPOYLOS", "AGGELOS");
	insertAthlete(athletesFd, 101, "AGGELOPOYLOY", "BASILIKH");
	insertAthlete(athletesFd, 142, "GEVRGIOS", "KOYTSANTVNAKHS");
	insertAthlete(athletesFd, 216, "KVNSTANTINIDOY", "KYRIAKH");
	insertAthlete(athletesFd, 232, "PAPADOPOYLOY", "ANASTASIA");
	insertAthlete(athletesFd, 122, "MPITSAKHS", "SPYRIDVN");
	insertAthlete(athletesFd, 12, "DHMAS", "PYRROS");
	insertAthlete(athletesFd, 25, "XRONOPOYLOY", "ELENH");
	insertAthlete(athletesFd, 128, "SAKELLARIDOY", "MARIA");
	insertAthlete(athletesFd, 277, "KANELAKH-KLOOYZMAN", "XLOH");
	insertAthlete(athletesFd, 208, "PANTALEVN", "SVTHRIOS");
	insertAthlete(athletesFd, 48, "KOSMATOPOYLOS", "ANDREAS");
	insertAthlete(athletesFd, 370, "NIKOLAIDHS", "ALEJANDROS");
	insertAthlete(athletesFd, 299, "TSOYMELEKA", "AUANASIA");
	insertAthlete(athletesFd, 155, "SPENSER", "SVN");
	insertAthlete(athletesFd, 246, "GOYNDOYLAKHS", "FANOYRIOS");
	insertAthlete(athletesFd, 46, "DHMHTRAKOPOYLOY", "ELENH");
	insertAthlete(athletesFd, 129, "POLYMEROS", "BASILEIOS");
	insertAthlete(athletesFd, 181, "MPETINIDHS", "EMZARIOS");
	insertAthlete(athletesFd, 23, "PANTAZH", "STERGIANH");
	insertAthlete(athletesFd, 153, "ROMPINSON", "XRISTOFOROS");
	insertAthlete(athletesFd, 63, "KLIGKOPOYLOY", "SOFIA");
	insertAthlete(athletesFd, 71, "GLYNIADAKHS", "ANDREAS");
	insertAthlete(athletesFd, 125, "JYLOYRHS", "NIKOLAOS");
	insertAthlete(athletesFd, 111, "GRHGORIADHS", "ARISTEIDHS");
	insertAthlete(athletesFd, 296, "EFENTAKH", "KVNSTANTINA");
	insertAthlete(athletesFd, 91, "GEVRGATOY", "DIAMANTINA");
	insertAthlete(athletesFd, 106, "MANVLH", "GEVRGIA");
	insertAthlete(athletesFd, 318, "SKAFIDA", "AFRODITH");
	insertAthlete(athletesFd, 348, "STAMATOPOYLOS", "UEODVROS");
	insertAthlete(athletesFd, 84, "TSAKMAKHS", "XRHSTOS");
	insertAthlete(athletesFd, 325, "OYZOYNH", "KALLIOPH");
	insertAthlete(athletesFd, 135, "ZABARAS", "KLINTON");
	insertAthlete(athletesFd, 139, "KORY-ANTVNIOS", "KABOYRGIARHS");
	insertAthlete(athletesFd, 60, "DELH", "AIKATERINH");
	insertAthlete(athletesFd, 78, "SPANOYLHS", "BASILEIOS");
	insertAthlete(athletesFd, 5, "OIKONOMIDHS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 37, "ROMPERSON-MYTILHNAIOY", "XANNA");
	insertAthlete(athletesFd, 290, "TZEIMI", "LYN");
	insertAthlete(athletesFd, 127, "MPISKITZH", "XRYSH");
	insertAthlete(athletesFd, 81, "XARISHS", "XRHSTOS");
	insertAthlete(athletesFd, 119, "GKIOYLMPAS", "ANTVNIOS");
	insertAthlete(athletesFd, 201, "TZANAKAKH", "GEVRGIA");
	insertAthlete(athletesFd, 258, "IVANNIDHS", "SPYRIDVN");
	insertAthlete(athletesFd, 202, "XATZHNIKOY", "ELEYUERIA");
	insertAthlete(athletesFd, 285, "MPOYZIOY", "IVANNA");
	insertAthlete(athletesFd, 133, "DHMHTRELHS", "TZEIMS-XRISTODOYLOS");
	insertAthlete(athletesFd, 147, "MELEXES", "MELETI");
	insertAthlete(athletesFd, 360, "GEVRGIOY", "ELENH");
	insertAthlete(athletesFd, 9, "IVANNIDH", "XRISTINA");
	insertAthlete(athletesFd, 0, "BELKOS", "UEODVROS");
	insertAthlete(athletesFd, 358, "MELETOGLOY", "XRHSTOS");
	insertAthlete(athletesFd, 367, "XRISTODOYLOY", "MARIA");
	insertAthlete(athletesFd, 141, "ROMPERT-REIMONT", "KOTTARAS");
	insertAthlete(athletesFd, 146, "MARKAKHS", "NIKOLAOS");
	insertAthlete(athletesFd, 235, "SOYPIADOY", "BASILIKH");
	insertAthlete(athletesFd, 376, "TAMPASH", "ELENH");
	insertAthlete(athletesFd, 159, "ARBANITH", "BASILIKH");
	insertAthlete(athletesFd, 287, "TZARNESKI", "BANESSA");
	insertAthlete(athletesFd, 356, "FILINDRAS", "DHMHTRIOS");
	insertAthlete(athletesFd, 308, "KOYMNAKH", "GEVRGIA");
	insertAthlete(athletesFd, 343, "GRABALOS", "DHMHTRIOS");
	insertAthlete(athletesFd, 366, "FTOYLH", "ELEYUERIA");
	insertAthlete(athletesFd, 347, "KASTANHS", "SPYRIDVN");
	insertAthlete(athletesFd, 54, "KAKLAMANAKHS", "NIKOLAOS");
	insertAthlete(athletesFd, 237, "TEFANH", "AGGELIKH");
	insertAthlete(athletesFd, 130, "SKIAUITHS", "NIKOLAOS");
	insertAthlete(athletesFd, 16, "APOSTOLIDH", "MARIA");
	insertAthlete(athletesFd, 182, "LOIZIDHS", "LAZAROS");
	insertAthlete(athletesFd, 305, "KOKLVNH", "GEVRGIA");
	insertAthlete(athletesFd, 98, "SARAKATSANH", "AIKATERINH");
	insertAthlete(athletesFd, 40, "PETRHS", "ANTVNHS");
	insertAthlete(athletesFd, 115, "ZHSIMOS", "ANDREAS");
	insertAthlete(athletesFd, 252, "SALPIGGIDHS", "DHMHTRIOS");
	insertAthlete(athletesFd, 15, "KOYRTIDHS", "NIKOLAOS");
	insertAthlete(athletesFd, 118, "ALYFANTHS", "RVMANOS-IASVN");
	insertAthlete(athletesFd, 351, "PANABOGLOY", "SABBAS");
	insertAthlete(athletesFd, 161, "KOYTROYMANIDOY", "EYUALIA");
	insertAthlete(athletesFd, 355, "TSATOYMAS", "LOYHS");
	insertAthlete(athletesFd, 121, "MAGGANAS", "DHMHTRIOS");
	insertAthlete(athletesFd, 90, "SFAKIANOY", "FLVRENTIA");
	insertAthlete(athletesFd, 69, "TASOYLH", "ATALANTH-MARI");
	insertAthlete(athletesFd, 138, "NIKOLAOS", "UEOXARHS");
	insertAthlete(athletesFd, 330, "BASDEKH", "OLGA");
	insertAthlete(athletesFd, 17, "MPISMPIKOY", "STEFANI");
	insertAthlete(athletesFd, 284, "LINTSEI", "KRISTIN");
	insertAthlete(athletesFd, 338, "GKOYSHS", "ANASTASIOS");
	insertAthlete(athletesFd, 269, "SABORGIANNAKHS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 385, "HLIADHS", "DIONYSIOS");
	insertAthlete(athletesFd, 300, "KAIDANTZH", "OLGA");
	insertAthlete(athletesFd, 363, "IVANNOY", "APOSTOLIA");
	insertAthlete(athletesFd, 280, "AIKATERINH", "KROMYDA");
	insertAthlete(athletesFd, 65, "MALTSH", "EYANUIA");
	insertAthlete(athletesFd, 244, "GALANOPOYLOS", "ARISTEIDHS");
	insertAthlete(athletesFd, 297, "KOKOTOY", "XRISTINA");
	insertAthlete(athletesFd, 340, "SARRHS", "PANAGIVTHS");
	insertAthlete(athletesFd, 222, "KALYBA", "TANYA");
	insertAthlete(athletesFd, 312, "LIKA", "BOISABA");
	insertAthlete(athletesFd, 36, "AUANASIADH", "EMMANOYELA");
	insertAthlete(athletesFd, 137, "TZARENT-GEVRGIOS", "UEODVROY");
	insertAthlete(athletesFd, 171, "MPASMATZIAN", "MARIOS");
	insertAthlete(athletesFd, 80, "FVTSHS", "ANTVNIOS");
	insertAthlete(athletesFd, 374, "TSELARIDOY", "MARIA");
	insertAthlete(athletesFd, 134, "DOYROS", "DHMHTRIOS");
	insertAthlete(athletesFd, 382, "BAZAGKASBILI", "GEVRGIOS");
	insertAthlete(athletesFd, 186, "GKIKAS", "XRHSTOS");
	insertAthlete(athletesFd, 76, "PAPALOYKAS", "UEODVROS");
	insertAthlete(athletesFd, 168, "XRHSTOY", "IVANNA");
	insertAthlete(athletesFd, 240, "AMANATIDHS", "IVANNHS");
	insertAthlete(athletesFd, 211, "STEFANOY", "GEVRGIOS");
	insertAthlete(athletesFd, 49, "TRIGKVNHS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 209, "PROYSALHS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 102, "TZABELLA", "AUHNA");
	insertAthlete(athletesFd, 154, "SPANOS", "BASILEIOS");
	insertAthlete(athletesFd, 192, "GKARAGKOYNH", "MARIA");
	insertAthlete(athletesFd, 175, "ZYGOYRH", "STAYROYLA");
	insertAthlete(athletesFd, 272, "SALABANTAKHS", "GEVRGIOS");
	insertAthlete(athletesFd, 4, "MAZARAKHS", "BASILEIOS");
	insertAthlete(athletesFd, 362, "UALASSINIDOY", "XRISTINA");
	insertAthlete(athletesFd, 103, "KVSTA", "EIRHNH");
	insertAthlete(athletesFd, 259, "KOTAKOS", "UEODVROS");
	insertAthlete(athletesFd, 52, "PAPAUANASIOY", "AIMILIOS");
	insertAthlete(athletesFd, 292, "LH", "FARNGOYORU");
	insertAthlete(athletesFd, 100, "DHMOSXAKH", "ZVH");
	insertAthlete(athletesFd, 359, "ANASTASIOY", "AGLAIA");
	insertAthlete(athletesFd, 286, "SKIGKAS", "STEFANI");
	insertAthlete(athletesFd, 250, "NEMPEGLERAS", "KVNSTANTINOS");
	insertAthlete(athletesFd, 114, "DIAMANTIDHS", "GEVRGIOS");
	insertAthlete(athletesFd, 61, "KABBADIA", "TATIANA");
	insertAthlete(athletesFd, 132, "FLVROS", "BASILEIOS");
	insertAthlete(athletesFd, 27, "PALLIDOY", "UEODVRA");
	insertAthlete(athletesFd, 327, "PAPAGEVRGIOY", "ALEJANDRA");
	insertAthlete(athletesFd, 197, "NTOYMITRESKOY", "ROYJANTRA-KONTROYTSA");
	insertAthlete(athletesFd, 350, "KORKIZOGLOY", "PRODROMOS");
	insertAthlete(athletesFd, 70, "XRISTOFORAKH", "AUHNA");
	insertAthlete(athletesFd, 38, "TSATSOY", "DANAH");
	insertAthlete(athletesFd, 116, "KOKKVDHS", "IVANNHS");
	insertAthlete(athletesFd, 99, "KARASTERGIOY", "EIRHNH");
	insertAthlete(athletesFd, 333, "MHTROPOYLOY", "NIKOLITSA");
	insertAthlete(athletesFd, 55, "PELEKANAKHS", "LEVNIDAS");
	insertAthlete(athletesFd, 26, "ANDRIOLA", "ELENH");
	insertAthlete(athletesFd, 14, "KAKIASBILHS", "AKAKIOS");
	insertAthlete(athletesFd, 172, "NTOYRAKOS", "TZEHSON-MAIKL");
	insertAthlete(athletesFd, 169, "AMPALOB", "GEVRGIOS");
	insertAthlete(athletesFd, 328, "PAPADOPOYLOY", "STYLIANH");
	insertAthlete(athletesFd, 251, "PAPADOPOYLOS", "DHMHTRIOS");
	insertAthlete(athletesFd, 28, "PELIBANIDHS", "MIXAHL");
	insertAthlete(athletesFd, 307, "PATSOY", "EYFROSYNH");
	insertAthlete(athletesFd, 30, "MOIROY", "MARIA");
	insertAthlete(athletesFd, 268, "PETSANHS", "GEVRGIOS");
	insertAthlete(athletesFd, 344, "NTOYPHS", "GEVRGIOS");
	insertAthlete(athletesFd, 219, "XEIMVNETOS", "GEVRGIOS");
	insertAthlete(athletesFd, 20, "EYUYMIOY", "HLEKTRA-ELLH");
	insertAthlete(athletesFd, 66, "SAMOROYKOBA", "MARIA");
	insertAthlete(athletesFd, 164, "MPELIGRATHS", "PAYLOS");
	insertAthlete(athletesFd, 189, "ABRAMHS", "DHMHTRIOS");
	insertAthlete(athletesFd, 167, "SIDHROPOYLOY", "NIKH-KATERINA");
	insertAthlete(athletesFd, 384, "HLIADHS", "HLIAS");
	insertAthlete(athletesFd, 188, "KOLITSOPOYLOS", "ALEJIOS");
	insertAthlete(athletesFd, 140, "DHMHTRIOS", "KINGKSMPOYRI");
	insertAthlete(athletesFd, 257, "KAPERVNHS", "MARIOS");
	insertAthlete(athletesFd, 369, "MYSTAKIDOY", "ELISABET");
	insertAthlete(athletesFd, 205, "KRABARIK", "ANTREI");
	insertAthlete(athletesFd, 345, "OIKONOMIDHS", "GEVRGIOS");
	insertAthlete(athletesFd, 126, "TSAGKARAKHS", "APOSTOLOS");

    /*   ATHLETES */
	if (BF_CloseFile(athletesFd) != BFE_OK)
		BF_PrintError("Error in BF_CloseFile called on ATHLETES.");


	/* 
	 * ------------- EVENTS -------------
	 */
	/*   EVENTS */
	if (HF_CreateFile("EVENTS") != HFE_OK)
	{
		HF_PrintError("Error in HF_CreateFile called on EVENTS.");
	}

	/*   EVENTS */
	eventsFd = BF_OpenFile("EVENTS");

	if (eventsFd < 0)
	{
		HF_PrintError("Error in BF_OpenFile called on EVENTS.");
		return -1;
	}

	/*    Event */
	insertEvent(eventsFd, 5, "GYMNASTIKH TRAMPOLINO");
	insertEvent(eventsFd, 28, "STIBOS");
	insertEvent(eventsFd, 16, "MPEIZMPVL");
	insertEvent(eventsFd, 12, "KATADYSEIS");
	insertEvent(eventsFd, 27, "SOFTMPVL");
	insertEvent(eventsFd, 31, "TZOYNTO");
	insertEvent(eventsFd, 20, "PALH ELLHNORVMAIKH");
	insertEvent(eventsFd, 11, "KANOE-KAGIAK TAXYTHTA");
	insertEvent(eventsFd, 6, "EPITRAPEZIA ANTISFAIRISH");
	insertEvent(eventsFd, 13, "KOLYMBHSH");
	insertEvent(eventsFd, 2, "ARSH BARVN");
	insertEvent(eventsFd, 29, "SYGXRONISMENH KOLYMBHSH");
	insertEvent(eventsFd, 9, "KALAUOSFAIRISH");
	insertEvent(eventsFd, 1, "ANTISFAIRISH");
	insertEvent(eventsFd, 10, "KANOE-KAGIAK SLALOM");
	insertEvent(eventsFd, 22, "PODHLASIA OREINH");
	insertEvent(eventsFd, 30, "TAEKBONTO");
	insertEvent(eventsFd, 17, "MPITS BOLLEY");
	insertEvent(eventsFd, 0, "ANTIPTERISH");
	insertEvent(eventsFd, 7, "IPPASIA");
	insertEvent(eventsFd, 15, "MONTERNO PENTAULO");
	insertEvent(eventsFd, 3, "GYMNASTIKH ENORGANH");
	insertEvent(eventsFd, 8, "ISTIOPLOIA");
	insertEvent(eventsFd, 19, "PALH ELEYUERA");
	insertEvent(eventsFd, 14, "KVPHLASIA");
	insertEvent(eventsFd, 23, "PODHLASIA PISTAS");
	insertEvent(eventsFd, 18, "JIFASKIA");
	insertEvent(eventsFd, 26, "SKOPOBOLH");
	insertEvent(eventsFd, 4, "GYMNASTIKH");
	insertEvent(eventsFd, 24, "PODOSFAIRO");
	insertEvent(eventsFd, 25, "PYGMAXIA");
	insertEvent(eventsFd, 21, "PETOSFAIRISH");

	/*   EVENTS */
	if (BF_CloseFile(eventsFd) != BFE_OK)
		BF_PrintError("Error in BF_CloseFile called on EVENTS.");

	/* 
	 * ------------- PARTICIPATIONS -------------
	 */
	/*   PARTICIPATIONS */
	if (HF_CreateFile("PARTICIPATIONS") != HFE_OK)
	{
		HF_PrintError("Error in HF_CreateFile called on PARTICIPATIONS.");
	}

	/*   PARTICIPATIONS */
	partsFd = BF_OpenFile("PARTICIPATIONS");

	if (partsFd < 0)
	{
		HF_PrintError("Error in BF_OpenFile called on PARTICIPATIONS.");
		return -1;
	}

	/*    Participation */
	insertParticipation(partsFd, 1, 0, "05/12/2005");
	insertParticipation(partsFd, 84, 10, "14/01/1988");
	insertParticipation(partsFd, 118, 13, "08/09/1987");
	insertParticipation(partsFd, 216, 23, "05/06/2002");
	insertParticipation(partsFd, 246, 24, "27/12/1998");
	insertParticipation(partsFd, 4, 1, "17/01/1987");
	insertParticipation(partsFd, 173, 19, "20/04/1987");
	insertParticipation(partsFd, 16, 3, "18/08/1991");
	insertParticipation(partsFd, 150, 16, "01/05/1986");
	insertParticipation(partsFd, 317, 28, "03/07/1988");
	insertParticipation(partsFd, 84, 10, "12/02/1993");
	insertParticipation(partsFd, 235, 24, "16/12/1998");
	insertParticipation(partsFd, 371, 30, "14/08/1987");
	insertParticipation(partsFd, 53, 8, "05/01/2002");
	insertParticipation(partsFd, 62, 9, "19/08/1998");
	insertParticipation(partsFd, 90, 12, "17/08/2004");
	insertParticipation(partsFd, 96, 12, "11/01/1999");
	insertParticipation(partsFd, 207, 21, "28/06/2002");
	insertParticipation(partsFd, 159, 17, "17/05/1986");
	insertParticipation(partsFd, 335, 28, "13/10/1988");
	insertParticipation(partsFd, 385, 31, "15/04/1995");
	insertParticipation(partsFd, 220, 24, "22/02/1990");
	insertParticipation(partsFd, 235, 24, "13/11/1989");
	insertParticipation(partsFd, 357, 28, "10/07/1999");
	insertParticipation(partsFd, 348, 28, "03/02/1996");
	insertParticipation(partsFd, 194, 21, "17/10/2000");
	insertParticipation(partsFd, 207, 21, "28/12/1992");
	insertParticipation(partsFd, 230, 24, "16/09/2004");
	insertParticipation(partsFd, 95, 12, "21/05/1996");
	insertParticipation(partsFd, 149, 16, "23/03/1993");
	insertParticipation(partsFd, 67, 9, "25/11/2004");
	insertParticipation(partsFd, 211, 21, "01/09/1990");
	insertParticipation(partsFd, 266, 26, "21/04/1992");
	insertParticipation(partsFd, 314, 28, "14/03/1994");
	insertParticipation(partsFd, 113, 13, "02/12/2004");
	insertParticipation(partsFd, 374, 31, "01/04/1989");
	insertParticipation(partsFd, 239, 24, "27/10/1995");
	insertParticipation(partsFd, 61, 9, "23/04/1992");
	insertParticipation(partsFd, 66, 9, "13/02/1994");
	insertParticipation(partsFd, 194, 21, "27/02/1994");
	insertParticipation(partsFd, 243, 24, "06/10/2004");
	insertParticipation(partsFd, 353, 28, "21/05/2001");
	insertParticipation(partsFd, 266, 26, "23/12/1996");
	insertParticipation(partsFd, 318, 28, "27/09/1991");
	insertParticipation(partsFd, 19, 3, "13/02/2002");
	insertParticipation(partsFd, 90, 12, "26/05/2003");
	insertParticipation(partsFd, 32, 6, "13/07/1986");
	insertParticipation(partsFd, 194, 21, "18/12/2000");
	insertParticipation(partsFd, 314, 28, "17/02/1993");
	insertParticipation(partsFd, 335, 28, "05/10/2005");
	insertParticipation(partsFd, 10, 2, "24/10/1999");
	insertParticipation(partsFd, 165, 18, "03/11/1997");
	insertParticipation(partsFd, 276, 27, "24/09/2001");
	insertParticipation(partsFd, 79, 9, "06/04/1999");
	insertParticipation(partsFd, 185, 20, "23/01/1998");
	insertParticipation(partsFd, 202, 21, "03/11/1995");
	insertParticipation(partsFd, 211, 21, "22/04/1994");
	insertParticipation(partsFd, 96, 12, "16/01/2004");
	insertParticipation(partsFd, 334, 28, "26/08/1991");
	insertParticipation(partsFd, 328, 28, "27/02/2003");
	insertParticipation(partsFd, 374, 31, "28/08/1991");
	insertParticipation(partsFd, 132, 15, "16/11/1987");
	insertParticipation(partsFd, 145, 16, "13/12/1995");
	insertParticipation(partsFd, 371, 30, "13/05/1992");
	insertParticipation(partsFd, 49, 8, "04/02/2001");
	insertParticipation(partsFd, 67, 9, "15/10/1989");
	insertParticipation(partsFd, 164, 17, "07/07/2001");
	insertParticipation(partsFd, 1, 0, "12/03/1999");
	insertParticipation(partsFd, 158, 16, "25/06/1999");
	insertParticipation(partsFd, 22, 4, "14/11/1991");
	insertParticipation(partsFd, 357, 28, "21/09/1988");
	insertParticipation(partsFd, 334, 28, "24/08/1992");
	insertParticipation(partsFd, 80, 9, "06/06/1986");
	insertParticipation(partsFd, 357, 28, "14/02/1993");
	insertParticipation(partsFd, 113, 13, "07/11/1989");
	insertParticipation(partsFd, 207, 21, "13/10/1995");
	insertParticipation(partsFd, 239, 24, "18/12/1998");
	insertParticipation(partsFd, 67, 9, "17/08/2005");
	insertParticipation(partsFd, 353, 28, "27/10/2005");
	insertParticipation(partsFd, 155, 16, "09/07/1995");
	insertParticipation(partsFd, 185, 20, "27/04/1998");
	insertParticipation(partsFd, 331, 28, "28/12/2004");
	insertParticipation(partsFd, 180, 19, "21/10/1998");
	insertParticipation(partsFd, 211, 21, "27/11/1989");
	insertParticipation(partsFd, 259, 25, "10/05/1996");
	insertParticipation(partsFd, 104, 13, "10/10/1994");
	insertParticipation(partsFd, 239, 24, "15/10/1989");
	insertParticipation(partsFd, 366, 29, "21/09/1995");
	insertParticipation(partsFd, 54, 8, "10/03/2001");
	insertParticipation(partsFd, 309, 28, "05/07/1994");
	insertParticipation(partsFd, 381, 31, "21/06/2001");
	insertParticipation(partsFd, 36, 7, "13/07/2005");
	insertParticipation(partsFd, 328, 28, "18/10/2002");
	insertParticipation(partsFd, 173, 19, "26/01/1994");
	insertParticipation(partsFd, 321, 28, "05/03/2005");
	insertParticipation(partsFd, 90, 12, "18/02/2004");
	insertParticipation(partsFd, 1, 0, "14/05/1988");
	insertParticipation(partsFd, 155, 16, "17/02/1989");
	insertParticipation(partsFd, 4, 1, "12/12/1994");
	insertParticipation(partsFd, 32, 6, "01/04/1990");
	insertParticipation(partsFd, 356, 28, "03/09/1992");
	insertParticipation(partsFd, 51, 8, "06/05/1997");
	insertParticipation(partsFd, 293, 27, "06/05/1994");
	insertParticipation(partsFd, 43, 8, "24/09/1989");
	insertParticipation(partsFd, 200, 21, "09/03/2002");
	insertParticipation(partsFd, 308, 28, "25/06/1991");
	insertParticipation(partsFd, 28, 5, "16/02/2001");
	insertParticipation(partsFd, 159, 17, "06/07/1986");
	insertParticipation(partsFd, 225, 24, "22/06/1995");
	insertParticipation(partsFd, 279, 27, "22/02/1986");
	insertParticipation(partsFd, 43, 8, "09/08/1988");
	insertParticipation(partsFd, 79, 9, "11/07/2003");
	insertParticipation(partsFd, 210, 21, "07/08/1988");
	insertParticipation(partsFd, 243, 24, "17/02/1996");
	insertParticipation(partsFd, 207, 21, "24/05/1992");
	insertParticipation(partsFd, 159, 17, "07/02/1993");
	insertParticipation(partsFd, 371, 30, "04/11/2004");
	insertParticipation(partsFd, 261, 25, "22/05/2002");
	insertParticipation(partsFd, 293, 27, "19/02/1997");
	insertParticipation(partsFd, 276, 27, "19/09/2001");
	insertParticipation(partsFd, 9, 2, "14/02/2003");
	insertParticipation(partsFd, 322, 28, "06/11/1995");
	insertParticipation(partsFd, 54, 8, "07/07/2004");
	insertParticipation(partsFd, 361, 29, "21/02/1994");
	insertParticipation(partsFd, 381, 31, "13/08/2002");
	insertParticipation(partsFd, 32, 6, "24/08/1987");
	insertParticipation(partsFd, 235, 24, "14/11/1990");
	insertParticipation(partsFd, 378, 31, "03/08/1989");
	insertParticipation(partsFd, 185, 20, "08/06/1998");
	insertParticipation(partsFd, 292, 27, "17/06/1999");
	insertParticipation(partsFd, 32, 6, "18/02/1994");
	insertParticipation(partsFd, 61, 9, "27/06/2001");
	insertParticipation(partsFd, 292, 27, "09/03/2003");
	insertParticipation(partsFd, 61, 9, "10/09/1995");
	insertParticipation(partsFd, 37, 7, "28/04/2001");
	insertParticipation(partsFd, 216, 23, "15/12/1994");
	insertParticipation(partsFd, 207, 21, "27/04/1990");
	insertParticipation(partsFd, 66, 9, "02/05/2002");
	insertParticipation(partsFd, 164, 17, "14/03/2002");
	insertParticipation(partsFd, 254, 24, "23/07/1997");
	insertParticipation(partsFd, 266, 26, "16/04/2005");
	insertParticipation(partsFd, 272, 26, "06/09/1989");
	insertParticipation(partsFd, 378, 31, "13/11/1999");
	insertParticipation(partsFd, 53, 8, "16/10/2003");
	insertParticipation(partsFd, 163, 17, "27/03/1991");
	insertParticipation(partsFd, 132, 15, "04/10/1994");
	insertParticipation(partsFd, 15, 2, "16/08/2004");
	insertParticipation(partsFd, 239, 24, "22/02/2000");
	insertParticipation(partsFd, 108, 13, "22/10/2005");
	insertParticipation(partsFd, 21, 4, "18/12/1998");
	insertParticipation(partsFd, 219, 23, "13/06/1987");
	insertParticipation(partsFd, 108, 13, "16/12/1990");
	insertParticipation(partsFd, 352, 28, "14/09/1999");
	insertParticipation(partsFd, 141, 16, "24/03/2004");
	insertParticipation(partsFd, 303, 28, "20/05/2005");
	insertParticipation(partsFd, 113, 13, "21/07/1994");
	insertParticipation(partsFd, 185, 20, "22/11/1998");
	insertParticipation(partsFd, 195, 21, "07/06/1986");
	insertParticipation(partsFd, 337, 28, "17/11/1988");
	insertParticipation(partsFd, 358, 28, "12/12/2002");
	insertParticipation(partsFd, 177, 19, "25/01/1994");
	insertParticipation(partsFd, 216, 23, "04/07/2003");
	insertParticipation(partsFd, 103, 13, "15/06/1992");
	insertParticipation(partsFd, 37, 7, "18/03/2004");
	insertParticipation(partsFd, 378, 31, "23/02/1993");
	insertParticipation(partsFd, 4, 1, "13/02/2000");
	insertParticipation(partsFd, 201, 21, "18/01/1993");
	insertParticipation(partsFd, 243, 24, "08/08/1993");
	insertParticipation(partsFd, 181, 19, "13/11/1997");
	insertParticipation(partsFd, 246, 24, "21/12/2004");
	insertParticipation(partsFd, 254, 24, "05/09/2002");
	insertParticipation(partsFd, 10, 2, "02/06/2002");
	insertParticipation(partsFd, 169, 18, "22/05/1989");
	insertParticipation(partsFd, 16, 3, "12/09/2003");
	insertParticipation(partsFd, 104, 13, "15/10/1991");
	insertParticipation(partsFd, 378, 31, "21/05/1987");
	insertParticipation(partsFd, 348, 28, "19/01/2004");
	insertParticipation(partsFd, 28, 5, "02/11/1990");
	insertParticipation(partsFd, 191, 21, "19/05/2000");
	insertParticipation(partsFd, 113, 13, "20/07/1993");
	insertParticipation(partsFd, 11, 2, "15/07/1988");
	insertParticipation(partsFd, 37, 7, "19/03/1992");
	insertParticipation(partsFd, 113, 13, "16/06/2000");
	insertParticipation(partsFd, 303, 28, "25/05/2001");
	insertParticipation(partsFd, 76, 9, "04/07/1989");
	insertParticipation(partsFd, 72, 9, "20/03/1987");
	insertParticipation(partsFd, 202, 21, "02/04/1986");
	insertParticipation(partsFd, 280, 27, "05/09/1990");
	insertParticipation(partsFd, 353, 28, "26/05/1997");
	insertParticipation(partsFd, 191, 21, "16/02/1991");
	insertParticipation(partsFd, 322, 28, "03/11/1995");
	insertParticipation(partsFd, 328, 28, "17/05/2000");
	insertParticipation(partsFd, 353, 28, "14/04/1995");
	insertParticipation(partsFd, 28, 5, "04/03/1992");
	insertParticipation(partsFd, 133, 16, "13/07/2002");
	insertParticipation(partsFd, 191, 21, "06/04/1988");
	insertParticipation(partsFd, 97, 13, "06/01/1988");
	insertParticipation(partsFd, 16, 3, "05/05/1988");
	insertParticipation(partsFd, 49, 8, "15/08/2003");
	insertParticipation(partsFd, 127, 14, "17/09/1989");
	insertParticipation(partsFd, 226, 24, "15/11/1989");
	insertParticipation(partsFd, 76, 9, "26/03/1989");
	insertParticipation(partsFd, 270, 26, "27/01/1998");
	insertParticipation(partsFd, 318, 28, "28/11/2003");
	insertParticipation(partsFd, 44, 8, "24/11/2003");
	insertParticipation(partsFd, 1, 0, "12/07/1989");
	insertParticipation(partsFd, 76, 9, "02/02/1999");
	insertParticipation(partsFd, 162, 17, "24/04/1995");
	insertParticipation(partsFd, 207, 21, "14/07/1993");
	insertParticipation(partsFd, 317, 28, "16/07/1998");
	insertParticipation(partsFd, 248, 24, "02/09/2002");
	insertParticipation(partsFd, 84, 10, "02/05/1992");
	insertParticipation(partsFd, 85, 10, "01/04/1999");
	insertParticipation(partsFd, 297, 28, "25/01/1998");
	insertParticipation(partsFd, 279, 27, "17/08/2004");
	insertParticipation(partsFd, 76, 9, "07/07/1994");
	insertParticipation(partsFd, 225, 24, "16/03/1994");
	insertParticipation(partsFd, 67, 9, "09/08/1995");
	insertParticipation(partsFd, 150, 16, "05/04/2002");
	insertParticipation(partsFd, 155, 16, "28/07/1998");
	insertParticipation(partsFd, 361, 29, "15/02/1988");
	insertParticipation(partsFd, 67, 9, "19/12/2005");
	insertParticipation(partsFd, 169, 18, "25/07/2000");
	insertParticipation(partsFd, 67, 9, "06/08/1989");
	insertParticipation(partsFd, 217, 23, "19/07/2001");
	insertParticipation(partsFd, 374, 31, "03/08/1987");
	insertParticipation(partsFd, 207, 21, "27/02/1996");
	insertParticipation(partsFd, 293, 27, "17/08/1994");
	insertParticipation(partsFd, 95, 12, "04/01/1999");
	insertParticipation(partsFd, 159, 17, "18/07/1996");
	insertParticipation(partsFd, 328, 28, "08/07/1986");
	insertParticipation(partsFd, 231, 24, "11/03/2001");
	insertParticipation(partsFd, 80, 9, "12/10/2005");
	insertParticipation(partsFd, 231, 24, "02/08/1996");
	insertParticipation(partsFd, 15, 2, "01/04/1986");
	insertParticipation(partsFd, 131, 15, "06/08/2000");
	insertParticipation(partsFd, 235, 24, "26/07/1988");
	insertParticipation(partsFd, 75, 9, "28/08/1990");
	insertParticipation(partsFd, 185, 20, "13/07/1989");
	insertParticipation(partsFd, 276, 27, "11/10/1999");
	insertParticipation(partsFd, 253, 24, "26/05/1995");
	insertParticipation(partsFd, 344, 28, "08/11/1991");
	insertParticipation(partsFd, 76, 9, "17/03/2004");
	insertParticipation(partsFd, 159, 17, "09/10/1993");
	insertParticipation(partsFd, 165, 18, "06/11/2004");
	insertParticipation(partsFd, 385, 31, "09/03/2002");
	insertParticipation(partsFd, 181, 19, "11/09/2001");
	insertParticipation(partsFd, 261, 25, "24/11/2003");
	insertParticipation(partsFd, 293, 27, "07/01/1988");
	insertParticipation(partsFd, 67, 9, "02/07/1996");
	insertParticipation(partsFd, 22, 4, "14/11/2003");
	insertParticipation(partsFd, 211, 21, "14/10/1988");
	insertParticipation(partsFd, 226, 24, "20/09/2003");
	insertParticipation(partsFd, 247, 24, "07/03/2003");
	insertParticipation(partsFd, 178, 19, "18/12/1995");
	insertParticipation(partsFd, 95, 12, "07/04/1995");
	insertParticipation(partsFd, 132, 15, "12/09/1988");
	insertParticipation(partsFd, 220, 24, "09/08/1996");
	insertParticipation(partsFd, 15, 2, "25/10/1988");
	insertParticipation(partsFd, 276, 27, "27/01/1994");
	insertParticipation(partsFd, 113, 13, "25/07/2003");
	insertParticipation(partsFd, 145, 16, "14/06/1996");
	insertParticipation(partsFd, 180, 19, "12/04/2004");
	insertParticipation(partsFd, 266, 26, "07/11/1991");
	insertParticipation(partsFd, 236, 24, "21/06/2000");
	insertParticipation(partsFd, 243, 24, "12/10/1996");
	insertParticipation(partsFd, 367, 29, "11/08/1996");
	insertParticipation(partsFd, 298, 28, "05/10/1993");
	insertParticipation(partsFd, 51, 8, "28/07/1998");
	insertParticipation(partsFd, 181, 19, "09/11/1989");
	insertParticipation(partsFd, 53, 8, "05/04/1997");
	insertParticipation(partsFd, 230, 24, "23/04/2003");
	insertParticipation(partsFd, 118, 13, "10/11/1995");
	insertParticipation(partsFd, 195, 21, "24/05/1995");
	insertParticipation(partsFd, 145, 16, "28/10/2004");
	insertParticipation(partsFd, 37, 7, "03/02/1994");
	insertParticipation(partsFd, 211, 21, "12/02/1991");
	insertParticipation(partsFd, 243, 24, "09/07/1997");
	insertParticipation(partsFd, 338, 28, "19/08/1997");
	insertParticipation(partsFd, 331, 28, "06/04/1999");
	insertParticipation(partsFd, 265, 26, "07/02/2004");
	insertParticipation(partsFd, 322, 28, "05/08/1989");
	insertParticipation(partsFd, 4, 1, "26/08/2004");
	insertParticipation(partsFd, 211, 21, "04/10/1991");
	insertParticipation(partsFd, 247, 24, "03/02/1992");
	insertParticipation(partsFd, 4, 1, "26/01/1989");
	insertParticipation(partsFd, 216, 23, "06/04/1992");
	insertParticipation(partsFd, 280, 27, "18/10/1992");
	insertParticipation(partsFd, 344, 28, "05/10/1990");
	insertParticipation(partsFd, 169, 18, "23/11/1989");
	insertParticipation(partsFd, 303, 28, "17/07/1992");
	insertParticipation(partsFd, 142, 16, "08/08/1996");
	insertParticipation(partsFd, 61, 9, "07/02/1994");
	insertParticipation(partsFd, 61, 9, "26/03/2005");
	insertParticipation(partsFd, 374, 31, "15/02/1986");
	insertParticipation(partsFd, 159, 17, "21/03/1998");
	insertParticipation(partsFd, 271, 26, "18/10/1991");
	insertParticipation(partsFd, 352, 28, "02/07/2002");
	insertParticipation(partsFd, 194, 21, "12/08/1992");
	insertParticipation(partsFd, 15, 2, "27/12/2002");
	insertParticipation(partsFd, 348, 28, "05/12/2003");
	insertParticipation(partsFd, 8, 2, "19/10/2005");
	insertParticipation(partsFd, 103, 13, "07/11/1999");
	insertParticipation(partsFd, 216, 23, "15/09/2004");
	insertParticipation(partsFd, 239, 24, "04/06/1990");
	insertParticipation(partsFd, 317, 28, "01/05/1987");
	insertParticipation(partsFd, 1, 0, "16/12/1992");
	insertParticipation(partsFd, 43, 8, "13/07/2003");
	insertParticipation(partsFd, 90, 12, "19/11/1995");
	insertParticipation(partsFd, 31, 6, "14/02/1995");
	insertParticipation(partsFd, 287, 27, "05/11/1998");
	insertParticipation(partsFd, 1, 0, "06/09/1987");
	insertParticipation(partsFd, 61, 9, "15/09/2003");
	insertParticipation(partsFd, 327, 28, "01/09/2005");
	insertParticipation(partsFd, 61, 9, "23/01/1994");
	insertParticipation(partsFd, 287, 27, "23/06/1996");
	insertParticipation(partsFd, 15, 2, "23/11/2003");
	insertParticipation(partsFd, 177, 19, "17/09/1996");
	insertParticipation(partsFd, 338, 28, "02/01/1994");
	insertParticipation(partsFd, 53, 8, "14/01/2000");
	insertParticipation(partsFd, 381, 31, "22/03/1996");
	insertParticipation(partsFd, 118, 13, "06/09/2004");
	insertParticipation(partsFd, 185, 20, "28/06/1989");
	insertParticipation(partsFd, 243, 24, "27/02/1991");
	insertParticipation(partsFd, 344, 28, "14/02/2000");
	insertParticipation(partsFd, 279, 27, "24/10/1987");
	insertParticipation(partsFd, 374, 31, "13/11/2005");
	insertParticipation(partsFd, 191, 21, "02/05/1994");
	insertParticipation(partsFd, 123, 13, "23/12/2001");
	insertParticipation(partsFd, 276, 27, "15/10/1993");
	insertParticipation(partsFd, 202, 21, "25/12/1987");
	insertParticipation(partsFd, 293, 27, "22/04/2005");
	insertParticipation(partsFd, 190, 20, "08/04/1988");
	insertParticipation(partsFd, 90, 12, "21/04/1999");
	insertParticipation(partsFd, 22, 4, "28/12/1998");
	insertParticipation(partsFd, 374, 31, "19/04/1990");
	insertParticipation(partsFd, 186, 20, "10/05/1990");
	insertParticipation(partsFd, 220, 24, "28/04/2000");
	insertParticipation(partsFd, 334, 28, "21/08/1987");
	insertParticipation(partsFd, 374, 31, "24/04/2000");
	insertParticipation(partsFd, 113, 13, "24/11/1986");
	insertParticipation(partsFd, 169, 18, "22/10/2001");
	insertParticipation(partsFd, 219, 23, "24/04/1995");
	insertParticipation(partsFd, 226, 24, "02/10/1991");
	insertParticipation(partsFd, 127, 14, "14/09/1987");
	insertParticipation(partsFd, 322, 28, "15/04/2003");
	insertParticipation(partsFd, 84, 10, "03/03/2001");
	insertParticipation(partsFd, 10, 2, "24/07/2000");
	insertParticipation(partsFd, 331, 28, "17/08/1993");
	insertParticipation(partsFd, 146, 16, "26/12/1997");
	insertParticipation(partsFd, 5, 1, "22/11/1995");
	insertParticipation(partsFd, 72, 9, "05/07/1990");
	insertParticipation(partsFd, 348, 28, "10/09/1989");
	insertParticipation(partsFd, 145, 16, "20/06/1994");
	insertParticipation(partsFd, 348, 28, "22/09/2003");
	insertParticipation(partsFd, 293, 27, "17/08/1986");
	insertParticipation(partsFd, 328, 28, "10/11/1994");
	insertParticipation(partsFd, 334, 28, "01/10/1999");
	insertParticipation(partsFd, 53, 8, "23/12/1989");
	insertParticipation(partsFd, 239, 24, "16/04/1987");
	insertParticipation(partsFd, 259, 25, "07/07/1993");
	insertParticipation(partsFd, 11, 2, "06/05/2002");
	insertParticipation(partsFd, 16, 3, "12/10/1986");
	insertParticipation(partsFd, 141, 16, "02/05/1989");
	insertParticipation(partsFd, 297, 28, "23/01/1991");
	insertParticipation(partsFd, 307, 28, "03/09/1992");
	insertParticipation(partsFd, 159, 17, "15/07/1995");
	insertParticipation(partsFd, 288, 27, "19/11/1994");
	insertParticipation(partsFd, 367, 29, "07/09/1994");
	insertParticipation(partsFd, 42, 8, "04/01/1998");
	insertParticipation(partsFd, 254, 24, "02/07/1988");
	insertParticipation(partsFd, 253, 24, "03/03/2003");
	insertParticipation(partsFd, 348, 28, "24/06/1993");
	insertParticipation(partsFd, 318, 28, "26/06/1994");
	insertParticipation(partsFd, 181, 19, "22/04/1986");
	insertParticipation(partsFd, 317, 28, "06/07/1999");
	insertParticipation(partsFd, 219, 23, "17/02/1990");
	insertParticipation(partsFd, 266, 26, "19/06/1989");
	insertParticipation(partsFd, 374, 31, "12/08/1999");
	insertParticipation(partsFd, 145, 16, "05/06/1988");
	insertParticipation(partsFd, 331, 28, "06/09/1989");
	insertParticipation(partsFd, 42, 8, "25/04/1998");
	insertParticipation(partsFd, 53, 8, "23/01/2003");
	insertParticipation(partsFd, 1, 0, "12/06/1994");
	insertParticipation(partsFd, 215, 22, "14/08/1988");
	insertParticipation(partsFd, 8, 2, "21/02/1986");
	insertParticipation(partsFd, 260, 25, "28/12/1994");
	insertParticipation(partsFd, 123, 13, "06/10/2005");
	insertParticipation(partsFd, 132, 15, "11/04/2001");
	insertParticipation(partsFd, 37, 7, "21/10/2004");
	insertParticipation(partsFd, 155, 16, "07/11/1992");
	insertParticipation(partsFd, 385, 31, "09/06/1993");
	insertParticipation(partsFd, 173, 19, "07/05/2005");
	insertParticipation(partsFd, 276, 27, "12/12/1992");
	insertParticipation(partsFd, 207, 21, "08/06/1991");
	insertParticipation(partsFd, 352, 28, "15/10/2005");
	insertParticipation(partsFd, 138, 16, "27/01/2005");
	insertParticipation(partsFd, 26, 4, "17/04/2003");
	insertParticipation(partsFd, 309, 28, "10/03/2002");
	insertParticipation(partsFd, 16, 3, "04/04/1997");
	insertParticipation(partsFd, 84, 10, "12/07/1998");
	insertParticipation(partsFd, 102, 13, "23/03/1990");
	insertParticipation(partsFd, 276, 27, "20/11/2002");
	insertParticipation(partsFd, 95, 12, "10/08/2005");
	insertParticipation(partsFd, 113, 13, "05/05/1996");
	insertParticipation(partsFd, 338, 28, "06/01/2003");
	insertParticipation(partsFd, 1, 0, "27/09/1991");
	insertParticipation(partsFd, 253, 24, "17/07/1990");
	insertParticipation(partsFd, 135, 16, "08/06/2004");
	insertParticipation(partsFd, 177, 19, "16/06/1989");
	insertParticipation(partsFd, 90, 12, "13/05/2000");
	insertParticipation(partsFd, 215, 22, "26/07/1986");
	insertParticipation(partsFd, 118, 13, "07/01/1990");
	insertParticipation(partsFd, 216, 23, "08/05/2004");
	insertParticipation(partsFd, 309, 28, "11/10/1991");
	insertParticipation(partsFd, 373, 31, "28/03/2004");
	insertParticipation(partsFd, 32, 6, "28/05/1990");
	insertParticipation(partsFd, 211, 21, "19/11/2001");
	insertParticipation(partsFd, 252, 24, "05/07/1993");
	insertParticipation(partsFd, 352, 28, "24/10/1998");
	insertParticipation(partsFd, 49, 8, "28/09/2001");
	insertParticipation(partsFd, 135, 16, "07/08/1988");
	insertParticipation(partsFd, 118, 13, "16/01/1992");
	insertParticipation(partsFd, 180, 19, "23/06/1993");
	insertParticipation(partsFd, 307, 28, "13/10/1999");
	insertParticipation(partsFd, 103, 13, "08/12/2002");
	insertParticipation(partsFd, 220, 24, "05/08/1990");
	insertParticipation(partsFd, 155, 16, "18/09/2005");
	insertParticipation(partsFd, 146, 16, "25/07/1992");
	insertParticipation(partsFd, 235, 24, "19/11/1986");
	insertParticipation(partsFd, 292, 27, "08/10/1990");
	insertParticipation(partsFd, 357, 28, "28/09/2001");
	insertParticipation(partsFd, 219, 23, "13/08/1992");
	insertParticipation(partsFd, 260, 25, "16/01/1989");
	insertParticipation(partsFd, 76, 9, "04/08/1999");
	insertParticipation(partsFd, 159, 17, "10/05/1995");
	insertParticipation(partsFd, 247, 24, "14/04/1993");
	insertParticipation(partsFd, 231, 24, "24/04/2004");
	insertParticipation(partsFd, 80, 9, "05/12/1992");
	insertParticipation(partsFd, 365, 29, "16/07/2004");
	insertParticipation(partsFd, 247, 24, "09/08/2002");
	insertParticipation(partsFd, 297, 28, "17/12/2000");
	insertParticipation(partsFd, 338, 28, "07/10/1998");
	insertParticipation(partsFd, 61, 9, "15/11/1994");
	insertParticipation(partsFd, 303, 28, "24/09/2000");
	insertParticipation(partsFd, 361, 29, "23/09/1986");
	insertParticipation(partsFd, 328, 28, "26/05/1997");
	insertParticipation(partsFd, 22, 4, "06/07/1997");
	insertParticipation(partsFd, 142, 16, "16/05/1986");
	insertParticipation(partsFd, 72, 9, "05/02/2000");
	insertParticipation(partsFd, 201, 21, "17/04/1994");
	insertParticipation(partsFd, 118, 13, "03/08/1996");
	insertParticipation(partsFd, 145, 16, "07/07/1991");
	insertParticipation(partsFd, 207, 21, "26/07/1996");
	insertParticipation(partsFd, 32, 6, "27/10/1994");
	insertParticipation(partsFd, 103, 13, "01/01/1999");
	insertParticipation(partsFd, 266, 26, "16/05/1989");
	insertParticipation(partsFd, 16, 3, "25/03/1992");
	insertParticipation(partsFd, 168, 18, "27/04/1998");
	insertParticipation(partsFd, 173, 19, "11/06/1986");
	insertParticipation(partsFd, 177, 19, "24/05/2000");
	insertParticipation(partsFd, 28, 5, "01/11/1996");
	insertParticipation(partsFd, 53, 8, "28/02/1998");
	insertParticipation(partsFd, 159, 17, "21/02/2005");
	insertParticipation(partsFd, 288, 27, "23/05/1994");
	insertParticipation(partsFd, 374, 31, "08/10/1995");
	insertParticipation(partsFd, 1, 0, "16/07/1995");
	insertParticipation(partsFd, 191, 21, "25/08/1991");
	insertParticipation(partsFd, 353, 28, "16/08/2001");
	insertParticipation(partsFd, 117, 13, "12/10/1999");
	insertParticipation(partsFd, 242, 24, "05/12/1997");
	insertParticipation(partsFd, 280, 27, "03/02/2002");
	insertParticipation(partsFd, 367, 29, "21/06/1996");
	insertParticipation(partsFd, 150, 16, "25/03/2000");
	insertParticipation(partsFd, 168, 18, "15/06/1991");
	insertParticipation(partsFd, 317, 28, "05/02/1994");
	insertParticipation(partsFd, 53, 8, "10/07/1994");
	insertParticipation(partsFd, 150, 16, "07/01/1997");
	insertParticipation(partsFd, 348, 28, "16/11/1991");
	insertParticipation(partsFd, 49, 8, "09/06/1990");
	insertParticipation(partsFd, 72, 9, "10/07/1990");
	insertParticipation(partsFd, 280, 27, "22/07/2003");
	insertParticipation(partsFd, 331, 28, "24/04/1987");
	insertParticipation(partsFd, 37, 7, "20/05/2003");
	insertParticipation(partsFd, 338, 28, "26/10/1991");
	insertParticipation(partsFd, 381, 31, "25/12/1997");
	insertParticipation(partsFd, 303, 28, "07/10/1993");
	insertParticipation(partsFd, 334, 28, "16/10/1986");
	insertParticipation(partsFd, 271, 26, "09/10/1992");
	insertParticipation(partsFd, 378, 31, "01/03/1998");
	insertParticipation(partsFd, 127, 14, "17/03/1990");
	insertParticipation(partsFd, 299, 28, "21/06/1999");
	insertParticipation(partsFd, 12, 2, "18/02/2001");
	insertParticipation(partsFd, 271, 26, "04/06/1989");
	insertParticipation(partsFd, 220, 24, "16/11/1991");
	insertParticipation(partsFd, 243, 24, "26/10/1996");
	insertParticipation(partsFd, 169, 18, "05/09/1990");
	insertParticipation(partsFd, 211, 21, "14/08/1990");
	insertParticipation(partsFd, 231, 24, "09/12/1987");
	insertParticipation(partsFd, 338, 28, "20/01/1990");
	insertParticipation(partsFd, 72, 9, "20/03/2005");
	insertParticipation(partsFd, 351, 28, "25/09/1993");
	insertParticipation(partsFd, 141, 16, "01/05/2004");
	insertParticipation(partsFd, 150, 16, "08/04/1992");
	insertParticipation(partsFd, 210, 21, "26/09/1997");
	insertParticipation(partsFd, 173, 19, "05/03/2001");
	insertParticipation(partsFd, 195, 21, "24/08/1996");
	insertParticipation(partsFd, 136, 16, "14/05/1991");
	insertParticipation(partsFd, 210, 21, "24/11/1997");
	insertParticipation(partsFd, 173, 19, "12/10/1992");
	insertParticipation(partsFd, 127, 14, "06/04/1999");
	insertParticipation(partsFd, 20, 4, "04/04/1988");
	insertParticipation(partsFd, 371, 30, "18/08/1992");
	insertParticipation(partsFd, 127, 14, "11/01/1992");
	insertParticipation(partsFd, 290, 27, "06/04/1999");
	insertParticipation(partsFd, 361, 29, "19/02/1989");
	insertParticipation(partsFd, 337, 28, "12/01/1988");
	insertParticipation(partsFd, 314, 28, "28/09/2003");
	insertParticipation(partsFd, 1, 0, "15/04/2002");
	insertParticipation(partsFd, 168, 18, "04/05/1996");
	insertParticipation(partsFd, 195, 21, "16/06/1993");
	insertParticipation(partsFd, 226, 24, "02/05/2000");
	insertParticipation(partsFd, 327, 28, "27/02/1986");
	insertParticipation(partsFd, 118, 13, "27/03/1999");
	insertParticipation(partsFd, 344, 28, "01/10/1995");
	insertParticipation(partsFd, 342, 28, "17/07/1989");
	insertParticipation(partsFd, 181, 19, "12/02/1991");
	insertParticipation(partsFd, 371, 30, "15/02/2000");
	insertParticipation(partsFd, 51, 8, "20/09/2004");
	insertParticipation(partsFd, 133, 16, "20/07/1998");
	insertParticipation(partsFd, 37, 7, "26/06/2004");
	insertParticipation(partsFd, 271, 26, "10/09/1991");
	insertParticipation(partsFd, 322, 28, "10/08/1988");
	insertParticipation(partsFd, 357, 28, "05/04/1995");
	insertParticipation(partsFd, 275, 27, "13/05/2002");
	insertParticipation(partsFd, 358, 28, "04/02/1994");
	insertParticipation(partsFd, 271, 26, "11/06/1989");
	insertParticipation(partsFd, 318, 28, "05/01/1993");
	insertParticipation(partsFd, 158, 16, "15/01/2003");
	insertParticipation(partsFd, 165, 18, "14/10/1986");
	insertParticipation(partsFd, 200, 21, "10/04/1992");
	insertParticipation(partsFd, 177, 19, "01/10/1997");
	insertParticipation(partsFd, 226, 24, "15/11/1997");
	insertParticipation(partsFd, 95, 12, "14/11/1993");
	insertParticipation(partsFd, 142, 16, "06/12/2004");
	insertParticipation(partsFd, 215, 22, "14/08/2003");
	insertParticipation(partsFd, 243, 24, "28/05/1995");
	insertParticipation(partsFd, 42, 8, "10/11/1992");
	insertParticipation(partsFd, 381, 31, "01/04/1993");
	insertParticipation(partsFd, 135, 16, "12/02/1990");
	insertParticipation(partsFd, 385, 31, "13/08/1990");
	insertParticipation(partsFd, 66, 9, "08/05/1991");
	insertParticipation(partsFd, 79, 9, "07/12/2003");
	insertParticipation(partsFd, 230, 24, "12/06/1993");
	insertParticipation(partsFd, 206, 21, "18/01/1992");
	insertParticipation(partsFd, 344, 28, "08/05/1999");
	insertParticipation(partsFd, 177, 19, "12/05/1991");
	insertParticipation(partsFd, 276, 27, "14/09/1993");
	insertParticipation(partsFd, 338, 28, "28/04/2003");
	insertParticipation(partsFd, 43, 8, "15/04/2002");
	insertParticipation(partsFd, 43, 8, "01/03/1991");
	insertParticipation(partsFd, 61, 9, "09/06/1986");
	insertParticipation(partsFd, 276, 27, "16/02/1995");
	insertParticipation(partsFd, 15, 2, "07/10/1993");
	insertParticipation(partsFd, 243, 24, "14/07/1987");
	insertParticipation(partsFd, 303, 28, "20/11/1995");
	insertParticipation(partsFd, 54, 8, "18/06/1987");
	insertParticipation(partsFd, 334, 28, "17/02/1994");
	insertParticipation(partsFd, 266, 26, "10/08/1996");
	insertParticipation(partsFd, 67, 9, "14/12/1987");
	insertParticipation(partsFd, 79, 9, "03/10/1988");
	insertParticipation(partsFd, 127, 14, "02/05/1999");
	insertParticipation(partsFd, 113, 13, "22/10/1992");
	insertParticipation(partsFd, 118, 13, "18/11/1991");
	insertParticipation(partsFd, 338, 28, "15/03/1999");
	insertParticipation(partsFd, 216, 23, "26/05/1988");
	insertParticipation(partsFd, 243, 24, "05/07/1994");
	insertParticipation(partsFd, 9, 2, "15/02/1999");
	insertParticipation(partsFd, 123, 13, "21/10/1998");
	insertParticipation(partsFd, 293, 27, "20/06/1993");
	insertParticipation(partsFd, 378, 31, "27/11/2003");
	insertParticipation(partsFd, 371, 30, "17/01/1995");
	insertParticipation(partsFd, 38, 7, "19/07/1991");
	insertParticipation(partsFd, 103, 13, "25/01/2000");
	insertParticipation(partsFd, 331, 28, "22/03/2003");
	insertParticipation(partsFd, 90, 12, "13/03/1995");
	insertParticipation(partsFd, 276, 27, "26/09/1996");
	insertParticipation(partsFd, 235, 24, "19/03/1986");
	insertParticipation(partsFd, 72, 9, "04/10/2003");
	insertParticipation(partsFd, 191, 21, "15/07/1996");
	insertParticipation(partsFd, 367, 29, "20/11/1999");
	insertParticipation(partsFd, 108, 13, "22/05/2002");
	insertParticipation(partsFd, 280, 27, "16/03/2005");
	insertParticipation(partsFd, 252, 24, "26/04/2005");
	insertParticipation(partsFd, 32, 6, "04/07/2005");
	insertParticipation(partsFd, 4, 1, "23/01/1994");
	insertParticipation(partsFd, 72, 9, "08/01/2001");
	insertParticipation(partsFd, 21, 4, "23/11/2003");
	insertParticipation(partsFd, 84, 10, "02/11/1990");
	insertParticipation(partsFd, 122, 13, "26/10/2002");
	insertParticipation(partsFd, 366, 29, "03/03/2005");
	insertParticipation(partsFd, 103, 13, "04/09/1994");
	insertParticipation(partsFd, 72, 9, "01/01/1999");
	insertParticipation(partsFd, 1, 0, "06/09/2004");
	insertParticipation(partsFd, 191, 21, "22/07/2003");
	insertParticipation(partsFd, 309, 28, "18/08/2002");
	insertParticipation(partsFd, 314, 28, "02/08/1993");
	insertParticipation(partsFd, 303, 28, "12/09/1989");
	insertParticipation(partsFd, 370, 30, "07/08/1990");
	insertParticipation(partsFd, 135, 16, "15/01/2003");
	insertParticipation(partsFd, 10, 2, "17/09/1998");
	insertParticipation(partsFd, 314, 28, "18/11/1991");
	insertParticipation(partsFd, 96, 12, "05/01/2000");
	insertParticipation(partsFd, 348, 28, "05/07/1989");
	insertParticipation(partsFd, 72, 9, "22/01/1990");
	insertParticipation(partsFd, 318, 28, "22/03/1997");
	insertParticipation(partsFd, 334, 28, "17/03/1989");
	insertParticipation(partsFd, 177, 19, "16/08/1995");
	insertParticipation(partsFd, 266, 26, "18/11/1992");
	insertParticipation(partsFd, 247, 24, "26/01/2003");
	insertParticipation(partsFd, 297, 28, "07/10/2001");
	insertParticipation(partsFd, 314, 28, "06/05/1987");
	insertParticipation(partsFd, 317, 28, "23/08/1996");
	insertParticipation(partsFd, 289, 27, "20/03/1996");
	insertParticipation(partsFd, 288, 27, "27/04/2001");
	insertParticipation(partsFd, 76, 9, "19/02/1988");
	insertParticipation(partsFd, 381, 31, "09/04/2005");
	insertParticipation(partsFd, 104, 13, "13/01/1988");
	insertParticipation(partsFd, 309, 28, "15/02/1994");
	insertParticipation(partsFd, 348, 28, "03/09/2000");
	insertParticipation(partsFd, 165, 18, "17/04/2002");
	insertParticipation(partsFd, 361, 29, "03/03/1994");
	insertParticipation(partsFd, 191, 21, "15/07/1987");
	insertParticipation(partsFd, 173, 19, "14/01/2001");
	insertParticipation(partsFd, 22, 4, "04/01/1994");
	insertParticipation(partsFd, 230, 24, "16/02/1990");
	insertParticipation(partsFd, 122, 13, "24/07/2003");
	insertParticipation(partsFd, 270, 26, "18/08/1993");
	insertParticipation(partsFd, 235, 24, "21/07/1992");
	insertParticipation(partsFd, 281, 27, "05/12/1999");
	insertParticipation(partsFd, 378, 31, "12/05/2001");
	insertParticipation(partsFd, 207, 21, "15/01/1990");
	insertParticipation(partsFd, 292, 27, "22/10/1998");
	insertParticipation(partsFd, 191, 21, "04/06/2001");
	insertParticipation(partsFd, 378, 31, "05/01/1992");
	insertParticipation(partsFd, 62, 9, "16/05/1992");
	insertParticipation(partsFd, 76, 9, "24/04/1996");
	insertParticipation(partsFd, 374, 31, "05/09/1997");
	insertParticipation(partsFd, 361, 29, "04/04/1989");
	insertParticipation(partsFd, 180, 19, "14/07/1989");
	insertParticipation(partsFd, 113, 13, "01/12/1992");
	insertParticipation(partsFd, 216, 23, "16/10/1997");
	insertParticipation(partsFd, 173, 19, "23/08/1993");
	insertParticipation(partsFd, 279, 27, "27/06/2000");
	insertParticipation(partsFd, 243, 24, "08/12/2003");
	insertParticipation(partsFd, 4, 1, "21/04/1994");
	insertParticipation(partsFd, 159, 17, "26/08/2005");
	insertParticipation(partsFd, 145, 16, "28/02/2005");
	insertParticipation(partsFd, 381, 31, "23/02/1995");
	insertParticipation(partsFd, 191, 21, "18/04/1989");
	insertParticipation(partsFd, 207, 21, "25/08/2000");
	insertParticipation(partsFd, 381, 31, "19/08/2002");
	insertParticipation(partsFd, 289, 27, "15/09/2003");
	insertParticipation(partsFd, 28, 5, "06/02/2002");
	insertParticipation(partsFd, 85, 10, "03/02/2001");
	insertParticipation(partsFd, 90, 12, "28/10/1991");
	insertParticipation(partsFd, 96, 12, "03/02/1986");
	insertParticipation(partsFd, 108, 13, "20/09/1996");
	insertParticipation(partsFd, 178, 19, "14/08/1990");
	insertParticipation(partsFd, 201, 21, "14/07/2002");
	insertParticipation(partsFd, 182, 19, "07/05/2005");
	insertParticipation(partsFd, 53, 8, "24/07/1990");
	insertParticipation(partsFd, 83, 10, "24/05/2004");
	insertParticipation(partsFd, 162, 17, "08/01/1995");
	insertParticipation(partsFd, 136, 16, "11/05/2003");
	insertParticipation(partsFd, 72, 9, "04/09/1991");
	insertParticipation(partsFd, 85, 10, "14/01/1991");
	insertParticipation(partsFd, 159, 17, "08/04/1996");
	insertParticipation(partsFd, 216, 23, "08/02/1992");
	insertParticipation(partsFd, 32, 6, "27/01/1997");
	insertParticipation(partsFd, 173, 19, "08/12/1990");
	insertParticipation(partsFd, 71, 9, "11/04/2001");
	insertParticipation(partsFd, 145, 16, "13/05/2000");
	insertParticipation(partsFd, 371, 30, "16/11/1988");
	insertParticipation(partsFd, 28, 5, "01/12/2001");
	insertParticipation(partsFd, 79, 9, "04/01/1987");
	insertParticipation(partsFd, 195, 21, "21/05/1989");
	insertParticipation(partsFd, 378, 31, "26/10/1987");
	insertParticipation(partsFd, 76, 9, "15/06/2004");
	insertParticipation(partsFd, 4, 1, "17/04/2001");
	insertParticipation(partsFd, 128, 14, "14/07/1991");
	insertParticipation(partsFd, 378, 31, "04/08/2004");
	insertParticipation(partsFd, 141, 16, "14/11/2002");
	insertParticipation(partsFd, 207, 21, "22/12/1994");
	insertParticipation(partsFd, 10, 2, "19/12/1999");
	insertParticipation(partsFd, 253, 24, "04/06/1986");
	insertParticipation(partsFd, 38, 7, "28/04/1994");
	insertParticipation(partsFd, 107, 13, "10/09/1989");
	insertParticipation(partsFd, 28, 5, "27/06/2004");
	insertParticipation(partsFd, 49, 8, "13/01/2003");
	insertParticipation(partsFd, 135, 16, "10/04/2004");
	insertParticipation(partsFd, 169, 18, "04/11/1990");
	insertParticipation(partsFd, 108, 13, "05/07/1986");
	insertParticipation(partsFd, 169, 18, "17/06/2001");
	insertParticipation(partsFd, 72, 9, "12/04/1989");
	insertParticipation(partsFd, 185, 20, "19/10/1999");
	insertParticipation(partsFd, 75, 9, "16/08/1994");
	insertParticipation(partsFd, 266, 26, "10/09/1987");
	insertParticipation(partsFd, 113, 13, "23/12/1986");
	insertParticipation(partsFd, 288, 27, "12/10/1997");
	insertParticipation(partsFd, 186, 20, "25/12/1988");
	insertParticipation(partsFd, 141, 16, "11/11/2000");
	insertParticipation(partsFd, 366, 29, "24/11/1995");
	insertParticipation(partsFd, 230, 24, "14/11/1992");
	insertParticipation(partsFd, 371, 30, "27/03/1998");
	insertParticipation(partsFd, 361, 29, "27/09/1990");
	insertParticipation(partsFd, 37, 7, "08/04/1988");
	insertParticipation(partsFd, 123, 13, "28/04/2003");
	insertParticipation(partsFd, 90, 12, "17/06/2004");
	insertParticipation(partsFd, 195, 21, "08/10/1998");
	insertParticipation(partsFd, 123, 13, "20/07/1990");
	insertParticipation(partsFd, 50, 8, "22/09/1998");
	insertParticipation(partsFd, 177, 19, "01/02/2001");
	insertParticipation(partsFd, 28, 5, "26/04/1996");
	insertParticipation(partsFd, 31, 6, "12/02/2001");
	insertParticipation(partsFd, 150, 16, "01/04/2000");
	insertParticipation(partsFd, 84, 10, "10/09/1998");
	insertParticipation(partsFd, 137, 16, "03/07/1988");
	insertParticipation(partsFd, 226, 24, "25/04/1989");
	insertParticipation(partsFd, 227, 24, "12/09/1987");
	insertParticipation(partsFd, 236, 24, "04/09/1990");
	insertParticipation(partsFd, 178, 19, "08/07/2005");
	insertParticipation(partsFd, 207, 21, "24/12/2002");
	insertParticipation(partsFd, 216, 23, "07/02/2005");
	insertParticipation(partsFd, 117, 13, "09/02/1988");
	insertParticipation(partsFd, 19, 3, "06/01/1999");
	insertParticipation(partsFd, 276, 27, "23/04/2000");
	insertParticipation(partsFd, 239, 24, "27/12/1999");
	insertParticipation(partsFd, 255, 24, "09/11/2004");
	insertParticipation(partsFd, 155, 16, "05/06/1998");
	insertParticipation(partsFd, 254, 24, "24/11/2001");
	insertParticipation(partsFd, 150, 16, "24/09/1997");
	insertParticipation(partsFd, 159, 17, "10/03/1994");
	insertParticipation(partsFd, 230, 24, "04/04/1986");
	insertParticipation(partsFd, 149, 16, "21/11/1992");
	insertParticipation(partsFd, 155, 16, "17/11/1992");
	insertParticipation(partsFd, 127, 14, "14/02/1986");
	insertParticipation(partsFd, 32, 6, "06/11/1989");
	insertParticipation(partsFd, 275, 27, "07/10/1991");
	insertParticipation(partsFd, 4, 1, "21/01/1997");
	insertParticipation(partsFd, 243, 24, "28/06/2001");
	insertParticipation(partsFd, 378, 31, "02/03/1994");
	insertParticipation(partsFd, 247, 24, "15/09/1994");
	insertParticipation(partsFd, 288, 27, "22/03/1999");
	insertParticipation(partsFd, 361, 29, "20/01/1998");
	insertParticipation(partsFd, 109, 13, "24/08/1987");
	insertParticipation(partsFd, 132, 15, "26/02/1991");
	insertParticipation(partsFd, 366, 29, "09/06/1997");
	insertParticipation(partsFd, 201, 21, "03/10/1996");
	insertParticipation(partsFd, 132, 15, "26/05/1994");
	insertParticipation(partsFd, 252, 24, "28/10/1987");
	insertParticipation(partsFd, 95, 12, "28/03/1993");
	insertParticipation(partsFd, 246, 24, "16/03/1998");
	insertParticipation(partsFd, 258, 25, "22/10/1988");
	insertParticipation(partsFd, 155, 16, "26/09/1998");
	insertParticipation(partsFd, 374, 31, "05/08/2002");
	insertParticipation(partsFd, 288, 27, "24/05/2003");
	insertParticipation(partsFd, 371, 30, "26/01/1991");
	insertParticipation(partsFd, 21, 4, "17/02/1986");
	insertParticipation(partsFd, 374, 31, "03/03/1997");
	insertParticipation(partsFd, 72, 9, "11/06/1994");
	insertParticipation(partsFd, 216, 23, "14/12/1986");
	insertParticipation(partsFd, 28, 5, "21/12/1990");
	insertParticipation(partsFd, 32, 6, "01/09/1988");
	insertParticipation(partsFd, 37, 7, "20/09/1996");
	insertParticipation(partsFd, 62, 9, "25/12/1993");
	insertParticipation(partsFd, 257, 25, "21/08/1991");
	insertParticipation(partsFd, 108, 13, "11/03/1988");
	insertParticipation(partsFd, 123, 13, "06/03/1994");
	insertParticipation(partsFd, 155, 16, "26/08/2005");
	insertParticipation(partsFd, 365, 29, "10/08/1989");
	insertParticipation(partsFd, 145, 16, "15/01/1998");
	insertParticipation(partsFd, 239, 24, "02/09/1987");
	insertParticipation(partsFd, 5, 1, "01/12/1997");
	insertParticipation(partsFd, 133, 16, "23/06/1990");
	insertParticipation(partsFd, 194, 21, "19/01/1992");
	insertParticipation(partsFd, 235, 24, "07/03/1987");
	insertParticipation(partsFd, 43, 8, "07/11/2002");
	insertParticipation(partsFd, 85, 10, "11/12/1991");
	insertParticipation(partsFd, 219, 23, "03/09/2004");
	insertParticipation(partsFd, 381, 31, "05/06/2003");
	insertParticipation(partsFd, 385, 31, "26/12/2002");
	insertParticipation(partsFd, 169, 18, "08/07/1988");
	insertParticipation(partsFd, 211, 21, "21/04/1988");
	insertParticipation(partsFd, 381, 31, "21/05/1990");
	insertParticipation(partsFd, 21, 4, "03/01/1989");
	insertParticipation(partsFd, 51, 8, "03/07/2003");
	insertParticipation(partsFd, 32, 6, "28/12/1996");
	insertParticipation(partsFd, 252, 24, "09/03/1987");
	insertParticipation(partsFd, 113, 13, "03/01/2003");
	insertParticipation(partsFd, 127, 14, "20/11/1989");
	insertParticipation(partsFd, 216, 23, "18/04/1996");
	insertParticipation(partsFd, 361, 29, "22/05/2000");
	insertParticipation(partsFd, 1, 0, "22/12/2001");
	insertParticipation(partsFd, 90, 12, "08/02/1986");
	insertParticipation(partsFd, 230, 24, "21/02/2005");
	insertParticipation(partsFd, 108, 13, "09/01/1997");
	insertParticipation(partsFd, 288, 27, "18/07/2005");
	insertParticipation(partsFd, 127, 14, "03/02/1991");
	insertParticipation(partsFd, 227, 24, "10/08/2002");
	insertParticipation(partsFd, 235, 24, "04/03/2005");
	insertParticipation(partsFd, 75, 9, "24/08/2002");
	insertParticipation(partsFd, 141, 16, "16/07/1998");
	insertParticipation(partsFd, 32, 6, "23/06/1996");
	insertParticipation(partsFd, 71, 9, "04/10/1991");
	insertParticipation(partsFd, 136, 16, "15/03/1992");
	insertParticipation(partsFd, 259, 25, "20/12/1993");
	insertParticipation(partsFd, 186, 20, "10/08/1989");
	insertParticipation(partsFd, 83, 10, "13/12/1992");
	insertParticipation(partsFd, 145, 16, "27/06/2005");
	insertParticipation(partsFd, 178, 19, "20/06/1987");
	insertParticipation(partsFd, 180, 19, "26/03/2002");
	insertParticipation(partsFd, 280, 27, "01/03/2004");
	insertParticipation(partsFd, 361, 29, "06/06/1998");
	insertParticipation(partsFd, 243, 24, "09/01/1994");
	insertParticipation(partsFd, 42, 8, "03/12/2004");
	insertParticipation(partsFd, 173, 19, "05/06/1989");
	insertParticipation(partsFd, 280, 27, "12/03/1988");
	insertParticipation(partsFd, 26, 4, "10/04/1995");
	insertParticipation(partsFd, 127, 14, "27/07/2000");
	insertParticipation(partsFd, 162, 17, "19/03/1996");
	insertParticipation(partsFd, 19, 3, "02/03/1994");
	insertParticipation(partsFd, 177, 19, "08/05/1988");
	insertParticipation(partsFd, 180, 19, "03/11/2004");
	insertParticipation(partsFd, 103, 13, "02/08/1994");
	insertParticipation(partsFd, 79, 9, "16/04/1996");
	insertParticipation(partsFd, 239, 24, "20/07/2003");
	insertParticipation(partsFd, 201, 21, "19/12/2005");
	insertParticipation(partsFd, 366, 29, "18/12/1994");
	insertParticipation(partsFd, 122, 13, "01/09/2003");
	insertParticipation(partsFd, 164, 17, "04/05/2005");
	insertParticipation(partsFd, 381, 31, "02/08/1999");
	insertParticipation(partsFd, 230, 24, "19/04/1992");
	insertParticipation(partsFd, 265, 26, "12/11/1990");
	insertParticipation(partsFd, 43, 8, "04/06/1989");
	insertParticipation(partsFd, 191, 21, "17/02/1997");
	insertParticipation(partsFd, 103, 13, "07/06/2000");
	insertParticipation(partsFd, 118, 13, "06/01/1991");
	insertParticipation(partsFd, 135, 16, "03/11/2001");
	insertParticipation(partsFd, 201, 21, "15/02/1996");
	insertParticipation(partsFd, 168, 18, "26/11/1996");
	insertParticipation(partsFd, 361, 29, "26/02/1991");
	insertParticipation(partsFd, 67, 9, "10/02/1993");
	insertParticipation(partsFd, 132, 15, "11/01/2003");
	insertParticipation(partsFd, 162, 17, "11/07/1989");
	insertParticipation(partsFd, 239, 24, "01/04/1988");
	insertParticipation(partsFd, 146, 16, "26/12/1997");
	insertParticipation(partsFd, 61, 9, "17/11/1997");
	insertParticipation(partsFd, 165, 18, "12/02/2003");
	insertParticipation(partsFd, 136, 16, "07/05/2000");
	insertParticipation(partsFd, 235, 24, "27/04/1997");
	insertParticipation(partsFd, 293, 27, "27/05/1991");
	insertParticipation(partsFd, 4, 1, "03/12/1996");
	insertParticipation(partsFd, 27, 4, "21/03/1994");
	insertParticipation(partsFd, 10, 2, "26/09/1997");
	insertParticipation(partsFd, 118, 13, "09/08/1994");
	insertParticipation(partsFd, 173, 19, "27/03/1986");
	insertParticipation(partsFd, 288, 27, "10/11/1996");
	insertParticipation(partsFd, 361, 29, "09/03/1990");
	insertParticipation(partsFd, 154, 16, "14/07/1995");
	insertParticipation(partsFd, 211, 21, "03/08/2000");
	insertParticipation(partsFd, 150, 16, "14/08/2004");
	insertParticipation(partsFd, 79, 9, "08/05/1999");
	insertParticipation(partsFd, 271, 26, "18/01/1987");
	insertParticipation(partsFd, 51, 8, "20/12/1991");
	insertParticipation(partsFd, 9, 2, "12/05/1993");
	insertParticipation(partsFd, 95, 12, "08/03/1988");
	insertParticipation(partsFd, 266, 26, "20/03/1996");
	insertParticipation(partsFd, 381, 31, "22/08/1988");
	insertParticipation(partsFd, 113, 13, "03/07/1999");
	insertParticipation(partsFd, 149, 16, "19/08/1986");
	insertParticipation(partsFd, 246, 24, "13/06/1990");
	insertParticipation(partsFd, 378, 31, "17/04/1991");
	insertParticipation(partsFd, 123, 13, "16/09/1996");
	insertParticipation(partsFd, 90, 12, "09/10/1991");
	insertParticipation(partsFd, 131, 15, "04/06/2000");
	insertParticipation(partsFd, 382, 31, "17/02/1993");
	insertParticipation(partsFd, 80, 9, "08/06/1993");
	insertParticipation(partsFd, 155, 16, "24/02/2000");
	insertParticipation(partsFd, 51, 8, "18/12/1986");
	insertParticipation(partsFd, 235, 24, "20/07/1992");
	insertParticipation(partsFd, 260, 25, "02/11/1996");
	insertParticipation(partsFd, 382, 31, "22/06/1987");
	insertParticipation(partsFd, 4, 1, "16/09/2000");
	insertParticipation(partsFd, 206, 21, "07/03/2001");
	insertParticipation(partsFd, 62, 9, "04/05/1993");
	insertParticipation(partsFd, 201, 21, "06/01/1999");
	insertParticipation(partsFd, 239, 24, "19/06/2001");
	insertParticipation(partsFd, 254, 24, "16/05/1987");
	insertParticipation(partsFd, 173, 19, "17/07/1988");
	insertParticipation(partsFd, 259, 25, "28/07/2004");
	insertParticipation(partsFd, 84, 10, "09/07/2002");
	insertParticipation(partsFd, 141, 16, "01/08/2003");
	insertParticipation(partsFd, 43, 8, "01/05/2000");
	insertParticipation(partsFd, 37, 7, "04/12/1998");
	insertParticipation(partsFd, 79, 9, "18/02/1996");
	insertParticipation(partsFd, 201, 21, "02/01/2005");
	insertParticipation(partsFd, 220, 24, "09/01/2005");
	insertParticipation(partsFd, 276, 27, "26/10/1997");
	insertParticipation(partsFd, 104, 13, "03/10/1987");
	insertParticipation(partsFd, 276, 27, "05/09/1994");
	insertParticipation(partsFd, 370, 30, "18/09/1987");
	insertParticipation(partsFd, 255, 24, "11/11/1994");
	insertParticipation(partsFd, 132, 15, "09/07/1994");
	insertParticipation(partsFd, 271, 26, "01/07/1997");
	insertParticipation(partsFd, 67, 9, "22/07/1998");
	insertParticipation(partsFd, 71, 9, "21/03/1995");
	insertParticipation(partsFd, 123, 13, "17/08/2003");
	insertParticipation(partsFd, 127, 14, "17/08/1986");
	insertParticipation(partsFd, 136, 16, "13/11/2001");
	insertParticipation(partsFd, 361, 29, "13/04/1989");
	insertParticipation(partsFd, 0, 0, "18/05/2004");
	insertParticipation(partsFd, 67, 9, "03/12/1988");
	insertParticipation(partsFd, 141, 16, "16/05/1991");
	insertParticipation(partsFd, 293, 27, "01/09/1997");
	insertParticipation(partsFd, 76, 9, "08/01/2004");
	insertParticipation(partsFd, 0, 0, "16/11/1986");
	insertParticipation(partsFd, 230, 24, "26/02/1995");
	insertParticipation(partsFd, 107, 13, "05/08/1997");
	insertParticipation(partsFd, 177, 19, "20/07/1989");
	insertParticipation(partsFd, 49, 8, "11/09/1998");
	insertParticipation(partsFd, 97, 13, "19/04/1989");
	insertParticipation(partsFd, 135, 16, "12/02/1993");
	insertParticipation(partsFd, 290, 27, "27/11/1996");
	insertParticipation(partsFd, 227, 24, "16/11/1990");
	insertParticipation(partsFd, 260, 25, "04/10/1992");
	insertParticipation(partsFd, 146, 16, "05/03/1994");
	insertParticipation(partsFd, 365, 29, "25/09/1987");
	insertParticipation(partsFd, 1, 0, "06/02/1993");
	insertParticipation(partsFd, 271, 26, "10/02/1992");
	insertParticipation(partsFd, 155, 16, "13/05/2002");
	insertParticipation(partsFd, 162, 17, "16/05/2004");
	insertParticipation(partsFd, 159, 17, "27/08/2003");
	insertParticipation(partsFd, 370, 30, "23/06/2000");
	insertParticipation(partsFd, 201, 21, "18/01/1999");
	insertParticipation(partsFd, 271, 26, "14/11/2004");
	insertParticipation(partsFd, 108, 13, "05/04/1997");
	insertParticipation(partsFd, 15, 2, "10/03/1991");
	insertParticipation(partsFd, 49, 8, "25/03/1994");
	insertParticipation(partsFd, 84, 10, "08/02/1996");
	insertParticipation(partsFd, 235, 24, "01/01/1987");
	insertParticipation(partsFd, 53, 8, "12/08/1992");
	insertParticipation(partsFd, 62, 9, "04/02/2004");
	insertParticipation(partsFd, 127, 14, "03/01/2002");
	insertParticipation(partsFd, 235, 24, "16/06/2001");
	insertParticipation(partsFd, 374, 31, "07/06/1995");
	insertParticipation(partsFd, 159, 17, "04/01/1996");
	insertParticipation(partsFd, 239, 24, "13/04/1994");
	insertParticipation(partsFd, 53, 8, "27/10/1997");
	insertParticipation(partsFd, 272, 26, "08/10/1986");
	insertParticipation(partsFd, 21, 4, "09/09/2001");
	insertParticipation(partsFd, 103, 13, "04/12/1995");
	insertParticipation(partsFd, 4, 1, "10/03/1996");
	insertParticipation(partsFd, 155, 16, "14/08/2002");
	insertParticipation(partsFd, 108, 13, "28/02/2002");
	insertParticipation(partsFd, 211, 21, "21/10/1994");
	insertParticipation(partsFd, 225, 24, "16/09/1996");
	insertParticipation(partsFd, 202, 21, "17/12/1986");
	insertParticipation(partsFd, 118, 13, "04/12/1997");
	insertParticipation(partsFd, 385, 31, "16/09/2002");
	insertParticipation(partsFd, 141, 16, "07/03/1990");
	insertParticipation(partsFd, 220, 24, "21/02/1999");
	insertParticipation(partsFd, 366, 29, "02/11/1992");
	insertParticipation(partsFd, 170, 18, "23/05/1992");
	insertParticipation(partsFd, 22, 4, "01/01/2004");
	insertParticipation(partsFd, 103, 13, "11/11/2005");
	insertParticipation(partsFd, 247, 24, "26/08/1987");
	insertParticipation(partsFd, 90, 12, "15/03/1988");
	insertParticipation(partsFd, 226, 24, "15/04/1999");
	insertParticipation(partsFd, 185, 20, "04/07/1995");
	insertParticipation(partsFd, 248, 24, "21/11/2002");
	insertParticipation(partsFd, 385, 31, "05/11/1987");
	insertParticipation(partsFd, 155, 16, "08/08/2001");
	insertParticipation(partsFd, 195, 21, "24/12/1994");
	insertParticipation(partsFd, 227, 24, "12/09/1993");
	insertParticipation(partsFd, 230, 24, "14/09/1986");
	insertParticipation(partsFd, 42, 8, "20/01/1989");
	insertParticipation(partsFd, 67, 9, "02/05/1999");
	insertParticipation(partsFd, 80, 9, "18/11/1997");
	insertParticipation(partsFd, 122, 13, "22/10/1991");
	insertParticipation(partsFd, 260, 25, "02/11/1999");
	insertParticipation(partsFd, 53, 8, "11/06/2003");
	insertParticipation(partsFd, 271, 26, "13/04/1993");
	insertParticipation(partsFd, 361, 29, "28/05/1994");
	insertParticipation(partsFd, 374, 31, "12/05/1986");
	insertParticipation(partsFd, 177, 19, "08/06/1996");
	insertParticipation(partsFd, 186, 20, "19/01/1988");
	insertParticipation(partsFd, 360, 29, "14/02/1993");
	insertParticipation(partsFd, 37, 7, "06/05/1986");
	insertParticipation(partsFd, 109, 13, "11/03/1987");
	insertParticipation(partsFd, 371, 30, "10/03/1990");
	insertParticipation(partsFd, 150, 16, "10/12/1989");
	insertParticipation(partsFd, 381, 31, "26/07/1986");
	insertParticipation(partsFd, 270, 26, "08/11/1988");
	insertParticipation(partsFd, 180, 19, "24/10/1991");
	insertParticipation(partsFd, 16, 3, "02/09/1989");
	insertParticipation(partsFd, 28, 5, "26/10/1990");
	insertParticipation(partsFd, 16, 3, "17/03/1988");
	insertParticipation(partsFd, 181, 19, "27/10/2005");
	insertParticipation(partsFd, 118, 13, "27/06/1993");
	insertParticipation(partsFd, 211, 21, "06/11/1992");
	insertParticipation(partsFd, 5, 1, "14/07/2003");
	insertParticipation(partsFd, 260, 25, "10/07/1988");
	insertParticipation(partsFd, 378, 31, "09/11/2004");
	insertParticipation(partsFd, 219, 23, "01/06/1997");
	insertParticipation(partsFd, 239, 24, "19/02/1998");
	insertParticipation(partsFd, 378, 31, "18/03/1998");
	insertParticipation(partsFd, 185, 20, "28/08/1995");
	insertParticipation(partsFd, 170, 18, "10/04/1994");
	insertParticipation(partsFd, 254, 24, "13/03/1997");
	insertParticipation(partsFd, 370, 30, "13/11/1992");
	insertParticipation(partsFd, 90, 12, "08/10/1990");
	insertParticipation(partsFd, 141, 16, "04/02/1992");
	insertParticipation(partsFd, 194, 21, "05/06/1992");
	insertParticipation(partsFd, 230, 24, "18/04/2001");
	insertParticipation(partsFd, 90, 12, "23/07/2004");
	insertParticipation(partsFd, 138, 16, "24/10/2001");
	insertParticipation(partsFd, 145, 16, "10/10/1991");
	insertParticipation(partsFd, 124, 13, "20/04/1995");
	insertParticipation(partsFd, 191, 21, "18/03/2001");
	insertParticipation(partsFd, 243, 24, "16/01/1991");
	insertParticipation(partsFd, 248, 24, "06/02/2005");
	insertParticipation(partsFd, 276, 27, "15/09/1993");
	insertParticipation(partsFd, 145, 16, "22/10/1994");
	insertParticipation(partsFd, 385, 31, "02/12/2003");
	insertParticipation(partsFd, 150, 16, "08/01/1992");
	insertParticipation(partsFd, 155, 16, "09/05/1990");
	insertParticipation(partsFd, 186, 20, "18/12/2001");
	insertParticipation(partsFd, 370, 30, "25/12/1993");
	insertParticipation(partsFd, 382, 31, "09/10/1998");
	insertParticipation(partsFd, 220, 24, "19/02/2001");
	insertParticipation(partsFd, 67, 9, "09/03/1994");
	insertParticipation(partsFd, 102, 13, "17/03/2003");
	insertParticipation(partsFd, 173, 19, "14/03/1989");
	insertParticipation(partsFd, 201, 21, "28/06/1997");
	insertParticipation(partsFd, 265, 26, "03/07/1986");
	insertParticipation(partsFd, 17, 3, "01/09/1989");
	insertParticipation(partsFd, 211, 21, "10/01/2001");
	insertParticipation(partsFd, 132, 15, "05/06/1998");
	insertParticipation(partsFd, 142, 16, "05/09/1990");
	insertParticipation(partsFd, 281, 27, "25/11/1992");
	insertParticipation(partsFd, 79, 9, "04/02/1996");
	insertParticipation(partsFd, 149, 16, "23/04/1990");
	insertParticipation(partsFd, 96, 12, "12/12/2004");
	insertParticipation(partsFd, 194, 21, "15/05/1992");
	insertParticipation(partsFd, 261, 25, "18/05/1994");
	insertParticipation(partsFd, 84, 10, "28/10/1992");
	insertParticipation(partsFd, 27, 4, "01/06/2004");
	insertParticipation(partsFd, 80, 9, "18/10/1989");
	insertParticipation(partsFd, 164, 17, "11/04/2002");
	insertParticipation(partsFd, 162, 17, "12/05/1993");
	insertParticipation(partsFd, 220, 24, "10/11/1987");
	insertParticipation(partsFd, 190, 20, "21/07/1991");
	insertParticipation(partsFd, 259, 25, "24/09/2000");
	insertParticipation(partsFd, 32, 6, "10/01/2002");
	insertParticipation(partsFd, 37, 7, "21/04/1988");
	insertParticipation(partsFd, 42, 8, "19/04/1994");
	insertParticipation(partsFd, 76, 9, "12/07/1995");
	insertParticipation(partsFd, 185, 20, "28/10/1992");
	insertParticipation(partsFd, 28, 5, "01/05/1993");
	insertParticipation(partsFd, 113, 13, "08/05/2001");
	insertParticipation(partsFd, 173, 19, "28/08/1995");
	insertParticipation(partsFd, 76, 9, "27/12/2001");
	insertParticipation(partsFd, 123, 13, "27/06/1986");
	insertParticipation(partsFd, 127, 14, "18/12/1990");
	insertParticipation(partsFd, 96, 12, "20/10/1988");
	insertParticipation(partsFd, 280, 27, "26/01/1994");
	insertParticipation(partsFd, 186, 20, "26/07/1995");
	insertParticipation(partsFd, 127, 14, "27/09/1989");
	insertParticipation(partsFd, 90, 12, "05/10/1993");
	insertParticipation(partsFd, 150, 16, "24/01/2004");
	insertParticipation(partsFd, 219, 23, "17/12/2005");
	insertParticipation(partsFd, 366, 29, "18/06/1986");
	insertParticipation(partsFd, 9, 2, "12/10/2002");
	insertParticipation(partsFd, 239, 24, "07/05/2002");
	insertParticipation(partsFd, 42, 8, "28/11/1990");
	insertParticipation(partsFd, 113, 13, "10/06/1989");
	insertParticipation(partsFd, 191, 21, "23/12/1994");
	insertParticipation(partsFd, 271, 26, "20/01/1997");
	insertParticipation(partsFd, 226, 24, "17/11/1995");
	insertParticipation(partsFd, 1, 0, "24/01/1988");
	insertParticipation(partsFd, 118, 13, "06/11/1997");
	insertParticipation(partsFd, 51, 8, "24/01/1986");
	insertParticipation(partsFd, 123, 13, "07/02/1994");
	insertParticipation(partsFd, 10, 2, "06/09/1988");
	insertParticipation(partsFd, 124, 13, "02/06/1986");
	insertParticipation(partsFd, 37, 7, "09/11/1986");
	insertParticipation(partsFd, 138, 16, "14/04/1993");
	insertParticipation(partsFd, 177, 19, "17/09/1987");
	insertParticipation(partsFd, 50, 8, "17/08/1997");
	insertParticipation(partsFd, 226, 24, "02/08/1986");
	insertParticipation(partsFd, 247, 24, "22/06/1994");
	insertParticipation(partsFd, 365, 29, "07/06/1997");
	insertParticipation(partsFd, 235, 24, "13/11/1997");
	insertParticipation(partsFd, 90, 12, "05/07/2000");
	insertParticipation(partsFd, 155, 16, "12/07/1999");
	insertParticipation(partsFd, 361, 29, "25/04/2003");
	insertParticipation(partsFd, 108, 13, "07/11/1994");
	insertParticipation(partsFd, 288, 27, "18/03/1986");
	insertParticipation(partsFd, 168, 18, "18/09/1993");
	insertParticipation(partsFd, 266, 26, "14/05/1995");
	insertParticipation(partsFd, 281, 27, "09/11/2002");
	insertParticipation(partsFd, 28, 5, "13/04/2005");
	insertParticipation(partsFd, 32, 6, "26/04/2001");
	insertParticipation(partsFd, 378, 31, "20/03/2001");
	insertParticipation(partsFd, 181, 19, "09/12/2001");
	insertParticipation(partsFd, 132, 15, "06/08/2004");
	insertParticipation(partsFd, 117, 13, "05/09/1993");
	insertParticipation(partsFd, 230, 24, "12/08/1990");
	insertParticipation(partsFd, 293, 27, "09/06/2004");
	insertParticipation(partsFd, 109, 13, "21/04/2004");
	insertParticipation(partsFd, 370, 30, "15/02/1995");
	insertParticipation(partsFd, 20, 4, "11/12/2003");
	insertParticipation(partsFd, 367, 29, "16/03/1992");
	insertParticipation(partsFd, 289, 27, "22/04/1994");
	insertParticipation(partsFd, 280, 27, "04/07/1991");
	insertParticipation(partsFd, 374, 31, "28/05/2000");
	insertParticipation(partsFd, 80, 9, "19/11/1987");
	insertParticipation(partsFd, 266, 26, "22/03/1988");
	insertParticipation(partsFd, 72, 9, "17/02/1999");
	insertParticipation(partsFd, 378, 31, "09/02/1996");
	insertParticipation(partsFd, 190, 20, "23/12/1996");
	insertParticipation(partsFd, 194, 21, "14/10/2000");
	insertParticipation(partsFd, 243, 24, "17/04/2004");
	insertParticipation(partsFd, 113, 13, "20/06/1989");
	insertParticipation(partsFd, 4, 1, "04/01/2003");
	insertParticipation(partsFd, 239, 24, "28/03/1997");
	insertParticipation(partsFd, 173, 19, "12/12/1997");
	insertParticipation(partsFd, 239, 24, "14/04/1996");
	insertParticipation(partsFd, 54, 8, "01/04/1993");
	insertParticipation(partsFd, 266, 26, "16/06/1992");
	insertParticipation(partsFd, 108, 13, "09/03/1998");
	insertParticipation(partsFd, 169, 18, "13/04/2003");
	insertParticipation(partsFd, 195, 21, "13/10/1989");
	insertParticipation(partsFd, 173, 19, "19/07/1988");
	insertParticipation(partsFd, 181, 19, "07/08/1988");
	insertParticipation(partsFd, 247, 24, "28/09/1998");
	insertParticipation(partsFd, 293, 27, "21/06/1990");
	insertParticipation(partsFd, 141, 16, "22/01/1996");
	insertParticipation(partsFd, 293, 27, "17/11/1997");
	insertParticipation(partsFd, 75, 9, "16/11/2005");
	insertParticipation(partsFd, 96, 12, "10/02/2002");
	insertParticipation(partsFd, 142, 16, "06/08/1988");
	insertParticipation(partsFd, 127, 14, "20/01/2002");
	insertParticipation(partsFd, 133, 16, "07/05/1990");
	insertParticipation(partsFd, 61, 9, "07/07/2005");
	insertParticipation(partsFd, 149, 16, "10/09/1998");
	insertParticipation(partsFd, 207, 21, "16/10/2002");


	/*   PARTICIPATIONS */
	if (BF_CloseFile(partsFd) != BFE_OK)
		BF_PrintError("Error in BF_CloseFile called on PARTICIPATIONS.");

	return 0;
}


void insertAthlete(int athletesFd, int athleteId, char *athleteSurname, char *athleteName)
{
	int recId;
	char *athleteRec;

	athleteRec = (char*) malloc(HF_MAIN_ATHLETE_REC_SIZE);
	if (athleteRec == NULL)
	{
		printf("Athlete Record malloc failed\n");
		return;
	}

	printf("Inserting Athlete record (%d, \"%s\", \"%s\")\n", athleteId, athleteName, athleteSurname);

	memcpy((void *) athleteRec, (void *) &athleteId, sizeof(int));
	athleteRec += sizeof(int);
	memcpy((void *) athleteRec, (void *) athleteSurname, HF_MAIN_NAME_SIZE);
	athleteRec += HF_MAIN_NAME_SIZE;
	memcpy((void *) athleteRec, (void *) athleteName, HF_MAIN_NAME_SIZE);
	athleteRec += HF_MAIN_NAME_SIZE;

	athleteRec -= HF_MAIN_ATHLETE_REC_SIZE;

	recId = HF_InsertRec(athletesFd, athleteRec, HF_MAIN_ATHLETE_REC_SIZE);

	if (recId >= 0)
	{
		printf("OK!\n");
	}
	else
	{
		HF_PrintError("Record not inserted.\n");
	}

	free(athleteRec);
}



void insertEvent(int eventsFd, int eventId, char *eventName)
{
	int recId;
	char * eventRec;

	eventRec = (char *) malloc(HF_MAIN_EVENT_REC_SIZE);
	if (eventRec == NULL)
	{
		printf("Event Record malloc failed\n");
		return;
	}

	printf("Inserting Event record (%d, \"%s\")\n", eventId, eventName);

	memcpy((void *) eventRec, (void *) &eventId, sizeof(int));
	eventRec += sizeof(int);

	memcpy((void *) eventRec, (void *) eventName, HF_MAIN_EVENT_NAME_SIZE);
	eventRec += HF_MAIN_EVENT_NAME_SIZE;

	eventRec -= HF_MAIN_EVENT_REC_SIZE;

	recId = HF_InsertRec(eventsFd, eventRec, HF_MAIN_EVENT_REC_SIZE);
	if (recId >= 0)
	{
		printf("OK!\n");
	}
	else
	{
		HF_PrintError("Record not inserted.\n");
	}

	free(eventRec);
}


void insertParticipation(int partsFd, int athleteId, int eventId, char *partDate)
{
	int recId;
	char *partRec;

	partRec = (char *) malloc(HF_MAIN_PARTICIPATION_REC_SIZE);
	if (partRec == NULL)
	{
		printf("Participation Record malloc failed\n");
		return;
	}

	printf("Inserting Participation record (%d, %d, \"%s\")\n", athleteId, eventId, partDate);

	memcpy((void *) partRec, (void *) &athleteId, sizeof(int));
	partRec += sizeof(int);

	memcpy((void *) partRec, (void *) &eventId, sizeof(int));
	partRec += sizeof(int);

	memcpy((void *) partRec, (void *) partDate, HF_MAIN_DATE_SIZE);
	partRec += HF_MAIN_DATE_SIZE;

	partRec -= HF_MAIN_PARTICIPATION_REC_SIZE;

	recId = HF_InsertRec(partsFd, partRec, HF_MAIN_PARTICIPATION_REC_SIZE);
	
	if (recId >= 0 )
	{
		printf("OK!\n");
	}
	else
	{
		HF_PrintError("Record not inserted.\n");
	}

	free(partRec);
}

