#ifndef BF_LIB_H
#define BF_LIB_H


#define BF_BLOCK_SIZE 1024

#define BFE_OK 0                    /* OK */
#define BFE_NOMEM -1                /*   */
#define BFE_NOBUF -2                /*     */
#define BFE_BLOCKFIXED -3           /*   ``''   */
#define BFE_BLOCKNOTINBUF -4        /*   ``''     */
#define BFE_BLOCKINBUF -5           /*     */
#define BFE_OS -6                   /*     */
#define BFE_INCOMPLETEREAD -7       /*    */
#define BFE_INCOMPLETEWRITE -8      /*     */
#define BFE_INCOMPLETEHDRREAD -9    /*   - */
#define BFE_INCOMPLETEHDRWRITE -10  /*    - */
#define BFE_INVALIDBLOCK -11        /*      */
#define BFE_FILEOPEN -12            /*    */
#define BFE_FTABFULL -13            /*     */
#define BFE_FD -14                  /*      */
#define BFE_EOF -15                 /*   */
#define BFE_BLOCKFREE -16           /*    */
#define BFE_BLOCKUNFIXED -17        /*   ``'' */
#define BFE_FILE_EXISTS -18         /*    */
#define BFE_FILE_NOT_EXISTS -19     /*    */
#define BFE_FOPEN_ERROR  -20        /*      */
#define BFE_FILE_CLOSED -21         /*    */
#define BFE_INVALID_FILEDESC -22    /*     */
#define BFE_MALLOC_ERROR -23        /*  malloc */
#define BFE_FWRITE_ERROR -24        /*  fwrite */
#define BFE_FCLOSE_ERROR -25        /*  fclose */
#define BFE_NULL_POINTER -26        /*   */
#define BFE_FSEEK_ERROR -27         /*  fseek */
#define BFE_FREAD_ERROR -28         /*  fread */
#define BFE_FTELL_ERROR -29         /*  ftell */
#define BFE_REALLOC_ERROR -30       /*  realloc */
#define BFE_TOO_BIG_FILENAME -31    /*     */

/*     */
int BF_errno;

/*    Block */
void BF_Init( void );
int BF_CreateFile( char *filename );
int BF_DestroyFile( char *filename );
int BF_OpenFile( char *filename );
int BF_CloseFile( int fileDesc );
int BF_GetFirstBlock( int fileDesc, int *blockNum, char **blockBuf );
int BF_GetNextBlock( int fileDesc, int *blockNum, char **blockBuf );
int BF_GetThisBlock( int fileDesc, int blockNum, char **blockBuf );
int BF_AllocBlock( int fileDesc, int *blockNum, char **blockBuf );
int BF_DisposeBlock( int fileDesc, int *blockNum );
int BF_UnpinBlock( int fileDesc, int blockNum, int dirty );
void BF_PrintError( char *errString );

#endif
