/* Binary file to C header file converter */

#include <stdio.h>
#include <stdlib.h>

int main (int argc, char *argv[])
{
    FILE *in, *out;
    int i = 0, size = 0, total = 0;
    unsigned char data[16];

    if (argc < 3) {
        printf("bin2hex <bin file> <h file>\n");
        return (1);
    }

    if ((in = fopen(argv[1], "rb")) == NULL) {
        printf("Unable to open %s\n", argv[1]);
        return (1);
    }

    if ((out = fopen(argv[2], "w")) == NULL) {
        printf("Unable to open %s\n", argv[2]);
        fclose(in);
        return (1);
    }

    fprintf(out, "/*\n"
            " *------------------------------------------------------------------\n"
            " * Do not edit this file which generated from \"%s\"\n"
            " *------------------------------------------------------------------\n"
            " */\n\n", argv[1]);

    fprintf(out, "const unsigned char sample_array[] = {");
    while ((size = fread(&data[0], 1, 16, in)) != 0) {
        fprintf(out, "\n");
        total += size;
        for (i = 0; i < size; ++i) {
            fprintf(out, "0x%02x,", data[i]);
        }
    }
    fprintf(out, "\n};\n");
    fprintf(out, "\nconst unsigned int sample_size = %d;\n", total);

    fclose(in);
    fclose(out);
    return 0;
}
