/*
Copyright (c) 2011, Christopher Utz
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of SimpleHttp nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL CHRISTOPHER UTZ BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Author: Christopher Utz <utz.m.christopher@gmail.com>
*/

#ifndef SHTTP_HTTP_SERVER_H_
#define SHTTP_HTTP_SERVER_H_

#include <shttp_server_socket.h>

#include <ev.h>

#include <shttp_error.h>

typedef struct shttp_http_server_config_t {
    const char *ip_addr;
    int port;
    int backlog;
} shttp_http_server_config_t;

typedef struct shttp_http_server_t {
    shttp_server_socket_t server_socket;
    ev_io server_socket_readable;
} shttp_http_server_t;

shttp_error_t       shttp_http_server_init          (shttp_http_server_t *server,
                                                     shttp_http_server_config_t *config);

void                shttp_http_server_cleanup       (shttp_http_server_t *server);

shttp_error_t       shttp_http_server_start         (shttp_http_server_t *server,
                                                     struct ev_loop *loop);

shttp_error_t       shttp_http_server_run           (shttp_http_server_config_t *config);

#endif // SHTTP_HTTP_SERVER_H_
