/* See LICENSE file for copyright and license details. */
#include <string.h>
#include <X11/Xlib.h>
#include "dc.h"

#define MIN(a, b)  ((a) < (b) ? (a) : (b))
#define MAX(a, b)  ((a) > (b) ? (a) : (b))

void
dc_drawtext(DC *dc, const char *text, unsigned long col[ColLast]) {
	char buf[256];
	size_t n, mn;

	/* shorten text if necessary */
	n = strlen(text);
	for(mn = MIN(n, sizeof buf); dc_textnw(dc, text, mn) > dc->w - dc->font.height/2; mn--)
		if(mn == 0)
			return;
	memcpy(buf, text, mn);
	if(mn < n)
		for(n = MAX(mn-3, 0); n < mn; buf[n++] = '.');

	dc_drawrect(dc, 0, 0, dc->w, dc->h, True, BG(dc, col));
	dc_drawtextn(dc, buf, mn, col);
}
