/* blp-document.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_DOCUMENT_H
#define BLP_DOCUMENT_H

#include <gom/gom.h>

#include "blp-item.h"

G_BEGIN_DECLS

#define BLP_TYPE_DOCUMENT            (blp_document_get_type())
#define BLP_DOCUMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_DOCUMENT, BlpDocument))
#define BLP_DOCUMENT_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_DOCUMENT, BlpDocument const))
#define BLP_DOCUMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_DOCUMENT, BlpDocumentClass))
#define BLP_IS_DOCUMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_DOCUMENT))
#define BLP_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_DOCUMENT))
#define BLP_DOCUMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_DOCUMENT, BlpDocumentClass))

typedef struct _BlpDocument        BlpDocument;
typedef struct _BlpDocumentClass   BlpDocumentClass;
typedef struct _BlpDocumentPrivate BlpDocumentPrivate;

struct _BlpDocument
{
   GomResource parent;

   /*< private >*/
   BlpDocumentPrivate *priv;
};

struct _BlpDocumentClass
{
   GomResourceClass parent_class;
};

BlpItem     *blp_document_get_root (BlpDocument *document);
GType        blp_document_get_type (void) G_GNUC_CONST;
BlpDocument *blp_document_new      (void);

G_END_DECLS

#endif /* BLP_DOCUMENT_H */
