/* blp-item-view.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_ITEM_VIEW_H
#define BLP_ITEM_VIEW_H

#include <clutter/clutter.h>

G_BEGIN_DECLS

#define BLP_TYPE_ITEM_VIEW            (blp_item_view_get_type())
#define BLP_ITEM_VIEW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM_VIEW, BlpItemView))
#define BLP_ITEM_VIEW_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM_VIEW, BlpItemView const))
#define BLP_ITEM_VIEW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_ITEM_VIEW, BlpItemViewClass))
#define BLP_IS_ITEM_VIEW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_ITEM_VIEW))
#define BLP_IS_ITEM_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_ITEM_VIEW))
#define BLP_ITEM_VIEW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_ITEM_VIEW, BlpItemViewClass))

typedef struct _BlpItemView        BlpItemView;
typedef struct _BlpItemViewClass   BlpItemViewClass;
typedef struct _BlpItemViewPrivate BlpItemViewPrivate;

struct _BlpItemView
{
   ClutterActor parent;

   /*< private >*/
   BlpItemViewPrivate *priv;
};

struct _BlpItemViewClass
{
   ClutterActorClass parent_class;
};

GType    blp_item_view_get_type (void) G_GNUC_CONST;
gpointer blp_item_view_get_item (BlpItemView *view);

G_END_DECLS

#endif /* BLP_ITEM_VIEW_H */
