/* blp-item.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_ITEM_H
#define BLP_ITEM_H

#include <gom/gom.h>

#include "blp-item-view.h"

G_BEGIN_DECLS

#define BLP_TYPE_ITEM            (blp_item_get_type())
#define BLP_ITEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM, BlpItem))
#define BLP_ITEM_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM, BlpItem const))
#define BLP_ITEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_ITEM, BlpItemClass))
#define BLP_IS_ITEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_ITEM))
#define BLP_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_ITEM))
#define BLP_ITEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_ITEM, BlpItemClass))

typedef struct _BlpItem        BlpItem;
typedef struct _BlpItemClass   BlpItemClass;
typedef struct _BlpItemPrivate BlpItemPrivate;

struct _BlpItem
{
   GomResource parent;

   /*< private >*/
   BlpItemPrivate *priv;
};

struct _BlpItemClass
{
   GomResourceClass parent_class;
};

GType        blp_item_get_type      (void) G_GNUC_CONST;
GSList      *blp_item_get_children  (BlpItem     *item);
BlpItemView *blp_item_get_view      (BlpItem     *item);
void         blp_item_set_view      (BlpItem     *item,
                                     BlpItemView *view);
void         blp_item_append_child  (BlpItem     *item,
                                     BlpItem     *child);
void         _blp_item_set_document (BlpItem     *item,
                                     gpointer     document) G_GNUC_INTERNAL;

G_END_DECLS

#endif /* BLP_ITEM_H */
