/* blp-layer.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_LAYER_H
#define BLP_LAYER_H

#include "blp-item.h"

G_BEGIN_DECLS

#define BLP_TYPE_LAYER            (blp_layer_get_type())
#define BLP_LAYER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_LAYER, BlpLayer))
#define BLP_LAYER_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_LAYER, BlpLayer const))
#define BLP_LAYER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_LAYER, BlpLayerClass))
#define BLP_IS_LAYER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_LAYER))
#define BLP_IS_LAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_LAYER))
#define BLP_LAYER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_LAYER, BlpLayerClass))

typedef struct _BlpLayer        BlpLayer;
typedef struct _BlpLayerClass   BlpLayerClass;
typedef struct _BlpLayerPrivate BlpLayerPrivate;

struct _BlpLayer
{
   BlpItem parent;

   /*< private >*/
   BlpLayerPrivate *priv;
};

struct _BlpLayerClass
{
   BlpItemClass parent_class;
};

GType blp_layer_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* BLP_LAYER_H */
