/* blp-pixbuf-item.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_PIXBUF_ITEM_H
#define BLP_PIXBUF_ITEM_H

#include <gio/gio.h>

#include "blp-item.h"

G_BEGIN_DECLS

#define BLP_TYPE_PIXBUF_ITEM            (blp_pixbuf_item_get_type())
#define BLP_PIXBUF_ITEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_PIXBUF_ITEM, BlpPixbufItem))
#define BLP_PIXBUF_ITEM_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_PIXBUF_ITEM, BlpPixbufItem const))
#define BLP_PIXBUF_ITEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_PIXBUF_ITEM, BlpPixbufItemClass))
#define BLP_IS_PIXBUF_ITEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_PIXBUF_ITEM))
#define BLP_IS_PIXBUF_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_PIXBUF_ITEM))
#define BLP_PIXBUF_ITEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_PIXBUF_ITEM, BlpPixbufItemClass))

typedef struct _BlpPixbufItem        BlpPixbufItem;
typedef struct _BlpPixbufItemClass   BlpPixbufItemClass;
typedef struct _BlpPixbufItemPrivate BlpPixbufItemPrivate;

struct _BlpPixbufItem
{
   BlpItem parent;

   /*< private >*/
   BlpPixbufItemPrivate *priv;
};

struct _BlpPixbufItemClass
{
   BlpItemClass parent_class;
};

GType    blp_pixbuf_item_get_type (void) G_GNUC_CONST;
BlpItem *blp_pixbuf_item_new      (GFile *file);

G_END_DECLS

#endif /* BLP_PIXBUF_ITEM_H */
