/* blp-selection-view.c
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib/gi18n.h>

#include "blp-selection-view.h"

struct _BlpSelectionViewPrivate
{
   gpointer dummy;
};

enum
{
   PROP_0,
   LAST_PROP
};

G_DEFINE_TYPE_WITH_PRIVATE (BlpSelectionView,
                            blp_selection_view,
                            BLP_TYPE_ITEM_VIEW)

static GParamSpec *gParamSpecs [LAST_PROP];

static void
blp_selection_view_finalize (GObject *object)
{
   BlpSelectionViewPrivate *priv;

   priv = BLP_SELECTION_VIEW (object)->priv;

   G_OBJECT_CLASS (blp_selection_view_parent_class)->finalize (object);
}

static void
blp_selection_view_get_property (GObject    *object,
                                 guint       prop_id,
                                 GValue     *value,
                                 GParamSpec *pspec)
{
   BlpSelectionView *view = BLP_SELECTION_VIEW (object);

   switch (prop_id) {
   default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
   }
}

static void
blp_selection_view_set_property (GObject      *object,
                                 guint         prop_id,
                                 const GValue *value,
                                 GParamSpec   *pspec)
{
   BlpSelectionView *view = BLP_SELECTION_VIEW (object);

   switch (prop_id) {
   default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
   }
}

static void
blp_selection_view_class_init (BlpSelectionViewClass *klass)
{
   GObjectClass *object_class;

   object_class = G_OBJECT_CLASS (klass);
   object_class->finalize = blp_selection_view_finalize;
   object_class->get_property = blp_selection_view_get_property;
   object_class->set_property = blp_selection_view_set_property;
}

static void
blp_selection_view_init (BlpSelectionView *view)
{
   view->priv = blp_selection_view_get_instance_private (view);
}
