/* blp-selection-view.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_SELECTION_VIEW_H
#define BLP_SELECTION_VIEW_H

#include "blp-item-view.h"

G_BEGIN_DECLS

#define BLP_TYPE_SELECTION_VIEW            (blp_selection_view_get_type())
#define BLP_SELECTION_VIEW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_SELECTION_VIEW, BlpSelectionView))
#define BLP_SELECTION_VIEW_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_SELECTION_VIEW, BlpSelectionView const))
#define BLP_SELECTION_VIEW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_SELECTION_VIEW, BlpSelectionViewClass))
#define BLP_IS_SELECTION_VIEW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_SELECTION_VIEW))
#define BLP_IS_SELECTION_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_SELECTION_VIEW))
#define BLP_SELECTION_VIEW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_SELECTION_VIEW, BlpSelectionViewClass))

typedef struct _BlpSelectionView        BlpSelectionView;
typedef struct _BlpSelectionViewClass   BlpSelectionViewClass;
typedef struct _BlpSelectionViewPrivate BlpSelectionViewPrivate;

struct _BlpSelectionView
{
   BlpItemView parent;

   /*< private >*/
   BlpSelectionViewPrivate *priv;
};

struct _BlpSelectionViewClass
{
   BlpItemViewClass parent_class;
};

GType blp_selection_view_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* BLP_SELECTION_VIEW_H */
