/* blp-window.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_WINDOW_H
#define BLP_WINDOW_H

#include <gtk/gtk.h>

#include "blp-document.h"

G_BEGIN_DECLS

#define BLP_TYPE_WINDOW            (blp_window_get_type())
#define BLP_WINDOW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_WINDOW, BlpWindow))
#define BLP_WINDOW_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_WINDOW, BlpWindow const))
#define BLP_WINDOW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_WINDOW, BlpWindowClass))
#define BLP_IS_WINDOW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_WINDOW))
#define BLP_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_WINDOW))
#define BLP_WINDOW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_WINDOW, BlpWindowClass))

typedef struct _BlpWindow        BlpWindow;
typedef struct _BlpWindowClass   BlpWindowClass;
typedef struct _BlpWindowPrivate BlpWindowPrivate;

struct _BlpWindow
{
   GtkWindow parent;

   /*< private >*/
   BlpWindowPrivate *priv;
};

struct _BlpWindowClass
{
   GtkWindowClass parent_class;
};

GType      blp_window_get_type     (void) G_GNUC_CONST;
GtkWidget *blp_window_new          (void);
void       blp_window_set_document (BlpWindow   *window,
                                    BlpDocument *document);

G_END_DECLS

#endif /* BLP_WINDOW_H */
