/* blp-canvas.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_CANVAS_H
#define BLP_CANVAS_H

#include <gtk/gtk.h>
#include <clutter-gtk/clutter-gtk.h>

#include "blp-document.h"
#include "blp-item.h"

G_BEGIN_DECLS

#define BLP_TYPE_CANVAS            (blp_canvas_get_type())
#define BLP_CANVAS(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_CANVAS, BlpCanvas))
#define BLP_CANVAS_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_CANVAS, BlpCanvas const))
#define BLP_CANVAS_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_CANVAS, BlpCanvasClass))
#define BLP_IS_CANVAS(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_CANVAS))
#define BLP_IS_CANVAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_CANVAS))
#define BLP_CANVAS_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_CANVAS, BlpCanvasClass))

typedef struct _BlpCanvas        BlpCanvas;
typedef struct _BlpCanvasClass   BlpCanvasClass;
typedef struct _BlpCanvasPrivate BlpCanvasPrivate;

struct _BlpCanvas
{
   GtkClutterEmbed parent;

   /*< private >*/
   BlpCanvasPrivate *priv;
};

struct _BlpCanvasClass
{
   GtkClutterEmbedClass parent_class;
};

GType         blp_canvas_get_type        (void) G_GNUC_CONST;
GtkWidget    *blp_canvas_new             (void);
BlpDocument  *blp_canvas_get_document    (BlpCanvas          *canvas);
void          blp_canvas_set_document    (BlpCanvas          *canvas,
                                          BlpDocument        *document);
gboolean      blp_canvas_get_rubber_banding (BlpCanvas *canvas);
void          blp_canvas_begin_move_drag (BlpCanvas          *canvas,
                                          ClutterButtonEvent *event,
                                          BlpItem            *item);
void          blp_canvas_begin_select_drag (BlpCanvas *canvas,
                                            ClutterButtonEvent *event);

G_END_DECLS

#endif /* BLP_CANVAS_H */
