/* blp-item-pixbuf.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_ITEM_PIXBUF_H
#define BLP_ITEM_PIXBUF_H

#include "blp-item.h"

G_BEGIN_DECLS

#define BLP_TYPE_ITEM_PIXBUF            (blp_item_pixbuf_get_type())
#define BLP_ITEM_PIXBUF(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM_PIXBUF, BlpItemPixbuf))
#define BLP_ITEM_PIXBUF_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM_PIXBUF, BlpItemPixbuf const))
#define BLP_ITEM_PIXBUF_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_ITEM_PIXBUF, BlpItemPixbufClass))
#define BLP_IS_ITEM_PIXBUF(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_ITEM_PIXBUF))
#define BLP_IS_ITEM_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_ITEM_PIXBUF))
#define BLP_ITEM_PIXBUF_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_ITEM_PIXBUF, BlpItemPixbufClass))

typedef struct _BlpItemPixbuf        BlpItemPixbuf;
typedef struct _BlpItemPixbufClass   BlpItemPixbufClass;
typedef struct _BlpItemPixbufPrivate BlpItemPixbufPrivate;

struct _BlpItemPixbuf
{
   BlpItem parent;

   /*< private >*/
   BlpItemPixbufPrivate *priv;
};

struct _BlpItemPixbufClass
{
   BlpItemClass parent_class;
};

GType    blp_item_pixbuf_get_type      (void) G_GNUC_CONST;
BlpItem *blp_item_pixbuf_new_from_path (const gchar *path);

G_END_DECLS

#endif /* BLP_ITEM_PIXBUF_H */
