/* blp-item-plaque.h
 *
 * Copyright (C) 2014 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BLP_ITEM_PLAQUE_H
#define BLP_ITEM_PLAQUE_H

#include "blp-item.h"

G_BEGIN_DECLS

#define BLP_TYPE_ITEM_PLAQUE            (blp_item_plaque_get_type())
#define BLP_ITEM_PLAQUE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM_PLAQUE, BlpItemPlaque))
#define BLP_ITEM_PLAQUE_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLP_TYPE_ITEM_PLAQUE, BlpItemPlaque const))
#define BLP_ITEM_PLAQUE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  BLP_TYPE_ITEM_PLAQUE, BlpItemPlaqueClass))
#define BLP_IS_ITEM_PLAQUE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLP_TYPE_ITEM_PLAQUE))
#define BLP_IS_ITEM_PLAQUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  BLP_TYPE_ITEM_PLAQUE))
#define BLP_ITEM_PLAQUE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  BLP_TYPE_ITEM_PLAQUE, BlpItemPlaqueClass))

typedef struct _BlpItemPlaque        BlpItemPlaque;
typedef struct _BlpItemPlaqueClass   BlpItemPlaqueClass;
typedef struct _BlpItemPlaquePrivate BlpItemPlaquePrivate;

struct _BlpItemPlaque
{
   BlpItem parent;

   /*< private >*/
   BlpItemPlaquePrivate *priv;
};

struct _BlpItemPlaqueClass
{
   BlpItemClass parent_class;
};

GType    blp_item_plaque_get_type (void) G_GNUC_CONST;
BlpItem *blp_item_plaque_new      (void);

G_END_DECLS

#endif /* BLP_ITEM_PLAQUE_H */
