/* mail-enhanced-store.c
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib/gi18n.h>

#include "mail-enhanced-store.h"

/**
 * mail_enhanced_store_new:
 * @session: (in): A #MailSession.
 *
 * Creates a #GtkTreeStore containing information for the enhanced mail view.
 *
 * XXX: This is currently demo code while we prototype.
 *
 * Returns: A #GtkListStore.
 * Side effects: None.
 */
GtkTreeStore*
mail_enhanced_store_new (MailSession *session)
{
	GtkTreeStore *store;
	GtkTreeIter iter;

	store = gtk_tree_store_new(3,
	                           G_TYPE_STRING,
	                           G_TYPE_STRING,
	                           G_TYPE_INT);

	gtk_tree_store_append(store, &iter, NULL);
	gtk_tree_store_set(store, &iter,
	                   MAIL_ENHANCED_STORE_COLUMN_ICON_NAME, "applications-debugging",
	                   MAIL_ENHANCED_STORE_COLUMN_TITLE, _("Bugzilla"),
	                   MAIL_ENHANCED_STORE_COLUMN_COUNT, 5,
	                   -1);

	gtk_tree_store_append(store, &iter, NULL);
	gtk_tree_store_set(store, &iter,
	                   MAIL_ENHANCED_STORE_COLUMN_ICON_NAME, GTK_STOCK_FIND,
	                   MAIL_ENHANCED_STORE_COLUMN_TITLE, _("Review Board"),
	                   MAIL_ENHANCED_STORE_COLUMN_COUNT, 3,
	                   -1);

	gtk_tree_store_append(store, &iter, NULL);
	gtk_tree_store_set(store, &iter,
	                   MAIL_ENHANCED_STORE_COLUMN_ICON_NAME, "news-feed",
	                   MAIL_ENHANCED_STORE_COLUMN_TITLE, _("Mailing Lists"),
	                   MAIL_ENHANCED_STORE_COLUMN_COUNT, 1,
	                   -1);

	return store;
}
