/* mail-message-view.c
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "mail-message-view.h"

G_DEFINE_TYPE(MailMessageView, mail_message_view, GTK_TYPE_TEXT_VIEW)

struct _MailMessageViewPrivate
{
	gpointer dummy;
};

static void
mail_message_view_finalize (GObject *object)
{
	G_OBJECT_CLASS(mail_message_view_parent_class)->finalize(object);
}

static void
mail_message_view_class_init (MailMessageViewClass *klass)
{
	GObjectClass *object_class;

	object_class = G_OBJECT_CLASS(klass);
	object_class->finalize = mail_message_view_finalize;
	g_type_class_add_private(object_class, sizeof(MailMessageViewPrivate));
}

static void
mail_message_view_init (MailMessageView *view)
{
	MailMessageViewPrivate *priv;

	priv = G_TYPE_INSTANCE_GET_PRIVATE(view, MAIL_TYPE_MESSAGE_VIEW,
	                                   MailMessageViewPrivate);
	view->priv = priv;
}
