/* mail-message-view.h
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIL_MESSAGE_VIEW_H
#define MAIL_MESSAGE_VIEW_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define MAIL_TYPE_MESSAGE_VIEW            (mail_message_view_get_type())
#define MAIL_MESSAGE_VIEW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_MESSAGE_VIEW, MailMessageView))
#define MAIL_MESSAGE_VIEW_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_MESSAGE_VIEW, MailMessageView const))
#define MAIL_MESSAGE_VIEW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  MAIL_TYPE_MESSAGE_VIEW, MailMessageViewClass))
#define MAIL_IS_MESSAGE_VIEW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_MESSAGE_VIEW))
#define MAIL_IS_MESSAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  MAIL_TYPE_MESSAGE_VIEW))
#define MAIL_MESSAGE_VIEW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  MAIL_TYPE_MESSAGE_VIEW, MailMessageViewClass))

typedef struct _MailMessageView        MailMessageView;
typedef struct _MailMessageViewClass   MailMessageViewClass;
typedef struct _MailMessageViewPrivate MailMessageViewPrivate;

struct _MailMessageView
{
	GtkTextView parent;

	/*< private >*/
	MailMessageViewPrivate *priv;
};

struct _MailMessageViewClass
{
	GtkTextViewClass parent_class;
};

GType mail_message_view_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* MAIL_MESSAGE_VIEW_H */
