/* mail-prefs-dialog.c
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib/gi18n.h>

#include "mail-prefs-dialog.h"

G_DEFINE_TYPE(MailPrefsDialog, mail_prefs_dialog, GTK_TYPE_DIALOG)

struct _MailPrefsDialogPrivate
{
	gpointer dummy;
};

static void
mail_prefs_dialog_finalize (GObject *object)
{
	G_OBJECT_CLASS(mail_prefs_dialog_parent_class)->finalize(object);
}

static void
mail_prefs_dialog_class_init (MailPrefsDialogClass *klass)
{
	GObjectClass *object_class;

	object_class = G_OBJECT_CLASS(klass);
	object_class->finalize = mail_prefs_dialog_finalize;
	g_type_class_add_private(object_class, sizeof(MailPrefsDialogPrivate));
}

static void
mail_prefs_dialog_init (MailPrefsDialog *dialog)
{
	MailPrefsDialogPrivate *priv;

	priv = G_TYPE_INSTANCE_GET_PRIVATE(dialog, MAIL_TYPE_PREFS_DIALOG,
	                                   MailPrefsDialogPrivate);
	dialog->priv = priv;

	g_object_set(dialog,
	             "border-width", 6,
	             "default-height", 450,
	             "default-width", 400,
	             "title", _("Preferences"),
	             NULL);

	gtk_dialog_add_button(GTK_DIALOG(dialog), GTK_STOCK_CLOSE,
	                      GTK_RESPONSE_CLOSE);
	gtk_dialog_set_default_response(GTK_DIALOG(dialog), GTK_RESPONSE_CLOSE);
}
