/* mail-prefs-dialog.h
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIL_PREFS_DIALOG_H
#define MAIL_PREFS_DIALOG_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define MAIL_TYPE_PREFS_DIALOG            (mail_prefs_dialog_get_type())
#define MAIL_PREFS_DIALOG(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_PREFS_DIALOG, MailPrefsDialog))
#define MAIL_PREFS_DIALOG_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_PREFS_DIALOG, MailPrefsDialog const))
#define MAIL_PREFS_DIALOG_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  MAIL_TYPE_PREFS_DIALOG, MailPrefsDialogClass))
#define MAIL_IS_PREFS_DIALOG(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_PREFS_DIALOG))
#define MAIL_IS_PREFS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  MAIL_TYPE_PREFS_DIALOG))
#define MAIL_PREFS_DIALOG_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  MAIL_TYPE_PREFS_DIALOG, MailPrefsDialogClass))

typedef struct _MailPrefsDialog        MailPrefsDialog;
typedef struct _MailPrefsDialogClass   MailPrefsDialogClass;
typedef struct _MailPrefsDialogPrivate MailPrefsDialogPrivate;

struct _MailPrefsDialog
{
	GtkDialog parent;

	/*< private >*/
	MailPrefsDialogPrivate *priv;
};

struct _MailPrefsDialogClass
{
	GtkDialogClass parent_class;
};

GType mail_prefs_dialog_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* MAIL_PREFS_DIALOG_H */
