/* mail-search-tool-item.h
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIL_SEARCH_TOOL_ITEM_H
#define MAIL_SEARCH_TOOL_ITEM_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define MAIL_TYPE_SEARCH_TOOL_ITEM            (mail_search_tool_item_get_type())
#define MAIL_SEARCH_TOOL_ITEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_SEARCH_TOOL_ITEM, MailSearchToolItem))
#define MAIL_SEARCH_TOOL_ITEM_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_SEARCH_TOOL_ITEM, MailSearchToolItem const))
#define MAIL_SEARCH_TOOL_ITEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  MAIL_TYPE_SEARCH_TOOL_ITEM, MailSearchToolItemClass))
#define MAIL_IS_SEARCH_TOOL_ITEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_SEARCH_TOOL_ITEM))
#define MAIL_IS_SEARCH_TOOL_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  MAIL_TYPE_SEARCH_TOOL_ITEM))
#define MAIL_SEARCH_TOOL_ITEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  MAIL_TYPE_SEARCH_TOOL_ITEM, MailSearchToolItemClass))

typedef struct _MailSearchToolItem        MailSearchToolItem;
typedef struct _MailSearchToolItemClass   MailSearchToolItemClass;
typedef struct _MailSearchToolItemPrivate MailSearchToolItemPrivate;

struct _MailSearchToolItem
{
	GtkToolItem parent;

	/*< private >*/
	MailSearchToolItemPrivate *priv;
};

struct _MailSearchToolItemClass
{
	GtkToolItemClass parent_class;
};

GType      mail_search_tool_item_get_type  (void) G_GNUC_CONST;
GtkWidget* mail_search_tool_item_get_entry (MailSearchToolItem *item);

G_END_DECLS

#endif /* MAIL_SEARCH_TOOL_ITEM_H */
