/* mail-session.c
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "mail-session.h"

G_DEFINE_TYPE(MailSession, mail_session, G_TYPE_INITIALLY_UNOWNED)

struct _MailSessionPrivate
{
	gpointer dummy;
};

void
mail_session_run_task (MailSession *session,
                       MailTask *task)
{
}

static void
mail_session_finalize (GObject *object)
{
	G_OBJECT_CLASS(mail_session_parent_class)->finalize(object);
}

static void
mail_session_class_init (MailSessionClass *klass)
{
	GObjectClass *object_class;

	object_class = G_OBJECT_CLASS(klass);
	object_class->finalize = mail_session_finalize;
	g_type_class_add_private(object_class, sizeof(MailSessionPrivate));
}

static void
mail_session_init (MailSession *session)
{
	MailSessionPrivate *priv;

	priv = G_TYPE_INSTANCE_GET_PRIVATE(session, MAIL_TYPE_SESSION,
	                                   MailSessionPrivate);
	session->priv = priv;
}
