/* mail-session.h
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIL_SESSION_H
#define MAIL_SESSION_H

#include <glib-object.h>

#include "mail-task.h"

G_BEGIN_DECLS

#define MAIL_TYPE_SESSION            (mail_session_get_type())
#define MAIL_SESSION(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_SESSION, MailSession))
#define MAIL_SESSION_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_SESSION, MailSession const))
#define MAIL_SESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  MAIL_TYPE_SESSION, MailSessionClass))
#define MAIL_IS_SESSION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_SESSION))
#define MAIL_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  MAIL_TYPE_SESSION))
#define MAIL_SESSION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  MAIL_TYPE_SESSION, MailSessionClass))

typedef struct _MailSession        MailSession;
typedef struct _MailSessionClass   MailSessionClass;
typedef struct _MailSessionPrivate MailSessionPrivate;

struct _MailSession
{
	GInitiallyUnowned parent;

	/*< private >*/
	MailSessionPrivate *priv;
};

struct _MailSessionClass
{
	GInitiallyUnownedClass parent_class;
};

GType mail_session_get_type (void) G_GNUC_CONST;
void  mail_session_run_task (MailSession *session,
                             MailTask    *task);

G_END_DECLS

#endif /* MAIL_SESSION_H */
