/* mail-status-view.h
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIL_STATUS_VIEW_H
#define MAIL_STATUS_VIEW_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define MAIL_TYPE_STATUS_VIEW            (mail_status_view_get_type())
#define MAIL_STATUS_VIEW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_STATUS_VIEW, MailStatusView))
#define MAIL_STATUS_VIEW_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_STATUS_VIEW, MailStatusView const))
#define MAIL_STATUS_VIEW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  MAIL_TYPE_STATUS_VIEW, MailStatusViewClass))
#define MAIL_IS_STATUS_VIEW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_STATUS_VIEW))
#define MAIL_IS_STATUS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  MAIL_TYPE_STATUS_VIEW))
#define MAIL_STATUS_VIEW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  MAIL_TYPE_STATUS_VIEW, MailStatusViewClass))

typedef struct _MailStatusView        MailStatusView;
typedef struct _MailStatusViewClass   MailStatusViewClass;
typedef struct _MailStatusViewPrivate MailStatusViewPrivate;

struct _MailStatusView
{
	GtkVBox parent;

	/*< private >*/
	MailStatusViewPrivate *priv;
};

struct _MailStatusViewClass
{
	GtkVBoxClass parent_class;
};

GType mail_status_view_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* MAIL_STATUS_VIEW_H */
