/* mail-window-actions.h
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib/gi18n.h>
#include <gtk/gtk.h>

#include "mail-runtime.h"

static void mail_window_preferences_activate (GtkAction *action,
                                              MailWindow *window);
static void mail_window_search_activate      (GtkAction *action,
                                              MailWindow *window);

static GtkActionEntry mail_window_action_entries[] = {
	{ "file", GTK_STOCK_FILE, N_("_File") },
	{ "send-receive", "stock_mail-send-receive", N_("Get Mail"), "F5" },
	{ "quit", GTK_STOCK_QUIT, NULL, NULL, NULL, G_CALLBACK(mail_runtime_quit)  },

	{ "edit", GTK_STOCK_EDIT, N_("_Edit") },
	{ "cut", GTK_STOCK_CUT },
	{ "copy", GTK_STOCK_COPY },
	{ "paste", GTK_STOCK_PASTE },
	{ "delete", GTK_STOCK_DELETE },
	{ "search", GTK_STOCK_FIND, NULL, NULL, NULL, G_CALLBACK(mail_window_search_activate) },
	{ "preferences", GTK_STOCK_PREFERENCES, NULL, "<control>comma", NULL, G_CALLBACK(mail_window_preferences_activate) },
	{ "accounts", NULL, N_("_Accounts") },

	{ "message", NULL, N_("_Message") },
	{ "compose", "stock_mail-compose", N_("Compose new mail") },
	{ "reply", "stock_mail-reply", N_("Reply") },
	{ "reply-all", "stock_mail-reply-to-all", N_("Reply to all") },
	{ "forward", "stock_mail-forward", N_("Forward") },
};
