/* mail-window.h
 *
 * Copyright (C) 2010 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIL_WINDOW_H
#define MAIL_WINDOW_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define MAIL_TYPE_WINDOW            (mail_window_get_type())
#define MAIL_WINDOW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_WINDOW, MailWindow))
#define MAIL_WINDOW_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_WINDOW, MailWindow const))
#define MAIL_WINDOW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  MAIL_TYPE_WINDOW, MailWindowClass))
#define MAIL_IS_WINDOW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_WINDOW))
#define MAIL_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  MAIL_TYPE_WINDOW))
#define MAIL_WINDOW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  MAIL_TYPE_WINDOW, MailWindowClass))

typedef struct _MailWindow        MailWindow;
typedef struct _MailWindowClass   MailWindowClass;
typedef struct _MailWindowPrivate MailWindowPrivate;

struct _MailWindow
{
	GtkWindow parent;

	/*< private >*/
	MailWindowPrivate *priv;
};

struct _MailWindowClass
{
	GtkWindowClass parent_class;
};

GType mail_window_get_type   (void) G_GNUC_CONST;
void  mail_window_action_set (MailWindow  *window,
                              const gchar *name,
                              const gchar *first_property,
                              ...) G_GNUC_NULL_TERMINATED;

G_END_DECLS

#endif /* MAIL_WINDOW_H */
