/* news-anim-bin.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_ANIM_BIN_H
#define NEWS_ANIM_BIN_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define NEWS_TYPE_ANIM_BIN            (news_anim_bin_get_type())
#define NEWS_ANIM_BIN(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_ANIM_BIN, NewsAnimBin))
#define NEWS_ANIM_BIN_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_ANIM_BIN, NewsAnimBin const))
#define NEWS_ANIM_BIN_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_ANIM_BIN, NewsAnimBinClass))
#define NEWS_IS_ANIM_BIN(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_ANIM_BIN))
#define NEWS_IS_ANIM_BIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_ANIM_BIN))
#define NEWS_ANIM_BIN_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_ANIM_BIN, NewsAnimBinClass))

typedef struct _NewsAnimBin        NewsAnimBin;
typedef struct _NewsAnimBinClass   NewsAnimBinClass;
typedef struct _NewsAnimBinPrivate NewsAnimBinPrivate;

struct _NewsAnimBin
{
   GtkEventBox parent;

   /*< private >*/
   NewsAnimBinPrivate *priv;
};

struct _NewsAnimBinClass
{
   GtkEventBoxClass parent_class;
};

GType news_anim_bin_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_ANIM_BIN_H */
