/* news-application.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_APPLICATION_H
#define NEWS_APPLICATION_H

#include <gom/gom.h>
#include <gtk/gtk.h>

#include "news-client.h"

G_BEGIN_DECLS

#define NEWS_APPLICATION_DEFAULT         (news_application_get_default())
#define NEWS_TYPE_APPLICATION            (news_application_get_type())
#define NEWS_APPLICATION(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_APPLICATION, NewsApplication))
#define NEWS_APPLICATION_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_APPLICATION, NewsApplication const))
#define NEWS_APPLICATION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_APPLICATION, NewsApplicationClass))
#define NEWS_IS_APPLICATION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_APPLICATION))
#define NEWS_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_APPLICATION))
#define NEWS_APPLICATION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_APPLICATION, NewsApplicationClass))

typedef struct _NewsApplication        NewsApplication;
typedef struct _NewsApplicationClass   NewsApplicationClass;
typedef struct _NewsApplicationPrivate NewsApplicationPrivate;

struct _NewsApplication
{
   GtkApplication parent;

   /*< private >*/
   NewsApplicationPrivate *priv;
};

struct _NewsApplicationClass
{
   GtkApplicationClass parent_class;
};

GtkActionGroup  *news_application_get_actions (NewsApplication *application);
NewsClient      *news_application_get_client  (NewsApplication *application);
NewsApplication *news_application_get_default (void);
GType            news_application_get_type    (void) G_GNUC_CONST;
GomAdapter      *news_application_get_adapter (NewsApplication *application);

G_END_DECLS

#endif /* NEWS_APPLICATION_H */
