/* news-category.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_CATEGORY_H
#define NEWS_CATEGORY_H

#include <gom/gom.h>

G_BEGIN_DECLS

#define NEWS_TYPE_CATEGORY            (news_category_get_type())
#define NEWS_CATEGORY(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_CATEGORY, NewsCategory))
#define NEWS_CATEGORY_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_CATEGORY, NewsCategory const))
#define NEWS_CATEGORY_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_CATEGORY, NewsCategoryClass))
#define NEWS_IS_CATEGORY(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_CATEGORY))
#define NEWS_IS_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_CATEGORY))
#define NEWS_CATEGORY_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_CATEGORY, NewsCategoryClass))

typedef struct _NewsCategory        NewsCategory;
typedef struct _NewsCategoryClass   NewsCategoryClass;
typedef struct _NewsCategoryPrivate NewsCategoryPrivate;

struct _NewsCategory
{
   GomResource parent;

   /*< private >*/
   NewsCategoryPrivate *priv;
};

struct _NewsCategoryClass
{
   GomResourceClass parent_class;
};

GType news_category_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_CATEGORY_H */
