/* news-content-kind.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_CONTENT_KIND_H
#define NEWS_CONTENT_KIND_H

#include <glib-object.h>

G_BEGIN_DECLS

#define NEWS_TYPE_CONTENT_KIND (news_content_kind_get_type())

typedef enum {
   NEWS_CONTENT_TEXT,
   NEWS_CONTENT_HTML,
   NEWS_CONTENT_XHTML,
} NewsContentKind;

GType    news_content_kind_get_type (void) G_GNUC_CONST;
gboolean news_content_kind_parse    (NewsContentKind *kind,
                                     const gchar     *text);

G_END_DECLS

#endif /* NEWS_CONTENT_KIND_H */
