/* news-feed.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_FEED_H
#define NEWS_FEED_H

#include <gom/gom.h>

G_BEGIN_DECLS

#define NEWS_TYPE_FEED            (news_feed_get_type())
#define NEWS_FEED(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_FEED, NewsFeed))
#define NEWS_FEED_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_FEED, NewsFeed const))
#define NEWS_FEED_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_FEED, NewsFeedClass))
#define NEWS_IS_FEED(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_FEED))
#define NEWS_IS_FEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_FEED))
#define NEWS_FEED_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_FEED, NewsFeedClass))

typedef struct _NewsFeed        NewsFeed;
typedef struct _NewsFeedClass   NewsFeedClass;
typedef struct _NewsFeedPrivate NewsFeedPrivate;

struct _NewsFeed
{
   GomResource parent;

   /*< private >*/
   NewsFeedPrivate *priv;
};

struct _NewsFeedClass
{
   GomResourceClass parent_class;
};

GType    news_feed_get_type (void) G_GNUC_CONST;
gboolean news_feed_is_newer (NewsFeed *feed,
                             NewsFeed *other);

G_END_DECLS

#endif /* NEWS_FEED_H */
