/* news-format-atom.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_FORMAT_ATOM_H
#define NEWS_FORMAT_ATOM_H

#include "news-format.h"

G_BEGIN_DECLS

#define NEWS_TYPE_FORMAT_ATOM            (news_format_atom_get_type())
#define NEWS_FORMAT_ATOM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_FORMAT_ATOM, NewsFormatAtom))
#define NEWS_FORMAT_ATOM_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_FORMAT_ATOM, NewsFormatAtom const))
#define NEWS_FORMAT_ATOM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_FORMAT_ATOM, NewsFormatAtomClass))
#define NEWS_IS_FORMAT_ATOM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_FORMAT_ATOM))
#define NEWS_IS_FORMAT_ATOM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_FORMAT_ATOM))
#define NEWS_FORMAT_ATOM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_FORMAT_ATOM, NewsFormatAtomClass))
#define NEWS_FORMAT_ATOM_ERROR           (news_format_atom_error_quark())

typedef struct _NewsFormatAtom        NewsFormatAtom;
typedef struct _NewsFormatAtomClass   NewsFormatAtomClass;
typedef struct _NewsFormatAtomPrivate NewsFormatAtomPrivate;
typedef enum   _NewsFormatAtomError   NewsFormatAtomError;

enum _NewsFormatAtomError
{
   NEWS_FORMAT_ATOM_ERROR_INVALID_XML = 1,
};

struct _NewsFormatAtom
{
   NewsFormat parent;

   /*< private >*/
   NewsFormatAtomPrivate *priv;
};

struct _NewsFormatAtomClass
{
   NewsFormatClass parent_class;
};

GQuark news_format_atom_error_quark (void) G_GNUC_CONST;
GType  news_format_atom_get_type    (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_FORMAT_ATOM_H */
