/* news-item.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_ITEM_H
#define NEWS_ITEM_H

#include <gom/gom.h>

G_BEGIN_DECLS

#define NEWS_TYPE_ITEM            (news_item_get_type())
#define NEWS_ITEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_ITEM, NewsItem))
#define NEWS_ITEM_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_ITEM, NewsItem const))
#define NEWS_ITEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_ITEM, NewsItemClass))
#define NEWS_IS_ITEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_ITEM))
#define NEWS_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_ITEM))
#define NEWS_ITEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_ITEM, NewsItemClass))

typedef struct _NewsItem        NewsItem;
typedef struct _NewsItemClass   NewsItemClass;
typedef struct _NewsItemPrivate NewsItemPrivate;

struct _NewsItem
{
   GomResource parent;

   /*< private >*/
   NewsItemPrivate *priv;
};

struct _NewsItemClass
{
   GomResourceClass parent_class;
};

GType news_item_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_ITEM_H */
