/* news-link.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_LINK_H
#define NEWS_LINK_H

#include <gom/gom.h>

G_BEGIN_DECLS

#define NEWS_TYPE_LINK            (news_link_get_type())
#define NEWS_LINK(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_LINK, NewsLink))
#define NEWS_LINK_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_LINK, NewsLink const))
#define NEWS_LINK_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_LINK, NewsLinkClass))
#define NEWS_IS_LINK(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_LINK))
#define NEWS_IS_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_LINK))
#define NEWS_LINK_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_LINK, NewsLinkClass))

typedef struct _NewsLink        NewsLink;
typedef struct _NewsLinkClass   NewsLinkClass;
typedef struct _NewsLinkPrivate NewsLinkPrivate;

struct _NewsLink
{
   GomResource parent;

   /*< private >*/
   NewsLinkPrivate *priv;
};

struct _NewsLinkClass
{
   GomResourceClass parent_class;
};

GType news_link_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_LINK_H */
