/* news-section.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_SECTION_H
#define NEWS_SECTION_H

#include <gom/gom.h>

G_BEGIN_DECLS

#define NEWS_TYPE_SECTION            (news_section_get_type())
#define NEWS_SECTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_SECTION, NewsSection))
#define NEWS_SECTION_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_SECTION, NewsSection const))
#define NEWS_SECTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_SECTION, NewsSectionClass))
#define NEWS_IS_SECTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_SECTION))
#define NEWS_IS_SECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_SECTION))
#define NEWS_SECTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_SECTION, NewsSectionClass))

typedef struct _NewsSection        NewsSection;
typedef struct _NewsSectionClass   NewsSectionClass;
typedef struct _NewsSectionPrivate NewsSectionPrivate;

struct _NewsSection
{
   GomResource parent;

   /*< private >*/
   NewsSectionPrivate *priv;
};

struct _NewsSectionClass
{
   GomResourceClass parent_class;
};

GType news_section_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_SECTION_H */
