/* news-source-file.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_SOURCE_FILE_H
#define NEWS_SOURCE_FILE_H

#include "news-source.h"

G_BEGIN_DECLS

#define NEWS_TYPE_SOURCE_FILE            (news_source_file_get_type())
#define NEWS_SOURCE_FILE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_SOURCE_FILE, NewsSourceFile))
#define NEWS_SOURCE_FILE_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_SOURCE_FILE, NewsSourceFile const))
#define NEWS_SOURCE_FILE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_SOURCE_FILE, NewsSourceFileClass))
#define NEWS_IS_SOURCE_FILE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_SOURCE_FILE))
#define NEWS_IS_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_SOURCE_FILE))
#define NEWS_SOURCE_FILE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_SOURCE_FILE, NewsSourceFileClass))

typedef struct _NewsSourceFile        NewsSourceFile;
typedef struct _NewsSourceFileClass   NewsSourceFileClass;
typedef struct _NewsSourceFilePrivate NewsSourceFilePrivate;

struct _NewsSourceFile
{
   NewsSource parent;

   /*< private >*/
   NewsSourceFilePrivate *priv;
};

struct _NewsSourceFileClass
{
   NewsSourceClass parent_class;
};

GType news_source_file_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_SOURCE_FILE_H */
