/* news-source-soup.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_SOURCE_SOUP_H
#define NEWS_SOURCE_SOUP_H

#include "news-source.h"

G_BEGIN_DECLS

#define NEWS_TYPE_SOURCE_SOUP            (news_source_soup_get_type())
#define NEWS_SOURCE_SOUP(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_SOURCE_SOUP, NewsSourceSoup))
#define NEWS_SOURCE_SOUP_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_SOURCE_SOUP, NewsSourceSoup const))
#define NEWS_SOURCE_SOUP_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_SOURCE_SOUP, NewsSourceSoupClass))
#define NEWS_IS_SOURCE_SOUP(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_SOURCE_SOUP))
#define NEWS_IS_SOURCE_SOUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_SOURCE_SOUP))
#define NEWS_SOURCE_SOUP_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_SOURCE_SOUP, NewsSourceSoupClass))

typedef struct _NewsSourceSoup        NewsSourceSoup;
typedef struct _NewsSourceSoupClass   NewsSourceSoupClass;
typedef struct _NewsSourceSoupPrivate NewsSourceSoupPrivate;

struct _NewsSourceSoup
{
   NewsSource parent;

   /*< private >*/
   NewsSourceSoupPrivate *priv;
};

struct _NewsSourceSoupClass
{
   NewsSourceClass parent_class;
};

GType news_source_soup_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_SOURCE_SOUP_H */
