/* news-status.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_STATUS_H
#define NEWS_STATUS_H

#include <glib-object.h>

G_BEGIN_DECLS

#define NEWS_TYPE_STATUS (news_status_get_type())

typedef struct _NewsStatus NewsStatus;

struct _NewsStatus
{
   gulong  completed;
   gulong  total;
   gdouble fraction;
};

GType       news_status_get_type (void) G_GNUC_CONST;
void        news_status_add      (NewsStatus       *status,
                                  gulong            count);
NewsStatus *news_status_copy     (const NewsStatus *status);
void        news_status_free     (NewsStatus       *status);
void        news_status_complete (NewsStatus       *status,
                                  gulong            count);

G_END_DECLS

#endif /* NEWS_STATUS_H */
