/* news-window.h
 *
 * Copyright (C) 2011 Christian Hergert <chris@dronelabs.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NEWS_WINDOW_H
#define NEWS_WINDOW_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define NEWS_TYPE_WINDOW            (news_window_get_type())
#define NEWS_WINDOW(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_WINDOW, NewsWindow))
#define NEWS_WINDOW_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEWS_TYPE_WINDOW, NewsWindow const))
#define NEWS_WINDOW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NEWS_TYPE_WINDOW, NewsWindowClass))
#define NEWS_IS_WINDOW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEWS_TYPE_WINDOW))
#define NEWS_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NEWS_TYPE_WINDOW))
#define NEWS_WINDOW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NEWS_TYPE_WINDOW, NewsWindowClass))

typedef struct _NewsWindow        NewsWindow;
typedef struct _NewsWindowClass   NewsWindowClass;
typedef struct _NewsWindowPrivate NewsWindowPrivate;

struct _NewsWindow
{
   GtkWindow parent;

   /*< private >*/
   NewsWindowPrivate *priv;
};

struct _NewsWindowClass
{
   GtkWindowClass parent_class;
};

GType news_window_get_type (void) G_GNUC_CONST;

G_END_DECLS

#endif /* NEWS_WINDOW_H */
