/*
 * write.h - write output from terminal to host
 *
 * Written by
 *  Christian Vogelgsang <chris@vogelgsang.org>
 *
 * This file is part of knobterm.
 * See README for copyright notice.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307  USA.
 *
 */

#ifndef WRITE_H
#define WRITE_H

#include <avr/pgmspace.h>

extern void write_begin(void);
extern void write_cmd(u08 c);
extern void write_ch(char c);
extern void write_str(const char *str);
extern void write_pstr(PGM_P data);
extern void write_hex_nybble(u08 b);
extern void write_hex_byte(u08 b);
extern void write_end(void);

#endif