/**
*  @file znpRfTestInterface.h
*
*  @brief  public methods for znpRfTestInterface.c
*
* $Rev: 547 $
* $Author: dsmith $
* $Date: 2010-05-27 17:11:30 -0700 (Thu, 27 May 2010) $
*
* YOU ACKNOWLEDGE AND AGREE THAT THE SOFTWARE AND DOCUMENTATION ARE PROVIDED AS IS WITHOUT WARRANTY 
* OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY, 
* TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL TEXAS INSTRUMENTS 
* OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, 
* BREACH OF WARRANTY, OR OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
* INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR CONSEQUENTIAL DAMAGES, 
* LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY 
* CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/
#ifndef ZNP_RF_TEST_INTERFACE_H
#define ZNP_RF_TEST_INTERFACE_H

#include "znp_commands.h"

signed int rfTest(unsigned char mode, unsigned char channel);

//RF TEST MODES
#define RF_TEST_RECEIVE                 1
#define RF_TEST_UNMODULATED             2
#define RF_TEST_MODULATED               3
#define RF_TEST_NONE                    0xFF  //NOTE: this is for the application only, don't send this to the ZNP

//From Table 1 in cc2530 datasheet, p 21
#define RF_OUTPUT_POWER_PLUS_4_5_DBM    0xF5  //+4.5dBm
#define RF_OUTPUT_POWER_PLUS_2_5_DBM    0xE5  //+2.5dBm
#define RF_OUTPUT_POWER_PLUS_1_0_DBM    0xD5  //+1.0dBm
#define RF_OUTPUT_POWER_MINUS_0_5_DBM   0xC5  //-0.5dBm
#define RF_OUTPUT_POWER_MINUS_1_5_DBM   0xB5  //-1.5dBm
#define RF_OUTPUT_POWER_MINUS_3_0_DBM   0xA5  //-3.0dBm
#define RF_OUTPUT_POWER_MINUS_10_0_DBM  0x65  //-10.0dBm

//used for RF Test Modes:
#define RF_TEST_CHANNEL_MIN             11
#define RF_TEST_CHANNEL_MAX             26


#endif