#include <stdio.h>

char stack[100];
int top = -1;

void handleOp(char);
void push(char);
char pop();
int getPriority(char);

int main()
{
    int nexp;
    int i;
    char c;

    scanf("%d", &nexp);
    while ((c = getchar()) != '\n')
        ;
    for (i = 0; i < nexp; ++i) {
        while ((c = getchar()) != '\n') {
            if (c >= 'a' && c <= 'z')
                printf("%c", c);
            else
                handleOp(c);
        }
        if (top > -1) 
            while ((c = pop()) != -1)
                printf("%c", c); 
        printf("\n");
    }

    return 0;
}
    
void handleOp(char op)
{
    char c;
    if(top == -1)
        push(op);
    else if (op == '(')
        push(op);
    else if (op == ')')
        while ((c = pop()) != '(')
            printf("%c", c);
    else {
        if (getPriority(op) > getPriority(stack[top]))
            push(op);
        else {
            while (getPriority(op) <= getPriority(stack[top])) {
                c = pop();
                printf("%c", c);
            }
            push(op);
        }
    }
}

void push(char ele)
{
    top++;
    stack[top] = ele;
}

char pop()
{
    char ele;
    if (top == -1)
        return -1; // STACK EMPTY
    ele = stack[top];
    top--;

    return ele;
}

int getPriority(char op)
{
    switch(op) {
        case '+':
        case '-':
            return 1;
            break;
        case '*':
        case '/':
            return 2;
            break;
        case '^':
            return 3;
            break;
        default:
            return 0;
            break;
    }
}
