/*
 * SPOJ PROBLEM : Prime Generator
 */

/* The primality check is done using divisibility check
 * against a list of prime numbers
 */

#include <stdio.h>
#include <math.h>

int isPrime (int n, int plist[], int len);
int genPrime (int plist[]);

int main()
{
	int ulim[9], llim[9];
	int i, ctr, len, plist[10000], test;
	int flag ;
	i = 0;
	ctr = 0;
	scanf("%i", &test);
	while (ctr < test) {
		scanf("%i %i", &llim[ctr], &ulim[ctr]);
		++ctr;
	}
	len = genPrime (plist);
	for (ctr = 0; ctr < test; ++ctr) {
		for (i = llim[ctr]; i <= ulim[ctr]; ++i) {
			flag = 1;
			flag = isPrime(i, plist, len);
			if (flag)
				printf("%i\n", i);
		}
		printf("\n");
	}

	return 0;
}

int isPrime (int n, int plist[], int len)
{
	int j, sqrtx;
	if (n == 1)
		return 0;
	sqrtx = sqrt(n);
	for (j = 0; j < len && plist[j] <= sqrtx; ++j) {
		if (n % plist[j] == 0)
			return 0;
	}
	return 1;
}	

/* 
 * Generates a list of prime numbers between 4 and
 * 40000 (since sqrt(1x10^9) is close to 31000
 *
 * A number is prime if it has no factors in the
 * range 1 to sqrt(n) other than 1
 */
int genPrime (int plist[])
{
	int i, j, len, sqrtx, flag;
	plist[0] = 2;
	plist[1] = 3;
	len = 2;
	for (i = 4;i < 40000; ++i) {
		sqrtx = sqrt(i);
		flag = 1;
		for (j = 2; j <= sqrtx && flag; ++j)
			if (i % j == 0)
				flag = 0;
		if (flag) {
			plist[len] = i;
			++len;
		}
		
	}

	return len;
}	
