#include <stdlib.h>
#include <string.h>
#include "crontask.h"

crontask *head = 0;

void ParseCronTimeField(char *ptr,char *ary, int max, int off, char **endptr) {
	int slash = 0;
	int n1 = -1;
	int n2 = -1;
    int *n;

	while (*ptr == ' ') ptr++;
	while (1) {
		slash = 0;
		n = &n1;
		if (*ptr == '*'){
			*n = -1; ptr++;
		} else if (*ptr >= '0' && *ptr <='9') {
			*n = strtol(ptr, &ptr, 10);
		}

		n = &n2;
		if (*ptr == '-')
			ptr++;
		if (*ptr == '/') {
			ptr++; slash = 1;
		}
		if (*ptr == 0 || *ptr == ' ' || *ptr == ',')
			n2 = n1;
		if (*ptr >= '0' && *ptr <='9') {
			*n = strtol(ptr, &ptr, 10);
		}
	
		int to = n2;
		if (to > max)
			to = max;
		if (n1 == -1) { n1 = 0; to = max; }
		for (int i=n1;i<=to;i++)
			if (slash) {
				if (!(i%n2))
					ary[i+off] = 1;
			}
			else
				ary[i+off] = 1;


		if (*ptr == ','){
			ptr++;
			continue;
		} else break;
	}

	*endptr = ptr;
}

int CreateCrontask(char *cronstring, char *shellcmd, int func_ref) {
	struct crontask *task;
	task = (crontask *)malloc(sizeof(crontask));
	memset(task,0,sizeof(crontask));
	char *pEnd;
	ParseCronTimeField(cronstring,task->min,59,0,&pEnd);
	ParseCronTimeField(pEnd,task->hour,23,0,&pEnd);
	ParseCronTimeField(pEnd,task->mday,31,0,&pEnd);
	ParseCronTimeField(pEnd,task->mon,12,-1,&pEnd);
	ParseCronTimeField(pEnd,task->wday,7,0,&pEnd);
	if (task->wday[7])
		task->wday[0] = 1;  // Sunday =0 or =7

	task->shellcmd = shellcmd;
	task->func_ref = func_ref;

	task->next = head;
	head = task;

	return 1;
}