/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/common-private.h"
#include "sv/bio.h"

ssize_t bio_0_read(int, void *, size_t);

uint8_t bio_0_data[8192];
bio_t _bio_0 = BIO_INIT(bio_0_read, 0, bio_0_data, sizeof(bio_0_data));
bio_t *bio_0 = &_bio_0;

uint8_t bio_1_data[8192];
bio_t _bio_1 = BIO_INIT(write, 1, bio_1_data, sizeof(bio_1_data));
bio_t *bio_1 = &_bio_1;

uint8_t bio_2_data[1024];
bio_t _bio_2 = BIO_INIT(write, 2, bio_2_data, sizeof(bio_2_data));
bio_t *bio_2 = &_bio_2;

ssize_t bio_0_read(int fd, void *data, size_t dlen) {
  if (bio_flush(bio_1) == -1)
    return -1;
  return read(fd, data, dlen);
}
