/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/common.h"

int main() {
  size_t size;
  int i;
  unsigned long ul = 0;
  unsigned long ula[4] = { 0, 1, 2, 3 };
  unsigned long ulab[100000];
  unsigned long *ulp;
  array_t arr = ARRAY_INIT(sizeof(ul));
  
  array_append(&arr, &ul, 1);
  if (array_failed(&arr))
    return 1;
  if (array_size(&arr) != 1)
    return 2;
    
  ul = 1;
  array_append(&arr, &ul, 1);
  if (array_failed(&arr))
    return 3;
  if (array_size(&arr) != 2)
    return 4;
    
  array_append(&arr, ula, 4);
  if (array_failed(&arr))
    return 5;
  if (array_size(&arr) != 6)
    return 6;
    
  ulp = array_get(&arr, 0);
  if (*ulp != 0)
    return 7;
  ulp = array_get(&arr, 5);
  if (*ulp != 3)
    return 8;
    
  for (i = 0; i < 100; i++) {
    array_append(&arr, ulab, 100000);
    if (array_failed(&arr))
      return 9;
  }
  if (array_size(&arr) != 10000006)
    return 10;
    
  size = array_size(&arr);
  for (i = 0; i < 1000; i++) {
    array_append(&arr, ulab, i);
    size += i;
  }
  if (array_failed(&arr))
    return 11;
  if (array_size(&arr) != size)
    return 12;
    
  return 0;
}
