/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/common.h"

int main() {
  char out[128];
  
  if (base16_encode(out, "", 0) != 0)
    return 1;
    
  if (base16_encode(out, "f", 1) != 2)
    return 2;
  if (memcmp(out, "66", 2))
    return 3;
    
  if (base16_encode(out, "fo", 2) != 4)
    return 3;
  if (memcmp(out, "666F", 4))
    return 4;
    
  if (base16_encode(out, "foo", 3) != 6)
    return 5;
  if (memcmp(out, "666F6F", 6))
    return 6;
    
  if (base16_encode(out, "foob", 4) != 8)
    return 7;
  if (memcmp(out, "666F6F62", 8))
    return 8;
    
  if (base16_encode(out, "fooba", 5) != 10)
    return 9;
  if (memcmp(out, "666F6F6261", 10))
    return 10;
    
  if (base16_encode(out, "foobar", 6) != 12)
    return 11;
  if (memcmp(out, "666F6F626172", 12))
    return 12;
    
  if (base16_decode(out, "66", 2) != 1)
    return 13;
  if (memcmp(out, "f", 1))
    return 14;
    
  if (base16_decode(out, "666F", 4) != 2)
    return 15;
  if (memcmp(out, "fo", 2))
    return 16;
    
  if (base16_decode(out, "666F6F", 6) != 3)
    return 17;
  if (memcmp(out, "foo", 3))
    return 18;
    
  if (base16_decode(out, "666F6F62", 8) != 4)
    return 19;
  if (memcmp(out, "foob", 4))
    return 20;
    
  if (base16_decode(out, "666F6F6261", 10) != 5)
    return 21;
  if (memcmp(out, "fooba", 5))
    return 22;
    
  if (base16_decode(out, "666F6F626172", 12) != 6)
    return 23;
  if (memcmp(out, "foobar", 6))
    return 24;
    
  if (base16_decode(out, "666f6f626172", 12) != 6)
    return 25;
  if (memcmp(out, "foobar", 6))
    return 26;
    
  return 0;
}
