/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/common.h"

int main() {
  char out[128];
  char out2[64];
  
  if (base64url_encode(out, "", 0) != 0)
    return 1;
    
  if (base64url_encode(out, "f", 1) != 4)
    return 2;
  if (memcmp(out, "Zg==", 4))
    return 3;
    
  if (base64url_encode(out, "fo", 2) != 4)
    return 4;
  if (memcmp(out, "Zm8=", 4))
    return 5;
    
  if (base64url_encode(out, "foo", 3) != 4)
    return 6;
  if (memcmp(out, "Zm9v", 4))
    return 7;
    
  if (base64url_encode(out, "foob", 4) != 8)
    return 8;
  if (memcmp(out, "Zm9vYg==", 8))
    return 9;
    
  if (base64url_encode(out, "fooba", 5) != 8)
    return 10;
  if (memcmp(out, "Zm9vYmE=", 8))
    return 11;
    
  if (base64url_encode(out, "foobar", 6) != 8)
    return 12;
  if (memcmp(out, "Zm9vYmFy", 8))
    return 13;
    
  if (base64url_decode(out, "Zg==", 4) != 1)
    return 14;
  if (memcmp(out, "f", 1))
    return 15;
    
  if (base64url_decode(out, "Zm8=", 4) != 2)
    return 16;
  if (memcmp(out, "fo", 2))
    return 17;
    
  if (base64url_decode(out, "Zm9v", 4) != 3)
    return 18;
  if (memcmp(out, "foo", 3))
    return 19;
    
  if (base64url_decode(out, "Zm9vYg==", 8) != 4)
    return 20;
  if (memcmp(out, "foob", 4))
    return 21;
    
  if (base64url_decode(out, "Zm9vYmE=", 8) != 5)
    return 22;
  if (memcmp(out, "fooba", 5))
    return 23;
    
  if (base64url_decode(out, "Zm9vYmFy", 8) != 6)
    return 24;
  if (memcmp(out, "foobar", 6))
    return 25;
    
  if (base64url_encode(out, (char *)base64url_charset, 64) != 88)
    return 26;
  if (base64url_decode(out2, out, 88) != 64)
    return 27;
  if (memcmp((char *)base64url_charset, out2, 64))
    return 28;
    
  return 0;
}
