/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/common-private.h"
#include "sv/common.h"

int main() {
  uint32_t u32 = 0;
  uint32_t u32_pack;
  uint64_t u64 = 0;
  uint64_t u64_pack;
  char buf[sizeof(u64) * 2 + 1];
  
  u32_pack = htobe32(u32);
  buf[fmt_hex_pad(buf, &u32_pack, sizeof(u32_pack))] = 0;
  if (strcmp(buf, "00000000"))
    return 1;
    
  u32 = 0xabcdef;
  u32_pack = htobe32(u32);
  buf[fmt_hex_pad(buf, &u32_pack, sizeof(u32_pack))] = 0;
  if (strcmp(buf, "00abcdef"))
    return 2;
    
  u32 = 0xab0001;
  u32_pack = htobe32(u32);
  buf[fmt_hex_pad(buf, &u32_pack, sizeof(u32_pack))] = 0;
  if (strcmp(buf, "00ab0001"))
    return 3;
    
  u32 = 0xffffffff;
  u32_pack = htobe32(u32);
  buf[fmt_hex_pad(buf, &u32_pack, sizeof(u32_pack))] = 0;
  if (strcmp(buf, "ffffffff"))
    return 4;
    
  buf[fmt_hex_pad(buf, &u64, sizeof(u64))] = 0;
  if (strcmp(buf, "0000000000000000"))
    return 5;
    
  u64 = 0xffffffffffffffff;
  u64_pack = htobe64(u64);
  buf[fmt_hex_pad(buf, &u64_pack, sizeof(u64_pack))] = 0;
  if (strcmp(buf, "ffffffffffffffff"))
    return 6;
    
  return 0;
}
