/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/common.h"

int main() {
  unsigned char ip[4];
  char *s;
  int i;
  unsigned int r;
  
  s = "0.0.0.0";
  r = scan_ip4(ip, s);
  if (r != 7)
    return 1;
    
  for (i = 0; i < 4; i++)
    if (ip[i] != 0)
      return 2;
      
  s = "255.255.255.255";
  r = scan_ip4(ip, s);
  if (r != 15)
    return 3;
    
  for (i = 0; i < 4; i++)
    if (ip[i] != 255)
      return 4;
      
  s = "33.95.122.0";
  r = scan_ip4(ip, s);
  if (r != 11)
    return 5;
    
  if ((ip[0] != 33) ||
      (ip[1] != 95) ||
      (ip[2] != 122) ||
      (ip[3] != 0))
    return 6;
    
  s = "";
  r = scan_ip4(ip, s);
  if (r != 0)
    return 6;
    
  s = "a";
  r = scan_ip4(ip, s);
  if (r != 0)
    return 7;
    
  s = "0";
  r = scan_ip4(ip, s);
  if (r != 0)
    return 8;
    
  s = "0.0.0.a";
  r = scan_ip4(ip, s);
  if (r != 0)
    return 9;
    
  s = "0.0.0..0";
  r = scan_ip4(ip, s);
  if (r != 0)
    return 9;
    
  return 0;
}
