/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef SV_TIME_POSTGRESQL
#define SV_TIME_POSTGRESQL

#include <postgres.h>
#include <fmgr.h>
#include <access/hash.h>
#include "sv/tai.h"
#include "sv/taia.h"

Datum tai_add_pg(PG_FUNCTION_ARGS);
Datum tai_cmp_pg(PG_FUNCTION_ARGS);
Datum tai_eq_pg(PG_FUNCTION_ARGS);
Datum tai_gt_pg(PG_FUNCTION_ARGS);
Datum tai_gte_pg(PG_FUNCTION_ARGS);
Datum tai_in_pg(PG_FUNCTION_ARGS);
Datum tai_lt_pg(PG_FUNCTION_ARGS);
Datum tai_ne_pg(PG_FUNCTION_ARGS);
Datum tai_now_pg(PG_FUNCTION_ARGS);
Datum tai_out_pg(PG_FUNCTION_ARGS);
Datum tai_sub_pg(PG_FUNCTION_ARGS);
Datum taia_add_pg(PG_FUNCTION_ARGS);
Datum taia_cmp_pg(PG_FUNCTION_ARGS);
Datum taia_eq_pg(PG_FUNCTION_ARGS);
Datum taia_gt_pg(PG_FUNCTION_ARGS);
Datum taia_gte_pg(PG_FUNCTION_ARGS);
Datum taia_in_pg(PG_FUNCTION_ARGS);
Datum taia_lt_pg(PG_FUNCTION_ARGS);
Datum taia_ne_pg(PG_FUNCTION_ARGS);
Datum taia_now_pg(PG_FUNCTION_ARGS);
Datum taia_out_pg(PG_FUNCTION_ARGS);
Datum taia_sub_pg(PG_FUNCTION_ARGS);

#endif
