/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef SV_TIME_PYTHON_H
#define SV_TIME_PYTHON_H

#include <Python.h>
#include "sv/time.h"

/* Tai Object */
typedef struct {
  PyObject_HEAD
  tai_t t;
} TaiObject;
extern PyTypeObject  TaiType;
extern PyObject     *TaiType_Add(PyObject *, PyObject *);
extern int           TaiType_Compare(PyObject *, PyObject *);
extern int           TaiType_Init(PyObject *, PyObject *, PyObject *);
extern PyObject     *TaiType_Subtract(PyObject *, PyObject *);

/* Taia Object */
typedef struct {
  PyObject_HEAD
  taia_t t;
} TaiaObject;
extern PyTypeObject  TaiaType;
extern PyObject     *TaiaType_Add(PyObject *, PyObject *);
extern int           TaiaType_Compare(PyObject *, PyObject *);
extern PyObject     *TaiaType_Encode(PyObject *, PyObject *);
extern int           TaiaType_Init(PyObject *, PyObject *, PyObject *);
extern PyObject     *TaiaType_Subtract(PyObject *, PyObject *);

/* Module Functions */
extern PyObject     *TaiNow(PyObject *, PyObject *);
extern PyObject     *TaiaNow(PyObject *, PyObject *);

#endif
