/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/time-ruby.h"

VALUE TaiClass;
VALUE TaiaClass;

void Init_time() {
  TaiClass = rb_define_class("Tai", rb_cObject);
  rb_define_alloc_func(TaiClass, Tai_alloc);
  rb_define_method(TaiClass, "<=>", Tai_cmp, 1);
  rb_define_method(TaiClass, "==", Tai_equal, 1);
  rb_define_method(TaiClass, ">", Tai_gt, 1);
  rb_define_method(TaiClass, ">=", Tai_gte, 1);
  rb_define_method(TaiClass, "<", Tai_lt, 1);
  rb_define_method(TaiClass, "<=", Tai_lte, 1);
  rb_define_method(TaiClass, "-", Tai_sub, 1);
  rb_define_method(TaiClass, "decode", Tai_decode, 1);
  rb_define_method(TaiClass, "encode", Tai_encode, 0);
  rb_define_method(TaiClass, "init", Tai_init, 1);
  rb_define_method(TaiClass, "now", Tai_now, 0);
  rb_define_method(TaiClass, "seconds", Tai_get_seconds, 0);
  rb_define_method(TaiClass, "seconds=", Tai_set_seconds, 1);
  
  TaiaClass = rb_define_class("Taia", rb_cObject);
  rb_define_alloc_func(TaiaClass, Taia_alloc);
  rb_define_method(TaiaClass, "<=>", Taia_cmp, 1);
  rb_define_method(TaiaClass, "==", Taia_equal, 1);
  rb_define_method(TaiaClass, ">", Taia_gt, 1);
  rb_define_method(TaiaClass, ">=", Taia_gte, 1);
  rb_define_method(TaiaClass, "<", Taia_lt, 1);
  rb_define_method(TaiaClass, "<=", Taia_lte, 1);
  rb_define_method(TaiaClass, "-", Taia_sub, 1);
  rb_define_method(TaiaClass, "decode", Taia_decode, 1);
  rb_define_method(TaiaClass, "encode", Taia_encode, 0);
  rb_define_method(TaiaClass, "init", Taia_init, 3);
  rb_define_method(TaiaClass, "attoseconds", Taia_get_attoseconds, 0);
  rb_define_method(TaiaClass, "attoseconds=", Taia_set_attoseconds, 1);
  rb_define_method(TaiaClass, "nanoseconds", Taia_get_nanoseconds, 0);
  rb_define_method(TaiaClass, "nanoseconds=", Taia_set_nanoseconds, 1);
  rb_define_method(TaiaClass, "now", Taia_now, 0);
  rb_define_method(TaiaClass, "seconds", Taia_get_seconds, 0);
  rb_define_method(TaiaClass, "seconds=", Taia_set_seconds, 1);
}
