/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef SV_TIME_RUBY_H
#define SV_TIME_RUBY_H

#include <ruby.h>
#include <string.h>
#include "sv/time.h"

extern VALUE TaiClass;
extern VALUE TaiaClass;

VALUE Tai_alloc(VALUE);
VALUE Tai_cmp(VALUE, VALUE);
VALUE Tai_decode(VALUE, VALUE);
VALUE Tai_encode(VALUE);
VALUE Tai_equal(VALUE, VALUE);
VALUE Tai_get_seconds(VALUE);
VALUE Tai_gt(VALUE, VALUE);
VALUE Tai_gte(VALUE, VALUE);
VALUE Tai_init(VALUE, VALUE);
VALUE Tai_lt(VALUE, VALUE);
VALUE Tai_lte(VALUE, VALUE);
VALUE Tai_now(VALUE);
VALUE Tai_set_seconds(VALUE, VALUE);
VALUE Tai_sub(VALUE, VALUE);

VALUE Taia_alloc(VALUE);
VALUE Taia_cmp(VALUE, VALUE);
VALUE Taia_decode(VALUE, VALUE);
VALUE Taia_encode(VALUE);
VALUE Taia_equal(VALUE, VALUE);
VALUE Taia_get_attoseconds(VALUE);
VALUE Taia_get_nanoseconds(VALUE);
VALUE Taia_get_seconds(VALUE);
VALUE Taia_gt(VALUE, VALUE);
VALUE Taia_gte(VALUE, VALUE);
VALUE Taia_init(VALUE, VALUE, VALUE, VALUE);
VALUE Taia_lt(VALUE, VALUE);
VALUE Taia_lte(VALUE, VALUE);
VALUE Taia_now(VALUE);
VALUE Taia_set_attoseconds(VALUE, VALUE);
VALUE Taia_set_nanoseconds(VALUE, VALUE);
VALUE Taia_set_seconds(VALUE, VALUE);
VALUE Taia_sub(VALUE, VALUE);

#endif
