/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/time-private.h"
#include "sv/caldate.h"
#include "sv/caltime.h"

unsigned int caltime_fmt(char *s, caltime_t *ct) {
  unsigned int result;
  long x;
  
  result = caldate_fmt(s, &ct->date);
  
  if (s) {
    s += result;
    
    x = ct->hour;
    s[0] = ' ';
    s[2] = '0' + (x % 10);
    x /= 10;
    s[1] = '0' + (x % 10);
    s += 3;
    
    x = ct->minute;
    s[0] = ':';
    s[2] = '0' + (x % 10);
    x /= 10;
    s[1] = '0' + (x % 10);
    s += 3;
    
    x = ct->second;
    s[0] = ':';
    s[2] = '0' + (x % 10);
    x /= 10;
    s[1] = '0' + (x % 10);
    s += 3;
    
    s[0] = ' ';
    x = ct->offset;
    if (x < 0) {
      s[1] = '-';
      x = -x;
    } else
      s[1] = '+';
      
    s[5] = '0' + (x % 10);
    x /= 10;
    s[4] = '0' + (x % 6);
    x /= 6;
    s[3] = '0' + (x % 10);
    x /= 10;
    s[2] = '0' + (x % 10);
  }
  
  return result + 15;
}
