/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <string.h>
#include <unistd.h>
#include "sv/caldate.h"

int main() {
  caldate_t cd;
  char buf[100];
  unsigned int len;
  
  cd.year = 2009;
  cd.month = 1;
  cd.day = 1;
  
  /* Check caldate_fmt writes out a positive value. */
  buf[caldate_fmt(&buf[0], &cd)] = 0;
  if (strcmp(buf, "2009-01-01"))
    return 1;
  /* Check caldate_fmt returns the same value even when the string is 0. */
  if (caldate_fmt(0, &cd) != strlen(buf))
    return 2;
    
  cd.year = -1;
  cd.month = 1;
  cd.day = 1;
  
  /* Check caldate_fmt writes out a negative value. */
  buf[caldate_fmt(&buf[0], &cd)] = 0;
  if (strcmp(buf, "-1-01-01"))
    return 3;
  /* Check caldate_fmt returns the same value even when the string is 0. */
  if (caldate_fmt(0, &cd) != strlen(buf))
    return 4;
    
  return 0;
}
