/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv/taia.h"

int main() {
  char buf[TAI64NA_ENCODE_SIZE];
  taia_t t = TAIA_INIT;
  taia_t u = TAIA_INIT;
  char pt[TAIA_PACK_SIZE];
  char pu[TAIA_PACK_SIZE];
  
  t.sec = UINT64_MAX;
  t.nano = UINT32_MAX;
  t.atto = UINT32_MAX;
  
  int i;
  for (i = 0; i <= 32; i++) {
    taia_pack(pt, &t);
    tai64na_encode(buf, pt);
    tai64na_decode(pu, buf);
    taia_unpack(&u, pu);
    
    if (taia_cmp(&t, &u) != 0)
      return 1;
      
    t.sec >>= 2;
    t.nano >>= 1;
    t.atto >>= 1;
  }
  
  t.sec = UINT64_MAX;
  t.nano = UINT32_MAX;
  t.atto = UINT32_MAX;
  
  for (i = 0; i <= 32; i++) {
    taia_pack(pt, &t);
    tai64na_encode(buf, pt);
    tai64na_decode(pu, buf);
    taia_unpack(&u, pu);
    
    if (taia_cmp(&t, &u) != 0)
      return 1;
    t.sec <<= 2;
    t.nano <<= 1;
    t.atto <<= 1;
  }
  
  return 0;
}
