/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef SV_PYTHON_H
#define SV_PYTHON_H

#include <Python.h>
#include <sv.h>

extern PyObject *ServiceException;

/* Service Object */
typedef struct {
  PyObject_HEAD
  PyObject *path;
} ServiceObject;
extern PyTypeObject  ServiceType;
extern PyObject *ServiceType_Control(PyObject *, PyObject *);
extern void      ServiceType_Dealloc(PyObject *);
extern PyObject *ServiceType_Down(PyObject *, PyObject *);
extern PyObject *ServiceType_Exit(PyObject *, PyObject *);
extern PyObject *ServiceType_GetStatus(PyObject *, void *);
extern int       ServiceType_Init(PyObject *, PyObject *, PyObject *);
extern PyObject *ServiceType_New(PyTypeObject *, PyObject *, PyObject *);
extern PyObject *ServiceType_Sigalrm(PyObject *, PyObject *);
extern PyObject *ServiceType_Sigcont(PyObject *, PyObject *);
extern PyObject *ServiceType_Sighup(PyObject *, PyObject *);
extern PyObject *ServiceType_Sigint(PyObject *, PyObject *);
extern PyObject *ServiceType_Sigkill(PyObject *, PyObject *);
extern PyObject *ServiceType_Sigstop(PyObject *, PyObject *);
extern PyObject *ServiceType_Sigterm(PyObject *, PyObject *);
extern PyObject *ServiceType_Up(PyObject *, PyObject *);
extern PyObject *ServiceType_UpOnce(PyObject *, PyObject *);

/* ServiceStatus Object */
typedef struct {
  PyObject_HEAD
  sv_stat_t svst;
} ServiceStatusObject;
extern PyTypeObject  ServiceStatusType;
extern PyObject *ServiceStatusType_GetTimestamp(PyObject *, void *);

#endif
