/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <Python.h>
#include <structmember.h>
#include "sv-python.h"

static PyGetSetDef ServiceStatusType_GetSet[] = {
  { "timestamp", ServiceStatusType_GetTimestamp, 0, "status timestamp" },
  { NULL }
};

static PyMemberDef ServiceStatusType_Members[] = {
  { "autostart", T_INT, offsetof(ServiceStatusObject, svst.autostart), 0, "autostart" },
  { "pid",       T_INT, offsetof(ServiceStatusObject, svst.pid),       0, "pid" },
  { "paused",    T_INT, offsetof(ServiceStatusObject, svst.paused),    0, "paused" },
  { "mode",      T_INT, offsetof(ServiceStatusObject, svst.mode),      0, "mode" },
  { NULL }
};

PyTypeObject ServiceStatusType = {
  PyObject_HEAD_INIT(NULL)
  0,                           /* ob_size */
  "sv.Service",                /* tp_name */
  sizeof(ServiceStatusObject), /* tp_basicsize */
  0,                           /* tp_itemsize */
  0,                           /* tp_dealloc */
  0,                           /* tp_print */
  0,                           /* tp_getattr */
  0,                           /* tp_setattr */
  0,                           /* tp_compare */
  0,                           /* tp_repr */
  0,                           /* tp_as_number */
  0,                           /* tp_as_sequence */
  0,                           /* tp_as_mapping */
  0,                           /* tp_hash */
  0,                           /* tp_call */
  0,                           /* tp_str */
  0,                           /* tp_getattro */
  0,                           /* tp_setattro */
  0,                           /* tp_as_buffer */
  Py_TPFLAGS_DEFAULT,          /* tp_flags */
  "ServiceStatus object",      /* tp_doc */
  0,                           /* tp_traverse */
  0,                           /* tp_clear */
  0,                           /* tp_richcompare */
  0,                           /* tp_weaklistoffset */
  0,                           /* tp_iter */
  0,                           /* tp_iterext */
  0,                           /* tp_methods */
  ServiceStatusType_Members,   /* tp_members */
  ServiceStatusType_GetSet,    /* tp_getset */
  0,                           /* tp_base */
  0,                           /* tp_dict */
  0,                           /* tp_descr_get */
  0,                           /* tp_descr_set */
  0,                           /* tp_dictoffset */
  0,                           /* tp_init */
  0,                           /* tp_alloc */
  PyType_GenericNew,           /* tp_new */
  0,                           /* tp_free */
  0,                           /* tp_is_gc */
  0,                           /* tp_bases */
  0,                           /* tp_mro */
  0,                           /* tp_cache */
  0,                           /* tp_subclasses */
  0                            /* tp_weaklist */
};
