/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv-ruby.h"

VALUE ServiceClass;
VALUE ServiceError;
VALUE ServiceStatusClass;

void Init_sv() {
  rb_require("sv/time");
  
  ServiceError = rb_define_class("ServiceError", rb_eStandardError);
  
  ServiceClass = rb_define_class("Service", rb_cObject);
  rb_define_method(ServiceClass, "control", Service_control, 1);
  rb_define_method(ServiceClass, "down", Service_down, 0);
  rb_define_method(ServiceClass, "exit", Service_exit, 0);
  rb_define_method(ServiceClass, "initialize", Service_initialize, 1);
  rb_define_method(ServiceClass, "path", Service_get_path, 0);
  rb_define_method(ServiceClass, "path=", Service_set_path, 1);
  rb_define_method(ServiceClass, "sigalrm", Service_sigalrm, 0);
  rb_define_method(ServiceClass, "sigcont", Service_sigcont, 0);
  rb_define_method(ServiceClass, "sighup", Service_sighup, 0);
  rb_define_method(ServiceClass, "sigint", Service_sigint, 0);
  rb_define_method(ServiceClass, "sigkill", Service_sigkill, 0);
  rb_define_method(ServiceClass, "sigstop", Service_sigstop, 0);
  rb_define_method(ServiceClass, "sigterm", Service_sigterm, 0);
  rb_define_method(ServiceClass, "status", Service_get_status, 0);
  rb_define_method(ServiceClass, "up", Service_up, 0);
  rb_define_method(ServiceClass, "up_once", Service_up_once, 0);
  
  ServiceStatusClass = rb_define_class("ServiceStatus", rb_cObject);
  rb_define_method(ServiceStatusClass, "mode", ServiceStatus_get_mode, 0);
  rb_define_method(ServiceStatusClass, "mode=", ServiceStatus_set_mode, 1);
  rb_define_method(ServiceStatusClass, "paused", ServiceStatus_get_paused, 0);
  rb_define_method(ServiceStatusClass, "paused=", ServiceStatus_set_paused, 1);
  rb_define_method(ServiceStatusClass, "pid", ServiceStatus_get_pid, 0);
  rb_define_method(ServiceStatusClass, "pid=", ServiceStatus_get_pid, 1);
  rb_define_method(ServiceStatusClass, "timestamp", ServiceStatus_get_timestamp, 0);
  rb_define_method(ServiceStatusClass, "timestamp=", ServiceStatus_set_timestamp, 0);
}
