/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "sv-ruby.h"

VALUE Service_get_status(VALUE self) {
  VALUE error;
  int r;
  VALUE status = rb_class_new_instance(0, 0, rb_path2class("ServiceStatus"));
  sv_stat_t svst;
  VALUE taia = rb_class_new_instance(0, 0, rb_path2class("Taia"));
  taia_t *t;
  
  r = sv_stat(&svst, RSTRING_PTR(rb_iv_get(self, "@path")));
  if (r) {
    error = rb_exc_new2(ServiceError, sv_error_str(r));
    rb_exc_raise(error);
  }
  
  Data_Get_Struct(taia, taia_t, t);
  memcpy(t, &svst.timestamp, sizeof(taia_t));
  
  rb_iv_set(status, "@mode", svst.mode ? rb_str_new((char*)&svst.mode, 1) : rb_str_new("", 0));
  rb_iv_set(status, "@paused", svst.paused ? Qtrue : Qfalse);
  rb_iv_set(status, "@pid", INT2NUM(svst.pid));
  rb_iv_set(status, "@timestamp", taia);
  
  return status;
}
