/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef SV_RUBY_H
#define SV_RUBY_H

#include <errno.h>
#include <ruby.h>
#include <string.h>
#include <sv.h>

extern VALUE ServiceClass;
extern VALUE ServiceError;
extern VALUE ServiceStatusClass;

VALUE Service_control(VALUE, VALUE);
VALUE Service_down(VALUE);
VALUE Service_exit(VALUE);
VALUE Service_get_path(VALUE);
VALUE Service_get_status(VALUE);
VALUE Service_initialize(VALUE, VALUE);
VALUE Service_set_path(VALUE, VALUE);
VALUE Service_sigalrm(VALUE);
VALUE Service_sigcont(VALUE);
VALUE Service_sighup(VALUE);
VALUE Service_sigint(VALUE);
VALUE Service_sigkill(VALUE);
VALUE Service_sigstop(VALUE);
VALUE Service_sigterm(VALUE);
VALUE Service_up(VALUE);
VALUE Service_up_once(VALUE);

VALUE ServiceStatus_get_mode(VALUE);
VALUE ServiceStatus_set_mode(VALUE, VALUE);
VALUE ServiceStatus_get_paused(VALUE);
VALUE ServiceStatus_set_paused(VALUE, VALUE);
VALUE ServiceStatus_get_pid(VALUE);
VALUE ServiceStatus_set_pid(VALUE, VALUE);
VALUE ServiceStatus_get_timestamp(VALUE);
VALUE ServiceStatus_set_timestamp(VALUE, VALUE);

#endif
