/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <dirent.h>
#include <errno.h>
#include "multilog.h"

int filesfit(struct cyclog *d) {
  DIR *dir;
  struct dirent *x;
  int count;
  int i;
  
  dir = opendir(".");
  if (!dir)
    return -1;
    
  fn[0] = '@';
  fn[1] = 'z';
  fn[2] = 0;
  
  count = 0;
  for (;;) {
    errno = 0;
    x = readdir(dir);
    if (!x)
      break;
    if (x->d_name[0] == '@')
      if (strlen(x->d_name) >= 25) {
        ++count;
        if (strcmp(x->d_name, fn) < 0) {
          for (i = 0; i < 25; ++i)
            fn[i] = x->d_name[i];
          fn[25] = 0;
        }
      }
  }
  if (errno) {
    closedir(dir);
    return -1;
  }
  closedir(dir);
  
  if (count < d->num)
    return 1;
    
  dir = opendir(".");
  if (!dir)
    return -1;
    
  for (;;) {
    errno = 0;
    x = readdir(dir);
    if (!x)
      break;
    if (x->d_name[0] == '@') {
      if (strlen(x->d_name) >= 25) {
        if (strncmp(x->d_name, fn, strlen(fn))) {
          unlink(x->d_name);
          break;
        }
      }
    }
  }
  if (errno) {
    closedir(dir);
    return -1;
  }
  closedir(dir);
  return 0;
}
