/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef SV_MULTILOG_H
#define SV_MULTILOG_H

#include <unistd.h>
#include <sv/bio.h>

#define FATAL "multilog: fatal: "
#define WARNING "multilog: warning: "

struct cyclog {
  char           buf[512];
  bio_t          ss;
  int            fdcurrent;
  unsigned long  bytes;
  unsigned long  num;
  unsigned long  size;
  char          *processor;
  char          *dir;
  int            fddir;
  int            fdlock;
  int            flagselected;
};

void c_init(char **);
void c_quit();
ssize_t c_write(int, char *, int);
void f_init(char **);
int filesfit(struct cyclog *);
void finish(struct cyclog *, char *, char *);
ssize_t flushread(int, char *, int);
void fullcurrent(struct cyclog *);
int match(const char *, const char *, unsigned int);
void pause3(char *, char *, char *);
void pause5(char *, char *, char *, char *, char *);
void restart(struct cyclog *);
void startprocessor(struct cyclog *);

extern struct cyclog *c;
extern int cnum;
extern int *f;
extern int fdstartdir;
extern int flagexitasap;
extern int flagforcerotate;
extern int flagnewline;
extern char fn[40];

#endif
