/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <sv/file.h>
#include <sv/sig.h>
#include "multilog.h"

extern char **environ;

void startprocessor(struct cyclog *d) {
  char *args[4];
  int fd;
  
  sig_uncatch(SIGTERM);
  sig_uncatch(SIGALRM);
  sig_unblock(SIGTERM);
  sig_unblock(SIGALRM);
  
  fd = open_read("previous");
  if (fd == -1)
    return;
  if (fd_move(0, fd) == -1)
    return;
    
  fd = open_trunc("processed");
  if (fd == -1)
    return;
  if (fd_move(1, fd) == -1)
    return;
    
  fd = open_read("state");
  if (fd == -1)
    return;
  if (fd_move(4, fd) == -1)
    return;
    
  fd = open_trunc("newstate");
  if (fd == -1)
    return;
  if (fd_move(5, fd) == -1)
    return;
    
  args[0] = "sh";
  args[1] = "-c";
  args[2] = d->processor;
  args[3] = 0;
  
  execve("/bin/sh", args, environ);
}
