/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef SV_SUPERVISE_H
#define SV_SUPERVISE_H

#include <sv.h>

#define FATAL "supervise: fatal: "
#define WARNING "supervise: warning: "

struct supervise_config {
  char *service_path;
};

struct supervise_status {
  int fd_control;        /* supervise/control fifo file descriptor */
  int fd_control_write;  /* supervise/control fifo write fd */
  int fd_lock;           /* supervise/lock file descriptor */
  int fd_ok;             /* supervise/ok fifo file descriptor */
  int flag_down;         /* set when the service is down */
  int flag_exit;         /* set when supervise should exit */
  int flag_paused;       /* set when the service is paused */
  int flag_want;         /* set when an operation is in progress */
  int pid;               /* service pid */
  int pipe[2];           /* nofity pipe */
};

extern struct supervise_config config;
extern struct supervise_status status;

void config_init();
void main_loop();
void start();
void status_init();
void trigger();
void update_status();

#endif
