/*
 * Copyright (c) 2011-2015 David Shane Holden. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <unistd.h>
#include <sv/bio.h>
#include <sv/file.h>
#include <sv/strerr.h>
#include "svstat.h"

void usage() {
  strerr_die1x(100,
               "\n"
               "svstat: usage: svstat dir1 [ ... dirX ]\n"
              );
}

int main(int argc, char **argv) {
  char *dirname;
  int fdodir;
  
  if (!*argv || !*++argv)
    usage();
    
  fdodir = open_read(".");
  if (fdodir == -1)
    strerr_die2sys(111, FATAL, "unable to open current directory: ");
    
  while ((dirname = *argv++)) {
    handle(dirname);
    bio_put_str(bio_1, "\n");
    if (fchdir(fdodir) == -1)
      strerr_die2sys(111, FATAL, "unable to set directory: ");
  }
  
  bio_flush(bio_1);
  _exit(0);
}
