/* -*- coding: utf-8; tab-width: 2; indent-tabs-mode: t -*- */
/*
 *   Copyright 2013 Daniel Trebbien
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <verlibc/string.h>

void * memchr(const void *bv, int c, size_t n)
{
	size_t i;
	const unsigned char *b = (const unsigned char *) bv;

	for (i = 0; i < n; ++i)
		_(invariant \forall size_t j; j < i ==> b[j] != ((unsigned char) c))
	{
		if (b[i] == ((unsigned char) c))
		{
			_(assert ((unsigned char *) bv) + i != 0)
			return ((unsigned char *) bv) + i;
		}
	}

	return (unsigned char *) 0;
}

#ifdef VERIFY
static void memchr_test1()
{
	const unsigned char buf[4] = { '\0', 'a', '3', '4' };
	const void *bv = buf;
	
	unsigned char *p = (unsigned char *) memchr(bv, '4', 3);
	_(assert p == 0)
	
	p = (unsigned char *) memchr(bv, '4', 4);
	_(assert p != 0)
	_(assert p == buf + 3)
}
#endif
