/* -*- coding: utf-8; tab-width: 2; indent-tabs-mode: t -*- */
/*
 *   Copyright 2013 Daniel Trebbien
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <verlibc/string.h>

void * memcpy(void *__restrict dv, const void *__restrict sv, size_t n)
{
	size_t i;
	char *d = (char *) dv;
	const char *s = (const char *) sv;

	for (i = 0; i < n; ++i)
		_(invariant \forall size_t j; j < i ==> d[j] == s[j])
	{
		d[i] = s[i];
	}

	return dv;
}

#ifdef VERIFY
static void memcpy_test1()
{
	char dest[8], *d;
	const char src[4] = { 'a', 'b', 'c', 'd' };

	d = (char *) memcpy(dest, src, 4);

	_(assert d == dest)
	_(assert dest[0] == 'a')
	_(assert d[3] == 'd')
}
#endif
