/* -*- coding: utf-8; tab-width: 2; indent-tabs-mode: t -*- */
/*
 *   Copyright 2013 Daniel Trebbien
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <verlibc/string.h>

void * memset(void *dv, int c, size_t n)
{
	size_t i;
	unsigned char *s = (unsigned char *) dv;

	for (i = 0; i < n; ++i)
		_(invariant \forall size_t j; j < i ==> s[j] == (unsigned char) c)
	{
		s[i] = (unsigned char) c;
	}

	return dv;
}

#ifdef VERIFY
static void memset_test1()
{
	unsigned char buf[4] = { 'a', 'b', 'c', 'd' };
	unsigned char *b = memset(buf, '8', 4);

	_(assert b == buf)
	_(assert buf[0] == '8')
	_(assert b[1] == '8')
}
#endif
