/* -*- coding: utf-8; tab-width: 2; indent-tabs-mode: t -*- */
/*
 *   Copyright 2013 Daniel Trebbien
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <verlibc/string.h>

char * strcat(char *__restrict b, const char *__restrict str
		_(ghost size_t b_nul_pos) _(ghost size_t str_nul_pos))
{
	size_t i, j;

	for (i = 0; b[i] != '\0'; ++i)
		_(invariant i <= strlen(b, b_nul_pos))
	{
	}

	_(ghost size_t old_b_length = strlen(b, b_nul_pos))
	_(assert old_b_length == \old(strlen(b, b_nul_pos)))
	_(assert i == old_b_length)

	_(ghost size_t str_length = strlen(str, str_nul_pos))

	_(assert i <= b_nul_pos)
	for (j = 0; str[j] != '\0'; ++i, ++j)
		_(invariant j <= str_length)
		_(invariant \forall size_t k; k <= str_nul_pos ==> \unchanged(str[k]))
		_(invariant i == old_b_length + j)
		_(invariant old_b_length <= i && i <= b_nul_pos + str_nul_pos)
		_(invariant i <= old_b_length + str_length)
		_(invariant \forall size_t k; k < old_b_length ==> \unchanged(b[k]))
		_(invariant \forall size_t k; old_b_length <= k && k < i ==> b[k] == str[k - old_b_length])
		_(invariant \forall size_t k; i < k && k < b_nul_pos + str_nul_pos + 1 ==> \unchanged(b[k]))
	{
		b[i] = str[j];
	}

	b[i] = '\0';

	return b;
}

#ifdef VERIFY
static void strcat_test1()
{
	char buf[3] = { 'a', '\0', '\0' };
	const char str[2] = { 'b', '\0' };

	char *b = strcat(buf, str _(ghost 1) _(ghost 1));

	_(assert b[0] == 'a')
	_(assert b[1] == 'b')
	_(assert b[2] == '\0')
}
#endif
