/* -*- coding: utf-8; tab-width: 2; indent-tabs-mode: t -*- */
/*
 *   Copyright 2013 Daniel Trebbien
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <verlibc/string.h>

char *strchr(const char *str, int c _(ghost size_t nul_pos))
{
	size_t i;

	for (i = 0; str[i] != '\0'; ++i)
		_(invariant i <= strlen(str, nul_pos))
		_(invariant \forall size_t j; j < i ==> str[j] != (char) c)
	{
		if (str[i] == (char) c)
		{
			_(assert str + i != 0)
			return str + i;
		}
	}

	_(assert i == strlen(str, nul_pos))

	if ((char) c == '\0')
	{
		_(assert str[strlen(str, nul_pos)] == '\0')
		_(assert str + i != 0)
		return str + i;
	}

	return 0;
}

#ifdef VERIFY
static void strchr_test1()
{
	const char str[] = { 'a', '\0', 'b', '\0' };

	char *p = strchr(str, 'b' _(ghost 3));
	_(assert p == 0)

	p = strchr(str, '\0' _(ghost 3));
	_(assert p == str + 1)
}
#endif
