/* -*- coding: utf-8; tab-width: 2; indent-tabs-mode: t -*- */
/*
 *   Copyright 2013 Daniel Trebbien
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <verlibc/string.h>

size_t strlen(const char *str _(ghost size_t nul_lim))
{
	size_t i = 0;

	for (; str[i] != '\0'; ++i)
		_(invariant i <= nul_lim)
		_(invariant \forall size_t j; j < i ==> str[j] != '\0')
		_(invariant strlen(str, nul_lim) == i + strlen(str + i, nul_lim - i))
	{
		_(assert str[i] != '\0')
	}

	_(assert str[i] == '\0')

	return i;
}

#ifdef VERIFY
static void strlen_test1()
{
	//const char str[13] = "hello\0world!";
	const char str[13] = { 'h', 'e', 'l', 'l', 'o', '\0', 'w', 'o', 'r', 'l', 'd', '!', '\0' };
	size_t len = strlen(str _(ghost 12));

	_(assert len == 5)
}
#endif
