/* -*- coding: utf-8; tab-width: 2; indent-tabs-mode: t -*- */
/*
 *   Copyright 2013 Daniel Trebbien
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <verlibc/string.h>

char *strrchr(const char *str, int c _(ghost size_t nul_pos))
{
	size_t i;
	char *p = 0;

	for (i = 0; 1; ++i)
		_(invariant i <= strlen(str, nul_pos))
		_(invariant p == 0 <==> (\forall size_t j; j < i ==> str[j] != (char) c))
		_(invariant p != 0 ==> ((size_t) (p - str)) < i && str[p - str] == (char) c)
		_(invariant p != 0 ==> (\forall size_t j; ((size_t) (p - str)) < j && j < i ==> str[j] != (char) c))
		_(invariant p != 0 ==> *p == (char) c)
		_(invariant p != 0 ==> (\forall size_t k; k < i && (\forall size_t j; k < j && j <= strlen(str, nul_pos) ==> str[j] != (char) c) && str[k] == (char) c ==> p == str + k))
	{
		if (str[i] == (char) c)
		{
			p = str + i;
			_(assert p != 0)
		}

		if (str[i] == '\0')
			break;
	}

	_(assert i == strlen(str, nul_pos))
	return p;
}

#ifdef VERIFY
static void strrchr_test1()
{
	const char str[] = { 'a', 'b', 'c', 'b', 'a', 'a', 'd', '\0' };
	_(assert strrchr(str, 'a', 7) == str + 5)
}
#endif
