
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

unsigned int maxadd;


char gstring[80];
char newline[1024];
unsigned char hexline[1024];

#define ROMMASK 0xFFF
unsigned int rom[(ROMMASK+1)>>2];
#define ROMBYTESMASK 0x3FFF
unsigned char rombytes[ROMBYTESMASK+1];

//-----------------------------------------------------------------------------
int readhex ( FILE *fp )
{
    unsigned int addhigh;
    unsigned int add;
    unsigned int ra;
    unsigned int line;
    unsigned char checksum;
    unsigned int len;
    unsigned int hexlen;
    unsigned char t;

    maxadd=0;

    addhigh=0;
    memset(rombytes,0xFF,sizeof(rombytes));

    line=0;
    while(fgets(newline,sizeof(newline)-1,fp))
    {
        line++;
        //printf("%s",newline);
        if(newline[0]!=':')
        {
            printf("Syntax error <%u> no colon\n",line);
            continue;
        }
        gstring[0]=newline[1];
        gstring[1]=newline[2];
        gstring[2]=0;
        len=strtoul(gstring,NULL,16);
        for(ra=0;ra<(len+5);ra++)
        {
            gstring[0]=newline[(ra<<1)+1];
            gstring[1]=newline[(ra<<1)+2];
            gstring[2]=0;
            hexline[ra]=(unsigned char)strtoul(gstring,NULL,16);
        }
        checksum=0;
        for(ra=0;ra<(len+5);ra++) checksum+=hexline[ra];
        //checksum&=0xFF;
        if(checksum)
        {
            printf("checksum error <%u>\n",line);
        }
        add=hexline[1]; add<<=8;
        add|=hexline[2];
        add|=addhigh;
        if(add>=ROMBYTESMASK)
        {
            printf("address too big 0x%08X\n",add);
            return(1);
            continue;
        }
        t=hexline[3];

        //:0011223344
        //;llaaaattdddddd
        //01234567890
        switch(t)
        {
            default:
                printf("UNKOWN type %02X <%u>\n",t,line);
                break;
            case 0x00:
                for(ra=0;ra<len;ra++)
                {
                    if(add>=ROMBYTESMASK)
                    {
                        printf("address too big 0x%08X\n",add);
                        return(1);
                    }
                    rombytes[add]=hexline[ra+4];
                    add++;
                    if(add>maxadd) maxadd=add;
                }
                break;
            case 0x01:
                printf("End of data\n");
                break;
            case 0x02:
                addhigh=hexline[5];
                addhigh<<=8;
                addhigh|=hexline[4];
                addhigh<<=16;
                break;
        }
    }

    add=0;
    for(ra=0;ra<=ROMMASK;ra++)
    {
        rom[ra] =rombytes[add++]; rom[ra]<<=8;
        rom[ra]|=rombytes[add++]; rom[ra]<<=8;
        rom[ra]|=rombytes[add++];
    }

    //printf("%u lines processed\n",line);
    printf("%08X\n",maxadd);



    return(0);

}

int diss ( unsigned int add, unsigned int inst )
{
    unsigned int rd;
    unsigned int rb;
    unsigned int pc_next;

    printf("0x%03X: 0x%05X  ",add,inst);

//76 5432 1098 7654 3210
//00 000d dddd bbbb b000 sub rd,rb       rd = rd - rb        CZ
    if((inst&0x3E007)==0x00000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("sub r%u,r%u\n",rd,rb);
        return(0);
    }
//00 001d dddd cccc cccc subi rd,const   rd = rd - const     CZ
    if((inst&0x3E000)==0x02000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("subi r%u,0x%02X\n",rd,rb);
        return(0);
    }
//00 010d dddd bbbb b000 subc rd,rb      rd = rd - rb - c    CZ
    if((inst&0x3E007)==0x04000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("subc r%u,r%u\n",rd,rb);
        return(0);
    }
//00 011d dddd cccc cccc subic rd,const  rd = rd - const -c  CZ
    if((inst&0x3E000)==0x03000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("subic r%u,0x%02X\n",rd,rb);
        return(0);
    }
//00 100d dddd bbbb b000 add rd,rb       rd = rd + rb        CZ
    if((inst&0x3E007)==0x08000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("add r%u,r%u\n",rd,rb);
        return(0);
    }
//00 101d dddd cccc cccc addi rd,const   rd = rd + const     CZ
    if((inst&0x3E000)==0x0A000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("addi r%u,0x%02X\n",rd,rb);
        return(0);
    }
//00 110d dddd bbbb b000 addc rd,rb      rd = rd + rb + c    CZ
    if((inst&0x3E007)==0x0C000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("addc r%u,r%u\n",rd,rb);
        return(0);
    }
//00 111d dddd cccc cccc addic rd,const  rd = rd + const + c CZ
    if((inst&0x3E000)==0x0E000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("addic r%u,0x%02X\n",rd,rb);
        return(0);
    }
//01 000d dddd bbbb b000 mov rd,rb       rd = rb
    if((inst&0x3E007)==0x10000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("mov r%u,r%u\n",rd,rb);
        return(0);
    }
//01 001d dddd cccc cccc movi rd,const   rd = const
    if((inst&0x3E000)==0x12000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("movi r%u,0x%02X\n",rd,rb);
        return(0);
    }
//01 010d dddd bbbb b000 and rd,rb       rd = rd & rb        Z
    if((inst&0x3E007)==0x14000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("and r%u,r%u\n",rd,rb);
        return(0);
    }
//01 011d dddd cccc cccc andi rd,const   rd = rd & const     Z
    if((inst&0x3E000)==0x16000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("andi r%u,0x%02X\n",rd,rb);
        return(0);
    }
//01 100d dddd bbbb b000 or rd,rb        rd = rd | rb        Z
    if((inst&0x3E007)==0x18000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("or r%u,r%u\n",rd,rb);
        return(0);
    }
//01 101d dddd cccc cccc ori rd,const    rd = rd | const     Z
    if((inst&0x3E000)==0x1A000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("ori r%u,0x%02X\n",rd,rb);
        return(0);
    }
//01 110d dddd bbbb b000 xor rd,rb       rd = rd ^ rb        Z
    if((inst&0x3E007)==0x1C000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("xor r%u,r%u\n",rd,rb);
        return(0);
    }
//01 111d dddd cccc cccc xori rd,const   rd = rd ^ const     Z
    if((inst&0x3E000)==0x1E000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("xori r%u,0x%02X\n",rd,rb);
        return(0);
    }
//10 000d dddd bbbb b000 cmp rd,rb       rd - rb             CZ
    if((inst&0x3E007)==0x20000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("cmp r%u,r%u\n",rd,rb);
        return(0);
    }
//10 001d dddd cccc cccc cmpi rd,const   rd - const          CZ
    if((inst&0x3E000)==0x22000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("cmpi r%u,0x%02X\n",rd,rb);
        return(0);
    }
//10 010d dddd bbbb b000 test rd,rb      rd & rb             Z
    if((inst&0x3E007)==0x24000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("test r%u,r%u\n",rd,rb);
        return(0);
    }
//10 011d dddd cccc cccc testi rd,const  rd & const          Z
    if((inst&0x3E000)==0x26000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>0)&0xFF;
        printf("testi r%u,0x%02X\n",rd,rb);
        return(0);
    }
//10 100d dddd bbbb b000 ror rd,rb                           Z
    if((inst&0x3E007)==0x28000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("ror r%u,r%u\n",rd,rb);
        return(0);
    }
//10 100d dddd bbbb b001 rol rd,rb                           Z
    if((inst&0x3E007)==0x28001)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("rol r%u,r%u\n",rd,rb);
        return(0);
    }
//10 100d dddd bbbb b010 rorc rd,rb                          CZ
    if((inst&0x3E007)==0x28002)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("rorc r%u,r%u\n",rd,rb);
        return(0);
    }
//10 100d dddd bbbb b011 rolc rd,rb                          CZ
    if((inst&0x3E007)==0x28003)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("rolc r%u,r%u\n",rd,rb);
        return(0);
    }
//10 1100 0000 0000 0000 clrc            clear carry
    if(inst==0x2C000)
    {
        printf("clrc\n");
        return(0);
    }
//10 1100 0000 0000 0001 setc            set carry
    if(inst==0x2C001)
    {
        printf("setc\n");
        return(0);
    }
//10 1100 0000 0000 0010 clrz            clear zero
    if(inst==0x2C002)
    {
        printf("clrz\n");
        return(0);
    }
//10 1100 0000 0000 0011 setz            set zero
    if(inst==0x2C003)
    {
        printf("setz\n");
        return(0);
    }
//10 1100 0000 0000 0100 clri            disable interrupts
    if(inst==0x2C004)
    {
        printf("clri\n");
        return(0);
    }
//10 1100 0000 0000 0101 seti            enable interrupts
    if(inst==0x2C005)
    {
        printf("seti\n");
        return(0);
    }
//10 111d dddd bbbb b010 exporti rd,rb    (port rb) = rd
    if((inst&0x3E007)==0x2E002)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("exporti r%u,r%u\n",rd,rb);
        return(0);
    }
//10 111d dddd bbbb b011 importi rd,rb   rd = (port rb)
    if((inst&0x3E007)==0x2E003)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("importi r%u,r%u\n",rd,rb);
        return(0);
    }
//10 111d dddd bbbb b110 sspi rd,rb      (rb) = rd
    if((inst&0x3E007)==0x2E006)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("sspi r%u,r%u\n",rd,rb);
        return(0);
    }
//10 111d dddd bbbb b111 lspi rd,rb      rd = (rb)
    if((inst&0x3E007)==0x2E007)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("lspi r%u,r%u\n",rd,rb);
        return(0);
    }
//10 111d dddd pppp p000 export rd,port  (port) = rd
    if((inst&0x3E007)==0x2E000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("export r%u,0x%02X\n",rd,rb);
        return(0);
    }
//10 111d dddd pppp p001 import rd,port  rd = (port)
    if((inst&0x3E007)==0x2E001)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("import r%u,0x%02X\n",rd,rb);
        return(0);
    }
//10 111d dddd ssss s100 ssp rd,ss       (sp) = rd
    if((inst&0x3E007)==0x2E004)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("ssp 0x%02X,r%u\n",rd,rb);
        return(0);
    }
//10 111d dddd ssss s101 lsp rd,ss       rd = (sp)
    if((inst&0x3E007)==0x2E005)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
        printf("lsp r%u,0x%02X\n",rd,rb);
        return(0);
    }
//11 0000 llll llll llll bz label
    if((inst&0x3F000)==0x30000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("bz 0x%03X\n",pc_next);
        return(0);
    }
//11 0001 llll llll llll bnz label
    if((inst&0x3F000)==0x31000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("bnz 0x%03X\n",pc_next);
        return(0);
    }
//11 0010 llll llll llll bc label
    if((inst&0x3F000)==0x32000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("bc 0x%03X\n",pc_next);
        return(0);
    }
//11 0011 llll llll llll bnc label
    if((inst&0x3F000)==0x33000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("bnc 0x%03X\n",pc_next);
        return(0);
    }
//11 0100 llll llll llll callz label
    if((inst&0x3F000)==0x34000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("callz 0x%03X\n",pc_next);
        return(0);
    }
//11 0101 llll llll llll callnz label
    if((inst&0x3F000)==0x35000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("callnz 0x%03X\n",pc_next);
        return(0);
    }
//11 0110 llll llll llll callc label
    if((inst&0x3F000)==0x36000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("callc 0x%03X\n",pc_next);
        return(0);
    }
//11 0111 llll llll llll callnc label
    if((inst&0x3F000)==0x37000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("callnc 0x%03X\n",pc_next);
        return(0);
    }
//11 1000 llll llll llll call label
    if((inst&0x3F000)==0x38000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("call 0x%03X\n",pc_next);
        return(0);
    }
//11 1001 0000 0000 0000 ret
    if(inst==0x39000)
    {
        printf("ret\n");
        return(0);
    }
//11 1010 0000 0000 0000 iret
    if(inst==0x3A000)
    {
        printf("iret\n");
        return(0);
    }
//11 1011 llll llll llll b label
    if((inst&0x3F000)==0x3B000)
    {
        pc_next=(add+inst)&0x00FFF;
        printf("b 0x%03X\n",pc_next);
        return(0);
    }














    printf("UNKNOWN\n");
    return(1);
}





int main ( int argc, char *argv[] )
{
    FILE *fp;
    unsigned int add;
    unsigned int ra;

    if(argc<2)
    {
        fprintf(stderr,".hex file not specified\n");
        return(1);
    }
    fp=fopen(argv[1],"rt");
    if(fp==NULL)
    {
        fprintf(stderr,"Error opening file [%s]\n",argv[1]);
        return(1);
    }
    if(readhex(fp)) return(1);
    fclose(fp);


    add=0;
    for(ra=0;ra<maxadd;ra+=3)
    {
        diss(add,rom[add]);
        add++;
    }




    return(0);
}

