//-------------------------------------------------------------------
//-------------------------------------------------------------------

//#define WATCH_REGISTERS
//#define WATCH_STACK
//#define WATCH_ROM
//#define WATCH_EXPORT
//#define WATCH_IMPORT
//#define WATCH_SCRATCH
//#define DISASSEMBLE
//#define WATCH_FLAGS

// This code was written from scratch to simulate/clone the Lattice
// Semiconductor Mico8 microcontroller core.  Lattice has open code with
// markings like the ones below and others.  THIS RTL WAS NOT WRITTEN BY
// AND IS NOT SUPPORRTED BY LATTICE SEMICONDUCTOR.  Bug me about it dont
// bug them.  In case it is legally considered a derivative work and esp
// because I dont want steal from them but instead support this architecture
// I have included their markings below.  This cdl file is the top level
// source the verilog file is a compiled derivative and wont contain such
// markings.


// =============================================================================
//                           COPYRIGHT NOTICE
// Copyright 2000-2001 (c) Lattice Semiconductor Corporation
// ALL RIGHTS RESERVED
// This core is licensed under the Lattice Open IP Core Agreement version 1.0 and
// subsequent versions
//
// Lattice Semiconductor Corporation    TEL : 1-800-Lattice (USA and Canada)
// 5555 NE Moore Court                        408-826-6000 (other locations)
// Hillsboro, OR 97124                  web  : http://www.latticesemi.com/
// U.S.A                                email: techsupport@latticesemi.com
// =============================================================================
//
//
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//
// ====================================================================
//
// Lattice Semiconductor Corporation
// 5555 NE Moore Court
// Hillsboro, OR 97124
// U.S.A
//
// TEL: 1-800-Lattice (USA and Canada)
// 408-826-6000 (other locations)
//
// web: http://www.latticesemi.com/
// email: techsupport@latticesemi.com
//


#include <stdio.h>
#include <stdlib.h>
#include <string.h>



unsigned long total_fetches;


unsigned int pc;
unsigned int flag_c;
unsigned int flag_z;
unsigned int flag_i;
unsigned int save_c;
unsigned int save_z;
unsigned int stack_pointer;
unsigned int stack[16];
unsigned char reg[32];
unsigned char scratch[256];

unsigned int maxadd;


char gstring[80];
char newline[1024];
unsigned char hexline[1024];

#define ROMMASK 0xFFF
unsigned int rom[(ROMMASK+1)>>2];
#define ROMBYTESMASK 0x3FFF
unsigned char rombytes[ROMBYTESMASK+1];


//-----------------------------------------------------------------------------
int readhex ( FILE *fp )
{
    unsigned int addhigh;
    unsigned int add;
    unsigned int ra;
    unsigned int line;
    unsigned char checksum;
    unsigned int len;
    unsigned int hexlen;
    unsigned char t;

    maxadd=0;

    addhigh=0;
    memset(rombytes,0xFF,sizeof(rombytes));

    line=0;
    while(fgets(newline,sizeof(newline)-1,fp))
    {
        line++;
        //printf("%s",newline);
        if(newline[0]!=':')
        {
            printf("Syntax error <%u> no colon\n",line);
            continue;
        }
        gstring[0]=newline[1];
        gstring[1]=newline[2];
        gstring[2]=0;
        len=strtoul(gstring,NULL,16);
        for(ra=0;ra<(len+5);ra++)
        {
            gstring[0]=newline[(ra<<1)+1];
            gstring[1]=newline[(ra<<1)+2];
            gstring[2]=0;
            hexline[ra]=(unsigned char)strtoul(gstring,NULL,16);
        }
        checksum=0;
        for(ra=0;ra<(len+5);ra++) checksum+=hexline[ra];
        //checksum&=0xFF;
        if(checksum)
        {
            printf("checksum error <%u>\n",line);
        }
        add=hexline[1]; add<<=8;
        add|=hexline[2];
        add|=addhigh;
        if(add>=ROMBYTESMASK)
        {
            printf("address too big 0x%08X\n",add);
            return(1);
            continue;
        }
        t=hexline[3];

        //:0011223344
        //;llaaaattdddddd
        //01234567890
        switch(t)
        {
            default:
                printf("UNKOWN type %02X <%u>\n",t,line);
                break;
            case 0x00:
                for(ra=0;ra<len;ra++)
                {
                    if(add>=ROMBYTESMASK)
                    {
                        printf("address too big 0x%08X\n",add);
                        return(1);
                    }
                    rombytes[add]=hexline[ra+4];
                    add++;
                    if(add>maxadd) maxadd=add;
                }
                break;
            case 0x01:
                printf("End of data\n");
                break;
            case 0x02:
                addhigh=hexline[5];
                addhigh<<=8;
                addhigh|=hexline[4];
                addhigh<<=16;
                break;
        }
    }

    add=0;
    for(ra=0;ra<=ROMMASK;ra++)
    {
        rom[ra] =rombytes[add++]; rom[ra]<<=8;
        rom[ra]|=rombytes[add++]; rom[ra]<<=8;
        rom[ra]|=rombytes[add++];
    }

    //printf("%u lines processed\n",line);
    printf("%08X\n",maxadd);



    return(0);

}
//-------------------------------------------------------------------
unsigned char get_register ( unsigned int r )
{
    unsigned char data;

    r&=31;
    data=reg[r];
#ifdef WATCH_REGISTERS
    printf("get_register(%2u) => 0x%02X\n",r,data);
#endif
    return(data);
}
//-------------------------------------------------------------------
void put_register ( unsigned int r, unsigned int data )
{
    r&=31;
    data&=0xFF;
#ifdef WATCH_REGISTERS
    printf("put_register(%2u) <= 0x%02X\n",r,data);
#endif
    reg[r]=data;
}
//-------------------------------------------------------------------
void push_stack ( unsigned int data )
{
    data&=0xFFF;
#ifdef WATCH_STACK
    printf("push_stack(%u) => 0x%03X\n",stack_pointer&15,data);
#endif
    stack[stack_pointer++] = data;
    stack_pointer&=0xF;
}
//-------------------------------------------------------------------
unsigned int pop_stack ( void )
{
    unsigned int data;

    data=stack[--stack_pointer];
    stack_pointer&=0xF;
#ifdef WATCH_STACK
    printf("pop_stack(%u) <= 0x%03X\n",(stack_pointer&15,data);
#endif
    return(data);
}
//-------------------------------------------------------------------
unsigned int rom_fetch ( unsigned int radd )
{
    unsigned int data;

    total_fetches++;
    radd&=ROMMASK;
    data=rom[radd];
#ifdef WATCH_ROM
    printf("rom_fetch(0x%03X) => 0x%05X\n",radd,data);
#endif
    return(data);
}
//-------------------------------------------------------------------
void do_export ( unsigned int add, unsigned int data )
{
    add&=0x1F;
    data&=0xFF;
#ifdef WATCH_EXPORT
    printf("do_export(0x%02X) => 0x%02X\n",add,data);
#endif
    switch(add)
    {
        default:
            printf("export(0x%02X,0x%02X);\n",add,data);
            break;
    }
}
//-------------------------------------------------------------------
unsigned int do_import ( unsigned int add )
{
    unsigned int data;

    add&=0x1F;
    data=scratch[add];
    switch(add)
    {
        default:
            data = 0xFF;
            break;
    }
#ifdef WATCH_IMPORT
    printf("lsp(0x%02X) <= 0x%02X\n",add,data);
#endif
    return(data);
}
//-------------------------------------------------------------------
void ssp ( unsigned int add, unsigned int data )
{
    add&=0x1F;
    data&=0xFF;
#ifdef WATCH_SCRATCH
    printf("ssp(0x%02X) => 0x%02X\n",add,data);
#endif
    scratch[add] = data;
}
//-------------------------------------------------------------------
unsigned int lsp ( unsigned int add )
{
    unsigned int data;
    add&=0x1F;
    data = scratch[add];
    data&=0xFF;
#ifdef WATCH_SCRATCH
    printf("lsp(0x%02X) <= 0x%02X\n",add,data);
#endif
    return(data);
}
//-------------------------------------------------------------------
void do_cflag ( unsigned int x )
{
    if(x&0x100) flag_c=1;
    else        flag_c=0;
#ifdef WATCH_FLAGS

    printf("do_cflag 0x%X %u\n",x,flag_c);
#endif

}
//-------------------------------------------------------------------
void do_zflag ( unsigned int x )
{
    x&=0xFF;
    if(x==0x00) flag_z=1;
    else        flag_z=0;
}
//-------------------------------------------------------------------
void do_iflag ( unsigned int x )
{
    flag_i=x&1;
}
//-------------------------------------------------------------------
int reset_lm8 ( void )
{
    total_fetches=0;
    pc=0;
    flag_c=0;
    flag_z=0;
    flag_i=0;
    memset(reg,0,sizeof(reg));
    memset(scratch,0,sizeof(scratch));
    memset(stack,0,sizeof(stack));
    return(0);
}
//-------------------------------------------------------------------
int execute_one ( void )
{
    unsigned int rd;
    unsigned int rb;
    unsigned int rd_data;
    unsigned int rb_data;
    unsigned int res;
    unsigned int pc_next;
    unsigned int pc_cond;
    unsigned int opa;
    unsigned int opb;
    unsigned int opc;
    unsigned int opr;

    unsigned int inst;

    inst=rom_fetch(pc);
    pc_next = (pc+1)&ROMMASK;

#ifdef DISASSEMBLE
        printf("0x%03X: 0x%05X ",pc,inst);
#endif

//76 5432 1098 7654 3210
//00 000d dddd bbbb b000 sub rd,rb       rd = rd - rb        CZ
    if((inst&0x3E007)==0x00000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("sub r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (~rb_data)&0xFF;
        opc = 1;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(~opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//00 001d dddd cccc cccc subi rd,const   rd = rd - const     CZ
    if((inst&0x3E000)==0x02000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("subi r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (~rb_data)&0xFF;
        opc = 1;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(~opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//00 010d dddd bbbb b000 subc rd,rb      rd = rd - rb - c    CZ
    if((inst&0x3E007)==0x04000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("subc r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (~rb_data)&0xFF;
        opc = (~flag_c)&1;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(~opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//00 011d dddd cccc cccc subic rd,const  rd = rd - const -c  CZ
    if((inst&0x3E000)==0x03000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("subic r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (~rb_data)&0xFF;
        opc = (~flag_c)&1;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(~opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//00 100d dddd bbbb b000 add rd,rb       rd = rd + rb        CZ
    if((inst&0x3E007)==0x08000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("add r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;
        opc = 0;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//00 101d dddd cccc cccc addi rd,const   rd = rd + const     CZ
    if((inst&0x3E000)==0x0A000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("addi r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;
        opc = 0;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//00 110d dddd bbbb b000 addc rd,rb      rd = rd + rb + c    CZ
    if((inst&0x3E007)==0x0C000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("addc r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;
        opc = flag_c;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//00 111d dddd cccc cccc addic rd,const  rd = rd + const + c CZ
    if((inst&0x3E000)==0x0E000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("addic r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;
        opc = flag_c;

        opr = opa + opb + opc;

        put_register(rd,opr);
        do_cflag(opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//01 000d dddd bbbb b000 mov rd,rb       rd = rb
    if((inst&0x3E007)==0x10000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("mov r%u,r%u\n",rd,rb);
#endif
        rb_data=get_register(rb);
        put_register(rd,rb_data);
        pc = pc_next;
        return(0);
    }
//01 001d dddd cccc cccc movi rd,const   rd = const
    if((inst&0x3E000)==0x12000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("movi r%u,0x%02X\n",rd,rb_data);
#endif
        put_register(rd,rb_data);
        pc = pc_next;
        return(0);
    }
//01 010d dddd bbbb b000 and rd,rb       rd = rd & rb        Z
    if((inst&0x3E007)==0x14000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("and r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa & opb;

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//01 011d dddd cccc cccc andi rd,const   rd = rd & const     Z
    if((inst&0x3E000)==0x16000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("andi r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa & opb;

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//01 100d dddd bbbb b000 or rd,rb        rd = rd | rb        Z
    if((inst&0x3E007)==0x18000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("or r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa | opb;

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//01 101d dddd cccc cccc ori rd,const    rd = rd | const     Z
    if((inst&0x3E000)==0x1A000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("ori r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa | opb;

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//01 110d dddd bbbb b000 xor rd,rb       rd = rd ^ rb        Z
    if((inst&0x3E007)==0x1C000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("xor r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa ^ opb;

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//01 111d dddd cccc cccc xori rd,const   rd = rd ^ const     Z
    if((inst&0x3E000)==0x1E000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("xori r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa ^ opb;

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 000d dddd bbbb b000 cmp rd,rb       rd - rb             CZ
    if((inst&0x3E007)==0x20000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("cmp r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (~rb_data)&0xFF;
        opc = 1;

        opr = opa + opb + opc;

        //put_register(rd,opr);
        do_cflag(~opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 001d dddd cccc cccc cmpi rd,const   rd - const          CZ
    if((inst&0x3E000)==0x22000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("cmpi r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (~rb_data)&0xFF;
        opc = 1;

        opr = opa + opb + opc;

        //put_register(rd,opr);
        do_cflag(~opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 010d dddd bbbb b000 test rd,rb      rd & rb             Z
    if((inst&0x3E007)==0x24000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("test r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa & opb;

        //put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 011d dddd cccc cccc testi rd,const  rd & const          Z
    if((inst&0x3E000)==0x26000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>0)&0xFF;
#ifdef DISASSEMBLE
        printf("testi r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = (rd_data)&0xFF;
        opb = (rb_data)&0xFF;

        opr = opa & opb;

        //put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 100d dddd bbbb b000 ror rd,rb                           Z
    if((inst&0x3E007)==0x28000)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("ror r%u,r%u\n",rd,rb);
#endif
        rb_data=get_register(rb);

        opb = (rb_data)&0xFF;
        opc = opb&1;

        opr = (opb>>1)|(opc<<7);

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 100d dddd bbbb b001 rol rd,rb                           Z
    if((inst&0x3E007)==0x28001)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("rol r%u,r%u\n",rd,rb);
#endif
        rb_data=get_register(rb);

        opb = (rb_data)&0xFF;
        opc = (opb>>7)&1;

        opr = (opb<<1)|opc;

        put_register(rd,opr);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 100d dddd bbbb b010 rorc rd,rb                          CZ
    if((inst&0x3E007)==0x28002)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("rorc r%u,r%u\n",rd,rb);
#endif
        rb_data=get_register(rb);

        opa = (rb_data)&0xFF;
        opb = opa&1;
        opc = flag_c;

        opr = (opa>>1)|(opc<<7);

        put_register(rd,opr);
        do_cflag(opb<<8);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 100d dddd bbbb b011 rolc rd,rb                          CZ
    if((inst&0x3E007)==0x28003)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("rolc r%u,r%u\n",rd,rb);
#endif
        rb_data=get_register(rb);

        opa = (rb_data)&0xFF;
        opb = (opa>>7)&1;
        opc = flag_c;

        opr = (opa<<1)|opc;

        put_register(rd,opr);
        do_cflag(opb<<8);
        do_zflag(opr);
        pc = pc_next;
        return(0);
    }
//10 1100 0000 0000 0000 clrc            clear carry
    if(inst==0x2C000)
    {
#ifdef DISASSEMBLE
        printf("clrc\n");
#endif
        flag_c = 0;
        pc = pc_next;
        return(0);
    }
//10 1100 0000 0000 0001 setc            set carry
    if(inst==0x2C001)
    {
#ifdef DISASSEMBLE
        printf("setc\n");
#endif
        flag_c = 1;
        pc = pc_next;
        return(0);
    }
//10 1100 0000 0000 0010 clrz            clear zero
    if(inst==0x2C002)
    {
#ifdef DISASSEMBLE
        printf("clrz\n");
#endif
        flag_z = 0;
        pc = pc_next;
        return(0);
    }
//10 1100 0000 0000 0011 setz            set zero
    if(inst==0x2C003)
    {
#ifdef DISASSEMBLE
        printf("setz\n");
#endif
        flag_z = 1;
        pc = pc_next;
        return(0);
    }
//10 1100 0000 0000 0100 clri            disable interrupts
    if(inst==0x2C004)
    {
#ifdef DISASSEMBLE
        printf("clri\n");
#endif
        flag_i = 0;
        pc = pc_next;
        return(0);
    }
//10 1100 0000 0000 0101 seti            enable interrupts
    if(inst==0x2C005)
    {
#ifdef DISASSEMBLE
        printf("seti\n");
#endif
        flag_i = 1;
        pc = pc_next;
        return(0);
    }
//10 111d dddd bbbb b010 exporti rd,rb    (port rb) = rd
    if((inst&0x3E007)==0x2E002)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("exporti r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = rb_data;
        opb = rd_data;

        do_export(opa,opb);
        pc = pc_next;

        if(opa==0x1F) return(1);
        return(0);
    }
//10 111d dddd bbbb b011 importi rd,rb   rd = (port rb)
    if((inst&0x3E007)==0x2E003)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("importi r%u,r%u\n",rd,rb);
#endif
        rb_data=get_register(rb);

        opa = rb_data;

        opr=do_import(opb);

        put_register(rd,opr);
        pc = pc_next;
        return(0);
    }
//10 111d dddd bbbb b110 sspi rd,rb      (rb) = rd
    if((inst&0x3E007)==0x2E006)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("sspi r%u,r%u\n",rd,rb);
#endif
        rd_data=get_register(rd);
        rb_data=get_register(rb);

        opa = rb_data;
        opb = rd_data;

        ssp(opa,opb);

        pc = pc_next;
        return(0);
    }
//10 111d dddd bbbb b111 lspi rd,rb      rd = (rb)
    if((inst&0x3E007)==0x2E007)
    {
        rd=(inst>>8)&0x1F;
        rb=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("lspi r%u,r%u\n",rd,rb);
#endif
        rb_data=get_register(rb);

        opa = rb_data & 0x1F;

        opr=lsp(opa);

        put_register(rd,opr);
        pc = pc_next;
        return(0);
    }
//10 111d dddd pppp p000 export rd,port  (port) = rd
    if((inst&0x3E007)==0x2E000)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>3)&0x1F;
if(rb_data==0x1F)
{
    printf("export(0x1F);\n");
    return(1);
}
#ifdef DISASSEMBLE
        printf("export r%u,0x%02X\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = rb_data;
        opb = rd_data;

        do_export(opa,opb);

        pc = pc_next;
        return(0);
    }
//10 111d dddd pppp p001 import rd,port  rd = (port)
    if((inst&0x3E007)==0x2E001)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("import r%u,0x%02X\n",rd,rb_data);
#endif
        opa = rb_data;

        opr = do_import(opa);

        put_register(rd,opr);
        pc = pc_next;
        return(0);
    }
//10 111d dddd ssss s100 ssp rd,ss       (sp) = rd
    if((inst&0x3E007)==0x2E004)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("ssp 0x%02X,r%u\n",rd,rb_data);
#endif
        rd_data=get_register(rd);

        opa = rb_data;
        opb = rd_data;

        ssp(opa,opb);

        pc = pc_next;
        return(0);
    }
//10 111d dddd ssss s101 lsp rd,ss       rd = (sp)
    if((inst&0x3E007)==0x2E005)
    {
        rd=(inst>>8)&0x1F;
        rb_data=(inst>>3)&0x1F;
#ifdef DISASSEMBLE
        printf("lsp r%u,0x%02X\n",rd,rb_data);
#endif

        opa = rb_data;

        opr = do_import(opa);

        put_register(rd,opr);
        pc = pc_next;
        return(0);
    }
//11 0000 llll llll llll bz label
    if((inst&0x3F000)==0x30000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("bz 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_z)
        {
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 0001 llll llll llll bnz label
    if((inst&0x3F000)==0x31000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("bnz 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_z == 0)
        {
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 0010 llll llll llll bc label
    if((inst&0x3F000)==0x32000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("bc 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_c)
        {
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 0011 llll llll llll bnc label
    if((inst&0x3F000)==0x33000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("bnc 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_c == 0)
        {
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 0100 llll llll llll callz label
    if((inst&0x3F000)==0x34000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("callz 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_z)
        {
            push_stack(pc + 1);
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 0101 llll llll llll callnz label
    if((inst&0x3F000)==0x35000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("callnz 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_z == 0)
        {
            push_stack(pc + 1);
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 0110 llll llll llll callc label
    if((inst&0x3F000)==0x36000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("callc 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_c)
        {
            push_stack(pc + 1);
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 0111 llll llll llll callnc label
    if((inst&0x3F000)==0x37000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("callnc 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        if(flag_c == 0)
        {
            push_stack(pc + 1);
            pc_next = pc_cond;
        }
        pc = pc_next;
        return(0);
    }
//11 1000 llll llll llll call label
    if((inst&0x3F000)==0x38000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("call 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        push_stack(pc + 1);
        pc_next = pc_cond;

        pc = pc_next;
        return(0);
    }
//11 1001 0000 0000 0000 ret
    if(inst==0x39000)
    {
#ifdef DISASSEMBLE
        printf("ret\n");
#endif
        pc_next = pop_stack();

        pc = pc_next;
        return(0);
    }
//11 1010 0000 0000 0000 iret
    if(inst==0x3A000)
    {
#ifdef DISASSEMBLE
        printf("iret\n");
#endif
        pc_next = pop_stack();
        flag_z = save_z;
        flag_c = save_c;

        pc = pc_next;
        return(0);
    }
//11 1011 llll llll llll b label
    if((inst&0x3F000)==0x3B000)
    {
        rb_data = inst&0xFFF;
        pc_cond = (pc+rb_data)&0xFFF;
#ifdef DISASSEMBLE
        printf("b 0x%03X //+0x%03X\n",pc_cond,rb_data);
#endif
        pc_next = pc_cond;
        pc = pc_next;
        return(0);
    }


    printf("0x%03X: 0x%05X UNKNOWN\n",pc,inst);
    return(1);
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
int main ( int argc, char *argv[] )
{
    FILE *fp;
    unsigned int add;
    unsigned int ra;

    if(argc<2)
    {
        fprintf(stderr,".hex file not specified\n");
        return(1);
    }
    fp=fopen(argv[1],"rt");
    if(fp==NULL)
    {
        fprintf(stderr,"Error opening file [%s]\n",argv[1]);
        return(1);
    }
    if(readhex(fp)) return(1);
    fclose(fp);

    reset_lm8();

    while(1)
    {
        if(execute_one()) break;

//if(total_fetches>200) break;
    }
    printf("total_fetches %lu\n",total_fetches);
    return(0);
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
