
/*vectors.s*/

.cpu cortex-m3
.thumb

.word   0x40010000  /* stack top address */
.word   _start      /* 1 Reset */
.word   hang        /* 2 NMI */
.word   hang        /* 3 HardFault */
.word   hang        /* 4 MemManage */
.word   hang        /* 5 BusFault */
.word   hang        /* 6 UsageFault */
.word   hang        /* 7 RESERVED */
.word   hang        /* 8 RESERVED */
.word   hang        /* 9 RESERVED*/
.word   hang        /* 10 RESERVED */
.word   hang        /* 11 SVCall */
.word   hang        /* 12 Debug Monitor */
.word   hang        /* 13 RESERVED */
.word   hang        /* 14 PendSV */
.word   hang        /* 15 SysTick */
.word   hang        /* 16 External Interrupt(0) */
.word   hang        /* 17 External Interrupt(1) */
.word   hang        /* 18 External Interrupt(2) */
.word   hang        /* 19 ...   */

.global __div0
__div0:
hang:   b .

.thumb_func
.globl _start
_start:
    ldr r0,=0x40000000;
    ldr r1,=0x40008000;

    mov r2,#0
zero_bss:
    str r2,[r0]
    add r0,#4
    cmp r0,r1
    bne zero_bss;

    bl notmain
    b .

.thumb_func
.globl PUT32
PUT32:
    str r1,[r0]
    bx lr

.thumb_func
.globl GET32
GET32:
    ldr r0,[r0]
    bx lr

.thumb_func
.globl GETSP
GETSP:
    mov r0,sp
    bx lr

.thumb_func
.global infinite
infinite:
    ldr r0,=0xF0000000
    str r0,[r0]
    b .

