#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include "hiredis.h"
#include "input_generator.h"
#include "user.h"
#include "manager.h"

#include <event2/event-config.h>
#include <event2/event.h>
#include <event2/util.h>

#include "util.h"

#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>


lua_State* L;

int main()
{
				manager_mr* mgr;
				cbcontext_mr* ctx;

				struct event_base* base;
				int nuser;

				int i;
				struct timeval* tvperiod;
				struct timeval* tvnow;
				struct timeval* tvthen;
				struct timeval* tvstart;
				struct event* e;
				user** users;
				user* u;

				

				//for debug
				FILE* ftime;

				long tmin=0;
				long tmax=0;	
				long temustart=0;
				long temuend=0;

				//stat
				double st_offeredload;
				double st_finishedload;

				//init lua environment
				sstore_lua_init();

				//init db
				mgr = mgr_init();
				//clear data
				//mr_cleardata(mgr);

				base = event_base_new();

				//nuser = 5000*1000;
				//nuser = 1000*1000;
				LUA_PCG_INT("nuser", nuser);
				//printf("nuser =============%d\n", nuser);
				
				//mmm: prepair user	
				users = (user**)malloc(nuser*sizeof(user*));
				generate_users(nuser, users);


				//debug: save starttime and endtime to file
				if((ftime = fopen("analysis/time", "w"))==NULL)	{
					printf("time file error!\n");
					}

				//mmm: prepair tvstart
				tvstart = (struct timeval*)malloc(sizeof(struct timeval));
				gettimeofday(tvstart, NULL);
				tvstart->tv_sec = tvstart->tv_sec + 5; 

				for(i=0;i<nuser;i++)	{
								u = users[i];
								//printf("u[i].id=%s\n", u->id);

								tvthen = (struct timeval*)malloc(sizeof(struct timeval));

								//1. add start event
								//printf("u->a=%d, tvstart->tvsec=%ld\n", u->a, tvstart->tv_sec);
								tvthen->tv_sec = tvstart->tv_sec + u->a;
								tvthen->tv_usec = tvstart->tv_usec;
								
								fprintf(ftime, "%ld ", tvthen->tv_sec);
								if(tmin==0 || tvthen->tv_sec<tmin)	{
									tmin = tvthen->tv_sec;
									}

								tvnow = (struct timeval*)malloc(sizeof(struct timeval));
								gettimeofday(tvnow, NULL);

								tvperiod = (struct timeval*)malloc(sizeof(struct timeval));
								//printf("tvnow s=%d\n", tvnow->tv_sec);
								//printf("tvthen s=%d\n", tvthen->tv_sec);
								timeval_subtract(tvperiod, tvthen, tvnow);	

								ctx = (cbcontext_mr*)malloc(sizeof(cbcontext_mr));
								ctx->mgr = mgr;
								ctx->u = u;

								e = evtimer_new(base, mgr_cbuserstart, (void*)ctx);
								//printf("tvperiod s=%d\n", tvperiod->tv_sec);
								evtimer_add(e, tvperiod);	

								//2. add end event
								tvthen->tv_sec = tvstart->tv_sec + u->a + u->d;
								tvthen->tv_usec = tvstart->tv_usec;
								
								fprintf(ftime, "%ld\n", tvthen->tv_sec);
								if(tmax==0 || tvthen->tv_sec>tmax)	{
									tmax = tvthen->tv_sec;
									}

								tvnow = (struct timeval*)malloc(sizeof(struct timeval));
								gettimeofday(tvnow, NULL);

								tvperiod = (struct timeval*)malloc(sizeof(struct timeval));
								timeval_subtract(tvperiod, tvthen, tvnow);	

								ctx = (cbcontext_mr*)malloc(sizeof(cbcontext_mr));
								ctx->mgr = mgr;
								ctx->u = u;

								e = evtimer_new(base, mgr_cbuserend, (void*)ctx);
								evtimer_add(e, tvperiod);	

								
				}
				printf("user preparation ended\n");
				fclose(ftime);

				//debug
				tvthen = (struct timeval*)malloc(sizeof(struct timeval));
				gettimeofday(tvthen, NULL);
				temustart = tvthen->tv_sec;

				//run loop
				event_base_dispatch(base);	

				//debug
				gettimeofday(tvthen, NULL);
				temuend = tvthen->tv_sec;

				//stat
				st_offeredload = nuser/60.0;
				st_finishedload = st_offeredload*90.0/(90.0+temuend-tmax);
				printf("user: %d\n", nuser);
				printf("emu:\t\t %ld~%ld\t(%ld)\n", temustart, temuend, temuend-temustart);
				printf("planned:\t %ld~%ld\t(%ld)\n", tmin, tmax, tmax-tmin); 
				printf("endtime diff: %ld\n", temuend-tmax);
				printf("finishedload/offeredload =  %f/%f = %f\n", st_finishedload, st_offeredload, st_finishedload/st_offeredload);				
				
				printf("end\n");
}

