#include<stdio.h>

char *NextBalBeString(int length) { 

  //  cleaned up initializations
  static char *beString;
  static int *bPositions, endRound, prevLength;

  // local variables for loops, tracking accesses
  int i, j, beRead = 0, beWrite = 0;

  // determine if this function is being called for a string of a different length
  // if so, reinitialize things
  
  // printf("prevLength: %d\n",prevLength);
  if (prevLength != length) 
  { // reset previous length to new current length
    prevLength  =  length;
    // free memory used by beString for previous lenght; reallocate
    free(beString);beString = (char*)malloc((length+1)*sizeof(char));
    // free memory used by bPositions for previous lenght; reallocate
    free(bPositions);bPositions = (int*)malloc((length/2)*sizeof(int));
    for (i = 0; i < length/2; i++) bPositions[i] = i;   
    // initialize first and last items in beString by def inition of be-string
    beString[0] = 'b';
    beString[length-1] = 'e';
    // record write access to array
    beWrite=2;
  } 
  else 
  {
    for (i = length/2-1; i > 0; i--) if (2*i != bPositions[i]) break;
    if (0 == i)
    {
      if (0 == endRound) 
      {
        endRound = 1;
        return NULL;
      } 
      else 
      {
        for (j = 0; j < length/2; j++) bPositions[j] = j;
      }
    } 
    else 
    {
      bPositions[i]++; 
      for (j = i + 1; j < length/2; j++) bPositions[j] = bPositions[j-1]+1;
    }    
  }
  // assuming that for char is a 'b' and the last char is an 'e'
  // for all valid strings, we'll not check beString[0] and beString[length-1]
  for (i=j=1; i < length-1; i++) 
  {
    // fixed comparison order
    if (i == bPositions[j])
    {
      beRead++;
      if ('b' != beString[i]) 
      {
        beString[i] = 'b';
	beWrite++;
      }
      // post increment of j was being executed by both
      j++;
    } 
    else 
    {
      // eliminated check for e @ beString[i]
      // and assuming it needs to be written
      beString[i] = 'e';
      beWrite++;
    }
  }
  printf("%s \n...Reads : %d\n...Writes: %d\n", beString, beRead, beWrite); 
  return beString;
}

// stored return value of NextBalBeString, and
// printed either it out or (null) if == NULL

void Test (int length, int numCalls) {
  char *next;
  next = (char*)malloc((length+1)*sizeof(char));
  int i;
  for (i = 0; i < numCalls; i++) {
    next = NextBalBeString(length);
    if (NULL == next) {
      printf("(null)\n");
    } else {
      //printf("%s\n",next);
    }
  }
}

int main() {
 Test(2, 3);
 Test(8, 17);
 Test(4, 7);
}
