//cc readInput.c
//Contact kundu@csc.lsu.edu for comments and questions
//This program reads the data for a graph from graph.dat.
//Shown below is a sample input file;
// 5 //numNodes
// 0 (2) 1 2 //nodeNum, degree, adjNodes
// 1 (4) 0 2 3 4 
// 2 (3) 0 1 4
// 3 (2) 1 4
// 4 (3) 1 2 3

#include<stdio.h>
#define INPUT_FILE "graph.dat"

typedef struct {
  int degree, *adjNodes;
} GraphNode;

int numNodes;
GraphNode *nodes;

void PrintIntVector(int *vector, int size)
{ int i;
  for (i=0; i<size; i++) printf("%d",vector[i]);
  printf("\n");
}

void SkipToEndofLine(FILE *fpInp)
{ while (getc(fpInp) != '\n');
}

void ReadInput() //creates the digraph
{ int i, j, nodeNum;
  FILE *fp;

  if (NULL == (fp = fopen(INPUT_FILE, "r")))
  { fprintf(stderr, "Cannot open %s\n", INPUT_FILE); exit(1);}
  fscanf(fp, "%d", &numNodes); 
  SkipToEndofLine(fp);
  nodes = (GraphNode *)malloc(numNodes*sizeof(GraphNode));
  for (i=0; i<numNodes; i++) 
  {
    fscanf(fp, "%d", &nodeNum); 
    fscanf(fp, " ( %d ) ", &nodes[nodeNum].degree);
    nodes[nodeNum].adjNodes = (int *)malloc(nodes[nodeNum].degree*sizeof(int));
    for (j=0; j<nodes[nodeNum].degree; j++)
      fscanf(fp, "%d", &nodes[nodeNum].adjNodes[j]);
    SkipToEndofLine(fp);
  }  
  fclose(fp);
  printf("nodeNum (degree) adjNodes:");
  for (i=0; i<numNodes; i++)
  { printf("%d (%d)", i, nodes[i].degree); 
    PrintIntVector(nodes[i].adjNodes, nodes[i].degree); }
}

int main() 
{ ReadInput();
}



