/* Copyright (c) 2012 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#ifndef ABL_TYPES_H_
#define ABL_TYPES_H_

#include <stdint.h>

typedef enum {
	FALSE						= 0,
	TRUE						= !FALSE,
} GCC_PACKED bool_t;

typedef int8_t char8_t;
typedef int16_t char16_t;
typedef int32_t char32_t;

typedef union union16 union16_t;
union union16 {
	int8_t int8[2];
	uint8_t uint8[2];
	int16_t int16;
	uint16_t uint16;
#if __SIZEOF_POINTER__ == 2
	void *ptr;
#endif
};

typedef union union32 union32_t;
union union32 {
	int8_t int8[4];
	uint8_t uint8[4];
	int16_t int16[2];
	uint16_t uint16[2];
	int32_t int32;
	uint32_t uint32;
#if __SIZEOF_POINTER__ == 4
	void *ptr;
#endif
};

typedef union union64 union64_t;
union union64 {
	int8_t int8[8];
	uint8_t uint8[8];
	int16_t int16[4];
	uint16_t uint16[4];
	int32_t int32[2];
	uint32_t uint32[2];
	int64_t int64;
	uint64_t uint64;
#if __SIZEOF_POINTER__ == 8
	void *ptr;
#endif
};

typedef union ptrs ptrs_t;
union ptrs {
	void *void_ptr;
	uint8_t *uint8_ptr;
	uint16_t *uint16_ptr;
	uint32_t *uint32_ptr;
	uint64_t *uint64_ptr;
};

typedef union volatile_ptrs volatile_ptrs_t;
union volatile_ptrs {
	void volatile *void_ptr;
	uint8_t volatile *uint8_ptr;
	uint16_t volatile *uint16_ptr;
	uint32_t volatile *uint32_ptr;
	uint64_t volatile *uint64_ptr;
};

typedef union const_ptrs const_ptrs_t;
union const_ptrs {
	void const *void_ptr;
	uint8_t const *uint8_ptr;
	uint16_t const *uint16_ptr;
	uint32_t const *uint32_ptr;
	uint64_t const *uint64_ptr;
};

typedef union const_volatile_ptrs const_volatile_ptrs_t;
union const_volatile_ptrs {
	void const volatile *void_ptr;
	uint8_t const volatile *uint8_ptr;
	uint16_t const volatile *uint16_ptr;
	uint32_t const volatile *uint32_ptr;
	uint64_t const volatile *uint64_ptr;
};

#endif /* ABL_TYPES_H_ */
