/* Copyright (c) 2012 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#ifndef NIBO_CEPRO_COPRO_H_
#define NIBO_CEPRO_COPRO_H_

#include <abl/gcc.h>
#include <abl/isp.h>

#include <nibo/cepro/uid.h>

extern uint8_t nibo_copro_init(void);

inline uint8_t nibo_copro_is_reset(void) GCC_ALWAYS_INLINE;
inline void nibo_copro_reset(void) GCC_ALWAYS_INLINE;
inline void nibo_copro_clear_reset(void) GCC_ALWAYS_INLINE;

extern isp_return_code_t nibo_copro_program_flash(prog_uint8_t const *buffer, uint16_t const buffer_size, isp_progress_callback_t const progress_callback);
extern isp_return_code_t nibo_copro_verify_flash(prog_uint8_t const *buffer, uint16_t const buffer_size, isp_progress_callback_t const progress_callback);
extern isp_return_code_t nibo_copro_program_and_verify_flash(prog_uint8_t const *buffer, uint16_t const buffer_size, isp_progress_callback_t const write_progress_callback, isp_progress_callback_t const verify_progress_callback);

inline uint8_t nibo_copro_is_reset(void) {
	return NIBO_COPRO_RESET_PORT & NIBO_COPRO_RESET_MASK;
}

inline void nibo_copro_reset(void) {
	NIBO_COPRO_RESET_PORT &= ~NIBO_COPRO_RESET_MASK;
}

inline void nibo_copro_clear_reset(void) {
	NIBO_COPRO_RESET_PORT |= NIBO_COPRO_RESET_MASK;
}

#endif /* NIBO_CEPRO_COPRO_H_ */
