/* Copyright (c) 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#ifndef _NIBO_CEPRO_HEADLIGHTS_H
#define _NIBO_CEPRO_HEADLIGHTS_H

#include <abl/gcc.h>

#include <nibo/cepro/uid.h>

extern void nibo_headlights_init(void);
inline uint16_t nibo_headlights_get_brightness(void) GCC_ALWAYS_INLINE;
inline void nibo_headlights_set_brightness(uint16_t const brightness) GCC_ALWAYS_INLINE;
extern void nibo_headlights_set_apparent_brightness(uint16_t const brightness);

inline uint16_t nibo_headlights_get_brightness(void) {
	return NIBO_HEADLIGHTS_PWM_OCR;
}

inline void nibo_headlights_set_brightness(uint16_t const brightness) {
	NIBO_HEADLIGHTS_PWM_OCR = brightness;
}

#endif /* _NIBO_CEPRO_HEADLIGHTS_H */
