/* Copyright (c) 2012 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#ifndef NIBO_CEPRO_SWITCHES_H_
#define NIBO_CEPRO_SWITCHES_H_

#include <abl/gcc.h>

#include <nibo/cepro/uid.h>

extern void nibo_switches_init(void);

inline uint8_t nibo_switches_is_switch_closed(void) GCC_ALWAYS_INLINE;
inline uint8_t nibo_switches_is_jumper_closed(void) GCC_ALWAYS_INLINE;

inline uint8_t nibo_switches_is_switch_closed(void) {
	return !(NIBO_SWITCHES_S3_PIN & NIBO_SWITCHES_S3_MASK);
}

inline uint8_t nibo_switches_is_jumper_closed(void) {
	return !(NIBO_SWITCHES_JP1_PIN & NIBO_SWITCHES_JP1_2_MASK);
}

#endif /* NIBO_CEPRO_SWITCHES_H_ */
