/* Copyright (c) 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#ifndef _NIBO_CEPRO_TERMINAL_H
#define _NIBO_CEPRO_TERMINAL_H

#include <stdint.h>

#define NIBO_TERMINAL_ROWS			8
#define NIBO_TERMINAL_COLUMNS			25

extern void nibo_terminal_init(void);

extern void nibo_terminal_clear(void);
extern void nibo_terminal_clear_row(uint8_t const row);

extern void nibo_terminal_get_cursor_position(uint8_t * const row, uint8_t * const column);
extern void nibo_terminal_set_cursor_position(uint8_t const row, uint8_t const column);

extern uint8_t nibo_terminal_write_char(char c);
extern uint8_t nibo_terminal_write_string(char const *string);
extern uint8_t nibo_terminal_write_format(char const *format, ...);

#endif /* _NIBO_CEPRO_TERMINAL_H */
