/* Copyright (c) 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#ifndef _NIBO_CEPRO_UID_H
#define _NIBO_CEPRO_UID_H

#include <avr/io.h>

#define NIBO_COPRO_RESET_DDR			DDRD
#define NIBO_COPRO_RESET_PORT			PORTD
#define NIBO_COPRO_RESET_MASK			(1 << PD7)

#define NIBO_HEADLIGHTS_PWM_DDR			DDRB
#define NIBO_HEADLIGHTS_PWM_PORT		PORTB
#define NIBO_HEADLIGHTS_PWM_MASK		(1 << PB5)
#define NIBO_HEADLIGHTS_PWM_OCR			OCR1A

#define NIBO_LCD_DATA_DDR			DDRA
#define NIBO_LCD_DATA_PORT			PORTA
#define NIBO_LCD_DATA_PIN			PINA
#define NIBO_LCD_DATA_MASK			0xff
#define NIBO_LCD_CONTROL_DDR			DDRG
#define NIBO_LCD_CONTROL_PORT			PORTG
#define NIBO_LCD_CONTROL_EN_MASK		(1 << PG2)
#define NIBO_LCD_CONTROL_RS_MASK		(1 << PG3)
#define NIBO_LCD_CONTROL_RW_MASK		(1 << PG4)
#define NIBO_LCD_CONTROL_CS1_MASK		(1 << PG0)
#define NIBO_LCD_CONTROL_CS2_MASK		(1 << PG1)
#define NIBO_LCD_RESET_DDR			DDRB
#define NIBO_LCD_RESET_PORT			PORTB
#define NIBO_LCD_RESET_PIN			PINB
#define NIBO_LCD_RESET_MASK			(1 << PB0)
#define NIBO_LCD_PWM_DDR			DDRB
#define NIBO_LCD_PWM_PORT			PORTB
#define NIBO_LCD_PWM_MASK			(1 << PB6)
#define NIBO_LCD_PWM_OCR			OCR1B

#define NIBO_STATUS_LEDS_RED_PORT		PORTE
#define NIBO_STATUS_LEDS_RED_DDR		DDRE
#define NIBO_STATUS_LEDS_RED_MASK		0xff
#define NIBO_STATUS_LEDS_GREEN_PORT		PORTC
#define NIBO_STATUS_LEDS_GREEN_DDR		DDRC
#define NIBO_STATUS_LEDS_GREEN_MASK		0xff
#define NIBO_STATUS_LEDS_PWM_DDR		DDRB
#define NIBO_STATUS_LEDS_PWM_PORT		PORTB
#define NIBO_STATUS_LEDS_PWM_MASK		(1 << PB7)
#define NIBO_STATUS_LEDS_PWM_OCR		OCR1C

#define NIBO_SWITCHES_S3_DDR			DDRD
#define NIBO_SWITCHES_S3_PORT			PORTD
#define NIBO_SWITCHES_S3_PIN			PIND
#define NIBO_SWITCHES_S3_MASK			(1 << PD4)
#define NIBO_SWITCHES_JP1_DDR			DDRF
#define NIBO_SWITCHES_JP1_PORT			PORTF
#define NIBO_SWITCHES_JP1_PIN			PINF
#define NIBO_SWITCHES_JP1_1_MASK		(1 << PF4)
#define NIBO_SWITCHES_JP1_2_MASK		(1 << PF5)

#endif /* _NIBO_CEPRO_UID_H */
