/* Copyright (c) 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#include <nibo/cepro/headlights.h>
#include <nibo/cepro/pwm.h>

#include "../pwm/pwm-private.h"

static uint8_t nibo_headlights_initialized = 0;

void nibo_headlights_init(void) {
	if(!nibo_headlights_initialized) {
		NIBO_HEADLIGHTS_PWM_DDR |= NIBO_HEADLIGHTS_PWM_MASK;

		nibo_pwm_init();

		nibo_headlights_initialized = 1;
	}
}

void nibo_headlights_set_apparent_brightness(uint16_t const brightness) {
	nibo_headlights_set_brightness(nibo_pwm_translate_value(brightness));
}
