/* Copyright (c) 2011-2012 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of jdp-incubator.
 *
 * jdp-incubator is licensed under the Simplified BSD License (the "License").
 * You should have received a copy of the License along with jdp-incubator.
 * If not, see <http://www.opensource.org/licenses/bsd-license.php>.
 */

#include <nibo/cepro/pwm.h>
#include <nibo/cepro/statusleds.h>

#include "../pwm/pwm-private.h"

static uint8_t nibo_status_leds_initialized = 0;

void nibo_status_leds_init(void) {
	if(!nibo_status_leds_initialized) {
		NIBO_STATUS_LEDS_RED_DDR = NIBO_STATUS_LEDS_RED_MASK;
		NIBO_STATUS_LEDS_RED_PORT &= ~NIBO_STATUS_LEDS_RED_MASK;

		NIBO_STATUS_LEDS_GREEN_DDR = NIBO_STATUS_LEDS_GREEN_MASK;
		NIBO_STATUS_LEDS_GREEN_PORT &= ~NIBO_STATUS_LEDS_GREEN_MASK;

		NIBO_STATUS_LEDS_PWM_DDR |= NIBO_STATUS_LEDS_PWM_MASK;

		nibo_pwm_init();

		nibo_status_leds_initialized = 1;
	}
}

void nibo_status_leds_set_apparent_brightness(uint16_t const brightness) {
	nibo_status_leds_set_brightness(nibo_pwm_translate_value(brightness));
}
