# Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
#
# This file is part of xng-cmake-template.
#
# xng-cmake-template is licensed under the Simplified BSD License
# (the "License").
#
# You should have received a copy of the License along with xng-cmake-template.
# If not, see <http://www.opensource.org/licenses/bsd-license.php>.
#
# Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>

if(NOT DEFINED XNG_AVR32_CONFIG_READ)
	include("${CMAKE_SOURCE_DIR}/cmake/xng-ct/avr32/config.cmake")
endif()

set(CMAKE_SYSTEM_NAME "Generic")

set(CMAKE_C_COMPILER "${XNG_AVR32_GCC}")
set(CMAKE_C_COMPILER_ID "GNU")
set(CMAKE_C_COMPILER_ID_RUN TRUE)
set(CMAKE_C_COMPILER_WORKS TRUE)
set(CMAKE_C_COMPILER_FORCED TRUE)

set(CMAKE_CXX_COMPILER "${XNG_AVR32_GCC}")
set(CMAKE_CXX_COMPILER_ID "GNU")
set(CMAKE_CXX_COMPILER_ID_RUN TRUE)
set(CMAKE_CXX_COMPILER_WORKS TRUE)
set(CMAKE_CXX_COMPILER_FORCED TRUE)

set(CMAKE_ASM_COMPILER "${XNG_AVR32_GCC}")
set(CMAKE_ASM_COMPILER_ARG1 "-c")
set(CMAKE_ASM_COMPILER_ID "GNU")
set(CMAKE_ASM_COMPILER_ID_RUN TRUE)
set(CMAKE_ASM_COMPILER_WORKS TRUE)
set(CMAKE_ASM_COMPILER_FORCED TRUE)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -mpart=${XNG_AVR32_PART} -ffunction-sections -fdata-sections" CACHE STRING "Flags used by the compiler during all build types.")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${CMAKE_C_FLAGS}" CACHE STRING "Flags used by the assembler during all build types.")

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--gc-sections" CACHE STRING "Flags used by the linker.")

set(CMAKE_EXECUTABLE_SUFFIX_C ".elf")
set(CMAKE_STATIC_LIBRARY_SUFFIX_C ".a")

if(NOT XNG_AVR32_CONFIG_OK)
	set(CMAKE_C_COMPILER_ENV_VAR "")
	set(CMAKE_CXX_COMPILER_ENV_VAR "")
	file(WRITE "${CMAKE_BINARY_DIR}/CMakeFiles/CMakeCCompiler.cmake" "")
	file(WRITE "${CMAKE_BINARY_DIR}/CMakeFiles/CMakeCXXCompiler.cmake" "")
endif()

