# Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
#
# This file is part of libat32uc3.
#
# libat32uc3 is licensed under the Simplified BSD License
# (the "License").
#
# A copy of the License should be included in the distribution.
# Alternatively, you may obtain a copy of the License at
# http://www.opensource.org/licenses/bsd-license.php
#
# Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>

#include "evba.h"

.section .evba, "ax", @progbits

.balign 0x00000200

.global _evba
.type _evba, @function

_evba:
	.org EVBA_OFFSET_UNRECOVERABLE_EXCEPTION
	rjmp _exceptions_handle_unrecoverable_exception

	.org EVBA_OFFSET_TLB_MULTIPLE_HIT
	rjmp _exceptions_handle_tlb_multiple_hit

	.org EVBA_OFFSET_BUS_ERROR_DATA_FETCH
	rjmp _exceptions_handle_bus_error_data_fetch

	.org EVBA_OFFSET_BUS_ERROR_INSTRUCTION_FETCH
	rjmp _exceptions_handle_bus_error_instruction_fetch

	.org EVBA_OFFSET_NMI
	rjmp _exceptions_handle_nmi

	.org EVBA_OFFSET_INSTRUCTION_ADDRESS
	rjmp _exceptions_handle_instruction_address

	.org EVBA_OFFSET_ITLB_PROTECTION
	rjmp _exceptions_handle_itlb_protection

	.org EVBA_OFFSET_BREAKPOINT
	rjmp _exceptions_handle_breakpoint

	.org EVBA_OFFSET_ILLEGAL_OPCODE
	rjmp _exceptions_handle_illegal_opcode

	.org EVBA_OFFSET_UNIMPLEMENTED_INSTRUCTION
	rjmp _exceptions_handle_unimplemented_instruction

	.org EVBA_OFFSET_PRIVILEGE_VIOLATION
	rjmp _exceptions_handle_privilege_violation

	.org EVBA_OFFSET_DATA_ADDRESS_READ
	rjmp _exceptions_handle_data_address_read

	.org EVBA_OFFSET_DATA_ADDRESS_WRITE
	rjmp _exceptions_handle_data_address_write

	.org EVBA_OFFSET_DTLB_PROTECTION_READ
	rjmp _exceptions_handle_dtlb_protection_read

	.org EVBA_OFFSET_DTLB_PROTECTION_WRITE
	rjmp _exceptions_handle_dtlb_protection_write

	.org EVBA_OFFSET_ITLB_MISS
	rjmp _exceptions_handle_itlb_miss

	.org EVBA_OFFSET_DTLB_MISS_READ
	rjmp _exceptions_handle_dtlb_miss_read

	.org EVBA_OFFSET_DTLB_MISS_WRITE
	rjmp _exceptions_handle_dtlb_miss_write

	.org EVBA_OFFSET_SUPERVISOR_CALL
	rjmp _exceptions_handle_supervisor_call

	.org EVBA_OFFSET_INTERRUPT0_REQUEST
	rjmp _exceptions_handle_interrupt0_request

	.org EVBA_OFFSET_INTERRUPT1_REQUEST
	rjmp _exceptions_handle_interrupt1_request

	.org EVBA_OFFSET_INTERRUPT2_REQUEST
	rjmp _exceptions_handle_interrupt2_request

	.org EVBA_OFFSET_INTERRUPT3_REQUEST
	rjmp _exceptions_handle_interrupt3_request

