/*
 * Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of libat32uc3.
 *
 * libat32uc3 is licensed under the Simplified BSD License
 * (the "License").
 *
 * A copy of the License should be included in the distribution.
 * Alternatively, you may obtain a copy of the License at
 * http://www.opensource.org/licenses/bsd-license.php
 *
 * Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>
 */

#ifndef EVBA_H_
#define EVBA_H_

#define EVBA_OFFSET_UNRECOVERABLE_EXCEPTION		0x00000000
#define EVBA_OFFSET_TLB_MULTIPLE_HIT			0x00000004
#define EVBA_OFFSET_BUS_ERROR_DATA_FETCH		0x00000008
#define EVBA_OFFSET_BUS_ERROR_INSTRUCTION_FETCH		0x0000000c
#define EVBA_OFFSET_NMI					0x00000010
#define EVBA_OFFSET_INSTRUCTION_ADDRESS			0x00000014
#define EVBA_OFFSET_ITLB_PROTECTION			0x00000018
#define EVBA_OFFSET_BREAKPOINT				0x0000001c
#define EVBA_OFFSET_ILLEGAL_OPCODE			0x00000020
#define EVBA_OFFSET_UNIMPLEMENTED_INSTRUCTION		0x00000024
#define EVBA_OFFSET_PRIVILEGE_VIOLATION			0x00000028
#define EVBA_OFFSET_DATA_ADDRESS_READ			0x00000034
#define EVBA_OFFSET_DATA_ADDRESS_WRITE			0x00000038
#define EVBA_OFFSET_DTLB_PROTECTION_READ		0x0000003c
#define EVBA_OFFSET_DTLB_PROTECTION_WRITE		0x00000040
#define EVBA_OFFSET_ITLB_MISS				0x00000050
#define EVBA_OFFSET_DTLB_MISS_READ			0x00000060
#define EVBA_OFFSET_DTLB_MISS_WRITE			0x00000070
#define EVBA_OFFSET_SUPERVISOR_CALL			0x00000100
#define EVBA_OFFSET_INTERRUPT0_REQUEST			0x00000104
#define EVBA_OFFSET_INTERRUPT1_REQUEST			0x00000108
#define EVBA_OFFSET_INTERRUPT2_REQUEST			0x0000010c
#define EVBA_OFFSET_INTERRUPT3_REQUEST			0x00000110

#endif /* EVBA_H_ */

