/*
 * Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of libat32uc3.
 *
 * libat32uc3 is licensed under the Simplified BSD License
 * (the "License").
 *
 * A copy of the License should be included in the distribution.
 * Alternatively, you may obtain a copy of the License at
 * http://www.opensource.org/licenses/bsd-license.php
 *
 * Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>
 */

static exceptions_handler_t unrecoverable_exception_handler = 0;
static exceptions_handler_t tlb_multiple_hit_handler = 0;
static exceptions_handler_t bus_error_data_fetch_handler = 0;
static exceptions_handler_t bus_error_instruction_fetch_handler = 0;
static exceptions_handler_t nmi_handler = 0;
static exceptions_handler_t instruction_address_handler = 0;
static exceptions_handler_t itlb_protection_handler = 0;
static exceptions_handler_t breakpoint_handler = 0;
static exceptions_handler_t illegal_opcode_handler = 0;
static exceptions_handler_t unimplemented_instruction_handler = 0;
static exceptions_handler_t privilege_violation_handler = 0;
static exceptions_handler_t data_address_read_handler = 0;
static exceptions_handler_t data_address_write_handler = 0;
static exceptions_handler_t dtlb_protection_read_handler = 0;
static exceptions_handler_t dtlb_protection_write_handler = 0;
static exceptions_handler_t itlb_miss_handler = 0;
static exceptions_handler_t dtlb_miss_read_handler = 0;
static exceptions_handler_t dtlb_miss_write_handler = 0;
static exceptions_handler_t supervisor_call_handler = 0;

void exceptions_set_unrecoverable_exception_handler(exceptions_handler_t const handler) {
        unrecoverable_exception_handler = handler;
}

void exceptions_set_tlb_multiple_hit_handler(exceptions_handler_t const handler) {
        tlb_multiple_hit_handler = handler;
}

void exceptions_set_bus_error_data_fetch_handler(exceptions_handler_t const handler) {
        bus_error_data_fetch_handler = handler;
}

void exceptions_set_bus_error_instruction_fetch_handler(exceptions_handler_t const handler) {
        bus_error_instruction_fetch_handler = handler;
}

void exceptions_set_nmi_handler(exceptions_handler_t const handler) {
        nmi_handler = handler;
}

void exceptions_set_instruction_address_handler(exceptions_handler_t const handler) {
        instruction_address_handler = handler;
}

void exceptions_set_itlb_protection_handler(exceptions_handler_t const handler) {
        itlb_protection_handler = handler;
}

void exceptions_set_breakpoint_handler(exceptions_handler_t const handler) {
        breakpoint_handler = handler;
}

void exceptions_set_illegal_opcode_handler(exceptions_handler_t const handler) {
        illegal_opcode_handler = handler;
}

void exceptions_set_unimplemented_instruction_handler(exceptions_handler_t const handler) {
        unimplemented_instruction_handler = handler;
}

void exceptions_set_privilege_violation_handler(exceptions_handler_t const handler) {
        privilege_violation_handler = handler;
}

void exceptions_set_data_address_read_handler(exceptions_handler_t const handler) {
        data_address_read_handler = handler;
}

void exceptions_set_data_address_write_handler(exceptions_handler_t const handler) {
        data_address_write_handler = handler;
}

void exceptions_set_dtlb_protection_read_handler(exceptions_handler_t const handler) {
        dtlb_protection_read_handler = handler;
}

void exceptions_set_dtlb_protection_write_handler(exceptions_handler_t const handler) {
        dtlb_protection_write_handler = handler;
}

void exceptions_set_itlb_miss_handler(exceptions_handler_t const handler) {
        itlb_miss_handler = handler;
}

void exceptions_set_dtlb_miss_read_handler(exceptions_handler_t const handler) {
        dtlb_miss_read_handler = handler;
}

void exceptions_set_dtlb_miss_write_handler(exceptions_handler_t const handler) {
        dtlb_miss_write_handler = handler;
}

void exceptions_set_supervisor_call_handler(exceptions_handler_t const handler) {
        supervisor_call_handler = handler;
}

