/*
 * Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of libat32uc3.
 *
 * libat32uc3 is licensed under the Simplified BSD License
 * (the "License").
 *
 * A copy of the License should be included in the distribution.
 * Alternatively, you may obtain a copy of the License at
 * http://www.opensource.org/licenses/bsd-license.php
 *
 * Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>
 */

#include <at32uc3/exceptions.h>
#include <at32uc3/sysreg.h>

#include "evba.h"

#include "exceptionhandlers_common.c"

extern void _exceptions_handle_unrecoverable_exception(void) GCC_INTERRUPT;
extern void _exceptions_handle_tlb_multiple_hit(void) GCC_INTERRUPT;
extern void _exceptions_handle_bus_error_data_fetch(void) GCC_INTERRUPT;
extern void _exceptions_handle_bus_error_instruction_fetch(void) GCC_INTERRUPT;
extern void _exceptions_handle_nmi(void) GCC_INTERRUPT;
extern void _exceptions_handle_instruction_address(void) GCC_INTERRUPT;
extern void _exceptions_handle_itlb_protection(void) GCC_INTERRUPT;
extern void _exceptions_handle_breakpoint(void) GCC_INTERRUPT;
extern void _exceptions_handle_illegal_opcode(void) GCC_INTERRUPT;
extern void _exceptions_handle_unimplemented_instruction(void) GCC_INTERRUPT;
extern void _exceptions_handle_privilege_violation(void) GCC_INTERRUPT;
extern void _exceptions_handle_data_address_read(void) GCC_INTERRUPT;
extern void _exceptions_handle_data_address_write(void) GCC_INTERRUPT;
extern void _exceptions_handle_dtlb_protection_read(void) GCC_INTERRUPT;
extern void _exceptions_handle_dtlb_protection_write(void) GCC_INTERRUPT;
extern void _exceptions_handle_itlb_miss(void) GCC_INTERRUPT;
extern void _exceptions_handle_dtlb_miss_read(void) GCC_INTERRUPT;
extern void _exceptions_handle_dtlb_miss_write(void) GCC_INTERRUPT;
extern void _exceptions_handle_supervisor_call(void) GCC_INTERRUPT;

void _exceptions_handle_unrecoverable_exception(void) {
        if(unrecoverable_exception_handler)
                unrecoverable_exception_handler();
}

void _exceptions_handle_tlb_multiple_hit(void) {
        if(tlb_multiple_hit_handler)
                tlb_multiple_hit_handler();
}

void _exceptions_handle_bus_error_data_fetch(void) {
        if(bus_error_data_fetch_handler)
                bus_error_data_fetch_handler();
}

void _exceptions_handle_bus_error_instruction_fetch(void) {
        if(bus_error_instruction_fetch_handler)
                bus_error_instruction_fetch_handler();
}

void _exceptions_handle_nmi(void) {
        if(nmi_handler)
                nmi_handler();
}

void _exceptions_handle_instruction_address(void) {
        if(instruction_address_handler)
                instruction_address_handler();
}

void _exceptions_handle_itlb_protection(void) {
        if(itlb_protection_handler)
                itlb_protection_handler();
}

void _exceptions_handle_breakpoint(void) {
        if(breakpoint_handler)
                breakpoint_handler();
}

void _exceptions_handle_illegal_opcode(void) {
        if(illegal_opcode_handler)
                illegal_opcode_handler();
}

void _exceptions_handle_unimplemented_instruction(void) {
        if(unimplemented_instruction_handler)
                unimplemented_instruction_handler();
}

void _exceptions_handle_privilege_violation(void) {
        if(privilege_violation_handler)
                privilege_violation_handler();
}

void _exceptions_handle_data_address_read(void) {
        if(data_address_read_handler)
                data_address_read_handler();
}

void _exceptions_handle_data_address_write(void) {
        if(data_address_write_handler)
                data_address_write_handler();
}

void _exceptions_handle_dtlb_protection_read(void) {
        if(dtlb_protection_read_handler)
                dtlb_protection_read_handler();
}

void _exceptions_handle_dtlb_protection_write(void) {
        if(dtlb_protection_write_handler)
                dtlb_protection_write_handler();
}

void _exceptions_handle_itlb_miss(void) {
        if(itlb_miss_handler)
                itlb_miss_handler();
}

void _exceptions_handle_dtlb_miss_read(void) {
        if(dtlb_miss_read_handler)
                dtlb_miss_read_handler();
}

void _exceptions_handle_dtlb_miss_write(void) {
        if(dtlb_miss_write_handler)
                dtlb_miss_write_handler();
}

void _exceptions_handle_supervisor_call(void) {
        if(supervisor_call_handler)
                supervisor_call_handler();
}
