/*
 * Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of libat32uc3.
 *
 * libat32uc3 is licensed under the Simplified BSD License
 * (the "License").
 *
 * A copy of the License should be included in the distribution.
 * Alternatively, you may obtain a copy of the License at
 * http://www.opensource.org/licenses/bsd-license.php
 *
 * Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>
 */

#include <at32uc3/exceptions.h>
#include <at32uc3/sysreg.h>

#include "evba.h"

extern void _exceptions_init(void) GCC_NAKED GCC_SECTION(".init") GCC_USED;

extern void _evba(void);

void _exceptions_init(void) {
	sysreg_write(SYSREG_EVBA_NO, (uint32_t)&_evba);
}

void exceptions_enable(void) {
	sysreg_clear(SYSREG_SR_NO, SYSREG_SR_EM_MASK);
}

uint32_t exceptions_enabled(void) {
	return sysreg_read(SYSREG_SR_NO) & SYSREG_SR_EM_MASK;
}

void exceptions_disable(void) {
	sysreg_set(SYSREG_SR_NO, SYSREG_SR_EM_MASK);
}

