/*
 * Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of libat32uc3.
 *
 * libat32uc3 is licensed under the Simplified BSD License
 * (the "License").
 *
 * A copy of the License should be included in the distribution.
 * Alternatively, you may obtain a copy of the License at
 * http://www.opensource.org/licenses/bsd-license.php
 *
 * Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>
 */

#include <at32uc3/intc.h>

uint32_t intc_read_register(uint32_t const offset, intc_group_t const group) {
	uint32_t volatile * const p = (uint32_t volatile *)(INTC_ADDRESS + offset + group * 4);

	return *p;
}

void intc_write_register(uint32_t const offset, intc_group_t const group, uint32_t const value) {
	uint32_t volatile * const p = (uint32_t volatile *)(INTC_ADDRESS + offset + group * 4);

	*p = value;
}

void intc_connect(intc_group_t const group, intc_intlevel_t const intlevel, uint16_t const autovector) {
	intc_write_register(INTC_REG_IPR, group, (autovector << INTC_REG_IPR_AUTOVECTOR_OFFSET) | (intlevel << INTC_REG_IPR_INTLEVEL_OFFSET));
}
