/*
 * Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of libat32uc3.
 *
 * libat32uc3 is licensed under the Simplified BSD License
 * (the "License").
 *
 * A copy of the License should be included in the distribution.
 * Alternatively, you may obtain a copy of the License at
 * http://www.opensource.org/licenses/bsd-license.php
 *
 * Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>
 */

#include <at32uc3/gccmacros.h>
#include <at32uc3/interrupts.h>

#include "irqhandlers_common.c"

extern void _exceptions_handle_interrupt0_request(void) GCC_INTERRUPT;
extern void _exceptions_handle_interrupt1_request(void) GCC_INTERRUPT;
extern void _exceptions_handle_interrupt2_request(void) GCC_INTERRUPT;
extern void _exceptions_handle_interrupt3_request(void) GCC_INTERRUPT;

void _exceptions_handle_interrupt0_request(void) {
	irq0_handler();
}

void _exceptions_handle_interrupt1_request(void) {
	irq1_handler();
}

void _exceptions_handle_interrupt2_request(void) {
	irq2_handler();
}

void _exceptions_handle_interrupt3_request(void) {
	irq3_handler();
}
