/*
 * Copyright 2011 Florian Albrechtskirchinger. All rights reserved.
 *
 * This file is part of libat32uc3.
 *
 * libat32uc3 is licensed under the Simplified BSD License
 * (the "License").
 *
 * A copy of the License should be included in the distribution.
 * Alternatively, you may obtain a copy of the License at
 * http://www.opensource.org/licenses/bsd-license.php
 *
 * Author(s): Florian Albrechtskirchinger <falbrechtskirchinger@gmail.com>
 */

#include <at32uc3/mac.h>

uint32_t mac_read_register(uint32_t const offset) {
	uint32_t volatile const * const p = (uint32_t volatile const * const)(MAC_ADDRESS + offset);

	return *p;
}

void mac_write_register(uint32_t const offset, uint32_t const value) {
	uint32_t volatile * const p = (uint32_t volatile * const)(MAC_ADDRESS + offset);

	*p = value;
}
