/* Bring in gd library functions */
#include "gd.h"
/* Bring in standard I/O so we can output the PNG to a file */
#include <stdio.h>

int main() {
  /* Declare the image */
  gdImagePtr im;

  /* Declare output files */
  FILE *pngout, *jpegout;

  /* Declare color indexes */
  int black;  int white; int cyan; int orange;

  /* Allocate the image: 64 pixels across by 64 pixels tall */
  im = gdImageCreate(64, 64);

   /* Allocate the color black (red, green and blue all minimum).
      Since this is the first color in a new image, it will
      be the background color. */
  black = gdImageColorAllocate(im, 0, 0, 0);

  /* Allocate the color white (red, green and blue all maximum). */
  white = gdImageColorAllocate(im, 255, 255, 255);

  /* Allocate the color cyan and orange. */
  cyan    = gdImageColorAllocate(im, 0, 192, 255);
  orange  = gdImageColorAllocate(im, 255, 128, 0);

  /* Draw a line from the upper left to the lower right,
     using white color index. */
  gdImageLine(im, 0, 0, 63, 63, white);
  gdImageLine(im, 15, 0, 15, 63, cyan);
  gdImageLine(im, 31, 0, 31, 63, orange);

  /* Open a file for writing. "wb" means "write binary", important
     under MSDOS, harmless under Unix. */
  pngout = fopen("test.png", "wb");

  /* Do the same for a JPEG-format file. */
  jpegout = fopen("test.jpg", "wb");

  /* Output the image to the disk file in PNG format. */
  gdImagePng(im, pngout);

  /* Output the same image in JPEG format, using the default
     JPEG quality setting. */
  gdImageJpeg(im, jpegout, -1);

  /* Close the files. */
  fclose(pngout);
  fclose(jpegout);

  /* Destroy the image in memory. */
  gdImageDestroy(im);

  return(0);
}
