/* -------------------------------------------------------------------------- *
 * file:         edacsweb.c                                                   *
 * purpose:      collection of functions used in edacsweb CGI's               *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <cgic.h>
#include "../edacs.h"

/* functions */
void sigint_handler(void) {
  cgi_error("Error: Program Cought SIGINT\n");
  _abort_flag++;
}

#ifdef ORACLE_DB
int col_count(sqlo_db_handle_t dbh, char * table_name) {
  int stat;
  if ( 0 > (stat = sqlo_count(dbh, "USER_TAB_COLUMNS", "TABLE_NAME",
                              table_name, NULL)))
    cgi_error(sqlo_geterror(dbh));
  return stat;
}
#endif

void get_dns_name(char *ip) {
  struct hostent *host;
  struct in_addr *my_addr;

  strncpy(dns_name, "unknown", sizeof(dns_name));
  my_addr=(struct in_addr*)malloc(sizeof(struct in_addr));
  my_addr->s_addr=inet_addr(ip);
  host = gethostbyaddr((char *) my_addr, 4, AF_INET);
  if(host != NULL) strncpy(dns_name, host->h_name, sizeof(dns_name));
}

char * calc_units (char * src, char * dst) {
  char buf[255] = "";
  div_t result;
  unsigned long long terabyte = 1099511627776; /* (1024*1024*1024*1024) */
  unsigned long gigabyte = 1073741824;         /* (1024*1024*1024)      */
  unsigned long megabyte = 1048576;            /* (1024*1024)           */
  unsigned long kilobyte = 1024;               /* (1024)                */

  if(atoll(src) > terabyte) {
    result = div(atoll(src), terabyte);
    sprintf(buf, "%d", result.rem);
    sprintf(dst, "%d.%.2s TB", result.quot, buf);
    return dst;
  }
  else if(atoll(src) > gigabyte) {
    result = div(atoll(src), gigabyte);
    sprintf(buf, "%d", result.rem);
    sprintf(dst, "%d.%.2s GB", result.quot, buf);
    return dst;
  }
  else if(atoll(src) > megabyte) {
    result = div(atoll(src), megabyte);
    sprintf(buf, "%d", result.rem);
    sprintf(dst, "%d.%.2s MB", result.quot, buf);
    return dst;
  }
  else if(atoll(src) > kilobyte) {
    result = div(atoll(src), kilobyte);
    sprintf(buf, "%d", result.rem);
    sprintf(dst, "%d.%.2s KB", result.quot, buf);

    return dst;
  }
  else {
    sprintf(dst, "%s Bytes", src);
  }
  return dst;
}
