/* -------------------------------------------------------------------------- *
 * file:	 handle_error.c                                               *
 * purpose:      provides a standard error page for all cgi's                 *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>     /* for exit() */
#include <cgic.h>
#include "../edacs.h"

/* -------------------------------------------------------------------------- *
 * handle_error_cgi is the error handler for web cgi programs                 *
 * ---------------------------------------------------------------------------*/
void handle_error_cgi(const char *file, int lineno, const char *msg) {
   static char title[] = "System Error Information";

/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/

   pagehead(title);
   fprintf(cgiOut, "<div id=\"content\">\n");

   fprintf(cgiOut, "<h3>%s Error</h3>\n", EDACSWEB_VERSION);
   fprintf(cgiOut, "<hr>");
   fprintf(cgiOut, "<ul><li>file: %s line: %d error: %s</li></ul>\n", file, lineno, msg);

   fprintf(cgiOut, "<h3>Additional Information</h3>\n");
   fprintf(cgiOut, "<hr>");

   fprintf(cgiOut, "For most common errors, please see section 7 under <a href=\"edacsweb-help.cgi\">EDAcSweb Help</a>.\n");
   fprintf(cgiOut, "For loader errors, section 3 under <a href=\"edacsdb-help.cgi\">Loader Help</a>.\n");
   fprintf(cgiOut, "If the problem persists, please contact me at <a href=\"mailto:%s\">%s</a>\n", CONTACT_EMAIL, CONTACT_EMAIL);
   fprintf(cgiOut, "with the info above. For loader problems please check the %s directory ",ERROR_DIR);
   fprintf(cgiOut, "for a SQL file containing any troublesome statement(s).");
   fprintf(cgiOut, "</p>");
   pageside();
   pagefoot();
   exit(-1);
}
