/* -------------------------------------------------------------------------- *
 * file:         pagehead.c                                                   *
 * purpose:      provides a standard page header across all cgi's             *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <cgic.h>
#include "../edacs.h"

void pagehead(char* title) {
  int ret;
  FILE *fp;

  cgiHeaderContentType("text/html; charset=UTF-8");
  fprintf(cgiOut, "<html>\n");
  fprintf(cgiOut, "<head>\n");

  fprintf(cgiOut, "<link rel=\"stylesheet\" type=\"text/css\" href=\"../style/style.css\" media=\"screen\" />\n");
  fprintf(cgiOut, "<meta name=\"Title\" content=\"EDAcS - %s\" />\n", title);
  fprintf(cgiOut, "<meta name=\"Description\" content=\"Enterprise Dialin Accounting System EDAcS\" />\n");
  fprintf(cgiOut, "<meta name=\"Keywords\" content=\"Radius, Tacacs, Session tracking, Accounting\" />\n");
  fprintf(cgiOut, "<title>EDAcS - %s</title>\n", title);
  fprintf(cgiOut, "</head>\n");

  fprintf(cgiOut, "<body>\n");
  fprintf(cgiOut, "<div id=\"wrapper\">\n");
  fprintf(cgiOut, "<div id=\"banner\">\n");
  fprintf(cgiOut, "<h1>EDAcS - %s</h1>\n", title);
  fprintf(cgiOut, "<h2>The Enterprise Remote Login Accounting System</h2>\n");
  fprintf(cgiOut, "</div>\n");

  if ((fp = fopen(NAVI_TEMPL, "r"))) {
    for(;;) {
       ret = getc(fp);
       if(ret == EOF) break;
       fprintf(cgiOut, "%c", ret);
     }
  }
}
