/* ---------------------------------------------------------------------------*
 * file:        oracle.h                                                      *
 * purpose:     provide standard definitions accross cgi's                    *
 * author:      17/05/2010 Frank4DD                                           *
 * ---------------------------------------------------------------------------*/
#include <sqlora.h>

/**********************************************************************/
/********* edacsdb Oracle database settings defined here **************/
/**********************************************************************/
#define EDACSADMIN     "edacsadmin"
#define DB_TNS_STRING  "edacsadmin/mypasswordhere@work2"
//#define DB_ORACLE_ENV  "ORACLE_HOME=/var/edacsdb/oracle"
#define DB_ORACLE_ENV "ORACLE_HOME=/u01/app/oracle/product/10.1.0/db_1"

/**********************************************************************/
/********* edacsweb Oracle database settings defined here *************/
/**********************************************************************/
#define EDACSUSER      "edacsuser"
#define WEB_TNS_STRING "edacsuser/mypasswordhere@work2"
//#define WEB_ORACLE_ENV "ORACLE_HOME=/var/edacsdb/oracle"
#define WEB_ORACLE_ENV "ORACLE_HOME=/u01/app/oracle/product/10.1.0/db_1"

/**********************************************************************/
/*************** no changes required below this line ******************/
/**********************************************************************/

/* Oracle static table defines */
#define TEMP_TABLE "EDACS_TEMPLOG"
#define TEMP_TABLE_COLCOUNT 14

/* function definitions */
#define dbs_error(_dbh, _msg) handle_error_dbs(_dbh, __FILE__, __LINE__, _msg)
#define RETURN_ON_ABORT if (_abort_flag) { sqlo_rollback(dbh); return EXIT_FAILURE; }

/* function prototypes */
void handle_error_ldr(const char *file, int lineno, const char *msg);
void handle_error_cgi(const char *file, int lineno, const char *msg);
void handle_error_dbs __P((sqlo_db_handle_t dbh, CONST char *file, int lineno,
                        const char * msg));

int col_count __P((sqlo_db_handle_t dbh, char * table_name));

/* global defined variables */
sqlo_db_handle_t dbh;           /* database connection handle 

/****************************** end edacs.h *********************************/
