#include <stdio.h>
#include <string.h>
#include "linux-sio.h"
#include <termios.h>

int main(int argc, char **argv)
{
	int ret;
	int nbytes;
	struct termios oldtio,newtio;
	MuxConnection* connection;
	char buf[CMDLINE_LEN+1];
	int repeat_times = 10;
	int i = 0;

	if (argc == 1)
	{
		connection = mux_open (1, "/dev/ttyUSB4", 115200);
	}
	else
	{
		connection = mux_open (1, argv[1], 115200);
	}
	if (connection == NULL)
	{
		return -1;
	}


	while (1)
	{
		size_t len;
		int start  = 0;
		int end = 0;

		/* get AT command from stdin */
		fgets (buf, CMDLINE_LEN-1, stdin);
		len = strlen (buf);
		buf[len] = buf[len-1];
		buf[len-1] = '\r';
		buf[len+1] = '\0';
		if (strcmp (buf, "quit\r\n") == 0)
		{
			break;
		}
		mux_write (connection, buf, strlen (buf));
		start = get_cur_time ();

		/*
		   snprintf (buf, 100, "AT+CPBR=%d\r\n", i%100);
		   mux_write (connection, buf, strlen (buf));*/

		while (1)
		{
			ret = mux_select (connection, 8000);
			if (ret <= 0)
			{
				printf ("Error to wait serial.\n");
				break;
			}

			nbytes = mux_read (connection, buf, CMDLINE_LEN);
			buf[nbytes] = 0;
			if (strstr (buf, "OK") != NULL || (strstr (buf, "ERROR") != NULL))
			{
				end = get_cur_time ();
				printf ("read data: %s\n", buf);
				printf ("use time=%d\n", end - start);
				break;
			}
		}
		i++;

/*
		ret = mux_select (connection, -1);
		nbytes = mux_read (connection, buf, CMDLINE_LEN);
		buf[nbytes] = '\0';
		printf("%s\n", buf);
*/
	}

	mux_close (connection);
	return 0;
}


