/* File: gpushd.h

   Copyright (c) 2011 David Hauweele <david@hauweele.net>
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:
   1. Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
   3. Neither the name of the University nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
   SUCH DAMAGE. */

#ifndef _GPUSHD_H_
#define _GPUSHD_H_

#define REQUEST_TIMEOUT 1
#define MAX_ENTRY       UINT16_MAX

enum cmd { CMD_QUIT,
           CMD_END,
           CMD_PUSH,
           CMD_POP,
           CMD_POPF,
           CMD_CLEAN,
           CMD_GET,
           CMD_GETF,
           CMD_GETALL,
           CMD_RESPS,
           CMD_RESPI,
           CMD_SIZE,
           CMD_NBCLI,
           CMD_NBSRV,
           CMD_NBRCV,
           CMD_NBSND,
           CMD_NBERR,
           CMD_MAXNSEC,
           CMD_MINNSEC,
           CMD_SUMNSEC,
           CMD_ERROR };

enum proto_error { E_PERM,
                   E_INVAL,
                   E_EMPTY,
                   E_NFOUND,
                   E_LONG,
                   E_FULL };

#endif /* _GPUSHD_H_ */
