/********************************************************************
*																	*
*							Scene.c									*
*																	*
*	Author:		Steven Johnson										*
*	Purpose:	Contains implementation of scene tool				*
*																	*
********************************************************************/

#include "Scene.h"

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/********************************************************************
*																	*
*							External includes						*
*																	*
********************************************************************/
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include "ADT.h"
#include "Resources.h"

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/********************************************************************
*																	*
*							Construction							*
*																	*
********************************************************************/
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/********************************************************************
*	InitializeSceneObject - Initialize primary scene object			*
********************************************************************/

BOOL InitializeSceneObject (Scene * sceneObj)
{
	ZeroMemory (sceneObj, sizeof (Scene));

	return TRUE;
	// Return success
}

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/********************************************************************
*																	*
*							Cutscene methods						*
*																	*
********************************************************************/
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/********************************************************************
*	BeginScene - Initializes a scene for playback					*
********************************************************************/

void BeginScene (Scene * sceneObj, dataType type, long lParam)
{
	sceneObj->bField  = sceneObj->bField2  = sceneObj->bField3  = 0;
	sceneObj->wField  = sceneObj->wField2  = sceneObj->wField3  = 0;
	sceneObj->dwField = sceneObj->dwField2 = sceneObj->dwField3 = 0;
}

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/********************************************************************
*																	*
*							Destruction								*
*																	*
********************************************************************/
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/********************************************************************
*	DeinitializeSceneObject - Deinitialize a scene object			*
********************************************************************/

BOOL DeinitializeSceneObject (Scene * sceneObj)
{
	DeleteVisuals (&sceneObj->visuals);

	return TRUE;
	// Return success
}
