#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lua.h>
#include <lauxlib.h>
#include <time.h>

#include "SDLTk.h"

#include "mt.h"

/*
 * Global variables
 */
lua_State *L;
SDL_Window *window;


int W_WIDTH = 1024;
int W_HEIGHT = 600;


int ORI_ITEM_NUMBER = 0;
int ITEM_NUMBER = 0;
int flow_count = 0;
int leave = 0;
int answer = 0;
char has_char = 0;
int all_pass = 0;
int fresh_display = 1;
int burnin_run = 1;
int burnin_kill = 0;
//SDL_Widget *fresh_label[7] = {NULL};

int main(int argc, char **argv)
{
	SDL_Surface *video;

	L = luaL_newstate();
	luaL_openlibs(L);

        loadFile(L, "person.conf");        	
	loadFile(L, "../../config.txt");
	loadFile(L, "../../lib/mt_lib.lua");
	loadFile(L, "../../lib/err_base.txt");
	createLogFiles();
	
	loadFile(L, "origin_flow.txt");
	registerFuncs4Lua();
	registerApplets4Lua();

	SDL_Init(SDL_INIT_VIDEO);
	enumerate_sdl_modes( &W_WIDTH, &W_HEIGHT, stderr );
	video = SDL_SetVideoMode(W_WIDTH,W_HEIGHT, 32, SDL_FULLSCREEN|SDL_ANYFORMAT);  //SDL_HWSURFACE
	atexit(SDL_Quit);
	
	SDLTk_Init();
	window = SDL_WindowNew(0,0,W_WIDTH,W_HEIGHT);
/*
        int color[7]={0x00ff0000, 0x00ffa500, 0x00ffff00, 0x00800000, 0x0000ffff, 0x000000ff, 0x00800080};	
	int i = 0;
	for( i = 0; i< 7;++i)
	        fresh_label[i] = (SDL_Widget *)drawLabel( color[i]);
*/	
	
	char buf_s[64] = {0};
	char buf_v[64] = {0};
	char *station = (char *)getTableElement(L, "con", "STATION");
	strcat(buf_s, station);
	char *version = (char *)getTableElement(L, "con", "VERSION");
	strcat(buf_v, version);
	preface(buf_s, buf_v);

	SDL_WindowOpen(window);


#if 1
    while(!leave)
    {
        extern SDL_Widget *button_ensure;
        SDL_Event event;
        memset(&event, 0,sizeof(SDL_Event));
        while( !leave && SDL_WaitEvent(&event)) 
        {
            switch(event.type)
            {
            case SDL_QUIT:
                burnin_kill = 1;
                return 9;
            case SDL_KEYUP:
//            	printf("you typed a key.\n");
                printf( "keydown: %d, keyup: %d\n", SDL_KEYDOWN, SDL_KEYUP);
                
            	processKeyInput( &event.key );
            	break;
            default:
                SDLTk_PushEvent(&event);
                break;
            }
            
        }
    }

#endif

//        SDL_Quit();
//	SDLTk_Main();
    	lua_close(L);
    	exit(0);
    	return 0;
}
