#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lua.h>
#include <lauxlib.h>

#include "SDLTk.h"

#include "mt.h"

void createLogFile(char *fn)
{
	char buf[128];	
	extern lua_State *L;
	FILE *fp;

	// ATTEN: notice that these codes here seems redundant, 
	// but should write like this for lua's stack mechanism.

//	char buf0[64];
//	sprintf(buf0, "%s", fn);
	sprintf(buf, "%s", fn);
	
//	char *sf = (char *)getTableElement(L, "logs", "SDIR");
//	sprintf(buf, "%s", sf);
//	strcat(buf, buf0);
	printf( "createlogfile: %s\n", buf);
	
	if ((fp = fopen(buf, "w")) == NULL) {
		fprintf(stderr, "Can not create file: %s.\n", buf);
		exit(-1);
	}
	fclose(fp);
				
}

void createLogFiles()
{
	extern lua_State *L;
	char *fn;
	
	fn = (char *)getTableElement(L, "logs", "logfile");
	createLogFile(fn);
	
	fn = (char *)getTableElement(L, "logs", "errfile");
	createLogFile(fn);
	
	fn = (char *)getTableElement(L, "logs", "err_details");
	createLogFile(fn);
	
	fn = (char *)getTableElement(L, "logs", "mbsnfile");
	createLogFile(fn);
	
	fn = (char *)getTableElement(L, "logs", "psnfile");
	createLogFile(fn);

	fn = (char *)getTableElement(L, "logs", "skufile");
	createLogFile(fn);

}


void fatal (int ret, char *format, ...)
{
  va_list ap;

  fprintf (stderr, "fatal error: ");
  va_start (ap, format);
  vfprintf (stderr, format, ap);
  va_end (ap);
  if (ret == 1)
    fprintf (stderr, "Wrong parameters!\n");
  exit (ret);
}



int enumerate_sdl_modes (int *width, int *height, FILE *out)
{
  SDL_Rect **modes;
  int w = -1;
  int h = -1;
  int m = -1;
  int i;

  modes = SDL_ListModes (NULL, SDL_HWSURFACE | SDL_FULLSCREEN);

  if (! modes)
    fatal (2, "no SDL display modes available\n");

  if (modes == (SDL_Rect **) -1)
    fatal (2, "all SDL resolutions available (on hardware?)\n");

  for (i = 0; modes [i]; i++)
  {
	if (out)
		fprintf (out, "  mode %d: %d x %d\n", i, modes [i]->w, modes [i]->h);
	// find the largest resolution for the screen
	if ((modes [i]->w >= w) && (modes [i]->h >= h))	{
		w = modes [i]->w;
		h = modes [i]->h;
		m = i;
	}
	
  }

  if (m < 0)
    fatal (2, "no matching SDL video modes found\n");

  *width = w;
  *height = h;
  return (m);
}

