#include <stdio.h>
#include <lua.h>
#include <lauxlib.h>

#include "SDLTk.h"
#include "mt.h"


extern int W_WIDTH;
extern int W_HEIGHT;

extern SDL_Window *window;

SDL_Widget *radio[NN];
SDL_Widget *label_status = NULL;

SDL_Widget *button_ok = NULL;

// Global varibles
char* radios[NN] = { NULL };
//---------------------------------------------
int getFlowFromConfig(const char *str)
{
	extern lua_State *L;
	extern int ORI_ITEM_NUMBER;
	
	size_t len;
	int i;
	
	lua_getglobal(L, "con");
	if (!lua_istable(L, -1)) {
		fprintf(stderr, "The table 'con' doesn't exist.\n" );
		return -1;
	}
	
	lua_getfield(L, -1, str);
	if (!lua_istable(L, -1)) {
		fprintf(stderr, "The table 'con.ORI_FLOW' doesn't exist.\n" );
		return -1;
	}
	len = lua_objlen(L, -1);
	fprintf(stderr, "%d\n", len);
	ORI_ITEM_NUMBER = len;
	
	for (i=0; i<len; i++) {
		
		lua_rawgeti(L, -1, i+1);
		if (!lua_isstring(L, -1)) {
			fprintf(stderr, "This string doesn't exist.\n" );
			return -1;
		}
		radios[i] = (char *)lua_tostring(L, -1);
		lua_pop(L, 1);
	}
	
	lua_pop(L, 2);
	
	return 0;

}

int drawRadio()
{
	extern int ORI_ITEM_NUMBER;
	int i, n;
	int x, y;
	char buf[64] = {0};

	for (i=0; i<ORI_ITEM_NUMBER; i++) {
	
		if (i < 10 ) {
			x = MARGIN;
			y = R_S_y + R_HEIGHT*i;
		}
		else if (i < 20) {
			x = MARGIN + 200;
			y = R_S_y + R_HEIGHT*(i - 10);	
	    	}
	    	else {
			x = MARGIN + 400;
			y = R_S_y + R_HEIGHT*(i - 20);	
	    	}
	    	
	    	radio[i] = SDL_RadioButtonNew();
	    	// ((SDL_RadioButton *)radio[i])->State = 0;
	    	SDL_WidgetSetDims(radio[i], x, y,100,20);
	    	sprintf(buf, "%d. %s", i + 1, radios[i]);
	    	SDL_RadioButtonSetText(radio[i], buf);
	    	
	    	SDL_WidgetShow(radio[i]);
    
	}
	
}


void drawButtonSelAll()
{
	SDL_Widget *button_sel_all;
	
	button_sel_all = SDL_ButtonNew();
	SDL_WidgetSetDims(button_sel_all, W_WIDTH - 100, W_HEIGHT - 80, 60, 30);
	SDL_ButtonSetLabel(button_sel_all, "All");
	SDL_SignalConnect(button_sel_all,"clicked",(T_Signal_Callback)callback_button_sel_all, NULL);
	SDL_WidgetShow(button_sel_all);
}

void drawButtonOk()
{
	
	button_ok = SDL_ButtonNew();
	SDL_WidgetSetDims(button_ok, W_WIDTH - 100, W_HEIGHT - 40, 60, 30);
	SDL_ButtonSetLabel(button_ok, "OK");
	SDL_SignalConnect(button_ok,"clicked",(T_Signal_Callback)callback_button_ok, NULL);
	SDL_WidgetShow(button_ok);
}

void drawButton()
{
	//drawButtonSelAll();
	//drawButtonOk();
	drawButtonLeave();
}

void drawStatusBar()
{
	label_status = SDL_LabelNew();
	SDL_WidgetSetDims(label_status, MARGIN, W_HEIGHT - MARGIN - 25, 400, 25);
	SDL_LabelSetText(label_status, "Press anykey to continue...");
	SDL_LabelSetAlignment(label_status, CENTERLEFT);
	((SDL_Label *)label_status)->fgcolor = 0x000000ff;
	SDL_WidgetShow(label_status);
}

void printHead( char *station, char *version)
{
	char buf[64];
	SDL_Widget *label_head;
	
	sprintf(buf, "%s %s", station, version);
	label_head = SDL_LabelNew();
	SDL_WidgetSetDims(label_head, 300, MARGIN, 400, 80);	
	SDL_LabelSetAlignment(label_head, CENTER);
	((SDL_Label *)label_head)->bgcolor = 0x00000000;
	((SDL_Label *)label_head)->fgcolor = 0x00ff00ff;
	SDL_LabelSetText(label_head, buf);

	SDL_WidgetShow(label_head);
}


void preface( char *station, char *version )
{
	printHead( station, version);
	drawLine_Style1();

    	getFlowFromConfig("ORI_FLOW");
	drawRadio();
	
	drawStatusBar();
	
	drawButton();
	
	SDL_Delay(1000);
	// skip menu, auto run
	callback_button_ok();

}
