#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lua.h>
#include <lauxlib.h>

#include "SDLTk.h"
#include "applet.h"

#define SHOW_KEY	0x2
#define LISTEN_KEY	0x1
#define DIS_KEY		0x0
#define SUM_KEY		80
#define LINE_KEY	6
#define FUNC_KEY	5

typedef struct {
//        int		scancode;
        int		x,y;
        int		width, height;
        int		flag;
        Keyboard_Data	*data;
        SDL_Widget	*key;        
}User_Key;

User_Key *newKey( int scancode, int *sum)
{
        printf("create key\n");

        User_Key *key	=	(User_Key *) malloc( sizeof(User_Key));
        memset( key, 0,sizeof( User_Key));
        
//        key->scancode	=	scancode;
        key->x			=	0;
        key->y			=	0;
        key->width		=	0;
        key->height		=	0;
        key->flag		=	0;
        key->key		=	SDL_ButtonNew();        
                        
        key->data		=	(Keyboard_Data *)malloc( sizeof( Keyboard_Data));

        key->data->scancode	=	scancode;
        key->data->ispressed	=	0;
        key->data->sum		= 	sum;
        
        SDL_ButtonSetSignalSwitch( key->key, BUTTON_LEFT_SWITCH, DISABLE);
/*
        SDL_ButtonSetSignalSwitch( key->key, BUTTON_KEYDOWN_SWITCH, ENABLE);
        SDL_SignalConnect( key->key, "keydown", (T_Signal_Callback)callback_keydown_keyboard,(void*) key->data);
*/
        
//	SDL_LabelSetListen( Key->Label, KEYDOWN, LISTEN_KEY);
//	SDL_SignalConnect( Label, "keydown", callback_keydown, (void *) key);        
//        if (isListenKey)
//                SDL_LabelSetListen( key->Label, LISTEN_KEY)
        
        return key;
}

int  getKeyIspressed( User_Key *key)
{
        if( !key)
                return -1;
        return key->data->ispressed;
}

void setKeyPressed( User_Key *key)
{
        if( !key)
                return;
        key->data->ispressed = 1;
}
void setKeydownSignal( User_Key *key)
{
        printf( "scancode %d, flag %d\n" ,key->data->scancode, key->flag);
        if( key->flag & (0x1<< LISTEN_KEY))
        {
                SDL_ButtonSetSignalSwitch( key->key, BUTTON_KEYDOWN_SWITCH, ENABLE);
                SDL_SignalConnect( key->key, "keydown", (T_Signal_Callback)callback_keydown_keyboard,(void*) key->data);        
        }
        
}

void setKeyFlag( User_Key *key, int flag)
{
        key->flag = flag;
}

void setKeyTitle( User_Key *key, char *keyname)
{
        if ( !key->key)
                key->key = SDL_LabelNew();
        
        SDL_ButtonSetLabel( key->key, keyname);
}

void setKeyDims( User_Key *key, int x, int y, int width, int height)
{
        key->x = x;
        key->y = y;
        key->width = width;
        key->height = height;
}

void showKey( User_Key *key)
{                
       // printf( "scancode: %d, x: %d, y: %d, width: %d, height: %d\n",key->data->scancode, key->x, key->y, key->width, key->height);
        if ( key->key == NULL)
                printf( "key->Label is null.\n");                
        
        SDL_WidgetSetDims( key->key, key->x, key->y, key->width, key->height);
                
        SDL_WidgetShow( key->key);
}

void deleteKey( User_Key *key)
{
        if( key->key)
        {
                SDL_ButtonClose( key->key);
                key->key=NULL;
        }
        
        if( key->data)
        {
                free(key->data);
                key->data = NULL;
        }
                        
        free( key);
        key =NULL;
        // refreshWin();
}

User_Key *drawKey( int enableFn, int scancode, int x, int y, int width, int height, int flag, int *sum, char *keyname)
{
        
        User_Key *key = newKey( scancode, sum);

        setKeyTitle( key, keyname);
        setKeyFlag( key, flag);

        setKeydownSignal( key);
                
        setKeyDims( key, x, y, width, height);
        //if( !enable)
        
        printf( "show key \n");
        
        showKey( key);
        return key;
}

int drawKeyboard( int enableFn)
{
        
        char keyname[SUM_KEY][6]={"Ese","~","F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","PgUp","PgDn","Ins","Del",	
                                "1","2","3","4","5","6","7","8","9","0","-","=","BS",						
                                "Tab","Q","W","E","R","T","y","U","I","O","P","[","]","\\",
                                "Caps","A","S","D","F","G","H","J","K","L",";","'","Enter",
                                "Shift","Z","X","C","V","B","N","M",",",".","/","Up","Shift",
                                "Fn","Ctrl","Menu","Alt","Space","Alt","Paste","Left","Down","Right"};
        
        int keyLoyout[LINE_KEY] = {17,13,14,13,13,10};
                
        int keyvalue[SUM_KEY]={ 0x01, 0x29, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, 0x40, 0x41, 0x42, 0x43, 0x44, 0x57, 0x68, 0x6D, 0x6E, 0x6F,
                                0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E,
                                0x0F, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x2B,
                                0x3A, 0x1E, 0x1F, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x1C,
                                0x2A, 0x2C, 0x2D, 0x2E, 0x2F, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x67, 0x36,
                                0x00, 0x1D, 0x7D, 0x38, 0x39, 0x64, 0x7F, 0x69, 0x6C, 0x6A};
        // funckey index 	 /fn	up 	down	right	left/	      
        int funckey[ FUNC_KEY] = {70,	68,	78,	79,	77};
        int funckey_block = 5;
        int funckey_start = 5;
        char funckey_mask[5] = "0x01";
        
         
        int initx = 90, inity = 200;
        int all_width = 850, all_height=200;
        int w1 = 50, h1 = 30;
        int w2 = 60, h2 = 40;
        int w3 = 40;
        int w4 = 40;
        int flag = 0x3;
        int i, j, k, sum;
        int *sum_key = (int*) malloc( sizeof( int));
        memset( sum_key, 0, sizeof( int));
        
        int rules[LINE_KEY][8] ={
                {16,	w1,	1,	0,	-1,	-1,	-1,	-1},
                {12,	w2,	1,	0,	-1,	-1,	-1,	-1},
                {1,	w1,	10,	w2,	2,	w1,	1,	0},
                {10,	w2,	2,	w4,	1,	0,	-1,	-1},
                {1,	0,	11,	w2,	1,	w2,	-1,	-1},
                {2,	w2,	2,	w1,	1,	0,	5,	w2}};
                
        int start_pair[LINE_KEY][3] = {
                {10,		1,	h1},
                {10+h1,		1,	h2},
                {10+h1+h2,	1,	h2},
                {10+h1+2*h2,	1,	h2},
                {10+h1+3*h2,	1,	h2},
                {10+h1+4*h2,	1,	h2}};
        
        for( i = 0; i < LINE_KEY; ++i)
        {
                k = 0;
                for( j = 0; j < 8; ++j)
                        if( !rules[i][j]) 
                        { 
                                k = j; 
                                break;
                        }
                
                sum = 0;
                
                for( j = 0; j< 8/2; ++j)
                        if ( rules[i][2*j] != -1)
                                sum += rules[i][2*j]*rules[i][2*j+1];
                
                rules[i][k] = all_width - sum;
                        
        }         
                
                
        // creat key
        User_Key *key[SUM_KEY];
        int line = 0, keynum = 0;
        int x = initx;
        char str[6] = {0};
        i = 0; j = 0; k = 0;
                
        for ( i = 0; i < LINE_KEY; ++i)
        {	
                x = initx; 
                
                for (j = 0; j < 8/2; ++j)
                {
                        if (rules[i][2*j] ==-1) break;
                                
                        sum = rules[i][2*j];
                        
                        for ( k = 0; k < sum; ++k)
                        {	
                                memset( str, 0, strlen(str));
                                
                                if ( enableFn)
                                {
                                        
                                        if( keynum == funckey[0] || keynum == funckey[1] || keynum == funckey[2] || keynum == funckey[3] || keynum == funckey[4])
                                        {
                                                strcpy( str, keyname[keynum]);
                                                flag = 0x1;       
                                        }
                                        else
                                        {
                                                flag = 0x1;
                                        }
                                }
                                else
                                {
                                        if ( keynum != funckey[0])                                      
                                        {
                                                strcpy( str, keyname[keynum]);
                                                flag = 0x3;
                                        }
                                        else
                                        {
                                                flag = 0x1;
                                        }
                                }
                                        
                                key[keynum] = drawKey( enableFn, keyvalue[keynum], x, inity + start_pair[i][0], rules[i][2*j+1], start_pair[i][2], flag, sum_key, str);
                                x += rules[i][2*j+1];
                                ++keynum;
                        }        
                }
        }
        i = 0; j = 0; k = 0;  sum = 0;
        if ( enableFn)
        {
                FILE *fp = fopen( "/proc/sci", "r");
                char newline[256] = {0};
                char oldline[256] = {0};
                char *temp = NULL; 
                if(!fp) return 0;
                
                for( i = 0; i < 30000; ++i)
                {
                        //read file
                        if( feof( fp)) break;               
                        fread( newline, 115, 1, fp);
#if 1
                        printf( "new :%s \n", newline);
                        printf( "old :%s \n", oldline);
#endif                                                
                        // newline is null                        
                        if( strlen( newline) < funckey_start + funckey_block * (FUNC_KEY - 1))
                                continue;
                        else if( strlen( oldline) < funckey_start + funckey_block * (FUNC_KEY - 1))
                                strcpy( oldline, newline);
                        else if ( strcmp( oldline, newline))
                        {	
                                        temp = strstr( newline, funckey_mask);
                                        j = (temp - newline - funckey_start)/funckey_block + 1;
                                        
                                        if( j > FUNC_KEY - 1)
                                                continue;
                                        
                                        if ( !getKeyIspressed( key[funckey[j]]))
                                        {
                                                ++sum;
                                                setKeyPressed( key[ funckey[j]]);
                                                setKeyTitle( key[ funckey[j]], "");
                                        }
                                                                                
                                        if ( sum >=4)
                                        {
                                                k = 1;
                                                break;
                                        }
                                        strcpy( oldline, newline);
                        }
                        SDL_Delay(1);
                }                       
                fclose( fp);
        }
        else
        {

                for ( i = 0; i < 300000; ++i)
                {
                        if (*sum_key >= SUM_KEY -2)
                        {
                                k = 1;
                                break;
                        }
                        system( "sleep 0.001");
                }

        }     
        
        system( "sleep 1");
        

        free( sum_key);

        if (k)
                return 0;
        else
                return 1;
}

int drawKeyboard_4lua( lua_State *L)
{
        int enableFn = DISABLE;        
        int ret = drawKeyboard( enableFn);
        putNumber( L, ret);
        
        return 1;
}

int drawFunKey_4lua( lua_State *L)
{
        int enableFn = ENABLE;        
        int ret = drawKeyboard( enableFn);
        putNumber( L, ret);
        
        return 1;
}


