#include <stdio.h>
#include <string.h>
#include <lua.h>
#include <lauxlib.h>
#include <unistd.h>
#include <sys/syscall.h>
#include <sys/time.h>

#include "SDL_thread.h"
#include "SDLTk.h"
#include "mt.h"



void callback_button_leave()
{
	extern int leave;
	fprintf(stderr, "you clicked leave button!\n");
	
	SDL_WindowClose();
	SDL_Quit();
	
	leave = 1;

}

void callback_button_sel_all()
{
	extern SDL_Widget *radio[];
	extern int ORI_ITEM_NUMBER;
	
	SDL_RadioButton *radio_b;
	int i = 0;
	int count = 0;
	
	for (i=0; i<ORI_ITEM_NUMBER; i++) {
		radio_b = (SDL_RadioButton *)radio[i];
		if (radio_b->State == 1) {
			count++;
		}
	}
	
	for (i=0; i<ORI_ITEM_NUMBER; i++) {
		
		radio_b = (SDL_RadioButton *)radio[i];
		if (count < ORI_ITEM_NUMBER) {
			if (radio_b->State == 0) radio_b->State = 1;
		}
		else {
			radio_b->State = 0;
		}
		SDL_WidgetRedrawEvent(radio[i]);
	
	}
}

void callback_button_ok()
{
	extern lua_State *L;
	extern int ORI_ITEM_NUMBER;
	extern int ITEM_NUMBER;
	extern SDL_Widget *radio[];
	
	extern char *radios[];
	int i;
	
	SDL_RadioButton *radio_b;
	FILE *fp = NULL;
	
	if ((fp=fopen("flow.txt", "w")) == NULL) {
		printf("Cann't create file flow.txt\n");
		exit(1);
	}
	
	fprintf(fp, "con.FLOW = {\n");
	
	for (i=0; i< ORI_ITEM_NUMBER; i++) {
		radio_b = (SDL_RadioButton *)radio[i];
		
		if (radio_b->State == 1) {
			fprintf(fp, "\t\"%s\",\n", radios[i]);//(char *)radio_b->Label);
		}
	}
	
	fprintf(fp, "}\n");
	fclose(fp);
		
	// load the new flow file and add FLOW to global environment 
	loadFile(L, "flow.txt");
	lua_getglobal(L, "con");
	if (!lua_istable(L, -1)) {
		fprintf(stderr, "The table 'con' doesn't exist.\n" );
		exit(-1);
	}
	
	lua_getfield(L, -1, "FLOW");
	if (!lua_istable(L, -1)) {
		fprintf(stderr, "The table 'con.FLOW' doesn't exist.\n" );
		exit(-1);
	}
	ITEM_NUMBER = lua_objlen(L, -1);
	fprintf(stderr, "%d\n", ITEM_NUMBER);
	
	getFlowFromConfig("FLOW");
	
	lua_pop(L, 2);
	
	// go to execute the body.
	go();


}

void callback_button_yes()
{	
	extern SDL_Widget *button_yes;
	extern SDL_Widget *button_no;
	extern int answer;
	answer = 121;
	SDL_WidgetClose(((SDL_Button *)button_yes)->Label);
	SDL_WidgetClose(button_yes);
	SDL_WidgetClose(((SDL_Button *)button_no)->Label);
	SDL_WidgetClose(button_no);
	refreshWin();
}

void callback_button_no()
{	
	extern SDL_Widget *button_yes;
	extern SDL_Widget *button_no;
	extern int answer;
	answer = 110;
	SDL_WidgetClose(((SDL_Button *)button_yes)->Label);
	SDL_WidgetClose(button_yes);
	SDL_WidgetClose(((SDL_Button *)button_no)->Label);
	SDL_WidgetClose(button_no);
	refreshWin();
}


void callback_button_ensure()
{	
	extern int flow_count;
	extern int ITEM_NUMBER;
	extern int all_pass;
	
	if (flow_count < ITEM_NUMBER) {
		go();
	}
	else {
		clearWin();
		if (all_pass) {
			printPassResult();
		}
		else {
			printFailResult();
		}
	}
}

void callback_button_poweroff()
{
	callback_button_leave();
	
	system( "poweroff" );

}

void callback_button_retest()
{
	extern lua_State *L;
	extern int flow_count;
	extern int ITEM_NUMBER;
	
	clearWin();
	char buf[64] = {0};

	char *station = (char *)getTableElement(L, "con", "STATION");
	strcat(buf, station);
	strcat(buf, " ");
	char *version = (char *)getTableElement(L, "con", "VERSION");
	strcat(buf, version);
	
	if (flow_count >= ITEM_NUMBER) {
		flow_count = 0;
		preface( buf );
	}
	else {
		go();
	}


}

void callback_button_finish()
{
	extern lua_State *L;
	extern int leave;

	char buf[128] = {0};
	char station[32] = {0};
    char *tmp;

	tmp = (char *)getTableElement(L, "self", "STAT");
	sprintf( station, "%s", tmp);
	
	tmp = (char *)getTableElement(L, "logs", "ADIR");
	printf( "station: %s , path: %s\n", station, tmp);
	sprintf(buf, "touch %sfunction-%s-pass", tmp, station);
	printf( "buf: %s\n", buf);
	
	system( buf);


	fprintf(stderr, "you clicked leave button!\n");
	
	SDL_WindowClose();
	SDL_Quit();
	
	leave = 1;

}


void callback_input_edit()
{
	extern SDL_Widget *input_edit;
	char *str = SDL_EditGetText(input_edit);
	
	fprintf(stderr, "You input '%s' in Edit.\n", str);

}

void callback_input_edit_changed()
{
	extern SDL_Widget *input_edit;
	extern int edit_length;
	
	char *str = SDL_EditGetText(input_edit);
	
	edit_length = strlen(str);

}

void callback_lbutton_touchpad( SDL_Object *object, void *signaldata, void *userdata)
{
        int *data = (int *)userdata;
        ++(*data);
        printf( "userdata: %d\n", *data);
        SDL_ButtonSetLabel( (SDL_Widget*)object, " ");
}

void callback_rbutton_touchpad( SDL_Object *object, void *signaldata, void *userdata)
{
        int *data = (int *)userdata;
        ++(*data);        
        printf( "userdata %d\n", *data);
        SDL_ButtonSetLabel( (SDL_Widget*)object, " ");
}

void callback_keydown_keyboard( SDL_Object *object, void *signaldata, void *userdata)
{
	extern lua_State *L;
        extern struct timeval tv1, tv2;
        
        Keyboard_Data *data	= (Keyboard_Data *) userdata;
        SDL_Button *Button	= (SDL_Button *) object;        
        SDL_Event *event	= (SDL_Event *) signaldata;
        SDL_Widget *widget	= (SDL_Widget *) object;

        //int getTableNumElement(lua_State *L, char *t, char *element )

        int interval = getTableNumElement( L, "con", "KEYBOARD_INTERVAL");
        char warm_str[256] = {0};
	char *warm_file = (char *)getTableElement(L, "con", "WARM_WAV_FILE");

        //printf( " warm file : %s\n", warm_file);
	sprintf( warm_str, "aplay  %s", warm_file);
        //printf( " warm_str: %s\n", warm_str);
        
        //printf( "scancode: %d, userdata: %d\n", data->scancode, data->ispress);
        if ( data->scancode == event->key.keysym.scancode)
        {
                gettimeofday( &tv1, NULL);
                //printf( "keyboard tv1: %d, %d; tv2: %d, %d; sec: %d, usec: %d\n", tv1.tv_sec, tv1.tv_usec, tv2.tv_sec, tv2.tv_usec, tv1.tv_sec - tv2.tv_sec, tv1.tv_usec - tv2.tv_usec);                
                if ( tv1.tv_sec == tv2.tv_sec && tv1.tv_usec - tv2.tv_usec <  interval)
                {
                        // warm
                        //printf( "press key kkkk\n");
                        //printf( warm_str);
                        //printf( "\n");
                        system( warm_str);       
                        if ( data->ispressed == 0)
                                SDL_StyleTransition( widget, Button->State, SDL_BUTTON_STATE_UP);
                                
                }
                else
                {
                        SDL_StyleTransition( widget, Button->State, SDL_BUTTON_STATE_DOWN);
                        Button->State = SDL_BUTTON_STATE_DOWN;
                        //printf( "scancode: %d\n", data->scancode);                
                        //printf( "press the key: %d\n", event->key.keysym.scancode);
                
                        //printf( "old ispressed: %d sum: %d\n", data->ispressed, *(data->sum));
                        if ( data->ispressed == 0)
                        {
                                ++(*(data->sum));
                                ++data->ispressed;
                        }
                        //printf( "new ispressed: %d sum: %d\n", data->ispressed, *(data->sum));
                        SDL_ButtonSetLabel(widget, "");
                }
                tv2 = tv1;

        }


        
}
