#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lua.h>
#include <lauxlib.h>
#include <sys/time.h>
#include <unistd.h>

#include "SDLTk.h"
//#include "SDL_terminal_private.h"

#include "mt.h"

/*
 * Global variables
 */
lua_State *L;
SDL_Window *window;

struct timeval tv1,tv2;

int W_WIDTH = 1024;
int W_HEIGHT = 600;


int ORI_ITEM_NUMBER = 0;
int ITEM_NUMBER = 0;
int flow_count = 0;
int leave = 0;
int answer = 0;
char has_char = 0;
int all_pass = 0;

int preprocess()
{
	if (getTableBooleanElement(L, "con", "HAVE_PREPROCESS")) {

		chdir("preprocess");
		loadFile(L, "run.lua");
		chdir("..");
	}
	
	return 0;
}

int main(int argc, char **argv)
{
	SDL_Surface *video;

	
	L = luaL_newstate();
	luaL_openlibs(L);

        loadFile(L, "person.conf");        	
	loadFile(L, "../../config.txt");
	loadFile(L, "../../lib/mt_lib.lua");
	loadFile(L, "../../lib/err_base.txt");
	createLogFiles();
	
	preprocess();

	loadFile(L, "origin_flow.txt");
	registerFuncs4Lua();
	registerApplets4Lua();

	printf( "old: width %d  height %d \n", W_WIDTH, W_HEIGHT);
	W_WIDTH = getTableNumElement(L, "con", "W_WIDTH");
	W_HEIGHT = getTableNumElement(L, "con", "W_HEIGHT");
	printf( "new: width %d  height %d \n", W_WIDTH, W_HEIGHT);
	
	SDL_Init(SDL_INIT_VIDEO);
//	enumerate_sdl_modes( &W_WIDTH, &W_HEIGHT, stderr );
//	printf( "last: width %d  height %d \n", W_WIDTH, W_HEIGHT);
	
	video = SDL_SetVideoMode(W_WIDTH,W_HEIGHT, 32, SDL_FULLSCREEN|SDL_ANYFORMAT);  //SDL_HWSURFACE
	atexit(SDL_Quit);
	
	SDLTk_Init();
	window = SDL_WindowNew(0,0,W_WIDTH,W_HEIGHT);
        
        gettimeofday( &tv1, NULL);
        system( "sleep 0.1");
        gettimeofday( &tv2, NULL);

        //printf( "tv1: %d, %d, tv2: %d, %d\n", tv1.tv_sec, tv1.tv_usec, tv2.tv_sec, tv2.tv_usec);
        	
	char buf_s[128] = {0};
	char buf_v[64] = {0};
	char *station = (char *)getTableElement(L, "con", "STATION");
	strcat(buf_s, station);
	char *version = (char *)getTableElement(L, "con", "VERSION");
	strcat(buf_v, version);
	printf( "station: %s, version: %s\n", buf_s, buf_v);
	preface(buf_s, buf_v);

	SDL_WindowOpen(window);


#if 1
    while(!leave)
    {
        extern SDL_Widget *button_ensure;
        SDL_Event event;
        memset(&event, 0,sizeof(SDL_Event));
        while(!leave && SDL_WaitEvent(&event)) 
        {
            switch(event.type)
            {
            case SDL_QUIT:
                return 9;
            case SDL_KEYUP:
//            	printf("you typed a key.\n");
                printf( "keydown: %d, keyup: %d\n", SDL_KEYDOWN, SDL_KEYUP);
                
            	processKeyInput( &event.key );
            	break;
            default:
                SDLTk_PushEvent(&event);
                break;
            }
	    
        }

    }

#endif

//	SDLTk_Main();
    	lua_close(L);
    	return 0;
}
