#include <stdio.h>
#include <string.h>
#include <lua.h>
#include <lauxlib.h>

#include "SDL_thread.h"
#include "SDLTk.h"
#include "mt.h"

void printPass( char *str );
void printFail( char *str );

extern int W_WIDTH;
extern int W_HEIGHT;

typedef struct {
        int flow_number;
        int ret_value;
}FR_THD_PARG;

// ==========================================
// global widgets
// ==========================================
SDL_Thread *thread;

SDL_Widget *button_yes = NULL;
SDL_Widget *button_no = NULL;
SDL_Widget *button_ensure = NULL;
SDL_Widget *button_leave = NULL;
SDL_Widget *button_poweroff = NULL;
SDL_Widget *button_retest = NULL;
SDL_Widget *button_finish = NULL;

SDL_Widget *line_style1 = NULL;
SDL_Widget *input_edit = NULL;
SDL_Widget *msg_box = NULL;

int gy = 0;
int edit_length = 0;

/* frt split display */
//int SPLIT_DIS_X = 256;
//int SPLIT_DIS_Y = 240;
//int SPLIT_DIS_Y_START = 120;
//int SPLIT_DIS_PRINT = 20;

// ====================================================================
void printItemHead( char *str )
{
	SDL_Widget *label_item_head;
	
	label_item_head = SDL_LabelNew();
	SDL_WidgetSetDims(label_item_head, MARGIN, MARGIN, 400, 80);	
	SDL_LabelSetAlignment(label_item_head, CENTER);
	((SDL_Label *)label_item_head)->bgcolor = 0x00000000;
	((SDL_Label *)label_item_head)->fgcolor = 0x00ff00ff;
	
	SDL_LabelSetText(label_item_head, str);
	
	SDL_WidgetShow(label_item_head);

}

void drawLine_Style1()
{
	line_style1 = SDL_LabelNew();
	SDL_WidgetSetDims(line_style1, MARGIN, 106, 1024 - 2*MARGIN, 2);	
	((SDL_Label *)line_style1)->bgcolor = 0x007700ff;

	SDL_WidgetShow(line_style1);

}

void drawEdit()
{
	input_edit = SDL_EditNew();
	SDL_WidgetSetDims(input_edit, 400, 300, 240, 25);
//	SDL_EditSetText(input_edit, "");
	SDL_SignalConnect(input_edit,"activate",(T_Signal_Callback)callback_input_edit, NULL);
	SDL_SignalConnect(input_edit,"changed",(T_Signal_Callback)callback_input_edit_changed, NULL);
	SDL_WidgetShow(input_edit);
}

void drawButtonYes()
{
	button_yes = SDL_ButtonNew();
	SDL_WidgetSetDims(button_yes, W_WIDTH - 400, W_HEIGHT - 40, 60, 30);
	SDL_ButtonSetLabel(button_yes, "Yes");
	SDL_SignalConnect(button_yes,"clicked",(T_Signal_Callback)callback_button_yes, NULL);
	SDL_WidgetShow(button_yes);
}

void drawButtonNo()
{
	button_no = SDL_ButtonNew();
	SDL_WidgetSetDims(button_no, W_WIDTH - 300, W_HEIGHT - 40, 60, 30);
	SDL_ButtonSetLabel(button_no, "No");
	SDL_SignalConnect(button_no,"clicked",(T_Signal_Callback)callback_button_no, NULL);
	SDL_WidgetShow(button_no);
}

void drawButtonEnsure()
{
	button_ensure = SDL_ButtonNew();
	SDL_WidgetSetDims(button_ensure, W_WIDTH - 100, W_HEIGHT - 40, 60, 30);
	SDL_ButtonSetLabel(button_ensure, "Ensure");
	SDL_SignalConnect(button_ensure,"clicked",(T_Signal_Callback)callback_button_ensure, NULL);
	SDL_WidgetShow(button_ensure);
}

void drawButtonLeave()
{
	
	button_leave = SDL_ButtonNew();
	SDL_WidgetSetDims(button_leave, W_WIDTH - 100, MARGIN + 50, 60, 30);
	SDL_ButtonSetLabel(button_leave, "Exit");
	SDL_SignalConnect(button_leave,"clicked",(T_Signal_Callback)callback_button_leave, NULL);
	SDL_WidgetShow(button_leave);

}

void drawButtonPoweroff()
{
	
	button_poweroff = SDL_ButtonNew();
	SDL_WidgetSetDims(button_poweroff, W_WIDTH - 100, W_HEIGHT - 40, 60, 30);
	SDL_ButtonSetLabel(button_poweroff, "Poweroff");
	SDL_SignalConnect(button_poweroff,"clicked",(T_Signal_Callback)callback_button_poweroff, NULL);
	SDL_WidgetShow(button_poweroff);
}

void drawButtonRetest()
{
	
	button_retest = SDL_ButtonNew();
	SDL_WidgetSetDims(button_retest, W_WIDTH - 180, W_HEIGHT - 40, 60, 30);
	SDL_ButtonSetLabel(button_retest, "Retest");
	SDL_SignalConnect(button_retest,"clicked",(T_Signal_Callback)callback_button_retest, NULL);
	SDL_WidgetShow(button_retest);
}

void drawButtonFinish()
{
	
	button_finish = SDL_ButtonNew();
	SDL_WidgetSetDims(button_finish, W_WIDTH - 180, W_HEIGHT - 40, 60, 30);
	SDL_ButtonSetLabel(button_finish, "Finish");
	SDL_SignalConnect(button_finish,"clicked",(T_Signal_Callback)callback_button_finish, NULL);
	SDL_WidgetShow(button_finish);
}

void refreshWin()
{
	extern SDL_Window *window;
	SDL_WindowRedrawEvent(window);
}

void clearGlobals()
{
	extern int answer;
	extern SDL_Widget *button_ok;
	// variables clearing area 
	gy = 0;
	answer = 0;
	button_ok = NULL;
	button_ensure = NULL;
	button_yes = NULL;
	button_no = NULL;
	button_poweroff = NULL;
	button_retest = NULL;
}

void clearWin()
{
	// This function should remove and free all widgets on the top window.
	// should find a way to judge the widget type
	SDL_WidgetList *temp;

	temp = SDL_WindowGetWidgetList();
	while(temp)
	{
		/* tangg temporarily modified */
		if (	temp->Widget != button_leave 
			&& temp->Widget != ((SDL_Button *)button_leave)->Label 
			&& temp->Widget != line_style1) 
			SDL_WidgetClose(temp->Widget);

		temp = temp->Next;
	}
	
	refreshWin();
	
	clearGlobals();
}

int go_thread(void *data)
{
	extern SDL_Window *window;
	extern int flow_count;
	extern lua_State *L;
	extern char *radios[];
	extern int ITEM_NUMBER;	
	extern SDL_Widget *button_ensure;
	extern int all_pass;
        
	int r;
	char buf[128] = {0};
	char run_file[1024] = {0};
	char log_file[1024] = {0};	
	char *path, *tmp;
	
	sprintf(buf, "%s test", radios[flow_count]);
	printItemHead(buf);
	
	// record log
	tmp = (char *)getTableElement(L, "self", "STAT");
	sprintf(buf, "%slog", tmp);
	path = (char *)getTableElement(L, "logs", buf);
	sprintf( log_file, "%s", path);
//	sprintf( buf, "%s test start", radios[flow_count]);	
//	recordlog( log_file, buf);

	
	path = (char *)getTableElement(L, "con", "PATH");
	sprintf( run_file, "%sfunction/%s/run.lua",path,radios[flow_count]);
        printf( "go-run.lua: %s\n", run_file);
        	
//	printf("Current dir: %s\n", getcwd(NULL, 0));
//	chdir(radios[flow_count]);
//	printf("Current dir: %s\n", getcwd(NULL, 0));
//	r = run(L, "run.lua"); 
	r = run(L, run_file); 
//	chdir("..");
//	printf("Current dir: %s\n", getcwd(NULL, 0));
	
	if (r == 0) {
		printPass("This item test PASS.");
		if (flow_count >= ITEM_NUMBER - 1) {
			all_pass = 1;
		}
		sprintf( buf, "%s test PASS!", radios[flow_count]);	
		
	}
	else {
		printFail("This item test FAIL.");
		sprintf( buf, "%s test FAILED!", radios[flow_count]);	

	}

	recordlog( log_file, buf);
	
	if ( r == 0 ) {
		drawButtonEnsure();
		SDL_Delay(500);
		flow_count++;
		refreshWin();
		if (getTableBooleanElement(L, "con", "AUTOTEST"))
			SDL_SignalEmit( button_ensure, "clicked", NULL);	
	}
	else {
		if (getTableBooleanElement(L, "con", "RETEST_IF_FAIL"))
			drawButtonRetest();
		if (getTableBooleanElement(L, "con", "GJ_IF_FAIL"))
			drawButtonPoweroff();
		else {
			drawButtonEnsure();
			flow_count++;
		}
		refreshWin();
	}


}


void go()
{		
	clearWin();	
        if ((thread = SDL_CreateThread(go_thread, NULL)) == NULL ) {
	        fprintf(stderr, "Can't create thread: %s \n", SDL_GetError());
	        return;
        }

}

void printMsg( char *str )
{
	SDL_Widget *label_tmp = SDL_LabelNew();
	
	SDL_WidgetSetDims(label_tmp, MARGIN, gy + 120, strlen(str)*8, 18);	
	((SDL_Label *)label_tmp)->fgcolor = 0x000000ff;
	
	SDL_LabelSetText(label_tmp, str);
	SDL_WidgetShow(label_tmp);

	gy +=20;
	if (gy >= W_HEIGHT - 30) {
		gy = 0;
//		gy = 120;
	}

}

int printMsg_4lua(lua_State *L)
{
	printMsg( (char *)getStr(L) );
	return 0;	
}

void printError( char *str )
{
	SDL_Widget *label_tmp = SDL_LabelNew();
	
	SDL_WidgetSetDims(label_tmp, MARGIN, gy + 120, strlen(str)*8, 18);	
	((SDL_Label *)label_tmp)->fgcolor = 0x00ff0000;
	
	SDL_LabelSetText(label_tmp, str);
	SDL_WidgetShow(label_tmp);

	gy +=20;
	if (gy >= W_HEIGHT - 30) {
		gy = 0;
	}
}

int printError_4lua(lua_State *L)
{
	printError( (char *)getStr(L) );
	return 0;
}

void printPrompt( char *str )
{
	SDL_Widget *label_tmp = SDL_LabelNew();
	
	SDL_WidgetSetDims(label_tmp, MARGIN, gy + 120, strlen(str)*8, 18);	
	((SDL_Label *)label_tmp)->fgcolor = 0x007700aa;
	
	SDL_LabelSetText(label_tmp, str);
	SDL_WidgetShow(label_tmp);

	gy +=20;
	if (gy >= W_HEIGHT - 30) {
		gy = 0;
	}
}

int printPrompt_4lua(lua_State *L)
{
	printPrompt( (char *)getStr(L) );
	return 0;
}

SDL_Widget *printStr( char *str, int x, int y )
{
	SDL_Widget *label_tmp = SDL_LabelNew();
	
	SDL_WidgetSetDims(label_tmp, x, y, strlen(str)*8, 18);	
	((SDL_Label *)label_tmp)->fgcolor = 0x000000ff;
	
	SDL_LabelSetText(label_tmp, str);
	SDL_WidgetShow(label_tmp);
	
	return label_tmp;
}

int printStr_4lua(lua_State *L)
{
	int y = getNumber(L);
	int x = getNumber(L);	
	
	printStr( (char *)getStr(L), x, y );
	return 0;
}

void printPass( char *str )
{
	SDL_Widget *label_tmp = SDL_LabelNew();
	
	SDL_WidgetSetDims(label_tmp, MARGIN, gy + 120, strlen(str)*8, 18);	
	((SDL_Label *)label_tmp)->fgcolor = 0x0000cc77;
	
	SDL_LabelSetText(label_tmp, str);
	SDL_WidgetShow(label_tmp);

	gy +=20;
	if (gy >= W_HEIGHT - 30) {
		gy = 0;
	}
}

int printPass_4lua(lua_State *L)
{
	printPass( (char *)getStr(L) );
	return 0;
}

void printFail( char *str )
{
	SDL_Widget *label_tmp = SDL_LabelNew();
	
	SDL_WidgetSetDims(label_tmp, MARGIN, gy + 120, strlen(str)*8, 18);	
	((SDL_Label *)label_tmp)->fgcolor = 0x00cc0000;
	
	SDL_LabelSetText(label_tmp, str);
	SDL_WidgetShow(label_tmp);

	gy +=20;
	if (gy >= W_HEIGHT - 30) {
		gy = 0;
	}
}

int printFail_4lua(lua_State *L)
{
	printFail( (char *)getStr(L) );
	return 0;
}

void printPassResult()
{
	extern lua_State *L;
	char buf[128] = {0};
	char *station = (char *)getTableElement(L, "con", "STATION");
	printItemHead( station );
	
	sprintf(buf, "%s TEST ALL PASS.", station);
	printPass(buf);
	
	drawButtonFinish();
	
//	SDL_SignalEmit( button_leave, "clicked", NULL);	
	
//	drawButtonPoweroff();

}

void printFailResult()
{
	extern lua_State *L;
	char buf[128] = {0};
	char *station = (char *)getTableElement(L, "con", "STATION");
	printItemHead( station );
	
	sprintf(buf, "%s TEST FAILED.", station);
	printFail(buf);
	
	drawButtonRetest();
	drawButtonPoweroff();

}

void judgement( char *str)
{
	printMsg(str);
	
	drawButtonYes();
	drawButtonNo();
		
}

int judgement_4lua(lua_State *L)
{	
	extern int answer;
	
	judgement((char *)getStr(L));
	
//	printf("answer %d", answer);
	while (!answer) {
		SDL_Delay(50);
	}
	
	putNumber(L, answer);
	answer = 0;
	
	return 1;
}

// -------------------------------------------------------------

char *getNChars( int n )
{
	extern SDL_Window *window;
	SDL_Widget *label_edit;
	static char buf[32] = {0};
	
	label_edit = printStr( "Please input MBSN into this editor.", 400, 275 );
	
	drawEdit();
	SDL_WidgetSetFocus(input_edit);
	
	while (edit_length < n) {
		SDL_Delay(50);
	}
	
	char *str = SDL_EditGetText(input_edit);

	sprintf(buf, "%s", str);	
//	sprintf(buf, "Your inputs is %s.", str);
//	printMsg( buf );
	
	SDL_WidgetClose(label_edit);
	SDL_WidgetClose(input_edit);
	refreshWin();
	
	edit_length = 0;

	return buf;
}

int getNChars_4lua(lua_State *L)
{
	int n = getNumber(L);
	putStr(L, getNChars(n));
	
	return 1;
}

char *getNCharsPrompt( int n, char *prompt)
{
//        printf( "len %d, prompt %s", n, prompt);
//        SDL_Delay( 5000);
        
	extern SDL_Window *window;
	SDL_Widget *label_edit;
	static char buf[32] = {0};
	char strPrompt[4096] = {0};
	sprintf( strPrompt, "Please inpute %s into this editer.", prompt);
	
	label_edit = printStr( strPrompt, 400, 275 );
	
	drawEdit();
	SDL_WidgetSetFocus(input_edit);
	
	while (edit_length < n) {
		SDL_Delay(50);
	}
	
	char *str = SDL_EditGetText(input_edit);

	sprintf(buf, "%s", str);	
//	sprintf(buf, "Your inputs is %s.", str);
//	printMsg( buf );
	
	SDL_WidgetClose(label_edit);
	SDL_WidgetClose(input_edit);
	refreshWin();
	
	edit_length = 0;

	return buf;
}

int getNCharsPrompt_4lua(lua_State *L)
{
	char *str = (char *)getStr(L);
	int n = getNumber(L);

	putStr(L, getNCharsPrompt(n, str));
	
	return 1;
}

char getChar()
{
	extern char has_char;
	char ch;
	SDL_Widget *label_tmp = printStr( "Press anykey to continue...", MARGIN, W_HEIGHT - MARGIN - 20 );
	
	has_char = 0;	
	while (!has_char) {
		SDL_Delay(50);
	}
	ch = has_char;
	has_char = 0;
	
	SDL_WidgetClose(label_tmp); refreshWin();
	
	return ch;
}

int getChar_4lua(lua_State *L)
{
	putChar(L, getChar());
	
	return 1;
}


void drawMsgBox()
{
	msg_box = SDL_MultiLineEditNew();
	
	SDL_WidgetSetDims(msg_box, MARGIN, 120, 600, 400);	
	// here, should not focus on the MsgBox because we use it only for display messages
	SDL_WidgetShow(msg_box);
}

int drawMsgBox_4lua(lua_State *L)
{
	drawMsgBox();
	return 0;
}

int showMsg_4lua(lua_State *L)
{
	char buf[4096] = {0};
	char *str = (char *)getStr(L);
	SDL_String *str_pre;
	
	if (msg_box == NULL) {
		drawMsgBox();
	}
	
	str_pre = (SDL_String *)SDL_MultiLineEditGetText( msg_box );
//	printf("str_pre->Data: %s\n", str_pre->Data);
	if (str_pre->Data != NULL)
		sprintf(buf, "%s%s", str_pre->Data, str);
	else
		sprintf(buf, "%s", str);
	SDL_MultiLineEditSetText(msg_box, buf);
	
	return 0;	
}

int clearMsgBox_4lua(lua_State *L)
{
	SDL_MultiLineEditSetText(msg_box, "");
	return 0;
}

void drawScrollBar()
{
	SDL_Widget *scrollbar = SDL_ScrollbarNew();
	SDL_WidgetSetDims(scrollbar, MARGIN, 120, 40, 400);		
	SDL_WidgetShow(scrollbar);
}

int drawScrollBar_4lua(lua_State *L)
{
	drawScrollBar();
	return 0;
}

int refreshWin_4lua(lua_State *L)
{
	refreshWin();
	return 0;
}

int listenMouseEvent(int x1, int y1, int x2, int y2, int button)
{
        SDL_Event event;
        SDL_MouseButtonEvent mouseEvent;
        
        int flag = 0;
        int btArr[3] = { SDL_BUTTON_LEFT, SDL_BUTTON_RIGHT, SDL_BUTTON_MIDDLE};
        int x,y;
        
        SDL_PollEvent( &event);
        
                switch( event.type)
                {
                case SDL_MOUSEBUTTONDOWN:
                case SDL_MOUSEBUTTONUP:

                        mouseEvent = event.button;
                        
                        x = mouseEvent.x;
                        y = mouseEvent.y;
                        
                        if ( x < x1 || x > x2 || y < y1 || y > y2)
                        {
                                SDLTk_PushEvent( &event);
                                break;
                        }
                        
                        if ( mouseEvent.button == btArr[ button])
                        {
                                flag = 1; 
                                break;
                        }
                                                
                default:
                        SDLTk_PushEvent( &event);
                        break;
                }                     
        
        
        return flag;
}
/*
void listenEvent(int x1, int y1, int x2, int y2)
{
        SDL_Event event;
        char ret[14]={0};
        
        
        while( SDL_PollEvent( &event))
        {
                switch( event.type)
                {
                case SDL_MOUSEBUTTONDOWN:
                case SDL_MOUSEBUTTONUP:
                        
                        ret[0] = '0'; //mouse

                        SDL_MouseButtonEvent mouseEvent = event.button;
                        
                        int x = mouseEvent.x;
                        int y = mouseEvent.y;
                        
                        if( ( x < x1 or x > x2 or y < y1 or y > y2)
                        {
                                SDLTk_PushEvent( &event);
                                break;
                        } 
                        
                        //down or up
                        if ( mouseEvent.type == SDL_MOUSEBUTTONDOWN)
                                ret[1] = '0';
                        else
                                ret[1] = '1';
                        
                        //pressed or release        
                        if( mouseEvent.state == SDL_PRESSED)
                                ret[2] = '0';
                        else
                                ret[2] = '1';

                        switch( mouseEvent.button){
                        case SDL_BUTTON_LEFT:
                                ret[3] = '0';
                                ret[4] = '0';
                                break;
                        case SDL_BUTTON_RIGHT:
                                ret[3] = '0';
                                ret[4] = '1';
                                break;
                        default:
                                ret[3] = '1';
                                ret[4] = '0';
                        }
                        
                printf( " %s\n", ret);                
                break;                                                        
                                
//                case SDL_MOUSEBUTTONUP:
//                        printf( "mouse button up.\n");
//                        break;
                default:
                        SDLTk_PushEvent( &event);
                        break;
                }                     
                        
        }
}

int listenMouseEvent_4lua(lua_State *L)
{
	int y2 = ( int) getNumber( L);
	int x2 = ( int) getNumber( L);
	int y1 = ( int) getNumber( L);
	int x1 = ( int) getNumber( L);
	
	if x1 < 0 then x1 = 0;
        if y1 < 0 then y1 = 0;
        if x2 > W_WIDTH then x2 = W_WIDTH;
        if y2 > W_HEIGHT then y2 = W_HEIGHT;
        
        
        listenMouseEvent( x1, y1, x2, y2);
        return 0;
}
*/
// --------------------------------------------------------------
void registerFuncs4Lua()
{
	extern lua_State *L;
	
	lua_register(L, "printMsg", (lua_CFunction)printMsg_4lua);
	lua_register(L, "printError", (lua_CFunction)printError_4lua);
	lua_register(L, "printPrompt", (lua_CFunction)printPrompt_4lua);
	lua_register(L, "printStr", (lua_CFunction)printStr_4lua);
	lua_register(L, "printPass", (lua_CFunction)printPass_4lua);
	lua_register(L, "printFail", (lua_CFunction)printFail_4lua);

	lua_register(L, "drawMsgBox", (lua_CFunction)drawMsgBox_4lua);
	lua_register(L, "showMsg", (lua_CFunction)showMsg_4lua);
	lua_register(L, "clearMsgBox", (lua_CFunction)clearMsgBox_4lua);

	lua_register(L, "judgement", (lua_CFunction)judgement_4lua);

	lua_register(L, "getNChars", (lua_CFunction)getNChars_4lua);
	lua_register(L, "getChar", (lua_CFunction)getChar_4lua);
	lua_register(L, "getNCharsPrompt",(lua_CFunction)getNCharsPrompt_4lua);
	
	lua_register(L, "drawScrollBar", (lua_CFunction)drawScrollBar_4lua);
	lua_register(L, "refreshWin", (lua_CFunction)refreshWin_4lua);
	
//	lua_register(L, "listenMouseEvent", (lua_CFunction)listenMouseEvent_4lua);
}

//---------------------------------------------------------------
void processKeyInput(SDL_KeyboardEvent *key)
{
	extern SDL_Widget *button_ok;
	extern int answer;
	extern char has_char;
	extern fresh_display;
	
	printf("Scancode: 0x%02X\t", key->keysym.scancode);
	printf("Key Name: %s\n", SDL_GetKeyName(key->keysym.sym));
        printf( "key unicode: %d, %c\n", key->keysym.unicode, key->keysym.unicode);
        	
//	printf("button_ok: %x\n", button_ok);
//	printf("button_ensure: %x\n", button_ensure);
	has_char = SDL_GetKeyName(key->keysym.sym)[0];
	
	switch (key->keysym.sym) {
/*	case SDLK_ESCAPE:
		SDL_SignalEmit( button_leave, "clicked", NULL);
		break;
*/	case SDLK_RETURN:
		if (button_ok) {
			SDL_SignalEmit( button_ok, "clicked", NULL);
		}
		else if (button_ensure) {
			SDL_SignalEmit( button_ensure, "clicked", NULL);
		}
		else if (button_poweroff) {
			SDL_SignalEmit( button_poweroff, "clicked", NULL);
		}
		break;
	case SDLK_y:
		if (!answer) {
			SDL_SignalEmit( button_yes, "clicked", NULL);
		}
		break;
	case SDLK_n:
		if (!answer) {
			SDL_SignalEmit( button_no, "clicked", NULL);
		}
		break;
	case SDLK_r:
		if (button_retest) {
			SDL_SignalEmit( button_retest, "clicked", NULL );
		}
		break;
	default:
		break;
	}
}
