#include <gidx.h>
#include <unistd.h>
#include <gidx-rd.h>
#include <gidx-query.h>

static int do_webroot_query(gidx_rd_t db, const char *str)
{
	struct ro_vec qstr;
	gidx_idx_t uri_idx;
	gidx_query_t q;
	
	q = gidx_query_new(db);
	if ( NULL == q )
		return 0;

	uri_idx = gidx_rd_primary(db, "uri");
	if ( NULL == uri_idx ) {
		ERR("uri field not found");
		return 0;
	}

	qstr.v_len = strlen(str);
	qstr.v_ptr = (uint8_t *)str;
	if ( !gidx_query_str(q, uri_idx, &qstr) )
		return 0;

	if ( !gidx_query_execute(q) )
		return 0;

	DEBUG("Erm, done...");
	return 1;
}

int main(int argc, char **argv)
{
	gidx_rd_t rd;

	rd = gidx_rd_open(STDIN_FILENO);
	if ( NULL == rd )
		return EXIT_FAILURE;

	mesg(M_INFO, "Opened database");
	if ( !do_webroot_query(rd, "/stuff/screeny.png") )
		return EXIT_FAILURE;

	gidx_rd_fini(rd);
	return EXIT_SUCCESS;
}
