/*
* This file is part of gidx
* Copyright (c) 2010 Gianni Tedesco
* Released under the terms of the GNU GPL version 3
*/
#ifndef _GIDX_QUERY_H
#define _GIDX_QUERY_H

typedef struct _gidx_query *gidx_query_t;

_protected _check_result gidx_query_t gidx_query_new(gidx_rd_t db);
_protected _check_result int gidx_query_select(gidx_query_t q,
						const char * const name);
_protected int gidx_query_execute(gidx_query_t q);
_protected void gidx_query_free(gidx_query_t q);

_protected _check_result int gidx_query_u32(gidx_query_t q, gidx_idx_t idx,
						uint32_t val);

_protected _check_result int gidx_query_u32_r(gidx_query_t q, gidx_idx_t idx,
						uint32_t min, uint32_t max);

_protected _check_result int gidx_query_u64(gidx_query_t q, gidx_idx_t idx,
						uint32_t val);
_protected _check_result int gidx_query_u64_r(gidx_query_t q, gidx_idx_t idx,
						uint32_t min, uint32_t max);

_protected _check_result int gidx_query_str(gidx_query_t q, gidx_idx_t idx,
						struct ro_vec *str);
_protected _check_result int gidx_query_strp(gidx_query_t q, gidx_idx_t idx,
						struct ro_vec *str);

#endif /* _GIDX_QUERY_H */
