/*
* This file is part of gidx
* Copyright (c) 2010 Gianni Tedesco
* Released under the terms of the GNU GPL version 3
*/
#ifndef _GIDX_RD_H
#define _GIDX_RD_H

typedef struct _gidx_rd 	*gidx_rd_t;
typedef const struct gidx_idx 	*gidx_idx_t;

_protected _check_result gidx_rd_t gidx_rd_open(int fd);
_protected _check_result gidx_idx_t gidx_rd_secondary(gidx_rd_t rd,
						const char * const name);
_protected _check_result gidx_idx_t gidx_rd_primary(gidx_rd_t rd,
						const char * const name);
_protected _check_result gidx_idx_t gidx_rd_resultset(gidx_rd_t rd,
						const char * const name);
_protected _check_result const uint8_t *gidx_rd_user_chunk(gidx_rd_t rd,
							gidx_idx_t idx,
							unsigned int id,
							size_t *sz);
_protected void gidx_rd_fini(gidx_rd_t rd);

#endif /* _GIDX_RD_H */
