/* xrtm_fd.c */
int xrtm_fd_create(xrtm_data *d, xrtm_fd_data *fd, int n_derivs);
void xrtm_fd_destroy(xrtm_fd_data *d);
int xrtm_fd_get_n_derivs(xrtm_fd_data *d);
int xrtm_fd_set_delta(xrtm_fd_data *d, double *delta);
int xrtm_fd_get_delta(xrtm_fd_data *d, double *delta);
int xrtm_fd_set_g_p_11(xrtm_fd_data *d, int i_layer, int i_deriv, double g_p);
int xrtm_fd_set_g_p_n1(xrtm_fd_data *d, int i_deriv, double *g_p);
int xrtm_fd_set_g_p_1n(xrtm_fd_data *d, int i_layer, double *g_p);
int xrtm_fd_set_g_p_nn(xrtm_fd_data *d, double **g_p);
double xrtm_fd_get_g_p(xrtm_fd_data *d, int i_layer, int i_deriv);
int xrtm_fd_set_coef_p_11(xrtm_fd_data *d, int i_layer, int i_deriv, double **coef_p);
int xrtm_fd_set_coef_p_n1(xrtm_fd_data *d, int i_deriv, double ***coef_p);
int xrtm_fd_set_coef_p_1n(xrtm_fd_data *d, int i_layer, double ***coef_p);
int xrtm_fd_set_coef_p_nn(xrtm_fd_data *d, double ****coef_p);
double xrtm_fd_get_coef_p(xrtm_fd_data *d, int i_layer, int i_deriv, int i_elem, int i_coef);
int xrtm_fd_set_omega_p_11(xrtm_fd_data *d, int i_layer, int i_deriv, double omega_p);
int xrtm_fd_set_omega_p_n1(xrtm_fd_data *d, int i_deriv, double *omega_p);
int xrtm_fd_set_omega_p_1n(xrtm_fd_data *d, int i_layer, double *omega_p);
int xrtm_fd_set_omega_p_nn(xrtm_fd_data *d, double **omega_p);
double xrtm_fd_get_omega_p(xrtm_fd_data *d, int i_layer, int i_deriv);
int xrtm_fd_set_ltau_p_11(xrtm_fd_data *d, int i_layer, int i_deriv, double ltau_p);
int xrtm_fd_set_ltau_p_n1(xrtm_fd_data *d, int i_deriv, double *ltau_p);
int xrtm_fd_set_ltau_p_1n(xrtm_fd_data *d, int i_layer, double *ltau_p);
int xrtm_fd_set_ltau_p_nn(xrtm_fd_data *d, double **ltau_p);
double xrtm_fd_get_ltau_p(xrtm_fd_data *d, int i_layer, int i_deriv);
int xrtm_fd_set_kernel_ampfac_p_1(xrtm_fd_data *d, int i_kernel, int i_deriv, double ampfac_p);
int xrtm_fd_set_kernel_ampfac_p_n(xrtm_fd_data *d, int i_kernel, double *ampfac_p);
double xrtm_fd_get_kernel_ampfac_p(xrtm_fd_data *d, int i_kernel, int i_deriv);
int xrtm_fd_set_kernel_params_p_11(xrtm_fd_data *d, int i_kernel, int i_deriv, int i_param, double param_p);
int xrtm_fd_set_kernel_params_p_1n(xrtm_fd_data *d, int i_kernel, int i_deriv, double *params_p);
int xrtm_fd_set_kernel_params_p_n1(xrtm_fd_data *d, int i_kernel, int i_param, double *params_p);
int xrtm_fd_set_kernel_params_p_nn(xrtm_fd_data *d, int i_kernel, double **params_p);
double xrtm_fd_get_kernel_params_p(xrtm_fd_data *d, int i_kernel, int i_deriv, int i_param);
int xrtm_fd_solution(xrtm_fd_data *d, enum xrtm_solver_mask solver, int solutions, enum fd_method_type fd_method, int n_phis, double **phis, double ****I_p, double ****I_m, double *****I_p_l, double *****I_m_l, double *mean_p, double *mean_m, double **mean_p_l, double **mean_m_l, double *flux_p, double *flux_m, double **flux_p_l, double **flux_m_l, double *flux_div, double **flux_div_l);
int xrtm_fd_radiance(xrtm_fd_data *d, enum xrtm_solver_mask solver, enum fd_method_type fd_method, int n_phis, double **phis, double ****I_p, double ****I_m, double *****I_p_l, double *****I_m_l);
