/*********************************************************************************************************
*                                      The Real-Time Kernel For AVR
*                                             CORE FUNCTIONS
* File    : AVR_RTOS.C
* By      : 
* Version : V2.0
*********************************************************************************************************/
#include "AVR_RTOS.h"
/*********************************************************************************************************
ƣ	OSTaskCreate
ԭͣ	void OSTaskCreate(void (*Task)(void),INT8U *Stack,INT8U prio)
ܣ	û 
ڲ	*Taskַ*Stackջָ룻prioȼ
*********************************************************************************************************/
void OSTaskCreate(void (*Task)(void),INT8U *Stack,INT8U prio)
{
	INT8U i;
	*Stack--=(INT16U)Task;				     /*ĵַλѹջ                                 */
	*Stack--=(INT16U)Task>>8;		 	     /*ĵַλѹջ	                                */
	*Stack--=0x00;							 /*R1 __zero_reg__				                            */
	*Stack--=0x00;							 /*R0 __tmp_reg__			                                */
	*Stack--=0x80;							 /*SREG Уȫж	                            */
	for(i=0;i<14;i++)
    *Stack--=i;/* avr-libc е FAQе What registers are used by the C compiler?˼Ĵ	*/
	TCB[prio].OSTaskStackTop = (INT16U)Stack;/*˹ջջ浽ջ                     */
    TCB[prio].OSWaitTick     = 0;			 /* ʼʱ    	                                    */
	OSRdyTbl                |= 0x01<<prio;   /*Ѿ׼		      	                        */
}
/*********************************************************************************************************
ƣ	OSInit
ԭͣ	void OSInit (void)
ܣ	ûʼʱӺһЩϵͳȫֱ	
*********************************************************************************************************/
void OSInit (void)
{
	OSRdyTbl      = 0;                            /*                                      */
	OSIntNesting  = 0;	                          /*жǶ׼                                  */
	OSLockNesting = 0;
	OSIdleCtr     = 0;
#if OS_CPU_HOOKS_EN > 0
    OSInitHookBegin ();
#endif
	OSTaskCreate(IdleTask,&IdleStack[IDLE_STACK_SIZE-1],IDLE_TASK_PRIO); /*IDLE                 */
}
/*********************************************************************************************************
ƣ	OSStart
ԭͣ	void OSStart(void)
ܣ	ûʼ,ӿʼ 	
*********************************************************************************************************/
void OSStart(void)
{
	OSPrioCur     = OS_TASKS;
	OSPrioHighRdy = OS_TASKS;
	SP=TCB[OS_TASKS].OSTaskStackTop+17;
	__asm__ __volatile__("reti"                    "\n\t");
}
/*********************************************************************************************************
ƣ	OS_TASK_SW
ԭͣ	void OS_TASK_SW(void)
ܣ	 
й˵	ڲжϺ񶼿ԵȺ	
*********************************************************************************************************/
void OS_TASK_SW(void)
{
	__asm__ __volatile__("PUSH __zero_reg__         \n\t");	/*R1 					                    */
	__asm__ __volatile__("PUSH __tmp_reg__          \n\t");	/*R0					                    */
	__asm__ __volatile__("IN   __tmp_reg__,__SREG__ \n\t");	/*״̬ĴSREG               	        */
	__asm__ __volatile__("PUSH __tmp_reg__          \n\t"); 
	__asm__ __volatile__("CLR  __zero_reg__         \n\t");	/*R0			                    */
	__asm__ __volatile__("PUSH R18                  \n\t");
	__asm__ __volatile__("PUSH R19                  \n\t");
	__asm__ __volatile__("PUSH R20                  \n\t");
	__asm__ __volatile__("PUSH R21                  \n\t");
	__asm__ __volatile__("PUSH R22                  \n\t");
	__asm__ __volatile__("PUSH R23                  \n\t");
	__asm__ __volatile__("PUSH R24                  \n\t");
	__asm__ __volatile__("PUSH R25                  \n\t");
	__asm__ __volatile__("PUSH R26                  \n\t");
	__asm__ __volatile__("PUSH R27                  \n\t");
	__asm__ __volatile__("PUSH R30                  \n\t");  
	__asm__ __volatile__("PUSH R31                  \n\t");	

	__asm__ __volatile__("Int_OSSched:              \n\t");	/*жҪȣֱӽ		        */ 
    __asm__ __volatile__("CLI                       \n\t");                
	__asm__ __volatile__("PUSH R28                  \n\t");	/*R28R29ڽڶջϵָ	        */
	__asm__ __volatile__("PUSH R29                  \n\t");	/*ջ							        */	
	
	TCB[OSPrioCur].OSTaskStackTop=SP;					    /*еĶջױ		        */	
	OSPrioCur = OSPrioHighRdy ;							    /*еǰеȼ	        */	
	SP=TCB[OSPrioCur].OSTaskStackTop;

	__asm__ __volatile__("POP  R29                  \n\t"); /*ջ                                      */
	__asm__ __volatile__("POP  R28                  \n\t");
	__asm__ __volatile__("POP  R31                  \n\t");
	__asm__ __volatile__("POP  R30                  \n\t");
	__asm__ __volatile__("POP  R27                  \n\t");
	__asm__ __volatile__("POP  R26                  \n\t");
	__asm__ __volatile__("POP  R25                  \n\t");
	__asm__ __volatile__("POP  R24                  \n\t");
	__asm__ __volatile__("POP  R23                  \n\t");
	__asm__ __volatile__("POP  R22                  \n\t");
	__asm__ __volatile__("POP  R21                  \n\t");
	__asm__ __volatile__("POP  R20                  \n\t");
	__asm__ __volatile__("POP  R19                  \n\t");
	__asm__ __volatile__("POP  R18                  \n\t");
	__asm__ __volatile__("POP  __tmp_reg__          \n\t"); /*SERG ջָ	                        */
	__asm__ __volatile__("OUT  __SREG__,__tmp_reg__ \n\t");
	__asm__ __volatile__("POP  __tmp_reg__          \n\t");	/*R0 ջ			                        */
	__asm__ __volatile__("POP  __zero_reg__         \n\t");	/*R1 ջ			                        */	                                                      
	__asm__ __volatile__("RETI                      \n\t"); /*ջ,زж		                */
}
/*********************************************************************************************************
ƣ	OSIntCtxSw
ԭͣ	void OSIntCtxSw(void)
ܣ	ж˳е
й˵	жǶײжҪлʱŽл
			Ϊжϵһ񹲵ӺҪĸջPC
*********************************************************************************************************/
void OSIntCtxSw(void)
{                                
	__asm__ __volatile__("POP  R31                  \n\t");	    /*ȥӳջPC            */
	__asm__ __volatile__("POP  R31                  \n\t");
	__asm__ __volatile__("POP  R31                  \n\t");
	__asm__ __volatile__("POP  R31                  \n\t");
	__asm__ __volatile__("RJMP Int_OSSched          \n\t");	    /*µ					            */	
}
/*********************************************************************************************************
ƣ	OSSched
ԭͣ	void OSSched(void)
ܣ	
й˵	ڲֻиȼʱŽһллжвɵô˺	
*********************************************************************************************************/
void OS_Sched (void)
{
    OS_ENTER_CRITICAL();
	if(OSIntNesting == 0){                                 /*жǷжϵãֱƳ           */   	
	    if(OSLockNesting == 0){                            /*жϵǷֱƳ             */
		    OS_SchedNew();						           /*ҳȼߵ               */
	        if(OSPrioHighRdy != OSPrioCur){				   /*ǵǰе񣬽       */	    
		        OS_TASK_SW();							   /*                                   */    
		    }
		}
    }
	OS_EXIT_CRITICAL();
}
/*********************************************************************************************************
ƣ	OSTaskSuspend
ԭͣ	void OSTaskSuspend(INT8U prio)
ܣ	 
ڲ	prioȼ
й˵	ûһԹҲԹ	
*********************************************************************************************************/
#if OS_TASK_SUSPEND_EN >0
void OSTaskSuspend(INT8U prio)
{
	OS_ENTER_CRITICAL();
	TCB[prio].OSWaitTick=0;         
	OSRdyTbl &= ~(0x01<<prio);		                       /*ȥ־λ	                */
	if(OSPrioCur == prio){			                       /*ҪΪǰ	                */	
		OS_EXIT_CRITICAL();
		OS_Sched();					                       /*µ					                */
		return;
	}
	OS_EXIT_CRITICAL();
}
#endif
/*********************************************************************************************************
ƣ	OSTaskResume
ԭͣ	void OSTaskResume(INT8U prio)
ܣ	ûָ ñOSTaskSuspend OSTimeDlyָͣ 
ڲ	prioȼ	
*********************************************************************************************************/
#if OS_TASK_RESUME_EN > 0
void OSTaskResume(INT8U prio)
{
	OS_ENTER_CRITICAL();
	OSRdyTbl |= 0x01<<prio;			                       /*ñ־λ	                */
    TCB[prio].OSWaitTick=0;			                       /*ʱʱΪ0,ʱ		                */
	if(OSPrioCur > prio){			                       /*ǰȼλȼ	*/	
		OS_EXIT_CRITICAL();
		OS_Sched();					                       /*µ				             	    */
	    return;
	}
	OS_EXIT_CRITICAL();
}
#endif
/*********************************************************************************************************
ƣ	IdleTask(void)
ԭͣ	void IdleTask(void)
ܣ	񣬵ûоʱ
й˵	ϵͳʼеʱǴпʼġɾ
ｫtimer0ڴ˴ΪúǵһеĺģUCosڵһϵͳ
*********************************************************************************************************/
void IdleTask(void)
{   
    TCN0Init();                                            /*ʼʱ                               */
	OS_Sched();
	for (;;){
    	OS_ENTER_CRITICAL();
        OSIdleCtr++;
#if OS_CPU_HOOKS_EN > 0
        OSTaskIdleHook();
#endif
        OS_EXIT_CRITICAL();	
	}
}
/*********************************************************************************************************
ƣ	OS_SchedNew
ԭͣ	void OS_SchedNew (void)
ܣ	ҳеȼ
*********************************************************************************************************/
void OS_SchedNew (void)
{   
	INT8U OSNextTaskPrio;
	OSNextTaskPrio = 0;
	while ((OSNextTaskPrio < OS_TASKS) && (!(OSRdyTbl & (0x01<<OSNextTaskPrio)))){
		OSNextTaskPrio++;                                 /*ҳźȴбȼߵ    */
	}
	OSPrioHighRdy  =  OSNextTaskPrio;
}
/*********************************************************************************************************
ƣ	OSIntEnter
ԭͣ	void OSIntEnter(void)
ܣ	жʱô˺
й˵	OSIntEnter()OSIntExit()ҪɶԳʹ
*********************************************************************************************************/
void OSIntEnter(void)
{
	OS_ENTER_CRITICAL();
	if(OSIntNesting<255u){
		OSIntNesting++;     				             /*жǶ׼1    			                    */
	}
	OS_EXIT_CRITICAL();
}
/*********************************************************************************************************
ƣ	OSIntExit
ԭͣ	void OSIntExit(void)
ܣ	ж˳ʱô˺жøȼͽ
й˵	OSIntEnter()OSIntExit()ҪɶԳʹ	
*********************************************************************************************************/
void OSIntExit(void)
{
	OS_ENTER_CRITICAL();
	if(OSIntNesting>0){
		OSIntNesting--;     				             /*жǶ׼1			                        */
	}
	if(OSIntNesting == 0){
	    if(OSLockNesting == 0){
		    OS_SchedNew();				                 /*ҳȼߵ                 */
		    if(OSPrioHighRdy != OSPrioCur){	
			    OS_EXIT_CRITICAL();	   	
			    OSIntCtxSw();					        /*            	                    */	
		        return;
		    }
	    }
	}
	OS_EXIT_CRITICAL();
}
/*********************************************************************************************************
ƣ	OSSchedLock  &  OSSchedUnlock
ԭͣ	void  OSSchedLock (void)  void  OSSchedUnlock (void)
ܣ	
й˵	OSSchedLock ()  OSSchedUnlock ()ҪɶԳʹ	
*********************************************************************************************************/
#if OS_SCHED_LOCK_EN > 0
void  OSSchedLock (void)
{
    OS_ENTER_CRITICAL();
    if (OSIntNesting == 0) {                             /* жϲõ                                */
         if(OSLockNesting < 255u){          
             OSLockNesting++;                            /* Ƕ׼+1                            */
         }
    }
    OS_EXIT_CRITICAL();
}

void  OSSchedUnlock (void)
{
    OS_ENTER_CRITICAL();
    if(OSLockNesting > 0){                           
        OSLockNesting--;                              
        if(OSLockNesting == 0){                     
            if(OSIntNesting == 0){                   
                OS_EXIT_CRITICAL();
                OS_Sched();                           
            }else{
                  OS_EXIT_CRITICAL();
            }
        }else{
              OS_EXIT_CRITICAL();
        }
    }else{
          OS_EXIT_CRITICAL();
    }
}
#endif
/*********************************************************************************************************
ƣ	OSTimeTick (void)
ԭͣ	OSTimeTick (void)
ܣ	ϵͳķ
й˵	ΪҪʱʱϵͳʱ	
*********************************************************************************************************/
void  OSTimeTick (void)
{
	INT8U i;
#if OS_CPU_HOOKS_EN > 0
    OSTimeTickHook ();
#endif
	OS_ENTER_CRITICAL();
	for(i=0;i < OS_TASKS;i++){				             /*ˢ¸ʱ	        	                */	
		 if(TCB[i].OSWaitTick){
			 TCB[i].OSWaitTick--;
			 if(TCB[i].OSWaitTick == 0){		         /*ʱӵʱ,ɶʱʱĲ      */			
				 OSRdyTbl |= (0x01<<i);		             /*ʱĳλ	                    */				
			 }
		 }
	}
	OS_EXIT_CRITICAL();
}
/*********************************************************************************************************
ƣ	OSTimeDly
ԭͣ	void OSTimeDly(INT16U ticks)
ܣ	ʱ 
ڲ	ʱʱ䣬ϵͳĵĸ
й˵		
*********************************************************************************************************/
void OSTimeDly(INT16U ticks)
{
    if(OSIntNesting > 0){                               /*ж õ                                 */
       return;
    }         
    if(ticks){                             	            /*ʱЧ                                    */	
	   OS_ENTER_CRITICAL();
	   OSRdyTbl &= ~(0x01<<OSPrioCur);	                /*Ӿȥ                          */
	   TCB[OSPrioCur].OSWaitTick=ticks;
	   OS_EXIT_CRITICAL();
	   OS_Sched();                                       /*µ	                                    */
	}
}
/*********************************************************************************************************
ƣ	OSTimeDlyHMSM
ԭͣ	OSTimeDlyHMSM (INT8U hours, INT8U minutes, INT8U seconds, INT16U ms)
ܣ	ʱ 
ڲ	ʱʱ䣬Сʱ
й˵		
*********************************************************************************************************/
#if OS_TIME_DLY_HMSM_EN > 0
INT8U  OSTimeDlyHMSM (INT8U hours, INT8U minutes, INT8U seconds, INT16U ms)
{
    INT32U ticks;
    INT16U loops;                                                
    ticks = ((INT32U)hours * 3600L + (INT32U)minutes * 60L + (INT32U)seconds) * OS_TICKS_PER_SEC
          + OS_TICKS_PER_SEC * ((INT32U)ms + 500L / OS_TICKS_PER_SEC) / 1000L;
    loops = (INT16U)(ticks >> 16);               
    ticks = ticks & 0xFFFFL;                     
    OSTimeDly((INT16U)ticks);
    while (loops > 0) {
        OSTimeDly((INT16U)32768u);
        OSTimeDly((INT16U)32768u);
        loops--;
    }
    return OS_ERR_NONE;
}
#endif
/*********************************************************************************************************
ƣ	OSSemCreate
ԭͣ	void OSSemCreate(OS_SEM *pevent,INT8U cnt)
ܣ	ʼź 
ڲ	peventźָ룻cntźֵ	    
*********************************************************************************************************/
#if OS_SEM_CREATE_EN >0
INT8U OSSemCreate(OS_SEM *pevent,INT8U cnt)
{
	pevent->OSSemCnt=cnt;                               /*źżֵ                            */
	pevent->OSSemPendTbl=0;
	return OS_ERR_NONE;				
}
#endif
/*********************************************************************************************************
ƣ	OSSemPend
ԭͣ	INT8U OSSemPend(OS_SEM *pevent,INT16U timeout,INT8U *perr) 
ܣ	ȴź, 
ڲ	pevent:źָ룻Timeoutʱʱ
ڲ	
й˵	Timeout==0ʱΪ޵ȴ	 úжϳʹ
*********************************************************************************************************/
#if OS_SEM_PEND_EN >0
void  OSSemPend (OS_SEM *pevent, INT16U timeout, INT8U *perr)
{
    if(OSIntNesting>0){                                 /* Ƿжϵ                           */
        *perr = OS_ERR_PEND_ISR;                        
        return;
    }
    if(OSLockNesting>0){                                /* Ƿ                           */
        *perr = OS_ERR_PEND_LOCKED;                     
        return;
    }
    OS_ENTER_CRITICAL();
	if(pevent->OSSemCnt>0){                              					
        pevent->OSSemCnt--;				                /*ź1                               */		
        OS_EXIT_CRITICAL();
		*perr = OS_ERR_NONE;
		return ;       
    }
	pevent->OSSemPendTbl |= 0x01<<OSPrioCur;            /*ȴб                                  */
	OSRdyTbl &= ~(0x01<<OSPrioCur);			            /*ȥ	                        */
	if(timeout ==0 ){        
        OS_EXIT_CRITICAL();	                            /*µ				                        */
		OS_Sched();
	    pevent->OSSemPendTbl &= ~(0x01<<OSPrioCur);
		*perr = OS_ERR_NONE;
		return ;	 
    }
	TCB[OSPrioCur].OSWaitTick = timeout;	            /*ȴʱ	        	                    */
	OS_EXIT_CRITICAL();
	OS_Sched();	
	if(TCB[OSPrioCur].OSWaitTick == 0){
		pevent->OSSemPendTbl &= ~(0x01<<OSPrioCur);
		*perr = OS_ERR_TIMEOUT;
        return ;			 
 	}      
}
#endif
/*********************************************************************************************************
ƣ	OSSemAccept
ԭͣ	INT8U OSSemAccept(OS_SEM *pevent) 
ܣ	޵ȴһź 
ڲ	pevent:źָ úжϳʹ
*********************************************************************************************************/
#if OS_SEM_ACCEPT_EN >0
INT8U OSSemAccept(OS_SEM *pevent)
{
    INT8U cnt;
    OS_ENTER_CRITICAL();
    cnt=pevent->OSSemCnt;
	if(cnt>0){				                           /*ź0	                        */	
		pevent->OSSemCnt--;				               /*ź1                                */		       
	}
	OS_EXIT_CRITICAL();
	return (cnt); 
}
#endif
/*********************************************************************************************************
ƣ	OSSemPost
ԭͣ	INT8U OSSemPost(OS_SEM *pevent) 
ܣ	һźԴжϷͣ
ڲ	peventźָ
й˵	ڵȴź򽫸ûȴǰź+1	
*********************************************************************************************************/
#if OS_SEM_POST_EN >0
INT8U OSSemPost(OS_SEM *pevent)
{
    INT8U i;
    OS_ENTER_CRITICAL();
    if(pevent->OSSemPendTbl != 0){                    /*ȴź                         */    	   
	    i=0;
	    while((i<OS_TASKS)&&(!(pevent->OSSemPendTbl&(0x01<<i)))){
		 	    i++;                                  /*ҳźȴбȼߵ        */
	       }
	    if(i<OS_TASKS){							      /*Ҫ		     	                    */		   	
		    pevent->OSSemPendTbl &= ~(0x01<<i);	      /*ӵȴȥ		                            */
			OSRdyTbl |= 0x01<<i;				      /*					                    */
            if(OSPrioCur>i){                          /*ȴźŵȼڵǰ          */	     
			    OS_EXIT_CRITICAL(); 
                OS_Sched();                            /*µ                                        */
                return (OS_ERR_NONE);
			}			
	    }     
	}
    if(pevent->OSSemCnt<255u){
	    pevent->OSSemCnt++;				               /*ʹź1			          	        */
	    OS_EXIT_CRITICAL();
	    return (OS_ERR_NONE);
    }
	OS_EXIT_CRITICAL();
	return (OS_ERR_NONE);
}
#endif
/********************************************************************************************************
ƣ	OSMboxCreate
ԭͣ	INT8U OSMboxCreate(OS_MBOX *pevent);
ܣ	ʼ 
ڲ	peventָ
*********************************************************************************************************/
#if OS_MBOX_CREATE_EN >0
INT8U OSMboxCreate(OS_MBOX *pevent)
{
	pevent->OSMboxPtr=(void *)0;                       /*ֵָ                               */
	pevent->OSMboxPendTbl=0;                           /*ȴбΪ                           */
	pevent->OSMboxStatus=OS_MBOX_EMPTY;                /*״̬Ϊ                               */
	return (OS_ERR_NONE);				
}
#endif
/*********************************************************************************************************
ƣ	OSMboxPend
ԭͣ	void *OSMboxPend(OS_MBOX *pevent,INT16U Timeout,INT8U *perr)
ܣ	ȴź, 
ڲ	pevent:ָ룻 Timeoutȴʱ;perr󷵻ش
ڲ	
й˵	Timeout==0ʱΪ޵ȴ	 úжϳʹ
*********************************************************************************************************/
#if OS_MBOX_PEND_EN >0
void *OSMboxPend(OS_MBOX *pevent,INT16U Timeout,INT8U *perr)
{ 
    void *pmsg;
	if(OSIntNesting>0){                                    /* Ƿжϵ                        */
        *perr = OS_ERR_PEND_ISR;                        
        return ((void *)0);;
    }
    if(OSLockNesting>0){                                   /* Ƿ                        */
        *perr = OS_ERR_PEND_LOCKED;                     
        return ((void *)0);;
    }
    OS_ENTER_CRITICAL();
	if(pevent->OSMboxStatus==OS_MBOX_FULL){                /*Ϣ                           */	                              					
        pmsg=pevent->OSMboxPtr;				               /*ȡϢ                                   */
        pevent->OSMboxPtr=(void *)0;                       /*                               */
		pevent->OSMboxStatus=OS_MBOX_EMPTY;	   	           /*־Ϊ                             */
		pevent->OSMboxPendTbl &= ~(0x01<<OSPrioCur);       /*ȴб                           */
        OS_EXIT_CRITICAL(); 
		*perr = OS_ERR_NONE;
		return (pmsg);      
    }
	pevent->OSMboxPendTbl |= 0x01<<OSPrioCur;              /*ȴб                           */
	OSRdyTbl &= ~(0x01<<OSPrioCur);			               /*ȥ	                        */
	if(Timeout==0){                                        /*ʱõȴֱ       */	            
        OS_EXIT_CRITICAL();	                               /*µ				                    */
		OS_Sched();
    }else{
        TCB[OSPrioCur].OSWaitTick = Timeout;	           /*ȴʱ	        	                */
	    OS_EXIT_CRITICAL();
        OS_Sched();			
	    if(TCB[OSPrioCur].OSWaitTick == 0){                /*жǷʱ                               */
		    pevent->OSMboxPendTbl &= ~(0x01<<OSPrioCur);   /*ȴб                           */
            *perr = OS_ERR_TIMEOUT;
		    return ((void *)0);
	    }
	}
    pmsg=pevent->OSMboxPtr;                                /*ȡ                               */
	pevent->OSMboxPtr=(void *)0;		                   /*                               */		             
	pevent->OSMboxStatus=OS_MBOX_EMPTY;                    /*־Ϊ                             */
	pevent->OSMboxPendTbl &= ~(0x01<<OSPrioCur);           /*ȴб                           */
	OS_EXIT_CRITICAL();	
	return (pmsg);					       
}
#endif
/*********************************************************************************************************
ƣ	OSMboxAccept
ԭͣ	void *OSMboxAccept(OS_MBOX *pevent) 
ܣ	޵ȴһ 
ڲ	pevent:ָ
*********************************************************************************************************/
#if OS_MBOX_ACCEPT_EN >0
void *OSMboxAccept(OS_MBOX *pevent)
{
    void *pmsg;
    OS_ENTER_CRITICAL();
	pmsg=pevent->OSMboxPtr;			                  /*ȡϢ                                        */	
    pevent->OSMboxPtr=(void *)0;
	pevent->OSMboxPendTbl &= ~(0x01<<OSPrioCur);      /*ȴб                                    */	
	OS_EXIT_CRITICAL();
	return (pmsg);
}
#endif
/*********************************************************************************************************
ƣ	OSMboxPost
ԭͣ	INT8U OSMboxPost(OS_MBOX *pevent,void *pmsg )
ܣ	һ䣬ԴжϷͣ
ڲ	peventָ pmsgָ
й˵	жǷΪգϢ
*********************************************************************************************************/
#if OS_MBOX_POST_EN >0
INT8U OSMboxPost(OS_MBOX *pevent,void *pmsg )
{
    INT8U i;
    OS_ENTER_CRITICAL();
    if(pevent->OSMboxStatus==OS_MBOX_EMPTY){
        pevent->OSMboxPtr=pmsg;
        pevent->OSMboxStatus=OS_MBOX_FULL;
        if(pevent->OSMboxPendTbl!=0){                /*ȴź                           */     
	        i=0;
	        while((i<OS_TASKS)&&(!(pevent->OSMboxPendTbl&(0x01<<i)))){
		        i++;                                 /*ҳźȴбȼߵ         */
	        }
	        if(i<OS_TASKS){					         /*Ҫ		                            */	
		        pevent->OSMboxPendTbl &= ~(0x01<<i); /*ӵȴȥ		                            */
		        OSRdyTbl |= 0x01<<i;				 /*					                        */
                if(OSPrioCur>i){                     /*ȴźŵȼڵǰ           */  
			        OS_EXIT_CRITICAL();
                    OS_Sched();                      /*µ                                         */
                    return (OS_ERR_NONE);
				}			
	        }     
	    }
		OS_EXIT_CRITICAL(); 
        return (OS_ERR_NONE);
    }
	OS_EXIT_CRITICAL();
	return (OS_ERR_MBOX_FULL);
}
#endif
/********************************************************************************************************
ƣ	TCN0Init
ԭͣ	void TCN0Init(void)
ܣ	ʼʱ0
й˵	ʱT0ʱ	
*********************************************************************************************************/
void TCN0Init(void)
{
	TCCR0 = 0;
	TCCR0 = 0x05;			    /* 1024ԤƵ		*/
	TIMSK |= (1<<TOIE0);		/* T0ж	*/
	TCNT0 = (256-F_CPU/1024/OS_TICKS_PER_SEC);
}
SIGNAL(SIG_OVERFLOW0)
{    
	OSIntEnter();
    TCNT0 = (256-F_CPU/1024/OS_TICKS_PER_SEC);	
    OSTimeTick();	
	OSIntExit();
}
#if OS_CPU_HOOKS_EN > 0
void  OSTimeTickHook (void){}
void  OSTaskIdleHook (void){}
void  OSInitHookBegin (void){}
#endif

