/*
 ============================================================================
 Name        : hev-impathy-server-sasl-handler.h
 Author      : Heiher <admin@heiher.info>
 Version     : 0.0.1
 Copyright   : Copyright (C) 2011 everyone.
 Description : 
 ============================================================================
 */

#ifndef __HEV_IMPATHY_SERVER_SASL_HANDLER_H__
#define __HEV_IMPATHY_SERVER_SASL_HANDLER_H__

#include <glib-object.h>
#include <telepathy-glib/account.h>
#include <telepathy-glib/channel.h>

G_BEGIN_DECLS

#define HEV_TYPE_IMPATHY_SERVER_SASL_HANDLER	(hev_impathy_server_sasl_handler_get_type())
#define HEV_IMPATHY_SERVER_SASL_HANDLER(obj)	(G_TYPE_CHECK_INSTANCE_CAST((obj), HEV_TYPE_IMPATHY_SERVER_SASL_HANDLER, HevImpathyServerSASLHandler))
#define HEV_IS_IMPATHY_SERVER_SASL_HANDLER(obj)	(G_TYPE_CHECK_INSTANCE_TYPE((obj), HEV_TYPE_IMPATHY_SERVER_SASL_HANDLER))
#define HEV_IMPATHY_SERVER_SASL_HANDLER_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), HEV_TYPE_IMPATHY_SERVER_SASL_HANDLER, HevImpathyServerSASLHandlerClass))
#define HEV_IS_IMPATHY_SERVER_SASL_HANDLER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), HEV_TYPE_IMPATHY_SERVER_SASL_HANDLER))
#define HEV_IMPATHY_SERVER_SASL_HANDLER_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), HEV_TYPE_IMPATHY_SERVER_SASL_HANDLER, HevImpathyServerSASLHandlerClass))

typedef struct _HevImpathyServerSASLHandler HevImpathyServerSASLHandler;
typedef struct _HevImpathyServerSASLHandlerClass HevImpathyServerSASLHandlerClass;

struct _HevImpathyServerSASLHandler
{
	GObject parent_instance;
};

struct _HevImpathyServerSASLHandlerClass
{
	GObjectClass parent_class;
};

GType hev_impathy_server_sasl_handler_get_type(void);

void hev_impathy_server_sasl_handler_new_async(
			TpAccount *account, TpChannel *channel,
			GAsyncReadyCallback callback,
			gpointer user_data);
GObject * hev_impathy_server_sasl_handler_new_finish(
			GAsyncResult *res, GError **error);

void hev_impathy_server_sasl_handler_provide_password(
			HevImpathyServerSASLHandler *self,
			const gchar *password, gboolean remember);

void hev_impathy_server_sasl_handler_cancel(
			HevImpathyServerSASLHandler *self);

TpAccount * hev_impathy_server_sasl_handler_get_account(
			HevImpathyServerSASLHandler *self);

TpChannel * hev_impathy_server_sasl_handler_get_channel(
			HevImpathyServerSASLHandler *self);

gboolean hev_impathy_server_sasl_handler_has_password(
			HevImpathyServerSASLHandler *self);

gboolean hev_impathy_server_sasl_handler_can_save_response_somewhere(
			HevImpathyServerSASLHandler *self);

G_END_DECLS

#endif /* __HEV_IMPATHY_SERVER_SASL_HANDLER_H__ */

