/*
 ============================================================================
 Name        : hev-scgi-response.h
 Author      : Heiher <root@heiher.info>
 Version     : 1.0.0
 Copyright   : Copyright (C) 2013 everyone.
 Description : 
 ============================================================================
 */

#ifndef __HEV_SCGI_RESPONSE_H__
#define __HEV_SCGI_RESPONSE_H__

#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define HEV_TYPE_SCGI_RESPONSE	(hev_scgi_response_get_type())
#define HEV_SCGI_RESPONSE_CAST(obj)	((HevSCGIResponse *)obj)
#define HEV_SCGI_RESPONSE(obj)	(G_TYPE_CHECK_INSTANCE_CAST((obj), HEV_TYPE_SCGI_RESPONSE, HevSCGIResponse))
#define HEV_IS_SCGI_RESPONSE(obj)	(G_TYPE_CHECK_INSTANCE_TYPE((obj), HEV_TYPE_SCGI_RESPONSE))
#define HEV_SCGI_RESPONSE_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), HEV_TYPE_SCGI_RESPONSE, HevSCGIResponseClass))
#define HEV_IS_SCGI_RESPONSE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), HEV_TYPE_SCGI_RESPONSE))
#define HEV_SCGI_RESPONSE_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), HEV_TYPE_SCGI_RESPONSE, HevSCGIResponseClass))

typedef struct _HevSCGIResponse HevSCGIResponse;
typedef struct _HevSCGIResponseClass HevSCGIResponseClass;

struct _HevSCGIResponse
{
	GObject parent_instance;
};

struct _HevSCGIResponseClass
{
	GObjectClass parent_class;
};

GType hev_scgi_response_get_type(void);

GObject * _hev_scgi_response_new(void);
void _hev_scgi_response_set_output_stream(HevSCGIResponse *self,
			GOutputStream *output_stream);

GHashTable * hev_scgi_response_get_header_hash_table(HevSCGIResponse *self);
void hev_scgi_response_set_header_hash_table(HevSCGIResponse *self, GHashTable *hash_table);
gboolean hev_scgi_response_write_header(HevSCGIResponse *self, GError **error);
void hev_scgi_response_write_header_async(HevSCGIResponse *self,
			GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data);
gboolean hev_scgi_response_write_header_finish(HevSCGIResponse *self, GAsyncResult *res,
			GError **error);
GOutputStream * hev_scgi_response_get_output_stream(HevSCGIResponse *self);

G_END_DECLS

#endif /* __HEV_SCGI_RESPONSE_H__ */

