/**************************************/
/*  keisoku.c                         */
/*  ۸ ƭخ  ۸ ̧   */
/**************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "common.h"
#include "main.h"
#include "keisoku.h"

extern int akicode_tbl[ MEMBER_MAX + 1 ];			/*  ˮ */
extern int codedata_tbl[ MEMBER_MAX ];				/* ް  ˮ */
extern struct KEISOKU_TBL kojin_keisoku_tbl;			/*   ްˮ */
extern struct KEISOKU_TBL sort_keisoku_tbl[ MEMBER_MAX ];	/*  ֳ  ް ˮ */


/* ƭخ  ް ð */
static struct  KEISOKU_INPUT   keisoku_indata[ 5 ];

/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*   Ҳ                            */
/*   Ұ : ż                    */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
int keisoku_input( void )
{
    int     ret;                /*          */
    int     i;                  /* ޯ          */
    int     kaiin_code;         /*      */
    int     undou_sisuu;        /* ݼ ޳   */
    char    msg[ 64 ];          /* ү ر       */
    char    keisoku_date[ 9 ];  /*  ޹        */

    /*   ˮ READ -> NG ? */
    if( (ret = akicode_tbl_read( )) == NG ) {
        return ret;
    }

    /* ƭ  */
    if( akicode_tbl[ 0 ] >= MEMBER_MAX ) {
        printf( "\n ݻ޲ ƭ  Ͼ" );
        return NG;
    }

    /*  ް  ˮ ̧ READ -> NG ? */
    if( (ret = codedata_tbl_read( )) == NG ) {
        return ret;
    }

    /*    ƭخ */
    kaiin_code_input( &kaiin_code );

    /*  ޹ ƭخ */
    keisoku_date_input( keisoku_date );

    /*  ƭخ  */
    for( i = 0; i < 5; i++ ) {
        keisoku_data_input( i );
    }

    /* ƭخ ް ˮ */
    keisoku_data_disp( kaiin_code, keisoku_date );

    /* ƭخ  */
    strcpy( msg, "\n ƭخ  ۼ ޽( Y/N )" );

    /* 'N' OR 'n' ƭخ -> OK  Ų ? */
    if( (ret = kakunin_input( msg )) != OK ) {
        return NG;
    }

    /*  ް ˮ READ -> NG ? */
    if( (ret = kojin_data_read( kaiin_code )) == NG ) {
        return ret;
    }

    /*    */
    undou_sisuu_keisan( &undou_sisuu );

    /*  ް ˮ SET */
    kojin_data_update( kaiin_code, keisoku_date, undou_sisuu );

    /*   ް ˮ */
    kojin_data_disp( kaiin_code, "\n **   ް **" );

    /*  ƭخ  */
    while( getchar( ) != '\n' ) ;
    printf( "\n    ø޻." );
    getchar( );

    /*   ޭݲ  ˮ */
    ret = keisoku_rank( );

    return ret;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*    ް  ˮ ̧ READ  */
/*   Ұ : ż                    */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
#ifdef ADMIN
int codedata_tbl_read( void )
#else
static int codedata_tbl_read( void )
#endif
{
    int     ret;                        /*                  */
    FILE    *fp;                        /* ̧ ߲               */
    char    *fname = CODEDATA_TBL_NAME;	/*  ް  ˮ ̧ */

    /*  ް  ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n  ް  ˮ ̧ OPEN װ" );
        return NG;
    }

    /*  ް  ˮ ̧ READ -> 1޲ ? */
    if( (ret = fread( (char *)codedata_tbl, sizeof( codedata_tbl ), 1, fp ))
               != 1 ) {
        printf( "\n  ް  ˮ ̧ READ װ" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /*  ް  ˮ ̧ CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*   ݺ ƭخ                */
/*   Ұ : ƭخ        */
/*      : ż                    */
/************************************/
static void kaiin_code_input( int *kaiin_code )
{
    int     loop = TRUE;    /* ٰ ׸    */
    char    work[ 128 ];    /* ƭخ ܰ   */

    while( loop ) {
        printf( "\n      ƭخ ø޻" );
        printf( "\n ? " );

        /*   ƭخ */
		work[ 0 ] = '\0';
        scanf( "%s", work );

        /* ƭد  ->  ޲ ? */
        if( strspn( work, "1234567890" ) < strlen( work ) ) {
            printf( "\n  ޲  ƭخ ϼ" );
            continue;
        }

        /* ƭخ ݲ ( 0 < kaiin_code <= MEMBER_MAX ) */
        *kaiin_code = atoi( work );
        if( *kaiin_code > MEMBER_MAX || *kaiin_code <= 0 ) {
            printf( "\n ƭخ н ޽" );
            continue;
        }

        /* ݺ ĳ۸  -> ĳ۸ ? */
        if( codedata_tbl[ *kaiin_code - 1 ] == 0 ) {
            printf( "\n  ݺ  ĳ۸ ޽" );
            continue;
        }
        break;
    }
    return;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*    ޹ ƭخ               */
/*   Ұ : ƭخ ޹           */
/*      : ż                    */
/************************************/
static void keisoku_date_input( char *keisoku_date )
{
    int     loop = TRUE;    /* ٰ ׸    */
    int     chk_date;       /* ޹      */
    char    conv[ 3 ];      /*  ݶ ֳ  */
    char    work[ 128 ];    /* ƭخ ܰ   */

    while( loop ) {
        printf( "\n ޹  ƭخ ø޻( YYYYMMDD )" );
        printf( "\n ? " );

        /* ޹ ƭخ */
		work[ 0 ] = '\0';
        scanf( "%s", work );

        /* ƭخ   -> 8޲ ? */
        if( strlen( work ) != 8 ) {
            printf( "\n ƭخ н ޽" );
            continue;
        }

        /* ƭد  -> ޲ ? */
        if( strspn( work, "1234567890" ) < strlen( work ) ) {
            printf( "\n  ޲  ƭخ ϼ" );
            continue;
        }

        /* ·  */
	conv[0] = work[4];
	conv[1] = work[5];
	conv[2] = '\0';

        chk_date = atoi( conv );
        if( chk_date > 12 || chk_date < 1 ) {
            printf( "\n ޹( · ) ƭخ װ ޽" );
            continue;
        }

        /*   */
	conv[0] = work[6];
	conv[1] = work[7];
	conv[2] = '\0';
        chk_date = atoi( conv );
        if( chk_date > 31 || chk_date < 1 ) {
            printf( "\n ޹(  ) ƭخ װ ޽" );
            continue;
        }

        break;
    }

    /* ƭخ ް  */
    strcpy(keisoku_date, work);
    return;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*    ƭخ                */
/*   Ұ : ޯ               */
/*      : ż                    */
/************************************/
static void keisoku_data_input( int idx )
{
    int     i;                  /* ޯ      */
    int     loop = TRUE;        /* ٰ ׸    */
    char    work[ 3 ][ 128 ];   /* ƭخ ܰ   */

    while( loop ) {
        printf( "\n ޳ %d   ް  ƭخ ø޻", idx + 1 );
        printf( "\n   ̶(999)  (100)  (100)" );
        printf( "\n ? " );

        /*  ް ƭخ */
   	work[ 0 ][ 0 ] = '\0';
	work[ 1 ][ 0 ] = '\0';
	work[ 2 ][ 0 ] = '\0';
        scanf( "%s %s %s", work[ 0 ], work[ 1 ], work[ 2 ] );

        for( i = 0; i < 3; i++ ) {

            /* ƭخ   -> 3ص ? */
            if( strlen( work[ i ] ) > 3 ) {
                printf( "\n ƭخ н ޽" );
                break;
            }

            /* ƭد  -> ޲ ? */
            if( strspn( work[ i ], "1234567890" ) < strlen( work[ i ] ) ) {
                printf( "\n  ޲  ƭخ ϼ" );
                break;
            }

            /* ̶ ޲  ޮ  -> 100 ص ? */
            if( i != 0 ) {
                if( atoi( work[ i ] ) > 100 ) {
                    printf( "\n ޮ(100)  òϽ" );
                    break;
                 }
            }
        }//for( i = 0; i < 3; i++ )

        if( i < 3 ) {
            continue;
        }

        break;
    }//while( loop )

    /* ƭخ ް ð  */
    keisoku_indata[ idx ].huka = atoi( work[ 0 ] );
    keisoku_indata[ idx ].set = atoi( work[ 1 ] );
    keisoku_indata[ idx ].kaisuu = atoi( work[ 2 ] );

    return;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*   ƭخ  ˮ          */
/*   Ұ :               */
/*            ޹                  */
/*      : ż                    */
/************************************/
static void keisoku_data_disp( int kaiin_code, char *keisoku_date )
{
    int     i;  	/* ޯ      */

    printf( "\n ** ƭخ  ް **" );
    printf( "\n ݺ %3d", kaiin_code );
    printf( "\n ޹     %4.4s-%2.2s-%2.2s", 
        ( keisoku_date + 0 ), ( keisoku_date + 4 ), ( keisoku_date + 6 ) );

    printf( "\n\n ޳    ̶        " );

    for( i = 0; i < 5; i++ ) {
        printf( "\n   %d     %3d    %3d     %3d", i + 1, 
            keisoku_indata[ i ].huka,
            keisoku_indata[ i ].set,
            keisoku_indata[ i ].kaisuu );
    }

    return;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*   ޳                */
/*   Ұ : ޳              */
/*      : ż                    */
/************************************/
static void undou_sisuu_keisan( int *undou_sisuu )
{
    int     i;              /* ޯ      */
    double  sisuu;          /*  ܰ     */
    double  sisuu_total;    /*  ޳  */
    static  double  huka_sisuu[ 5 ] = { 0.24, 0.36, 0.52, 1.05, 2.13 };

    sisuu_total = 0.0;
    for( i = 0; i < 5; i++ ) {

        /*  1 ? */
        if( keisoku_indata[ i ].kaisuu <= 1 ) {
            continue;
        }

        sisuu = huka_sisuu[ i ] * (double)keisoku_indata[ i ].huka * 
               (double)keisoku_indata[ i ].set *
               ((pow( (double)keisoku_indata[ i ].kaisuu, 2.0 )) /
               ((double)keisoku_indata[ i ].kaisuu - 1.0));

        /* (ٲ)   */
        sisuu_total += sisuu;
    }

    /* Ͳγ  ݼ */
    *undou_sisuu = (int)sqrt( sisuu_total );

    return;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*    ް ˮ ̧         */
/*   Ұ :               */
/*            ޹                  */
/*            ޳              */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
static int kojin_data_update( int kaiin_code, char *keisoku_date, int undou_sisuu )
{
    int     ret;					/*              */
    long    fptr;					/*  ް ̧ ߲ */
    FILE    *fp;					/* ̧ ߲           */
    char    *fname = KEISOKU_TBL_NAME;			/*  ް ˮ ̧   */
    int	    i;						/* ޯ		*/

    /* 1 ? */
    if( kojin_keisoku_tbl.count <= 0 ) {
		strcpy( kojin_keisoku_tbl.first_date, keisoku_date );
        kojin_keisoku_tbl.first_data = undou_sisuu;

		strcpy( kojin_keisoku_tbl.max_date, keisoku_date );
        kojin_keisoku_tbl.max_data = undou_sisuu;
    }
    else {

        /*  ۸ ? */
        if( kojin_keisoku_tbl.max_data < undou_sisuu ) {
			strcpy( kojin_keisoku_tbl.max_date, keisoku_date );
            kojin_keisoku_tbl.max_data = undou_sisuu;
        }
		for (i = sizeof kojin_keisoku_tbl.soku_data / sizeof(int) - 1; i > 0; i-- )
			kojin_keisoku_tbl.soku_data[ i ] = kojin_keisoku_tbl.soku_data[ i - 1 ];
    }

	strcpy( kojin_keisoku_tbl.soku_date, keisoku_date );
    kojin_keisoku_tbl.soku_data[ 0 ] = undou_sisuu;
    kojin_keisoku_tbl.count++;

    /*  ް ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname, "r+b" )) == NULL ) {
        printf( "\n  ް ˮ ̧ OPEN װ" );
        return NG;
    }

    /* ޲ĳ ް ߲  */
    fptr = ( codedata_tbl[ kaiin_code - 1 ] - 1 ) * 
        sizeof( struct KEISOKU_TBL );

    /*  ް ˮ ̧ SEEK -> OK  Ų ? */
    if( (ret = fseek( fp, fptr, SEEK_SET )) != OK ) {
        printf( "\n  ް ˮ ̧ SEEK װ" );

        /*  ް ˮ ̧ CLOSE */
        fclose( fp );
        return NG;
    }

    /*  ް ˮ ̧ WRITE -> 1޲ ? */
    if( (ret = fwrite( (char *)&kojin_keisoku_tbl, sizeof( kojin_keisoku_tbl ),
               1, fp )) != 1 ) {
        printf( "\n  ް ˮ ̧ WRITE װ" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /*  ް ˮ ̧ CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*     ޭݲ  ˮ       */
/*   Ұ : ż                    */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
#ifdef ADMIN
int keisoku_rank( void )
#else
static int keisoku_rank( void )
#endif
{
    int     ret;						/*              */
    int     i;							/* ޯ              */
    FILE    *fp;						/* ̧ ߲           */
    char    *fname = KEISOKU_TBL_NAME;				/*  ް ˮ ̧   */

    /*  ް ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n  ް ˮ ̧ OPEN װ" );
        return NG;
    }

    i = 0;
    for( ; ; ) {

        /*  ް ˮ ̧ READ -> 1޲ ? */
        if( (ret = fread( (char *)&sort_keisoku_tbl[ i ],
                   sizeof( struct KEISOKU_TBL ), 1, fp )) != 1 ) {

            /* READ װ ? */
            if( ferror( fp ) != 0 ) {
                printf( "\n  ް ˮ ̧ READ װ" );
                ret = NG;
            }
            else {
                /* ̧ EOF  Ų ? */
                if( feof( fp ) == 0 ) {
                    printf( "\n  ް ˮ ̧ READ װ" );
                    ret = NG;
                }
                else {
                    ret = OK;
                }
            }
        }//if( (ret = fread( (char *)&sort_keisoku_tbl[ i ],

        /* READ װ ? */
        if( ret == NG ) {
            break;
        }

        /*  ް  ? */
        if( sort_keisoku_tbl[ i ].count != 0 ) {
            i++;
        }

        /* eof ? */
        if( ret == OK ) {
            break;
        }
    }

    /*  ް ˮ ̧ CLOSE */
    fclose( fp );

    if( ret == OK ) {
        /*  ް  */
        keisoku_data_sort( i );
        /*  ް   ˮ */
        keisoku_sort_disp( i );
    }

    return ret;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*                        */
/*   Ұ :  ް ݽ        */
/*      : ż                    */
/************************************/
static void keisoku_data_sort( int cnt )
{
    int     i;                  	/* ޯ      */
    int     j;                  	/* ޯ      */
    struct  KEISOKU_TBL  work;  	/* ܯ ֳ ر */

    /* ް  */
    for( i = 0; i < cnt - 1; i++ ) {
        for( j = i + 1; j < cnt; j++ ) {
            if( sort_keisoku_tbl[ i ].max_data < 
                sort_keisoku_tbl[ j ].max_data ) {

				work = sort_keisoku_tbl[ i ];
                sort_keisoku_tbl[ i ] = sort_keisoku_tbl[ j ];
                sort_keisoku_tbl[ j ] = work;
            }
        }
    }
	return;
}



/************************************/
/* ް  ۸                */
/*   ۸ ƭخ              */
/*     ˮ                 */
/*   Ұ :  ް ݽ        */
/*      : ż                    */
/************************************/
static void keisoku_sort_disp( int cnt )
{
    int     i;  /* ޯ  */

    printf( "\n\n ** ޭݲ ˮ **" );
    printf( "\n ޭݲ ݺ  ް   ޹" );

    for( i = 0; i < cnt; i++ ) {

        /* 10  ˮ  */
        if( i >= 10 ) {
            break;
        }

        printf( "\n   %2d   %3d        %4d   %4.4s-%2.2s-%2.2s", i + 1,
            sort_keisoku_tbl[ i ].kaiin_code,
            sort_keisoku_tbl[ i ].max_data,
            &sort_keisoku_tbl[ i ].max_date[ 0 ],
            &sort_keisoku_tbl[ i ].max_date[ 4 ],
            &sort_keisoku_tbl[ i ].max_date[ 6 ] );
    }
	return;
}
