/***********************************/
/*  main.c                         */
/*     ް  ۸ */
/***********************************/
#include <stdio.h>
#include <string.h>

#include "common.h"
#include "main.h"
#include "nyuukai.h"
#include "keisoku.h"
#include "sakujyo.h"

/***********************************/
/* ³ ް                      */
/***********************************/

/*  ˮ */
int akicode_tbl[ MEMBER_MAX + 1 ];

/* ް  ˮ */
int codedata_tbl[ MEMBER_MAX ];

/*   ްˮ */
struct KEISOKU_TBL kojin_keisoku_tbl;

/*  ֳ  ް ˮ */
struct KEISOKU_TBL sort_keisoku_tbl[ MEMBER_MAX ];


/***********************************/
/* ް  ۸               */
/*  Ҳ                            */
/*   Ұ : ż                   */
/*      : ż                   */
/***********************************/
int main( void )
{
    int    loop = TRUE;			/* ٰ ׸                */
    char   work[ 128 ];			/* ƭخ ܰ               */
    FILE   *fp;				/* ̧ ߲               */
    char   *fname1 = AKICODE_TBL_NAME;	/*   ˮ ̧         */
    char   *fname2 = CODEDATA_TBL_NAME;	/*  ް  ˮ ̧ */
    int	   i;				/* ޯ		    */

    /*   ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname1, "rb" )) == NULL ) {
        printf( "\n   ˮ ̧   òϽ" );

        /*   ˮ ̧  */
        akicode_tbl_create( );
    }
    else {
        /*   ˮ ̧ CLOSE */
        fclose( fp );
    }

    /*  ް  ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname2, "rb" )) == NULL ) {
        printf( "\n  ް  ˮ ̧   òϽ" );

        /*  ް  ˮ ̧  */
        codedata_tbl_create( );
    }
    else {
        /*  ް  ˮ ̧ CLOSE */
        fclose( fp );
    }

    while( loop ) {
        /* ð  ر */
		akicode_tbl[ 0 ] = 0;
		for( i = 0; i < MEMBER_MAX; i++) {
			akicode_tbl[ i + 1 ] = 0;
			codedata_tbl[ i ] = 0;
			sort_keisoku_tbl[ i ] = init_kojin_keisoku_tbl();
		}
		kojin_keisoku_tbl = init_kojin_keisoku_tbl();

        printf( "\n" );
        printf( "\n *******************************" );
        printf( "\n    ް  ۸ " );
        printf( "\n *******************************" );
        printf( "\n    ø޻" );
        printf( "\n 1:ƭ ĳ۸" );
        printf( "\n 2: ۸ ƭخ" );
        printf( "\n 3:ĳ۸ ޮ" );
        printf( "\n E:خ" );
        printf( "\n ? " );

        /* ظ ƭخ */
        work[ 0 ] = '\0';
        scanf( "%s", work );

        /* ƭخ   -> 1޲ ? */
        if( strlen( work ) != 1 ) {
            printf( "\n ƭخ н ޽" );
            continue;
        }

        switch( work[ 0 ] ) {
            case '1':       /* ƭ ĳ۸     */
                nyuukai_touroku( );
                break;

            case '2':       /*  ۸  */
                keisoku_input( );
                break;

            case '3':       /* ĳ۸ ޮ     */
                touroku_sakujyo( );
                break;

            case 'e':       /* خ         */
            case 'E':
                loop = FALSE;
                break;

            default:
                printf( "\n ƭخ н ޽" );
                break;
        }
    }
    return OK;
}



/************************************/
/* ް  ۸                */
/*  ƭ ĳ۸                   */
/*     ˮ ̧           */
/*   Ұ : ż                    */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
static int akicode_tbl_create( void )
{
    int     ret;				/*          */
    int     i;					/* ޯ          */
    FILE    *fp;				/* ̧ ߲       */
    char    *fname = AKICODE_TBL_NAME;		/*   ˮ ̧ */

    /*   ݼ */
    akicode_tbl[ 0 ] = MEMBER_MAX;
    for( i = 1; i < MEMBER_MAX + 1; i++ ) {
        akicode_tbl[ i ] = i;
    }

    /*   ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname, "w+b" )) == NULL ) {
        printf( "\n  ˮ ̧ OPEN װ" );
        return NG;
    }

    /*   ˮ ̧ WRITE -> 1޲ ? */
    if( (ret = fwrite( (char *)akicode_tbl, sizeof( akicode_tbl ), 1, fp ) )
               != 1 ) {
        printf( "\n  ˮ ̧ WRITE װ" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /*   ˮ ̧ CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ް  ۸                */
/*  ƭ ĳ۸                   */
/*    ް  ˮ ̧   */
/*   Ұ : ż                    */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
static int codedata_tbl_create( void )
{
    int     ret;                        	/*                  */
    FILE    *fp;                        	/* ̧ ߲               */
    char    *fname = CODEDATA_TBL_NAME;		/*  ް  ˮ ̧ */
    int	    i;					/* ޯ		    */

    /*  ް  ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname, "w+b" )) == NULL ) {
        printf( "\n  ް  ˮ ̧ OPEN װ" );
        return NG;
    }

	for( i = 0; i < MEMBER_MAX; i++ )
		codedata_tbl[ i ] = 0;

    /*  ް  ˮ ̧ WRITE -> 1޲ ? */
    if( (ret = fwrite( (char *)codedata_tbl, sizeof( codedata_tbl ), 1, fp ) )
               != 1 ) {
        /* WRITE װ */
        printf( "\n  ް  ˮ ̧ WRITE װ" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /*  ް  ˮ ̧ CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ³ ٰ                       */
/************************************/


/************************************/
/* ް  ۸                */
/*  ƭ ĳ۸                   */
/*     ˮ ̧ READ          */
/*   Ұ : ż                    */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
int akicode_tbl_read( void )
{
    int     ret;				/*          */
    int     i;					/* ޯ          */
    FILE    *fp;				/* ̧ ߲       */
    char    *fname = AKICODE_TBL_NAME;		/*   ˮ ̧ */

    /*   ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n   ˮ ̧ OPEN װ" );
        return NG;
    }

    for( i = 0; i < MEMBER_MAX + 1; i++ ) {
        /*   ˮ ̧ READ -> 1޲ ? */
        if( (ret = fread( (char *)&akicode_tbl[ i ], sizeof( int ), 1, fp ) )
                   != 1 ) {
            /* READ װ  ? */
            if( ferror( fp ) != 0 ) {
                printf( "\n   ˮ ̧ READ װ" );
                ret = NG;
            }
            else {
                /* ̧ EOF  Ų ? */
                if( feof( fp ) == 0 ) {
                    printf( "\n   ˮ ̧ READ װ" );
                    ret = NG;
                }
                else {
                    ret = OK;
                }
            }
            break;
        }
#ifdef DEBUG
        printf("[%s:%d]\n", __FILE__, __LINE__);
        printf("akicode_tbl[%d]=%d\n",
        			i, akicode_tbl[i]);
        printf("\n");
#endif
    }

#ifdef DEBUG
    /* Show a part of akicode_tbl[] */
    printf("[%s:%d]\n", __FILE__, __LINE__);
    printf("akicode_tbl[]\n");
    for(i = 0; i < 10; i++) {
    	printf("akicode_tbl[%d]=%c(%%d=%d)\n",
    			i, akicode_tbl[i], akicode_tbl[i]);

    }
    printf("\n");
#endif

    /*   ˮ ̧ CLOSE */
    fclose( fp );

    return ret;
}



/***********************************/
/* ް  ۸               */
/*  ƭخ                     */
/*   Ұ :  ү          */
/*      : 0:OK                 */
/*           -1:NG                 */
/*           -2:quit               */
/*           -3:choose a number    */
/***********************************/
int kakunin_input( char *msg )
{
    int     ret;            /*      */
    int     loop = TRUE;    /* ٰ ׸    */
    char    work[ 128 ];    /* ƭخ ܰ   */

    while( loop ) {
        /*  ˮ */
        printf( msg );
        printf( "\n ? " );

        /* Y/N ƭخ */
        work[ 0 ] = '\0';
        scanf( "%s", work );

        /* ƭخ   -> 1޲ ? */
        if( strlen( work ) != 1 ) {
            printf( "\n ƭخ н ޽" );
            continue;
        }

        switch( work[ 0 ] ) {
            case 'Y':   /* Yes */
            case 'y':
                ret  = OK;
                loop = FALSE;
                break;

            case 'N':   /* No */
            case 'n':
                ret  = NG;
                loop = FALSE;
                break;
            case 'Q':	/* Quit */
            case 'q':
            	ret = -2;
            	loop = FALSE;
				break;
            case 'C':	/* Choose a number */
			case 'c':
				ret = -3;
				loop = FALSE;
				break;
            default:
                printf( "\n ƭخ н ޽" );
                break;
        }
    }

    return ret;
}



/************************************/
/* ް  ۸                */
/*     ް ˮ ̧ READ   */
/*   Ұ : ݺ              */
/*      : 0:OK                  */
/*           -1:NG                  */
/************************************/
int kojin_data_read( int kaiin_code )
{
    int     ret;				/*                  */
    FILE    *fp;				/*  ް ˮ ̧ ߲ */
    long    fptr;				/*  ް ̧ ߲     */
    char    *fname = KEISOKU_TBL_NAME;		/*  ް ˮ ̧       */

    /*  ް ˮ ̧ OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n  ް ˮ ̧ OPEN װ" );
        return NG;
    }

    /* ޲ĳ ް ߲  */
    fptr = ( codedata_tbl[ kaiin_code - 1 ] - 1 ) *
             sizeof( struct KEISOKU_TBL );

    /*  ް ˮ ̧      SEEK -> OK ? */
    if( (ret = fseek( fp, fptr, SEEK_SET )) != OK ) {
        printf( "\n  ް ˮ ̧ SEEK װ" );

        /*  ް  ˮ ̧ CLOSE */
        fclose( fp );
        return NG;
    }

    /*  ް ˮ ̧ READ -> 1޲ ? */
    if( (ret = fread( (char *)&kojin_keisoku_tbl, sizeof( kojin_keisoku_tbl ),
               1, fp )) != 1 ) {
        printf( "\n  ް ˮ READ װ" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /*  ް  ˮ ̧ CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ް  ۸                */
/*    ް ˮ                */
/*   Ұ : ݺ              */
/*            ˮ ү          */
/*      : ż                    */
/************************************/
void kojin_data_disp( int kaiin_code, char *msg )
{
    printf( msg );
    printf( "\n ݺ %3d", kaiin_code );

    if( kojin_keisoku_tbl.count != 0 ) {
        printf( "\n\n     ޹   ް     " );
        printf( " ޹   ް      ޹   ް" );

        printf( "\n    %3d", kojin_keisoku_tbl.count );

        printf( "    %4.4s-%2.2s-%2.2s",
            &kojin_keisoku_tbl.first_date[ 0 ],
            &kojin_keisoku_tbl.first_date[ 4 ],
            &kojin_keisoku_tbl.first_date[ 6 ] );

        printf( "   %4d", kojin_keisoku_tbl.first_data );

		printf( "    %4.4s-%2.2s-%2.2s",
            &kojin_keisoku_tbl.max_date[ 0 ],
            &kojin_keisoku_tbl.max_date[ 4 ],
            &kojin_keisoku_tbl.max_date[ 6 ] );

        printf( "   %4d", kojin_keisoku_tbl.max_data );

        printf( "    %4.4s-%2.2s-%2.2s",
            &kojin_keisoku_tbl.soku_date[ 0 ],
            &kojin_keisoku_tbl.soku_date[ 4 ],
            &kojin_keisoku_tbl.soku_date[ 6 ] );

        printf( "   %4d", kojin_keisoku_tbl.soku_data[ 0 ] );

        printf( "\n\n    1ϴ   2ϴ   3ϴ   4ϴ   ");
        printf( "5ϴ   6ϴ   7ϴ   8ϴ   9ϴ" );

        printf( "\n " );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 1 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 2 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 3 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 4 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 5 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 6 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 7 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 8 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 9 ] );
    }
	else {
        printf( "     ް  Ͼ" );
	return;
	}
    return;
}



/************************************/
/* ް  ۸                */
/*    ް                  */
/*   Ұ : ż                    */
/*      :  ް             */
/************************************/
struct KEISOKU_TBL init_kojin_keisoku_tbl( void )
{
	static struct KEISOKU_TBL tbl = {
		0, 0, "        ", 0, "        ", 0, "        ", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	};
	return tbl;
}

/************************************/
/* ް  ۸                */
/*   o^ԍI                 */
/*   Ұ : ż                    */
/*      : I          */
/************************************/
int  choose_number( void )
{
	char	buf[10];	/* ͗p̃obt@[ */
	int		number;		/* ͂ */
	//int		loop = 1;	/* while [vp̃tO */

	/* ̓ */
	while (1) {
	//while (loop) {
		printf("Input a number: ");
		fgets(buf, sizeof(buf), stdin);

		/* 
		 * PDbuf Ɏ荞܂ꂽɂāA
		 * 		siɌ
		 * QDbuf ɓĂ镶񂪁Al
		 * 		ǂA؂
		 * RDĂAIƂ𑱂邩A
		 * 		mF̃bZ[Wo
		 * SD 'n' łA-1 Ԃ
		 * TD 'y' łA[v𑱂
		 */

		buf[strlen(buf) - 1] = 0;
		if (!isdigit(buf)) {
			int		ret;	/* kakunin_input() */

			printf("Input is not a number: %s\n",
						buf);

			while (1) {
				ret = kakunin_input
					("Continue to choose a number?(Y/N)");
				if (ret == OK)
					break;
				else if (ret == NG)
					return -1;
				else
					printf("Input is not appropriate."
							" 'Y' or 'N', please ");
				//printf("Continue to choose a number?"
					//	"(Y/N)");
			}//while (1) {
		} else {
			sscanf(buf, "%d", &number);
			return number;
		}
	}//while (1) {
}//int  choose_number( void )
