#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "jeu.h"

int		choose_map()
{
	SDL_Surface	*fenetre;
	SDL_Surface	*choose;
	int		flag;

	fenetre = NULL;
	choose = IMG_Load("./image/choose_lvl.png");
	if (SDL_Init(SDL_INIT_VIDEO) == -1)
	{
		write(2, "SDL Error\n", 10);
		exit(EXIT_FAILURE);
	}
	fenetre = SDL_SetVideoMode(800, 600, 32, SDL_HWSURFACE | SDL_RESIZABLE | SDL_DOUBLEBUF);
	if (fenetre == NULL)
	{
		write(2, "SDL Error\n", 10);
		exit(EXIT_FAILURE);
	}
	SDL_WM_SetCaption("Epikong", NULL);
	SDL_EnableKeyRepeat(100, 100);
	flag = choose_event(fenetre, choose);
	SDL_EnableKeyRepeat(0, 0);
	SDL_FreeSurface(choose);
	SDL_Quit();
	return (flag);
}

int	choose_event(SDL_Surface *fenetre, SDL_Surface *choose)
{
	int		continuer;
	int		flag;
	SDL_Rect	position;
	SDL_Event	event;

	continuer = 1;
	while (continuer)
	{
		SDL_WaitEvent(&event);
		if (event.type == SDL_QUIT) 
			continuer = 0;
		if (event.type == SDL_KEYDOWN) 
		{
			if (event.key.keysym.sym == SDLK_ESCAPE) 
				continuer = 0;
			else
			{
				if (event.key.keysym.sym == SDLK_1)
					flag = 1;
				if (event.key.keysym.sym == SDLK_2)
					flag = 2;
				if (event.key.keysym.sym == SDLK_3)
					flag = 3;
				if (event.key.keysym.sym == SDLK_4)
					flag = 4;
				if (event.key.keysym.sym == SDLK_5)
					flag = 5;
				continuer = 0;
			}
		}
		SDL_FillRect(fenetre, NULL, SDL_MapRGB(fenetre->format, 0, 0, 0));
		position.x = 0;
		position.y = 0;
		SDL_BlitSurface(choose, NULL, fenetre, &position);
		SDL_Flip(fenetre);
	}
	return (flag);
}

int			main()
{
	int	flag;

	flag = choose_map();
	if (flag == 1)
		getmap("stage1.map");
	if (flag == 2)
		getmap("stage2.map");
	if (flag == 3)
		getmap("stage3.map");
	if (flag == 4)
		getmap("stage4.map");
	if (flag == 5)
		getmap("stage5.map");
	return (EXIT_SUCCESS);
}
