#include <sys/mman.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "jeu.h"
#include "../librairy/lib.h"

void			sdl_end()
{
	extern t_sdl	t;

	SDL_FreeSurface(t.mur);
	SDL_FreeSurface(t.bolt);
	SDL_FreeSurface(t.bullet);
	SDL_FreeSurface(t.echelle);
	SDL_FreeSurface(t.boss);
	SDL_FreeSurface(t.key_img);
	SDL_FreeSurface(t.end);
	SDL_FreeSurface(t.monstre);
	SDL_FreeSurface(t.coeur);
	for (t.i = 0 ; t.i < 4 ; t.i++)
        	SDL_FreeSurface(t.mario[t.i]);
	if (t.flag == 2 && t.niveau == 5)
		win(1);
	if (t.niveau == 4)
	{
		t.niveau++;
		getmap("stage_final.map");
	}
	if (t.flag == 2 && t.niveau != 4)
	{
		t.niveau++;
		getmap(t.lvl[t.niveau]);
	}
	if (t.flag == 3)
		win(2);
	SDL_Quit();
}

void			var_init()
{
	extern t_sdl	t;

	t.fenetre = NULL;
	t.continuer = 1;
	t.pos = 2;
	t.key = 0;
	t.life = 3;
	t.flag = 0;
	t.exp = 0;
	t.turn = 0;
	t.tir = 0;
	t.count_turn = 0;
	t.count_monster = 0;
	t.mur = IMG_Load("./image/mur.jpg");
	t.coeur = IMG_Load("./image/coeur.png");
	t.echelle = IMG_Load("./image/echelle.png");
	t.bolt = IMG_Load("./image/bolt.png");
	t.bullet = IMG_Load("./image/bullet.png");
	t.mario[0] = IMG_Load("./image/mario0.gif");
	t.mario[1] = IMG_Load("./image/mario1.gif");
	t.mario[2] = IMG_Load("./image/mario2.gif");
	t.mario[3] = IMG_Load("./image/mario3.gif");
	t.monstre = IMG_Load("./image/monstre.png");
	t.key_img = IMG_Load("./image/key.gif");
	t.boss = IMG_Load("./image/boss.gif");
	t.end = IMG_Load("./image/end.gif");
	t.largeur = 34 * my_strlen(map[0]);
	for (t.hauteur = 0;map[t.hauteur];t.hauteur++);
	t.hauteur *= 34;	
}

void			pos_init_monstre()
{
	extern t_sdl	t;
	extern t_struct	*pos_monstre;

	pos_monstre = xmalloc((t.largeur * t.hauteur + 1) * sizeof(*pos_monstre));
	for (t.i = 0;map[t.i];t.i++)
	{
		for (t.j = 0;map[t.i][t.j] != '\0';t.j++)
		{
			if (map[t.i][t.j] == 'm')
			{
				pos_monstre[t.count_monster].x = t.j * 34;
				pos_monstre[t.count_monster].y = t.i * 34;
				pos_monstre[t.count_monster].flag = 0;
				t.count_monster++;
			}
		}
	}
}

void			pos_init_joueur()
{
	extern t_sdl	t;
	int		mario;

	mario = 0;
	for (t.i = 0;map[t.i];t.i++)
	{
		for (t.j = 0;map[t.i][t.j] != '\0';t.j++)
		{
			if (map[t.i][t.j] == 'i')
			{
				mario = 1;
				t.joueur.x = t.j * 34;
				t.joueur.y = t.i * 34;
				t.begin.x = t.joueur.x;
				t.begin.y = t.joueur.y;
			}
		}
	}
	if (mario == 0)
		exit (EXIT_FAILURE);
}

void			sdl_init()
{
	extern t_sdl	t;
	extern t_struct	*pos_monstre;

	if (SDL_Init(SDL_INIT_VIDEO) == -1)
	{
		write(2, "SDL Error\n", 10);
		exit(EXIT_FAILURE);
	}
	t.fenetre = SDL_SetVideoMode(t.largeur, t.hauteur, 32, SDL_HWSURFACE | SDL_RESIZABLE | SDL_DOUBLEBUF);
	if (t.fenetre == NULL)
	{
		write(2, "SDL Error\n", 10);
		exit(EXIT_FAILURE);
	}
	SDL_WM_SetCaption("Epikong", NULL);
}

