#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <stdlib.h>
#include "lib.h"

#define BUF 1024

char	*my_copyc(char *buffer, ssize_t r, int *i, int *j)
{
  char	*line;

  line = malloc((r + 1) * sizeof(*line));
  while (buffer[(*i)] != '\n' && buffer[(*i)] != '\0')
    {
      line[(*j)] = buffer[(*i)];
      ++(*i);
      ++(*j);
    }
  if (buffer[(*i)] != '\0')
    line[(*j)] = '\0';
  if (buffer[(*i)] == '\n')
    ++(*i);
  return (line);
}

char		*get_next_line(int fd)
{
  ssize_t	r;
  char		*line;
  static char	buffer[BUF + 1];
  static int	i = 0;
  int		j;

  r = 0;
  line = NULL;
  j = 0;
  if (i != 0 && buffer[i] != '\0')
    line = my_copyc(buffer, r, &i, &j);
  if (i == 0 || buffer[i] == '\0')
    {
      i = 0;
      r = read(fd, buffer, BUF);
      buffer[r] = '\0';
    }
  if (line == NULL || (line && line[j] != '\0'))
    line = my_copyc(buffer, r, &i, &j);
  if (buffer[0] == 0 && line[0] == '\0')
    return (NULL);
  return (line);
}

