/*
 * Copyright (C) 2004-2010 Kazuyoshi Aizawa. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/****************************************************************************
 *  ste_local.c
 *
 *    NDIS ̃Gg|CgȊO Ste.sys hCoŗL̊֐LqĂ
 *
 *  ύX:
 *    2006/05/05
 *      o MAC AhXhCo[̃CXg[ɓIɐ悤ɂB
 *
 *****************************************************************************/
#include "ste.h"
#include <ntstrsafe.h>

/****************************************************************************
 * SteCreateAdapter()
 * 
 *   STE_ADAPTER \̂mۂȂAKvȃ\[XmہAB
 *
 * :
 *
 *    Adapter : A_v^\̂̃|C^̃AhX
 *
 * ߂l:
 *
 *    : NDIS_STATUS_SUCCESS
 *
***************************************************************************/
NDIS_STATUS
SteCreateAdapter(
    IN OUT STE_ADAPTER    **pAdapter     
    )
{
    STE_ADAPTER      *Adapter = NULL;
    NDIS_STATUS       Status;
    INT                i;
    LARGE_INTEGER     SystemTime;    

    DEBUG_PRINT0(3, "SteCreateAdapter called\n");    

    do {
        //
        // STE_ADAPTER m
        //
        Status = NdisAllocateMemoryWithTag(
            (PVOID)&Adapter,     //OUT PVOID  *
            sizeof(STE_ADAPTER), //IN UINT    
            (ULONG)'CrtA'        //IN ULONG   
            );
        if (Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT1(1, "SteCreateAdapter: NdisAllocateMemoryWithTag Failed (0x%x)\n",
                            Status);
            break;
        }

        DEBUG_PRINT1(3, "SteCreateAdapter: Adapter = 0x%p\n", Adapter);
        
        NdisZeroMemory(Adapter, sizeof(STE_ADAPTER));

        //
        // Mpobt@[v[m
        // 
        NdisAllocateBufferPool(
            &Status,                      //OUT PNDIS_STATUS  
            &Adapter->RxBufferPoolHandle, //OUT PNDIS_HANDLE  
            STE_MAX_RXDS                  //IN UINT           
            );
        if (Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT1(1, "SteCreateAdapter: NdisAllocateBufferPool Failed (0x%x)\n",Status);
            break;
        }
        
        //
        // MppPbgv[m
        //
        NdisAllocatePacketPool(
            &Status,                         //OUT PNDIS_STATUS  
            &Adapter->RxPacketPoolHandle,    //OUT PNDIS_HANDLE  
            STE_MAX_RXDS,                    //IN UINT           
            PROTOCOL_RESERVED_SIZE_IN_PACKET //IN UINT           
            );
        if (Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT1(1, "SteCreateAdapter: NdisAllocatePacketPool Failed (0x%x)\n", Status);
            break;
        }            

        // Mp Queue 
        NdisInitializeListHead(&Adapter->RecvQueue.List);
        NdisAllocateSpinLock(&Adapter->RecvQueue.SpinLock);
        Adapter->RecvQueue.QueueMax = STE_QUEUE_MAX;
        Adapter->RecvQueue.QueueCount = 0;
        
        //Mp Queue 
        NdisInitializeListHead(&Adapter->SendQueue.List);        
        NdisAllocateSpinLock(&Adapter->SendQueue.SpinLock);
        Adapter->SendQueue.QueueMax = STE_QUEUE_MAX;        
        Adapter->SendQueue.QueueCount = 0;

        // A_v^[̃bN
        NdisAllocateSpinLock(&Adapter->AdapterSpinLock);
        NdisAllocateSpinLock(&Adapter->SendSpinLock);
        NdisAllocateSpinLock(&Adapter->RecvSpinLock);                        

        // pPbgtB^[̏lZbg
        // svȂ悤ȋCB
        Adapter->PacketFilter |=
            (NDIS_PACKET_TYPE_ALL_MULTICAST| NDIS_PACKET_TYPE_BROADCAST |NDIS_PACKET_TYPE_DIRECTED);
        
        // O[õA_v^Xgɒǉ
        NdisAcquireSpinLock(&SteGlobalSpinLock);
        Status = SteInsertAdapterToList(Adapter);
        NdisReleaseSpinLock(&SteGlobalSpinLock);
        if(Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT1(1, "SteCreateAdapter: SteInsertAdapterToList Failed (0x%x)\n", Status);
            break;
        }

        //
        // MAC AhXo^
        // INebg U/L rbg 1i=[JAhXjɃZbgB
        // 㔼 32 bit ̓hCoCXg[ꂽԂ猈߂B
        //
        KeQuerySystemTime(&SystemTime);
        
        Adapter->EthernetAddress[0] = 0x0A; 
        Adapter->EthernetAddress[1] = 0x00;
        Adapter->EthernetAddress[2] = (UCHAR)((SystemTime.QuadPart >> 24) & 0xff);
        Adapter->EthernetAddress[3] = (UCHAR)((SystemTime.QuadPart >> 16) & 0xff);
        Adapter->EthernetAddress[4] = (UCHAR)((SystemTime.QuadPart >>  8) & 0xff);
        Adapter->EthernetAddress[5] = (UCHAR)((SystemTime.QuadPart + Adapter->Instance) & 0xff);

    } while(FALSE);


    if(Status != NDIS_STATUS_SUCCESS && Adapter != NULL){
        //
        // G[ɂ͊mۂ\[XJ
        // 
        // obt@[v[J
        if(Adapter->RxBufferPoolHandle != NULL)
            NdisFreeBufferPool(Adapter->RxBufferPoolHandle);
        // pPbgv[J
        if(Adapter->RxPacketPoolHandle != NULL)
            NdisFreePacketPool(Adapter->RxPacketPoolHandle);
        // STE_ADAPTER \̂J
        NdisFreeMemory(
            (PVOID)Adapter,      //OUT PVOID  
            sizeof(STE_ADAPTER), //IN UINT    
            0                    //IN UINT
            );
    } else {
        //
        // ͊mۂA_v^[̃AhXZbg
        //
        *pAdapter = Adapter;
    }
    
    return(Status);
}

/****************************************************************************
 * SteDeleteAdapter()
 * 
 *   STE_ADAPTER \̂폜A\[XB
 *
 * :
 *
 *    Adapter : J STE_ADAPTER \
 *
 * ߂l:
 *
 *  펞 :  NDIS_STATUS_SUCCESS
 *
***************************************************************************/
NDIS_STATUS
SteDeleteAdapter(
    IN STE_ADAPTER    *Adapter
    )
{
    NDIS_STATUS        Status = NDIS_STATUS_SUCCESS;
    NDIS_PACKET       *Packet = NULL;

    DEBUG_PRINT0(3, "SteDeleteAdapter called\n");        

    // ML[ɓĂpPbg
    while (SteGetQueue(&Adapter->SendQueue, &Packet) == NDIS_STATUS_SUCCESS) {
        NdisMSendComplete(
            Adapter->MiniportAdapterHandle,  //IN NDIS_HANDLE   
            Packet,                          //IN PNDIS_PACKET  
            NDIS_STATUS_REQUEST_ABORTED      //IN NDIS_STATUS   
            );
    }

    //  ML[ɓĂpPbg
    while (SteGetQueue(&Adapter->RecvQueue, &Packet) == NDIS_STATUS_SUCCESS) {
        SteFreeRecvPacket(Adapter, Packet);
    }
    //  ꂪI΁ASĂ̎MpPbgt[Ă͂B
    
    // obt@[v[J
    if(Adapter->RxBufferPoolHandle != NULL)
        NdisFreeBufferPool(Adapter->RxBufferPoolHandle);

    // pPbgv[J
    if(Adapter->RxPacketPoolHandle != NULL)
        NdisFreePacketPool(Adapter->RxPacketPoolHandle);

    // O[õA_v^[̃Xg폜
    NdisAcquireSpinLock(&SteGlobalSpinLock);
    SteRemoveAdapterFromList(Adapter);
    NdisReleaseSpinLock(&SteGlobalSpinLock);    

    //
    // STE_ADAPTER \̂J
    //
    NdisFreeMemory(
        (PVOID)Adapter,      //OUT PVOID  
        sizeof(STE_ADAPTER), //IN UINT    
        0                    //IN UINT
    );
    
    return(Status);
}

/****************************************************************************
 * SteResetTimerFunc()
 *
 *  Zbg̊mF邽߂̃^C}[֐B
 *  SteMiniportInitialize() ɂď@NdisSetTimer()@ɂĎԂ
 *  ꂽɌĂяoB
 *
 * :
 *
 *    Adapter : STE_ADAPTER \
 *
 * ߂l:
 *
 *   
 *
***************************************************************************/
VOID 
SteResetTimerFunc(
    IN PVOID  SystemSpecific1,
    IN PVOID  FunctionContext,
    IN PVOID  SystemSpecific2,
    IN PVOID  SystemSpecific3
    )
{
    STE_ADAPTER    *Adapter;
    NDIS_STATUS     Status = NDIS_STATUS_SUCCESS;

    DEBUG_PRINT0(3, "SteResetTimverFunc called\n");            
    
    Adapter = (STE_ADAPTER *)FunctionContext;

    Adapter->ResetTrys++;

    // ʃvgRɒʒmς݂ł܂߂ĂĂȂpPbg邩
    // ǂmFB

    if (Adapter->RecvIndicatedPackets > 0) {
        if(Adapter->ResetTrys > STE_MAX_WAIT_FOR_RESET){
            // ő厎s񐔂𒴂
            Status = NDIS_STATUS_FAILURE;
        } else {
            // قǍăgC
            NdisSetTimer(&Adapter->ResetTimer, 300);
            return;
        }
    } else {
        Status = NDIS_STATUS_SUCCESS;
    }

    NdisMResetComplete(
        Adapter->MiniportAdapterHandle,  //IN NDIS_HANDLE  
        Status,                          //IN NDIS_STATUS  
        FALSE                            //IN BOOLEAN      
        );    

    return;
}

/****************************************************************************
 * SteRecvTimerFunc()
 *
 *  MpPbgL[ɗ܂pPbgʃvgRɒʒm邽߂
 *  ^C}[֐BSteMiniportInitialize() ɂď NdisSetTimer()
 *  ɂĎԂ߂ꂽɌĂяoB
 *
 * :
 *
 *    Adapter : J STE_ADAPTER \
 *
 * ߂l:
 *
 *   
 *
***************************************************************************/
VOID 
SteRecvTimerFunc(
    IN PVOID  SystemSpecific1,
    IN PVOID  FunctionContext,
    IN PVOID  SystemSpecific2,
    IN PVOID  SystemSpecific3
    )
{
    STE_ADAPTER *Adapter;
    NDIS_PACKET *Packet = NULL;
    
    Adapter = (STE_ADAPTER *)FunctionContext;

    DEBUG_PRINT0(3, "SteRecvtTimverFunc called\n");                

    while (SteGetQueue(&Adapter->RecvQueue, &Packet) == NDIS_STATUS_SUCCESS){
        /*
         * NdisMIndicateReceivePacket() ĂŏʃvgRɑ΂
         * pPbg]B
         */
        NdisMIndicateReceivePacket(
            Adapter->MiniportAdapterHandle,  // IN NDIS_HANDLE    
            &Packet,                         //IN PPNDIS_PACKET  
            1                                //IN UINT           
            );
    }
    
    return;
}


/****************************************************************************
 * SteRegisterDevice()
 * 
 *   NdisMRegisterDevice ĂԎɂAfoCXIuWFNg쐬Ae 
 *   Dispatch@[`o^B                                               
 *   쐬ꂽfoCXIuWFNg͉z NIC f[ɂăI[v        
 *   IOCTL R}h̑MAReadFile()AWriteFile() ɂf[^̑ɎgB 
 *                                                                                
 *  :
 *                                                                               
 *      Adapter : STE_ADAPTER \
 *                                                                               
 *  Ԃl:                                                                
 *                                                                               
 *      펞 : NDIS_STATUS_SUCCESS 
 *
 ****************************************************************************/
NDIS_STATUS
SteRegisterDevice(
    IN STE_ADAPTER    *Adapter
    )
{
    NDIS_STATUS        Status = NDIS_STATUS_SUCCESS;
    NDIS_STRING        DeviceName;
    NDIS_STRING        SymbolicName;
    NDIS_STRING        Instance; // gĂȂ
    PDRIVER_DISPATCH   MajorFunctions[IRP_MJ_MAXIMUM_FUNCTION+1]; // IOCTL + READ + WRITE
    NDIS_HANDLE        NdisDeviceHandle;
    UCHAR              SteDeviceName[STE_MAX_DEVICE_NAME];
    UCHAR              SteSymbolicName[STE_MAX_DEVICE_NAME];

    DEBUG_PRINT0(3, "SteRegisterDevice called\n");

    //
    // CX^XɈقȂfoCX쐬悤ɂB
    // ỉz NIC T|[g邽߁j
    // TODO: CX^Xԍ1Ɖ肵ĂBȂ̂ŁA
    //       2ȏゾƖ肪BȂɂ΍sȂ΁EEE
    //
    Status = RtlStringCbPrintfA(
        SteDeviceName,  //OUT LPSTR  
        15,             //IN size_t  
        "%s%d",STE_DEVICE_NAME, Adapter->Instance   //IN LPCSTR  
        );

    Status = RtlStringCbPrintfA(
        SteSymbolicName, //OUT LPSTR  
        19,              //IN size_t  
        "%s%d",STE_SYMBOLIC_NAME, Adapter->Instance  //IN LPCSTR  
        );        

    NdisInitializeString(
        &DeviceName, //IN OUT PNDIS_STRING
        SteDeviceName //IN PUCHAR
        );
    
    NdisInitializeString(
        &SymbolicName,    //IN OUT PNDIS_STRING  
        SteSymbolicName   //IN PCWSTR            
        );

    NdisZeroMemory(MajorFunctions, sizeof(MajorFunctions));    

    //
    // fBXpb`[`
    //
    MajorFunctions[IRP_MJ_READ]           = SteDispatchRead;
    MajorFunctions[IRP_MJ_WRITE]          = SteDispatchWrite;
    MajorFunctions[IRP_MJ_DEVICE_CONTROL] = SteDispatchIoctl;
    MajorFunctions[IRP_MJ_CREATE]         = SteDispatchOther;
    MajorFunctions[IRP_MJ_CLEANUP]        = SteDispatchOther;
    MajorFunctions[IRP_MJ_CLOSE]          = SteDispatchOther;
        
    Status = NdisMRegisterDevice(
        NdisWrapperHandle,      //IN NDIS_HANDLE   
        &DeviceName,            //IN PNDIS_STRING     
        &SymbolicName,          //IN PNDIS_STRING     
        MajorFunctions,         //IN PDRIVER_DISPATCH 
        &Adapter->DeviceObject, //OUT PDEVICE_OBJECT *
        &Adapter->DeviceHandle  //OUT NDIS_HANDLE *
        );

    /*
     * tOmFEEE 0x40(DO_DEVICE_HAS_NAME)B
     */
    DEBUG_PRINT0(3, "SteRegisterDevice ");         
    if(Adapter->DeviceObject->Flags & DO_BUFFERED_IO){
        DEBUG_PRINT0(3, "DeviceObject has DO_BUFFERED_IO flag\n");
    } else if (Adapter->DeviceObject->Flags & DO_DIRECT_IO){
        DEBUG_PRINT0(3, "DeviceObject has DO_DIRECT_IO flag\n");
    } else {
        DEBUG_PRINT1(3, "DeviceObject has flag 0x%x\n",Adapter->DeviceObject->Flags );
    }
    /*
     * V쐬ꂽ DeviceObject ̃tO Buffered I/O ̃tOZbgB
     * ɂ Irp->AssociatedIrp.SystemBuffer Ƀf[^Ă悤ɂȂ悤B
     * ̃Rs[Kv Buffered I/O  Direct I/O ̂قƂl
     * ÂƂ Buffered I/O ɂĂBi₷EE)
     */    
    Adapter->DeviceObject->Flags |= DO_BUFFERED_IO;
    /*
     * ēxtOmF
     */
    DEBUG_PRINT0(3, "SteRegisterDevice ");    
    if(Adapter->DeviceObject->Flags & DO_BUFFERED_IO){
        DEBUG_PRINT0(3, "After set flag: DeviceObject has DO_BUFFERED_IO flag\n");
    } else if (Adapter->DeviceObject->Flags & DO_DIRECT_IO){
        DEBUG_PRINT0(3, "After set flag: DeviceObject has DO_DIRECT_IO flag\n");
    } else {
        DEBUG_PRINT1(3, "After set flag: DeviceObject has flag 0x%x\n",Adapter->DeviceObject->Flags );
    }

    DEBUG_PRINT1(3, "SteRegisterDevice returned (0x%d)\n", Status);                    
    return(Status);
}


/****************************************************************************
 * SteDeregisterDevice()
 * 
 *   IOCTL/ReadFile/WiteFile p̃foCXIuWFNg폜B
 *
 *  :
 *                                                                               
 *      Adapter : STE_ADAPTER \
 *                                                                               
 *  Ԃl:                                                                
 *                                                                               
 *      펞 : NDIS_STATUS_SUCCESS 
 *
 ****************************************************************************/
NDIS_STATUS
SteDeregisterDevice(
    IN STE_ADAPTER    *Adapter
    )
{
    NDIS_STATUS        Status  = NDIS_STATUS_SUCCESS;

    DEBUG_PRINT0(3, "SteDeregisterDevice called\n");                

    Status = NdisMDeregisterDevice(Adapter->DeviceHandle);
    Adapter->DeviceHandle = NULL;
    
    return(Status);
}

/*********************************************************************
 * SteDispatchRead() 
 *
 * ̊֐ Dispatch Read [`BIRP_MJ_READ ̏̂߂ɌĂ΂B
 * 
 * :
 *
 *    DeviceObject - foCXIuWFNgւ̃|C^
 *    Irp      - I/O NGXgpPbgւ̃|C^(I/O Request Packt)
 *
 * Ԃl:
 *
 *    펞   : STATUS_SUCCESS
 *    G[ : STATUS_UNSUCCESSFUL
 *                 
 ******************************************************************************/
NTSTATUS
SteDispatchRead(
    IN PDEVICE_OBJECT           DeviceObject,
    IN PIRP                     Irp
    )
{
    NTSTATUS            NtStatus = STATUS_SUCCESS;
    NDIS_STATUS         Status = NDIS_STATUS_SUCCESS;
    STE_ADAPTER        *Adapter = NULL; // Packet ̑Ms Adapter
    NDIS_PACKET        *Packet = NULL;

    DEBUG_PRINT0(3, "SteDispatchRead called\n");

    //
    // Debug pB Buffer ̃tO`FbN
    //
    if( DebugLevel >= 3) {
        DEBUG_PRINT0(3, "SteDispatchRead: ");
        if ( Irp->Flags & DO_BUFFERED_IO){
            DEBUG_PRINT1(3, "Irp->Flags(0x%x)==DO_BUFFERED_IO\n",Irp->Flags);
        } else if ( Irp->Flags & DO_DIRECT_IO){
            DEBUG_PRINT1(3, "Irp->Flags(0x%x)==DO_DIRECT_IO\n",Irp->Flags);
        } else {
            DEBUG_PRINT1(3, "Irp->Flags(0x%x)\n",Irp->Flags);
        }
    }    


    //
    // r break 邽߂ do-while 
    // 
    do {    
        //
        // O[obN擾AA_v^[̃Xg 
        // nꂽ DeviceObject ܂ރA_v^[
        //
        NdisAcquireSpinLock(&SteGlobalSpinLock);
        Status =  SteFindAdapterByDeviceObject(DeviceObject, &Adapter);
        NdisReleaseSpinLock(&SteGlobalSpinLock);
        
        if ( Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT0(1, "SteDispatchRead: Can't find Adapter\n");
            break;
        }

        // ML[pPbg擾
        Status = SteGetQueue(&Adapter->SendQueue, &Packet);
        if ( Status != NDIS_STATUS_SUCCESS){        
            DEBUG_PRINT0(2, "SteDispatchRead: No packet found\n");
            break;
        }

        // 擾pPbg̒g\
        if(DebugLevel >= 3)
            StePrintPacket(Packet);                
        
        // f[^ Irp ɃRs[
        Status = SteCopyPacketToIrp(Packet, Irp);
        if(Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT0(1, "SteDispatchRead: SteCopyPacketToIrp failed\n");  
            break;
        }             

        // NDIS  SendComplete Ԃ
        Status = NDIS_STATUS_SUCCESS;
        NdisMSendComplete(
            Adapter->MiniportAdapterHandle,  //IN NDIS_HANDLE   
            Packet,                          //IN PNDIS_PACKET  
            Status                           //IN NDIS_STATUS   
            );
        
    } while (FALSE);

    if(Status != NDIS_STATUS_SUCCESS){
        // G[̏ꍇ IoStatus.Information  0 Zbg
        NtStatus = STATUS_UNSUCCESSFUL;
        Irp->IoStatus.Information = 0;
    }

    Irp->IoStatus.Status = NtStatus;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    return(NtStatus);
}  

/*********************************************************************
 * SteDispatchWrite()
 *  
 *  Dispatch Write [`BIRP_MJ_WRITE ̏̂߂ɌĂ΂B
 *  ̃[` sted 󂯂ƂC[Tlbgt[̒g
 *  Rs[AMpPbg𓾁Aobt@Ƃ̎MpPbgɊ֘AtsA
 *  pPbgA_v^[CX^X̎ML[ɓB
 *  ܂AقǃpPbgʃvgRɒʒm悤ɁA^C}[ZbgB
 *
 * :
 *
 *    DeviceObject :  foCXIuWFNgւ̃|C^
 *    Irp          :  I/O NGXgpPbgւ̃|C^(I/O Request Packt)
 *
 * Ԃl:
 *
 *    펞   : STATUS_SUCCESS
 *    G[ : STATUS_UNSUCCESSFUL
 *                 
 ******************************************************************************/
NTSTATUS
SteDispatchWrite(
    IN PDEVICE_OBJECT           DeviceObject,
    IN PIRP                     Irp
    )
{
    NDIS_STATUS            Status   = NDIS_STATUS_SUCCESS;
    NTSTATUS               NtStatus = STATUS_SUCCESS;
    IO_STACK_LOCATION     *irpStack;
    STE_ADAPTER           *Adapter  = NULL;// Packet ̑Ms Adapter
    NDIS_PACKET           *RecvPacket   = NULL;
    NDIS_BUFFER           *NdisBuffer;
    UINT                   NdisBufferLen;
    VOID                  *IrpRecvBuffer;    // IRP  buffer 
    ULONG                  IrpRecvBufferLen; // IRP  buffer ̒
    VOID                  *VirtualAddress = NULL; // IRP  Buffer ̃f[^̃AhX
    
    DEBUG_PRINT0(3, "SteDispatchWrite called\n");        

    // IRP  IO_STACK_LOCATION 𓾂
    irpStack = IoGetCurrentIrpStackLocation(Irp);

    // IRP 󂯎f[^ƁAf[^𓾂
    IrpRecvBuffer = Irp->AssociatedIrp.SystemBuffer;
    IrpRecvBufferLen = irpStack->Parameters.Write.Length;

    //
    // r break ł悤ɂ邽߂ do-while 
    //
    do {
        //
        // IRP ̃obt@[`FbN
        //
        if(IrpRecvBufferLen == 0 ){
            DEBUG_PRINT0(2, "SteDispatchWrite: IrpRecvBufferLen == 0\n");
            Status = NDIS_STATUS_FAILURE;
            break;
        }
        if( IrpRecvBuffer == NULL){
            DEBUG_PRINT0(2, "SteDispatchWrite: IrpRecvBuffer is NULL\n");
            Status = NDIS_STATUS_FAILURE;
            break;
        }
        
        //
        // O[obN擾AAdapter ̃Xg 
        // nꂽ DeviceObject ܂ Adapter 
        //
        NdisAcquireSpinLock(&SteGlobalSpinLock);
        Status =  SteFindAdapterByDeviceObject(DeviceObject, &Adapter);
        NdisReleaseSpinLock(&SteGlobalSpinLock);
        
        if ( Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT0(1, "SteDispatchWrite: Can't find Adapter\n");
            break;
        }

        //
        // Debug pB Buffer ̃tO`FbN
        //
        if( DebugLevel >= 3) {
            DEBUG_PRINT0(3, "SteDispatchWrite: ");
            if ( Irp->Flags & DO_BUFFERED_IO){
                DEBUG_PRINT1(3, "Irp->Flags(0x%x)== DO_BUFFERED_IO\n",Irp->Flags);
            } else if ( Irp->Flags & DO_DIRECT_IO){
                DEBUG_PRINT1(3, "Irp->Flags(0x%x)== DO_DIRECT_IO\n",Irp->Flags);
            } else {
                DEBUG_PRINT1(3, "Irp->Flags(0x%x)n",Irp->Flags);
            }
        }
        
        DEBUG_PRINT1(3, "SteDispatchWrite: IrpRecvBufferLen = %d\n",IrpRecvBufferLen);
        
        //
        //  A_v^[̃bN擾A
        //  pPbgv[Mp̃pPbgmۂ
        //
        NdisAcquireSpinLock(&Adapter->AdapterSpinLock);                        
        Status = SteAllocateRecvPacket(Adapter, &RecvPacket);
        NdisReleaseSpinLock(&Adapter->AdapterSpinLock);
        
        if(Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT0(2, "SteDispatchWrite: SteAllocateRecvPacket failed\n");
            Adapter->NoResources++;
            break;
        }
        
        DEBUG_PRINT1(3, "SteDispatchWrite: RecvPacket = %p\n", RecvPacket);        


        // Packet  Status  NDIS_STATUS_SUCCESS ɃZbg
        NDIS_SET_PACKET_STATUS(RecvPacket, NDIS_STATUS_SUCCESS);

        //
        // mۂ Packet  NDIS_BUFFER \̂̃|C^ƃC[Tlbg
        // t[i[邽߂̃̃AhX𓾂
        //
        NdisQueryPacket(
            RecvPacket,           //IN  PNDIS_PACKET   
            NULL,                 //OUT PUINT OPTIONAL
            NULL,                 //OUT PUINT         
            &NdisBuffer,          //OUT PNDIS_BUFFER *
            NULL                  //OUT PUINT         
            );

        // Debug p
        if(NdisBuffer == NULL){
            DEBUG_PRINT0(2, "SteDispatchWrite: NdisBuffer is NULL.\n");
            Status = NDIS_STATUS_FAILURE;
            break;
        } else {
            DEBUG_PRINT1(3, "SteDispatchWrite: NdisBuffer is %p\n", NdisBuffer);
        }
            
        NdisQueryBufferSafe(
            NdisBuffer,           //IN PNDIS_BUFFER    
            &VirtualAddress,      //OUT PVOID *
            &NdisBufferLen,       //OUT PUINT          
            NormalPagePriority    //IN MM_PAGE_PRIORITY
            );

        // NdisBuffer ɂ ETHERMAX(1514bytes)ȏ̓Rs[łȂ
        if ( IrpRecvBufferLen > ETHERMAX){
            IrpRecvBufferLen = ETHERMAX;
        }

        //
        // IRP ̓̃f[^ Packet ɃRs[B
        //
        NdisMoveMemory(VirtualAddress, IrpRecvBuffer, IrpRecvBufferLen);

        // ۂɏ񂾃TCY Irp ɃZbg 
        Irp->IoStatus.Information = IrpRecvBufferLen;
            
        // Buffer  Next |C^[ NULL ցB
        NdisBuffer->Next = NULL;
        // BufferLength Zbg
        NdisAdjustBufferLength(NdisBuffer, IrpRecvBufferLen);
        
        DEBUG_PRINT0(3, "SteDispatchWrite: Copying buffer data Completed\n");            

        //
        // TODO:
        // pPbgtB^[̃`FbNł悤ɂB
        // ͂ȂłiƂȂĂjɏグB
        //

        // Rs[pPbg̒g\
        if(DebugLevel >= 3)
            StePrintPacket(RecvPacket);        

        //   
        // pPbgML[ɃL[CO
        //
        Status = StePutQueue(&Adapter->RecvQueue, RecvPacket);
        if(Status != NDIS_STATUS_SUCCESS){            
            // ML[t̂悤B
            DEBUG_PRINT0(2, "SteDispatchWrite: Receive Queue is Full.\n");
            break;
        }        
        
        NdisInterlockedIncrement(&Adapter->RecvIndicatedPackets);
        Adapter->Ipackets++;
        DEBUG_PRINT0(3, "SteDispatchWrite: StePutQueue Completed\n");
        //
        // SteRecvTimerFunc() Ăяo߂̃^C}[Zbg
        //
        NdisSetTimer(&Adapter->RecvTimer, 0);

        DEBUG_PRINT0(3, "SteDispatchWrite: NdisSetTimer Completed\n");  
    } while (FALSE);

    if(Status != NDIS_STATUS_SUCCESS){
        NtStatus = STATUS_UNSUCCESSFUL;
        if (Adapter != NULL)
            Adapter->Ierrors++;
        // ݃TCY 0 ɃZbg
        Irp->IoStatus.Information = 0;
        // Packet 擾ς݂̏ꍇ͊JB
        if (RecvPacket != NULL && Adapter != NULL){
            SteFreeRecvPacket(Adapter, RecvPacket);
        }
    }

    Irp->IoStatus.Status = NtStatus; 
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    return(NtStatus);
 }  

/***********************************************************************
 * SteDispatchIoctl()
 *
 *    ̃foCXɑꂽ IOCTL R}h
 *
 * :
 *
 *    DeviceObject :  foCXIuWFNgւ̃|C^
 *    Irp          :  I/O NGXgpPbgւ̃|C^(I/O Request Packt)
 *
 * Ԃl:
 *
 *     : STATUS_SUCCESS@
 *    s : STATUS_UNSUCCESSFUL
 *
 *********************************************************************/
NTSTATUS
SteDispatchIoctl(
    IN PDEVICE_OBJECT           DeviceObject,
    IN PIRP                     Irp
    )
{

    NTSTATUS             NtStatus = STATUS_SUCCESS;
    NDIS_STATUS          Status   = NDIS_STATUS_SUCCESS;
    STE_ADAPTER         *Adapter  = NULL; // Packet ̑Ms Adapter     
    IO_STACK_LOCATION   *irpStack = NULL;
    HANDLE               hEvent;          // sted.exe nCxgnh

    DEBUG_PRINT0(3, "SteDispatchIoctl called\n");
        
    // IRP  IO_STACK_LOCATION 𓾂
    irpStack = IoGetCurrentIrpStackLocation(Irp);

    // break 邽߂ do-while 
    do {
    
        //
        // O[obN擾AAdapter ̃Xg 
        // nꂽ DeviceObject ܂ Adapter 
        //
        NdisAcquireSpinLock(&SteGlobalSpinLock);
        Status = SteFindAdapterByDeviceObject(DeviceObject, &Adapter);
        NdisReleaseSpinLock(&SteGlobalSpinLock);    

        if ( Status != NDIS_STATUS_SUCCESS){
            DEBUG_PRINT0(1, "SteDispatchIoctl: Can't find Adapter\n");
            break;
        }    

        switch (irpStack->Parameters.DeviceIoControl.IoControlCode) {
            //
            // z NIC f[̃CxgIuWFNg󂯎
            // A_v^[\̂ɕۑB
            //
            case REGSVC:
                DEBUG_PRINT0(3, "SteDispatchIoctl: Received REGSVC IOCTL\n");                  
                hEvent = (HANDLE) irpStack->Parameters.DeviceIoControl.Type3InputBuffer;

                if(hEvent == NULL){
                    DEBUG_PRINT0(1, "SteDispatchIoctl: hEvent is NULL\n");
                    Status = NDIS_STATUS_FAILURE;
                    break;
                }
                DEBUG_PRINT1(3,"SteDispatchIoctl: hEvent = 0x%p\n", hEvent);
                DEBUG_PRINT1(3,"SteDispatchIoctl: Adapter = 0x%p\n", Adapter);            
                DEBUG_PRINT1(3,"SteDispatchIoctl: &Adapter->EventObject = 0x%p\n",
                               &Adapter->EventObject);

                //
                // STE_ADAPTER \̂ EventObject ύX̂ŁA
                // A_v^[̃bN擾
                //
                NdisAcquireSpinLock(&Adapter->AdapterSpinLock);                
                NtStatus = ObReferenceObjectByHandle(
                    hEvent,                 //IN HANDLE                       
                    GENERIC_ALL,            //IN ACCESS_MASK                  
                    NULL,                   //IN POBJECT_TYPE                 
                    KernelMode,             //IN KPROCESSOR_MODE              
                    &Adapter->EventObject,  //OUT PVOID  *                    
                    NULL                    //OUT POBJECT_HANDLE_INFORMATION  
                    );

                NdisReleaseSpinLock(&Adapter->AdapterSpinLock);
            
                if(NtStatus != STATUS_SUCCESS){
                    DEBUG_PRINT1(1, "SteDispatchIoctl: ObReferenceObjectByHandle failed(%d) ",
                                    NtStatus);
                    switch(NtStatus){
                        case STATUS_OBJECT_TYPE_MISMATCH:
                            DEBUG_PRINT0(1," Failed STATUS_OBJECT_TYPE_MISMATCH\n");
                            break;
                        case STATUS_ACCESS_DENIED:
                            DEBUG_PRINT0(1," Failed STATUS_ACCESS_DENIED\n");
                            break;
                        case STATUS_INVALID_HANDLE:
                            DEBUG_PRINT0(1," Failed STATUS_INVALID_HANDLE\n");
                            break;
                        default:
                            DEBUG_PRINT1(1," Failed (0x%x)\n", NtStatus);
                            break;                        
                    }
                    Status = NDIS_STATUS_FAILURE;
                    break;
                }
                break;
            //
            // CxgIuWFNg̓o^
            //
            case UNREGSVC:
                DEBUG_PRINT0(3, "SteDispatchIoctl: Received UNREGSVC IOCTL\n");
                NdisAcquireSpinLock(&Adapter->AdapterSpinLock);                                
                if(Adapter->EventObject){
                    ObDereferenceObject(Adapter->EventObject);
                    Adapter->EventObject = NULL;
                }
                NdisReleaseSpinLock(&Adapter->AdapterSpinLock);                
                break;
            default:
                DEBUG_PRINT1(3, "SteDispatchIoctl: Received Unknown(0x%x)IOCTL\n",
                                irpStack->Parameters.DeviceIoControl.IoControlCode);             
                NtStatus = STATUS_UNSUCCESSFUL;
                break;
        }
    } while(FALSE);

    if(Status != NDIS_STATUS_SUCCESS){
        // G[̏ꍇ
        NtStatus = STATUS_UNSUCCESSFUL;
    }    
    Irp->IoStatus.Information = 0;    
    Irp->IoStatus.Status = NtStatus; 
    IoCompleteRequest(Irp, IO_NO_INCREMENT);
    
    return(NtStatus);
}

/***********************************************************************
 * SteDispatchOther()
 *
 *    ReadFile, WriteFile, IOCTL ȊO I/O NGXgB
 *
 * :
 *
 *    DeviceObject :  foCXIuWFNgւ̃|C^
 *    Irp          :  I/O NGXgpPbgւ̃|C^(I/O Request Packt)
 *
 * Ԃl:
 *
 *    Ɂ@STATUS_SUCCESS
 *
 *********************************************************************/
NTSTATUS
SteDispatchOther(
    IN PDEVICE_OBJECT           DeviceObject,
    IN PIRP                     Irp
    )
{
    NTSTATUS             NtStatus = STATUS_SUCCESS;
    IO_STACK_LOCATION   *irpStack = NULL;

    DEBUG_PRINT0(3, "SteDispatchOther called\n");

    /* IRP  IO_STACK_LOCATION 𓾂*/
    irpStack = IoGetCurrentIrpStackLocation(Irp);

    DEBUG_PRINT0(3, "SteDispatchOther: MajorFunction = ");                    
    switch (irpStack->MajorFunction){
        case IRP_MJ_CREATE:
            DEBUG_PRINT0(3, "IRP_MJ_CREATE\n");                
            break;
        case IRP_MJ_CLEANUP:
            DEBUG_PRINT0(3, "IRP_MJ_CLEANUP\n");            
            break;
        case IRP_MJ_CLOSE:
            DEBUG_PRINT0(3, "IRP_MJ_CLOSE\n");            
            break;
        default:
            DEBUG_PRINT1(3, "0x%x (See ndis.h)\n", irpStack->MajorFunction);
            break;
    }

    Irp->IoStatus.Status = NtStatus;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    return(NtStatus);
}


/***********************************************************************
 * SteAllocateRecvPacket()
 *
 *    MpPbgv[pPbgmۂB
 *
 * :
 *
 *        Adapter : STE_ADAPTER \̂̃|C^
 *        Packet  : NIDS_PACKET \̂̃|C^̃AhX
 *
 * Ԃl:
 *
 *    펞   : NDIS_STATUS_SUCCESS
 *    G[ : NDIS_STATUS_RESOURCES
 *
 *********************************************************************/
NDIS_STATUS
SteAllocateRecvPacket(
    IN STE_ADAPTER      *Adapter,
    IN OUT NDIS_PACKET  **pPacket
    )
{
    NDIS_STATUS       Status;    
    NDIS_BUFFER      *Buffer   = NULL;
    PVOID             VirtualAddress = NULL;

    DEBUG_PRINT0(3, "SteAllocateRecvPacket called\n");                

    *pPacket = NULL;
    
    //
    // epPbgɃobt@[֘AtA܂Amۂ
    // eMfBXNv^ɃpPbg֘AtB
    //
    do {
        NdisAllocatePacket(
            &Status,                     //OUT PNDIS_STATUS  
            pPacket,                     //OUT PNDIS_PACKET  
            Adapter->RxPacketPoolHandle  //IN NDIS_HANDLE    
            );
        if (Status != NDIS_STATUS_SUCCESS)
            break;

        NDIS_SET_PACKET_HEADER_SIZE(*pPacket, ETHERMAX-ETHERMTU);        
        
        //
        // Ethernet t[̊i[pm
        //
        Status = NdisAllocateMemoryWithTag(
            (PVOID)&VirtualAddress,   //OUT PVOID  *
            ETHERMAX,                 //IN UINT    
            (ULONG)'AlcE'             //IN ULONG   
            );
        if (Status != NDIS_STATUS_SUCCESS){
            NdisFreePacket(*pPacket);
            break;
        }
        NdisZeroMemory(VirtualAddress, ETHERMAX);

        // obt@[v[Aobt@[o
        NdisAllocateBuffer(
            &Status,                      //OUT PNDIS_STATUS  
            &Buffer,                      //OUT PNDIS_BUFFER
            Adapter->RxBufferPoolHandle,  //IN NDIS_HANDLE
            VirtualAddress,               //IN PVOID
            ETHERMAX                      //IN UINT
            );
        if (Status != NDIS_STATUS_SUCCESS){
            NdisFreePacket(*pPacket);
            NdisFreeMemory(VirtualAddress, ETHERMAX, 0);
            break;
        }
        //
        // obt@[ƁApPbg֘At
        // 
        NdisChainBufferAtBack(*pPacket, Buffer);

    } while(FALSE);

    return(Status);
}

/***********************************************************************
 * SteFreeRecvPacket()
 *
 *    MpPbgv[ɃpPbgǂ
 *
 * :
 *
 *        Adapter : STE_ADAPTER \̂̃|C^
 *        Packet  : J NDIS_PACKET \
 *
 * Ԃl:
 *
 *     NDIS_STATUS_SUCCESS
 *
 *********************************************************************/
NDIS_STATUS
SteFreeRecvPacket(
    IN STE_ADAPTER   *Adapter,
    IN NDIS_PACKET   *Packet
    )
{
    NDIS_STATUS       Status = NDIS_STATUS_SUCCESS;    
    NDIS_BUFFER      *Buffer = NULL;
    VOID             *VirtualAddress = NULL;
    UINT              Length;

    DEBUG_PRINT0(3, "SteFreeRecvPacket called\n");     

    NdisQueryPacket(
        Packet,               //IN PNDIS_PACKET   
        NULL,                 //OUT PUINT OPTIONAL
        NULL,                 //OUT PUINT         
        &Buffer,              //OUT PNDIS_BUFFER  
        NULL                  //OUT PUINT         
        );

    NdisQueryBufferSafe(
        Buffer,               //IN PNDIS_BUFFER    
        &VirtualAddress,      //OUT PVOID *
        &Length,              //OUT PUINT          
        NormalPagePriority    //IN MM_PAGE_PRIORITY
        );
        
    // Ethernet t[̊i[pJ
    NdisFreeMemory(VirtualAddress, ETHERMAX, 0);
        
    // obt@[v[Ƀobt@[߂
    NdisFreeBuffer(Buffer);

    // pPbgv[ɃpPbg߂
    NdisFreePacket(Packet);

    return(Status);
}

/***********************************************************************
 * StePutQueue()
 *
 *    pPbgL[ɓB
 *
 * :
 *
 *        Queue      : Queue \̂̃|C^
 *        Packet     : L[ɓpPbg
 *
 * Ԃl:
 *
 *      : NDIS_STATUS_SUCCESS
 *     s : NDIS_STATUS_RESOURCES
 *
 *********************************************************************/
NDIS_STATUS
StePutQueue(
    IN STE_QUEUE     *Queue,    
    IN NDIS_PACKET   *Packet
    )
{
    NDIS_STATUS      Status = NDIS_STATUS_SUCCESS;

    DEBUG_PRINT0(3, "StePutQueue called\n");         

    //
    // L[ɐݒ肵ĂێłpPbg̍ő吔rB
    // Queue->QueueMax QƎɃbN͂ƂȂ̂ł܂ŖڈB
    //
    if( Queue->QueueCount >= Queue->QueueMax){
        // ő吔ȏL[COĂ܂Ă悤B
        DEBUG_PRINT2(2, "StePutQueue: QFULL (%d >= %d)\n", Queue->QueueCount, Queue->QueueMax);
        Status = NDIS_STATUS_RESOURCES;
        DEBUG_PRINT0(3, "StePutQueue returned\n");
        return(Status);
    }

    // Xg̍Ōɑ}
    NdisInterlockedInsertTailList(
        &Queue->List,                           //IN PLIST_ENTRY      
        (PLIST_ENTRY)&Packet->MiniportReserved, //IN PLIST_ENTRY
        &Queue->SpinLock                        //IN PNDIS_SPIN_LOCK  
        );

   // L[̃JEgl𑝂₷
    NdisInterlockedIncrement(&Queue->QueueCount);
    DEBUG_PRINT1(3, "StePutQueue: QueueCount = %d\n", Queue->QueueCount);    

    DEBUG_PRINT0(3, "StePutQueue returned\n");
    return(Status);
}

/***********************************************************************
 * SteGetQueue()
 *
 *    L[pPbgo
 *
 * :
 *
 *        Queue      : Queue \̂̃|C^
 *        Packet     : L[opPbg̃|C^̃AhX
 *
 * Ԃl:
 *
 *      : NDIS_STATUS_SUCCESS
 *     s : NDIS_STATUS_RESOURCES
 *
 *********************************************************************/
NDIS_STATUS
SteGetQueue(
    IN STE_QUEUE         *Queue,    
    IN OUT NDIS_PACKET   **pPacket
    )
{
    NDIS_STATUS       Status = NDIS_STATUS_SUCCESS;
    LIST_ENTRY       *ListEntry;
    NDIS_SPIN_LOCK   *SpinLock;

    DEBUG_PRINT0(3, "SteGetQueue called\n");             

    ListEntry = NdisInterlockedRemoveHeadList(
        &Queue->List,          //IN PLIST_ENTRY      
        &Queue->SpinLock       //IN PNDIS_SPIN_LOCK  
        );

    if (ListEntry == NULL){
        // Packet ̓L[COĂȂ
        DEBUG_PRINT0(2, "SteGetQueue: No queued packet\n");
        Status = NDIS_STATUS_RESOURCES;
        *pPacket = NULL;
        return(Status);
    }
    
    *pPacket = CONTAINING_RECORD(ListEntry, NDIS_PACKET, MiniportReserved);

    // L[̃JEgl炷
    NdisInterlockedDecrement(&Queue->QueueCount);

    return(Status);
}


/*****************************************************************************
 * SteInsertAdapterToList()
 *
 * STE_ADAPTER \̂A_v^[̃NXgɒǉB
 *
 *  F
 *          Adapter : STE_ADAPTER \
 * 
 * ߂lF
 *          : NDIS_STATUS_SUCCESS
 *          s: 
 *****************************************************************************/
NDIS_STATUS
SteInsertAdapterToList(
    IN STE_ADAPTER  *Adapter
    )
{
    NDIS_STATUS    Status = NDIS_STATUS_SUCCESS;
    STE_ADAPTER   *pAdapter;
    ULONG          Instance = 0;

    DEBUG_PRINT0(3, "SteInsertAdapterToList called\n");

    // SteCreateAdapter ɂ NULL ɏĂ͂Ô
    Adapter->NextAdapter = NULL;

    // break 邽߂ do-while 
    do {
        if (SteAdapterHead == NULL){
            // ŏ̃A_v^[Ȃ̂ŁACX^Xԍ 0B
            Adapter->Instance = Instance; 
            SteAdapterHead = Adapter;
            break;
        }
        //
        // o^ĂŌ̃A_v^[TAVA_v^[
        // CX^Xԍ肷B
        //
        pAdapter = SteAdapterHead;
        while(pAdapter->NextAdapter != NULL){
            pAdapter = pAdapter->NextAdapter;
        }
        // CX^Xԍ͍Ō̃A_v^[̎̐
        Adapter->Instance = pAdapter->Instance + 1;
        // őCX^X 10BȂ̂ŁACX^Xԍ 9 ȏ͎ȂEE
        if(Adapter->Instance > STE_MAX_ADAPTERS - 1){
            Status = NDIS_STATUS_RESOURCES;
            break;
        }
        // A_v^[Xg̍Ōɒǉ 
        pAdapter->NextAdapter = Adapter;
    } while(FALSE);
    
    DEBUG_PRINT1(3, "SteInsertAdapterToList: New Adapter's instance is %d\n", Adapter->Instance);

    return(Status);
}

/*****************************************************************************
 * SteRemoveAdapterFromList()
 *
 * STE_ADAPTER \̂A_v^[̃NXg菜
 *
 *  F
 *          Adapter : STE_ADAPTER \
 * 
 * ߂lF
 *          : NDIS_STATUS_SUCCESS
 *          s:  
 *****************************************************************************/
NDIS_STATUS
SteRemoveAdapterFromList(
    IN STE_ADAPTER    *Adapter
    )
{  
    NDIS_STATUS    Status = NDIS_STATUS_SUCCESS;
    STE_ADAPTER   *pAdapter, *PreviousAdapter;

    DEBUG_PRINT0(3, "SteRemoveAdapterFromList called\n");

    if (SteAdapterHead == NULL){
        // ܂ЂƂA_v^o^ĂȂ
        DEBUG_PRINT0(1, "SteRemoveAdapterFromList: No Adapter exist\n");
        return(NDIS_STATUS_FAILURE);
    }

    pAdapter = SteAdapterHead;
    PreviousAdapter = (STE_ADAPTER *)NULL;
    do{
        if (pAdapter == Adapter){
            if (PreviousAdapter == NULL)
                SteAdapterHead = (STE_ADAPTER *)NULL;
            else
                PreviousAdapter->NextAdapter = pAdapter->NextAdapter;

            return(Status);
        }
        PreviousAdapter = pAdapter;
        pAdapter = pAdapter->NextAdapter;
    } while(pAdapter);

    // YA_v^݂Ȃ
    DEBUG_PRINT0(1, "SteRemoveAdapterFromList: Adapter not found\n");            
    return(NDIS_STATUS_FAILURE);
}

/*****************************************************************************
 * SteFindAdapterByDeviceObject()
 *
 *  ^ꂽfoCXIuWFNgA_v^[
 *
 *  F
 *          DeviceObject: foCXIuWFNg̃|C^
 *          Adapter     :  STE_ADAPTER \̂̃|C^
 * 
 * ߂lF
 *          : NDIS_STATUS_SUCCESS
 *          s: NDIS_STATUS_FAILURE
 * 
 *****************************************************************************/
NDIS_STATUS
SteFindAdapterByDeviceObject(
    IN      DEVICE_OBJECT    *DeviceObject,
    IN OUT  STE_ADAPTER      **pAdapter
    )
{ 
    NDIS_STATUS    Status = NDIS_STATUS_SUCCESS;
    STE_ADAPTER   *TempAdapter;

    DEBUG_PRINT0(3, "SteFindAdapterByDeviceObject called\n");
    
    if (SteAdapterHead == NULL){
        // ܂ЂƂA_v^o^ĂȂ
        DEBUG_PRINT0(1, "SteFindAdapterByDeviceObject: No Adapter exist\n");
        return(NDIS_STATUS_FAILURE);
    }

    TempAdapter = SteAdapterHead;    

    while (TempAdapter){
        if (TempAdapter->DeviceObject  == DeviceObject){
            *pAdapter = TempAdapter;
            return(Status);
        }
        TempAdapter = TempAdapter->NextAdapter;
    }

    DEBUG_PRINT0(1, "SteFindAdapterByDeviceObject: No Adapter exist\n");            
    // YA_v^݂Ȃ
    return(NDIS_STATUS_FAILURE);
}

/********************************************************************
 * SteCopyPacketToIrp()
 * 
 *    Ƃēnꂽ Packet ̃f[^AƂĂ킽ꂽ
 *    IRP ɃRs[B
 *        
 * :
 *
 *     Packet    : pPbg
 *     Irp       : z NIC f[󂯎 IRP
 *
 * Ԃl:
 *
 *    NDIS_STATUS
 *
 ********************************************************************/
NDIS_STATUS
SteCopyPacketToIrp(    
    IN     NDIS_PACKET  *Packet,
    IN OUT PIRP          Irp
    )
{
    NDIS_STATUS         Status = NDIS_STATUS_SUCCESS;
    PIO_STACK_LOCATION  irpStack;        
    UINT                IrpBufferSize; // X IRP ̃obt@[̃TCY
    UINT                IrpBufferLeft; // Rs[\Ȏc IRP obt@[̃TCY
    UCHAR              *IrpBuffer;
    NDIS_BUFFER        *NdisBuffer;
    UINT                TotalPacketLength;
    UINT                CopiedLength = 0;
    VOID               *VirtualAddress;    
    UINT                Length;
    
    DEBUG_PRINT0(3, "SteCopyPacketToIrp called\n");                

    /* IRP  IO_STACK_LOCATION 𓾂*/
    irpStack = IoGetCurrentIrpStackLocation(Irp);

    /* IRP Mobt@[ƁAobt@[TCY𓾂 */
    IrpBuffer = Irp->AssociatedIrp.SystemBuffer;
    IrpBufferLeft = IrpBufferSize = irpStack->Parameters.Read.Length;

    DEBUG_PRINT1(3, "SteCopyPacketToIrp: IrpBufferSize = %d\n", IrpBufferSize);
    // IRP ̃obt@[TCY`FbN
    if(IrpBufferSize < ETHERMIN){
        DEBUG_PRINT0(1, "SteCopyPacketToIrp: IRP buffer size too SMALL < ETHERMIN\n");
        Status = NDIS_STATUS_FAILURE;
        Irp->IoStatus.Information  = 0;        
        return(Status);
    }     
    
    if(IrpBuffer == NULL){
        DEBUG_PRINT0(1, "SteCopyPacketToIrp: Irp->AssociatedIrp.SystemBuffer is NULL\n");
        Status = NDIS_STATUS_FAILURE;
        Irp->IoStatus.Information  = 0;        
        return(Status);
    }

    NdisQueryPacket(
        Packet,              //IN PNDIS_PACKET           
        NULL,                //OUT PUINT OPTIONAL        
        NULL,                //OUT PUINT OPTIONAL        
        &NdisBuffer,         //OUT PNDIS_BUFFER OPTIONAL 
        &TotalPacketLength   //OUT PUINT OPTIONAL        
        );

    if( TotalPacketLength > ETHERMAX){
        // 傫BW{t[H
        DEBUG_PRINT0(1, "SteCopyPacketToIrp: Packet size too BIG > ETHERMAX\n");
        Status = NDIS_STATUS_FAILURE;
        Irp->IoStatus.Information  = 0;        
        return(Status);
    }

    while(NdisBuffer != NULL) {
        NdisQueryBufferSafe(
            NdisBuffer,        //IN PNDIS_BUFFER      
            &VirtualAddress,   //OUT PVOID * OPTIONAL  
            &Length,           //OUT PUINT            
            NormalPagePriority //IN MM_PAGE_PRIORITY
            );

        //
        // c IRP obt@[ʂ`FbNB
        // z NIC f[ ReadFile() ɂ ETHERMAX ̃obt@[TCY
        // w肵Ăꍇ́AIRP ̃obt@[ȂȂ\B
        //
        if (Length > IrpBufferLeft){
            //
            // r[ Ethernet t[Rs[Ăd̂ŁAG[
            // Ƃă^[B
            //
            Status = NDIS_STATUS_FAILURE;
            DEBUG_PRINT0(1, "SteCopyPacketToIrp: Insufficient IRP buffer size\n");            
            break;            
        }
  
        if(VirtualAddress == NULL){
            // NDIS obt@[Ƀf[^܂܂ĂȂH
            Status = NDIS_STATUS_FAILURE;
            DEBUG_PRINT0(1, "SteCopyPacketToIrp: NdisQueryBuffer: VirtualAddress is NULL\n");
            break;
        }

        // f[^Rs[
        NdisMoveMemory(IrpBuffer, VirtualAddress, Length);
        CopiedLength  += Length;
        IrpBufferLeft -= Length;
        IrpBuffer     += Length;

        // c̃obt@[ʂ`FbNBȂ炱ŃuCNB
        if(IrpBufferLeft == 0){
            break;
        }

        //  NDIS obt@[𓾂B
        NdisGetNextBuffer(
            NdisBuffer,  //IN PNDIS_BUFFER   
            &NdisBuffer  //OUT PNDIS_BUFFER  
            );
    }

    if(Status != NDIS_STATUS_SUCCESS) {
        // G[悤Ȃ̂ Irp->IoStatus.Information  0 Zbg        
        Irp->IoStatus.Information  = 0;
    } else {
        // Rs[TCY`FbN
        if(CopiedLength < ETHERMIN){
            // BpfBOB
            // IRP obt@[ ETHERMIN ȏł邱Ƃ͊mFς݂Ȃ̂ŁA
            // Rs[ς݃TCY ETHERMIN Ɋg債Ă͖B
            DEBUG_PRINT0(2, "SteCopyPacketToIrp: Packet size is < ETHERMIN. Padded.\n"); 
            CopiedLength = ETHERMIN;   
        } 
        Irp->IoStatus.Information  = CopiedLength;        
    }

    return(Status);
}


/********************************************************************
 * StePrintPacket()
 * 
 *    Ƃēnꂽ Packet ̃f[^debug o͂
 *        
 * :
 *
 *     Packet    - \ Packet
 *
 * Ԃl:
 *
 *    : TRUE
 *    s: FALSE
 *
 ********************************************************************/
VOID
StePrintPacket(
    NDIS_PACKET *Packet)
{
    
    NDIS_BUFFER       *Ndis_Buffer;  
    PVOID              VirtualAddress; 
    UINT               NdisBufferLen;  
    UINT               TotalPacketLength;   
    UINT               PrintOffset = 0;
    UCHAR             *Data;           
    
    DEBUG_PRINT0(3, "StePrintPacket called\n");

    NdisQueryPacket(
        Packet,             //IN  PNDIS_PACKET  
        NULL,               //OUT PUINT OPTIONAL
        NULL,               //OUT PUINT         
        &Ndis_Buffer,       //OUT PNDIS_BUFFER *
        &TotalPacketLength  //OUT PUINT         
        );

    while(Ndis_Buffer){
        UINT i = 0;
            
        NdisQueryBufferSafe(
            Ndis_Buffer,
            &VirtualAddress,
            &NdisBufferLen,
            NormalPagePriority);
        
        if(VirtualAddress == NULL){
            DEBUG_PRINT0(1, "StePrintPacket: VirtuallAddress is NULL\n");            
            break;
        }

        Data = (unsigned char *)VirtualAddress;

        /*
         * debug x 4 ̏ꍇ 14byte
         * iEthernet Header jo͂B
         */
        if(DebugLevel < 4){
            NdisBufferLen = 14;
        }
        
        while(NdisBufferLen){
            if( PrintOffset%16 == 0){
                if(PrintOffset != 0)
                    DbgPrint ("\n");
                DbgPrint("0x%.4x: ", PrintOffset);
            }
            DbgPrint("%.2x ", Data[i]);
            PrintOffset++;
            
            NdisBufferLen--;
            i++;
        }
        NdisGetNextBuffer( Ndis_Buffer, &Ndis_Buffer);
    }
    DbgPrint("\n");
    DEBUG_PRINT0(3, "StePrintPacket end\n");

    return;
}

/*****************************************************************************
 * bebug_print()
 *
 * fobOo͗p֐
 *
 *  F
 *           Level  :  G[̐[xB
 *           Format :  bZ[W̏o̓tH[}bg
 *           ...
 * ߂lF
 *           ȂB
 *****************************************************************************/
VOID
SteDebugPrint(
    IN ULONG   Level,
    IN PCCHAR  Format,
    ...
    )
{
    va_list        list;
    UCHAR          Buffer[STE_MAX_DEBUG_MSG];
    NTSTATUS       NtStatus;
    
    va_start(list, Format);
    NtStatus = RtlStringCbVPrintfA(Buffer, sizeof(Buffer), Format, list);
    if(NtStatus != STATUS_SUCCESS) {
        DbgPrint("Ste: SteDebugPrint Failed.\n");
        return;
    }
    va_end(list);

    if (Level <= DebugLevel) {
         DbgPrint ("Ste: %s", Buffer);
    }        
    return;
}
