#include "defines.h"
#include "kozos.h"
#include "interrupt.h"
#include "lib.h"


/* システム・タスクとユーザ・スレッドの起動 */
static int start_threads(int argc, char *argv[])
{
	kz_run(test11_1_main, "test11_1_main", 1, 0x100, 0, NULL);
	kz_run(test11_2_main, "test11_2_main", 2, 0x100, 0, NULL);

	kz_chpri(15); /* 優先順位を下げて、アイドルスレッドに移行する。 */
	INTR_ENABLE; /* 割り込み有効にする */
	while (1) {
		asm volatile("sleep"); /* 省電力モードに移行 */
	}
	return 0;
}

int main(void)
{
	INTR_DISABLE;

	printf("kozos boot succeed!\n");

	/* OSの動作開始 */
	kz_start(start_threads, "idle", 0, 0x100, 0, NULL);
	/* ここには戻ってこない */

	return 0;
}
