/****************************************************************************
Copyright (c) 2011 kona4kona (kona4kona@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
****************************************************************************/

#ifndef HiME_IO_EXCEPTIONS_H
#define HiME_IO_EXCEPTIONS_H

#include "hime-exceptions.h"

namespace HiME
{

///
struct IOException : Exception
{
    explicit IOException(const char* msg = "") : Exception(msg) {}
    IOException(const char* msg, uint32_t code) : Exception(msg, code) {}
};

struct InvalidFileName : IOException
{
    explicit InvalidFileName(const char* msg = "") : IOException(msg) {}
};

struct InvalidFilePath : IOException
{
    explicit InvalidFilePath(const char* msg = "") : IOException(msg) {}
};

struct AccessDenied : IOException
{
    explicit AccessDenied(const char* msg = "") : IOException(msg) {}
    AccessDenied(const char* msg, uint32_t code) : IOException(msg, code) {}
};


struct FileNotFound : IOException
{
    explicit FileNotFound(const char* msg = "") : IOException(msg) {}
    FileNotFound(const char* msg, uint32_t code) : IOException(msg, code) {}
};

} // namspace HiME

#endif // HiME_IO_EXCEPTIONS_H
