/****************************************************************************
Copyright (c) 2011 kona4kona (kona4kona@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
****************************************************************************/

#ifndef HiME_IO_H
#define HiME_IO_H

#include "hime-core.h"

namespace HiME
{

namespace IO
{
    enum Access
    {
        AccessRead = 1,
        AccessWrite = 2,
        AccessReadWrite = AccessRead | AccessWrite
    };

    enum NodeFlags
    {
        NodeDataFile        = 1 << 0,
        NodeDirectory       = 1 << 1,
        NodeLink            = 1 << 2,
        Hidden              = 1 << 3,
        ReadOnly            = 1 << 4
    };

    enum SeekOrigin
    {
        SeekSet             = 0,
        SeekCurrent         = 1,
        SeekEnd             = 2
    };

    struct Stat
    {
        uint32_t        flags;  /// Any combination of NodeFlags
        hime_timespec_t ctime;  /// Creation time, nano sec round to 100 ns
        hime_timespec_t mtime;  /// Modification time, nano sec round to 100 ns
        hime_lsize_t    size;   /// Size in bytes.
    };
} // namespace IO

} // namspace HiME

#endif // HiME_IO_H
