/****************************************************************************
Copyright (c) 2011 kona4kona (kona4kona@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining 
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation 
the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom 
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included 
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT 
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
****************************************************************************/

#ifndef HiME_THREAD_POOL_H
#define HiME_THREAD_POOL_H

#include "hime-job.h"
#include "hime-mutex.h"
#include "hime-semaphore.h"
#include "hime-thread.h"
#include "hime-vector.h"

namespace HiME
{

class Job;

///
class ThreadPool
{
    HiME_DEFINE_NEW_OPERATOR();
public:
    ThreadPool();
    ~ThreadPool();

    void start(Job* job, HiME_ThreadPriority pr = HiME_ThreadPriorityNormal);

private:

    struct Runner
    {
        ThreadPool* pool;
        Job* job;
        Thread thread;
        Semaphore start;
        Semaphore end;
    };

    friend struct Runner;

    static uint32_t startProc(void* p);
    void startProc(Runner* p);

    Mutex m_lock;
    Vector<Runner*> m_pool;
};

} // namespace HiME

#endif // HiME_THREAD_POOL_H
