/****************************************************************************
Copyright (c) 2011 kona4kona (kona4kona@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining 
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation 
the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom 
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included 
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT 
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
****************************************************************************/

#ifndef HiME_GRAPHICS_H
#define HiME_GRAPHICS_H

#include "hime-no-copy.h"
#include "hime-geometry.h"
#include "hime-string.h"

namespace HiME
{

class Surface;

class Graphics : public NoCopy
{
    HiME_DEFINE_NEW_OPERATOR();
public:

    enum Composition
    {
        BlendSource,
        BlendDestination,
        CopySource,
        CopyDestination
    };

    virtual ~Graphics() {}

    virtual void blitSurface(const Recti& destRect, Surface* surf, const Recti& srcRect, Composition comp = BlendSource) = 0;
    virtual void drawText(const Recti& destRect, const String& text) = 0;
    virtual void drawRect(const Recti& destRect) = 0;
    virtual void drawRoundRect(const Recti& destRect, float xrad, float yrad) = 0;

protected:
    Graphics() {}
};

} // namespace HiME

#endif // HiME_GRAPHICS_H
