/****************************************************************************
Copyright (c) 2011 kona4kona (kona4kona@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining 
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation 
the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom 
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included 
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT 
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
****************************************************************************/

#include "hime-scale.h"
#include "hime-surface.h"
//#include "hime-enhance.h"

namespace HiME
{
namespace imageAux
{

void scale(Surface& dst, const Surface& src)
{
    float scalex = (float)dst.width() / (float)src.width();
    float scaley = (float)dst.height() / (float)src.height();
    float maxscale = HiME_MAX(scalex, scaley);
    //float sharpfract = (maxscale < 0.7f) ? 0.2f : 0.4f;
    //int sharpwidth = (maxscale < 0.7f) ? 1 : 2;

    if (maxscale < 1.0f)
    {
        // area mapping for anti-aliasing
        scaleColorAreaMapLow(dst, src);
        //if (maxscale > 0.2f && sharpfract > 0.0f && sharpwidth > 0)
        //    unsharpMasking(dst, sharpwidth, sharpfract);
    }
    else
    {
        // use linear interpolation
        scaleLow(dst, src);
        //if (maxscale < 1.4f && sharpfract > 0.0f && sharpwidth > 0)
        //    unsharpMasking(dst, sharpwidth, sharpfract);
    }
}

} // namespace imageAux
} // namespace HiME
