/****************************************************************************
Copyright (c) 2011 kona4kona (kona4kona@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining 
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation 
the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom 
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included 
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT 
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
****************************************************************************/

#ifndef HiME_SCALE_H
#define HiME_SCALE_H

#include "hime-core.h"

namespace HiME
{

class Surface;

namespace imageAux
{
    void scale(Surface& dst, const Surface& src);
    void scaleLow(Surface& dst, const Surface& src);
    void scaleColorAreaMapLow(Surface& dst, const Surface& src);
}

} // namespace HiME

#define HiME_READ_32_FROM_8(ADDR )       (*(ADDR) | (*(ADDR) << 8) | (*(ADDR) << 16) | (*(ADDR) << 24))
#define HiME_READ_32_FROM_24(ADDR)       (*(ADDR) | (*((ADDR) + 1) << 8) | (*((ADDR) + 2) << 16) | 0xff000000)
#define HiME_READ_32_FROM_32(ADDR)       (*(uint32_t*)(ADDR))

#endif // HiME_IMG_SCALE_H
