/****************************************************************************
Copyright (c) 2011 kona4kona (kona4kona@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
****************************************************************************/

#include "hime-test.h"
#include "hime-variant.h"
#include "hime-string.h"

namespace HiME {
	struct Test1 {
		int a;
		char s[512];

		Test1() {
			a = 0;
		}

		Test1(const Test1& t) {
			a = t.a;
		}

		~Test1() {
			a = -1;
		}
	};

	template<> struct TypeIDMap<Test1> {
		static const HiME_Type TypeID =
			HiME_Type_UserDefinedType;
	};

	namespace Test {
		extern "C" void
		hime_test_cpp_variant(hime_test_context_t* ctx)
		{
			ctx->package = "c++ variant";
			ctx->test_group = "c++ variant";
			ctx->test_case = "c++ variant";

			Variant t;
			t = (int)1;
			t = String("qqq");
			t = 12.0;

			Test1 a;
			t = a;
			//t.clear();
		}
	}
} // namespace HiME
