/* vim:set ts=8 sts=4 sw=4 tw=0: */
/*
 * Last Change: 03-Jun-2003.
 * Written By:  Muraoka Taro <koron@tka.att.ne.jp>
 */

/* netupvim.cpp : AvP[Vp̃Gg |Cg̒` */

#include "stdafx.h"
#include <stdio.h>
#include "resource.h"
#include "freshen.h"
#pragma comment(lib, "freshen")

#define NETUPVIM_FILELIST "filelist.xml"
#define NETUPVIM_DEFAULT_URL "http://www.kaoriya.net/update/netup-vim64-w32j.xml"

static HWND g_hwnd = 0;
static int g_cancel = 0;

    void
output_info(char* info, ...)
{
    if (info)
    {
	char buf[4096];
	va_list args;
	va_start(args, info);
	_vsnprintf(buf, sizeof(buf), info, args);

	HWND hwndInfo = GetDlgItem(g_hwnd, IDC_INFOMATION);
	SendMessage(hwndInfo, EM_SETSEL, -1, 0);
	SendMessage(hwndInfo, EM_REPLACESEL, FALSE, (LPARAM)buf);
	SendMessage(hwndInfo, EM_REPLACESEL, FALSE, (LPARAM)"\r\n");
    }
}

    int
message(void* d, unsigned int id, int param1, void* param2, char* str)
{
    static int filenum = 0, totalsize = 0, proxyflag = 0;
    static char proxy[256];
    int confirm;

    switch (id)
    {
	case FRESHEN_MSG_USEPROXY:
	    proxyflag = 1;
	    strncpy(proxy, (char*)param2, sizeof(proxy));
	    output_info("_E[hɃvLV %s gp܂B", proxy);
	    break;
	case FRESHEN_MSG_START:
	    output_info("lbg[NAbvf[gJn܂B");
	    output_info("");
	    break;
	case FRESHEN_MSG_NOUPDATE:
	    output_info("XVꂽt@C͂܂łB");
	    break;
	case FRESHEN_MSG_FLESHOUT:
	    if (param1 >= 0)
		output_info("XV܂B");
	    else
		output_info("XV͍sȂ܂ł");
	    output_info("uv{^ďIĂB");
	    break;
	case FRESHEN_MSG_BADINFO:
	    output_info("XV擾o܂łB");
	    MessageBox(g_hwnd,
		    "Vim̍XV𐳂擾o܂łB\r\n"
		    "Ǘ <koron@tka.att.ne.jp> Ƀ[ŘA邩A\r\n"
		    "艮 http://www.kaoriya.net/ փANZXĂB"
		    , "Vim̍XV擾Ɏs", MB_OK | MB_ICONERROR);
	    break;
	case FRESHEN_MSG_GOODINFO:
	    output_info("XV̎擾܂B");
	    break;
	case FRESHEN_MSG_SCHEDULE:
	    filenum = param1;
	    totalsize = (int)param2;
	    output_info("%d t@C v %d oCg_E[h܂B",
		    filenum, totalsize);
	    output_info("");
	    break;
	case FRESHEN_MSG_CONFIRM:
	    {
		char buf[1024];
		char proxymsg[512];

		proxymsg[0] = '\0';
		if (proxyflag)
		    _snprintf(proxymsg, sizeof(proxymsg), " vLV %s",
			    proxy);
		_snprintf(buf, sizeof(buf),
			"t@C̃_E[h\r\n"
			"(%d t@C v %d oCg%s)\r\n"
			"Jn܂?"
			, filenum, totalsize, proxymsg);
		confirm = MessageBox(g_hwnd, buf, "_E[hmF",
			MB_ICONQUESTION | MB_YESNO);
	    }
	    return confirm == IDNO ? 0 : 1;
	case FRESHEN_MSG_CANCEL:
	    switch (param1)
	    {
		case FRESHEN_CANCEL_NOFILE:
		    output_info("XVꂽt@C͂܂łB");
		    break;
		case FRESHEN_CANCEL_CONFIRM:
		case FRESHEN_CANCEL_DOWNLOAD:
		    output_info("_E[h𒆎~܂B");
		    break;
		default:
		    output_info(str);
		    break;
	    }
	    break;
	case FRESHEN_MSG_DLBEGIN:
	    output_info("");
	    output_info("URL %s", param2);
	    output_info("%d oCg_E[hĂ܂B", param1);
	    break;
	case FRESHEN_MSG_DLEND:
	    output_info("_E[h(%d oCg)܂B", param1);
	    break;
	case FRESHEN_MSG_DECOMPRESS:
	    output_info("_E[ht@C𓀂Ă܂B");
	    break;
	case FRESHEN_MSG_BADMD5:
	    output_info("MD5lv܂łB"
		    "_E[hɎs悤łB");
	    break;
	case FRESHEN_MSG_GOODMD5:
	    output_info("MD5lv܂B_E[hɐ܂B");
	    break;
	case FRESHEN_MSG_DLALLEND:
	    output_info("");
	    if (param1 > 0)
	    {
		output_info("%d ̃t@C_E[hI܂B",
			param1);
	    }
	    break;
	case FRESHEN_MSG_UPDATEINFO:
	    output_info("XV`FbN܂B");
	    break;
	case FRESHEN_MSG_DLINFO:
	    output_info("URL %s", param2);
	    output_info("ŐV̍XV_E[hĂ܂"
		    "(%d )B", param1);
	    break;
	case FRESHEN_MSG_CHDIR:
	    break;
	default:
	    output_info(str);
	    break;
    }
    return 1;
}

    int
progress(void* d, FRESHEN_PROGRESS_T* p)
{
    HWND hwndMinute = GetDlgItem(g_hwnd, IDC_PROGRESS_MINUTE);
    PostMessage(GetDlgItem(g_hwnd, IDC_PROGRESS_HOUR),
	    PBM_SETPOS, (p->hour * 100 / p->hour_last), 0);
    PostMessage(GetDlgItem(g_hwnd, IDC_PROGRESS_MINUTE),
	    PBM_SETPOS, (p->minute * 100 / p->minute_last), 0);
    return g_cancel ? 0 : 1;
}

    void __cdecl
do_update(void* p)
{
    FreshenSetMessageProc(message, 0);
    FreshenSetProgressProc(progress, 0);
    int res = Freshen(0, NETUPVIM_FILELIST, NETUPVIM_DEFAULT_URL);
    SendMessage(g_hwnd, WM_USER + 0, res, 0);
    _endthread();
}

    static int CALLBACK
dlgproc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static int flag_close = 0;
    switch (uMsg)
    {
	case WM_USER + 0:
	    SetDlgItemText(hwnd, ID_NOTIFYBUTTON, "");
	    flag_close = 1;
	    return 1;
	case WM_SYSCOMMAND:
	    switch (wParam)
	    {
		case SC_CLOSE:
		    if (!flag_close)
			g_cancel = 1;
		    else
			DestroyWindow(hwnd);
		    return 1;
	    }
	    break;
	case WM_COMMAND:
	    switch (LOWORD(wParam))
	    {
		case ID_NOTIFYBUTTON:
		    if (!flag_close)
			g_cancel = 1;
		    else
			DestroyWindow(hwnd);
		    return 1;
	    }
	    break;
	case WM_DESTROY:
	    PostQuitMessage(0);
	    return 1;
	case WM_INITDIALOG:
	    SetWindowLong(hwnd, DWL_MSGRESULT, 1);
	    return 1;
    }

    return 0;
}

    int APIENTRY
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpCmdLine,
	int       nCmdShow )
{
    InitCommonControls();
    HWND hwnd = CreateDialog(hInstance,
		MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, dlgproc);
    if (!hwnd)
	return -1;
    g_hwnd = hwnd;
    SetClassLong(g_hwnd, GCL_HICON, (LONG)LoadIcon(hInstance,
		MAKEINTRESOURCE(IDI_NETUPVIM)));

    MSG msg;
    ShowWindow(hwnd, SW_SHOW);
    int res = MessageBox(hwnd,
	    "Vim̃lbg[NAbvf[gJn܂?\r\n"
	    "\r\n"
	    "Abvf[gɂ͐ȏォꍇ\r\n"
	    "܂BVimgpĂꍇA\r\n"
	    "Abvf[gn߂OVimIĂB"
	    , "VimAbvf[g̊mF", MB_YESNO | MB_ICONQUESTION);
    if (res == IDNO)
	DestroyWindow(hwnd);
    else
	_beginthread(do_update, 0, 0);
    while (GetMessage(&msg, NULL, 0, 0))
    {
	if (IsDialogMessage(hwnd, &msg))
	    continue;
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }

    return 0;
}
