#include <dogadjaji.h>
#include <jezgra/pozivi_jezgre.h>

int stvori_red_dogadjaja (int zast, int prio)
{
	struct {
		int zast;
		int prio;
	} p;
	
	p.zast = zast;
	p.prio = prio;
	
	return j_funkcija(STVORI_RED_DOGADJAJA, &p);
}

int obrisi_red_dogadjaja (int id)
{
	return j_funkcija(OBRISI_RED_DOGADJAJA, &id);
}

int prijavi_se_na_red_dogadjaja (int id, 
				 void (*funkcija) (dogadjaj_t *dog, void *),
				 void *param)
{
	struct {
		int id;
		void (*funkcija) (dogadjaj_t *dog, void *param);
		void *param;
	} p;
	
	p.id = id;
	p.funkcija = funkcija;
	p.param = param;

	return j_funkcija(PRIJAVI_SE_NA_RED_DOGADJAJA, &p);
}

int postavi_dogadjaj (int tip, int param, void *pparam, int prio,
		      int kome, int id)
{
	struct {
		int tip;
		int param;
		void *pparam;
		int prio;
		int kome;
		int id;
	} p;

	p.tip = tip;
	p.param = param;
	p.pparam = pparam;
	p.prio = prio;
	p.kome = kome;
	p.id = id;

	return j_funkcija(POSTAVI_DOGADJAJ, &p);
}

int dohvati_dogadjaj_t (int id_reda, int tip, dogadjaj_t *dog, int zast,
			vrijeme_t *koliko)
{
	struct {
		int id_reda;
		int tip;
		dogadjaj_t *dog;
		int zast;
		vrijeme_t *koliko;
	} p;
	int povvr;
	
	p.id_reda = id_reda;
	p.tip = tip;
	p.dog = dog;
	p.zast = zast;
	p.koliko = koliko;

	povvr = j_funkcija(DOHVATI_DOGADJAJ, &p);
	
	while ((p.zast & DOG_CEKAJ) && povvr == 1)
		povvr = j_funkcija(DOHVATI_DOGADJAJ, &p);
	
	return povvr;
}