//! Startup OS-a

#include "postavke.h"
#include "ispis.h"
#include "razno.h"
#include "prekidi.h"
#include "vrijeme.h"
#include "tipkovnica.h"
#include "dretve.h"
#include "spremnik.h"

#include <programi.h>

//za zavrsetak "pocetne dretve", nakon sto inicijalizira sustav "izlazi"
extern void izadji_iz_jezgre(); //definirana u arh sloju

/*!
 * Funkcija koja je pozvana odmah iz asemblerskog koda kod samog pocetka
 * bootanja.
 * \param magic Bootloader magicni broj
 * \param addr Adresa multiboot_info_t strukture
 */

void j_pocetak (unsigned long magic, unsigned long addr)
{
	/* inicijalizacija svega */

	j_inicijaliziraj_spremnik();

	j_ispis_inicijaliziraj();

	j_prekidi_inicijaliziraj();

	j_visedretvenost_inicijaliziraj();

	j_sat_inicijaliziraj();

	j_tipkovnica_inicijaliziraj(ISTINA);

	j_ispisi("<%s:%s:%s>\nSustav inicijaliziran!\n\n",
		AUTOR, PROJEKT, PLATFORMA);

	//stvori pocetne dretve
	struct {
		void (*poc_funkc)(void *);	//pocetna funckija dreve
		void *param;			//parametar za stog
		void *stog;			//pocetni stog
		int prio;			//prioritet
		int rasp;			//koji rasporedjivac? FIFO, RR
	} pd;

	pd.param = NULL;
	pd.stog = NULL;
	pd.rasp = RASP_PRP;

	//latentna dretva (idle dretva)
	pd.poc_funkc = latentna_dretva;
	pd.prio = PRIO_MIN;
	j_stvori_dretvu (&pd);

	//pocetna dretva
	pd.poc_funkc = pocetna_dretva;
	pd.prio = PRIO_MAX;
	j_stvori_dretvu (&pd);


	//zavrsi "ovu" pocetnu dretvu
	izadji_iz_jezgre();
}
