#include <dretve.h>
#include <ispis.h>
#include <vrijeme.h>
#include <dogadjaji.h>

static void tobrada (dogadjaj_t *dog, void *param)
{
	ispisi("[obrada %d] ", *((int *) param));
	ispisi("Tip=%d, param=%d, pparam=%x, prio=%d, kada=%d:%d, id=%d\n",
		dog->tip, dog->param, dog->pparam, dog->prio, 
		dog->kada.sekunde, dog->kada.nsekunde/1000000, dog->id_gen);
}

static void tdretva (void *param)
{
	int i, id = id_dretve();
	vrijeme_t koliko;
	dogadjaj_t dog;
	int povvr;

	ispisi("Dretva %d, prioritet=%d, pocetak\n", id, dohvati_prioritet(-1));

	koliko.sekunde = 5;
	koliko.nsekunde = 0;
	
	prijavi_se_na_red_dogadjaja(RED_DOG_DRETVE, tobrada, &id);


#define NN 3
	for (i = 0; i < NN; i++) {
		ispisi("Dretva %d, prolaz %d/%d\n", id, i + 1, NN);
		odgodi(koliko);
	}
#undef NN

	//slanje signala "sebi"
	postavi_dogadjaj (1, 2, NULL, 33, DOG_ZA_DRETVU, id_dretve());

	povvr = dohvati_dogadjaj (RED_DOG_DRETVE, 7, &dog, 0);
	ispisi("[dohvat %d (%d)]", id, povvr);
	if (povvr == 0) {
		ispisi("Tip=%d, param=%d, pparam=%x, prio=%d, kada=%d:%d, "
			"id=%d\n", dog.tip, dog.param, dog.pparam, dog.prio,
			dog.kada.sekunde, dog.kada.nsekunde/1000000,
			dog.id_gen);
	}
	else {
		ispisi("\n");
	}

	povvr = dohvati_dogadjaj (RED_DOG_DRETVE, 0, &dog, DOG_CEKAJ);
	ispisi("[dohvat %d (%d)]", id, povvr);
	if (povvr == 0) {
		ispisi("Tip=%d, param=%d, pparam=%x, prio=%d, kada=%d:%d, "
			"id=%d\n", dog.tip, dog.param, dog.pparam, dog.prio,
			dog.kada.sekunde, dog.kada.nsekunde/1000000,
			dog.id_gen);
	}
	else {
		ispisi("\n");
	}

	ispisi("Dretva %d zavrsava\n", id);
}

void test_dogadjaji()
{
	int dr1, dr2, i1 = 1, i2 = 2, i3 = 3;
	vrijeme_t koliko;

	ispisi("\n[%s:%s]\n", __FILE__, __FUNCTION__);

	koliko.sekunde = 2;
	koliko.nsekunde = 0;
	
	dr1 = stvori_dretvu(tdretva, &i1);
	dr2 = stvori_dretvu(tdretva, &i2);
	if (dr1 == -1 || dr2 == -1)
		return; //nije potrebno ispisivati poruku o gresci, to je vec

	odgodi(koliko);
	postavi_dogadjaj (1, 2, &i3, 10, DOG_ZA_DRETVU, dr1);
	postavi_dogadjaj (3, 1, &i2, 15, DOG_ZA_DRETVU, dr1);
	postavi_dogadjaj (7, 1, &i2, 150, DOG_ZA_DRETVU, dr1);

	odgodi(koliko);
	postavi_dogadjaj (7, 1, &i2, 11, DOG_ZA_DRETVU, dr2);

	koliko.sekunde = 10;
	odgodi(koliko);
	postavi_dogadjaj (23, 2, &i3, 150, DOG_ZA_DRETVU, dr1);
	postavi_dogadjaj (32, 2, &i3, 150, DOG_ZA_DRETVU, dr2);

	cekaj_kraj_dretve(dr1);
	cekaj_kraj_dretve(dr2);
}
