//! Upravljanje prekidima - niska razina

#ifndef	_ARH_PREKIDI_H_
#define	_ARH_PREKIDI_H_

#ifndef _ARH_PREKIDI_S_
#include "tipovi.h"
#endif	/* !_ARH_PREKIDI_S_ */

//!prikazano i izvan prekidi.cS ----------------------------------------------->

//dozvoljeni broj razlicitih prekida
#define	PREKIDI_BROJ		49	//49 je dosta iako moze i do 256

//gdje su koji prekidi
#define	PREKIDI_PROCESOR	0
#define	PREKIDI_VANJSKI		32
#define	PREKIDI_PROGRAMSKI	48

#ifndef _ARH_PREKIDI_S_

void arh_prekidi_inicijaliziraj (	void (*j_prekidnaf)(int),
					uint32 *jstogpr,
					uint32 ***stog_aktivne);

char *arh_opis_prekida (int n);

#endif	/* !_ARH_PREKIDI_S_ */

#ifdef _ARH_PREKIDI_C_
//samo za "arh/prekidi.c"

//IDT dio --------------------------------------------------------------------->
//! Izgled nekog opisnika prekida u IDT
typedef	struct {
	uint16	offset_lo;		//!< Offset (bits 0-15)
	uint16	seg_sel;		//!< Segment selector
	uint8	zero;			//!< Uvijek 0
	uint8	type		: 5;	//!< Tip
	uint8	dpl		: 2;	//!< Privilege level
	uint8	present		: 1;	//!< Present
	uint16	offset_hi;		//!< Offset (bits 16-31)
} __attribute__((__packed__)) idt_t;

//! Pokazivac na IDT - registar, prilagodjen za LIDT instrukciju
typedef	struct {
	uint16 limit;
	idt_t *base;
} __attribute__((__packed__)) idtr_t;

static void idt_inicijaliziraj ();

//IDT dio ---------------------------------------------------------------------<

#endif /* _ARH_PREKIDI_C_ */
#endif	/* _ARH_PREKIDI_H_ */
