#include <dretve.h>
#include <ispis.h>
#include <vrijeme.h>

static int kraj = 0;

static void tdretva(void *param)
{
	int i, id = id_dretve();
	vrijeme_t koliko;

	koliko.sekunde = 1;
	koliko.nsekunde = 0;
	
	ispisi("Dretva %d, prioritet=%d, pocetak\n", id, dohvati_prioritet(0));

#define NN 3
	for (i = 0; i < NN; i++) {
		ispisi("Dretva %d, prolaz %d/%d\n", id, i + 1, NN);
		dretva_odstupi();
		odgodi(koliko);
	}
#undef NN

	ispisi("Dretva %d zavrsava\n", id);
	
	kraj++;
}

void test_dretve()
{
	ispisi("\n[%s:%s]\n", __FILE__, __FUNCTION__);

	int dr1, dr2, dr3;
	vrijeme_t koliko;
	koliko.sekunde = 0;
	koliko.nsekunde = 100000000; //100 ms
	
	dr1 = stvori_dretvu_pr(tdretva, NULL, NULL, 0, RASP_PRP);
	dr2 = stvori_dretvu_pr(tdretva, NULL, NULL, 0, RASP_PRP);

	dr3 = stvori_dretvu_pr(tdretva, NULL, NULL, PRIO_POCETNI, RASP_PRP);
	//ova nikad nece doc na red jer ima manji prioritet, a za sada nije
	//implementirano blokiranje!
	
	if (dr1 == -1 || dr2 == -1 || dr3 == -1)
		return; //nije potrebno ispisivati poruku o gresci, to je vec

	while (kraj < 2) { //mora se eksplicitno rasporedjivati dretve!
		dretva_odstupi();
		odgodi(koliko);
	}
}
