/* "upute" linkeru kako da napravi odredisnu datoteku, kamo da sto stavi */

ENTRY(start)

SECTIONS {
	.pocetak_koda 0x100000 : {
	        code = .;
		*(.pocetak_koda)
		. = ALIGN(4096);
	}

	.text : {
		*(.text)
		. = ALIGN(4096);
	}

	.data : {
	        data = .;
		*(.data)
	        *(.rodata.*)
		. = ALIGN(4096);
	}

	.bss : {
	        bss = .;
		*(.bss)
		. = ALIGN(4096);
	}
	
	end = .;
}


/*
Za navedene postavke memorija pocinje na 100000

sekcija - adresa pocetka
=========================
.pocetak_koda	100000
.text		100000 + velicina(.pocetak_koda) //odredjuje kompajler/linker
.data		.text + velicina(.text)
.bss		.data + velicina(.data)
end		.bss + velicina(.bss)


Opci primjercic kamo sto ide iz C datoteke (prema "konvenciji")

--->
#include dio

int var1 = 1, var2 = 2, var3;

int funkcija (parametri)
{
	int a, b, c, *p;
	
	"neki kod";
	p = malloc();
	
	return 0;
}
<--------
Globalne varijable koje imaju pocetnu vrijednost != 0 idu u .data.
Globalne varijable koje nemaju pocetne vrijednosti idu u .bss.

.bss ne zauzima prostor na disku u izvrsnoj (npr .out ili .exe) datoteci vec se
alocira u memoriji pri ucitavanju programa i popunjava nulama. Zato se u .bss
smjestaju sve globalne varijable koji nisu inicijalizirane ili su
inicijalizirane nulama. Razlog ovakvog ponasanja je u minimizaciji velicine
programa na disku!

* var1, var2 ce ici u .data sekciju zato jer imaju pocetne vrijednosti!

* u bss sekciji ce biti var3 i stog (i parametri a, b, c i p - na stogu) 

* memorija koju malloc rezervira biti ce u .bss (ali nemamo malloc!)

* sam "kod" funkcije "funkcija" (instrukcije) biti ce u .text sekciji

*/
