#include <ispis.h>
#include <vrijeme.h>
#include <jezgra/razno.h>
#include <jezgra/pozivi_jezgre.h>

int postavi_alarm_pr (	int id, vrijeme_t koliko, void (*obrada)(void *),
			void *param, uint32 zast)
{
	alarm_t p;
	
	p.id = id;
	p.kada = koliko;
	p.obrada = obrada;
	p.param = param;
	p.zast = zast;

	return j_funkcija(ALARM_POSTAVI, &p);
}

int postavi_alarm (	int id, vrijeme_t koliko, void (*obrada)(void *),
			void *param, bool ponavljaj)
{
	int zast = 0;
	
	if (!id)
		zast = STVORINOVI;
	if (ponavljaj)
		zast |= PERIODICKI;

	return postavi_alarm_pr(id, koliko, obrada, param, zast);
}

int obrisi_alarm (int id)
{
	return j_funkcija(ALARM_OBRISI, &id);
}

int odgodi (vrijeme_t koliko)
{
	int id;
	
	id = postavi_alarm_pr(	0, koliko, NULL, NULL, 
				STVORINOVI | BLOKIRAJDR);
	if (id < 0)
		return id;
	
	return obrisi_alarm(id);
}

int odgodi_do (vrijeme_t koliko)
{
	int id;
	
	id = postavi_alarm_pr(	0, koliko, NULL, NULL, 
				ABSVRIJEME | STVORINOVI | BLOKIRAJDR);
	if (id < 0)
		return id;
	
	return obrisi_alarm(id);
}
