/* pokreni.S - pokreni podizanje sustava */
     
#include "postavke.h"


/* ulazna tocka - pocetak koda (treba linkeru pa je oznacavamo globalnom) */
.global	start

.extern	arh_pocetak, code, bss, end	

.section .pocetak_koda

	
/* Poravnaj na 32 bitovnu granicu */
.align  4
/* Multiboot zaglavlje - treba 'grubu' */
multiboot_header:
	/* magic */
	.long   MULTIBOOT_HEADER_MAGIC
	/* flags */
	.long   MULTIBOOT_HEADER_FLAGS
	/* checksum */
	.long   -(MULTIBOOT_HEADER_MAGIC + MULTIBOOT_HEADER_FLAGS)
	
	.long	multiboot_header
	.long	code
	.long	bss
	.long	end
	.long	start

/* pocetak rada OS-a (tu 'grub' preda sustav) */
start:
	/* Postavi kazaljku stoga */
	movl    $(stog + VELICINA_STOGA_JEZGRE), %esp
	
	/* Resetiraj registar stanja EFLAGS */
	pushl   $0
	popf
	
	/* Stavi na stog vrijednosti koje nam je predao "grub" */
	pushl   %ebx
	pushl   %eax
	
	/* Pozovi C funkciju */
	call    EXT_C(arh_pocetak)
	addl	$8, %esp
	
	/* Zaustavi rad */
	cli
loop:	hlt
	jmp     loop
	

.section .bss

	/* Mjesto za stog */
.align 4
	.comm   stog, VELICINA_STOGA_JEZGRE
