#ifndef _ENV_H_
#define _ENV_H_
/*----- flags -----*/
#define _DEBUG_
#define _LINUX_ /* flag of operating system */
#define _VERBOSE_ /* writes some useful message to log */
#define _F_MODE_ S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH /* file mode */
#define _SUCCEED_ 0
#define _FAILURE_ -1
#define _EMPTYRE_ -2
#define _HVMPEAK_
/*---- formats ----*/
#define _TF_SQL_ "STRFTIME('%Y-%m-%d %H:%M:%S','now')" /* sql time format */
#define _TF_MSG_ "[%y%b%d %T] " /* [11Feb04 16:18:41] */
#define _TF_ERR_ "<%y%b%d %T> " /* <11Feb04 16:18:41> */
/*---- values -----*/
#define _NOMUSR_ 1001 /* uid of a normal user (who run the judged programs) */
#define _TF_LEN_ 19 /* length of time format */
#define _THREAD_ 4 /* multi-judge threads count */
#define _MAXRTY_ 3 /* max try count */
#define _CAREFL_ 2 /* careful level */
#define _BUFFSZ_ 300 /* size of buffer */
#define _OUTLMT_ 200 /* unit: kilobytes */
#define _STKLMT_ 128 /* unit: kilobytes */
/*----- paths -----*/
#define _CC_PATH_ "/usr/bin/gcc"
#define _CP_PATH_ "/usr/bin/g++"
/* the path of compilers */
#define _CCE_FNO_ STDERR_FILENO /* where to read compiler error message (C) */
#define _CPE_FNO_ STDERR_FILENO
#define _CC_ARGS_ "./main.c","-std=c99","--static" ,"-lm","-DONLINE_JUDGE","-Wall","-O2","-pipe",NULL
#define _CP_ARGS_ "./main.cpp","-ansi","--static","-lm","-DONLINE_JUDGE","-Wall","-O2","-pipe",NULL
/* args and do " #define ONLINE_JUDGE " */
#define _DB_PATH_ "./judge.db" /* "/var/db/judge.db" */ /* database path */
#define _LK_PATH_ "./judge.pid" /* "/var/run/judge.pid" */ /* pid lock file */
#define _LG_PATH_ "./judge.log" /* "/var/log/judge.log" */ /* log path */
#define _CF_PATH_ "./judge.conf" /* "/etc/judge.conf" */ /* config path */
/*--- languages ---*/
#define _ANSI_C_ 0
#define _GNUCPP_ 1
#define _SUNJAV_ 2
/*---- results ----*/
#define _PENDIN_ -1
#define _ACCEPT_ 0
#define _WRONGA_ 1
#define _TIMELE_ 2
#define _MEMRLE_ 3
#define _CMPERR_ 4
#define _PRSERR_ 5
#define _OUTLME_ 6
#define _RTEACV_ 7
#define _RTEDBZ_ 8
#define _RTEUEC_ 9
#define _RTEUKN_ 10
#define _SYSERR_ 11
/*----- args -----*/
#define TELE_CON 0x1
#define CLEN_PID 0x2
#define CLEN_LOG 0x4
#define VIRT_RUN 0x8
/*----------------*/
#ifndef _LINUX_
# define PTRACE_TRACEME PT_TRACE_ME
# define PTRACE_KILL PT_KILL
# define PTRACE_SYSCALL PT_CONTINUE
#endif
/*----------------*/
#endif