#include "./env.h"
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include "./log.h"
#ifdef _LINUX_
/* you can only use this in linux 2.6+ */
int get_mmr_u(pid_t pid) {
	/* get memory peak, implement by 'linprocfs' */
	char buffer[103];
#ifdef _HVMPEAK_
	const char *vmp = "VmPeak:";
#else
	const char *vmp = "VmSize:";
#endif
	sprintf(buffer,"/proc/%d/status",(int)pid);
	FILE *fp = fopen(buffer,"r");
	if(fp == NULL) {
		log_error("[E_GM01]:Can't Open Status");
	}
	int mmr_u = -1;
	while(fgets(buffer,100,fp)!=NULL) {
		int length = strlen(buffer);
		if(length < 8) {
			continue;
		} else {
			int idx = 0;
			while(vmp[idx] == buffer[idx]) {
				idx++;
				if(vmp[idx] == '\0') {
					sscanf(buffer+idx,"%d",&mmr_u);
					break;
				}
			}
		}
		if(mmr_u >= 0) {
			break;
		}
	}
	fclose(fp);
	if(mmr_u < 0) {
		log_error("[E_GM02]:Memory Data Read Error");
		return _FAILURE_;
	} else {
		return mmr_u;
	}
}
#else
int get_mmr_u(pid_t pid) {
	return 0;
}
#endif