/* sql_final()
 * sql_init(path)
 * sql_new_submit(ary,size)
 * sql_update_submit(result,sub_id)
 * sql_fetch_problem(problem,prob_id)
 * sql_fetch_submit(submit,sub_id)
 * sql_free_problem(problem)
 * sql_free_submit(submit)
 */
#ifndef _SQL_H_
#define _SQL_H_
#include "./struct.h"

int sql_final(void); /* global clean up function, call this before exiting */
int sql_init(const char*); /* init with a path, call this before everthing */
int sql_new_submit(int*,int); /* fetch un-judged sub_id, less than sz */
int sql_update_submit(const struct result*,int); /* update result data */
int sql_fetch_problem(struct problem**,int);
/* alloc and return problem info by prob_id */
int sql_fetch_submit(struct submit**,int);
/* alloc and return submit info by sub_id */
int sql_free_problem(struct problem*); /* free problem info structure */
int sql_free_submit(struct submit*); /* free submit info structure */

#endif