#include "./env.h"
#include <stdlib.h>
#include "./struct.h"

int free_problem(struct problem *pbp) {
	if(pbp) {
		if(pbp->std_in) {
			free(pbp->std_in);
		}
		if(pbp->std_ot) {
			free(pbp->std_ot);
		}
		free(pbp);
	}
	return _SUCCEED_;
}

int free_result(struct result *rbp) {
	if(rbp) {
		if(rbp->err_msg) {
			free(rbp->err_msg);
		}
		free(rbp);
	}
}

int free_submit(struct submit *sbp) {
	if(sbp) {
		if(sbp->code) {
			free(sbp->code);
		}
		if(sbp->r_ptr) {
			free_result(sbp->r_ptr);
		}
		free(sbp);
	}
	return _SUCCEED_;
}