#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "_memory.h"
#include "_interp.h"
#include "_zealot.h"

#define _HINT_S_ "# " 
#define EMP_CH(w) ((w)=='\n'||(w)==' '||(w)=='\t')

static char _buffer[100];
static int _index;
static int _length;

void _inspect_elements(void *p_tr,int top) {
	struct _i_node *ptr = (struct _i_node*)p_tr;
	if(top) printf("=> ");
	if(!ptr) {
		printf("<error>");
	} else if(ptr->type == _QUOTE__) {
		struct _i_node *front = (struct _i_node*)(ptr->data);
		int brk = 0;
		if(top && front && (front->next || front->type == _QUOTE__)) {
			printf("(");
			brk = 1;
		}
		while(front) {
			if(front->type == _QUOTE__) {
				putchar('(');
				_inspect_elements(front,0);
				putchar(')');
			} else {
				_inspect_elements(front,0);
			}
			if(front->next) putchar(' ');
			front = front->next;
		}
		if(brk) putchar(')');
	} else if(ptr->type == _NUMBER_) {
		printf("%d",*(int*)(ptr->data));
	} else if(ptr->type == _BOOLEAN) {
		printf("%s",*(char*)(ptr->data) ?"true":"false");
	} else if(ptr->type == _NIHIL__) {
		printf("<nil>");
	} else if(ptr->type == _LAMBDA_) {
		printf("<procedure>");
	} else if(ptr->type == _SYMBOL_) {
		printf("%s",(char*)ptr->data);
	} else {
		printf("%f",*(float*)(ptr->data));
	}
	if(top) {
		putchar('\n');
	}
}

void _init_io_inf(int t) {
	_index = 0;
	_length = 0;
}

/*---- misc ----*/
void _end_of_io(void) {
	putchar('\n');
	_dealloc_all();
}

/*---- expression ----*/
/* int _open_stream(char*); */
void _write_hint(int level) {
	int i;
	if(!level) {
		printf(_HINT_S_);
	} else {
		for(i=-1;i<level;i++) {
			printf("  ");
		}
	}
}
void _try_readline(int level) {
	_write_hint(level);
	if(!fgets(_buffer,100,stdin)) {
		_end_of_io();
		exit(0);
	} else {
		_index = 0;
		_length = strlen(_buffer);
	}
}

void _to_next_no_empty(int level) {
	while(_index<_length && EMP_CH(*(_buffer+_index))) _index++;
	if(_index >= _length) {
		_try_readline(level);
		_to_next_no_empty(level);
	}
}

void _to_end_of_elem(void) {
	while(_index<_length && *(_buffer+_index) != _RIGHT && *(_buffer+_index) != _LEFT && !(EMP_CH(*(_buffer+_index)))) _index++;
}
void _eat_left_char(void) {
	if(*(_buffer+_index) == _LEFT) _index++;
}
void _eat_right_char(void) {
	if(*(_buffer+_index) == _RIGHT) _index++;
}
char _will_in_char(int level) {
	_to_next_no_empty(level);
	return *(_buffer+_index);
}
char* _read_next_elem(void) {
	int now_idx = _index;
	_to_end_of_elem();
	if(_index>now_idx) {
		char *word = _alloc(sizeof(char) *(_index-now_idx)+2);
		memcpy(word,_buffer+now_idx,_index-now_idx);
		*(word+(_index-now_idx)) = _EOS;
		return word;
	} else {
		return NULL;
	}
}