#include <string.h>
#include "_parser.h"
#include "_memory.h"
#include "_io_inf.h"

struct _e_node* _e_node_init(struct _e_node *ptr) {
	ptr->child_e = NULL;
	ptr->child_n = NULL;
	ptr->next = NULL;
	return ptr;
}

void _expr_rec_parser(struct _e_node *root,int level) {
	_eat_left_char();
	struct _e_node *now = root->child_n;
	while(_RIGHT != _will_in_char(level)) {
		if(now) {
			now->next = _e_node_init(_alloc(sizeof(struct _e_node)));
			now = now->next;
		} else {
			root->child_n = _e_node_init(_alloc(sizeof(struct _e_node)));
			now = root->child_n;
		}
		if(_LEFT == _will_in_char(level)) {
			_expr_rec_parser(now,level+1);
		} else {
			now->child_e = _read_next_elem();
		}
	}
	if(now) {
		now->next = NULL;
	}
	_eat_right_char();
}

struct _e_node* _expr_duplicate(struct _e_node *root) {
	struct _e_node *front = NULL;
	struct _e_node *now = NULL;
	while(root) {
		if(front) {
			now->next = _alloc(sizeof(struct _e_node));
			now = now->next;
		} else {
			front = _alloc(sizeof(struct _e_node));
			now = front;
		}
		if(root->child_e) {
			now->child_e = _str_clone(root->child_e);
			now->child_n = NULL;
		} else {
			now->child_e = NULL;
			now->child_n = _expr_duplicate(root->child_n);
		}
		root = root->next;
	}
	now->next = NULL;
	return front;
}

void _expr_dealloc(struct _e_node *root) {
	while(root) {
		if(root->child_e) {
			_dealloc(root->child_e);
		} else {
			_expr_dealloc(root->child_n);
		}
		struct _e_node *temp = root;
		root = root->next;
		_dealloc(temp);
	}
}

struct _e_node* _expr_parser(void) {
	struct _e_node *root = NULL;
	if(_LEFT == _will_in_char(0)) {
		root = _e_node_init(_alloc(sizeof(struct _e_node)));
		_expr_rec_parser(root,1);
	} else if(_RIGHT == _will_in_char(0)) {
		_eat_right_char();
		return NULL;
	} else {
		root = _e_node_init(_alloc(sizeof(struct _e_node)));
		root->child_e = _read_next_elem();
	}
	return root;
}