#include "_parser.h"
#include "_io_inf.h"
#include "_interp.h"
#include "_zealot.h"
#include "_memory.h"
#include <stdio.h>
#include <string.h>
#define _VERBOSE 0x1

int parse_args(int argc,char **argv) {
	int result = 0;
	if(argc > 1) {
		int i;
		for(i=1;i<argc;i++) {
			if(!strcmp(*(argv+i),"-v") || !strcmp(*(argv+i),"-verbose")) {
				result |= _VERBOSE;
			}
#ifdef _DEBUG_VS
			else if(!strcmp(*(argv+i),"-bt")) {
				_d_trace_back = 1;
			}
#endif
		}
	}
	return result;
}

int main(int argc,char **argv) {
	_init_io_inf(_TERM_IO_);
	_create_nihil();
#ifdef _DEBUG_VS
	_d_trace_back = 0;
#endif
	int env = parse_args(argc,argv);
#ifdef _DEBUG_VS
	if(_d_trace_back) {
		printf("[the ySerA scheme interpreter] b%d  -bt\n",_BUILD_ID);
	} else {
		printf("[the ySerA scheme interpreter] b%d  -?\n",_BUILD_ID);
	}
#else
	printf("[the ySerA scheme interpreter] b%d\n",_BUILD_ID);
#endif
	for(;;) {
		struct _e_node *root = _expr_parser();
		struct _i_node *result = _expr_interp(root);
		_inspect_elements(result,1);
		_dealloc_i_node(result);
		_expr_dealloc(root);
		if(env & _VERBOSE) {
			print_m_leak();
		}
	}
	return 0;
}