/**
 * Copyright (c) 2009 Ma Can <ml.macana@gmail.com>
 *                           <macan@ncic.ac.cn>
 *
 * Time-stamp: <2009-06-29 16:08:49 macan>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "svfs.h"

/**
 * lookup:
 *
 * find the llfs dentry, return NULL if succeed
 */
struct dentry *svfs_relay_ext4_lookup(struct inode *inode)
{
    struct svfs_inode *si = SVFS_I(inode);
    
    svfs_info(mdc, "relay lookup for ext4, path %s\n",
              si->llfs_md.llfs_pathname);
    return NULL;
}
struct dentry *svfs_relay_ext3_lookup(struct inode *inode)
{
    struct svfs_inode *si = SVFS_I(inode);
    
    svfs_info(mdc, "relay lookup for ext3, path %s\n",
              si->llfs_md.llfs_pathname);
    return NULL;
}
struct dentry *svfs_relay_nfs4_lookup(struct inode *inode)
{
    struct svfs_inode *si = SVFS_I(inode);
    
    svfs_info(mdc, "relay lookup for nfs4, path %s\n",
              si->llfs_md.llfs_pathname);
    return NULL;
}

