#include "Mutex.h"

namespace System
{
	namespace Threading
	{
		//////////////////////////////////////////////////////////////////////
		Mutex::Mutex(void)
		//////////////////////////////////////////////////////////////////////
		{
#ifdef WIN32
			InitializeCriticalSection( &m_oMutex );
#else
			pthread_mutex_init( &m_oMutex, NULL );
#endif
		}

		//////////////////////////////////////////////////////////////////////
		Mutex::~Mutex(void)
		//////////////////////////////////////////////////////////////////////
		{
#ifdef WIN32
			DeleteCriticalSection( &m_oMutex ); 
#else
			pthread_mutex_destroy ( &m_oMutex );
#endif
		}

		//////////////////////////////////////////////////////////////////////
		void Mutex::Acquire ( )
		//////////////////////////////////////////////////////////////////////
		{
#ifdef WIN32
			EnterCriticalSection ( &m_oMutex );
#else
			pthread_mutex_lock ( &m_oMutex );		
#endif
		}

		//////////////////////////////////////////////////////////////////////
		void Mutex::Release ( ) 
		//////////////////////////////////////////////////////////////////////
		{
#ifdef WIN32
			LeaveCriticalSection ( &m_oMutex );
#else
			pthread_mutex_unlock ( &m_oMutex );
#endif
		}
	}
}
