#ifndef DEVICE_OPS_H
#define DEVICE_OPS_H

#include <limits.h>
#include <stdint.h>

#include "proc_spec.h"

/* these all return 0/-1 and print their own errors */

int	drop_cache();

/* args can be the same buffers */
int	mountpoint_to_device(const char *, char[PATH_MAX]);
int	path_to_mountpoint(const char *, char[PATH_MAX]);
/* returns hda or sda */
int	get_scheduler_device(const char *path, char device[16]);

/* NOT all-or-nothing; if it fails to set only a portion of the devices, it
 * does not go back and restore their readahead values */
int	set_all_readahead(const struct proc_spec *, uint16_t count,
	    uint16_t val);

inline int
	set_readahead(const struct proc_spec *, uint16_t val);
int	set_readahead_path(const char *dev, uint16_t val);

int	set_scheduler(const char *device, const char *scheduler);



inline int
set_readahead(const struct proc_spec *spec, uint16_t val)
{	return set_readahead_path(spec->path_device, val); }

#endif
