#ifndef IOPRIO_H
#define IOPRIO_H

#include <asm/unistd.h>
#include <unistd.h>

enum {
	IOPRIO_CLASS_RT=1,
	IOPRIO_CLASS_BE,
	IOPRIO_CLASS_IDLE
};

/* 'which' argument */
enum {
	IOPRIO_WHO_PROCESS=1,
	IOPRIO_WHO_PGRP,
	IOPRIO_WHO_USER
};

static inline int	IOPRIO_PRIO_VALUE(int class_, int data);
static inline int	IOPRIO_PRIO_CLASS(int mask);
static inline int	IOPRIO_PRIO_DATA(int mask);

static inline int	ioprio_get(int which, int who);
static inline int	ioprio_set(int which, int who, int ioprio);


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


static inline int
ioprio_get(int which, int who)
{
	return syscall(__NR_ioprio_get, which, who);
}

static inline int
ioprio_set(int which, int who, int ioprio)
{
	return syscall(__NR_ioprio_set, which, who, ioprio);
}

static inline int IOPRIO_PRIO_VALUE(int class_, int data)
{
	return ((class_ & 3) << 13) | (data & 0x1fff);
}

static inline int IOPRIO_PRIO_CLASS(int mask)
{
	return (mask >> 13) & 3;
}

static inline int IOPRIO_PRIO_DATA(int mask)
{
	return mask & 0x1fff;
}

#endif
