#!/bin/sh

BASE=base
SCALED=scaled
UNI=singlecore
TWOPROCS=twoprocs

function checkdir {
	if [ ! -d "$1" ]; then
		cat >&2 <<EOF
$0: directory \`$1' does not exist; aborting
(run commands in \`my_tests.txt' for the tests to run)
EOF
		exit 1
	fi
}

# prefix command with `need' to abort on error
function need {
	"$@"
	if [ $? != 0 ]; then
		echo "$0: aborting" >&2
		exit 1
	fi
}

checkdir "$BASE/procs-anti"
checkdir "$BASE/procs-cfq"
checkdir "$UNI/procs-cfq"

# 4-up comparison (4-core, 1-core) X (anticipatory, CFQ)
#need ./simplify_frontend -i -P "$BASE"/sym-anti/00
#need ./simplify_frontend -i -P "$BASE"/sym-cfq/00
#need ./simplify_frontend -i -P "$UNI"/sym-anti/00
#need ./simplify_frontend -i -P "$UNI"/sym-cfq/00
#need ./graph_timeline -fpng -feps -r0,3 "$BASE" sym-anti/00
#need ./graph_timeline -fpng -feps -r0,3 "$BASE" sym-cfq/00
#need ./graph_timeline -fpng -feps -r0,3 "$UNI" sym-anti/00
#need ./graph_timeline -fpng -feps -r0,3 "$UNI" sym-cfq/00

need ./simplify_frontend -i -P "$BASE"/procs-anti/02
need ./simplify_frontend -i -P "$BASE"/procs-anti/03
need ./simplify_frontend -i -P "$BASE"/procs-cfq/02
need ./simplify_frontend -i -P "$BASE"/procs-cfq/03
need ./simplify_frontend -i -P "$UNI"/procs-cfq/02
need ./simplify_frontend -i -P "$UNI"/procs-cfq/03
need ./simplify_frontend -i -P "$BASE"/procs-anti/08
need ./simplify_frontend -i -P "$BASE"/procs-cfq/08
need ./graph_timeline -fpng -feps -r0,3 "$BASE" procs-anti/02
need ./graph_timeline -fpng -feps -r0,3 "$BASE" procs-anti/03
need ./graph_timeline -fpng -feps -r0,3 "$BASE" procs-cfq/02
need ./graph_timeline -fpng -feps -r0,3 "$BASE" procs-cfq/03
need ./graph_timeline -fpng -feps -r0,3 "$UNI" procs-cfq/02
need ./graph_timeline -fpng -feps -r0,3 "$UNI" procs-cfq/03
need ./graph_timeline -fpng -feps -r0,3 "$BASE" procs-anti/08
need ./graph_timeline -fpng -feps -r0,3 "$BASE" procs-cfq/08

exit 0
