#include <mikoOS/kernel.h>
#include <mikoOS/arch/x86/descriptor_common.h>
#include "interrupt_handler.h"

struct handler_define  handler_info[HANDLER_INFO_NUM] = {
	{ (u_int32_t) isr_gate0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate1, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate2, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate3, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate4, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate5, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate6, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate7, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate8, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate9, SEL_KERN_CS, GATE_TYPE_INTR_GATE },  // 10
	{ (u_int32_t) isr_gate10, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate11, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate12, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate13, SEL_KERN_CS, GATE_TYPE_TRAP_GATE },
	{ (u_int32_t) isr_gate14, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate15, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate16, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate17, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate18, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate19, SEL_KERN_CS, GATE_TYPE_INTR_GATE },  // 20
	{ (u_int32_t) isr_gate20, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate21, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate22, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate23, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate24, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate25, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate26, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate27, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate28, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate29, SEL_KERN_CS, GATE_TYPE_INTR_GATE },  // 30
	{ (u_int32_t) isr_gate30, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) isr_gate31, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate1, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate2, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate3, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate4, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate5, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate6, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate7, SEL_KERN_CS, GATE_TYPE_INTR_GATE },  // 40
	{ (u_int32_t) irq_gate8, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate9, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate10, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate11, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate12, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate13, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate14, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) irq_gate15, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 50
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 60
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 70
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 80
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 90
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 100
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 110
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 120
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) soft_intr_handler, SEL_KERN_CS, GATE_TYPE_INTR_GATE },
	{ (u_int32_t) 0, SEL_KERN_CS, GATE_TYPE_INTR_GATE }, // 130
};
