	  
	     __             __                      __            _           
	    / /___  _______/ /_  ____        ____  / /_  ______ _(_)___  _____
	   / __/ / / / ___/ __ \/ __ \______/ __ \/ / / / / __ `/ / __ \/ ___/
	  / /_/ /_/ / /__/ / / / /_/ /_____/ /_/ / / /_/ / /_/ / / / / (__  ) 
	  \__/\__, /\___/_/ /_/\____/     / .___/_/\__,_/\__, /_/_/ /_/____/  
	     /____/                      /_/            /____/                
	  

transcode plugins ported to frei0r
==================================


What tycho-plugins is 
---------------------

tycho-plugins is a porting of the [transcode](http://tcforge.berlios.de),
[mirror here](http://bitbucket.org/france/xtranscode) filter set to the,
[frei0r](http://frei0r.dyne.org) API.

The porting is not always a straightfowarded process.
The preferred colorspace used by transcode is YUV420P (planar YUV 4:2:0),
while frei0r uses only packed colorspaces.
Sometimes, a port/adaptation of the transcode filters to a packed (RGBA)
colorspace is easy, sometimes is not.
Sometimes it requires a complete rewrite of the filter.

As short-to-mid term solution, each colorspace-mismatching filter
performs a two-phase internal conversion using the (bundled)
optimized transcode's routines (see the libac/ subdirectory).

While suboptimal, this method is already used by some of the frei0r filters.
The long term solution will of course to rewrite the interested filter.

However, given that the YUV planar colorspace are highly used in
the video processing, tycho-plugins also provides an extension to
frei0r to cope with that scenario. Such extension is frei0rx.

The extension is described in README.frei0rx.md.


Development Status
------------------

Highly experimental. Highly volatile. Less than alpha.


Filter set Taxonomy
-------------------

vanilla filters (video, using the vanilla frei0r interface)

* detectclipping: detect black regions on top, bottom, left and right of an image.
* dnr: dynamic noise reduction on video frames.
* facemask: mask people faces in video interviews.
* mask: filter through a rectangular mask.
* msharpen: spatial sharpening optimized for cartoons.
* xsharpen: port of VirtualDub's XSharpen filter.
* denoise3d: 3d video denoiser.


extended compatible video filters (using the frei0rx interface, backward compatible)

* deshake: one-pass stabilization filter for jiggled videos.
* stabilize: two-pass stabilization filter preprocessor.
* transform: two-pass stabilization filter engine, using the `stabilize` data.


extended audio filters (using the frei0rx interface)

* acopychannel: copy an audio channel into another one.
* astat: simple audio statistics.
* adetectsilence: detect silence intervals in audio track.


extended video filters (using the frei0rx interface)

* levels: luminosity level scaler.
* hqdn3d: port of mplayer's hqdn3d filter.
* barrel: apply/remove barrel distortion.


extended video filters (using the frei0rx interface, with extra dependencies)

* compare (GraphicsMagick): compare frames with a pattern.
* logo (GraphicsMagick): draws a logo in the frames.
* logoaway (GraphicsMagick): removes an image in a user specified area.


Build dependencies 
-------------------

Mandatory Requirements

* C99 toolchain (tested against gcc 4+ on linux x86-64).
* [cmake](http://www.cmake.org)

Optional Dependencies

* [GraphicsMagick](http://www.graphicsmagick.org)


Installation
------------

WRITEME


API explanation 
---------------

See README.frei0rx.md and/or the frei0rx.h header file and the
accompaining documentation.


Acknowledgments 
---------------

* all the original filter Authors.
  See each filter's source for the details and the author name.
* Andrew Church for the countless hours and the code (most notably aclib/libac)
  spent on transcode.


ChangeLog
----------

Not until 1.0.0 released! :)


TODO (not in any particular order)
----------------------------------

* avoid symbol pollution.
* proper format check in the X filters.
* colorspace conversion in X filters.
* real logging?
* Fill the WRITEMEs and the FIXMEs.
* frei0r compat layer.
* Implement the `f0rx_is_ready` API.
* Cleanup f0rx_frame.
* Consistency check (Style).
* Cleanup the header mess.

EOF

