/*  NEWPLUGIN.c
 *  (C) 2012-2014 Francesco Romani (fromani a gmail d com)
 */


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "frei0rx.h"
#include "frei0rx_param.h"
#include "frei0rx_compat.h"

enum {
    PLUGIN_PARAM_NUM = 2
};

typedef struct NEWPLUGINinstance_ {
    f0rx_param_attr_t attrs[PLUGIN_PARAM_NUM];
    // TODO
} NEWPLUGIN_instance_t;

#define RETURN_IF_NULL(inst) do { \
    if (!(inst)) { \
        return; \
    } \
} while (0)

#define RETURN_ERROR_IF_NULL(INST) do { \
    if (!(INST)) { \
        return -1; \
    } \
} while (0)


enum {
    RGB_BYTES             = 3, /* how much storage a pixel take? */
    RGBA_BYTES            = 4, /* ditto */
    PIXEL_BLACK_THRESHOLD = 24
};

// TODO

int f0r_init()
{
    /* no initialization required */
    return 1;
}

void f0r_deinit()
{
    /* no initialization required */
    return;
}

void f0r_get_plugin_info(f0r_plugin_info_t* info)
{
    info->name = "NEWPLUGIN";
    info->author = "XXX TODO";
    info->plugin_type = F0R_PLUGIN_TYPE_FILTER;
    info->color_model = F0R_COLOR_MODEL_RGBA8888;
    info->frei0r_version = FREI0R_MAJOR_VERSION;
    info->major_version = 0;
    info->minor_version = 1;
    info->num_params =  PLUGIN_PARAM_NUM;
    info->explanation = ""
"";
}

void f0rx_get_plugin_info(f0rx_plugin_info_t* info)
{
    f0r_get_plugin_info(&(info->base));
    info->content_type = F0RX_CONTENT_TYPE_VIDEO;
    info->sample_model = 0;
    info->channel_layout = 0;
}


void f0r_get_param_info(f0r_param_info_t* info, int param_index)
{
    switch (param_index) {
      case 0:
        info->name = "Start";
        info->type = F0R_PARAM_DOUBLE;
        info->explanation = "The first frame to consider.";
        break;
      case 1:
        info->name = "End";
        info->type = F0R_PARAM_DOUBLE;
        info->explanation = "The last frame to consider.";
        break;
      case 2:
        info->name = "Step";
        info->type = F0R_PARAM_DOUBLE;
        info->explanation = "Apply the check every `Step' frames.";
        break;
      case 3:
        info->name = "Limit";
        info->type = F0R_PARAM_DOUBLE;
        info->explanation = "The sum of a line must be below this"
                            " limit to be considered black.";
        break;
      case 4:
        info->name = "Log path";
        info->type = F0R_PARAM_STRING;
        info->explanation = "File to save a detailed values";
        break;
      default:
        break; // XXX
    }
    return;
}

static f0rx_param_attr_t *f0rx_get_param_attr(f0r_instance_t instance,
                                              int param_index)
{
    NEWPLUGIN_instance_t* inst = (NEWPLUGIN_instance_t*)instance;
    return &inst->attrs[param_index];
}


f0r_instance_t f0rx_construct(int format, f0r_param_t *params,
                              unsigned int value1, unsigned int value2)
{
    NEWPLUGIN_instance_t* inst = tc_zalloc(sizeof(*inst));
    if (inst) {
        // TODO
    }
    return (f0r_instance_t)inst;
}

f0r_instance_t f0r_construct(unsigned int width, unsigned int height)
{
    return f0rx_construct(F0R_COLOR_MODEL_RGBA8888, NULL, width, height);
}


void f0r_destruct(f0r_instance_t instance)
{
    NEWPLUGIN_instance_t* inst = (NEWPLUGIN_instance_t*)instance;
    RETURN_IF_NULL(inst);
    // TODO
    free(instance);
    return;
}

int f0rx_set_params_values(f0r_instance_t instance,
                           f0r_param_t *params)
{
    return 0;
}

int f0rx_is_ready(f0r_instance_t instance, int param_index)
{
    return 1;
}

int f0rx_update(f0r_instance_t instance,
                double intime,
                const uint32_t *inframe1,
                const uint32_t *inframe2,
                const uint32_t *inframe3,
                double *outtime,
                uint32_t *outframe)
{
    return -1;
}

/*
 * vim: expandtab shiftwidth=4:
 */

