
#ifndef INCLUDED_FREI0RX_PARAMEXT_H
#define INCLUDED_FREI0RX_PARAMEXT_H

#include "frei0rx_param.h"

static void f0rx_param_getter_remap_int(f0r_instance_t instance,
                                        int param_index,
                                        f0r_param_t param)
{
    f0rx_param_attr_t *attr = f0rx_get_param_attr(instance, param_index);
    f0r_param_info_t info;

    f0r_get_param_info(&info, param_index);
    switch (info.type) {
      case F0R_PARAM_BOOL:
        *((f0r_param_bool*)param) = *((int*)attr->field);
        break;
      case F0R_PARAM_DOUBLE:
        *((f0r_param_double*)param) = *((int*)attr->field);
        break;
      default:
        f0rx_param_getter(instance, param_index, param);
        break;
    }
    return;
}

static void f0rx_param_setter_remap_int(f0r_instance_t instance,
                                        int param_index,
                                        const f0r_param_t param)
{
    f0rx_param_attr_t *attr = f0rx_get_param_attr(instance, param_index);
    f0r_param_info_t info;

    f0r_get_param_info(&info, param_index);
    switch (info.type) {
      case F0R_PARAM_BOOL:
        *((int*)attr->field) = *((f0r_param_bool*)param);
        break;
      case F0R_PARAM_DOUBLE:
        *((int*)attr->field) = *((f0r_param_double*)param);
        break;
      default:
        f0rx_param_setter(instance, param_index, param);
        break;
    }
    return;
}

/*************************************************************************/

static void f0rx_bind_param_attr_remap_int(f0r_instance_t instance,
                                           int param_index,
                                           void *field)
{
    f0rx_param_attr_t *attr = f0rx_get_param_attr(instance, param_index);
    f0rx_bind_param_attr(instance, param_index, field);
    /* to make gcc quiet(er) */
    attr->get = f0rx_param_getter_remap_int;
    attr->set = f0rx_param_setter_remap_int;
}

#endif /* INCLUDED_FREI0RX_PARAMEXT_H */

