/*
 *  memutils.h - memory handling helpers functions for transcode (interface)
 *  Written by Thomas Oestreich, Francesco Romani, Andrew Church, and others
 *  compatibility layer over libc functions.
 *
 *  This file is part of transcode, a video stream processing tool.
 *  transcode is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  transcode is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef MEMUTILS_COMPAT_H
#define MEMUTILS_COMPAT_H

#include <stdlib.h>
#include <stdint.h>

/*************************************************************************/

#define tc_malloc(size)    malloc(size)
#define tc_zalloc(size)    calloc(1, size)
#define tc_realloc(p,size) realloc(p, size)
#define tc_free(ptr)       free(ptr)

#endif  /* MEMUTILS_COMPAT_H */

