/*****************************************************************************
* Odense University College of Enginerring
* Embedded C Programming (ECP)
*
* MODULENAME.: cpu.h
*
* PROJECT....: ECP
*
* DESCRIPTION:
*
* Change Log:
******************************************************************************
* Date    Id    Change
* YYMMDD
* --------------------
* 050128  KA    Module created.
*
*****************************************************************************/

#ifndef _CPU_H
  #define _CPU_H

/***************************** Include files *******************************/
#include "../inc/emp_type.h"
/*****************************    Defines    *******************************/
#define FCPU					50000000

/*****************************   Constants   *******************************/

/*****************************   Functions   *******************************/

void cpu_idle();
/*****************************************************************************
*   Function : Call when leaving a task.
*****************************************************************************/

void cpu_busy();
/*****************************************************************************
*   Function : Call when enetering a task.
*****************************************************************************/

void cpu_setup_measure_led();
/*****************************************************************************
*   Function : Sets up the red LED for showing CPU load.
*****************************************************************************/

void clk_system_init();
/*****************************************************************************
*   Input    : 	-
*   Function : Set the system clock to 50 Mhz.
*****************************************************************************/

void enable_global_int();
/*****************************************************************************
*   Input    : 	-
*   Output   : 	-
*   Function : Enable global interrupt
*****************************************************************************/

void disable_global_int();
/*****************************************************************************
*   Input    : 	-
*   Output   : 	-
*   Function : Disable global interrupt
*****************************************************************************/


/****************************** End Of Module *******************************/
#endif
