/*****************************************************************************
* Odense University College of Enginerring
* Embedded C Programming (ECP)
*
* MODULENAME.: joystick.h
*
* PROJECT....: ECP
*
* DESCRIPTION:
*
* Change Log:
******************************************************************************
* Date    Id    Change
* YYMMDD
* --------------------
* 050128  NS    Module created.
*
*****************************************************************************/

#ifndef _JOYSTICK_H
  #define _JOYSTICK_H

/***************************** Include files *******************************/
#include "../inc/emp_type.h"
/*****************************    Defines    *******************************/

/*****************************   Constants   *******************************/

/*****************************   Functions   *******************************/

INT16U get_x_target_pos( void );
/*****************************************************************************
*   Function : Returns the x-axis position in the virtual space.
*****************************************************************************/

INT16U get_y_target_pos( void );
/*****************************************************************************
*   Function : Returns the y-axis position in the virtual space.
*****************************************************************************/

void joystick_task();
/*****************************************************************************
*   Function : Joystick task.
*****************************************************************************/

void init_joystick();
/*****************************************************************************
*   Function : Sets up the ADCs for the joystick.
*****************************************************************************/

/****************************** End Of Module *******************************/
#endif
