/*****************************************************************************
* Odense University College of Enginerring
* Embedded C Programming (ECP)
*
* MODULENAME.: led.h
*
* PROJECT....: ECP
*
* DESCRIPTION:
*
* Change Log:
******************************************************************************
* Date    Id    Change
* YYMMDD
* --------------------
* 050128  NS    Module created.
*
*****************************************************************************/

#ifndef _SPI_H
  #define _SPI_H

/***************************** Include files *******************************/
#include "../inc/emp_type.h"
/*****************************    Defines    *******************************/

/*****************************   Constants   *******************************/

/*****************************   Functions   *******************************/

void spi_receive_task( void );
/*****************************************************************************
*   Function : Moves received SPI packages from the FIFO to the queue.
*****************************************************************************/

void spi_send_task( void );
/*****************************************************************************
*   Function : Sends packages from the queue.
*****************************************************************************/

void spi_enable( void );
/*****************************************************************************
*   Function : Enables SPI.
*****************************************************************************/

void spi_disable( void );
/*****************************************************************************
*   Function : Disables SPI.
*****************************************************************************/

void init_spi();
/*****************************************************************************
*   Function : Sets up the SPI.
*****************************************************************************/

/****************************** End Of Module *******************************/
#endif
