//
//  Copyright (C) 17-02-2012 Jasper den Ouden.
//
//  This is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//

//Just some stuff helping to initialize and get rid of stuff.

#pragma once

#include <stdlib.h>

enum{ StackCom_flag_reset_funs=1, StackCom_flag_reset_defs=2 };

//Init stackcom, providing all pointers.
StackCom* StackCom_init_ptr (StackCom* sc, 
			     int* stack, int max_stack_len,
			     StackFun* funs, int funs_max_cnt,
			     byte** defs,  int defs_max_cnt,
			     int* arr, int arr_len, byte* idefs,
			     unsigned flags)
{
  sc->stack_len=0; sc->max_stack_len= max_stack_len; sc->stack= stack;
  sc->funs_cnt=0;  sc->funs_max_cnt= funs_max_cnt;   sc->funs= funs;
  sc->defs_max_cnt= defs_max_cnt;   sc->defs= defs;
  sc->arr= arr;    sc->arr_len= arr_len;
  sc->idefs= idefs;
  if( flags & StackCom_flag_reset_funs )
    { for( int i=0 ; i< sc->funs_max_cnt ; i++ ){ sc->funs[i]=NULL; } }
  if( flags & StackCom_flag_reset_defs )
    { for( int i=0 ; i< sc->defs_max_cnt ; i++ ){ sc->defs[i]=NULL; } }
  return sc;
}
//This init also allocates. Can free again with `StackCom_free_stuff`.
StackCom* StackCom_init
   (StackCom* sc, 
    int max_stack_len,int funs_max_cnt,int defs_max_cnt,int arr_len)
{ return StackCom_init_ptr
    (sc, (int*)malloc(sizeof(int)*max_stack_len),max_stack_len,
         (StackFun*)malloc(sizeof(StackFun)*funs_max_cnt),funs_max_cnt,
         (byte**)malloc(sizeof(byte*)*defs_max_cnt),defs_max_cnt,
         (int*)malloc(sizeof(int)*arr_len), arr_len,
         NULL, StackCom_flag_reset_funs | StackCom_flag_reset_defs);
}
//Frees the arrays and stuff in them if applicable. 
StackCom* StackCom_free_stuff(StackCom* sc)
{
  free(sc->stack); free(sc->arr); free(sc->funs); 
  for( int i=0 ; i<sc->defs_max_cnt ; i++ )
    { if( sc->defs[i]!=NULL ){ free(sc->defs[i]); } }
  free(sc->defs);free(sc->idefs);
}
