//
//  Copyright (C) 13-02-2012 Jasper den Ouden.
//
//  This is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//

#pragma once

typedef unsigned char byte;

enum //Inbuilds.
  { ib_add=0, ib_sub=1, ib_mult=2, ib_div=3, ib_mod=4, //Integer ops.
    ib_l=5,ib_le=6, ib_g=7,ib_ge=8,
    ib_min= 9, ib_max= 49,
  //Float ops. (Same ones)
    ib_add_f=11, ib_sub_f=12, ib_mult_f=13, ib_div_f=14, ib_mod_f=15, 
    ib_l_f=16,ib_le_f=17, ib_g_f=18,ib_ge_f=19,
    ib_min_f= 20, ib_max_f= 21,
  //Conversion.
    ib_to_float=22, ib_to_int=23,
  //Bit operations and `and`.
    ib_left_shift= 24, ib_right_shift=25, ib_bit_not=26,
    ib_bit_and=27,ib_bit_or=28,
    ib_and=29,
  //`dup`-n-stuff.
    ib_dup=30,ib_drop=31,ib_swap=32,ib_over=33,ib_rot=34, 
    ib_when=35,
  //Arrays.
    ib_get_index=36, ib_set_index=37,
  //Definitions.
    ib_usedef=38, ib_def=39,ib_enddef=40,
    ib_iuse=41,
  //'Long' reference to function.
    ib_fun= 42,ib_fun_ptr= 43,
  //Indicators a float/int is coming. (TODO indicate 2,3,4,5,6 coming?)
    ib_float=44,
    ib_int=45,ib_int2=46,ib_int3=47,ib_int4=48,
  //End marker.
    ib_endstop=10 //Swapped with 49 (10 is newline)

  //Pointer-based functions
    //    ib_fun_i,ib_fun_f, //Stack handled for it.
    //    ib_fun_ii,ib_fun_ff,ib_fun_if */
  };

#define inbuild_cnt 50

//TODO working on the stack is nice, but perhaps we want some to work on
// the code aswell.
typedef int (*StackFun)(int*,void*);

typedef struct
{
  int stack_len, max_stack_len;
  int* stack;

  int arr_len;
  int* arr;
  
  int funs_cnt,funs_max_cnt;
  StackFun* funs;

  int defs_max_cnt;
  byte** defs;
  
  byte* idefs; //'Hard coded definitions.' 
  
  //Stack stuff is 'denoted backward!!'
} StackCom;

enum{ eval_success=0, eval_stack_underflow=-1, eval_stack_overflow=-2,
      eval_incorrect_access=-3, eval_definition_overflow=-4 };
 
#include "StackCom.c"

