//
//  Copyright (C) 16-02-2012 Jasper den Ouden.
//
//  This is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//

#include <stdio.h>
#include <assert.h>

#include "../stack-eval.c"
#include "../code-receiver.c"

#include "../array-namer.c" //Just here for the `StackCom_stack_print`
#include "../stack-client.c" 

#define receive_buf_len 256

//#define _max_code_len 256
#define _max_stack_len 256
#define _arr_len 256

#define _max_fun_cnt 256
#define _max_def_cnt 256

int main()
{ 
//Receiver.
  byte received[receive_buf_len]; //Directly used as code.
  CodeReceiver cr; CodeReceiver_init_ptr(&cr, receive_buf_len, received);
//Evaluator. Note that the receiver handles the code ammount.
  int stack[_max_stack_len],arr[_arr_len]; StackFun funs[_max_fun_cnt]; 
  byte* defs[_max_def_cnt];
  StackCom sc;
  StackCom_init_ptr(&sc, stack,_max_stack_len, funs, _max_fun_cnt, 
		    defs, _max_def_cnt, arr, _arr_len, NULL,
		    StackCom_flag_reset_funs | StackCom_flag_reset_defs);
  
  while( !feof(stdin) && !ferror(stdin) )
    { byte got; 
      int read_len= fread((void*)&got, 1,1, stdin);
      if( read_len==0 ){ return 0; }
      assert( read_len==1 );
      CodeReceiver_receive_1(&cr, got); //Receive the byte.
      if( CodeReceiver_feed_eval(&cr, &sc, NULL) != 1 ) //Evaluate if needed.
	{ StackCom_stack_print(&sc,stdout); printf("\n"); }//Print results.
    }
}
