//
//  Copyright (C) 4-03-2012 Jasper den Ouden.
//
//  This is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//

#pragma once

#include "stack-eval.c"

#define var_define_character '$'
#define var_macro_character '%'
#define code_repl_tmp_name_len 256
//Read(parse)-eval loop... step.
void code_repl(ClientNamer* cn, FILE* stream, byte* code, int* lenv)
{
  int got= fgetc(stream);
//Check characters for definition beginnings.
  if( got== var_define_character || got== var_macro_character )
    { char name[code_repl_tmp_name_len];
      fscanf(stream,"%s",name); //Read name.
      int len= INT_MAX;
    //This one sends a definition to the evaller and defines a 'caller-macro'.
    //TODO one that automatically chooses between variable and macro.
      if( got== var_define_character )
	{//Go ahead two so we can stick stuff in front.
	  code_parse(cn, stream, code+2, &len, "\n"); 
        //Add _caller_ "`{ib_usedef, def_n}`" to client side.
	  int def_n= ClientNamer_name_def(cn,name);
       //Set `code` such as to send to to evaller side.
	  code[0]= ib_def; code[1]= def_n; /*..code..*/ 
	  code[len+2]= ib_enddef;
	  *lenv= len+3;
	  return;
	}
      if( got== var_macro_character )
	{ code_parse(cn, stream, code, &len, "\n"); //Just add the definition.
	  ClientNamer_name_code(cn, name, code,len); 
	  *lenv=0; //With macros, nothing is send to evaller side.
	  return;
	}
      assert(0); return;
    }
  //Just an expression.
  ungetc(got,stream); 
  code_parse(cn, stream, code, lenv, "\n");
}

typedef struct //State that can be passed to StackFun void* argument.
{ ClientNamer* cn;
  StackCom* sc;
  void* other;
} ReplPass;

//Functions to control/get repl info.
int ClientNamer_print_macros_stackfun(int* stack, void* data)
{ ReplPass* repl= (ReplPass*)data;
  if( repl->cn!=NULL ){ ClientNamer_print_macros(repl->cn, stdout); }
  else{ printf("Nothing named; No client namer.\n"); }
  return 0;
}

void ReplPass_add_fun(ReplPass* r, char* name, StackFun fun, int pos)
{ StackCom_add_fun(r->sc, fun,pos); //Prints 
  ClientNamer_name_fun(r->cn, name, pos);
}

ReplPass* ReplPass_init(ReplPass* r, ClientNamer* cn, StackCom* sc, void* other)
{ r->cn = cn; r->sc = sc; r->other= other;
  int pos=0;
  ReplPass_add_fun(r,"print_macros", ClientNamer_print_macros_stackfun, pos++);
  return r;
}

