#pragma config(Motor,  port1,           fLeft,         tmotorVex393, openLoop)
#pragma config(Motor,  port2,           bLeft,         tmotorVex393, openLoop)
#pragma config(Motor,  port3,           atLeft,        tmotorVex269, openLoop)
#pragma config(Motor,  port4,           abLeft,        tmotorVex269, openLoop, reversed)
#pragma config(Motor,  port5,           rollersLeft,   tmotorVex269, openLoop)
#pragma config(Motor,  port6,           fRight,        tmotorVex393, openLoop, reversed)
#pragma config(Motor,  port7,           bRight,        tmotorVex393, openLoop, reversed)
#pragma config(Motor,  port8,           atRight,       tmotorVex269, openLoop)
#pragma config(Motor,  port9,           abRight,       tmotorVex269, openLoop, reversed)
#pragma config(Motor,  port10,          rollersRight,  tmotorVex269, openLoop, reversed)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

#include "pid.cpp"
#pragma platform(VEX)

//Competition Control and Duration Settings
#pragma competitionControl(Competition)
#pragma autonomousDuration(20)
#pragma userControlDuration(120)

#include "Vex_Competition_Includes.c"   //Main competition background code...do not modify!
const float circumference = 12.6;
const int encoderCounts = 360;

int distanceToCounts(float distance)
{
		int counts = distance / circumference * encoderCounts;
		return counts;
}
void motorUnity (int group, int power)
{
		if (abs (power) <= 10) //threshold
		{
			power=0;
		}
		switch(group)
		{
			case 0: //Left Drive
				motor[fLeft] = power;
				motor[bLeft] = power;
				break;
			case 1: //Right Drive
				motor[fRight] = power;
				motor[bRight] = power;
				break;
			case 2: //Arm
				motor[atLeft] = power;
				motor[abLeft] = power;
				motor[atRight] = power;
				motor[abRight] = power;
				break;
			case 3: //Rollers
				motor[rollersLeft] = power;
				motor[rollersRight] = power;
				break;
		}
}


/////////////////////////////////////////////////////////////////////////////////////////
//
//                          Pre-Autonomous Functions
//
// You may want to perform some actions before the competition starts. Do them in the
// following function.
//
/////////////////////////////////////////////////////////////////////////////////////////

void pre_auton()
{
  // Set bStopTasksBetweenModes to false if you want to keep user created tasks running between
  // Autonomous and Tele-Op modes. You will need to manage all user created tasks if set to false.
  bStopTasksBetweenModes = true;

	// All activities that occur before the competition starts
	// Example: clearing encoders, setting servo positions, ...
}

/////////////////////////////////////////////////////////////////////////////////////////
//
//                                 Autonomous Task
//
// This task is used to control your robot during the autonomous phase of a VEX Competition.
// You must modify the code to add your own robot specific commands here.
//
/////////////////////////////////////////////////////////////////////////////////////////

task autonomous()
{
  // .....................................................................................
  // Insert user code here.
  // .....................................................................................

	AutonomousCodePlaceholderForTesting();  // Remove this function call once you have "real" code.
}

/////////////////////////////////////////////////////////////////////////////////////////
//
//                                 User Control Task
//
// This task is used to control your robot during the user control phase of a VEX Competition.
// You must modify the code to add your own robot specific commands here.
//
/////////////////////////////////////////////////////////////////////////////////////////

task usercontrol()
{
	// User control code here, inside the loop

	while (true)
	{
		motorUnity (0,vexRT[Ch3]); //Left
		motorUnity (1,vexRT[Ch2]); //Right
	 	motorUnity (2,vexRT[Ch3Xmtr2]); //Arm
	  	motorUnity (3,vexRT[Ch2Xmtr2]); //Rollers

	  // This is the main execution loop for the user control program. Each time through the loop
	  // your program should update motor + servo values based on feedback from the joysticks.

	  // .....................................................................................
	  // Insert user code here. This is where you use the joystick values to update your motors, etc.
	  // .....................................................................................

	 	//UserControlCodePlaceholderForTesting(); // Remove this function call once you have "real" code.

	}
}
