/**
 *  @file getopt.h
 *  @brief Implementation of POSIX getopt (not only) for Windows.
 *
 *  @note Copyright Přemysl Janouch 2007 - 2008. All rights reserved.
 *  @note See the file LICENSE for licensing information.
 *
 */

#ifndef __GETOPT_H__
#define __GETOPT_H__


/** Points to the argument. */
extern char *optarg;

/** Option character. */
extern int optopt;

/** Index of the next argument to be processed. */
extern int optind;

/** Set to zero if you don't want getopt to print messages. */
extern int opterr;

/** POSIX getopt implementation.
 *  Gets command-line options from the argv array.
 *  @param[in] argc  The argument count value from @em main
 *  @param[in] argv  The argument string array from @em main
 *  @param[in] commands  A list of possible commands (see POSIX documentation).
 *  @return See POSIX documentation.
 */
int getopt (int argc, char **argv, char *commands);


#endif /* ! __GETOPT_H__ */

