/**
 *  @file xalloc.c
 *  @brief Defines the xalloc_die function.
 *
 *  Copyright Přemysl Janouch 2010. All rights reserved.
 *  See the file LICENSE for licensing information.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

#include <xtnd/xtnd.h>
#include <xtndprivate.h>


void (*g_xtndDie) (const char *) = xtndXallocDie;

void xtndXallocDie (const char *fun)
{
	fprintf (stderr, _("Error: %s: %s\n"), fun, strerror (errno));
	exit (EXIT_FAILURE);
}

char *xstrdup (const char *s)
{
	return strcpy (xmalloc (strlen (s) + 1), s);
}
