/**
 *  @file xtnd.h
 *  @brief Master include file.
 *
 *  @note This file is a part of libxtnd.
 *        Copyright Přemysl Janouch 2011. All rights reserved.
 *  @note See the file LICENSE for licensing information.
 *
 *  @mainpage
 *
 *  libxtnd provides a single master header, which in turn includes
 *  all of the library:
 *
 *  @code
 *  #include <xtnd/xtnd.h>
 *  @endcode
 *
 *  Please proceed to Modules to see what this makes available to you.
 *
 */

#ifndef __XTND_XTND_H__
#define __XTND_XTND_H__

#include <stdio.h>
#include <setjmp.h>

#include <xtndconfig.h>

/** @defgroup ds Data structures */
#include <xtnd/ds/memstream.h>
#include <xtnd/ds/dynarray.h>
#include <xtnd/ds/ptrlist.h>
#include <xtnd/ds/strlist.h>
#include <xtnd/ds/queue.h>
#include <xtnd/ds/btree.h>
#include <xtnd/ds/hmap.h>

/** @defgroup net Network */
#include <xtnd/net/sockets.h>
#include <xtnd/net/socks.h>
#include <xtnd/net/ircproto.h>

/** @defgroup util Utilities */
#include <xtnd/conf.h>
#include <xtnd/getopt.h>
#include <xtnd/macro.h>
#include <xtnd/xalloc.h>
#include <xtnd/csv.h>
#include <xtnd/exception.h>

#endif /* ! __XTND_XTND_H__ */

