/*
 *  Copyright (C) 2012, Robert Tang <opensource@robotang.co.nz>
 *
 *  This is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public Licence
 *  along with this library; if not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GPS_H
#define GPS_H

#include <stdbool.h>

#define GPS_LOGFILE     0

typedef struct
{
    char str[50];
    float time;
    int id;
    bool valid;
    float latitude;
    char latitude_dir;
    float longitude;
    char longitude_dir;
} gps_t;

int gps_init(const char *dev, int baud);
void gps_close(void);
int gps_update(gps_t *gps);

#endif

