//***************************************************************************

// Im Hauptprogramm einfügen:
 
// SPI
 volatile uint8_t						spistatus=0;
 
#define TIMER0_STARTWERT					0x80
#define SPI_BUFSIZE							32

/*

// declared in SPI_slave
extern volatile uint8_t spi_startdaten;				// Startdaten des Slave, bestimmen Art der Daten
extern volatile uint8_t spibuffer[SPI_BUFSIZE];		// Der SPI-buffer, der vom Master ausgelesen werden kann.
extern volatile uint8_t spi_enddaten;					// Enddaten des Slave, Quittung fuer vollstaendige Uebertragung

extern volatile uint8_t in_startdaten;					// Startdaten vom Master, bestimmen Art der Daten
extern volatile uint8_t inbuffer[SPI_BUFSIZE];		// In-Buffer fuer die Daten vom Master
extern volatile uint8_t in_enddaten;					// Enddaten vom Master, Anzeige fuer vollstaendige Uebertragung
*/

#define SPI_DATA_PORT				PORTD // Clock und Data
#define SPI_DATA_PORTPIN			PIND	// Data lesen
#define SPI_DATA_PORTDIR			DDRD	// Data RICHTUNG
#define SPI_CLK_PIN				3
#define SPI_DATA_IO_PIN			4




 // 

// defines fuer webspistatus

#define SEND_SERIE_BIT			0	// unused
#define WRITE_CONFIRM_BIT		1
#define SEND_REQUEST_BIT		2
#define DATA_RECEIVE_BIT		3
#define TWI_WAIT_BIT			4 // stoppt den TWI waehrend status 0
#define SPI_ERR_BIT				5
#define SPI_TALK_BIT				6 // unused
#define SPI_DATA_READY_BIT		7

#define TIMER2_WERT				0xFF

 
// Startwert, auf den Timer0 bei Overflow gesetzt wird. Je hoeher, desto kuerzer ist die Timer-Laufzeit.
// Der Wert wird bei jedem zu ladenden Byte gesetzt. Die ISR raeumt am Schluss auf, wenn etwas schief gegangen ist.

volatile uint8_t timer0startwert=TIMER0_STARTWERT;

volatile uint8_t  webspistatus =0;

// SPI


//**************************************************************************
#include <avr/io.h>
#include "lcd.h"




volatile uint8_t								spi_startdaten;
volatile uint8_t								spibuffer[SPI_BUFSIZE];
volatile uint8_t								spi_enddaten;
volatile uint8_t								spi_hbdaten;
volatile uint8_t								spi_lbdaten;

//extern volatile uint8_t						timer0startwert;

static volatile uint8_t						ByteCounter=0xFF;
volatile uint8_t								errCounter=0;

static volatile uint8_t						ONCounter=0x00;
static volatile uint8_t						OFFCounter=0x00;
static volatile uint8_t						OutCounter=0x00;
static volatile uint8_t						SendOKCounter=0x00;
static volatile uint8_t						SendErrCounter=0x00;
static volatile uint8_t						IncompleteCounter=0x00;

volatile uint8_t								in_startdaten;
volatile uint8_t								inbuffer[SPI_BUFSIZE];
volatile uint8_t								in_enddaten;
volatile uint8_t								in_hbdaten;
volatile uint8_t								in_lbdaten;

volatile uint8_t								complement=0;		//Zweiercomplement


static volatile uint8_t						bitpos=0xFF;
static volatile uint8_t						startbitpos=0;



#define OSZIPORT				PORTC
#define OSZIPORTDDR			DDRC
#define OSZIPORTPIN			PINC
#define PULS					1

#define OSZILO OSZIPORT &= ~(1<<PULS)
#define OSZIHI OSZIPORT |= (1<<PULS)
#define OSZITOG OSZIPORT ^= (1<<PULS)

#define SPI_CONTROL_DDR			DDRD
#define SPI_CONTROL_PORT		PORTD
#define SPI_CONTROL_PORTPIN	PIND

#define SPI_CONTROL_MOSI		PORTD0	// Eingang fuer Daten vom Master
#define SPI_CONTROL_MISO		PORTD1	// Ausgang fuer Daten zum Master
#define SPI_CONTROL_SCK			PORTD2	// INT0 als Eingang fuer CLK
#define SPI_CONTROL_CS_HC		PORTD3	// CS fuer HomeCentral Master

#define SPI_INT0_DDR				DDRD
#define SPI_INT0_PORT			PORTD


// Makros:
#define IS_CS_HC_ACTIVE			SPI_CONTROL_PORTPIN & ~(1<< SPI_CONTROL_CS_HC)	// ist CS fuer HC  LO?



#define SPI_PULSE_DELAY			70 // delay in ns
//#define DATENBREITE			8	// Anzahl Bytes in einer Serie


// defines fuer spistatus
#define ACTIVE_BIT				0
#define STARTDATEN_BIT			1
#define ENDDATEN_BIT				2
#define SUCCESS_BIT				3
#define LB_BIT						4
#define HB_BIT						5
#define ERR_BIT					6

/*
Timer0 fuer Atmega8
void timer0 (void) 
{ 
// Timer fuer Exp
	//TCCR0 |= (1<<CS01);						// clock	/8
	//TCCR0 |= (1<<CS01)|(1<<CS02);			// clock	/64
	TCCR0 |= (1<<CS02);							// clock	/256
	//TCCR0 |= (1<<CS00)|(1<<CS02);			// clock /1024
	
	TIFR |= (1<<TOV0);							//Clear TOV0 Timer/Counter Overflow Flag. clear pending interrupts
	TIMSK |= (1<<TOIE0);							//Overflow Interrupt aktivieren
	TCNT0 = TIMER0_STARTWERT;					//Rücksetzen des Timers
	OSZILO;
}

ISR (OVERFLOW0)
{	
	spistatus &= ~(1<<ACTIVE_BIT);		// Ende der Uebertragung, Bit zuruecksetzen
	spistatus &= ~(1<<STARTDATEN_BIT);	// Ende der Uebertragung, Bit fuer Startdaten sicher zuruecksetzen
	spistatus &= ~(1<<ENDDATEN_BIT);		// Ende der Uebertragung, Bit fuer Enddaten sicher zuruecksetzen

	
	//OSZIHI ;
	TCCR0=0;
	SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
	//lcd_clr_line(1);
	//lcd_gotoxy(10,1);
	//lcd_puts("Tim0\0");
}

*/

// Timer0 fuer Atmega328
void timer0 (void) 
{ 
// Timer fuer Exp
	//TCCR0 |= (1<<CS01);						// clock	/8
	//TCCR0 |= (1<<CS01)|(1<<CS02);			// clock	/64
	TCCR0A |= (1<<CS02);							// clock	/256
	//TCCR0 |= (1<<CS00)|(1<<CS02);			// clock /1024
	
	TIFR0 |= (1<<TOV0);							//Clear TOV0 Timer/Counter Overflow Flag. clear pending interrupts
	TIMSK0 |= (1<<TOIE0);							//Overflow Interrupt aktivieren
	TCNT0 = TIMER0_STARTWERT;					//Rücksetzen des Timers
	//OSZILO;
}





// ISR fuer Atmega328
ISR (TIMER0_OVF_vect)
{	
	spistatus &= ~(1<<ACTIVE_BIT);		// Ende der Uebertragung, Bit zuruecksetzen
	spistatus &= ~(1<<STARTDATEN_BIT);	// Ende der Uebertragung, Bit fuer Startdaten sicher zuruecksetzen
	spistatus &= ~(1<<ENDDATEN_BIT);		// Ende der Uebertragung, Bit fuer Enddaten sicher zuruecksetzen

	
	//OSZIHI ;
	TCCR0A=0;
	SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
	//lcd_clr_line(1);
	//lcd_gotoxy(10,1);
	//lcd_puts("Tim0\0");
}


void InitSPI_Slave(void) 
{ 

	SPI_CONTROL_DDR   |= (1<<SPI_CONTROL_MISO);		// MISO als Output
	SPI_CONTROL_PORT	|= (1<<SPI_CONTROL_MISO);		// HI
	SPI_CONTROL_DDR	&= ~(1<<SPI_CONTROL_CS_HC);	// Chip Select als Eingang
	SPI_CONTROL_PORT	|= (1<<SPI_CONTROL_CS_HC);		// HI

	SPI_CONTROL_DDR	&= ~(1<<SPI_CONTROL_MOSI);		// MOSI als Eingang
	SPI_CONTROL_PORT	|= (1<<SPI_CONTROL_MOSI);		// HI
	
	SPI_INT0_DDR&= ~(1<<SPI_CONTROL_SCK);				// INT0 als SCK Eingang
	SPI_INT0_PORT |=(1<<SPI_CONTROL_SCK);				// HI
		
	// interrupt on INT0 pin falling edge (sensor triggered) 
	EICRA = (1<<ISC01) | (0<<ISC00);
	// turn on interrupts!
	EIMSK  |= (1<<INT0);
	
	lcd_gotoxy(0,0);
	lcd_puts("SPI_S Init\0");

	sei(); // Enable global interrupts

} 



// Interrupt Routine Slave Mode (interrupt controlled)
// Aufgerufen bei fallender Flanke an INT0

ISR( INT0_vect )
{
	
	if (spistatus & (1<<ACTIVE_BIT))									// CS ist LO, Interrupt ist OK
	{
																				
			_delay_us(10);																	// PIN lesen:
		
		if (spistatus & (1<<STARTDATEN_BIT))						// spi_startdaten senden, in_startdaten laden
		{
		
			if (SPI_CONTROL_PORTPIN & (1<<SPI_CONTROL_MOSI))	// bit ist HI
			{
				in_startdaten |= (1<<(7-bitpos));

				// Echo laden
				//SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				in_startdaten |= (0<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			// Output laden
			if (spi_startdaten & (1<<(7-bitpos)))
			{
				SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else 
			{
				SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			bitpos++;


			if (bitpos>=8) // Byte fertig
			{
				complement=	~in_startdaten;		// Zweiercomplement aus Startdaten bestimmen fuer Enddaten

				spistatus &= ~(1<<STARTDATEN_BIT);					// Bit fuer Startdaten zuruecksetzen
				spistatus |= (1<<LB_BIT);								// Bit fuer lb setzen

				bitpos=0;
				
			}
			
		}
		
		
		//	LB
		else if (spistatus & (1<<LB_BIT))					// spi_lbdaten senden, in_lbdaten laden
		{
			
			if (SPI_CONTROL_PORTPIN & (1<<SPI_CONTROL_MOSI))	// bit ist HI
			{
				in_lbdaten |= (1<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				in_lbdaten |= (0<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			// Output laden
			if (spi_lbdaten & (1<<(7-bitpos)))						// bit ist HI
			{
				SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			bitpos++;
			
			
			if (bitpos>=8)	// Byte fertig
			{
				spistatus &= ~(1<<LB_BIT);						// Bit fuer lb zuruecksetzen
				spistatus |= (1<<HB_BIT);						// Bit fuer hb setzen
				bitpos=0;
			}
			
		}		
		//LB end
	
		//	HB
		else if (spistatus & (1<<HB_BIT))					// spi_hbdaten senden, in_hbdaten laden
		{
			
			if (SPI_CONTROL_PORTPIN & (1<<SPI_CONTROL_MOSI))	// bit ist HI
			{
				in_hbdaten |= (1<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				in_hbdaten |= (0<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			// Output laden
			if (spi_hbdaten & (1<<(7-bitpos)))						// bit ist HI
			{
				SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			bitpos++;
			
			if (bitpos>=8)	// Byte fertig
			{
				spistatus &= ~(1<<HB_BIT);						// Bit fuer hb zuruecksetzen
				
				bitpos=0;
			}
			
		}
		//HB end


		
		
		else if (spistatus & (1<<ENDDATEN_BIT))					// spi_enddaten senden, in_enddaten laden
		{
			
			if (SPI_CONTROL_PORTPIN & (1<<SPI_CONTROL_MOSI))	// bit ist HI
			{
				in_enddaten |= (1<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				in_enddaten |= (0<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			// Output laden
//			if (spi_enddaten & (1<<(7-bitpos)))						// bit ist HI
			if (complement & (1<<(7-bitpos)))						// bit ist HI
			{
				SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			bitpos++;
			
			
			if (bitpos>=8)	// Byte fertig
			{
				spistatus &= ~(1<<ENDDATEN_BIT);						// Bit fuer Enddaten zuruecksetzen
				bitpos=0;
				if (spi_startdaten + in_enddaten==0xFF)
				{
					//lcd_putc('+');
					//spistatus |= (1<<SUCCESS_BIT);					// Datenserie korrekt geladen
					
				}
				else 
				{
					//lcd_putc('-');
					//spistatus &= ~(1<<SUCCESS_BIT);					// Datenserie nicht korrekt geladen
					errCounter++;
				}
				// 24.6.2010
//				spi_startdaten=0xC0; ergab nicht korrekte Pruefsumme mit in_enddaten

//18.7.10
//				spi_hbdaten=0;
//				spi_lbdaten=0;
				
			}
			
		}
		
		else			// Datenarray in inbuffer laden, Daten von spibuffer senden
		
		{
			if (SPI_CONTROL_PORTPIN & (1<<SPI_CONTROL_MOSI))	// bit ist HI
			{
				
				inbuffer[ByteCounter] |= (1<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				inbuffer[ByteCounter] |= (0<<(7-bitpos));
				
				// Echo laden
				//SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			// Output laden
			if (spibuffer[ByteCounter] & (1<<(7-bitpos)))		// bit ist HI
			{
				SPI_CONTROL_PORT |= (1<<SPI_CONTROL_MISO);
			}
			else																// bit ist LO
			{
				SPI_CONTROL_PORT &= ~(1<<SPI_CONTROL_MISO);
			}
			
			
			bitpos++;
			
			if (bitpos>=8) // Byte fertig
			{
				if (ByteCounter<SPI_BUFSIZE -1 )						// zweitletztes Byte
				{
					ByteCounter++;
				}
				else 
				{
					spistatus |= (1<<ENDDATEN_BIT);					// Bit fuer Enddaten setzen
				}
				bitpos=0;
			}	// if bitpos
		}						//  Datenarray in inbuffer laden, Daten von spibuffer senden
	}						// if (spistatus & (1<<ACTIVE_BIT))
	
}		// ISR



