/*****************************************************************************
* Product: DPP example
* Last Updated for Version: 4.0.00
* Date of the Last Update:  Apr 07, 2008
*
*                    Q u a n t u m     L e a P s
*                    ---------------------------
*                    innovating embedded systems
*
* Copyright (C) 2002-2008 Quantum Leaps, LLC. All rights reserved.
*
* This software may be distributed and modified under the terms of the GNU
* General Public License version 2 (GPL) as published by the Free Software
* Foundation and appearing in the file GPL.TXT included in the packaging of
* this file. Please note that GPL Section 2[b] requires that all works based
* on this software must also be made publicly available under the terms of
* the GPL ("Copyleft").
*
* Alternatively, this software may be distributed and modified under the
* terms of Quantum Leaps commercial licenses, which expressly supersede
* the GPL and are specifically designed for licensees interested in
* retaining the proprietary status of their code.
*
* Contact information:
* Quantum Leaps Web site:  http://www.quantum-leaps.com
* e-mail:                  info@quantum-leaps.com
*****************************************************************************/
#ifndef bsp_h_INCLUDED
#define bsp_h_INCLUDED

#include "wordclock.h"

#ifdef __AVR
/* Must match the ticks per second generated by the AVR code. */
#define BSP_TICKS_PER_SECOND 25
#endif

#define BSP_logmsg(f,...)
#define BSP_print_event(me,name,e)

void BSP_watchdog(struct Wordclock *me);
void BSP_startmain();		/* Code to put right at the start of main() */
void BSP_init(void);

void BSP_ledOn();
void BSP_ledOff();

void enable_1hz_interrupts(uint8_t onoff);

#endif	/* bsp_h_INCLUDED */
