#include <stdlib.h>
#include <string.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#define YYPREFIX "yy"
#line 27 "parse.y"
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/queue.h>

#include <net/if.h>
#include <net/pfvar.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <net/route.h>

#include <ctype.h>
#include <unistd.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <limits.h>
#include <stdint.h>
#include <stdarg.h>
#include <stdio.h>
#include <netdb.h>
#include <string.h>
#include <ifaddrs.h>

#include <openssl/ssl.h>

#include "relayd.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 yyerror(const char *, ...);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 lgetc(int);
int		 lungetc(int);
int		 findeol(void);

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct relayd		*conf = NULL;
static int		 errors = 0;
objid_t			 last_rdr_id = 0;
objid_t			 last_table_id = 0;
objid_t			 last_host_id = 0;
objid_t			 last_relay_id = 0;
objid_t			 last_proto_id = 0;
objid_t			 last_rt_id = 0;
objid_t			 last_nr_id = 0;

static struct rdr	*rdr = NULL;
static struct table	*table = NULL;
static struct relay	*rlay = NULL;
static struct host	*hst = NULL;
struct relaylist	 relays;
static struct protocol	*proto = NULL;
static struct protonode	 node;
static struct router	*router = NULL;
static u_int16_t	 label = 0;
static in_port_t	 tableport = 0;
static int		 nodedirection;

struct address	*host_v4(const char *);
struct address	*host_v6(const char *);
int		 host_dns(const char *, struct addresslist *,
		    int, struct portrange *, const char *, int);
int		 host_if(const char *, struct addresslist *,
		    int, struct portrange *, const char *, int);
int		 host(const char *, struct addresslist *,
		    int, struct portrange *, const char *, int);

struct table	*table_inherit(struct table *);
struct relay	*relay_inherit(struct relay *, struct relay *);
int		 getservice(char *);

typedef struct {
	union {
		int64_t			 number;
		char			*string;
		struct host		*host;
		struct timeval		 tv;
		struct table		*table;
		struct portrange	 port;
		struct {
			struct sockaddr_storage	 ss;
			char			 name[MAXHOSTNAMELEN];
		}			 addr;
		struct {
			enum digest_type type;
			char		*digest;
		}			 digest;
	} v;
	int lineno;
} YYSTYPE;

#line 129 "y.tab.c"
#define ALL 257
#define APPEND 258
#define BACKLOG 259
#define BACKUP 260
#define BUFFER 261
#define CA 262
#define CACHE 263
#define CHANGE 264
#define CHECK 265
#define CIPHERS 266
#define CODE 267
#define COOKIE 268
#define DEMOTE 269
#define DIGEST 270
#define DISABLE 271
#define ERROR 272
#define EXPECT 273
#define EXTERNAL 274
#define FILENAME 275
#define FILTER 276
#define FORWARD 277
#define FROM 278
#define HASH 279
#define HEADER 280
#define HOST 281
#define ICMP 282
#define INCLUDE 283
#define INET 284
#define INET6 285
#define INTERFACE 286
#define INTERVAL 287
#define IP 288
#define LABEL 289
#define LISTEN 290
#define LOADBALANCE 291
#define LOG 292
#define LOOKUP 293
#define MARK 294
#define MARKED 295
#define MODE 296
#define NAT 297
#define NO 298
#define DESTINATION 299
#define NODELAY 300
#define NOTHING 301
#define ON 302
#define PARENT 303
#define PATH 304
#define PORT 305
#define PREFORK 306
#define PRIORITY 307
#define PROTO 308
#define QUERYSTR 309
#define REAL 310
#define REDIRECT 311
#define RELAY 312
#define REMOVE 313
#define REQUEST 314
#define RESPONSE 315
#define RETRY 316
#define RETURN 317
#define ROUNDROBIN 318
#define ROUTE 319
#define SACK 320
#define SCRIPT 321
#define SEND 322
#define SESSION 323
#define SOCKET 324
#define SPLICE 325
#define SSL 326
#define STICKYADDR 327
#define STYLE 328
#define TABLE 329
#define TAG 330
#define TCP 331
#define TIMEOUT 332
#define TO 333
#define ROUTER 334
#define RTLABEL 335
#define TRANSPARENT 336
#define TRAP 337
#define UPDATES 338
#define URL 339
#define VIRTUAL 340
#define WITH 341
#define TTL 342
#define RTABLE 343
#define MATCH 344
#define STRING 345
#define NUMBER 346
#define YYERRCODE 256
#if defined(__cplusplus) || defined(__STDC__)
const short yylhs[] =
#else
short yylhs[] =
#endif
	{                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   24,   12,   12,   13,   13,    4,    1,    1,   16,
   16,   16,   15,   15,   15,   32,   32,   35,   35,   33,
   18,   18,   25,   36,   36,   26,   26,   26,   26,   26,
   26,    5,    5,   37,   27,   39,   39,   40,   40,   40,
   40,   40,   40,   40,   17,   17,   10,   10,   10,    3,
   43,   28,   42,   42,   44,   44,   45,   45,   46,   46,
   48,   23,   47,   47,   49,   49,   49,   49,   49,   49,
   50,   50,   50,   50,   50,   50,   50,   22,   52,   30,
   51,   51,   51,   53,   53,   54,   54,   54,   54,   54,
   54,   54,   54,   60,   54,   54,    7,    7,    7,   58,
   58,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   56,   56,   55,   55,   55,   55,   55,    9,   59,   59,
   59,   64,   59,   59,   59,   65,   59,   59,   59,   59,
   66,   59,   59,   59,   59,   67,   59,   59,   59,   63,
   62,   69,   69,   68,   68,    6,   61,   61,   61,   61,
   61,   14,   14,   70,   29,   71,   71,   72,   72,   72,
   72,   72,   72,   73,   73,   73,   73,    8,    8,    8,
    8,   75,   31,   76,   76,   77,   77,   77,   77,   77,
   77,   74,   74,   74,    2,    2,   79,   19,   78,   78,
   80,   80,   81,   81,   81,   81,   20,   11,   11,   21,
   34,   34,   34,   38,   38,   41,
};
#if defined(__cplusplus) || defined(__STDC__)
const short yylen[] =
#else
short yylen[] =
#endif
	{                                         2,
    0,    3,    2,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    0,    1,    0,    2,    1,    0,    2,    0,
    1,    1,    0,    1,    1,    3,    1,    0,    1,    2,
    2,    2,    3,    1,    1,    2,    2,    2,    2,    2,
    2,    1,    1,    0,    7,    3,    2,    4,    6,    1,
    1,    3,    3,    1,    0,    1,    1,    1,    2,    3,
    0,    4,    2,    1,    1,    4,    3,    2,    1,    1,
    0,    3,    2,    1,    2,    1,    2,    2,    2,    2,
    1,    1,    1,    5,    4,    5,    2,    2,    0,    5,
    0,    2,    4,    3,    2,    2,    4,    2,    4,    3,
    5,    2,    2,    0,    3,    1,    0,    1,    1,    3,
    1,    1,    2,    1,    2,    1,    2,    2,    3,    3,
    3,    1,    3,    2,    3,    2,    1,    1,    6,    6,
    4,    0,    4,    6,    4,    0,    4,    4,    6,    4,
    0,    4,    4,    4,    4,    0,    4,    8,    6,    3,
    2,    0,    2,    0,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    0,    7,    3,    2,    5,    6,    3,
    2,    1,    1,    3,    3,    2,    1,    0,    1,    1,
    1,    0,    7,    3,    2,    4,    3,    2,    2,    1,
    1,    0,    1,    2,    0,    2,    0,    3,    0,    1,
    2,    1,    2,    2,    2,    3,    1,    0,    2,    1,
    1,    1,    0,    2,    0,    2,
};
#if defined(__cplusplus) || defined(__STDC__)
const short yydefred[] =
#else
short yydefred[] =
#endif
	{                                      1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   21,    0,    0,    0,    3,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   11,   40,   12,   36,   43,
   42,   37,   39,   44,  164,   41,    0,   61,  210,   38,
  182,    0,    0,    2,    4,    5,    6,    7,    8,    9,
   10,    0,    0,    0,    0,    0,   33,   89,    0,    0,
   60,   65,    0,    0,   64,    0,    0,    0,    0,    0,
    0,   63,    0,    0,   90,  214,   50,   57,    0,   58,
    0,   51,    0,   56,    0,    0,   54,    0,    0,  172,
    0,    0,    0,    0,  173,    0,    0,  207,   69,  197,
   70,    0,    0,  190,    0,    0,    0,    0,  191,    0,
    0,   92,    0,    0,    0,   59,    0,    0,   45,    0,
   47,    0,  171,    0,    0,    0,  165,    0,  167,    0,
   66,    0,  211,    0,   68,  212,    0,    0,  189,  188,
  183,    0,  185,    0,    0,  108,  109,    0,    0,    0,
  104,  106,    0,    0,    0,   53,   71,    0,   52,    0,
   46,    0,  170,   16,    0,  166,    0,    0,    0,    0,
  198,  200,    0,    0,   67,  187,    0,  184,  102,  103,
    0,    0,    0,    0,    0,  128,    0,  127,   96,    0,
    0,    0,  114,  112,    0,  116,    0,   98,    0,   93,
    0,   95,   24,   25,    0,    0,    0,   48,  216,    0,
    0,    0,    0,    0,  177,    0,    0,  204,  205,  203,
  201,  186,    0,    0,   29,  100,    0,  124,  126,    0,
    0,    0,  118,    0,  115,  113,  117,    0,    0,    0,
  159,  157,  160,  158,  161,  105,    0,   94,    0,    0,
    0,    0,    0,    0,   76,   72,    0,  196,   31,   32,
   14,  168,    0,    0,  176,    0,    0,  206,   30,    0,
    0,  125,  163,  162,  123,    0,   97,  120,  119,    0,
   99,    0,    0,    0,    0,    0,    0,    0,    0,   49,
   81,    0,    0,   83,   82,   17,    0,   75,   78,   79,
  181,  179,  180,   80,   77,   73,  175,  209,  174,  193,
    0,  169,  101,    0,  121,  110,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   87,   34,   35,    0,    0,  194,   26,    0,    0,
   88,    0,    0,  135,    0,  138,    0,  137,    0,  140,
  143,  142,  144,  145,  147,    0,    0,  131,  133,    0,
    0,    0,    0,    0,    0,  156,  153,  155,  151,    0,
    0,    0,    0,    0,   19,    0,   85,  129,  130,  134,
  150,  139,    0,  149,   86,   84,    0,  148,
};
#if defined(__cplusplus) || defined(__STDC__)
const short yydgoto[] =
#else
short yydgoto[] =
#endif
	{                                       1,
  362,  208,  157,  297,   32,  367,  151,  304,  188,   85,
  265,  262,  126,  275,  205,   17,   86,  255,   99,  100,
   40,  321,  158,   87,   19,   20,   21,   22,   23,   24,
   25,  270,  271,  134,  226,  335,   52,   69,   88,   89,
  136,   64,   55,   65,  102,  103,  256,  206,  257,  298,
   75,   67,  153,  154,  231,  232,  239,  240,  246,  199,
  247,  344,  348,  331,  322,  325,  328,  369,  345,   53,
   96,   97,  216,  312,   56,  110,  111,  171,  130,  172,
  173,
};
#if defined(__cplusplus) || defined(__STDC__)
const short yysindex[] =
#else
short yysindex[] =
#endif
	{                                      0,
  -10,   42, -287, -274, -259, -243, -221, -206, -204, -182,
  100,    0, -174, -184,  125,    0, -116,  177,  179,  187,
  188,  189,  190,  192,  195,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -137,    0,    0,    0,
    0, -135, -134,    0,    0,    0,    0,    0,    0,    0,
    0,   96,   99,  172, -114,  113,    0,    0,  228,  228,
    0,    0,  228, -114,    0,  228,  117,  228,  459,  517,
 -252,    0, -217,    2,    0,    0,    0,    0,  -53,    0,
  -79,    0,  -22,    0,  -72,  -73,    0,  -76,  228,    0,
  -40,  -82,  -68,  -75,    0,  451,  228,    0,    0,    0,
    0,  144,   29,    0,  -63,  -69,  -67,  -65,    0, -102,
  228,    0,  549,  -66,  -54,    0,  100,  -58,    0,  261,
    0,  -52,    0,  -48,  -27,  -61,    0,  261,    0, -136,
    0,  228,    0, -252,    0,    0,  100,  262,    0,    0,
    0,  261,    0,  -32,   26,    0,    0,   46, -120,  171,
    0,    0,  -31,  228, -283,    0,    0,   31,    0,  228,
    0,   25,    0,    0,  -55,    0,  -19,  -15,  -12,   -6,
    0,    0, -136,    0,    0,    0,   -5,    0,    0,    0,
 -113,   63,   -3,   -1,   85,    0, -237,    0,    0,    3,
    9, -167,    0,    0,  106,    0,   70,    0,  -74,    0,
  261,    0,    0,    0,   25, -228,   15,    0,    0, -196,
   35,   83,   61,   25,    0,   31,   34,    0,    0,    0,
    0,    0,   36,   54,    0,    0,   38,    0,    0, -254,
   45,  263,    0,   40,    0,    0,    0,   41,   45,  264,
    0,    0,    0,    0,    0,    0,  316,    0,   31, -191,
   47,   55, -246, -174,    0,    0, -228,    0,    0,    0,
    0,    0,   61,   56,    0,   61, -185,    0,    0,  278,
   45,    0,    0,    0,    0, -237,    0,    0,    0,   70,
    0,   60,   64, -244, -242,   65,   67,   68,   69,    0,
    0,   71, -267,    0,    0,    0,   72,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   74,    0,    0,   54,    0,    0,   73,   75,   76, -238,
  130,  152, -157,  130,  152,  130,  130,  152, -231,  130,
  152,    0,    0,    0,  155,  148,    0,    0,   90,   91,
    0,   93,   97,    0,  147,    0,  103,    0,  107,    0,
    0,    0,    0,    0,    0,  109,   97,    0,    0,  110,
  111, -158,  130,  130,  130,    0,    0,    0,    0,  130,
  130,  104,  130,   35,    0,  115,    0,    0,    0,    0,
    0,    0,   97,    0,    0,    0,  147,    0,};
#if defined(__cplusplus) || defined(__STDC__)
const short yyrindex[] =
#else
short yyrindex[] =
#endif
	{                                      0,
  154,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  156,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -208,  522,
    0,    0, -216,  450,    0, -187,  455,  380,  137,    0,
    0,    0,    0,  500,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  137, -107,    0,
    0,    0,    0,  135,    0,    0,  456,    0,    0,    0,
    0,    0, -121,    0,    0,    0,    0,    0,    0,    0,
  -87,    0,  -59,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   -9,
    0, -118,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -59,  446,  165,    0,    0,  163,    0,  380,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   -8, -117,    0,    0,    0,    0,    0,    0,
  221,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   43,    0,  301,    0,    0,  317,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -119,    0,    0,    0,    0,    0,    0,    0,  220,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  163,    0,
    0,    0,   20,    0,    0,    0,  114,    0,    0,    0,
    0,    0,  301,    0,    0,  301,  322,    0,    0,    0,
 -110,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  198,  199,    0,  201,    0,  202,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  183,
  183,    0,  183,  183,    0,  183,  183,    0,    0,  183,
    0,    0,    0,    0,    0, -133,    0,    0,    0,    0,
    0,    0,    0,    0,  244,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  183,  183,  183,    0,    0,    0,    0,  183,
  183,    0,  183,   88,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  244,    0,};
#if defined(__cplusplus) || defined(__STDC__)
const short yygindex[] =
#else
short yygindex[] =
#endif
	{                                      0,
    0, -173,  467,    0,    0, -313,    0,    0,  296,   18,
  -89,  120,    0,    0,    0,    0,    0, -140,    0,  377,
  230, -265,  -86,   10,    0,    0,    0,    0,    0,    0,
    0,  174,  304,  -80,    0,    0,    0,  -47,    0,  414,
  -96,    0,    0,  439,  372,    0,  254,    0,    0,    0,
    0,    0,    0,  360,  366,  240,  367,  241,    0,    0,
    0,  497, -143,    0,    0,    0,    0,  136,    0,    0,
    0,  430,    0,    0,    0,    0,  418,    0,    0,  356,
    0,
};
#define YYTABLESIZE 880
#if defined(__cplusplus) || defined(__STDC__)
const short yytable[] =
#else
short yytable[] =
#endif
	{                                      16,
  199,  202,  187,  215,   37,  122,  215,  214,   63,  224,
   18,   68,   70,   30,   27,   71,  273,  215,   73,  324,
   76,  211,  141,  161,  182,  319,  113,  319,  183,  178,
    4,  166,  301,  333,  199,  202,  250,  215,  132,  342,
  251,  121,  267,  373,  302,  178,  356,  203,  119,  129,
  176,   26,   13,  104,  160,  135,  343,   27,  252,  105,
  184,  204,  215,  143,  249,    4,  215,  253,  215,  387,
   28,  303,  133,  266,  215,  290,  210,  334,  215,   95,
  101,  215,  109,  215,  174,  185,   29,   94,  133,  215,
  291,  274,   98,  200,   31,  215,  377,   13,  310,  311,
  320,  106,  323,  254,  248,   95,  202,  186,  376,  357,
  215,  319,  209,   94,  215,  199,  202,  107,  215,  109,
  349,  215,  152,   74,   33,  108,  112,  215,  215,  292,
  293,  215,  235,   18,  294,  215,   18,  343,   34,  295,
   35,  182,  213,  101,  178,  183,  213,  215,  259,  260,
  276,  167,  236,  296,   36,  215,   62,  237,  280,   37,
   41,  213,  152,  215,  215,  216,  168,   13,  104,  215,
  169,   39,  195,  307,  105,  215,  309,  184,  213,  170,
    4,  352,  215,  215,  355,   42,   44,  359,   45,  215,
  314,   43,  152,  241,   77,  215,   46,   47,   48,   49,
   78,   50,  185,  213,   51,  242,    4,   54,  107,   57,
   58,  215,   13,   79,  223,  215,  106,  213,   59,  215,
  107,   60,  215,  213,  186,  213,  215,  216,  215,  243,
   28,  215,  107,   61,  244,   66,  215,   68,   74,   74,
  108,  212,   80,  213,  107,    2,   81,  215,  114,  107,
   82,    4,  115,  154,  116,  215,  118,  144,    3,   83,
  117,  122,  123,  124,  245,  125,  145,   84,  131,  137,
  160,  165,    4,  199,  202,   98,    5,  139,  155,  107,
  140,    6,  146,  147,  178,  148,  159,  195,  178,  214,
  178,  156,  162,  197,  149,    7,  178,  163,  164,  150,
    8,    9,  178,  178,  178,  178,  178,  152,  177,  178,
  208,   10,  179,   13,  180,  178,  207,  181,   11,   13,
   12,   13,  217,   14,  178,   13,  195,  178,  190,  210,
  218,  192,   13,  219,   15,  199,  202,  227,  178,  220,
  222,  228,  178,  186,  111,   28,  178,  230,  233,  178,
   13,  178,   13,  234,  178,  178,   13,  191,   13,  258,
  261,   13,  178,  178,   13,   13,  238,  192,  154,  193,
   13,   13,   13,   13,   13,  263,  264,   13,   13,  268,
  269,  223,  272,   13,   74,  278,  279,  277,  281,  194,
   74,  299,   13,  195,  196,   13,   74,   74,   74,   74,
  300,  308,  313,   74,  317,  339,   13,  340,  318,  326,
   13,  327,  329,  330,   13,  332,  336,   13,  337,   13,
  341,   74,   13,   13,  343,  208,  347,  360,  361,  190,
   13,   13,   74,  195,  363,  364,   74,  365,  368,  195,
   74,  195,  366,   74,  383,  195,  192,  370,   74,   74,
  152,  371,  195,  372,  374,  375,   74,   74,  191,   62,
  386,   20,  152,   22,   91,  152,   55,   15,  192,   23,
  193,  152,  136,  141,  152,  146,  132,   38,  213,  229,
  152,  195,  138,  305,  225,  195,  152,  338,   28,  195,
  194,  152,  195,  385,  195,  196,  152,  152,  195,  152,
   28,  120,   72,   28,  215,  175,  195,  213,  152,   28,
  306,  154,  201,  152,  189,  315,  198,  213,   28,  213,
  316,  152,  388,  154,   28,  128,  154,  142,  221,   28,
    0,    0,  154,    0,   28,   28,    0,   28,    0,  213,
    0,  154,    0,  213,  213,    0,   28,  154,    0,    0,
    0,   28,  154,    0,    0,    0,    0,  154,  154,   28,
  154,    0,    0,    0,    0,    0,    0,    0,    0,  154,
  215,  208,    0,  282,  154,  127,    0,  208,    0,  283,
  215,    0,  154,  208,  208,  208,  208,  195,  284,    0,
  208,  285,  192,  195,  286,    0,    0,    0,  192,  195,
  195,  195,    0,    0,  192,    0,  195,  287,  208,  288,
    0,  192,    0,    0,    0,    0,    0,    0,    0,  208,
    0,    0,    0,  208,  195,    0,    0,    0,  289,  192,
    0,    0,    0,    0,    0,  195,  208,    0,  215,  195,
  192,  215,    0,    0,  192,  215,    0,  215,    0,    0,
  215,    0,  195,    0,    0,    0,  215,  192,    0,  215,
    0,    0,  215,    0,    0,    0,    0,  215,  215,  215,
    0,    0,    0,    0,    0,    0,    0,  215,    0,  215,
    0,    0,    0,  215,    0,    0,    0,  215,  215,    0,
    0,    0,    0,  215,  215,    0,  215,    0,  215,  215,
    0,    0,  215,  215,  215,  215,  215,  215,    0,  215,
  215,    0,    0,  215,  215,  215,    0,    0,  215,    0,
    0,   90,  215,  215,  215,  215,  215,   78,  215,   77,
    0,    0,  215,    4,  215,   78,    0,    0,  215,    0,
   91,    4,    0,  215,    0,  215,    0,    0,   79,  215,
    0,    0,    0,    0,  215,    0,    0,    0,   92,  215,
  215,    0,  215,  215,    0,    0,    0,  215,    0,   80,
    0,  215,    0,   93,  215,    0,  215,   80,  215,  215,
    0,   81,  215,    0,  215,   82,   83,   90,  215,    0,
    0,  215,  215,   78,   83,    0,    0,  215,  215,    4,
    0,    0,   84,  215,  215,    0,   91,    0,  215,    0,
    0,  215,    0,  215,  215,    0,  215,  346,    0,  350,
  351,    0,  353,  354,   92,  215,  358,    0,    0,  215,
  215,    4,    0,    0,    0,   80,    0,  144,  215,   93,
  215,    0,    0,    0,  215,    0,  145,    0,    0,    0,
    0,    0,   83,    0,    0,    0,    0,  215,    0,  378,
  379,  380,  146,  147,    0,  148,  381,  382,    0,  384,
    0,    0,    0,    0,  149,    0,    0,    0,    0,  150,
};
#if defined(__cplusplus) || defined(__STDC__)
const short yycheck[] =
#else
short yycheck[] =
#endif
	{                                      10,
   10,   10,  123,  125,   60,  125,  125,  125,  123,  123,
    1,   10,   60,  257,  125,   63,  271,  125,   66,  285,
   68,  162,  125,  120,  262,  270,   74,  270,  266,   10,
  283,  128,  279,  301,   44,   44,  265,  125,   10,  278,
  269,   89,  216,  357,  291,  142,  278,  331,  125,   97,
  137,   10,   10,  271,   10,  103,  295,  345,  287,  277,
  298,  345,  271,  111,  205,  283,  283,  296,  277,  383,
  345,  318,   44,  214,  283,  249,  305,  345,  165,   70,
   71,  290,   73,  271,  132,  323,  346,   70,   44,  277,
  282,  346,  345,  125,  338,  283,  362,   10,  284,  285,
  345,  319,  345,  332,  201,   96,  154,  345,  267,  341,
  319,  270,  160,   96,  323,  125,  125,  335,  327,  110,
  278,  330,  113,   10,  346,  343,  125,  336,  345,  321,
  322,  319,  300,  267,  326,  344,  270,  295,  345,  331,
  345,  262,  262,  134,  125,  266,  266,  335,  345,  346,
  231,  288,  320,  345,  337,  343,  271,  325,  239,   60,
  345,  283,  153,  271,  283,  283,  303,  125,  271,  277,
  307,  346,   10,  263,  277,  283,  266,  298,  298,  316,
  283,  325,  290,  271,  328,   61,   10,  331,   10,  277,
  271,  308,   10,  268,  271,  283,   10,   10,   10,   10,
  277,   10,  323,  323,   10,  280,  283,  345,  268,  345,
  345,  319,  125,  290,  328,  323,  319,  328,  123,  327,
  280,  123,  330,  345,  345,  345,  345,  345,  336,  304,
   10,  319,  335,   62,  309,  123,  344,   10,  125,  123,
  343,  297,  319,  299,  304,  256,  323,  335,  302,  309,
  327,  283,  332,   10,  277,  343,  330,  289,  269,  336,
  333,  302,  345,  332,  339,  341,  298,  344,  125,  333,
   10,  333,  283,  283,  283,  345,  287,  345,  345,  339,
  346,  292,  314,  315,  265,  317,  345,  125,  269,  345,
  271,  346,  345,  123,  326,  306,  277,  346,  326,  331,
  311,  312,  283,  284,  285,  286,  287,  125,   47,  290,
   10,  322,  345,  271,  289,  296,  286,  272,  329,  277,
  331,  332,  342,  334,  305,  283,   10,  308,  259,  305,
  346,   10,  290,  346,  345,  345,  345,  275,  319,  346,
  346,  345,  323,  345,  125,  125,  327,  263,  346,  330,
  308,  332,  265,  345,  335,  336,  269,  288,  271,  345,
  326,  319,  343,  344,  277,  323,  261,  298,  125,  300,
  283,  284,  285,  286,  287,  293,  316,  290,  336,  346,
  345,  328,  345,  296,  271,  346,  346,  125,  125,  320,
  277,  345,  305,  324,  325,  308,  283,  284,  285,  286,
  346,  346,  125,  290,  345,  333,  319,  333,  345,  345,
  323,  345,  345,  345,  327,  345,  345,  330,  345,  332,
  345,  308,  335,  336,  295,  125,  275,  273,  281,  259,
  343,  344,  319,  271,  345,  345,  323,  345,  292,  277,
  327,  125,  346,  330,  341,  283,  125,  345,  335,  336,
  268,  345,  290,  345,  345,  345,  343,  344,  288,   10,
  346,  308,  280,  308,   10,  283,  330,  333,  298,  305,
  300,  289,  275,  275,  292,  275,  275,   11,  259,  184,
  298,  319,  106,  254,  181,  323,  304,  314,  268,  327,
  320,  309,  330,  374,  324,  325,  314,  315,  336,  317,
  280,   88,   64,  283,  125,  134,  344,  288,  326,  289,
  257,  268,  153,  331,  149,  276,  150,  298,  298,  300,
  280,  339,  387,  280,  304,   96,  283,  110,  173,  309,
   -1,   -1,  289,   -1,  314,  315,   -1,  317,   -1,  320,
   -1,  298,   -1,  324,  325,   -1,  326,  304,   -1,   -1,
   -1,  331,  309,   -1,   -1,   -1,   -1,  314,  315,  339,
  317,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  326,
  125,  271,   -1,  258,  331,  125,   -1,  277,   -1,  264,
  125,   -1,  339,  283,  284,  285,  286,  271,  273,   -1,
  290,  276,  271,  277,  279,   -1,   -1,   -1,  277,  283,
  284,  285,   -1,   -1,  283,   -1,  290,  292,  308,  294,
   -1,  290,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,
   -1,   -1,   -1,  323,  308,   -1,   -1,   -1,  313,  308,
   -1,   -1,   -1,   -1,   -1,  319,  336,   -1,  259,  323,
  319,  262,   -1,   -1,  323,  266,   -1,  268,   -1,   -1,
  271,   -1,  336,   -1,   -1,   -1,  277,  336,   -1,  280,
   -1,   -1,  283,   -1,   -1,   -1,   -1,  288,  289,  290,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
   -1,   -1,   -1,  304,   -1,   -1,   -1,  308,  309,   -1,
   -1,   -1,   -1,  314,  315,   -1,  317,   -1,  319,  320,
   -1,   -1,  323,  324,  325,  326,  327,  328,   -1,  330,
  331,   -1,   -1,  268,  335,  336,   -1,   -1,  339,   -1,
   -1,  271,  343,  344,  345,  280,  271,  277,  283,  271,
   -1,   -1,  277,  283,  289,  277,   -1,   -1,  283,   -1,
  290,  283,   -1,  298,   -1,  290,   -1,   -1,  290,  304,
   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  308,  314,
  315,   -1,  317,  308,   -1,   -1,   -1,  268,   -1,  319,
   -1,  326,   -1,  323,  319,   -1,  331,  319,  323,  280,
   -1,  323,  283,   -1,  339,  327,  336,  271,  289,   -1,
   -1,  336,  271,  277,  336,   -1,   -1,  298,  277,  283,
   -1,   -1,  344,  304,  283,   -1,  290,   -1,  309,   -1,
   -1,  290,   -1,  314,  315,   -1,  317,  321,   -1,  323,
  324,   -1,  326,  327,  308,  326,  330,   -1,   -1,  308,
  331,  283,   -1,   -1,   -1,  319,   -1,  289,  339,  323,
  319,   -1,   -1,   -1,  323,   -1,  298,   -1,   -1,   -1,
   -1,   -1,  336,   -1,   -1,   -1,   -1,  336,   -1,  363,
  364,  365,  314,  315,   -1,  317,  370,  371,   -1,  373,
   -1,   -1,   -1,   -1,  326,   -1,   -1,   -1,   -1,  331,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 346
#if YYDEBUG
#if defined(__cplusplus) || defined(__STDC__)
const char * const yyname[] =
#else
char *yyname[] =
#endif
	{
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"','",0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,0,"'<'","'='",
"'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"ALL","APPEND","BACKLOG","BACKUP","BUFFER","CA","CACHE","CHANGE","CHECK",
"CIPHERS","CODE","COOKIE","DEMOTE","DIGEST","DISABLE","ERROR","EXPECT",
"EXTERNAL","FILENAME","FILTER","FORWARD","FROM","HASH","HEADER","HOST","ICMP",
"INCLUDE","INET","INET6","INTERFACE","INTERVAL","IP","LABEL","LISTEN",
"LOADBALANCE","LOG","LOOKUP","MARK","MARKED","MODE","NAT","NO","DESTINATION",
"NODELAY","NOTHING","ON","PARENT","PATH","PORT","PREFORK","PRIORITY","PROTO",
"QUERYSTR","REAL","REDIRECT","RELAY","REMOVE","REQUEST","RESPONSE","RETRY",
"RETURN","ROUNDROBIN","ROUTE","SACK","SCRIPT","SEND","SESSION","SOCKET",
"SPLICE","SSL","STICKYADDR","STYLE","TABLE","TAG","TCP","TIMEOUT","TO","ROUTER",
"RTLABEL","TRANSPARENT","TRAP","UPDATES","URL","VIRTUAL","WITH","TTL","RTABLE",
"MATCH","STRING","NUMBER",
};
#if defined(__cplusplus) || defined(__STDC__)
const char * const yyrule[] =
#else
char *yyrule[] =
#endif
	{"$accept : grammar",
"grammar :",
"grammar : grammar include '\\n'",
"grammar : grammar '\\n'",
"grammar : grammar varset '\\n'",
"grammar : grammar main '\\n'",
"grammar : grammar rdr '\\n'",
"grammar : grammar tabledef '\\n'",
"grammar : grammar relay '\\n'",
"grammar : grammar proto '\\n'",
"grammar : grammar router '\\n'",
"grammar : grammar error '\\n'",
"include : INCLUDE STRING",
"optssl :",
"optssl : SSL",
"optsslclient :",
"optsslclient : WITH SSL",
"http_type : STRING",
"hostname :",
"hostname : HOST STRING",
"relay_proto :",
"relay_proto : TCP",
"relay_proto : STRING",
"redirect_proto :",
"redirect_proto : TCP",
"redirect_proto : STRING",
"eflags_l : eflags comma eflags_l",
"eflags_l : eflags",
"opteflags :",
"opteflags : eflags",
"eflags : STYLE STRING",
"port : PORT STRING",
"port : PORT NUMBER",
"varset : STRING '=' STRING",
"sendbuf : NOTHING",
"sendbuf : STRING",
"main : INTERVAL NUMBER",
"main : LOG loglevel",
"main : TIMEOUT timeout",
"main : PREFORK NUMBER",
"main : DEMOTE STRING",
"main : SEND TRAP",
"loglevel : UPDATES",
"loglevel : ALL",
"$$1 :",
"rdr : REDIRECT STRING $$1 '{' optnl rdropts_l '}'",
"rdropts_l : rdropts_l rdroptsl nl",
"rdropts_l : rdroptsl optnl",
"rdroptsl : forwardmode TO tablespec interface",
"rdroptsl : LISTEN ON STRING redirect_proto port interface",
"rdroptsl : DISABLE",
"rdroptsl : STICKYADDR",
"rdroptsl : match TAG STRING",
"rdroptsl : SESSION TIMEOUT NUMBER",
"rdroptsl : include",
"match :",
"match : MATCH",
"forwardmode : FORWARD",
"forwardmode : ROUTE",
"forwardmode : TRANSPARENT FORWARD",
"table : '<' STRING '>'",
"$$2 :",
"tabledef : TABLE table $$2 tabledefopts_l",
"tabledefopts_l : tabledefopts_l tabledefopts",
"tabledefopts_l : tabledefopts",
"tabledefopts : DISABLE",
"tabledefopts : '{' optnl tablelist_l '}'",
"tablelist_l : tablelist comma tablelist_l",
"tablelist_l : tablelist optnl",
"tablelist : host",
"tablelist : include",
"$$3 :",
"tablespec : table $$3 tableopts_l",
"tableopts_l : tableopts tableopts_l",
"tableopts_l : tableopts",
"tableopts : CHECK tablecheck",
"tableopts : port",
"tableopts : TIMEOUT timeout",
"tableopts : DEMOTE STRING",
"tableopts : INTERVAL NUMBER",
"tableopts : MODE dstmode",
"tablecheck : ICMP",
"tablecheck : TCP",
"tablecheck : SSL",
"tablecheck : http_type STRING hostname CODE NUMBER",
"tablecheck : http_type STRING hostname digest",
"tablecheck : SEND sendbuf EXPECT STRING optssl",
"tablecheck : SCRIPT STRING",
"digest : DIGEST STRING",
"$$4 :",
"proto : relay_proto PROTO STRING $$4 protopts_n",
"protopts_n :",
"protopts_n : '{' '}'",
"protopts_n : '{' optnl protopts_l '}'",
"protopts_l : protopts_l protoptsl nl",
"protopts_l : protoptsl optnl",
"protoptsl : SSL sslflags",
"protoptsl : SSL '{' sslflags_l '}'",
"protoptsl : TCP tcpflags",
"protoptsl : TCP '{' tcpflags_l '}'",
"protoptsl : RETURN ERROR opteflags",
"protoptsl : RETURN ERROR '{' eflags_l '}'",
"protoptsl : LABEL STRING",
"protoptsl : NO LABEL",
"$$5 :",
"protoptsl : direction $$5 protonode",
"protoptsl : include",
"direction :",
"direction : REQUEST",
"direction : RESPONSE",
"tcpflags_l : tcpflags comma tcpflags_l",
"tcpflags_l : tcpflags",
"tcpflags : SACK",
"tcpflags : NO SACK",
"tcpflags : NODELAY",
"tcpflags : NO NODELAY",
"tcpflags : SPLICE",
"tcpflags : NO SPLICE",
"tcpflags : BACKLOG NUMBER",
"tcpflags : SOCKET BUFFER NUMBER",
"tcpflags : IP STRING NUMBER",
"sslflags_l : sslflags comma sslflags_l",
"sslflags_l : sslflags",
"sslflags : SESSION CACHE sslcache",
"sslflags : CIPHERS STRING",
"sslflags : CA FILENAME STRING",
"sslflags : NO flag",
"sslflags : flag",
"flag : STRING",
"protonode : nodetype APPEND STRING TO STRING nodeopts",
"protonode : nodetype CHANGE STRING TO STRING nodeopts",
"protonode : nodetype REMOVE STRING nodeopts",
"$$6 :",
"protonode : nodetype REMOVE $$6 nodefile",
"protonode : nodetype EXPECT STRING FROM STRING nodeopts",
"protonode : nodetype EXPECT STRING nodeopts",
"$$7 :",
"protonode : nodetype EXPECT $$7 nodefile",
"protonode : nodetype EXPECT digest nodeopts",
"protonode : nodetype FILTER STRING FROM STRING nodeopts",
"protonode : nodetype FILTER STRING nodeopts",
"$$8 :",
"protonode : nodetype FILTER $$8 nodefile",
"protonode : nodetype FILTER digest nodeopts",
"protonode : nodetype HASH STRING nodeopts",
"protonode : nodetype LOG STRING nodeopts",
"$$9 :",
"protonode : nodetype LOG $$9 nodefile",
"protonode : nodetype MARK STRING FROM STRING WITH mark log",
"protonode : nodetype MARK STRING WITH mark nodeopts",
"nodefile : FILENAME STRING nodeopts",
"nodeopts : marked log",
"marked :",
"marked : MARKED mark",
"log :",
"log : LOG",
"mark : NUMBER",
"nodetype : HEADER",
"nodetype : QUERYSTR",
"nodetype : COOKIE",
"nodetype : PATH",
"nodetype : URL",
"sslcache : NUMBER",
"sslcache : DISABLE",
"$$10 :",
"relay : RELAY STRING $$10 '{' optnl relayopts_l '}'",
"relayopts_l : relayopts_l relayoptsl nl",
"relayopts_l : relayoptsl optnl",
"relayoptsl : LISTEN ON STRING port optssl",
"relayoptsl : forwardmode optsslclient TO forwardspec interface dstaf",
"relayoptsl : SESSION TIMEOUT NUMBER",
"relayoptsl : PROTO STRING",
"relayoptsl : DISABLE",
"relayoptsl : include",
"forwardspec : STRING port retry",
"forwardspec : NAT LOOKUP retry",
"forwardspec : DESTINATION retry",
"forwardspec : tablespec",
"dstmode :",
"dstmode : LOADBALANCE",
"dstmode : ROUNDROBIN",
"dstmode : HASH",
"$$11 :",
"router : ROUTER STRING $$11 '{' optnl routeopts_l '}'",
"routeopts_l : routeopts_l routeoptsl nl",
"routeopts_l : routeoptsl optnl",
"routeoptsl : ROUTE address '/' NUMBER",
"routeoptsl : FORWARD TO tablespec",
"routeoptsl : RTABLE NUMBER",
"routeoptsl : RTLABEL STRING",
"routeoptsl : DISABLE",
"routeoptsl : include",
"dstaf :",
"dstaf : INET",
"dstaf : INET6 STRING",
"interface :",
"interface : INTERFACE STRING",
"$$12 :",
"host : address $$12 opthostflags",
"opthostflags :",
"opthostflags : hostflags_l",
"hostflags_l : hostflags hostflags_l",
"hostflags_l : hostflags",
"hostflags : RETRY NUMBER",
"hostflags : PARENT NUMBER",
"hostflags : PRIORITY NUMBER",
"hostflags : IP TTL NUMBER",
"address : STRING",
"retry :",
"retry : RETRY NUMBER",
"timeout : NUMBER",
"comma : ','",
"comma : nl",
"comma :",
"optnl : '\\n' optnl",
"optnl :",
"nl : '\\n' optnl",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
/* LINTUSED */
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 1707 "parse.y"

struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;

	file->errors++;
	va_start(ap, fmt);
	fprintf(stderr, "%s:%d: ", file->name, yylval.lineno);
	vfprintf(stderr, fmt, ap);
	fprintf(stderr, "\n");
	va_end(ap);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "all",		ALL },
		{ "append",		APPEND },
		{ "backlog",		BACKLOG },
		{ "backup",		BACKUP },
		{ "buffer",		BUFFER },
		{ "ca",			CA },
		{ "cache",		CACHE },
		{ "change",		CHANGE },
		{ "check",		CHECK },
		{ "ciphers",		CIPHERS },
		{ "code",		CODE },
		{ "cookie",		COOKIE },
		{ "demote",		DEMOTE },
		{ "destination",	DESTINATION },
		{ "digest",		DIGEST },
		{ "disable",		DISABLE },
		{ "error",		ERROR },
		{ "expect",		EXPECT },
		{ "external",		EXTERNAL },
		{ "file",		FILENAME },
		{ "filter",		FILTER },
		{ "forward",		FORWARD },
		{ "from",		FROM },
		{ "hash",		HASH },
		{ "header",		HEADER },
		{ "host",		HOST },
		{ "icmp",		ICMP },
		{ "include",		INCLUDE },
		{ "inet",		INET },
		{ "inet6",		INET6 },
		{ "interface",		INTERFACE },
		{ "interval",		INTERVAL },
		{ "ip",			IP },
		{ "label",		LABEL },
		{ "listen",		LISTEN },
		{ "loadbalance",	LOADBALANCE },
		{ "log",		LOG },
		{ "lookup",		LOOKUP },
		{ "mark",		MARK },
		{ "marked",		MARKED },
		{ "match",		MATCH },
		{ "mode",		MODE },
		{ "nat",		NAT },
		{ "no",			NO },
		{ "nodelay",		NODELAY },
		{ "nothing",		NOTHING },
		{ "on",			ON },
		{ "parent",		PARENT },
		{ "path",		PATH },
		{ "port",		PORT },
		{ "prefork",		PREFORK },
		{ "priority",		PRIORITY },
		{ "protocol",		PROTO },
		{ "query",		QUERYSTR },
		{ "real",		REAL },
		{ "redirect",		REDIRECT },
		{ "relay",		RELAY },
		{ "remove",		REMOVE },
		{ "request",		REQUEST },
		{ "response",		RESPONSE },
		{ "retry",		RETRY },
		{ "return",		RETURN },
		{ "roundrobin",		ROUNDROBIN },
		{ "route",		ROUTE },
		{ "router",		ROUTER },
		{ "rtable",		RTABLE },
		{ "rtlabel",		RTLABEL },
		{ "sack",		SACK },
		{ "script",		SCRIPT },
		{ "send",		SEND },
		{ "session",		SESSION },
		{ "socket",		SOCKET },
		{ "splice",		SPLICE },
		{ "ssl",		SSL },
		{ "sticky-address",	STICKYADDR },
		{ "style",		STYLE },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tcp",		TCP },
		{ "timeout",		TIMEOUT },
		{ "to",			TO },
		{ "transparent",	TRANSPARENT },
		{ "trap",		TRAP },
		{ "ttl",		TTL },
		{ "updates",		UPDATES },
		{ "url",		URL },
		{ "virtual",		VIRTUAL },
		{ "with",		WITH }
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define MAXPUSHBACK	128

char	*parsebuf;
int	 parseindex;
char	 pushback_buffer[MAXPUSHBACK];
int	 pushback_index = 0;

int
lgetc(int quotec)
{
	int		c, next;

	if (parsebuf) {
		/* Read character from the parsebuffer instead of input. */
		if (parseindex >= 0) {
			c = parsebuf[parseindex++];
			if (c != '\0')
				return (c);
			parsebuf = NULL;
		} else
			parseindex++;
	}

	if (pushback_index)
		return (pushback_buffer[--pushback_index]);

	if (quotec) {
		if ((c = getc(file->stream)) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = getc(file->stream)) == '\\') {
		next = getc(file->stream);
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	while (c == EOF) {
		if (file == topfile || popfile() == EOF)
			return (EOF);
		c = getc(file->stream);
	}
	return (c);
}

int
lungetc(int c)
{
	if (c == EOF)
		return (EOF);
	if (parsebuf) {
		parseindex--;
		if (parseindex >= 0)
			return (c);
	}
	if (pushback_index < MAXPUSHBACK-1)
		return (pushback_buffer[pushback_index++] = c);
	else
		return (EOF);
}

int
findeol(void)
{
	int	c;

	parsebuf = NULL;

	/* skip to either EOF or the first real EOL */
	while (1) {
		if (pushback_index)
			c = pushback_buffer[--pushback_index];
		else
			c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	char	 buf[8096];
	char	*p, *val;
	int	 quotec, next, c;
	int	 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && parsebuf == NULL) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = (char)c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		parsebuf = val;
		parseindex = 0;
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || c == ' ' || c == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = (char)c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "yylex: strdup");
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ',' && x != '/'))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "yylex: strdup");
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("%s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IRWXG | S_IRWXO)) {
		log_warnx("%s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("%s: malloc", __func__);
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("%s: malloc", __func__);
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("%s: %s", __func__, nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = 1;
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

struct relayd *
parse_config(const char *filename, int opts)
{
	struct sym	*sym, *next;
	struct table	*nexttb;
	struct host	*h, *ph;

	if ((conf = calloc(1, sizeof(*conf))) == NULL ||
	    (conf->sc_tables = calloc(1, sizeof(*conf->sc_tables))) == NULL ||
	    (conf->sc_relays = calloc(1, sizeof(*conf->sc_relays))) == NULL ||
	    (conf->sc_protos = calloc(1, sizeof(*conf->sc_protos))) == NULL ||
	    (conf->sc_routes = calloc(1, sizeof(*conf->sc_routes))) == NULL ||
	    (conf->sc_rts = calloc(1, sizeof(*conf->sc_rts))) == NULL ||
	    (conf->sc_rdrs = calloc(1, sizeof(*conf->sc_rdrs))) == NULL) {
		if (conf != NULL) {
			if (conf->sc_tables != NULL)
				free(conf->sc_tables);
			if (conf->sc_relays != NULL)
				free(conf->sc_relays);
			if (conf->sc_protos != NULL)
				free(conf->sc_protos);
			if (conf->sc_rdrs != NULL)
				free(conf->sc_rdrs);
			if (conf->sc_rts != NULL)
				free(conf->sc_rts);
			free(conf);
		}
		log_warn("%s: cannot allocate memory", __func__);
		return (NULL);
	}

	errors = 0;
	last_host_id = last_table_id = last_rdr_id = last_proto_id =
	    last_relay_id = last_rt_id = last_nr_id = 0;

	rdr = NULL;
	table = NULL;
	rlay = NULL;
	proto = NULL;
	router = NULL;

	TAILQ_INIT(conf->sc_rdrs);
	TAILQ_INIT(conf->sc_tables);
	TAILQ_INIT(conf->sc_protos);
	TAILQ_INIT(conf->sc_relays);
	TAILQ_INIT(conf->sc_rts);
	TAILQ_INIT(conf->sc_routes);

	memset(&conf->sc_empty_table, 0, sizeof(conf->sc_empty_table));
	conf->sc_empty_table.conf.id = EMPTY_TABLE;
	conf->sc_empty_table.conf.flags |= F_DISABLE;
	(void)strlcpy(conf->sc_empty_table.conf.name, "empty",
	    sizeof(conf->sc_empty_table.conf.name));

	bzero(&conf->sc_proto_default, sizeof(conf->sc_proto_default));
	conf->sc_proto_default.flags = F_USED;
	conf->sc_proto_default.cache = RELAY_CACHESIZE;
	conf->sc_proto_default.tcpflags = TCPFLAG_DEFAULT;
	conf->sc_proto_default.tcpbacklog = RELAY_BACKLOG;
	conf->sc_proto_default.sslflags = SSLFLAG_DEFAULT;
	(void)strlcpy(conf->sc_proto_default.sslciphers, SSLCIPHERS_DEFAULT,
	    sizeof(conf->sc_proto_default.sslciphers));
	conf->sc_proto_default.type = RELAY_PROTO_TCP;
	(void)strlcpy(conf->sc_proto_default.name, "default",
	    sizeof(conf->sc_proto_default.name));
	RB_INIT(&conf->sc_proto_default.request_tree);
	RB_INIT(&conf->sc_proto_default.response_tree);

	conf->sc_timeout.tv_sec = CHECK_TIMEOUT / 1000;
	conf->sc_timeout.tv_usec = (CHECK_TIMEOUT % 1000) * 1000;
	conf->sc_interval.tv_sec = CHECK_INTERVAL;
	conf->sc_interval.tv_usec = 0;
	conf->sc_prefork_relay = RELAY_NUMPROC;
	conf->sc_statinterval.tv_sec = RELAY_STATINTERVAL;
	conf->sc_opts = opts;
	conf->sc_confpath = filename;

	if ((file = pushfile(filename, 0)) == NULL) {
		free(conf);
		return (NULL);
	}
	topfile = file;
	setservent(1);

	yyparse();
	errors = file->errors;
	popfile();

	endservent();
	endprotoent();

	/* Free macros and check which have not been used. */
	for (sym = TAILQ_FIRST(&symhead); sym != NULL; sym = next) {
		next = TAILQ_NEXT(sym, entry);
		if ((conf->sc_opts & RELAYD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rdrs) &&
	    TAILQ_EMPTY(conf->sc_relays) &&
	    TAILQ_EMPTY(conf->sc_rts)) {
		log_warnx("no actions, nothing to do");
		errors++;
	}

	if (TAILQ_EMPTY(conf->sc_relays))
		conf->sc_prefork_relay = 0;

	/* Cleanup relay list to inherit */
	while ((rlay = TAILQ_FIRST(&relays)) != NULL) {
		TAILQ_REMOVE(&relays, rlay, rl_entry);
		free(rlay);
	}

	if (timercmp(&conf->sc_timeout, &conf->sc_interval, >=)) {
		log_warnx("global timeout exceeds interval");
		errors++;
	}

	/* Verify that every table is used */
	for (table = TAILQ_FIRST(conf->sc_tables); table != NULL;
	     table = nexttb) {
		nexttb = TAILQ_NEXT(table, entry);
		if (table->conf.port == 0) {
			TAILQ_REMOVE(conf->sc_tables, table, entry);
			while ((h = TAILQ_FIRST(&table->hosts)) != NULL) {
				TAILQ_REMOVE(&table->hosts, h, entry);
				free(h);
			}
			if (table->sendbuf != NULL)
				free(table->sendbuf);
			free(table);
			continue;
		}

		TAILQ_FOREACH(h, &table->hosts, entry) {
			if (h->conf.parentid) {
				ph = host_find(conf, h->conf.parentid);

				/* Validate the parent id */
				if (h->conf.id == h->conf.parentid ||
				    ph == NULL || ph->conf.parentid)
					ph = NULL;

				if (ph == NULL) {
					log_warnx("host parent id %d invalid",
					    h->conf.parentid);
					errors++;
				} else
					SLIST_INSERT_HEAD(&ph->children,
					    h, child);
			}
		}

		if (!(table->conf.flags & F_USED)) {
			log_warnx("unused table: %s", table->conf.name);
			errors++;
		}
		if (timercmp(&table->conf.timeout, &conf->sc_interval, >=)) {
			log_warnx("table timeout exceeds interval: %s",
			    table->conf.name);
			errors++;
		}
	}

	/* Verify that every non-default protocol is used */
	TAILQ_FOREACH(proto, conf->sc_protos, entry) {
		if (!(proto->flags & F_USED)) {
			log_warnx("unused protocol: %s", proto->name);
		}
	}

	if (errors) {
		free(conf);
		return (NULL);
	}

	return (conf);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	for (sym = TAILQ_FIRST(&symhead); sym && strcmp(nam, sym->nam);
	    sym = TAILQ_NEXT(sym, entry))
		;	/* nothing */

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;
	size_t	len;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);

	len = strlen(s) - strlen(val) + 1;
	if ((sym = malloc(len)) == NULL)
		errx(1, "cmdline_symset: malloc");

	(void)strlcpy(sym, s, len);

	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry)
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	return (NULL);
}

struct address *
host_v4(const char *s)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct address		*h;

	bzero(&ina, sizeof(ina));
	if (inet_pton(AF_INET, s, &ina) != 1)
		return (NULL);

	if ((h = calloc(1, sizeof(*h))) == NULL)
		fatal(NULL);
	sain = (struct sockaddr_in *)&h->ss;
	sain->sin_len = sizeof(struct sockaddr_in);
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;

	return (h);
}

struct address *
host_v6(const char *s)
{
	struct addrinfo		 hints, *res;
	struct sockaddr_in6	*sa_in6;
	struct address		*h = NULL;

	bzero(&hints, sizeof(hints));
	hints.ai_family = AF_INET6;
	hints.ai_socktype = SOCK_DGRAM; /* dummy */
	hints.ai_flags = AI_NUMERICHOST;
	if (getaddrinfo(s, "0", &hints, &res) == 0) {
		if ((h = calloc(1, sizeof(*h))) == NULL)
			fatal(NULL);
		sa_in6 = (struct sockaddr_in6 *)&h->ss;
		sa_in6->sin6_len = sizeof(struct sockaddr_in6);
		sa_in6->sin6_family = AF_INET6;
		memcpy(&sa_in6->sin6_addr,
		    &((struct sockaddr_in6 *)res->ai_addr)->sin6_addr,
		    sizeof(sa_in6->sin6_addr));
		sa_in6->sin6_scope_id =
		    ((struct sockaddr_in6 *)res->ai_addr)->sin6_scope_id;

		freeaddrinfo(res);
	}

	return (h);
}

int
host_dns(const char *s, struct addresslist *al, int max,
    struct portrange *port, const char *ifname, int ipproto)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct address		*h;

	if ((cnt = host_if(s, al, max, port, ifname, ipproto)) != 0)
		return (cnt);

	bzero(&hints, sizeof(hints));
	hints.ai_family = PF_UNSPEC;
	hints.ai_socktype = SOCK_DGRAM; /* DUMMY */
	error = getaddrinfo(s, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("%s: could not parse \"%s\": %s", __func__, s,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res && cnt < max; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		if ((h = calloc(1, sizeof(*h))) == NULL)
			fatal(NULL);

		if (port != NULL)
			bcopy(port, &h->port, sizeof(h->port));
		if (ifname != NULL) {
			if (strlcpy(h->ifname, ifname, sizeof(h->ifname)) >=
			    sizeof(h->ifname))
				log_warnx("%s: interface name truncated",
				    __func__);
			freeaddrinfo(res0);
			return (-1);
		}
		if (ipproto != -1)
			h->ipproto = ipproto;
		h->ss.ss_family = res->ai_family;

		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
			sain->sin_len = sizeof(struct sockaddr_in);
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
			sin6->sin6_len = sizeof(struct sockaddr_in6);
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
		}

		TAILQ_INSERT_HEAD(al, h, entry);
		cnt++;
	}
	if (cnt == max && res) {
		log_warnx("%s: %s resolves to more than %d hosts", __func__,
		    s, max);
	}
	freeaddrinfo(res0);
	return (cnt);
}

int
host_if(const char *s, struct addresslist *al, int max,
    struct portrange *port, const char *ifname, int ipproto)
{
	struct ifaddrs		*ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct address		*h;
	int			 cnt = 0, af;

	if (if_nametoindex(s) == 0)
		return (0);

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	/* First search for IPv4 addresses */
	af = AF_INET;

 nextaf:
	for (p = ifap; p != NULL && cnt < max; p = p->ifa_next) {
		if (p->ifa_addr->sa_family != af ||
		    strcmp(s, p->ifa_name) != 0)
			continue;
		if ((h = calloc(1, sizeof(*h))) == NULL)
			fatal("calloc");

		if (port != NULL)
			bcopy(port, &h->port, sizeof(h->port));
		if (ifname != NULL) {
			if (strlcpy(h->ifname, ifname, sizeof(h->ifname)) >=
			    sizeof(h->ifname))
				log_warnx("%s: interface name truncated",
				    __func__);
			freeifaddrs(ifap);
			return (-1);
		}
		if (ipproto != -1)
			h->ipproto = ipproto;
		h->ss.ss_family = af;

		if (af == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
			sain->sin_len = sizeof(struct sockaddr_in);
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    p->ifa_addr)->sin_addr.s_addr;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
			sin6->sin6_len = sizeof(struct sockaddr_in6);
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    p->ifa_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_scope_id = ((struct sockaddr_in6 *)
			    p->ifa_addr)->sin6_scope_id;
		}

		TAILQ_INSERT_HEAD(al, h, entry);
		cnt++;
	}
	if (af == AF_INET) {
		/* Next search for IPv6 addresses */
		af = AF_INET6;
		goto nextaf;
	}

	if (cnt > max) {
		log_warnx("%s: %s resolves to more than %d hosts", __func__,
		    s, max);
	}
	freeifaddrs(ifap);
	return (cnt);
}

int
host(const char *s, struct addresslist *al, int max,
    struct portrange *port, const char *ifname, int ipproto)
{
	struct address *h;

	h = host_v4(s);

	/* IPv6 address? */
	if (h == NULL)
		h = host_v6(s);

	if (h != NULL) {
		if (port != NULL)
			bcopy(port, &h->port, sizeof(h->port));
		if (ifname != NULL) {
			if (strlcpy(h->ifname, ifname, sizeof(h->ifname)) >=
			    sizeof(h->ifname)) {
				log_warnx("%s: interface name truncated",
				    __func__);
				return (-1);
			}
		}
		if (ipproto != -1)
			h->ipproto = ipproto;

		TAILQ_INSERT_HEAD(al, h, entry);
		return (1);
	}

	return (host_dns(s, al, max, port, ifname, ipproto));
}

struct table *
table_inherit(struct table *tb)
{
	char		pname[TABLE_NAME_SIZE + 6];
	struct host	*h, *dsth;
	struct table	*dsttb, *oldtb;

	/* Get the table or table template */
	if ((dsttb = table_findbyname(conf, tb->conf.name)) == NULL) {
		yyerror("unknown table %s", tb->conf.name);
		purge_table(NULL, tb);
		return (NULL);
	}
	if (dsttb->conf.port != 0)
		fatal("invalid table");	/* should not happen */

	if (tb->conf.port == 0) {
		yyerror("invalid port");
		purge_table(NULL, tb);
		return (NULL);
	}

	/* Check if a matching table already exists */
	if (snprintf(pname, sizeof(pname), "%s:%u",
	    tb->conf.name, ntohs(tb->conf.port)) >= (int)sizeof(pname)) {
		yyerror("invalid table name");
		return (NULL);
	}
	(void)strlcpy(tb->conf.name, pname, sizeof(tb->conf.name));
	if ((oldtb = table_findbyconf(conf, tb)) != NULL) {
		purge_table(NULL, tb);
		return (oldtb);
	}

	/* Create a new table */
	tb->conf.id = ++last_table_id;
	if (last_table_id == INT_MAX) {
		yyerror("too many tables defined");
		purge_table(NULL, tb);
		return (NULL);
	}
	tb->conf.flags |= dsttb->conf.flags;

	/* Inherit global table options */
	bcopy(&dsttb->conf.timeout, &tb->conf.timeout, sizeof(struct timeval));

	/* Copy the associated hosts */
	TAILQ_INIT(&tb->hosts);
	TAILQ_FOREACH(dsth, &dsttb->hosts, entry) {
		if ((h = (struct host *)
		    calloc(1, sizeof (*h))) == NULL)
			fatal("out of memory");
		bcopy(dsth, h, sizeof(*h));
		h->conf.id = ++last_host_id;
		if (last_host_id == INT_MAX) {
			yyerror("too many hosts defined");
			purge_table(NULL, tb);
			return (NULL);
		}
		h->conf.tableid = tb->conf.id;
		h->tablename = tb->conf.name;
		SLIST_INIT(&h->children);
		TAILQ_INSERT_TAIL(&tb->hosts, h, entry);
	}

	conf->sc_tablecount++;
	TAILQ_INSERT_TAIL(conf->sc_tables, tb, entry);

	return (tb);
}

struct relay *
relay_inherit(struct relay *ra, struct relay *rb)
{
	struct relay_config	 rc;

	bcopy(&rb->rl_conf, &rc, sizeof(rc));
	bcopy(ra, rb, sizeof(*rb));

	bcopy(&rc.ss, &rb->rl_conf.ss, sizeof(rb->rl_conf.ss));
	rb->rl_conf.port = rc.port;
	rb->rl_conf.flags =
	    (ra->rl_conf.flags & ~F_SSL) | (rc.flags & F_SSL);

	rb->rl_conf.id = ++last_relay_id;
	if (last_relay_id == INT_MAX) {
		yyerror("too many relays defined");
		goto err;
	}

	if (snprintf(rb->rl_conf.name, sizeof(rb->rl_conf.name), "%s%u:%u",
	    ra->rl_conf.name, rb->rl_conf.id, ntohs(rc.port)) >=
	    (int)sizeof(rb->rl_conf.name)) {
		yyerror("invalid relay name");
		goto err;
	}

	if (relay_findbyname(conf, rb->rl_conf.name) != NULL ||
	    relay_findbyaddr(conf, &rb->rl_conf) != NULL) {
		yyerror("relay %s defined twice", rb->rl_conf.name);
		goto err;
	}
	if (relay_load_certfiles(rb) == -1) {
		yyerror("cannot load certificates for relay %s",
		    rb->rl_conf.name);
		goto err;
	}

	conf->sc_relaycount++;
	SPLAY_INIT(&rlay->rl_sessions);
	TAILQ_INSERT_TAIL(conf->sc_relays, rb, rl_entry);

	return (rb);

 err:
	free(rb);
	return (NULL);
}

int
getservice(char *n)
{
	struct servent	*s;
	const char	*errstr;
	long long	 llval;

	llval = strtonum(n, 0, UINT16_MAX, &errstr);
	if (errstr) {
		s = getservbyname(n, "tcp");
		if (s == NULL)
			s = getservbyname(n, "udp");
		if (s == NULL) {
			yyerror("unknown port %s", n);
			return (-1);
		}
		return (s->s_port);
	}

	return (htons((u_short)llval));
}
#line 1930 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
#if defined(__cplusplus) || defined(__STDC__)
static int yygrowstack(void)
#else
static int yygrowstack()
#endif
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
#ifdef SIZE_MAX
#define YY_SIZE_MAX SIZE_MAX
#else
#define YY_SIZE_MAX 0xffffffffU
#endif
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newss)
        goto bail;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss); /* overflow check above */
    if (newss == NULL)
        goto bail;
    yyss = newss;
    yyssp = newss + i;
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newvs)
        goto bail;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs); /* overflow check above */
    if (newvs == NULL)
        goto bail;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
bail:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return -1;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__cplusplus) || defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    int yym, yyn, yystate;
#if YYDEBUG
#if defined(__cplusplus) || defined(__STDC__)
    const char *yys;
#else /* !(defined(__cplusplus) || defined(__STDC__)) */
    char *yys;
#endif /* !(defined(__cplusplus) || defined(__STDC__)) */

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif /* YYDEBUG */

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 11:
#line 180 "parse.y"
{ file->errors++; }
break;
case 12:
#line 183 "parse.y"
{
			struct file	*nfile;

			if ((nfile = pushfile(yyvsp[0].v.string, 0)) == NULL) {
				yyerror("failed to include file %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);

			file = nfile;
			lungetc('\n');
		}
break;
case 13:
#line 198 "parse.y"
{ yyval.v.number = 0; }
break;
case 14:
#line 199 "parse.y"
{ yyval.v.number = 1; }
break;
case 15:
#line 202 "parse.y"
{ yyval.v.number = 0; }
break;
case 16:
#line 203 "parse.y"
{ yyval.v.number = 1; }
break;
case 17:
#line 206 "parse.y"
{
			if (strcmp("https", yyvsp[0].v.string) == 0) {
				yyval.v.number = 1;
			} else if (strcmp("http", yyvsp[0].v.string) == 0) {
				yyval.v.number = 0;
			} else {
				yyerror("invalid check type: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
		}
break;
case 18:
#line 220 "parse.y"
{
			yyval.v.string = strdup("");
			if (yyval.v.string == NULL)
				fatal("calloc");
		}
break;
case 19:
#line 225 "parse.y"
{
			if (asprintf(&yyval.v.string, "Host: %s\r\nConnection: close\r\n",
			    yyvsp[0].v.string) == -1)
				fatal("asprintf");
		}
break;
case 20:
#line 232 "parse.y"
{ yyval.v.number = RELAY_PROTO_TCP; }
break;
case 21:
#line 233 "parse.y"
{ yyval.v.number = RELAY_PROTO_TCP; }
break;
case 22:
#line 234 "parse.y"
{
			if (strcmp("http", yyvsp[0].v.string) == 0) {
				yyval.v.number = RELAY_PROTO_HTTP;
			} else if (strcmp("dns", yyvsp[0].v.string) == 0) {
				yyval.v.number = RELAY_PROTO_DNS;
			} else {
				yyerror("invalid protocol type: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
		}
break;
case 23:
#line 248 "parse.y"
{ yyval.v.number = IPPROTO_TCP; }
break;
case 24:
#line 249 "parse.y"
{ yyval.v.number = IPPROTO_TCP; }
break;
case 25:
#line 250 "parse.y"
{
			struct protoent	*p;

			if ((p = getprotobyname(yyvsp[0].v.string)) == NULL) {
				yyerror("invalid protocol: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);

			yyval.v.number = p->p_proto;
		}
break;
case 30:
#line 273 "parse.y"
{
			if ((proto->style = strdup(yyvsp[0].v.string)) == NULL)
				fatal("out of memory");
			free(yyvsp[0].v.string);
		}
break;
case 31:
#line 280 "parse.y"
{
			char		*a, *b;
			int		 p[2];

			p[0] = p[1] = 0;

			a = yyvsp[0].v.string;
			b = strchr(yyvsp[0].v.string, ':');
			if (b == NULL)
				yyval.v.port.op = PF_OP_EQ;
			else {
				*b++ = '\0';
				if ((p[1] = getservice(b)) == -1) {
					free(yyvsp[0].v.string);
					YYERROR;
				}
				yyval.v.port.op = PF_OP_RRG;
			}
			if ((p[0] = getservice(a)) == -1) {
				free(yyvsp[0].v.string);
				YYERROR;
			}
			yyval.v.port.val[0] = p[0];
			yyval.v.port.val[1] = p[1];
			free(yyvsp[0].v.string);
		}
break;
case 32:
#line 306 "parse.y"
{
			if (yyvsp[0].v.number <= 0 || yyvsp[0].v.number >= (int)USHRT_MAX) {
				yyerror("invalid port: %d", yyvsp[0].v.number);
				YYERROR;
			}
			yyval.v.port.val[0] = htons(yyvsp[0].v.number);
			yyval.v.port.op = PF_OP_EQ;
		}
break;
case 33:
#line 316 "parse.y"
{
			if (symset(yyvsp[-2].v.string, yyvsp[0].v.string, 0) == -1)
				fatal("cannot store variable");
			free(yyvsp[-2].v.string);
			free(yyvsp[0].v.string);
		}
break;
case 34:
#line 324 "parse.y"
{
			table->sendbuf = NULL;
			table->sendbuf_len = 0;
		}
break;
case 35:
#line 328 "parse.y"
{
			table->sendbuf = strdup(yyvsp[0].v.string);
			if (table->sendbuf == NULL)
				fatal("out of memory");
			table->sendbuf_len = strlen(table->sendbuf);
			free(yyvsp[0].v.string);
		}
break;
case 36:
#line 337 "parse.y"
{
			if ((conf->sc_interval.tv_sec = yyvsp[0].v.number) < 0) {
				yyerror("invalid interval: %d", yyvsp[0].v.number);
				YYERROR;
			}
		}
break;
case 37:
#line 343 "parse.y"
{ conf->sc_opts |= yyvsp[0].v.number; }
break;
case 38:
#line 344 "parse.y"
{
			bcopy(&yyvsp[0].v.tv, &conf->sc_timeout, sizeof(struct timeval));
		}
break;
case 39:
#line 347 "parse.y"
{
			if (yyvsp[0].v.number <= 0 || yyvsp[0].v.number > RELAY_MAXPROC) {
				yyerror("invalid number of preforked "
				    "relays: %d", yyvsp[0].v.number);
				YYERROR;
			}
			conf->sc_prefork_relay = yyvsp[0].v.number;
		}
break;
case 40:
#line 355 "parse.y"
{
			conf->sc_flags |= F_DEMOTE;
			if (strlcpy(conf->sc_demote_group, yyvsp[0].v.string,
			    sizeof(conf->sc_demote_group))
			    >= sizeof(conf->sc_demote_group)) {
				yyerror("yyparse: demote group name too long");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			if (carp_demote_init(conf->sc_demote_group, 1) == -1) {
				yyerror("yyparse: error initializing group %s",
				    conf->sc_demote_group);
				YYERROR;
			}
		}
break;
case 41:
#line 371 "parse.y"
{ conf->sc_flags |= F_TRAP; }
break;
case 42:
#line 374 "parse.y"
{ yyval.v.number = RELAYD_OPT_LOGUPDATE; }
break;
case 43:
#line 375 "parse.y"
{ yyval.v.number = RELAYD_OPT_LOGALL; }
break;
case 44:
#line 378 "parse.y"
{
			struct rdr *srv;

			conf->sc_flags |= F_NEEDPF;
			TAILQ_FOREACH(srv, conf->sc_rdrs, entry)
				if (!strcmp(srv->conf.name, yyvsp[0].v.string))
					break;
			if (srv != NULL) {
				yyerror("redirection %s defined twice", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			if ((srv = calloc(1, sizeof (*srv))) == NULL)
				fatal("out of memory");

			if (strlcpy(srv->conf.name, yyvsp[0].v.string,
			    sizeof(srv->conf.name)) >=
			    sizeof(srv->conf.name)) {
				yyerror("redirection name truncated");
				free(srv);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			srv->conf.id = ++last_rdr_id;
			srv->conf.timeout.tv_sec = RELAY_TIMEOUT;
			if (last_rdr_id == INT_MAX) {
				yyerror("too many redirections defined");
				free(srv);
				YYERROR;
			}
			rdr = srv;
		}
break;
case 45:
#line 409 "parse.y"
{
			if (rdr->table == NULL) {
				yyerror("redirection %s has no table",
				    rdr->conf.name);
				YYERROR;
			}
			if (TAILQ_EMPTY(&rdr->virts)) {
				yyerror("redirection %s has no virtual ip",
				    rdr->conf.name);
				YYERROR;
			}
			conf->sc_rdrcount++;
			if (rdr->backup == NULL) {
				rdr->conf.backup_id =
				    conf->sc_empty_table.conf.id;
				rdr->backup = &conf->sc_empty_table;
			} else if (rdr->backup->conf.port !=
			    rdr->table->conf.port) {
				yyerror("redirection %s uses two different "
				    "ports for its table and backup table",
				    rdr->conf.name);
				YYERROR;
			}
			if (!(rdr->conf.flags & F_DISABLE))
				rdr->conf.flags |= F_ADD;
			TAILQ_INSERT_TAIL(conf->sc_rdrs, rdr, entry);
			tableport = 0;
			rdr = NULL;
		}
break;
case 48:
#line 444 "parse.y"
{
			switch (yyvsp[-3].v.number) {
			case FWD_NORMAL:
				if (yyvsp[0].v.string == NULL)
					break;
				yyerror("superfluous interface");
				YYERROR;
			case FWD_ROUTE:
				if (yyvsp[0].v.string != NULL)
					break;
				yyerror("missing interface to route to");
				YYERROR;
			case FWD_TRANS:
				yyerror("no transparent forward here");
				YYERROR;
			}
			if (yyvsp[0].v.string != NULL) {
				strlcpy(yyvsp[-1].v.table->conf.ifname, yyvsp[0].v.string,
				    sizeof(yyvsp[-1].v.table->conf.ifname));
				free(yyvsp[0].v.string);
			}

			if (yyvsp[-1].v.table->conf.check == CHECK_NOCHECK) {
				yyerror("table %s has no check", yyvsp[-1].v.table->conf.name);
				purge_table(conf->sc_tables, yyvsp[-1].v.table);
				YYERROR;
			}
			if (rdr->backup) {
				yyerror("only one backup table is allowed");
				purge_table(conf->sc_tables, yyvsp[-1].v.table);
				YYERROR;
			}
			if (rdr->table) {
				rdr->backup = yyvsp[-1].v.table;
				rdr->conf.backup_id = yyvsp[-1].v.table->conf.id;
			} else {
				rdr->table = yyvsp[-1].v.table;
				rdr->conf.table_id = yyvsp[-1].v.table->conf.id;
			}
			yyvsp[-1].v.table->conf.fwdmode = yyvsp[-3].v.number;
			yyvsp[-1].v.table->conf.rdrid = rdr->conf.id;
			yyvsp[-1].v.table->conf.flags |= F_USED;
		}
break;
case 49:
#line 487 "parse.y"
{
			if (host(yyvsp[-3].v.string, &rdr->virts,
			    SRV_MAX_VIRTS, &yyvsp[-1].v.port, yyvsp[0].v.string, yyvsp[-2].v.number) <= 0) {
				yyerror("invalid virtual ip: %s", yyvsp[-3].v.string);
				free(yyvsp[-3].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[-3].v.string);
			free(yyvsp[0].v.string);
			if (rdr->conf.port == 0)
				rdr->conf.port = yyvsp[-1].v.port.val[0];
			tableport = rdr->conf.port;
		}
break;
case 50:
#line 501 "parse.y"
{ rdr->conf.flags |= F_DISABLE; }
break;
case 51:
#line 502 "parse.y"
{ rdr->conf.flags |= F_STICKY; }
break;
case 52:
#line 503 "parse.y"
{
			conf->sc_flags |= F_NEEDPF;
			if (strlcpy(rdr->conf.tag, yyvsp[0].v.string,
			    sizeof(rdr->conf.tag)) >=
			    sizeof(rdr->conf.tag)) {
				yyerror("redirection tag name truncated");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			if (yyvsp[-2].v.number)
				rdr->conf.flags |= F_MATCH;
			free(yyvsp[0].v.string);
		}
break;
case 53:
#line 516 "parse.y"
{
			if ((rdr->conf.timeout.tv_sec = yyvsp[0].v.number) < 0) {
				yyerror("invalid timeout: %d", yyvsp[0].v.number);
				YYERROR;
			}
		}
break;
case 55:
#line 525 "parse.y"
{ yyval.v.number = 0; }
break;
case 56:
#line 526 "parse.y"
{ yyval.v.number = 1; }
break;
case 57:
#line 529 "parse.y"
{ yyval.v.number = FWD_NORMAL; }
break;
case 58:
#line 530 "parse.y"
{ yyval.v.number = FWD_ROUTE; }
break;
case 59:
#line 531 "parse.y"
{ yyval.v.number = FWD_TRANS; }
break;
case 60:
#line 534 "parse.y"
{
			if (strlen(yyvsp[-1].v.string) >= TABLE_NAME_SIZE) {
				yyerror("invalid table name");
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			yyval.v.string = yyvsp[-1].v.string;
		}
break;
case 61:
#line 544 "parse.y"
{
			struct table *tb;

			TAILQ_FOREACH(tb, conf->sc_tables, entry)
				if (!strcmp(tb->conf.name, yyvsp[0].v.string))
					break;
			if (tb != NULL) {
				yyerror("table %s defined twice", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}

			if ((tb = calloc(1, sizeof (*tb))) == NULL)
				fatal("out of memory");

			(void)strlcpy(tb->conf.name, yyvsp[0].v.string, sizeof(tb->conf.name));
			free(yyvsp[0].v.string);

			tb->conf.id = 0; /* will be set later */
			bcopy(&conf->sc_timeout, &tb->conf.timeout,
			    sizeof(struct timeval));
			TAILQ_INIT(&tb->hosts);
			table = tb;
		}
break;
case 62:
#line 567 "parse.y"
{
			if (TAILQ_EMPTY(&table->hosts)) {
				yyerror("table %s has no hosts",
				    table->conf.name);
				YYERROR;
			}
			conf->sc_tablecount++;
			TAILQ_INSERT_TAIL(conf->sc_tables, table, entry);
		}
break;
case 65:
#line 582 "parse.y"
{ table->conf.flags |= F_DISABLE; }
break;
case 69:
#line 590 "parse.y"
{
			yyvsp[0].v.host->conf.tableid = table->conf.id;
			yyvsp[0].v.host->tablename = table->conf.name;
			TAILQ_INSERT_TAIL(&table->hosts, yyvsp[0].v.host, entry);
		}
break;
case 71:
#line 598 "parse.y"
{
			struct table	*tb;
			if ((tb = calloc(1, sizeof (*tb))) == NULL)
				fatal("out of memory");
			(void)strlcpy(tb->conf.name, yyvsp[0].v.string, sizeof(tb->conf.name));
			free(yyvsp[0].v.string);
			table = tb;
		}
break;
case 72:
#line 605 "parse.y"
{
			struct table	*tb;
			if (table->conf.port == 0)
				table->conf.port = tableport;
			else
				table->conf.flags |= F_PORT;
			if ((tb = table_inherit(table)) == NULL)
				YYERROR;
			yyval.v.table = tb;
		}
break;
case 76:
#line 622 "parse.y"
{
			if (yyvsp[0].v.port.op != PF_OP_EQ) {
				yyerror("invalid port");
				YYERROR;
			}
			table->conf.port = yyvsp[0].v.port.val[0];
		}
break;
case 77:
#line 629 "parse.y"
{
			bcopy(&yyvsp[0].v.tv, &table->conf.timeout,
			    sizeof(struct timeval));
		}
break;
case 78:
#line 633 "parse.y"
{
			table->conf.flags |= F_DEMOTE;
			if (strlcpy(table->conf.demote_group, yyvsp[0].v.string,
			    sizeof(table->conf.demote_group))
			    >= sizeof(table->conf.demote_group)) {
				yyerror("yyparse: demote group name too long");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			if (carp_demote_init(table->conf.demote_group, 1)
			    == -1) {
				yyerror("yyparse: error initializing group "
				    "'%s'", table->conf.demote_group);
				YYERROR;
			}
		}
break;
case 79:
#line 650 "parse.y"
{
			if (yyvsp[0].v.number < conf->sc_interval.tv_sec ||
			    yyvsp[0].v.number % conf->sc_interval.tv_sec) {
				yyerror("table interval must be "
				    "divisible by global interval");
				YYERROR;
			}
			table->conf.skip_cnt = (yyvsp[0].v.number / conf->sc_interval.tv_sec) - 1;
		}
break;
case 80:
#line 659 "parse.y"
{
			switch (yyvsp[0].v.number) {
			case RELAY_DSTMODE_LOADBALANCE:
			case RELAY_DSTMODE_HASH:
				if (rdr != NULL) {
					yyerror("mode not supported "
					    "for redirections");
					YYERROR;
				}
				/* FALLTHROUGH */
			case RELAY_DSTMODE_ROUNDROBIN:
				if (rlay != NULL)
					rlay->rl_conf.dstmode = yyvsp[0].v.number;
				break;
			}
		}
break;
case 81:
#line 677 "parse.y"
{ table->conf.check = CHECK_ICMP; }
break;
case 82:
#line 678 "parse.y"
{ table->conf.check = CHECK_TCP; }
break;
case 83:
#line 679 "parse.y"
{
			table->conf.check = CHECK_TCP;
			conf->sc_flags |= F_SSL;
			table->conf.flags |= F_SSL;
		}
break;
case 84:
#line 684 "parse.y"
{
			if (yyvsp[-4].v.number) {
				conf->sc_flags |= F_SSL;
				table->conf.flags |= F_SSL;
			}
			table->conf.check = CHECK_HTTP_CODE;
			if ((table->conf.retcode = yyvsp[0].v.number) <= 0) {
				yyerror("invalid HTTP code: %d", yyvsp[0].v.number);
				free(yyvsp[-3].v.string);
				free(yyvsp[-2].v.string);
				YYERROR;
			}
			if (asprintf(&table->sendbuf,
			    "HEAD %s HTTP/1.%c\r\n%s\r\n",
			    yyvsp[-3].v.string, strlen(yyvsp[-2].v.string) ? '1' : '0', yyvsp[-2].v.string) == -1)
				fatal("asprintf");
			free(yyvsp[-3].v.string);
			free(yyvsp[-2].v.string);
			if (table->sendbuf == NULL)
				fatal("out of memory");
			table->sendbuf_len = strlen(table->sendbuf);
		}
break;
case 85:
#line 706 "parse.y"
{
			if (yyvsp[-3].v.number) {
				conf->sc_flags |= F_SSL;
				table->conf.flags |= F_SSL;
			}
			table->conf.check = CHECK_HTTP_DIGEST;
			if (asprintf(&table->sendbuf,
			    "GET %s HTTP/1.%c\r\n%s\r\n",
			    yyvsp[-2].v.string, strlen(yyvsp[-1].v.string) ? '1' : '0', yyvsp[-1].v.string) == -1)
				fatal("asprintf");
			free(yyvsp[-2].v.string);
			free(yyvsp[-1].v.string);
			if (table->sendbuf == NULL)
				fatal("out of memory");
			table->sendbuf_len = strlen(table->sendbuf);
			(void)strlcpy(table->conf.digest, yyvsp[0].v.digest.digest,
			    sizeof(table->conf.digest));
			table->conf.digest_type = yyvsp[0].v.digest.type;
			free(yyvsp[0].v.digest.digest);
		}
break;
case 86:
#line 726 "parse.y"
{
			table->conf.check = CHECK_SEND_EXPECT;
			if (yyvsp[0].v.number) {
				conf->sc_flags |= F_SSL;
				table->conf.flags |= F_SSL;
			}
			if (strlcpy(table->conf.exbuf, yyvsp[-1].v.string,
			    sizeof(table->conf.exbuf))
			    >= sizeof(table->conf.exbuf)) {
				yyerror("yyparse: expect buffer truncated");
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			translate_string(table->conf.exbuf);
			free(yyvsp[-1].v.string);
		}
break;
case 87:
#line 742 "parse.y"
{
			table->conf.check = CHECK_SCRIPT;
			if (strlcpy(table->conf.path, yyvsp[0].v.string,
			    sizeof(table->conf.path)) >=
			    sizeof(table->conf.path)) {
				yyerror("script path truncated");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
		}
break;
case 88:
#line 756 "parse.y"
{
			switch (strlen(yyvsp[0].v.string)) {
			case 40:
				yyval.v.digest.type = DIGEST_SHA1;
				break;
			case 32:
				yyval.v.digest.type = DIGEST_MD5;
				break;
			default:
				yyerror("invalid http digest");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			yyval.v.digest.digest = yyvsp[0].v.string;
		}
break;
case 89:
#line 773 "parse.y"
{
			struct protocol *p;

			if (strcmp(yyvsp[0].v.string, "default") == 0) {
				p = &conf->sc_proto_default;
			} else {
				TAILQ_FOREACH(p, conf->sc_protos, entry)
					if (!strcmp(p->name, yyvsp[0].v.string))
						break;
			}
			if (p != NULL) {
				yyerror("protocol %s defined twice", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			if ((p = calloc(1, sizeof (*p))) == NULL)
				fatal("out of memory");

			if (strlcpy(p->name, yyvsp[0].v.string, sizeof(p->name)) >=
			    sizeof(p->name)) {
				yyerror("protocol name truncated");
				free(p);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			p->id = ++last_proto_id;
			p->type = yyvsp[-2].v.number;
			p->cache = RELAY_CACHESIZE;
			p->tcpflags = TCPFLAG_DEFAULT;
			if (p->type != RELAY_PROTO_TCP) {
				/*
				 * Splicing is currently only supported
				 * for plain TCP relays.
				 */
				p->tcpflags |= TCPFLAG_NSPLICE;
			}
			p->sslflags = SSLFLAG_DEFAULT;
			p->tcpbacklog = RELAY_BACKLOG;
			(void)strlcpy(p->sslciphers, SSLCIPHERS_DEFAULT,
			    sizeof(p->sslciphers));
			if (last_proto_id == INT_MAX) {
				yyerror("too many protocols defined");
				free(p);
				YYERROR;
			}
			RB_INIT(&p->request_tree);
			RB_INIT(&p->response_tree);
			proto = p;
		}
break;
case 90:
#line 821 "parse.y"
{
			conf->sc_protocount++;

			if ((proto->sslflags & SSLFLAG_VERSION) == 0) {
				yyerror("invalid SSL protocol");
				YYERROR;
			}

			TAILQ_INSERT_TAIL(conf->sc_protos, proto, entry);
		}
break;
case 100:
#line 846 "parse.y"
{ proto->flags |= F_RETURN; }
break;
case 101:
#line 847 "parse.y"
{ proto->flags |= F_RETURN; }
break;
case 102:
#line 848 "parse.y"
{
			label = pn_name2id(yyvsp[0].v.string);
			free(yyvsp[0].v.string);
			if (label == 0) {
				yyerror("invalid protocol action label");
				YYERROR;
			}
		}
break;
case 103:
#line 856 "parse.y"
{
			label = 0;
		}
break;
case 104:
#line 859 "parse.y"
{
			node.label = label;
			nodedirection = yyvsp[0].v.number;
		}
break;
case 105:
#line 862 "parse.y"
{
			if (nodedirection != -1 &&
			    protonode_add(nodedirection, proto, &node) == -1) {
				yyerror("failed to add protocol node");
				YYERROR;
			}
			bzero(&node, sizeof(node));
		}
break;
case 107:
#line 873 "parse.y"
{ yyval.v.number = RELAY_DIR_REQUEST; }
break;
case 108:
#line 874 "parse.y"
{ yyval.v.number = RELAY_DIR_REQUEST; }
break;
case 109:
#line 875 "parse.y"
{ yyval.v.number = RELAY_DIR_RESPONSE; }
break;
case 112:
#line 882 "parse.y"
{ proto->tcpflags |= TCPFLAG_SACK; }
break;
case 113:
#line 883 "parse.y"
{ proto->tcpflags |= TCPFLAG_NSACK; }
break;
case 114:
#line 884 "parse.y"
{ proto->tcpflags |= TCPFLAG_NODELAY; }
break;
case 115:
#line 885 "parse.y"
{ proto->tcpflags |= TCPFLAG_NNODELAY; }
break;
case 116:
#line 886 "parse.y"
{ /* default */ }
break;
case 117:
#line 887 "parse.y"
{ proto->tcpflags |= TCPFLAG_NSPLICE; }
break;
case 118:
#line 888 "parse.y"
{
			if (yyvsp[0].v.number < 0 || yyvsp[0].v.number > RELAY_MAX_SESSIONS) {
				yyerror("invalid backlog: %d", yyvsp[0].v.number);
				YYERROR;
			}
			proto->tcpbacklog = yyvsp[0].v.number;
		}
break;
case 119:
#line 895 "parse.y"
{
			proto->tcpflags |= TCPFLAG_BUFSIZ;
			if ((proto->tcpbufsiz = yyvsp[0].v.number) < 0) {
				yyerror("invalid socket buffer size: %d", yyvsp[0].v.number);
				YYERROR;
			}
		}
break;
case 120:
#line 902 "parse.y"
{
			if (yyvsp[0].v.number < 0) {
				yyerror("invalid ttl: %d", yyvsp[0].v.number);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			if (strcasecmp("ttl", yyvsp[-1].v.string) == 0) {
				proto->tcpflags |= TCPFLAG_IPTTL;
				proto->tcpipttl = yyvsp[0].v.number;
			} else if (strcasecmp("minttl", yyvsp[-1].v.string) == 0) {
				proto->tcpflags |= TCPFLAG_IPMINTTL;
				proto->tcpipminttl = yyvsp[0].v.number;
			} else {
				yyerror("invalid TCP/IP flag: %s", yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			free(yyvsp[-1].v.string);
		}
break;
case 123:
#line 927 "parse.y"
{ proto->cache = yyvsp[0].v.number; }
break;
case 124:
#line 928 "parse.y"
{
			if (strlcpy(proto->sslciphers, yyvsp[0].v.string,
			    sizeof(proto->sslciphers)) >=
			    sizeof(proto->sslciphers)) {
				yyerror("sslciphers truncated");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
		}
break;
case 125:
#line 938 "parse.y"
{
			if (proto->sslca != NULL) {
				yyerror("sslca already specified");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			proto->sslca = yyvsp[0].v.string;
		}
break;
case 126:
#line 946 "parse.y"
{ proto->sslflags &= ~(yyvsp[0].v.number); }
break;
case 127:
#line 947 "parse.y"
{ proto->sslflags |= yyvsp[0].v.number; }
break;
case 128:
#line 950 "parse.y"
{
			if (strcmp("sslv2", yyvsp[0].v.string) == 0)
				yyval.v.number = SSLFLAG_SSLV2;
			else if (strcmp("sslv3", yyvsp[0].v.string) == 0)
				yyval.v.number = SSLFLAG_SSLV3;
			else if (strcmp("tlsv1", yyvsp[0].v.string) == 0)
				yyval.v.number = SSLFLAG_TLSV1;
			else {
				yyerror("invalid SSL flag: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
		}
break;
case 129:
#line 966 "parse.y"
{
			node.action = NODE_ACTION_APPEND;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = strdup(yyvsp[-3].v.string);
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			if (strchr(node.value, '$') != NULL)
				node.flags |= PNFLAG_MACRO;
			free(yyvsp[-1].v.string);
			free(yyvsp[-3].v.string);
		}
break;
case 130:
#line 977 "parse.y"
{
			node.action = NODE_ACTION_CHANGE;
			node.key = strdup(yyvsp[-3].v.string);
			node.value = strdup(yyvsp[-1].v.string);
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			if (strchr(node.value, '$') != NULL)
				node.flags |= PNFLAG_MACRO;
			free(yyvsp[-1].v.string);
			free(yyvsp[-3].v.string);
		}
break;
case 131:
#line 988 "parse.y"
{
			node.action = NODE_ACTION_REMOVE;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = NULL;
			if (node.key == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.string);
		}
break;
case 132:
#line 996 "parse.y"
{
			node.action = NODE_ACTION_REMOVE;
			node.key = NULL;
			node.value = NULL;
		}
break;
case 134:
#line 1001 "parse.y"
{
			node.action = NODE_ACTION_EXPECT;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = strdup(yyvsp[-3].v.string);
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.string);
			free(yyvsp[-3].v.string);
			proto->lateconnect++;
		}
break;
case 135:
#line 1011 "parse.y"
{
			node.action = NODE_ACTION_EXPECT;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = strdup("*");
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.string);
			proto->lateconnect++;
		}
break;
case 136:
#line 1020 "parse.y"
{
			node.action = NODE_ACTION_EXPECT;
			node.key = NULL;
			node.value = "*";
			proto->lateconnect++;
		}
break;
case 138:
#line 1026 "parse.y"
{
			if (node.type != NODE_TYPE_URL) {
				yyerror("digest not supported for this type");
				free(yyvsp[-1].v.digest.digest);
				YYERROR;
			}
			node.action = NODE_ACTION_EXPECT;
			node.key = strdup(yyvsp[-1].v.digest.digest);
			node.flags |= PNFLAG_LOOKUP_DIGEST(yyvsp[-1].v.digest.type);
			node.value = strdup("*");
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.digest.digest);
			proto->lateconnect++;
		}
break;
case 139:
#line 1041 "parse.y"
{
			node.action = NODE_ACTION_FILTER;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = strdup(yyvsp[-3].v.string);
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.string);
			free(yyvsp[-3].v.string);
			proto->lateconnect++;
		}
break;
case 140:
#line 1051 "parse.y"
{
			node.action = NODE_ACTION_FILTER;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = strdup("*");
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.string);
			proto->lateconnect++;
		}
break;
case 141:
#line 1060 "parse.y"
{
			node.action = NODE_ACTION_FILTER;
			node.key = NULL;
			node.value = "*";
			proto->lateconnect++;
		}
break;
case 143:
#line 1066 "parse.y"
{
			if (node.type != NODE_TYPE_URL) {
				yyerror("digest not supported for this type");
				free(yyvsp[-1].v.digest.digest);
				YYERROR;
			}
			node.action = NODE_ACTION_FILTER;
			node.key = strdup(yyvsp[-1].v.digest.digest);
			node.flags |= PNFLAG_LOOKUP_DIGEST(yyvsp[-1].v.digest.type);
			node.value = strdup("*");
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.digest.digest);
			proto->lateconnect++;
		}
break;
case 144:
#line 1081 "parse.y"
{
			node.action = NODE_ACTION_HASH;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = NULL;
			if (node.key == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.string);
			proto->lateconnect++;
		}
break;
case 145:
#line 1090 "parse.y"
{
			node.action = NODE_ACTION_LOG;
			node.key = strdup(yyvsp[-1].v.string);
			node.value = NULL;
			node.flags |= PNFLAG_LOG;
			if (node.key == NULL)
				fatal("out of memory");
			free(yyvsp[-1].v.string);
		}
break;
case 146:
#line 1099 "parse.y"
{
			node.action = NODE_ACTION_LOG;
			node.key = NULL;
			node.value = NULL;
			node.flags |= PNFLAG_LOG;
		}
break;
case 148:
#line 1105 "parse.y"
{
			node.action = NODE_ACTION_MARK;
			node.key = strdup(yyvsp[-3].v.string);
			node.value = strdup(yyvsp[-5].v.string);
			node.mark = yyvsp[-1].v.number;
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-5].v.string);
			free(yyvsp[-3].v.string);
		}
break;
case 149:
#line 1115 "parse.y"
{
			node.action = NODE_ACTION_MARK;
			node.key = strdup(yyvsp[-3].v.string);
			node.value = strdup("*");
			node.mark = yyvsp[-1].v.number;	/* overwrite */
			if (node.key == NULL || node.value == NULL)
				fatal("out of memory");
			free(yyvsp[-3].v.string);
		}
break;
case 150:
#line 1126 "parse.y"
{
			if (protonode_load(nodedirection,
			    proto, &node, yyvsp[-1].v.string) == -1) {
				yyerror("failed to load from file: %s", yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			free(yyvsp[-1].v.string);
			nodedirection = -1;	/* don't add template node */
		}
break;
case 153:
#line 1142 "parse.y"
{ node.mark = yyvsp[0].v.number; }
break;
case 155:
#line 1146 "parse.y"
{ node.flags |= PNFLAG_LOG; }
break;
case 156:
#line 1149 "parse.y"
{
			if (yyvsp[0].v.number <= 0 || yyvsp[0].v.number >= (int)USHRT_MAX) {
				yyerror("invalid mark: %d", yyvsp[0].v.number);
				YYERROR;
			}
			yyval.v.number = yyvsp[0].v.number;
		}
break;
case 157:
#line 1158 "parse.y"
{
			node.type = NODE_TYPE_HEADER;
		}
break;
case 158:
#line 1161 "parse.y"
{ node.type = NODE_TYPE_QUERY; }
break;
case 159:
#line 1162 "parse.y"
{
			node.type = NODE_TYPE_COOKIE;
		}
break;
case 160:
#line 1165 "parse.y"
{
			proto->flags |= F_LOOKUP_PATH;
			node.type = NODE_TYPE_PATH;
		}
break;
case 161:
#line 1169 "parse.y"
{ node.type = NODE_TYPE_URL; }
break;
case 162:
#line 1172 "parse.y"
{
			if (yyvsp[0].v.number < 0) {
				yyerror("invalid sslcache value: %d", yyvsp[0].v.number);
				YYERROR;
			}
			yyval.v.number = yyvsp[0].v.number;
		}
break;
case 163:
#line 1179 "parse.y"
{ yyval.v.number = -2; }
break;
case 164:
#line 1182 "parse.y"
{
			struct relay *r;

			TAILQ_FOREACH(r, conf->sc_relays, rl_entry)
				if (!strcmp(r->rl_conf.name, yyvsp[0].v.string))
					break;
			if (r != NULL) {
				yyerror("relay %s defined twice", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			TAILQ_INIT(&relays);

			if ((r = calloc(1, sizeof (*r))) == NULL)
				fatal("out of memory");

			if (strlcpy(r->rl_conf.name, yyvsp[0].v.string, sizeof(r->rl_conf.name)) >=
			    sizeof(r->rl_conf.name)) {
				yyerror("relay name truncated");
				free(r);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			r->rl_conf.id = ++last_relay_id;
			r->rl_conf.timeout.tv_sec = RELAY_TIMEOUT;
			r->rl_proto = NULL;
			r->rl_conf.proto = EMPTY_ID;
			r->rl_conf.dsttable = EMPTY_ID;
			r->rl_conf.dstmode = RELAY_DSTMODE_DEFAULT;
			r->rl_conf.dstretry = 0;
			if (last_relay_id == INT_MAX) {
				yyerror("too many relays defined");
				free(r);
				YYERROR;
			}
			rlay = r;
		}
break;
case 165:
#line 1218 "parse.y"
{
			struct relay	*r;

			if (rlay->rl_conf.ss.ss_family == AF_UNSPEC) {
				yyerror("relay %s has no listener",
				    rlay->rl_conf.name);
				YYERROR;
			}
			if ((rlay->rl_conf.flags & (F_NATLOOK|F_DIVERT)) ==
			    (F_NATLOOK|F_DIVERT)) {
				yyerror("relay %s with conflicting nat lookup "
				    "and peer options", rlay->rl_conf.name);
				YYERROR;
			}
			if ((rlay->rl_conf.flags & (F_NATLOOK|F_DIVERT)) == 0 &&
			    rlay->rl_conf.dstss.ss_family == AF_UNSPEC &&
			    rlay->rl_conf.dsttable == EMPTY_ID) {
				yyerror("relay %s has no target, rdr, "
				    "or table", rlay->rl_conf.name);
				YYERROR;
			}
			if (rlay->rl_backuptable == NULL) {
				rlay->rl_conf.backuptable =
				    conf->sc_empty_table.conf.id;
				rlay->rl_backuptable = &conf->sc_empty_table;
			}
			if (rlay->rl_conf.proto == EMPTY_ID) {
				rlay->rl_proto = &conf->sc_proto_default;
				rlay->rl_conf.proto = conf->sc_proto_default.id;
			}
			if (relay_load_certfiles(rlay) == -1) {
				yyerror("cannot load certificates for relay %s",
				    rlay->rl_conf.name);
				YYERROR;
			}
			conf->sc_relaycount++;
			SPLAY_INIT(&rlay->rl_sessions);
			TAILQ_INSERT_TAIL(conf->sc_relays, rlay, rl_entry);
			tableport = 0;

			while ((r = TAILQ_FIRST(&relays)) != NULL) {
				TAILQ_REMOVE(&relays, r, rl_entry);
				if (relay_inherit(rlay, r) == NULL) {
					YYERROR;
				}
			}
			rlay = NULL;
		}
break;
case 168:
#line 1272 "parse.y"
{
			struct addresslist	 al;
			struct address		*h;
			struct relay		*r;

			if (rlay->rl_conf.ss.ss_family != AF_UNSPEC) {
				if ((r = calloc(1, sizeof (*r))) == NULL)
					fatal("out of memory");
				TAILQ_INSERT_TAIL(&relays, r, rl_entry);
			} else
				r = rlay;
			if (yyvsp[-1].v.port.op != PF_OP_EQ) {
				yyerror("invalid port");
				free(yyvsp[-2].v.string);
				YYERROR;
			}

			TAILQ_INIT(&al);
			if (host(yyvsp[-2].v.string, &al, 1, &yyvsp[-1].v.port, NULL, -1) <= 0) {
				yyerror("invalid listen ip: %s", yyvsp[-2].v.string);
				free(yyvsp[-2].v.string);
				YYERROR;
			}
			free(yyvsp[-2].v.string);
			h = TAILQ_FIRST(&al);
			bcopy(&h->ss, &r->rl_conf.ss, sizeof(r->rl_conf.ss));
			r->rl_conf.port = h->port.val[0];
			if (yyvsp[0].v.number) {
				r->rl_conf.flags |= F_SSL;
				conf->sc_flags |= F_SSL;
			}
			tableport = h->port.val[0];
		}
break;
case 169:
#line 1305 "parse.y"
{
			rlay->rl_conf.fwdmode = yyvsp[-5].v.number;
			switch (yyvsp[-5].v.number) {
			case FWD_NORMAL:
				if (yyvsp[-1].v.string == NULL)
					break;
				yyerror("superfluous interface");
				YYERROR;
			case FWD_ROUTE:
				yyerror("no route for redirections");
				YYERROR;
			case FWD_TRANS:
				if (yyvsp[-1].v.string != NULL)
					break;
				yyerror("missing interface");
				YYERROR;
			}
			if (yyvsp[-1].v.string != NULL) {
				strlcpy(rlay->rl_conf.ifname, yyvsp[-1].v.string,
				    sizeof(rlay->rl_conf.ifname));
				free(yyvsp[-1].v.string);
			}
			if (yyvsp[-4].v.number) {
				rlay->rl_conf.flags |= F_SSLCLIENT;
				conf->sc_flags |= F_SSLCLIENT;
			}
		}
break;
case 170:
#line 1332 "parse.y"
{
			if ((rlay->rl_conf.timeout.tv_sec = yyvsp[0].v.number) < 0) {
				yyerror("invalid timeout: %d", yyvsp[0].v.number);
				YYERROR;
			}
		}
break;
case 171:
#line 1338 "parse.y"
{
			struct protocol *p;

			TAILQ_FOREACH(p, conf->sc_protos, entry)
				if (!strcmp(p->name, yyvsp[0].v.string))
					break;
			if (p == NULL) {
				yyerror("no such protocol: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			p->flags |= F_USED;
			rlay->rl_conf.proto = p->id;
			rlay->rl_proto = p;
			free(yyvsp[0].v.string);
		}
break;
case 172:
#line 1354 "parse.y"
{ rlay->rl_conf.flags |= F_DISABLE; }
break;
case 174:
#line 1358 "parse.y"
{
			struct addresslist	 al;
			struct address		*h;

			if (rlay->rl_conf.dstss.ss_family != AF_UNSPEC) {
				yyerror("relay %s target or redirection already "
				    "specified", rlay->rl_conf.name);
				free(yyvsp[-2].v.string);
				YYERROR;
			}
			if (yyvsp[-1].v.port.op != PF_OP_EQ) {
				yyerror("invalid port");
				free(yyvsp[-2].v.string);
				YYERROR;
			}

			TAILQ_INIT(&al);
			if (host(yyvsp[-2].v.string, &al, 1, &yyvsp[-1].v.port, NULL, -1) <= 0) {
				yyerror("invalid listen ip: %s", yyvsp[-2].v.string);
				free(yyvsp[-2].v.string);
				YYERROR;
			}
			free(yyvsp[-2].v.string);
			h = TAILQ_FIRST(&al);
			bcopy(&h->ss, &rlay->rl_conf.dstss,
			    sizeof(rlay->rl_conf.dstss));
			rlay->rl_conf.dstport = h->port.val[0];
			rlay->rl_conf.dstretry = yyvsp[0].v.number;
		}
break;
case 175:
#line 1387 "parse.y"
{
			conf->sc_flags |= F_NEEDPF;
			rlay->rl_conf.flags |= F_NATLOOK;
			rlay->rl_conf.dstretry = yyvsp[0].v.number;
		}
break;
case 176:
#line 1392 "parse.y"
{
			conf->sc_flags |= F_NEEDPF;
			rlay->rl_conf.flags |= F_DIVERT;
			rlay->rl_conf.dstretry = yyvsp[0].v.number;
		}
break;
case 177:
#line 1397 "parse.y"
{
			if (rlay->rl_backuptable) {
				yyerror("only one backup table is allowed");
				purge_table(conf->sc_tables, yyvsp[0].v.table);
				YYERROR;
			}
			if (rlay->rl_dsttable) {
				rlay->rl_backuptable = yyvsp[0].v.table;
				rlay->rl_backuptable->conf.flags |= F_USED;
				rlay->rl_conf.backuptable = yyvsp[0].v.table->conf.id;
			} else {
				rlay->rl_dsttable = yyvsp[0].v.table;
				rlay->rl_dsttable->conf.flags |= F_USED;
				rlay->rl_conf.dsttable = yyvsp[0].v.table->conf.id;
				rlay->rl_conf.dstport = yyvsp[0].v.table->conf.port;
			}
		}
break;
case 178:
#line 1416 "parse.y"
{ yyval.v.number = RELAY_DSTMODE_DEFAULT; }
break;
case 179:
#line 1417 "parse.y"
{ yyval.v.number = RELAY_DSTMODE_LOADBALANCE; }
break;
case 180:
#line 1418 "parse.y"
{ yyval.v.number = RELAY_DSTMODE_ROUNDROBIN; }
break;
case 181:
#line 1419 "parse.y"
{ yyval.v.number = RELAY_DSTMODE_HASH; }
break;
case 182:
#line 1422 "parse.y"
{
			struct router *rt = NULL;

			conf->sc_flags |= F_NEEDRT;
			TAILQ_FOREACH(rt, conf->sc_rts, rt_entry)
				if (!strcmp(rt->rt_conf.name, yyvsp[0].v.string))
					break;
			if (rt != NULL) {
				yyerror("router %s defined twice", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}

			if ((rt = calloc(1, sizeof (*rt))) == NULL)
				fatal("out of memory");

			if (strlcpy(rt->rt_conf.name, yyvsp[0].v.string,
			    sizeof(rt->rt_conf.name)) >=
			    sizeof(rt->rt_conf.name)) {
				yyerror("router name truncated");
				free(rt);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			rt->rt_conf.id = ++last_rt_id;
			if (last_rt_id == INT_MAX) {
				yyerror("too many routers defined");
				free(rt);
				YYERROR;
			}
			TAILQ_INIT(&rt->rt_netroutes);
			router = rt;

			tableport = -1;
		}
break;
case 183:
#line 1456 "parse.y"
{
			if (!router->rt_conf.nroutes) {
				yyerror("router %s without routes",
				    router->rt_conf.name);
				free(router);
				router = NULL;
				YYERROR;
			}

			conf->sc_routercount++;
			TAILQ_INSERT_TAIL(conf->sc_rts, router, rt_entry);
			router = NULL;

			tableport = 0;
		}
break;
case 186:
#line 1477 "parse.y"
{
			struct netroute	*nr;

			if (router->rt_af == AF_UNSPEC)
				router->rt_af = yyvsp[-2].v.addr.ss.ss_family;
			else if (router->rt_af != yyvsp[-2].v.addr.ss.ss_family) {
				yyerror("router %s address family mismatch",
				    router->rt_conf.name);
				YYERROR;
			}

			if ((router->rt_af == AF_INET && (yyvsp[0].v.number > 32 || yyvsp[0].v.number < 0)) ||
			    (router->rt_af == AF_INET6 && (yyvsp[0].v.number > 128 || yyvsp[0].v.number < 0))) {
				yyerror("invalid prefixlen %d", yyvsp[0].v.number);
				YYERROR;
			}

			if ((nr = calloc(1, sizeof(*nr))) == NULL)
				fatal("out of memory");

			nr->nr_conf.id = ++last_nr_id;
			if (last_nr_id == INT_MAX) {
				yyerror("too many routes defined");
				free(nr);
				YYERROR;
			}
			nr->nr_conf.prefixlen = yyvsp[0].v.number;
			nr->nr_conf.routerid = router->rt_conf.id;
			nr->nr_router = router;
			bcopy(&yyvsp[-2].v.addr.ss, &nr->nr_conf.ss, sizeof(yyvsp[-2].v.addr.ss));

			router->rt_conf.nroutes++;
			conf->sc_routecount++;
			TAILQ_INSERT_TAIL(&router->rt_netroutes, nr, nr_entry);
			TAILQ_INSERT_TAIL(conf->sc_routes, nr, nr_route);
		}
break;
case 187:
#line 1513 "parse.y"
{
			if (router->rt_gwtable) {
				yyerror("router %s table already specified",
				    router->rt_conf.name);
				purge_table(conf->sc_tables, yyvsp[0].v.table);
				YYERROR;
			}
			router->rt_gwtable = yyvsp[0].v.table;
			router->rt_gwtable->conf.flags |= F_USED;
			router->rt_conf.gwtable = yyvsp[0].v.table->conf.id;
			router->rt_conf.gwport = yyvsp[0].v.table->conf.port;
		}
break;
case 188:
#line 1525 "parse.y"
{
			if (router->rt_conf.rtable) {
				yyerror("router %s rtable already specified",
				    router->rt_conf.name);
				YYERROR;
			}
			if (yyvsp[0].v.number < 0 || yyvsp[0].v.number > RT_TABLEID_MAX) {
				yyerror("invalid rtable id %d", yyvsp[0].v.number);
				YYERROR;
			}
			router->rt_conf.rtable = yyvsp[0].v.number;
		}
break;
case 189:
#line 1537 "parse.y"
{
			if (strlcpy(router->rt_conf.label, yyvsp[0].v.string,
			    sizeof(router->rt_conf.label)) >=
			    sizeof(router->rt_conf.label)) {
				yyerror("route label truncated");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
		}
break;
case 190:
#line 1547 "parse.y"
{ rlay->rl_conf.flags |= F_DISABLE; }
break;
case 192:
#line 1551 "parse.y"
{
			rlay->rl_conf.dstaf.ss_family = AF_UNSPEC;
		}
break;
case 193:
#line 1554 "parse.y"
{
			rlay->rl_conf.dstaf.ss_family = AF_INET;
		}
break;
case 194:
#line 1557 "parse.y"
{
			struct sockaddr_in6	*sin6;

			sin6 = (struct sockaddr_in6 *)&rlay->rl_conf.dstaf;
			if (inet_pton(AF_INET6, yyvsp[0].v.string, &sin6->sin6_addr) == -1) {
				yyerror("invalid ipv6 address %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);

			sin6->sin6_family = AF_INET6;
			sin6->sin6_len = sizeof(*sin6);
		}
break;
case 195:
#line 1573 "parse.y"
{ yyval.v.string = NULL; }
break;
case 196:
#line 1574 "parse.y"
{ yyval.v.string = yyvsp[0].v.string; }
break;
case 197:
#line 1577 "parse.y"
{
			if ((hst = calloc(1, sizeof(*(hst)))) == NULL)
				fatal("out of memory");

			if (strlcpy(hst->conf.name, yyvsp[0].v.addr.name,
			    sizeof(hst->conf.name)) >= sizeof(hst->conf.name)) {
				yyerror("host name truncated");
				free(hst);
				YYERROR;
			}
			bcopy(&yyvsp[0].v.addr.ss, &hst->conf.ss, sizeof(yyvsp[0].v.addr.ss));
			hst->conf.id = 0; /* will be set later */
			SLIST_INIT(&hst->children);
		}
break;
case 198:
#line 1590 "parse.y"
{
			yyval.v.host = hst;
			hst = NULL;
		}
break;
case 203:
#line 1604 "parse.y"
{
			if (hst->conf.retry) {
				yyerror("retry value already set");
				YYERROR;
			}
			if (yyvsp[0].v.number < 0) {
				yyerror("invalid retry value: %d\n", yyvsp[0].v.number);
				YYERROR;
			}
			hst->conf.retry = yyvsp[0].v.number;
		}
break;
case 204:
#line 1615 "parse.y"
{
			if (hst->conf.parentid) {
				yyerror("parent value already set");
				YYERROR;
			}
			if (yyvsp[0].v.number < 0) {
				yyerror("invalid parent value: %d\n", yyvsp[0].v.number);
				YYERROR;
			}
			hst->conf.parentid = yyvsp[0].v.number;
		}
break;
case 205:
#line 1626 "parse.y"
{
			if (hst->conf.priority) {
				yyerror("priority already set");
				YYERROR;
			}
			if (yyvsp[0].v.number < 0 || yyvsp[0].v.number > RTP_MAX) {
				yyerror("invalid priority value: %d\n", yyvsp[0].v.number);
				YYERROR;
			}
			hst->conf.priority = yyvsp[0].v.number;
		}
break;
case 206:
#line 1637 "parse.y"
{
			if (hst->conf.ttl) {
				yyerror("ttl value already set");
				YYERROR;
			}
			if (yyvsp[0].v.number < 0) {
				yyerror("invalid ttl value: %d\n", yyvsp[0].v.number);
				YYERROR;
			}
			hst->conf.ttl = yyvsp[0].v.number;
		}
break;
case 207:
#line 1650 "parse.y"
{
			struct address *a;
			struct addresslist al;

			if (strlcpy(yyval.v.addr.name, yyvsp[0].v.string,
			    sizeof(yyval.v.addr.name)) >= sizeof(yyval.v.addr.name)) {
				yyerror("host name truncated");
				free(yyvsp[0].v.string);
				YYERROR;
			}

			TAILQ_INIT(&al);
			if (host(yyvsp[0].v.string, &al, 1, NULL, NULL, -1) <= 0) {
				yyerror("invalid host %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			a = TAILQ_FIRST(&al);
			memcpy(&yyval.v.addr.ss, &a->ss, sizeof(yyval.v.addr.ss));
			free(a);
		}
break;
case 208:
#line 1674 "parse.y"
{ yyval.v.number = 0; }
break;
case 209:
#line 1675 "parse.y"
{
			if ((yyval.v.number = yyvsp[0].v.number) < 0) {
				yyerror("invalid retry value: %d\n", yyvsp[0].v.number);
				YYERROR;
			}
		}
break;
case 210:
#line 1684 "parse.y"
{
			if (yyvsp[0].v.number < 0) {
				yyerror("invalid timeout: %d\n", yyvsp[0].v.number);
				YYERROR;
			}
			yyval.v.tv.tv_sec = yyvsp[0].v.number / 1000;
			yyval.v.tv.tv_usec = (yyvsp[0].v.number % 1000) * 1000;
		}
break;
#line 3936 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (1);
yyaccept:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (0);
}
