#include "fourier.h"

#define REAL(z,i) ((z)[2*(i)])
#define IMAG(z,i) ((z)[2*(i)+1])
#define N 16384 //2^14
int main(void)
{
	int i; double data[2*N];
	double freq;
	FILE * indat = fopen("dat","r");
	if (readfile(indat, data) != 0) {printf("Bad input file!\n"); return -1;}
//	printf("file read...\n");
#if 0
	for(i=0; i<N; i++){
		printf("%d %e %e\n",i,REAL(data,i),IMAG(data,i));
	}
#endif

	gsl_fft_complex_radix2_forward(data,1,N);
	for(i=0;i<N; i++){
		if(i < N/2){
			freq = ((double) i)/N ;//* 2.0 * M_PI;
		}else{
			freq = ((double)(i-N))/N;// * 2.0 * M_PI;
		}

		printf("%g %e %e\n",freq,
				REAL(data,i)/sqrt(N*N),
				IMAG(data,i)/sqrt(N*N));
	}
	return 0;
}
int readfile (FILE * infile, double data[]){
	int nlines,i=0, i0,lfirst = 1,asdf,lsecond;
	double re, im;
	char line[80];
	while(fgets(line,80,infile) != NULL){
		if(lfirst == 1){
			lfirst = 0;
			sscanf(line, "%d", &nlines);
			if(nlines != N) return -1;
			lsecond =1;
		}else{
			sscanf(line, "%d %lf %lf",&i, &re, &im);
			if(lsecond == 1){
				i0 = i;
				lsecond=0;
			}
			i=i-i0;
			REAL(data,i) = re;
			IMAG(data,i) = im;
		}
	}
	fclose(infile);
	return 0;
}
