#include "plan_r3b.h"
#include "xv2el.h"
#include "driver.h"
#define N_BINS 3000
double period = TWOPI;
int main (void)
{
	double y[NVAR] ;
	int ntp,i;
	int lfirst = 1;
	double ecc, alpha,q,mu1,mu2; // eccentricity' and a/a'
	FILE *star1; FILE *star2; FILE *tp; FILE *tprt;
//*** Begin Initial Conditions ***//
	double vel_multiplier = 1.0;
	q     =  0.1165; // m2/m1 ratio
    ecc   =  0.02; 
    ecc   = -1.0*ecc;
    alpha = 3.199; // a_particle / a_binary
    ntp   =  NVAR/4 - 2;
//**** Number of integrations to repeat ***//
	int integ = 0;
	int finteg = 1;
	double min_var,rms_bin_variance, min_vel_mult,old_vm,old_old_vm,old_var,temp,approach_vm;
	//************************************************************//
	for (integ = 0; integ < finteg; integ++) 
	{
		if (integ==0) {
			vel_multiplier = 1.0;//1.1;
			min_vel_mult = vel_multiplier;
			initialize_conditions(y,q,ecc,alpha,vel_multiplier);
			min_var = run_integration(y,q,ntp);
			printf("Bin variance: %g, vel. mult: %g\n",min_var, vel_multiplier);
			
		} else if (integ == 1) {
			vel_multiplier =1.0;
			initialize_conditions(y,q,ecc,alpha,vel_multiplier);
			rms_bin_variance = run_integration(y,q,ntp);
			printf("Bin variance: %g, vel. mult: %g\n",rms_bin_variance, vel_multiplier);
			//if (rms_bin_variance<min_var){ min_var=rms_bin_variance; min_vel_mult = vel_multiplier;}
			
		} else if (integ==2) {
			vel_multiplier = 0.9;
			initialize_conditions(y,q,ecc,alpha,vel_multiplier);
			rms_bin_variance = run_integration(y,q,ntp);
			printf("Bin variance: %g, vel. mult: %g\n",rms_bin_variance, vel_multiplier);
			if (rms_bin_variance<min_var) {min_var=rms_bin_variance; min_vel_mult = vel_multiplier;}
			approach_vm = 1.0;
			old_vm=1.0;
			old_var = min_var;
			vel_multiplier = min_vel_mult;
		} else {
			if(0){
				printf("AHH!\n");
				old_old_vm = old_vm;
				old_var=rms_bin_variance;
				old_vm = vel_multiplier;
			}
			if (rms_bin_variance <= old_var){ 
				if(rms_bin_variance < min_var){min_var=rms_bin_variance; min_vel_mult = vel_multiplier;}
				old_vm=vel_multiplier;
				vel_multiplier = (vel_multiplier + approach_vm)/2.0;
				printf("prev. var. %g <= old variance: %g, continue approaching %g\n\n",rms_bin_variance,old_var,approach_vm-1.0);
				old_var= rms_bin_variance;

			} else {
				approach_vm = old_vm;
				old_vm=vel_multiplier;
				vel_multiplier = (vel_multiplier + approach_vm)/2.0;
				printf("prev. var. %g > %g old variance, now approaching: %g\n\n",rms_bin_variance,old_var,approach_vm-1);
				old_var=rms_bin_variance;
			}
	
		//	printf("oldold: %g\told:  %g\toldvar:  %g\n",old_old_vm, old_vm, old_var);
			initialize_conditions(y,q,ecc,alpha,vel_multiplier);
			rms_bin_variance = run_integration(y,q,ntp);
			printf("bin variance is: %g, vel. mult: %g\n\n",rms_bin_variance, vel_multiplier-1.0);
		}
	}
	//initialize_conditions(y,q,ecc,alpha,min_vel_mult);
	//min_var = run_integration(y,q,ntp);
	//printf("Final run, minimum variance: %g  vel. mult.: %g\n",min_var, min_vel_mult);

// ***************************** //

}
void initialize_conditions(double y[],double q, double ecc, double alpha, double vel_mult){
	double mu1 = 1.0/(1.0+q);
	mu1 = 1.0 / (1.0 + q); // M_1/(M_tot)
    double mu2 = 1.0 - mu1; // M_2/ (M_tot)
	double vkep = 1.0 * pow(alpha, -0.5);

	// -- Start binary companions at apoapse for now...
    // *** Primary ***
    y[0] =mu2 * (1.0 + ecc);
    y[1] = 0.0;
    y[2] = 0.0;
    y[3] = mu2 * sqrt((1.0-ecc)/(1.0 +ecc) );
    //*** Secondary ***
    y[4] = -mu1 *(1.0 + ecc);
    y[5] = 0.0 ;
    y[6] = 0.0 ;
    y[7] = -mu1 * sqrt((1.0-ecc)/(1.0 +ecc) );
    // *** Test particles ***
    int ntp = NVAR/4 - 2;
    int i;
    for ( i =0; i < ntp; i++)
	{
		int j = 8 + i*4;
		y[j] = alpha;
		y[j+1] = 0.0;
		y[j+2] = 0.0;
		if (i ==0){
			y[j+3] = vel_mult * vkep;
		} else {
			y[j+3] = (1 + pow(-1,i)*.01) * vkep; 
		}
		
    }
	

}
void add_bin_r_theta(double r, double theta, int counts[], double bin_avgs[],double bin_er2[], double bin_var[],double deltheta)
{
	int bin_num = (int) floor((theta+M_PI)/deltheta);
	bin_avgs[bin_num] = bin_avgs[bin_num]*counts[bin_num];
	bin_er2[bin_num] =  bin_er2[bin_num]*counts[bin_num];
        counts[bin_num] += 1;
        bin_avgs[bin_num] += r;
        bin_er2[bin_num] += r*r;
	bin_avgs[bin_num] /= (double) counts[bin_num];
	bin_er2[bin_num] /= (double) counts[bin_num];
	bin_var[bin_num] = bin_er2[bin_num] - bin_avgs[bin_num]*bin_avgs[bin_num];
}
double rms_sum(double vals[])
{
	int fin = sizeof(vals)/sizeof(double);
	double sum=0.0;
	int i;
	for(i=0; i<fin; i++)
	{
		sum += vals[i];
	}
	return sqrt(sum);
}
void write_starxvdat(double t, FILE * star1, FILE * star2, double y[])
{
	fprintf(star1, "%-.8E  %-.8E  %-.8E  %-.8E  %-.8E\n",t/period, y[0], y[1], y[2],y[3]);
	fprintf(star2, "%-.8E  %-.8E  %-.8E  %-.8E  %-.8E\n",t/period, y[4], y[5], y[6],y[7]);
}
double run_integration(double y[],double q,int ntp)
{
	FILE * tpxv, * star1, * star2, *tprt; // Files
	tpxv=fopen("tp.xv","w"); tprt=fopen("tp.rt","w"); star1=fopen("star1.xv","w");star2=fopen("star2.xv","w");
	if ((tpxv==NULL) || (tprt==NULL) || (star1==NULL) ||(star2==NULL)) {
		printf("File handling error in run_integration!\n");
		exit(-1);
	}
	double del_theta = TWOPI/N_BINS; // Binning variables
	double rms_bin_variance = 0;
	int theta_bin_count[N_BINS] = { 0 };
	double theta_bin_var[N_BINS] = { 0 } , theta_bin_avg[N_BINS] = { 0 }, theta_bin_er2[N_BINS] = { 0 };
	
	double vrf[ntp+1];  	//Parameter array
	vrf[0]=q;
	
	double r, theta;  //Test particle r and theta
	
	int tint = 0, lfirst=1; // Time/loop control variales
	double t,tnext,e0;
	double tfinal = 4e4 * period;
	double dt = 1.0 * period;
	int tintfinal =  1 + (int) ceil(tfinal / dt);
	
	gsl_odeiv2_system sys = {derivs, 0, NVAR, &(vrf[0])}; // GSL integrator variables 
	double hh = 1.0e-7;
	gsl_odeiv2_driver * d = gsl_odeiv2_driver_alloc_y_new(&sys,gsl_odeiv2_step_rk8pd, hh,1.0e-12,0.0);
	
	for (tint = 0; tint < tintfinal; tint++)
	{
		t = tint * dt;
		tnext = (tint + 1) * dt;
		print_status(t, y,q,&e0,&lfirst);
		write_starxvdat(t,star1,star2,y);
		int id;
		for (id=0; id<ntp; id++) {
			get_rtheta(id,y,&r,&theta);
			add_bin_r_theta(r,theta,theta_bin_count,theta_bin_avg,theta_bin_er2,theta_bin_var,del_theta);
			write_tpxv(tpxv,t, id,y,q);
			write_tprtheta(tprt,t,id,r,theta);

#if DAMPING //Apply radial velocity adjustment...
			int j= 8+id*4;
			int i = id;
			double vr = (y[j]*y[j+2] + y[j+1]*y[j+3])/r;
			y[j+2] += vrf[i+1] * y[j]/r - vr*y[j]/r ;
			y[j+3] += vrf[i+1] * y[j+1]/r - vr*y[j+1]/r ;
#endif
		}
		int status = gsl_odeiv2_driver_apply (d, &t,tnext , y);
		if (status != GSL_SUCCESS) exit(-1);
	}
	fclose(star1);
	fclose(star2);
	fclose(tprt);fclose(tpxv);
	gsl_odeiv2_driver_free(d);
	rms_bin_variance = rms_sum(theta_bin_var);
	return rms_bin_variance;
}
void print_status(double t, double const y[], double q,double * e0, int * lfirst)
{
	double mu1 = 1.0/(1.0+q);
	double mu2 = 1 - mu1;
	double r12 = sqrt ( (y[0]-y[4])*(y[0]-y[4]) + (y[1]-y[5])*(y[1]-y[5]) );
	double energy = .5 * mu1 *( y[2]*y[2] + y[3]*y[3]) + .5 * mu2 *( y[6]*y[6] + y[7]*y[7]) - q * mu1 * mu1 / r12;
	if (*lfirst == 1)
	{
		*e0 = energy;
		*lfirst = 0;
	}
	double drift = sqrt( pow(mu1 * y[0] + mu2*y[4],2.0) + pow(mu1 * y[1] + mu2*y[5],2.0) );
	printf("T(periods)= %.8g   COM drift=  %.6g    dE/E = %.5g", t/period, drift,(energy-(*e0))/(*e0)) ; 
	printf("\n") ; 
}
void write_tpxv(FILE * tpxv, double t, int id, double const y[],double q)
{
	int j = 8 + id * 4;
	double mu1 = 1.0/(1.0 + q); 
	double mu2 = 1.0-mu1;
	double jconst, rho1, rho2,smatp,ecctp;
	smatp = get_sma(y[j], y[j+1], y[j+2],y[j+3]);
	ecctp = get_ecc(y[j], y[j+1], y[j+2],y[j+3]);
	// See Szebehely pg. 1j+1 for the following
	rho1 = sqrt((y[j] - y[0])*(y[j] - y[0]) + (y[j+1] - y[1])*(y[j+1] - y[1]));
	rho2 = sqrt((y[j] - y[4])*(y[j] - y[4]) + (y[j+1] - y[5])*(y[j+1] - y[5]));
	jconst = 2.0 * (y[j]*y[j+3] - y[j+1]*y[j+2]) + 2.0 * (mu1/rho1 + mu2/rho2) - (y[j+2]*y[j+2] + y[j+3]*y[j+3]);
	fprintf(tpxv, "%-.8E %3d  %-.8E  %-.8E  %-.8E  %-.8E  %-.8E  %-.8E %-.8E\n",t/period,id, y[j], y[j+1], y[j+2],y[j+3],smatp,ecctp,jconst);
}
void get_rtheta(int id,double const y[], double * r,double * theta)
{
	int j= 8 + id*4;
	*r = sqrt(y[j]*y[j]+y[j+1]*y[j+1]);
	*theta = atan(y[j+1]/y[j]);
	if ((y[j+1] < 0) &&(y[j] < 0)) *theta = *theta - M_PI; //QIII -- x&y<0
	if ((y[j+1]>0) &&(y[j]<0)) *theta= *theta + M_PI;   //QII -- x<0 & y>0
}	
void write_tprtheta(FILE * tprt, double t, int id, double r, double theta)
{
	fprintf(tprt, "%-.8E %3d  %-.8E  %-.8E  \n",t/period,id, r, theta);
}

