#include "plan_r3b.h"
#include "xv2el.h"
#define DP 2e3
inline double Mod(double x, double y){
	if (0 == y)
		return x;
	return x - y * floor(x/y);
}
inline double WrapTwoPI(double fAng){
	return Mod(fAng,2.0*M_PI);
}
void eldamp(double x, double y, double vx, double vy, double * fx, double *  fy,double * dx, double * dy, double tdamp,double target_a)
{

	double e = .5 * (vx*vx + vy*vy) - 1.0/sqrt(x*x +y*y);
	double h = x*vy-y*vx;
	double a0 = target_a;
	//printf("a0: %g\n", alphaa);
	//exit(0);
	double ecc0 = 0.0;
	double e0 = -.5/a0;
	double h0 = sqrt(a0) * sqrt(1 - ecc0*ecc0);
        double r = sqrt(x*x+y*y);
	double vr = (x*vx + y*vy)/r;
	double vtheta = (-y*vx + x*vy)/r;
	//double e0 = -.5/(h0*h0) * (1 - ecc0*ecc0);
        //printf("E: %e x: %e y: %e vx: %e vy: %e\n",e,x,y,vx, vy);
	//if(e>0){printf("positive Energy value!!?? E: %e x: %e y: %e vx: %e vy: %e\n",e,x,y,vx, vy); exit(-1);}
	double delE =    (e0-e)/tdamp;
	double delh = (h0-h)/( tdamp);
	//double delh = sqrt(1-ecc0*ecc0) / (2.0*sqrt(2.0)) * pow(-1.0*e, -1.5) * delE;
	double delvtheta = delh/r;
	*fx = delvtheta * (-y/r);
   	*fy = delvtheta *  (x/r);
#if 0
	*dx = delh/vy;
	*dy = -1.0*delh/vx;
	if(isnan(*dy))
		*dy=0;
	if(isnan(*dx))
		*dx=0;
#endif
#if 0
	double vkep = 1.0/sqrt(a0);
	*fx =  (-y/r * vkep - vx)/tdamp;
	*fy =  (x/r * vkep -vy)/tdamp;
#endif

	
}
void adamp(double a, double adot, double x, double y, double vx, double vy, double * fx, double * fy, double * kickx, double * kicky)
// semi-major axis damping taken from Lee & Peale (2002) Appendix A
{
	*fx = -.5 * vx * adot / a;
	*fy = -.5 * vy * adot / a;
	*kickx = x*adot/a;
	*kicky = y*adot/a;
	return;
}
void evec_damp(double x, double y, double vx, double vy, double * fx, double *  fy,double * dx, double * dy, double tdamp){

	double h = x*vy-y*vx;
        double r = sqrt(x*x+y*y);
	double evecx = h*vy - x/r;
	double evecy = -h*vx - y/r;
	double magevec=sqrt(evecx*evecx+evecy*evecy);
	
	*fx =  evecy/ h / tdamp;
   	*fy = -1.0 * evecx/h / tdamp;
	*dx=*dy=0;
}
int derivs(double t, const double y[], double f[], void *params)
{
	double x1, y1, vx1, vy1,x2, y2, vx2, vy2,xtp, ytp, vxtp, vytp;
	double r12, dr1, dr2;
	double mu1, mu2;
	parameters * par =  (parameters *) params;
#if DAMPING
	double sma, vycirc, vxcirc, tdamp, fx, fy,kickx, kicky; 
	tdamp = TWOPI*DP;
#endif
	double q =  par->bin_mass_ratio;
	double ecc = par->bin_ecc;
	double * star1_xv = par->star1_xv;
	double * star2_xv = par->star2_xv;
	double * target_sma = par->target_a;
	int * active = par->is_active;
	//if(ecc != 0.0){printf("NONZERO e!!\n");exit(-1);}
	mu1 = 1.0/(1.0+q);
	mu2 = 1.0 - mu1;
	// *** Cartesian Barycentric Coordinates *** //
	double tmod2pi = WrapTwoPI(t);//WrapTwoPI(t); // !*** Set to mod2pi
	double vperi = sqrt(1.0+ecc)/sqrt(1.0-ecc);
	double vapo = sqrt(1.0-ecc)/sqrt(1.0+ecc);
	double r0[3] = {(1.0+ecc), 0.0, 0.0};
	double v0[3] = {0.0, vapo, 0.0};
	drift_shep(1.0, r0, v0,tmod2pi);
	x1=mu2*r0[0], y1=mu2*r0[1] , vx1=mu2*v0[0], vy1=mu2*v0[1];
	x2= -1.0 * mu1*r0[0], y2=-1.0*mu1*r0[1] , vx2= -1.0*mu1*v0[0], vy2=-1.0*mu1*v0[1];
	star1_xv[0] = x1;star1_xv[1] = y1;star1_xv[2] = vx1;star1_xv[3] = vy1;
	star2_xv[0] = x2;star2_xv[1] = y2;star2_xv[2] = vx2;star2_xv[3] = vy2;
	// ******************************************//
	//Time-Derivatives: 
	//******************
	// *** Test Particles *** //	
	int ntp = NVAR/4 ;
	int i;
	for (i=0; i < ntp; i++)
	{
	  if(active[i] > 0){
		int j= i*4;
		xtp = y[j]; ytp = y[j+1]; vxtp = y[j+2]; vytp = y[j+3];
		dr1 = sqrt ( (x1-xtp)*(x1-xtp) + (y1-ytp)*(y1-ytp) );
		dr2 = sqrt ( (x2-xtp)*(x2-xtp) + (y2-ytp)*(y2-ytp) );
		f[j] = y[j+2];
		f[j+1] = y[j+3];
		f[j+2] = mu1 * (x1-xtp) / pow(dr1,3) + mu2 * (x2-xtp) / pow(dr2,3);
		f[j+3] = mu1 * (y1-ytp) / pow(dr1,3) + mu2 * (y2-ytp) / pow(dr2,3);
	
#if DAMPING	
		if(1){
#if 1
			sma = get_sma(y[j],y[j+1],y[j+2],y[j+3]);
			double adot = (target_sma[i]-sma)/tdamp;
			double kickx, kicky;
			adamp(sma, adot, xtp, ytp,vxtp, vytp,&fx,&fy,&kickx,&kicky);
			f[j] = f[j] + kickx;
			f[j+1] = f[j+1] + kicky;
			f[j+2] = f[j+2] + fx;
			f[j+3] = f[j+3] + fy;
#endif	//	}else{
#if 1
			double dx=0,dy=0;
			//eldamp(xtp,ytp,vxtp,vytp,&fx,&fy,&dx,&dy,tdamp,target_sma[i]);
			evec_damp(xtp,ytp,vxtp,vytp,&fx,&fy,&dx,&dy,tdamp);
			f[j] = f[j] + dx;
			f[j+1] = f[j+1] + dy;
			f[j+2] = f[j+2] + fx;
			f[j+3] = f[j+3] + fy;
#endif
		}
#endif
	  }else{
		  int j;
		  for(j=i*4; j<(i*4+4);j++ )
			  f[j] = 0;
	  }
	}
	return GSL_SUCCESS;
}

