#include "xv2el.h"
#include "oc.h"
void xv2el2D(double mu, const double x[], const double v[], double el[])
{
	double coswf, cosf,sma, ecc;
	double r2 = x[0]*x[0] + x[1]*x[1];
	double v2 = v[0]*v[0] + v[1]*v[1];
	double hz = x[0]*v[1] - x[1]*v[0];
        //Semimajor axis:
	el[0] = 1.0 / (2.0/sqrt(r2) - v2 / mu );
	sma = el[0];
	//Eccentricity:
	el[1] = sqrt(1.0 - hz*hz/(mu*sma));	
	ecc = el[1];
	//Longitude of Periapse
	coswf = x[0]/sqrt(r2);
	cosf = (1.0/ecc) * (sma*(1.0 - ecc * ecc)/sqrt(r2) -1.0);
}
double get_sma(const double x,const double y,const double vx,const double vy)
{
	double sma;
	double r2 = x*x + y*y;
	double v2 = vx*vx + vy*vy;
	double hz = x*vy - y*vx;
        //Semimajor axis:
	sma  = 1.0 / (2.0/sqrt(r2) - v2 );
	return sma;
}
double get_ecc(const double x,const double y,const double vx,const double vy)
{
	double sma  = get_sma(x,y,vx,vy);
        double hz = x*vy - y*vx;	
	double ecc  = sqrt(1.0 - hz*hz/(sma));
	return ecc;
}

