#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <complex.h>

double positions[1600][4]={0}; //x,y,z position of each atom
double complex eikx[1000][30] = {0}; //the 10th index coresponds to zero, and you count up and down from there
double complex eiky[1000][30] = {0};
double complex eikz[1000][30] = {0};
double complex eikxn[3][30] = {0};
double complex eikyn[3][30] = {0};
double complex eikzn[3][30] = {0};
double complex ioneikx[30] = {0};
double complex ioneiky[30] = {0};
double complex ioneikz[30] = {0};
double complex pk[30][30][30]={0};
double pkexp[30][30][30]={0};
double errorfc[3000][3]={0};
double postemp[13]={0};
double iondensityhist[1000]={0};
double waterdhist[1000]={0};
double iweshist[4000]={0};
double rdhist[1000]={0};
int i,j,k,l,m,n = 0;
double rspacing = .08;
int nparticles = 756;
int nmolecules = 252;
int nsteps = 1000;
int nsweeps = 2000000;
double MH = 1;
double MO = 16;
double MW = 18;
double qo = -.8476;
double qh = .4238;
double epsilon = 0;
double sigma = 3.1663;
double alpha=.0784;
double qion=0;
double xmax = 10;
double xmin = -10;
double ymax = 10;
double ymin = -10;
double zmax = 20;
double zmin = -20;
double boxx = 20;
double boxy = 20;
double boxz = 40;
double disp = .6;
double rotdisp = .3;
double energytot = 0;
double energynew = 0;
double encom, encomnew=0;
double lenergy=0;
double renergy=0;
double kenergy=0;
double lenergynew=0;
double renergynew=0;
double kenergynew=0;
double avenergylj, avenergyes, avenergytot=0;
double ljww, ljiw=0;
double ljwwo, ljiwo=0;
double rsww, rsiw=0;
double rswwo, rsiwo=0;
double ksww, ksiw=0;
double kswwo, ksiwo=0;
double avrsiw, avksiw, avljiw, avetiw=0;
double avrsww, avksww, avljww, avetww=0;
double sigmaion=0;
double sigmaiw=0;
double ionmax, ionmin=0;
double ionh=0;
double comz1=0;
int kcutoff = 5;
int kzcutoff=10;
int a=0;
double bf=0;
double beta = 557; //300K
double ionx, iony, ionz=0;
long int idum=0;
double conversion = 1389.354;
char trajfile[128];
char fconfigfile[128];
char inputfile[128];
char iondfile[128];
char waterdfile[128];
char avenfile[128];
char aviwfile[128];
char avwwfile[128];
char iwhistfile[128];
char rdistfile[128];

void initialize();
void moveparticle();
void moveion();
void anglestats();
void rotateparticle();
void tabulateerrfc();
double esenergy1();
double rsenergy1(const int);
double ksenergy1(const int);
double rsenergy2();
double ksenergy2();
double ljenergy();
double ljenergy2(const int);
double ljenergy3();
void updatepk(const int);
void updatepk2();
void printtraj(const int);
void printfinal();
void statistics();
void printstats();
void ionheight();
void centerofmass();
double erfc(double);
float ran2(long *idum);
//unit of energy is 23.0705 * 10^-19 Joules

int main(int argc, char *argv[]){
double rdum=0;
sscanf(argv[1], "%s", &inputfile);
sscanf(argv[2], "%s", &trajfile);
sscanf(argv[3], "%s", &fconfigfile);
sscanf(argv[4], "%s", &iondfile);
sscanf(argv[5], "%s", &waterdfile);
sscanf(argv[6], "%s", &avenfile);
sscanf(argv[7], "%s", &aviwfile);
sscanf(argv[8], "%s", &avwwfile);
sscanf(argv[9], "%s", &iwhistfile);
sscanf(argv[10], "%s", &rdistfile);
sscanf(argv[11], "%lf", &ionmin);
sscanf(argv[12], "%lf", &ionmax);
sscanf(argv[13], "%lf", &sigmaion);
sscanf(argv[14], "%lf", &qion);
sscanf(argv[15], "%lf", &beta);
sscanf(argv[16], "%d", &nsweeps);

int part=0;
double acc1, tot1, acc2, tot2, acc3, tot3=0;
double acc, tot=0;
double conversion = 1389.354;//multiply energies by this to get kj/mol
double iwesdum=0;
int iwesint=0;
a=0;
idum = -time(NULL);
tabulateerrfc();
initialize();
esenergy1();
lenergy = ljenergy();
energytot = renergy + kenergy + lenergy;
 printf("%f %f %f %f\n", energytot, renergy, kenergy, lenergy);
for(n=0; n<=nsweeps-1; n++){
for(m=0; m<=nsteps-1; m++){
	rdum = ran2(&idum);
	part = (int)nmolecules*ran2(&idum);

	if(rdum > .5){
		centerofmass();
		postemp[0] = positions[3*part][0];
		postemp[1] = positions[3*part][1];
		postemp[2] = positions[3*part][2];
		postemp[3] = positions[3*part+1][0];
		postemp[4] = positions[3*part+1][1];
		postemp[5] = positions[3*part+1][2];
		postemp[6] = positions[3*part+2][0];
		postemp[7] = positions[3*part+2][1];
		postemp[8] = positions[3*part+2][2];
		postemp[9] = ionx;
		postemp[10] = iony;
		postemp[11] = ionz;
		moveparticle(part);
		ljwwo=ljww;
		ljiwo = ljiw;	
		rswwo = rsww;
		rsiwo = rsiw;
		ksiwo = ksiw;
		kswwo = ksww;
		lenergynew = ljenergy2(part);
		renergynew = rsenergy1(part);
		kenergynew = ksenergy1(part);
		comz1=0;
		//printf("%f %f %f\n", renergynew, kenergynew, lenergynew);
		for(l=0; l<=nmolecules-1; l++){
		  comz1 = comz1 + positions[3*l][2];
		}
		comz1 = comz1/nmolecules;
		energynew = lenergynew + renergynew + kenergynew;
		bf = exp(beta*(energytot-energynew));
		tot1 = tot1+1;
		tot = tot +1;
		ionh = ionz-comz1;
		if(ionh<ionmax && ionh>ionmin && comz1<4 && comz1>-4){
		if(ran2(&idum) <= bf || energynew < energytot){
			lenergy = lenergynew;
			renergy = renergynew;
			kenergy = kenergynew;
			energytot = energynew;
			acc1 = acc1 +1;
			acc = acc +1;
			updatepk(part);
			for(i=0; i<=2; i++){
				for(j=0; j<=kcutoff+1; j++){			
					eikx[3*part+i][15+j] = eikxn[i][15+j];
					eikx[3*part+i][15-j] = eikxn[i][15-j];
					eiky[3*part+i][15+j] = eikyn[i][15+j];
					eiky[3*part+i][15-j] = eikyn[i][15-j];
					
				}
				for(j=0; j<=kzcutoff+1; j++){
					eikz[3*part+i][15+j] = eikzn[i][15+j];
					eikz[3*part+i][15-j] = eikzn[i][15-j];
				}
			}
		}
		else{
			positions[3*part][0] = postemp[0];
			positions[3*part][1] = postemp[1];
			positions[3*part][2] = postemp[2];
			positions[3*part+1][0] = postemp[3];
			positions[3*part+1][1] = postemp[4];
			positions[3*part+1][2] = postemp[5];
			positions[3*part+2][0] = postemp[6];
			positions[3*part+2][1] = postemp[7];
			positions[3*part+2][2] = postemp[8];
			ionx = postemp[9];
			iony = postemp[10];
			ionz = postemp[11];
			ljww = ljwwo;
			ljiw = ljiwo;
			rsiw = rsiwo;
			rsww = rswwo;
			ksiw = ksiwo;
			ksww = kswwo;
		}
		}
		else{
			positions[3*part][0] = postemp[0];
			positions[3*part][1] = postemp[1];
			positions[3*part][2] = postemp[2];
			positions[3*part+1][0] = postemp[3];
			positions[3*part+1][1] = postemp[4];
			positions[3*part+1][2] = postemp[5];
			positions[3*part+2][0] = postemp[6];
			positions[3*part+2][1] = postemp[7];
			positions[3*part+2][2] = postemp[8];
			ionx = postemp[9];
			iony = postemp[10];
			ionz = postemp[11];
			ljww = ljwwo;
			ljiw = ljiwo;
			rsiw = rsiwo;
			rsww = rswwo;
			ksiw = ksiwo;
			ksww = kswwo;
		}
	}
	else if(rdum > 0.05){
		centerofmass();
		postemp[0] = positions[3*part][0];
		postemp[1] = positions[3*part][1];
		postemp[2] = positions[3*part][2];
		postemp[3] = positions[3*part+1][0];
		postemp[4] = positions[3*part+1][1];
		postemp[5] = positions[3*part+1][2];
		postemp[6] = positions[3*part+2][0];
		postemp[7] = positions[3*part+2][1];
		postemp[8] = positions[3*part+2][2];
		postemp[9] = ionx;
		postemp[10] = iony;
		postemp[11] = ionz;
		rotateparticle(part);
		ljwwo = ljww;
		ljiwo = ljiw;
		rsiwo = rsiw;
		rswwo = rsww;
		ksiwo = ksiw;
		kswwo = ksww;
		lenergynew = ljenergy2(part);
		renergynew = rsenergy1(part);
		kenergynew = ksenergy1(part);
		comz1=0;
		for(l=0; l<=nmolecules-1; l++){
		  comz1 = comz1 + positions[3*l][2];
		}
		comz1 = comz1/nmolecules;
		energynew = lenergynew + renergynew + kenergynew;
		//printf("%f %f %f %f\n", renergynew, kenergynew, lenergynew, encomnew);
		bf = exp(beta*(energytot-energynew));
		tot2 = tot2 +1;
		tot = tot +1;
		ionh = ionz - comz1;
		if(ionh<ionmax && ionh>ionmin && comz1<4 && comz1>-4){
		if(ran2(&idum) <= bf || energynew < energytot){
			
			lenergy = lenergynew;
			renergy = renergynew;
			kenergy = kenergynew;
			energytot = energynew;
			acc2 = acc2 +1;
			acc = acc +1;
			updatepk(part);
			for(i=0; i<=2; i++){
				for(j=0; j<=kcutoff+1; j++){			
					eikx[3*part+i][15+j] = eikxn[i][15+j];
					eikx[3*part+i][15-j] = eikxn[i][15-j];
					eiky[3*part+i][15+j] = eikyn[i][15+j];
					eiky[3*part+i][15-j] = eikyn[i][15-j];
					
				}
				for(j=0; j<=kzcutoff+1; j++){
					eikz[3*part+i][15+j] = eikzn[i][15+j];
					eikz[3*part+i][15-j] = eikzn[i][15-j];
				}
			}
		}
		else{

			positions[3*part][0] = postemp[0];
			positions[3*part][1] = postemp[1];
			positions[3*part][2] = postemp[2];
			positions[3*part+1][0] = postemp[3];
			positions[3*part+1][1] = postemp[4];
			positions[3*part+1][2] = postemp[5];
			positions[3*part+2][0] = postemp[6];
			positions[3*part+2][1] = postemp[7];
			positions[3*part+2][2] = postemp[8];
			ionx = postemp[9];
			iony = postemp[10];
			ionz = postemp[11];
			ljww = ljwwo;
			ljiw = ljiwo;
			rsww = rswwo;
			rsiw = rsiwo;
			ksiw = ksiwo;
			ksww = kswwo; 
		}
	}
	else{
		positions[3*part][0] = postemp[0];
			positions[3*part][1] = postemp[1];
			positions[3*part][2] = postemp[2];
			positions[3*part+1][0] = postemp[3];
			positions[3*part+1][1] = postemp[4];
			positions[3*part+1][2] = postemp[5];
			positions[3*part+2][0] = postemp[6];
			positions[3*part+2][1] = postemp[7];
			positions[3*part+2][2] = postemp[8];
			ionx = postemp[9];
			iony = postemp[10];
			ionz = postemp[11];
			ljww = ljwwo;
			ljiw = ljiwo;
			rsww = rswwo;
			rsiw = rsiwo;
			ksiw = ksiwo;
			ksww = kswwo;
	}
	}
	else{
	  	
		postemp[0] = ionx;
		postemp[1] = iony;
		postemp[2] = ionz;
		moveion();
		ljiwo = ljiw;
		rsiwo = rsiw;
		ksiwo = ksiw;
		kswwo = ksww;
		lenergynew = ljenergy3();
		renergynew = rsenergy2();
		kenergynew = ksenergy2();
		tot3 = tot3 +1;
		tot = tot +1;
		comz1=0;
		for(l=0; l<=nmolecules-1; l++){
		  comz1 = comz1 + positions[3*l][2];
		}
		comz1 = comz1/nmolecules;
		energynew = lenergynew + renergynew + kenergynew;
		bf = exp(beta*(energytot-energynew));
		ionh = ionz - comz1;		

		if(ionh<ionmax && ionh>ionmin && comz1<4 && comz1>-4){
		  if(ran2(&idum) <= bf || energynew < energytot){

			lenergy = lenergynew;
			renergy = renergynew;
			kenergy = kenergynew;
			energytot = energynew;
			acc = acc +1;
			acc3 = acc3 +1;
			updatepk2();
			for(j=0; j<=kcutoff+1; j++){			
					ioneikx[15+j] = eikxn[0][15+j];
					ioneikx[15-j] = eikxn[0][15-j];
					ioneiky[15+j] = eikyn[0][15+j];
					ioneiky[15-j] = eikyn[0][15-j];
					
			}
			for(j=0; j<=kzcutoff+1; j++){
				ioneikz[15+j] = eikzn[0][15+j];
				ioneikz[15-j] = eikzn[0][15-j];
			}
		  }
		  else{
			ionx = postemp[0];
			iony = postemp[1];	
			ionz = postemp[2];
			ljiw = ljiwo;
			rsiw = rsiwo;
			ksiw = ksiwo;
			ksww = kswwo;
		  }
		}
		else{
			ionx = postemp[0];
			iony = postemp[1];	
			ionz = postemp[2];
			ljiw = ljiwo;
			rsiw = rsiwo;
			ksiw = ksiwo;
			ksww = kswwo;
		}
	}

}


if(n>2000){
	if(n % 100 == 0){
		printtraj(n);
		//printf("%f %f %f %f %f\n", energytot, lenergy, renergy, kenergy, ionz);
		//statistics();
		printstats();
		printfinal();
		
	}
	if(n % 20 == 0){
		comz1=0;
		for(l=0; l<=nmolecules-1; l++){
		  comz1 = comz1 + positions[3*l][2];
		}
		comz1 = comz1/nmolecules;
		ionh = ionz-comz1;
		ionheight();
	}
	if(n % 5 == 0){	
		//printf("%f %f %f %f %f\n", energytot, lenergy, renergy, kenergy, ionz);
		avljiw = (avljiw*a + ljiw)/(a+1);
		avljww = (avljww*a + ljww)/(a+1);
		avrsiw = (avrsiw*a + rsiw)/(a+1);
		avksiw = (avksiw*a + ksiw)/(a+1);
		avrsww = (avrsww*a + rsww)/(a+1);
		avksww = (avksww*a + ksww)/(a+1);
		avetiw = avljiw + avrsiw + avksiw;
		avetww = avljww + avrsww + avksww;
		avenergylj = (avenergylj*a + lenergy)/(a+1);
		avenergyes = (avenergyes*a + renergy + kenergy)/(a+1);
		avenergytot = (avenergytot*a + energytot)/(a+1);
		a = a+1;
		iwesdum = conversion*(rsiw + ksiw) + 1000;
		if(iwesdum>0 && iwesdum < 4000){
		iwesint = (int)iwesdum;
		iweshist[iwesint] = iweshist[iwesint]+1;
		}
	   statistics();
	}
   
}
}
acc = acc/tot;
acc1 = acc1/tot1;
acc2 = acc2/tot2;
printfinal();
//printf("acc1 is %f acc2 is %f acctot is %f\n", acc1, acc2, acc);
printstats();
return 0;
}

void centerofmass(){
comz1=0;
for(l=0; l<=nmolecules-1; l++){

   comz1 = comz1 + positions[3*l][2];
 }
 comz1 = comz1/((double)nmolecules);

}

void initialize(){
double xr, yr, zr, r2=0;
FILE *configptr;
configptr = fopen(inputfile, "r");
epsilon = 4.67843*pow(10, -4);
for(i=0; i<=nparticles-1; i++){
	fscanf(configptr, "%lf %lf %lf %lf\n", &positions[i][0], &positions[i][1], &positions[i][2], &positions[i][3]);
}
fscanf(configptr, "%lf %lf %lf\n", &ionx, &iony, &ionz);
comz1=0;
 for(i=0; i<=nmolecules-1; i++){
   comz1 = comz1 + positions[3*i][2];
 }
 comz1 = comz1/((double)nmolecules);
for(l=0; l<=nmolecules-1; l++){
   positions[3*l][2] = positions[3*l][2]-comz1;
   positions[3*l+1][2] = positions[3*l+1][2]-comz1;
   positions[3*l+2][2] = positions[3*l+2][2]-comz1;

 }
ionz = ionz - comz1;
/*
 ionx = 0;
 iony = 0;
 ionz = comz1 + ionmin;*/
sigmaiw = (sigma + sigmaion)/2;

fclose(configptr);
}




void rotateparticle(const int p){
double com[3]={0};
double r0, r1, r2, r3=0;
double rsq=2;
double rx, ry, rz=0;
double xtemp=0;
double theta=0;
double sint, cost=0;
double d, dsq=0;
double xr, yr, zr=0;
double comz2=0;

com[0] = positions[3*p][0]*MO + (positions[3*p+1][0] + positions[3*p+2][0])*MH;
com[0] = com[0]/MW;
com[1] = positions[3*p][1]*MO + (positions[3*p+1][1] + positions[3*p+2][1])*MH;
com[1] = com[1]/MW;
com[2] = positions[3*p][2]*MO + (positions[3*p+1][2] + positions[3*p+2][2])*MH;
com[2] = com[2]/MW;



positions[3*p][0] = positions[3*p][0]-com[0];
positions[3*p+1][0] = positions[3*p+1][0]-com[0];
positions[3*p+2][0] = positions[3*p+2][0]-com[0];
positions[3*p][1] = positions[3*p][1]-com[1];
positions[3*p+1][1] = positions[3*p+1][1]-com[1];
positions[3*p+2][1] = positions[3*p+2][1]-com[1];
positions[3*p][2] = positions[3*p][2]-com[2];
positions[3*p+1][2] = positions[3*p+1][2]-com[2];
positions[3*p+2][2] = positions[3*p+2][2]-com[2];

//generate random unit vector
while(rsq >= 1){
   r1 = 1-2*ran2(&idum);
   r2 = 1-2*ran2(&idum);
   
   rsq = r1*r1 + r2*r2;
}


r0=2*sqrt(1-rsq);
r1=r1*r0;
r2=r2*r0;
r3=(1-2*rsq);


theta = rotdisp*(.5-ran2(&idum))*2*3.14159;
sint = sin(theta);
cost = cos(theta);
//rotation matrix

rx = positions[3*p][0];
ry = positions[3*p][1];
rz = positions[3*p][2];

positions[3*p][0] = rx*(r1*r1 + (1 - r1*r1)*cost) + ry*(r1*r2*(1-cost) - r3*sint) + rz*(r1*r3*(1-cost) + r2*sint);
positions[3*p][1] = rx*(r1*r2*(1-cost) + r3*sint) + ry*(r2*r2 + (1-r2*r2)*cost) + rz*(r2*r3*(1-cost) - r1*sint);
positions[3*p][2] = rx*(r1*r3*(1-cost) - r2*sint) + ry*(r2*r3*(1-cost) + r1*sint) + rz*(r3*r3 + (1-r3*r3)*cost);

rx = positions[3*p+1][0];
ry = positions[3*p+1][1];
rz = positions[3*p+1][2];

positions[3*p+1][0] = rx*(r1*r1 + (1 - r1*r1)*cost) + ry*(r1*r2*(1-cost) - r3*sint) + rz*(r1*r3*(1-cost) + r2*sint);
positions[3*p+1][1] = rx*(r1*r2*(1-cost) + r3*sint) + ry*(r2*r2 + (1-r2*r2)*cost) + rz*(r2*r3*(1-cost) - r1*sint);
positions[3*p+1][2] = rx*(r1*r3*(1-cost) - r2*sint) + ry*(r2*r3*(1-cost) + r1*sint) + rz*(r3*r3 + (1-r3*r3)*cost);

rx = positions[3*p+2][0];
ry = positions[3*p+2][1];
rz = positions[3*p+2][2];

positions[3*p+2][0] = rx*(r1*r1 + (1 - r1*r1)*cost) + ry*(r1*r2*(1-cost) - r3*sint) + rz*(r1*r3*(1-cost) + r2*sint);
positions[3*p+2][1] = rx*(r1*r2*(1-cost) + r3*sint) + ry*(r2*r2 + (1-r2*r2)*cost) + rz*(r2*r3*(1-cost) - r1*sint);
positions[3*p+2][2] = rx*(r1*r3*(1-cost) - r2*sint) + ry*(r2*r3*(1-cost) + r1*sint) + rz*(r3*r3 + (1-r3*r3)*cost);



positions[3*p][0] = positions[3*p][0]+com[0];
positions[3*p+1][0] = positions[3*p+1][0]+com[0];
positions[3*p+2][0] = positions[3*p+2][0]+com[0];
positions[3*p][1] = positions[3*p][1]+com[1];
positions[3*p+1][1] = positions[3*p+1][1]+com[1];
positions[3*p+2][1] = positions[3*p+2][1]+com[1];
positions[3*p][2] = positions[3*p][2]+com[2];
positions[3*p+1][2] = positions[3*p+1][2]+com[2];
positions[3*p+2][2] = positions[3*p+2][2]+com[2];

xtemp = positions[3*p][0];
if(positions[3*p][0]>xmax){
	positions[3*p][0] = positions[3*p][0] - boxx;
	positions[3*p+1][0] = positions[3*p+1][0] - boxx;
	positions[3*p+2][0] = positions[3*p+2][0] - boxx;
}

if(positions[3*p][0]<xmin){
	positions[3*p][0] = boxx + positions[3*p][0];
	positions[3*p+1][0] = boxx + positions[3*p+1][0];
	positions[3*p+2][0] = boxx + positions[3*p+2][0];
}

if(positions[3*p][1]>ymax){
	positions[3*p][1] = positions[3*p][1] - boxy;
	positions[3*p+1][1] = positions[3*p+1][1] - boxy;
	positions[3*p+2][1] = positions[3*p+2][1] - boxy;
}

if(positions[3*p][1]<ymin){
	positions[3*p][1] = boxy + positions[3*p][1];
	positions[3*p+1][1] = boxy + positions[3*p+1][1];
	positions[3*p+2][1] = boxy + positions[3*p+2][1];
}

if(positions[3*p][2]>zmax){
	positions[3*p][2] = positions[3*p][2] - boxz;
	positions[3*p+1][2] = positions[3*p+1][2] - boxz;
	positions[3*p+2][2] = positions[3*p+2][2] - boxz;
}

if(positions[3*p][2]<zmin){
	positions[3*p][2] = boxz + positions[3*p][2];
	positions[3*p+1][2] = boxz + positions[3*p+1][2];
	positions[3*p+2][2] = boxz + positions[3*p+2][2];
}



}

void moveparticle(const int p){

double r0, r1, r2, r3=0;
double rsq=2;
double scale=0;
double comz2=0;

//generate random unit vector
while(rsq >= 1){
   r1 = 1-2*ran2(&idum);
   r2 = 1-2*ran2(&idum);
   
   rsq = r1*r1 + r2*r2;
}

r0=2*sqrt(1-rsq);
r1=r1*r0;
r2=r2*r0;
r3=(1-2*rsq);
scale = ran2(&idum)*disp;
r1 = r1*scale;
r2 = r2*scale;
r3 = r3*scale;


positions[3*p][0] = positions[3*p][0] + r1;
positions[3*p][1] = positions[3*p][1] + r2;
positions[3*p][2] = positions[3*p][2] + r3;

positions[3*p+1][0] = positions[3*p+1][0] + r1;
positions[3*p+1][1] = positions[3*p+1][1] + r2;
positions[3*p+1][2] = positions[3*p+1][2] + r3;

positions[3*p+2][0] = positions[3*p+2][0] + r1;
positions[3*p+2][1] = positions[3*p+2][1] + r2;
positions[3*p+2][2] = positions[3*p+2][2] + r3;

if(positions[3*p][0]>xmax){
	positions[3*p][0] = positions[3*p][0] - boxx;
	positions[3*p+1][0] = positions[3*p+1][0] - boxx;
	positions[3*p+2][0] = positions[3*p+2][0] - boxx;
}

if(positions[3*p][0]<xmin){
	positions[3*p][0] = boxx + positions[3*p][0];
	positions[3*p+1][0] = boxx + positions[3*p+1][0];
	positions[3*p+2][0] = boxx + positions[3*p+2][0];
}

if(positions[3*p][1]>ymax){
	positions[3*p][1] = positions[3*p][1] - boxy;
	positions[3*p+1][1] = positions[3*p+1][1] - boxy;
	positions[3*p+2][1] = positions[3*p+2][1] - boxy;
}

if(positions[3*p][1]<ymin){
	positions[3*p][1] = boxy + positions[3*p][1];
	positions[3*p+1][1] = boxy + positions[3*p+1][1];
	positions[3*p+2][1] = boxy + positions[3*p+2][1];
}

if(positions[3*p][2]>zmax){
	positions[3*p][2] = positions[3*p][2] - boxz;
	positions[3*p+1][2] = positions[3*p+1][2] - boxz;
	positions[3*p+2][2] = positions[3*p+2][2] - boxz;
}

if(positions[3*p][2]<zmin){
	positions[3*p][2] = boxz + positions[3*p][2];
	positions[3*p+1][2] = boxz + positions[3*p+1][2];
	positions[3*p+2][2] = boxz + positions[3*p+2][2];
}


}

void moveion(){
  double r0, r1, r2, r3=0;
  double rsq=2;
  double scale=0;


  //generate random unit vector
  while(rsq >= 1){
    r1 = 1-2*ran2(&idum);
    r2 = 1-2*ran2(&idum);
   
    rsq = r1*r1 + r2*r2;
  }

  r0=2*sqrt(1-rsq);
  r1=r1*r0;
  r2=r2*r0;
  r3=(1-2*rsq);
  scale = ran2(&idum)*disp;
  r1 = r1*scale;
  r2 = r2*scale;
  r3 = r3*scale;

  ionx = ionx + r1;
  iony = iony + r2;
  ionz = ionz + r3;
  if(ionx>xmax){
    ionx = ionx - boxx;
  }

  if(ionx<xmin){
    ionx = boxx + ionx;
  }

  if(iony>ymax){
    iony = iony - boxy;
  }

  if(iony<ymin){
    iony = boxy + iony;
  }

  if(ionz>zmax){
    ionz = ionz - boxz;
  }

  if(ionz<zmin){
    ionz = boxz + ionz;
  }

}



double ljenergy(){
double energy=0;
double xr, yr, zr, r2=0;
double r6=0;
double ljcutoff = 100;
double sigma2 = 0;
double sigmaiw2 = 0;
double ecut1, ecut2=0;
double factor=0;
sigma2 = sigma*sigma;
sigmaiw2 = sigmaiw*sigmaiw;
r6 = (sigma2/ljcutoff)*(sigma2/ljcutoff)*(sigma2/ljcutoff);
ecut1 = 4*epsilon*(r6*r6-r6);
r6 = (sigmaiw2/ljcutoff)*(sigmaiw2/ljcutoff)*(sigmaiw2/ljcutoff);
ecut2 = 4*epsilon*(r6*r6-r6);

for(i=0; i<=nmolecules-1; i++){
	for(j=i+1; j<=nmolecules-1; j++){
		xr = positions[3*i][0] - positions[3*j][0];
		if(xr > boxx/2){
			xr = xr - boxx;
		}
		if(xr < -boxx/2){
			xr = boxx + xr;
		}
      yr = positions[3*i][1] - positions[3*j][1];
		if(yr > boxy/2){
			yr = yr - boxy;
		}
		if(yr < -boxy/2){
			yr = boxy + yr;
		}
      zr = positions[3*i][2] - positions[3*j][2];
		if(zr > boxz/2){
				zr = zr - boxz;
		}
		if(zr < -boxz/2){
				zr = boxz + zr;
		}
		r2 = xr*xr + yr*yr + zr*zr;
		if(r2 < ljcutoff){
			r6 = (sigma2/r2)*(sigma2/r2)*(sigma2/r2);
			factor = 4*epsilon*(r6*r6 - r6);
			energy = energy + factor - ecut1;
			ljww = ljww + factor - ecut1;
		}
	}
}


for(i=0; i<=nmolecules-1; i++){
	xr = positions[3*i][0] - ionx;
	if(xr > boxx/2){
		xr = xr - boxx;
	}
	if(xr < -boxx/2){
		xr = boxx + xr;
	}
	yr = positions[3*i][1] - iony;
	if(yr > boxy/2){
		yr = yr - boxy;
	}
	if(yr < -boxy/2){
		yr = boxy + yr;
	}
	zr = positions[3*i][2] - ionz;
	if(zr > boxz/2){
		zr = zr - boxz;
	}
	if(zr < -boxz/2){
		zr = boxz + zr;
	}
	r2 = xr*xr + yr*yr + zr*zr;
	if(r2 < ljcutoff){
		r6 = (sigmaiw2/r2)*(sigmaiw2/r2)*(sigmaiw2/r2);
		factor = 4*epsilon*(r6*r6-r6);
		energy = energy + factor-ecut2;
		ljiw = ljiw + factor - ecut2;
	}
}

return energy;

}

double ljenergy2(const int p){
double energy=0;
double xr, yr, zr, r2=0;
double r6=0;
double ljcutoff = 100;
double sigma2 = 0;
double sigmaiw2 = 0;
double ecut1, ecut2=0;
double factor=0;
sigma2 = sigma*sigma;
sigmaiw2 = sigmaiw*sigmaiw;
r6 = (sigma2/ljcutoff)*(sigma2/ljcutoff)*(sigma2/ljcutoff);
ecut1 = 4*epsilon*(r6*r6-r6);
r6 = (sigmaiw2/ljcutoff)*(sigmaiw2/ljcutoff)*(sigmaiw2/ljcutoff);
ecut2 = 4*epsilon*(r6*r6-r6);

energy = lenergy;

for(i=0; i<=nmolecules-1; i++){
	if(i != p){
		xr = positions[3*i][0] - positions[3*p][0];
		if(xr > boxx/2){
			xr = xr - boxx;
		}
		if(xr < -boxx/2){
			xr = boxx + xr;
		}
      yr = positions[3*i][1] - positions[3*p][1];
		if(yr > boxy/2){
			yr = yr - boxy;
		}
		if(yr < -boxy/2){
			yr = boxy + yr;
		}
      zr = positions[3*i][2] - positions[3*p][2];
		if(zr > boxz/2){
				zr = zr - boxz;
		}
		if(zr < -boxz/2){
				zr = boxz + zr;
		}
		r2 = xr*xr + yr*yr + zr*zr;
		if(r2 < ljcutoff){
			r6 = (sigma2/r2)*(sigma2/r2)*(sigma2/r2);
			factor = 4*epsilon*(r6*r6-r6);
			energy = energy + factor - ecut1;
			ljww = ljww + factor - ecut1;
		}
	}
}

for(i=0; i<=nmolecules-1; i++){
	if(i != p){
		xr = positions[3*i][0] - postemp[0];
		if(xr > boxx/2){
			xr = xr - boxx;
		}
		if(xr < -boxx/2){
			xr = boxx + xr;
		}
      yr = positions[3*i][1] - postemp[1];
		if(yr > boxy/2){
			yr = yr - boxy;
		}
		if(yr < -boxy/2){
			yr = boxy + yr;
		}
      zr = positions[3*i][2] - postemp[2];
		if(zr > boxz/2){
				zr = zr - boxz;
		}
		if(zr < -boxz/2){
				zr = boxz + zr;
		}
		r2 = xr*xr + yr*yr + zr*zr;
		if(r2 < ljcutoff){
			r6 = (sigma2/r2)*(sigma2/r2)*(sigma2/r2);
			factor = 4*epsilon*(r6*r6-r6);
			energy = energy - factor + ecut1;
			ljww = ljww - factor + ecut1;
		}
	}
}

xr = positions[3*p][0] - ionx;
if(xr > boxx/2){
	xr = xr - boxx;
}
if(xr < -boxx/2){
	xr = boxx + xr;
}
yr = positions[3*p][1] - iony;
if(yr > boxy/2){
	yr = yr - boxy;
}
if(yr < -boxy/2){
	yr = boxy + yr;
}
zr = positions[3*p][2] - ionz;
if(zr > boxz/2){
	zr = zr - boxz;
}
if(zr < -boxz/2){
	zr = boxz + zr;
}
r2 = xr*xr + yr*yr + zr*zr;
if(r2 < ljcutoff){
	r6 = (sigmaiw2/r2)*(sigmaiw2/r2)*(sigmaiw2/r2);
	factor = 4*epsilon*(r6*r6-r6);
	energy = energy + factor-ecut2;
	ljiw = ljiw + factor - ecut2;		
}

xr = postemp[0] - ionx;
if(xr > boxx/2){
	xr = xr - boxx;
}
if(xr < -boxx/2){
	xr = boxx + xr;
}
yr = postemp[1] - iony;
if(yr > boxy/2){
	yr = yr - boxy;
}
if(yr < -boxy/2){
	yr = boxy + yr;
}
zr = postemp[2] - ionz;
if(zr > boxz/2){
	zr = zr - boxz;
}
if(zr < -boxz/2){
	zr = boxz + zr;
}
r2 = xr*xr + yr*yr + zr*zr;
if(r2 < ljcutoff){
	r6 = (sigmaiw2/r2)*(sigmaiw2/r2)*(sigmaiw2/r2);
	factor = 4*epsilon*(r6*r6-r6);
	energy = energy - factor+ecut2;
	ljiw = ljiw - factor + ecut2;
}

return energy;


}

double ljenergy3(){
double energy=0;
double xr, yr, zr, r2=0;
double r6=0;
double ljcutoff = 100;
double sigma2 = 0;
double sigmaiw2 = 0;
double ecut1, ecut2=0;
double factor=0;
sigma2 = sigma*sigma;
sigmaiw2 = sigmaiw*sigmaiw;
r6 = (sigma2/ljcutoff)*(sigma2/ljcutoff)*(sigma2/ljcutoff);
ecut1 = 4*epsilon*(r6*r6-r6);
r6 = (sigmaiw2/ljcutoff)*(sigmaiw2/ljcutoff)*(sigmaiw2/ljcutoff);
ecut2 = 4*epsilon*(r6*r6-r6);

energy = lenergy;

for(i=0; i<=nmolecules-1; i++){
	xr = positions[3*i][0] - ionx;
	if(xr > boxx/2){
		xr = xr - boxx;
	}
	if(xr < -boxx/2){
		xr = boxx + xr;
	}
	yr = positions[3*i][1] - iony;
	if(yr > boxy/2){
		yr = yr - boxy;
	}
	if(yr < -boxy/2){
		yr = boxy + yr;
	}
	zr = positions[3*i][2] - ionz;
	if(zr > boxz/2){
		zr = zr - boxz;
	}
	if(zr < -boxz/2){
		zr = boxz + zr;
	}
	r2 = xr*xr + yr*yr + zr*zr;
	if(r2 < ljcutoff){
		r6 = (sigmaiw2/r2)*(sigmaiw2/r2)*(sigmaiw2/r2);
		factor = 4*epsilon*(r6*r6-r6);
		energy = energy + factor-ecut2;
		ljiw = ljiw + factor - ecut2;
	}
}

for(i=0; i<=nmolecules-1; i++){
	xr = positions[3*i][0] - postemp[0];
	if(xr > boxx/2){
		xr = xr - boxx;
	}
	if(xr < -boxx/2){
		xr = boxx + xr;
	}
	yr = positions[3*i][1] - postemp[1];
	if(yr > boxy/2){
		yr = yr - boxy;
	}
	if(yr < -boxy/2){
		yr = boxy + yr;
	}
	zr = positions[3*i][2] - postemp[2];
	if(zr > boxz/2){
		zr = zr - boxz;
	}
	if(zr < -boxz/2){
		zr = boxz + zr;
	}
	r2 = xr*xr + yr*yr + zr*zr;
	if(r2 < ljcutoff){
		r6 = (sigmaiw2/r2)*(sigmaiw2/r2)*(sigmaiw2/r2);
		factor = 4*epsilon*(r6*r6-r6);
		energy = energy - factor+ecut2;
		ljiw = ljiw - factor + ecut2;
	}
}

return energy;

}


double esenergy1(const int partn){
double xr, yr, zr, r2=0;
double xr1, yr1, zr1=0;
double kx, ky, kz = 0;
double volume=0;
double complex pkr=0;
double complex pkr2=0;
double factor=0;
double q1, q2 = 0;
double k2=0;
double sqalpha=0;
long int c1=0;
int r2int=0;
sqalpha = sqrt(alpha);
volume=boxx*boxy*boxz;





//long range part

for(i=0; i<=nparticles-1; i++){
	eikx[i][15] = 1;
	eikx[i][16] = cexp(I*2*3.141593*positions[i][0]/boxx);
	eikx[i][14] = cexp(-I*2*3.141593*positions[i][0]/boxx);
	eiky[i][15] = 1;
	eiky[i][16] = cexp(I*2*3.141593*positions[i][1]/boxy);
	eiky[i][14] = cexp(-I*2*3.141593*positions[i][1]/boxy);
	eikz[i][15] = 1;
	eikz[i][16] = cexp(I*2*3.141593*positions[i][2]/boxz);
	eikz[i][14] = cexp(-I*2*3.141593*positions[i][2]/boxz);
}

ioneikx[15] = 1;
ioneikx[16] = cexp(I*2*3.141593*ionx/boxx);
ioneikx[14] = cexp(-I*2*3.141593*ionx/boxx);
ioneiky[15] = 1;
ioneiky[16] = cexp(I*2*3.141593*iony/boxy);
ioneiky[14] = cexp(-I*2*3.141593*iony/boxy);
ioneikz[15] = 1;
ioneikz[16] = cexp(I*2*3.141593*ionz/boxz);
ioneikz[14] = cexp(-I*2*3.141593*ionz/boxz);

for(i=0; i<=nparticles-1; i++){
	for(j=1; j<=kcutoff; j++){
		eikx[i][16+j] = eikx[i][15+j]*eikx[i][16];
		eikx[i][14-j] = eikx[i][15-j]*eikx[i][14];
		eiky[i][16+j] = eiky[i][15+j]*eiky[i][16];
		eiky[i][14-j] = eiky[i][15-j]*eiky[i][14];
		
	}
	for(j=1; j<=kzcutoff; j++){
		eikz[i][16+j] = eikz[i][15+j]*eikz[i][16];
		eikz[i][14-j] = eikz[i][15-j]*eikz[i][14];
		
	}
}

for(j=1; j<=kcutoff; j++){
		ioneikx[16+j] = ioneikx[15+j]*ioneikx[16];
		ioneikx[14-j] = ioneikx[15-j]*ioneikx[14];
		ioneiky[16+j] = ioneiky[15+j]*ioneiky[16];
		ioneiky[14-j] = ioneiky[15-j]*ioneiky[14];
		
}
for(j=1; j<=kzcutoff; j++){
	ioneikz[16+j] = ioneikz[15+j]*ioneikz[16];
	ioneikz[14-j] = ioneikz[15-j]*ioneikz[14];
	
}


//the following loops are constructed to minimize the calculation based on the fact that |p(k)|^2 = |p(-k)|^2
for(i=16; i<=16+kcutoff; i++){
	for(j=15; j<=16+kcutoff; j++){
		for(k=15; k<=16+kzcutoff; k++){
            pkr = 0;
            kx = 2*3.1415926*(i-15)/boxx;
            ky = 2*3.1415926*(j-15)/boxy;
            kz = 2*3.1415926*(k-15)/boxz;
				for(l=0; l<=nparticles-1; l++){
					pkr = pkr + positions[l][3]*eikx[l][i]*eiky[l][j]*eikz[l][k];
				}
				pkr2 = pkr;		
				pkr = pkr + qion*ioneikx[i]*ioneiky[j]*ioneikz[k];
				pk[i][j][k] = pkr;
				pkr = pkr*conj(pkr);
				k2 = kx*kx + ky*ky + kz*kz;
				pkexp[i][j][k] = 4*3.14159*exp(-k2/(4*alpha))/(k2*volume);
				kenergy = kenergy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww + pkexp[i][j][k]*pkr2;
				//printf("%f\n", energy	);
			
      }
   }
}


for(i=14-kcutoff; i<=15; i++){
  for(j=15; j<=16+kcutoff; j++){
    for(k=16; k<=16+kzcutoff; k++){

            pkr = 0;
            kx = 2*3.1415926*(i-15)/boxx;
            ky = 2*3.1415926*(j-15)/boxy;
            kz = 2*3.1415926*(k-15)/boxz;
				for(l=0; l<=nparticles-1; l++){
					pkr = pkr + positions[l][3]*eikx[l][i]*eiky[l][j]*eikz[l][k];
				}			
				pkr2 = pkr;		
				pkr = pkr + qion*ioneikx[i]*ioneiky[j]*ioneikz[k];
				pk[i][j][k] = pkr;
            pkr = pkr*conj(pkr);
            k2 = kx*kx + ky*ky + kz*kz;
         	pkexp[i][j][k] = 4*3.14159*exp(-k2/(4*alpha))/(k2*volume);
            kenergy = kenergy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww+ pkexp[i][j][k]*pkr2;
				//printf("%f\n", energy);
			
      }
   }
}


for(i=14-kcutoff; i<=14; i++){
  for(j=14-kcutoff; j<=14; j++){
    for(k=16; k<=16+kzcutoff; k++){

            pkr = 0;
			kx = 2*3.1415926*(i-15)/boxx;
            ky = 2*3.1415926*(j-15)/boxy;
            kz = 2*3.1415926*(k-15)/boxz;
				for(l=0; l<=nparticles-1; l++){
					pkr = pkr + positions[l][3]*eikx[l][i]*eiky[l][j]*eikz[l][k];
				}			
				pkr2 = pkr;		
				pkr = pkr + qion*ioneikx[i]*ioneiky[j]*ioneikz[k];
				pk[i][j][k] = pkr;
            pkr = pkr*conj(pkr);
            k2 = kx*kx + ky*ky + kz*kz;
         	pkexp[i][j][k] = 4*3.14159*exp(-k2/(4*alpha))/(k2*volume);
            kenergy = kenergy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww+ pkexp[i][j][k]*pkr2;
				//printf("%f\n", energy);
      }
   }
}

 for(i=15; i<=16+kcutoff; i++){
   for(j=14-kcutoff; j<=14; j++){
     for(k=15; k<=16+kzcutoff; k++){
            pkr = 0;
            kx = 2*3.1415926*(i-15)/boxx;
            ky = 2*3.1415926*(j-15)/boxy;
            kz = 2*3.1415926*(k-15)/boxz;
				for(l=0; l<=nparticles-1; l++){
					pkr = pkr + positions[l][3]*eikx[l][i]*eiky[l][j]*eikz[l][k];
				}			
				pkr2 = pkr;		
				pkr = pkr + qion*ioneikx[i]*ioneiky[j]*ioneikz[k];
				pk[i][j][k] = pkr;
            pkr = pkr*conj(pkr);
            k2 = kx*kx + ky*ky + kz*kz;
         	pkexp[i][j][k] = 4*3.14159*exp(-k2/(4*alpha))/(k2*volume);
            kenergy = kenergy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww + pkexp[i][j][k]*pkr2;
				//printf("%f\n", energy);

      }
   }
}

ksiw = kenergy - ksww;
printf("%f %f %f\n", kenergy, ksiw, ksww);

//short range part

for(i=0; i<=nparticles-1; i=i+3){
	for(k=0; k<=2; k++){
   	for(j=i+3; j<=nparticles-1; j++){
		
			c1 = c1+1;
      	
			if(j % 3 ==0){ //ensures that periodic boundary conditions are applied to the oxygens
				xr1 = positions[i][0] - positions[j][0];
				yr1 = positions[i][1] - positions[j][1];
				zr1 = positions[i][2] - positions[j][2];
			
			}
			xr = positions[i+k][0] - positions[j][0];
			if(xr1 > boxx/2){
				xr = xr - boxx;
			}
			if(xr1 < -boxx/2){
				xr = boxx + xr;
			}
      	yr = positions[i+k][1] - positions[j][1];
			if(yr1 > boxy/2){
				yr = yr - boxy;
			}
			if(yr1 < -boxy/2){
				yr = boxy + yr;
			}
      	zr = positions[i+k][2] - positions[j][2];
			if(zr1 > boxz/2){
				zr = zr - boxz;
			}
			if(zr1 < -boxz/2){
				zr = boxz + zr;
			}
      	r2 = xr*xr + yr*yr + zr*zr;
      	r2 = sqrt(r2);
			r2int = r2/.0125;
			factor = positions[i+k][3]*positions[j][3]*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
			renergy = renergy + factor;
		}
	}     
}
rsww = renergy;



for(i=0; i<=nparticles-1; i=i+3){
	for(k=0; k<=2; k++){
		
		
		xr1 = positions[i][0] - ionx;
		yr1 = positions[i][1] - iony;
		zr1 = positions[i][2] - ionz;
		

		xr = positions[i+k][0] - ionx;
		if(xr1 > boxx/2){
			xr = xr - boxx;
		}
		if(xr1 < -boxx/2){
			xr = boxx + xr;
		}
		yr = positions[i+k][1] - iony;
		if(yr1 > boxy/2){
			yr = yr - boxy;
		}
		if(yr1 < -boxy/2){
			yr = boxy + yr;
		}
		zr = positions[i+k][2] - ionz;
		if(zr1 > boxz/2){
			zr = zr - boxz;
		}
		if(zr1 < -boxz/2){
			zr = boxz + zr;
		}
		r2 = xr*xr + yr*yr + zr*zr;
		r2 = sqrt(r2);
		r2int = r2/.0125;
		//printf("%f %d\n", r2, r2int);
		factor = positions[i+k][3]*qion*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
	   renergy = renergy + factor;
	}
}
rsiw = renergy - rsww;
    
}

double ksenergy1(const int partn){
double energy=0;
double xr, yr, zr, r2=0;
double xr1, yr1, zr1=0;
double complex pkr, pki=0;
double complex pkr2=0;
double q1, q2 = 0;
double k2=0;
double sqalpha=0;
long int c1=0;
int r2int=0;
sqalpha = sqrt(alpha);
energy = 0;
ksww=0;
ksiw=0;
//long range part
for(i=0; i<=2; i++){
	eikxn[i][15] = 1;
	eikxn[i][16] = cexp(I*2*3.141593*positions[3*partn+i][0]/boxx);
	eikxn[i][14] = cexp(-I*2*3.141593*positions[3*partn+i][0]/boxx);
	eikyn[i][15] = 1;
	eikyn[i][16] = cexp(I*2*3.141593*positions[3*partn+i][1]/boxy);
	eikyn[i][14] = cexp(-I*2*3.141593*positions[3*partn+i][1]/boxy);
	eikzn[i][15] = 1;
	eikzn[i][16] = cexp(I*2*3.141593*positions[3*partn+i][2]/boxz);
	eikzn[i][14] = cexp(-I*2*3.141593*positions[3*partn+i][2]/boxz);
}


for(i=0; i<=2; i++){
	for(j=1; j<=kcutoff; j++){
		eikxn[i][16+j] = eikxn[i][15+j]*eikxn[i][16];
		eikxn[i][14-j] = eikxn[i][15-j]*eikxn[i][14];
		eikyn[i][16+j] = eikyn[i][15+j]*eikyn[i][16];
		eikyn[i][14-j] = eikyn[i][15-j]*eikyn[i][14];
	}
	for(j=1; j<=kzcutoff; j++){
		eikzn[i][16+j] = eikzn[i][15+j]*eikzn[i][16];
		eikzn[i][14-j] = eikzn[i][15-j]*eikzn[i][14];
	}
}

for(i=16; i<=16+kcutoff; i++){
	for(j=15; j<=16+kcutoff; j++){
		for(k=15; k<=16+kzcutoff; k++){
         
          
            pkr = pk[i][j][k];
          
          
				for(l=0; l<=2; l++){
					pkr = pkr + positions[3*partn+l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
      		pkr2 = pkr-qion*ioneikx[i]*ioneiky[j]*ioneikz[k];

            pkr = pkr*conj(pkr);
         
            energy = energy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww + pkexp[i][j][k]*pkr2;
				//printf("%f\n", energy);
			
      }
   }
}

for(i=14-kcutoff; i<=15; i++){
  for(j=15; j<=16+kcutoff; j++){
    for(k=16; k<=16+kzcutoff; k++){
      
	 	pkr = pk[i][j][k];
          
          
				for(l=0; l<=2; l++){
					pkr = pkr + positions[3*partn+l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
      
				pkr2 = pkr-qion*ioneikx[i]*ioneiky[j]*ioneikz[k];

            pkr = pkr*conj(pkr);
         
            energy = energy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww + pkexp[i][j][k]*pkr2;
	 	//printf("%f\n", energy);
       
     }
   }
 }

for(i=14-kcutoff; i<=14; i++){
  for(j=14-kcutoff; j<=14; j++){
    for(k=16; k<=16+kzcutoff; k++){
       
         pkr = pk[i][j][k];
          
          
				for(l=0; l<=2; l++){
					pkr = pkr + positions[3*partn+l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
      

            pkr2 = pkr-qion*ioneikx[i]*ioneiky[j]*ioneikz[k];

            pkr = pkr*conj(pkr);
         
            energy = energy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww + pkexp[i][j][k]*pkr2;
         //printf("%f\n", energy);                                                                                                                           
       
     }
   }
 }

 for(i=15; i<=16+kcutoff; i++){
   for(j=14-kcutoff; j<=14; j++){
     for(k=15; k<=16+kzcutoff; k++){
      
         pkr = pk[i][j][k];
          
          
				for(l=0; l<=2; l++){
					pkr = pkr + positions[3*partn+l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
      

            pkr2 = pkr-qion*ioneikx[i]*ioneiky[j]*ioneikz[k];

            pkr = pkr*conj(pkr);
         
            energy = energy + pkexp[i][j][k]*pkr;
				pkr2 = pkr2*conj(pkr2);
				ksww = ksww + pkexp[i][j][k]*pkr2;
         //printf("%f\n", energy);                                                                                                                           
      
     }
   }
 }
ksiw = energy - ksww;
return energy;
}

double rsenergy1(const int p){
double xr, yr, zr, r2=0;
double xr1, yr1, zr1=0;
double energy=0;
int r2int=0;
double factor=0;
energy = renergy;

for(i=0; i<=nparticles-1; i=i+3){
	if(i != 3*p){
		xr1 = positions[i][0] - positions[3*p][0];
		yr1 = positions[i][1] - positions[3*p][1];
		zr1 = positions[i][2] - positions[3*p][2];
		for(k=0; k<=2; k++){
			for(j=0; j<=2; j++){
		
      		xr = positions[i+k][0] - positions[3*p+j][0];
			
				if(xr1 > boxx/2){
					xr = xr - boxx;
				}
				if(xr1 < -boxx/2){
					xr = boxx + xr;
				}
      		yr = positions[i+k][1] - positions[3*p+j][1];
				if(yr1 > boxy/2){
					yr = yr - boxy;
				}
				if(yr1 < -boxy/2){
					yr = boxy + yr;
				}
      		zr = positions[i+k][2] - positions[3*p+j][2];
				if(zr1 > boxz/2){
					zr = zr - boxz;
				}
				if(zr1 < -boxz/2){
					zr = boxz + zr;
				}
      		r2 = xr*xr + yr*yr + zr*zr;
      		r2 = sqrt(r2);
				r2int = r2/.0125;
				factor = positions[i+k][3]*positions[3*p+j][3]*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
      		energy = energy + factor;
      		rsww = rsww + factor;
				
			}
		}
	}     
}

for(i=0; i<=nparticles-1; i=i+3){
	if(i != 3*p){
		xr1 = positions[i][0] - postemp[0];
		yr1 = positions[i][1] - postemp[1];
		zr1 = positions[i][2] - postemp[2];
		for(k=0; k<=2; k++){
			for(j=0; j<=2; j++){
		
      		xr = positions[i+k][0] - postemp[3*j];
			
				if(xr1 > boxx/2){
					xr = xr - boxx;
				}
				if(xr1 < -boxx/2){
					xr = boxx + xr;
				}
      		yr = positions[i+k][1] - postemp[3*j+1];
				if(yr1 > boxy/2){
					yr = yr - boxy;
				}
				if(yr1 < -boxy/2){
					yr = boxy + yr;
				}
      		zr = positions[i+k][2] - postemp[3*j+2];
				if(zr1 > boxz/2){
					zr = zr - boxz;
				}
				if(zr1 < -boxz/2){
					zr = boxz + zr;
				}
      		r2 = xr*xr + yr*yr + zr*zr;
      		r2 = sqrt(r2);
				r2int = r2/.0125;
				factor = positions[i+k][3]*positions[3*p+j][3]*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
      		energy = energy - factor;
      		rsww = rsww - factor;
			}
		}
	}     
}

for(k=0; k<=2; k++){
	
	xr1 = positions[3*p][0] - ionx;
	yr1 = positions[3*p][1] - iony;
	zr1 = positions[3*p][2] - ionz;
	

	xr = positions[3*p+k][0] - ionx;
	if(xr1 > boxx/2){
		xr = xr - boxx;
	}
	if(xr1 < -boxx/2){
		xr = boxx + xr;
	}
	yr = positions[3*p+k][1] - iony;
	if(yr1 > boxy/2){
		yr = yr - boxy;
	}
	if(yr1 < -boxy/2){
		yr = boxy + yr;
	}
	zr = positions[3*p+k][2] - ionz;
	if(zr1 > boxz/2){
		zr = zr - boxz;
	}
	if(zr1 < -boxz/2){
		zr = boxz + zr;
	}
	r2 = xr*xr + yr*yr + zr*zr;
	r2 = sqrt(r2);
	r2int = r2/.0125;
	//printf("%f %d\n", r2, r2int);
	factor = positions[3*p+k][3]*qion*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
	energy = energy + factor;
	rsiw = rsiw + factor;
	
}

for(k=0; k<=2; k++){
	
	xr1 = postemp[0] - ionx;
	yr1 = postemp[1] - iony;
	zr1 = postemp[2] - ionz;

	xr = postemp[3*k] - ionx;
	if(xr1 > boxx/2){
		xr = xr - boxx;
	}
	if(xr1 < -boxx/2){
		xr = boxx + xr;
	}
	yr = postemp[3*k+1] - iony;
	if(yr1 > boxy/2){
		yr = yr - boxy;
	}
	if(yr1 < -boxy/2){
		yr = boxy + yr;
	}
	zr = postemp[3*k+2] - ionz;
	if(zr1 > boxz/2){
		zr = zr - boxz;
	}
	if(zr1 < -boxz/2){
		zr = boxz + zr;
	}
	r2 = xr*xr + yr*yr + zr*zr;
	r2 = sqrt(r2);
	r2int = r2/.0125;
	//printf("%f %d\n", r2, r2int);
	factor = positions[3*p+k][3]*qion*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
	energy = energy - factor;
	rsiw = rsiw - factor;
}

return energy;


}


double ksenergy2(){
double energy=0;
double xr, yr, zr, r2=0;
double xr1, yr1, zr1=0;
double volume=0;
double complex pkr=0;
double complex pkr2=0;
double q1, q2 = 0;
double k2=0;
double sqalpha=0;
long int c1=0;
int r2int =0;
sqalpha = sqrt(alpha);
energy = 0;
ksww=0;
ksiw=0;
//long range part


eikxn[0][15] = 1;
eikxn[0][16] = cexp(I*2*3.141593*ionx/boxx);
eikxn[0][14] = cexp(-I*2*3.141593*ionx/boxx);
eikyn[0][15] = 1;
eikyn[0][16] = cexp(I*2*3.141593*iony/boxy);
eikyn[0][14] = cexp(-I*2*3.141593*iony/boxy);
eikzn[0][15] = 1;
eikzn[0][16] = cexp(I*2*3.141593*ionz/boxz);
eikzn[0][14] = cexp(-I*2*3.141593*ionz/boxz);




for(j=1; j<=kcutoff; j++){
		eikxn[0][16+j] = eikxn[0][15+j]*eikxn[0][16];
		eikxn[0][14-j] = eikxn[0][15-j]*eikxn[0][14];
		eikyn[0][16+j] = eikyn[0][15+j]*eikyn[0][16];
		eikyn[0][14-j] = eikyn[0][15-j]*eikyn[0][14];
}

for(j=1; j<=kzcutoff; j++){
		eikzn[0][16+j] = eikzn[0][15+j]*eikzn[0][16];
		eikzn[0][14-j] = eikzn[0][15-j]*eikzn[0][14];
}

for(i=16; i<=16+kcutoff; i++){
	for(j=15; j<=16+kcutoff; j++){
		for(k=15; k<=16+kzcutoff; k++){
         
          
            pkr = pk[i][j][k];
          
          
				
				pkr = pkr + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);  
      		pkr2 = pkr - qion*eikxn[0][i]*eikyn[0][j]*eikzn[0][k];

            pkr = pkr*conj(pkr);
         	pkr2 = pkr2*conj(pkr2);
            energy = energy + pkexp[i][j][k]*pkr;
				ksww = ksww + pkexp[i][j][k]*pkr2;
				//printf("%f\n", energy);
			
      }
   }
}

for(i=14-kcutoff; i<=15; i++){
  for(j=15; j<=16+kcutoff; j++){
    for(k=16; k<=16+kzcutoff; k++){
      
	 	pkr = pk[i][j][k];
          
          
				
				pkr = pkr + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);  
      		pkr2 = pkr - qion*eikxn[0][i]*eikyn[0][j]*eikzn[0][k];

            pkr = pkr*conj(pkr);
         	pkr2 = pkr2*conj(pkr2);
            energy = energy + pkexp[i][j][k]*pkr;
				ksww = ksww + pkexp[i][j][k]*pkr2;
	 	//printf("%f\n", energy);
       
     }
   }
 }

for(i=14-kcutoff; i<=14; i++){
  for(j=14-kcutoff; j<=14; j++){
    for(k=16; k<=16+kzcutoff; k++){
       
         pkr = pk[i][j][k];
          
          
				
				pkr = pkr + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);  
      		pkr2 = pkr - qion*eikxn[0][i]*eikyn[0][j]*eikzn[0][k];

            pkr = pkr*conj(pkr);
         	pkr2 = pkr2*conj(pkr2);
            energy = energy + pkexp[i][j][k]*pkr;
				ksww = ksww + pkexp[i][j][k]*pkr2;
         //printf("%f\n", energy);                                                                                                                           
       
     }
   }
 }

 for(i=15; i<=16+kcutoff; i++){
   for(j=14-kcutoff; j<=14; j++){
     for(k=15; k<=16+kzcutoff; k++){
      
         pkr = pk[i][j][k];
          
          
				
				pkr = pkr + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);  
      		pkr2 = pkr - qion*eikxn[0][i]*eikyn[0][j]*eikzn[0][k];

            pkr = pkr*conj(pkr);
         	pkr2 = pkr2*conj(pkr2);
            energy = energy + pkexp[i][j][k]*pkr;
				ksww = ksww + pkexp[i][j][k]*pkr2;
         //printf("%f\n", energy);                                                                                                                           
      
     }
   }
 }

ksiw = energy - ksww;


return energy;
}

double rsenergy2(){
double energy=0;
double xr, yr, zr, r2=0;
double xr1, yr1, zr1=0;
double volume=0;
double sqalpha=0;
long int c1=0;
int r2int =0;
double factor=0;
energy = renergy;
for(i=0; i<=nparticles-1; i=i+3){
	for(k=0; k<=2; k++){
		if(i % 3 == 0){ //ensures that periodic boundary conditions are applied to the oxygens
					xr1 = positions[i][0] - ionx;
					yr1 = positions[i][1] - iony;
					zr1 = positions[i][2] - ionz;
		}
		xr = positions[i+k][0] - ionx;
		if(xr1 > boxx/2){
			xr = xr - boxx;
		}
		if(xr1 < -boxx/2){
			xr = boxx + xr;
		}
		yr = positions[i+k][1] - iony;
		if(yr1 > boxy/2){
			yr = yr - boxy;
		}
		if(yr1 < -boxy/2){
			yr = boxy + yr;
		}
		zr = positions[i+k][2] - ionz;
		if(zr1 > boxz/2){
			zr = zr - boxz;
		}
		if(zr1 < -boxz/2){
			zr = boxz + zr;
		}
		r2 = xr*xr + yr*yr + zr*zr;
		r2 = sqrt(r2);
		r2int = r2/.0125;
		factor = positions[i+k][3]*qion*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
	   energy = energy + factor;
	   rsiw = rsiw + factor;
	}
}

for(i=0; i<=nparticles-1; i=i+3){
	for(k=0; k<=2; k++){
		if(i % 3 == 0){ //ensures that periodic boundary conditions are applied to the oxygens
					xr1 = positions[i][0] - postemp[0];
					yr1 = positions[i][1] - postemp[1];
					zr1 = positions[i][2] - postemp[2];
		}
		xr = positions[i+k][0] - postemp[0];
		if(xr1 > boxx/2){
			xr = xr - boxx;
		}
		if(xr1 < -boxx/2){
			xr = boxx + xr;
		}
		yr = positions[i+k][1] - postemp[1];
		if(yr1 > boxy/2){
			yr = yr - boxy;
		}
		if(yr1 < -boxy/2){
			yr = boxy + yr;
		}
		zr = positions[i+k][2] - postemp[2];
		if(zr1 > boxz/2){
			zr = zr - boxz;
		}
		if(zr1 < -boxz/2){
			zr = boxz + zr;
		}
		r2 = xr*xr + yr*yr + zr*zr;
		r2 = sqrt(r2);
		r2int = r2/.0125;
		factor = positions[i+k][3]*qion*(errorfc[r2int][1]+(r2-errorfc[r2int][0])*errorfc[r2int][2]);
	    energy = energy - factor;
		rsiw = rsiw - factor;
	}
}

return energy;

}



void updatepk(const int partn){
for(i=16; i<=16+kcutoff; i++){
	for(j=15; j<=16+kcutoff; j++){
		for(k=15; k<=16+kzcutoff; k++){
      
				for(l=0; l<=2; l++){
					pk[i][j][k] = pk[i][j][k] + positions[l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
     }
   }
 }

for(i=14-kcutoff; i<=15; i++){
  for(j=15; j<=16+kcutoff; j++){
    for(k=16; k<=16+kzcutoff; k++){
      
				for(l=0; l<=2; l++){
					pk[i][j][k] = pk[i][j][k] + positions[l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
     }
   }
 }

for(i=14-kcutoff; i<=14; i++){
  for(j=14-kcutoff; j<=14; j++){
    for(k=16; k<=16+kzcutoff; k++){
      
				for(l=0; l<=2; l++){
					pk[i][j][k] = pk[i][j][k] + positions[l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
     }
   }
 }

 for(i=15; i<=16+kcutoff; i++){
   for(j=14-kcutoff; j<=14; j++){
     for(k=15; k<=16+kzcutoff; k++){
      
				for(l=0; l<=2; l++){
					pk[i][j][k] = pk[i][j][k] + positions[l][3]*(eikxn[l][i]*eikyn[l][j]*eikzn[l][k] - eikx[3*partn+l][i]*eiky[3*partn+l][j]*eikz[3*partn+l][k]);
				}       
     }
   }
 }


}

void updatepk2(){
for(i=16; i<=16+kcutoff; i++){
	for(j=15; j<=16+kcutoff; j++){
		for(k=15; k<=16+kzcutoff; k++){
      
				
			pk[i][j][k] = pk[i][j][k] + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);  
			     
     }
   }
 }

for(i=14-kcutoff; i<=15; i++){
  for(j=15; j<=16+kcutoff; j++){
    for(k=16; k<=16+kzcutoff; k++){
      
				pk[i][j][k] = pk[i][j][k] + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);       
     }
   }
 }

for(i=14-kcutoff; i<=14; i++){
  for(j=14-kcutoff; j<=14; j++){
    for(k=16; k<=16+kzcutoff; k++){
      
				pk[i][j][k] = pk[i][j][k] + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);       
     }
   }
 }

 for(i=15; i<=16+kcutoff; i++){
   for(j=14-kcutoff; j<=14; j++){
     for(k=15; k<=16+kzcutoff; k++){
      
				pk[i][j][k] = pk[i][j][k] + qion*(eikxn[0][i]*eikyn[0][j]*eikzn[0][k] - ioneikx[i]*ioneiky[j]*ioneikz[k]);       
     }
   }
 }


}



void printtraj(const int ts){
FILE *trajptr;
trajptr=fopen(trajfile, "a");

fprintf(trajptr, "%d\n\n", nparticles + 1);

for(i=0; i<=nparticles-1; i=i+3){
	fprintf(trajptr, "O %f %f %f\n", positions[i][0], positions[i][1], positions[i][2]);
	fprintf(trajptr, "H %f %f %f\n", positions[i+1][0], positions[i+1][1], positions[i+1][2]);
	fprintf(trajptr, "H %f %f %f\n", positions[i+2][0], positions[i+2][1], positions[i+2][2]);
}

fprintf(trajptr, "I %f %f %f\n", ionx, iony, ionz);

fclose(trajptr);
}


void printfinal(){
FILE *finalconfig;
finalconfig = fopen(fconfigfile, "w");
for(i=0; i<=nparticles-1; i++){
	fprintf(finalconfig, "%f %f %f %f\n", positions[i][0], positions[i][1], positions[i][2], positions[i][3]);
}
fprintf(finalconfig, "%f %f %f\n", ionx, iony, ionz);
fclose(finalconfig);


}

void statistics(){
  double comz=0;
  double ionpos=0;
  int ionposint=0;
  double waterpos=0;
  int    waterposint=0;
	double rx, ry, rz, r2=0;
	int rint=0;
  for(i=0; i<=nmolecules-1; i++){
    comz = comz + positions[3*i][2];
  }
  comz = comz/nmolecules;
  ionpos = ionz - comz + 10;
  ionposint = ionpos/.05;
  iondensityhist[ionposint] = iondensityhist[ionposint]+1;
  for(i=0; i<=nmolecules-1; i++){
    waterpos = positions[3*i][2] - comz+10;
    waterposint =waterpos/.05;
	if(waterposint>0){
    waterdhist[waterposint] = waterdhist[waterposint] + 1;
	}
  }

for(i=0; i<=nparticles-1; i=i+3){
rx = ionx - positions[i][0];
if(rx>boxx/2)
 rx = -boxx+rx;
if(rx<-boxx/2)
 rx = boxx + rx;
ry=iony-positions[i][1];
if(ry>boxy/2)
 ry = -boxy+ry;
if(ry<-boxy/2)
ry = boxy+ry;
rz=ionz-positions[i][2];
r2=rx*rx + ry*ry + rz*rz;
r2=sqrt(r2);

rint=(int)(r2/rspacing);
if(rint<1000){
	rdhist[rint] = rdhist[rint]+1;
}
}


}


void ionheight(){
	FILE *iondptr;
  iondptr=fopen(iondfile, "a");
  fprintf(iondptr, "%.12f\n", ionh);
  fclose(iondptr);
	
}


void printstats(){
  double ionpos=0;
double volume1, volume2=0;
double volume3=0;
  FILE *waterdptr;
  waterdptr = fopen(waterdfile,"w");
	FILE *avenptr;
 avenptr = fopen(avenfile, "a");
	FILE *iwptr; 
iwptr = fopen(aviwfile, "a");
FILE *wwptr;
wwptr = fopen(avwwfile, "a");
FILE *iwhistptr;
iwhistptr=fopen(iwhistfile, "w");
FILE *rdistptr;
rdistptr=fopen(rdistfile, "w");	
  for(i=0; i<=600; i++){
    ionpos = i*.05;
    ionpos = ionpos-10;
    fprintf(waterdptr, "%f %f\n", ionpos, waterdhist[i]/nmolecules);
  }
	for(i=0; i<=4000; i++){
		volume1 = i-1000 - qion*qion*sqrt(alpha/3.14159)*conversion;
		fprintf(iwhistptr,"%f %f\n", volume1, iweshist[i]);
	}
	for(i=0; i<=1000; i++){
		volume1=(i+.5)*rspacing;
		volume2=(i+1+.5)*rspacing;
		volume2 = volume2*volume2*volume2-volume1*volume1*volume1;
		volume2 = rdhist[i]/(volume2*a);
		fprintf(rdistptr, "%f %f\n", volume1, volume2);
	}
	volume1 = conversion*(avenergytot - sqrt(alpha/3.14159)*(504*.4238*.4238 + 252*.8476*.8476 + qion*qion));
	volume2 = conversion*(avenergyes - sqrt(alpha/3.14159)*(504*.4238*.4238 + 252*.8476*.8476 + qion*qion));
	volume3 = conversion*avenergylj;
	fprintf(avenptr, "%d %f %f %f\n", a, volume1, volume2, volume3);
	volume1 = conversion*(avetiw-sqrt(alpha/3.14159)*qion*qion);
	volume2 = conversion*(avrsiw + avksiw - sqrt(alpha/3.14159)*qion*qion);
	volume3 = conversion*avljiw;
      fprintf(iwptr, "%d %f %f %f\n", a, volume1, volume2, volume3);
      volume1 = conversion*(avetww - sqrt(alpha/3.14159)*(504*.4238*.4238 + 252*.8476*.8476));
      volume2 = conversion*(avrsww + avksww - sqrt(alpha/3.14159)*(504*.4238*.4238 + 252*.8476*.8476));
      volume3 = conversion*avljww;
       fprintf(wwptr, "%d %f %f %f\n", a, volume1, volume2, volume3);
	fclose(avenptr);
  fclose(waterdptr);
	fclose(iwptr);
  fclose(wwptr);
	fclose(iwhistptr);
	fclose(rdistptr);

}

#define IM1 2147483563
#define IM2 2147483399
#define AM (1.0/IM1)
#define IMM1 (IM1-1)
#define IA1 40014
#define IA2 40692
#define IQ1 53668
#define IQ2 52774
#define IR1 12211
#define IR2 3791
#define NTAB 32
#define NDIV (1+IMM1/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)

float ran2(long *idum)
{
  int j;
  long k;
  static long idum2=123456789;
  static long iy=0;
  static long iv[NTAB];
  float temp;

  if (*idum <= 0) {
    if (-(*idum) < 1) *idum=1;
    else *idum = -(*idum);
    idum2 = (*idum);
    for (j=NTAB+7;j>=0;j--) {
      k=(*idum)/IQ1;
      *idum=IA1*(*idum-k*IQ1)-k*IR1;
      if (*idum < 0) *idum += IM1;
      if (j < NTAB) iv[j] = *idum;
    }
    iy=iv[0];
  }
  k=(*idum)/IQ1;
  *idum=IA1*(*idum-k*IQ1)-k*IR1;
  if (*idum < 0) *idum += IM1;
  k=idum2/IQ2;
  idum2=IA2*(idum2-k*IQ2)-k*IR2;
  if (idum2 < 0) idum2 += IM2;
  j=iy/NDIV;
  iy=iv[j]-idum2;
  iv[j] = *idum;
  if (iy < 1) iy+= IMM1;
  if ((temp=AM*iy) > RNMX) return RNMX;
  else return temp;
}

void tabulateerrfc(){
double sqalpha=0;
sqalpha = sqrt(alpha);

for(i=0; i<=2999; i++){
errorfc[i][0] = i*.0125;
errorfc[i][1] = erfc(errorfc[i][0]*sqalpha)/(errorfc[i][0]);
}
for(i=0; i<=2999; i++){
errorfc[i][2] = (errorfc[i+1][1]-errorfc[i][1])/(errorfc[i+1][0]-errorfc[i][0]);
}

}




