#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <complex.h>
//this code computes both es and lj energies, using coulumb potential for the interaction between water and ion
//the order in which things are printed out is esww, esiw, ljww, ljiw, density
//treats box size as 20 by 20 by 40
float totenergies[500][500][5]={0};
double positions[1000][4]={0};
double dipoles[900][3]={0};
double BT[400][3]={0};
double AP[400][3]={0};
double AD[400][3]={0};
double individualenergies[500][6]={0};
double residuals[900][3]={0};
double directions[900][3]={0};
int t,timesteps=0;
int i,j,k,l,m=0;
char inputfile[128];
char outputfile[128];
double aionx, aiony, aionz=0;
double cionx, ciony, cionz=0;
double qion=0;
double boxx=20;
double boxy=20;
double boxz=18.4;
double tolerance=0.0;
double polarizability=0.0;
int kcutoff = 4;
int kzcutoff = 4;
double alpha=.0784;
double errorfc[3000][3] = {0};
int Nparticles = 750;
int Nmolecules = 250;
double iondipoleenergy=0;
double dipoledipoleenergy=0;
double dipolefcenergy=0;

void statistics1();
void statistics2();
double esenergy1();
void tabulateerrfc();
void ljenergy1();
void initialize();
void cg();
void computeAE();
void computeAD();
void dipoleenergy();
int main(int argc, char *argv[])
{
  sscanf(argv[1], "%s", &inputfile);
  sscanf(argv[2], "%s", &outputfile);
  sscanf(argv[3], "%f", &qion);
  sscanf(argv[4], "%lf", &tolerance);
  sscanf(argv[5], "%lf", &polarizability);
  char lineoffile[100];
  FILE *lammpsptr;
  double iondpav, dpdpav, dpfcav=0;
  lammpsptr=fopen(inputfile,"r");
  tabulateerrfc();
  initialize();

  while((fgets(lineoffile, sizeof(lineoffile), lammpsptr)) !=NULL){
    for(i=0; i<=751; i++){
      fscanf(lammpsptr,"%s %lf %lf %lf\n", &lineoffile, &positions[i][0], &positions[i][1], &positions[i][2]);
      if(i%3 == 0){
	positions[i][3] = -.8476;
      }
      else{
	positions[i][3] = .4238;
      }
    }
    aionx = positions[750][0];
    aiony = positions[750][1];
    aionz = positions[750][2];
    cionx = positions[751][0];
    ciony = positions[751][1];
    cionz = positions[751][2];
    timesteps = timesteps+1;
    printf("%d\n", timesteps);
    cg();
    dpdpav+=dipoledipoleenergy;
    dpfcav+=dipolefcenergy;
    iondpav+=iondipoleenergy;
  }
  dpdpav=dpdpav/timesteps;
  iondpav=iondpav/timesteps;
  dpfcav=dpfcav/timesteps;
  printf("%f %f %f\n", dpdpav, iondpav, dpfcav);
  statistics2();
  return 0;
}

void statistics1(){
  double dpenergy1=0;
  double dpenergy2=0;
  int zint, zint2=0;
  int rhoint=0;
  float iix, iiy, iiz, iir=0;
  float rx, ry, rz, r2=0;
  float r2parallel, r2perpendicular;
  float rx1, ry1, rz1, rz2=0;
  float comz=0;
  for(i=0; i<=Nmolecules-1; i++){
    dpenergy1 += 0.5*(dipoles[i][0]*AP[i][0] + dipoles[i][1]*AP[i][1] + dipoles[i][2]*AP[i][2]);
    dpenergy2 -= (dipoles[i][0]*BT[i][0] + dipoles[i][1]*BT[i][1] + dipoles[i][2]*BT[i][2]);
    individualenergies[i][0] = 0.5*(dipoles[i][0]*AP[i][0] + dipoles[i][1]*AP[i][1]+dipoles[i][2]*AP[i][2]);
    individualenergies[i][1] = -(dipoles[i][0]*BT[i][0] + dipoles[i][1]*BT[i][1] + dipoles[i][2]*BT[i][2]);
    //printf("%lf %lf %lf %lf %lf\n", AP[i][0], AP[i][1], AP[i][2], dipoles[i][0], dpenergy1);
    //printf("%lf\n", dpenergy2);
  }
  dipoledipoleenergy=dpenergy1;
  dipolefcenergy=dpenergy2;
  printf("dp %lf %lf %lf\n", dpenergy1+dpenergy2, dpenergy1, dpenergy2);
  iix = cionx-aionx;
  if(iix> boxx/2)
    iix = iix - boxx;
  if(iix<-boxx/2)
    iix = boxx + iix;

  iiy = ciony-aiony;
  if(iiy> boxy/2)
    iiy = iiy - boxy;
  if(iiy<-boxy/2)
    iiy = boxy + iiy;

  iiz = cionz-aionz;
  if(iiz> boxz/2)
    iiz = iiz - boxz;
  if(iiz<-boxz/2)
    iiz = boxz + iiz;
  iir = iix*iix + iiy*iiy + iiz*iiz;
  iir = sqrt(iir);
  iix = iix/iir;
  iiy = iiy/iir;
  iiz = iiz/iir;
  for(k=0; k<750; k=k+3){
    rx = positions[k][0] - aionx;
    if(rx> boxx/2)
      rx = rx - boxx;
    if(rx<-boxx/2)
      rx = boxx + rx;
    ry = positions[k][1] - aiony;
    if(ry>boxy/2)
      ry = ry - boxy;
    if(ry<-boxy/2)
      ry = boxy + ry;
    rz = positions[k][2] - aionz;
    if(rz>boxz/2)
      rz = rz - boxz;
    if(rz<-boxz/2)
      rz = boxz + rz;
    rz2 = positions[k][2] - cionz;
    if(rz2>boxz/2)
      rz2 = rz2 - boxz;
    if(rz2<-boxz/2)
      rz2 = boxz + rz2;
    r2 = rx*rx + ry*ry + rz*rz;
    r2parallel = rx*iix + ry*iiy + rz*iiz;
    r2perpendicular = sqrt(r2 - r2parallel*r2parallel);
    rhoint = r2perpendicular/.2;
    zint = (r2parallel+9)/.2;
    if(zint > 0){
      totenergies[zint][rhoint][0] = totenergies[zint][rhoint][0] + 1;
      totenergies[zint][rhoint][1] = totenergies[zint][rhoint][1] + individualenergies[k/3][0];
      totenergies[zint][rhoint][2] = totenergies[zint][rhoint][2] + individualenergies[k/3][1];
      totenergies[zint][rhoint][3] = totenergies[zint][rhoint][3] + individualenergies[k/3][2];
      totenergies[zint][rhoint][4] = totenergies[zint][rhoint][4] + individualenergies[k/3][3];
    }
  }
}

void cg(){
  double delta, deltanew=0;
  int imax=100;
  double y[400][3]={0};
  double residuals2[400][3]={0};
  double stepsize=0;
  double dTy, beta=0;
  int i1, j1=0;
  computeAE();
  delta=0;
  deltanew=0;
  for(i1=0; i1<=Nmolecules-1; i1++){
    residuals[i1][0] = BT[i1][0]-AP[i1][0];
    residuals[i1][1] = BT[i1][1]-AP[i1][1];
    residuals[i1][2] = BT[i1][2]-AP[i1][2];
    directions[i1][0] = residuals[i1][0];
    directions[i1][1] = residuals[i1][1];
    directions[i1][2] = residuals[i1][2];
    deltanew += directions[i1][0]*directions[i1][0] + directions[i1][1]*directions[i1][1] + directions[i1][2]*directions[i1][2];
  }
  i1=0;
  printf("dn init %f\n", deltanew);
  while(i1<imax && deltanew> tolerance){
    computeAD();
    dTy=0;
    for(j1=0; j1<=Nmolecules-1; j1++){
      y[j1][0]=AD[j1][0];
      y[j1][1]=AD[j1][1];
      y[j1][2]=AD[j1][2];
      dTy+=y[j1][0]*directions[j1][0]+y[j1][1]*directions[j1][1]+y[j1][2]*directions[j1][2];
    }
    stepsize=deltanew/dTy;
    for(j1=0; j1<=Nmolecules-1; j1++){
      dipoles[j1][0]+=stepsize*directions[j1][0];
      dipoles[j1][1]+=stepsize*directions[j1][1];
      dipoles[j1][2]+=stepsize*directions[j1][2];
    }
    delta=deltanew;
    if(i1%3==0){
      computeAE();
      deltanew=0;
      for(j1=0; j1<=Nmolecules-1; j1++){
	residuals[j1][0]=BT[j1][0]-AP[j1][0];
	residuals[j1][1]=BT[j1][1]-AP[j1][1];
	residuals[j1][2]=BT[j1][2]-AP[j1][2];
	deltanew += residuals[j1][0]*residuals[j1][0] + residuals[j1][1]*residuals[j1][1] + residuals[j1][2]*residuals[j1][2];
      } 
    }
    else{
      deltanew=0;
      for(j1=0; j1<=Nmolecules-1; j1++){
	residuals[j1][0]-=stepsize*y[j1][0];
	residuals[j1][1]-=stepsize*y[j1][1];
	residuals[j1][2]-=stepsize*y[j1][2];
	deltanew += residuals[j1][0]*residuals[j1][0] + residuals[j1][1]*residuals[j1][1] + residuals[j1][2]*residuals[j1][2];
      }
    }
    beta=deltanew/delta;
    for(j1=0; j1<=Nmolecules-1; j1++){
      directions[j1][0]=residuals[j1][0]+beta*directions[j1][0];
      directions[j1][1]=residuals[j1][1]+beta*directions[j1][1];
      directions[j1][2]=residuals[j1][2]+beta*directions[j1][2];
    }
    i1+=1;
    printf("dn %f\n", deltanew);
  }
  computeAE();
  statistics1();
}

void initialize(){
  for(i=0; i<=Nmolecules-1; i++){
    dipoles[i][0]=0.5;
    dipoles[i][1]=0.5;
    dipoles[i][2]=0.5;
  }

}


void computeAE(){
  double xr, yr, zr, r2=0;
  double kx, ky, kz = 0;
  double expk2=0;
  double kdotr, coskdotr, APscalar=0;
  double udotr1, udotr2=0;
  double Bofr, Cofr=0;
  double volume=0;
  double factor=0;
  double k2=0;
  double sqalpha, energytemp=0;
  long int c1=0;
  int r2int=0;
  sqalpha=sqrt(alpha);
  volume=boxx*boxy*boxz;

  for(i=0; i<=Nmolecules-1; i++){
    AP[i][0]=0;
    AP[i][1]=0;
    AP[i][2]=0;
    BT[i][0]=0;
    BT[i][1]=0;
    BT[i][2]=0;
  }
  
  /* for(i=16; i<=16+kcutoff; i++){
    for(j=15; j<=16+kcutoff; j++){
      for(k=15; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m++){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=sin(kdotr);
	    if(m!=l && m!=(l+1) && m!=(l+2)){
	      BT[l/3][0]+=kx*positions[m][3]*coskdotr*expk2;
	      BT[l/3][1]+=ky*positions[m][3]*coskdotr*expk2;
	      BT[l/3][2]+=kz*positions[m][3]*coskdotr*expk2;
	    }
	    if(m%3==0 && m!=l){
	      coskdotr=cos(kdotr);
	      APscalar = coskdotr*(dipoles[m/3][0]*kx+dipoles[m/3][1]*ky+dipoles[m/3][2]*kz);
	      AP[l/3][0]+=APscalar*kx*expk2;
	      AP[l/3][1]+=APscalar*ky*expk2;
	      AP[l/3][2]+=APscalar*kz*expk2;
	      //printf("%f %f\n", AP[l/3][0], BT[l/3][0]);
	    }
	  }
	}
      }
    }
  }
 
  for(i=14-kcutoff; i<=15; i++){
    for(j=15; j<=16+kcutoff; j++){
      for(k=16; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m++){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=sin(kdotr);
	    if(m!=l && m!=(l+1) && m!=(l+2)){
	      BT[l/3][0]+=2*kx*positions[m][3]*coskdotr*expk2/2;
	      BT[l/3][1]+=2*ky*positions[m][3]*coskdotr*expk2/2;
	      BT[l/3][2]+=2*kz*positions[m][3]*coskdotr*expk2/2; 
	    }
	    if(m%3==0 && m!=l){
	      coskdotr=cos(kdotr);
	      APscalar = coskdotr*(dipoles[m/3][0]*kx+dipoles[m/3][1]*ky+dipoles[m/3][2]*kz);
	      AP[l/3][0]+=APscalar*kx*expk2;
	      AP[l/3][1]+=APscalar*ky*expk2;
	      AP[l/3][2]+=APscalar*kz*expk2;
	    }
	  }
	}
      }
    }
  }
 
  for(i=14-kcutoff; i<=14; i++){
    for(j=14-kcutoff; j<=14; j++){
      for(k=16; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m++){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=sin(kdotr);
	    if(m!=l && m!=(l+1) && m!=(l+2)){
	      BT[l/3][0]+=2*kx*positions[m][3]*coskdotr*expk2/2;
	      BT[l/3][1]+=2*ky*positions[m][3]*coskdotr*expk2/2;
	      BT[l/3][2]+=2*kz*positions[m][3]*coskdotr*expk2/2; 
	    }
	    if(m%3==0 && m!=l){
	      coskdotr=cos(kdotr);
	      APscalar = coskdotr*(dipoles[m/3][0]*kx+dipoles[m/3][1]*ky+dipoles[m/3][2]*kz);
	      AP[l/3][0]+=APscalar*kx*expk2;
	      AP[l/3][1]+=APscalar*ky*expk2;
	      AP[l/3][2]+=APscalar*kz*expk2;
	    }
	  }
	}
      }
    }
  }
 
  for(i=15; i<=16+kcutoff; i++){
    for(j=14-kcutoff; j<=14; j++){
      for(k=15; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m++){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=sin(kdotr);
	    if(m!=l && m!=(l+1) && m!=(l+2)){
	      BT[l/3][0]+=2*kx*positions[m][3]*coskdotr*expk2/2;
	      BT[l/3][1]+=2*ky*positions[m][3]*coskdotr*expk2/2;
	      BT[l/3][2]+=2*kz*positions[m][3]*coskdotr*expk2/2;
	    }
	    if(m%3==0 && m!=l){
	      coskdotr=cos(kdotr);
	      APscalar = coskdotr*(dipoles[m/3][0]*kx+dipoles[m/3][1]*ky+dipoles[m/3][2]*kz);
	      AP[l/3][0]+=APscalar*kx*expk2;
	      AP[l/3][1]+=APscalar*ky*expk2;
	      AP[l/3][2]+=APscalar*kz*expk2;
	    }
	  }
	}
      }
    }
    }*/
 
  //expk2=pow(alpha, 1.5)*4/(3*sqrt(3.141953));
  for(i=0; i<=Nmolecules-1; i++){
    AP[i][0]+=dipoles[i][0]*(1/polarizability);
    AP[i][1]+=dipoles[i][1]*(1/polarizability);
    AP[i][2]+=dipoles[i][2]*(1/polarizability);    
  }

  for(i=0; i<=Nparticles-1; i=i+3){
    for(j=0; j<=Nparticles-1; j=j+3){
      if(j!=i){
	xr = positions[i][0]-positions[j][0];
	if(xr>boxx/2){
	  xr=xr-boxx;
	}
	if(xr < -boxx/2){
	  xr = boxx + xr;
	}
	yr = positions[i][1]-positions[j][1];
	if(yr>boxy/2){
	  yr=yr-boxy;
	}
	if(yr < -boxy/2){
	  yr = boxy + yr;
	}
	zr = positions[i][2]-positions[j][2];
	if(zr>boxz/2){
	  zr=zr-boxz;
	}
	if(zr < -boxz/2){
	  zr = boxz + zr;
	}   
	udotr1 = dipoles[i/3][0]*xr + dipoles[i/3][1]*yr + dipoles[i/3][2]*zr;
	udotr2 = dipoles[j/3][0]*xr + dipoles[j/3][1]*yr + dipoles[j/3][2]*zr;
	r2 = xr*xr + yr*yr + zr*zr;
	r2 = sqrt(r2);
	Bofr = ((erfc(sqalpha*r2))/(r2*r2*r2) + 2*sqrt(alpha/3.14159)*exp(-alpha*r2*r2)/(r2*r2));
	Cofr = udotr2*((3*erfc(sqalpha*r2))/(r2*r2*r2*r2*r2) + 2*sqrt(alpha/3.14159)*(2*alpha + 3/(r2*r2))*exp(-alpha*r2*r2)/(r2*r2));
	AP[i/3][0]+=dipoles[j/3][0]*Bofr-xr*Cofr;
	AP[i/3][1]+=dipoles[j/3][1]*Bofr-yr*Cofr;
	AP[i/3][2]+=dipoles[j/3][2]*Bofr-zr*Cofr;

      }	       
    }
  }

  for(i=0; i<=Nparticles-1; i=i+3){
    for(j=0; j<=Nparticles-1; j++){
      if(j!=i && j!=(i+1) && j!=(i+2)){
	xr = positions[i][0]-positions[j][0];
	if(xr>boxx/2){
	  xr=xr-boxx;
	}
	if(xr < -boxx/2){
	  xr = boxx + xr;
	}
	yr = positions[i][1]-positions[j][1];
	if(yr>boxy/2){
	  yr=yr-boxy;
	}
	if(yr < -boxy/2){
	  yr = boxy + yr;
	}
	zr = positions[i][2]-positions[j][2];
	if(zr>boxz/2){
	  zr=zr-boxz;
	}
	if(zr < -boxz/2){
	  zr = boxz + zr;
	}
	r2 = xr*xr + yr*yr + zr*zr;
	r2 = sqrt(r2);
	Bofr = -erfc(sqalpha*r2)/(r2*r2*r2) - 2.*sqalpha*exp(-alpha*r2*r2)/(r2*r2*sqrt(3.141593));
	BT[i/3][0]-=Bofr*positions[j][3]*xr;
	BT[i/3][1]-=Bofr*positions[j][3]*yr;
	BT[i/3][2]-=Bofr*positions[j][3]*zr;
	
      }
     
    }
   
  }
  iondipoleenergy=0;

  for(i=0; i<=Nmolecules-1; i++){
    individualenergies[i][2]=0;
    individualenergies[i][3]=0;
  }

  for(i=0; i<=Nparticles-1; i=i+3){
    xr = positions[i][0]-aionx;
    if(xr>boxx/2){
      xr=xr-boxx;
    }
    if(xr < -boxx/2){
      xr = boxx + xr;
    }
    yr = positions[i][1]-aiony;
    if(yr>boxy/2){
      yr=yr-boxy;
    }
    if(yr < -boxy/2){
      yr = boxy + yr;
    }
    zr = positions[i][2]-aionz;
    if(zr>boxz/2){
      zr=zr-boxz;
    }
    if(zr < -boxz/2){
      zr = boxz + zr;
    }
    r2 = xr*xr+yr*yr+zr*zr;
    r2 = sqrt(r2);
    r2=r2*r2*r2;
    BT[i/3][0] -= xr*qion/r2;
    BT[i/3][1] -= yr*qion/r2;
    BT[i/3][2] -= zr*qion/r2;
    factor = dipoles[i/3][0]*xr*qion/r2 + dipoles[i/3][1]*yr/r2 + dipoles[i/3][2]*zr/r2;
    iondipoleenergy += factor;
    individualenergies[i/3][2] = factor;
    xr = positions[i][0]-cionx;
    if(xr>boxx/2){
      xr=xr-boxx;
    }
    if(xr < -boxx/2){
      xr = boxx + xr;
    }
    yr = positions[i][1]-ciony;
    if(yr>boxy/2){
      yr=yr-boxy;
    }
    if(yr < -boxy/2){
      yr = boxy + yr;
    }
    zr = positions[i][2]-cionz;
    if(zr>boxz/2){
      zr=zr-boxz;
    }
    if(zr < -boxz/2){
      zr = boxz + zr;
    }
    r2 = xr*xr+yr*yr+zr*zr;
    r2 = sqrt(r2);
    r2 = r2*r2*r2;
    BT[i/3][0] += xr*qion/r2;
    BT[i/3][1] += yr*qion/r2;
    BT[i/3][2] += zr*qion/r2;
    factor = dipoles[i/3][0]*xr*qion/r2 + dipoles[i/3][1]*yr/r2 + dipoles[i/3][2]*zr/r2;
    iondipoleenergy -= factor;
    individualenergies[i/3][3] = -factor;
  }

}


void computeAD(){
  double xr, yr, zr, r2=0;
  double kx, ky, kz = 0;
  double expk2=0;
  double kdotr, coskdotr, APscalar=0;
  double Bofr, Cofr=0;
  double udotr1,udotr2=0;
  double volume=0;
  double k2=0;
  double sqalpha=0;
  long int c1=0;
  int r2int=0;
  sqalpha = sqrt(alpha);
  volume=boxx*boxy*boxz;
  for(i=0; i<=Nmolecules-1; i++){
    AD[i][0]=0;
    AD[i][1]=0;
    AD[i][2]=0;
  }

  /*
  for(i=16; i<=16+kcutoff; i++){
    for(j=15; j<=16+kcutoff; j++){
      for(k=15; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m=m+3){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=cos(kdotr);
	    APscalar = coskdotr*(directions[m/3][0]*kx+directions[m/3][1]*ky+directions[m/3][2]*kz);
	    AD[l/3][0]+=APscalar*kx*expk2;
	    AD[l/3][1]+=APscalar*ky*expk2;
	    AD[l/3][2]+=APscalar*kz*expk2;
	  }
	}
      }
    }
  }

  for(i=14-kcutoff; i<=15; i++){
    for(j=15; j<=16+kcutoff; j++){
      for(k=16; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m=m+3){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=cos(kdotr);
	    APscalar = coskdotr*(directions[m/3][0]*kx+directions[m/3][1]*ky+directions[m/3][2]*kz);
	    AD[l/3][0]+=APscalar*kx*expk2;
	    AD[l/3][1]+=APscalar*ky*expk2;
	    AD[l/3][2]+=APscalar*kz*expk2;
	  }
	}
      }
    }
  }

  for(i=14-kcutoff; i<=14; i++){
    for(j=14-kcutoff; j<=14; j++){
      for(k=16; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m=m+3){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=cos(kdotr);
	    APscalar = coskdotr*(directions[m/3][0]*kx+directions[m/3][1]*ky+directions[m/3][2]*kz);
	    AD[l/3][0]+=APscalar*kx*expk2;
	    AD[l/3][1]+=APscalar*ky*expk2;
	    AD[l/3][2]+=APscalar*kz*expk2;
	  }
	}
      }
    }
  }

  for(i=15; i<=16+kcutoff; i++){
    for(j=14-kcutoff; j<=14; j++){
      for(k=15; k<=16+kzcutoff; k++){
	kx = 2*3.141593*(double)(i-15)/boxx;
	ky = 2*3.141593*(double)(j-15)/boxy;
	kz = 2*3.141593*(double)(k-15)/boxz;
	k2 = kx*kx + ky*ky + kz*kz;
	expk2 = 8*3.141593*exp(-k2/(4*alpha))/(k2*volume);
	for(l=0; l<=Nparticles-1; l=l+3){
	  for(m=0; m<=Nparticles-1; m=m+3){
	    kdotr = kx*(positions[l][0]-positions[m][0])+ky*(positions[l][1]-positions[m][1])+kz*(positions[l][2]-positions[m][2]);
	    coskdotr=cos(kdotr);
	    APscalar = coskdotr*(directions[m/3][0]*kx+directions[m/3][1]*ky+directions[m/3][2]*kz);
	    AD[l/3][0]+=APscalar*kx*expk2;
	    AD[l/3][1]+=APscalar*ky*expk2;
	    AD[l/3][2]+=APscalar*kz*expk2;
	  }
	}
      }
    }
    }*/
  expk2=pow(alpha, 1.5)*4/(3*sqrt(3.141953));
  expk2=0;
  for(i=0; i<=Nmolecules-1; i++){
    AD[i][0]+=directions[i][0]*(1/polarizability-expk2);
    AD[i][1]+=directions[i][1]*(1/polarizability-expk2);
    AD[i][2]+=directions[i][2]*(1/polarizability-expk2);
  }
 
  for(i=0; i<=Nparticles-1; i=i+3){
    for(j=0; j<=Nparticles-1; j=j+3){
      if(j!=i){
	xr = positions[i][0]-positions[j][0];
	if(xr>boxx/2){
	  xr=xr-boxx;
	}
	if(xr < -boxx/2){
	  xr = boxx + xr;
	}
	yr = positions[i][1]-positions[j][1];
	if(yr>boxy/2){
	  yr=yr-boxy;
	}
	if(yr < -boxy/2){
	  yr = boxy + yr;
	}
	zr = positions[i][2]-positions[j][2];
	if(zr>boxz/2){
	  zr=zr-boxz;
	}
	if(zr < -boxz/2){
	  zr = boxz + zr;
	}   
	udotr2 = directions[j/3][0]*xr + directions[j/3][1]*yr + directions[j/3][2]*zr;
	r2 = xr*xr + yr*yr + zr*zr;
	r2 = sqrt(r2);
	Bofr = ((erfc(sqalpha*r2))/(r2*r2*r2) + 2*sqrt(alpha/3.14159)*exp(-alpha*r2*r2)/(r2*r2));
	Cofr = udotr2*((3*erfc(sqalpha*r2))/(r2*r2*r2*r2*r2) + 2*sqrt(alpha/3.14159)*(2*alpha + 3/(r2*r2))*exp(-alpha*r2*r2)/(r2*r2));
	AD[i/3][0]+=directions[j/3][0]*Bofr-xr*Cofr;
	AD[i/3][1]+=directions[j/3][1]*Bofr-yr*Cofr;
	AD[i/3][2]+=directions[j/3][2]*Bofr-zr*Cofr;
      }	       
    }
  }
  
}


void statistics2(){
  float avenww=0;
  float aveniw=0;
  float avljww=0;
  float avljiw=0;
  float avdensity=0;
  float volume=0;
  FILE *outputptr;
  outputptr = fopen(outputfile, "w");
  for(i=0; i<=130; i++){
    for(j=0; j<=50; j++){
      avdensity=0;
      if(totenergies[i][j][0] != 0){
	volume = .2*3.14159*((.2*(j+1))*(.2*(j+1))-.2*.2*j*j);
	avenww = totenergies[i][j][1]/totenergies[i][j][0];
	aveniw = totenergies[i][j][2]/totenergies[i][j][0];
	avljww = totenergies[i][j][3]/totenergies[i][j][0];
	avljiw = totenergies[i][j][4]/totenergies[i][j][0];
	avdensity = totenergies[i][j][0]/(volume*timesteps*.0315);
      }
      fprintf(outputptr, "%f %f %f %f %f %f %f\n", j*.2, .2*i-9, 1389.354*avenww, 1389.354*aveniw, 1389.354*avljww, 1389.354*avljiw, avdensity);
    }
  }

  fclose(outputptr);
}






void tabulateerrfc(){
  double sqalpha=0;
  sqalpha = sqrt(alpha);

  for(i=0; i<=2999; i++){
    errorfc[i][0] = i*.0125;
    errorfc[i][1] = erfc(errorfc[i][0]*sqalpha)/(errorfc[i][0]);
  }
  for(i=0; i<=2999; i++){
    errorfc[i][2] = (errorfc[i+1][1]-errorfc[i][1])/(errorfc[i+1][0]-errorfc[i][0]);
  }

}
