#include "i2cmaster.h"  

int32_t as_poll_encoder() {
  uint32_t heading_raw;
  int32_t heading;

  if(i2c_start(0x50+I2C_READ)) {
    return(0xffff);
  } else {          
    heading_raw = (uint32_t)i2c_readAck()<<24;    
    heading_raw |= (uint32_t)i2c_readAck()<<16;   
    heading_raw |= (uint32_t)i2c_readAck()<<8;    
    heading_raw |= (uint32_t)i2c_readNak();       
    heading = ((heading_raw>>6) & 3);             
    heading |= (heading_raw >> 20)&(~3);
  }
  i2c_stop();   
  return(heading);
}

// Select the encoder you wish to read next. Wait at least 310us until you actually poll it.
void as_prepare_encoder(int number) {
  PORTC = (PORTC & ~0x03) | ~((1<<number)&0x03);
}


void as_init() {
  // Config encoder selector pins as outputs
  DDRC |= 0x07;  
}