#ifndef t_paths_h
#define t_paths_h
/*
 * Sylvain BERTRAND <digital.ragnarok@gmail.com>
 * code protected by GNU GPL v3
 */
G_BEGIN_DECLS
struct t_paths {
	gint ref;
	gchar *config_home;
	gchar *data_home;
	gchar *cache_home;
	GSList *config_dirs;
	GSList *data_dirs;
	GSList *autostart_dirs;
	GSList *exec_dirs;
	uid_t uid;
	gid_t *gid;
	guint n_gid;
};
struct t_paths *t_paths_new(void);
void t_paths_unref(struct t_paths *p);
const gchar *t_paths_cache_home(struct t_paths *p);
GSList *t_paths_config_dirs(struct t_paths *p);
GSList *t_paths_data_dirs(struct t_paths *p);
gchar *t_paths_expand_tilde(const gchar *f);
gboolean t_paths_mkdir(const gchar *path, gint mode);
gboolean t_paths_mkdir_path(const gchar *path, gint mode);
G_END_DECLS
#endif
