/*
 * Sylvain BERTRAND <digital.ragnarok@gmail.com>
 * code protected by GNU GPL v3
 */
#include <X11/Xlib.h>
#include <glib.h>
#include <libxml/xinclude.h>
#include "../../toolkit/keyboard.h"
#include "../../toolkit/xml.h"
#include "../../toolkit/paths.h"
#include "../misc.h"
#include "../geom.h"
#include "../frame.h"
#include "../actions.h"
#include "../wm.h"
struct options {
	gchar *cmd;
};

static gpointer setup_func(xmlNodePtr node)
{
	xmlNodePtr n;
	struct options *o;
	o = g_slice_new0(struct options);
	if((n = t_xml_find_node(node, "command")) || (n = t_xml_find_node(node, "execute"))) {
		gchar *s = t_xml_node_string(n);
		o->cmd = t_paths_expand_tilde(s);
		g_free(s);
	}
	return o;
}

static void free_func(gpointer options)
{
	struct options *o = options;
	g_free(o->cmd);
	g_slice_free(struct options, o);
}

static gboolean run_func(struct wm_actions_data *data, gpointer options)
{
	struct options *o = options;
	(void)data;
	wm_restart_other(o->cmd);
	return FALSE;
}

void action_restart_startup(void)
{
	actions_register("Restart", setup_func, free_func, run_func);
}
