#include "glue.h"

#include "markdown.h"
#include "html.h"
#include "buffer.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define READ_UNIT 1024
#define OUTPUT_UNIT 64

uw_Basis_xhtml uw_Sundown_render(uw_context ctx, uw_Basis_string input) {
  struct buf *ib;
  struct buf *ob;

  struct sd_callbacks callbacks;
  struct html_renderopt options;
  struct sd_markdown *markdown;

  /* Read */
  size_t ilen = strlen(input);
  ib = bufnew(READ_UNIT);
  bufgrow(ib, ilen);
  ib->size = ilen;
  memcpy(ib->data, input, ilen);

  /* Convert to markdown */
  ob = bufnew(OUTPUT_UNIT);

  sdhtml_renderer(&callbacks, &options, 0);
  markdown = sd_markdown_new(0, 16, &callbacks, &options);

  sd_markdown_render(ob, ib->data, ib->size, markdown);
  sd_markdown_free(markdown);

  /* Allocate copy and give it back to the page */
  uw_Basis_xhtml ret = uw_malloc(ctx, ob->size);
  memcpy(ret, ob->data, ob->size);

  bufrelease(ib);
  bufrelease(ob);

  return ret;
}
