// Tomer Elmalem

#ifndef INVADERS_H
#define INVADERS_H

#define INVADER_MOVES 8
#define INVADERS_AMT 10
#define INVADERS_BLT 5
#define TANK_BLT 5

/* Struct for invaders */
typedef struct invader {
  int r;
  int c;
  int width;
  int height;
  int alive;
  int type;
} Invader;

/* Struct for tank */
typedef struct tank {
  int r;
  int position;
  int lives;
} Tank;

/* Struct for player bullets */
typedef struct bullet {
  int r;
  int c;
  int fired;
} Bullet;

/* Create everything that's going to be used */
Invader invaders[INVADERS_AMT];
Bullet invader_bullets[INVADERS_BLT];
Tank tank;
Bullet tank_bullets[TANK_BLT];
int invaders_left;

/* Function prototypes */
void init_invaders();
void init_tank();
void init_invader_bullets();
void init_tank_bullets();
void fire_tank_bullet();
void fire_invader_bullet();
void move_invaders(int step);
void check_invader_collision(Bullet *bullet, Invader *invader); 
void check_tank_collision(Bullet *bullet, Tank *tank);
#endif
