// Tomer Elmalem

#ifndef MC_LIB_H
#define MC_LIB_H

#define CITY_AMT 6
#define ENEMY_AMT 3
#define PLAYER_AMT 3

typedef struct city {
  int alive;
  int r;
  int c;
  int w; //width
  int h; //height
} City;

typedef struct missile {
  int start_c;
  int start_r;
  int cur_r;
  int cur_c;
  int end_r;
  int end_c;
  int fired;
  int draw;
  int itr;
} Missile;

typedef struct explosion {
  int r;
  int c;
  int width;
  int height;
  int time;
} Explosion;

typedef struct cursor {
  int r;
  int c;
  int ready;
} Cursor;

//void draw_line(int x0, int y0, int x1, int y1, int itr);
void draw_line(Missile *m);
void init_cities(City *city);
void init_enemy_missiles(Missile *missile, int level);
void init_player_missiles(Missile *missile);
void init_cursor(Cursor *cursor);
int fire_enemy_missile(Missile *missile, int level);
void fire_player_missile(Missile *missile, Cursor *cursor);
int clear_missile(Missile *missile);
void explode(Missile *m, Explosion *e);
int collision_expl(Missile *m, Explosion *e);
int collision_city(Missile *m, City *c);
#endif
