/*
 *  DeleteBlueDot.cpp
 *      Blue Dot 폜
 *          written by H.Tsujimura  6 Oct 2006
 *
 * $Log: /comm/bookey/DeleteBlueDot.cpp $
 * 
 * 1     09/05/14 3:48 tsupo
 * (1) rh̃fBNg\𐮗
 * (2) VSST[o_ύX
 * 
 * 8     08/07/25 1:30 Tsujimura543
 * ubN}[N폜AOɖ폜̃ubN}[NcĂȂƂ
 * łAu1Oɖ߂v{^LȂ܂܂ɂȂĂ܂sC
 * 
 * 7     07/03/14 17:08 Tsujimura543
 * StdAfx.h CN[hȂĂ悤ɂ
 * 
 * 6     07/01/15 22:41 Tsujimura543
 * pꃂ[hΉ
 * 
 * 5     07/01/12 23:35 Tsujimura543
 * pꃂ[hΉ
 * 
 * 4     07/01/04 18:54 Tsujimura543
 * ShowWindow() ̈C
 * 
 * 3     06/10/26 23:53 Tsujimura543
 * RgC
 * 
 * 2     06/10/26 23:51 Tsujimura543
 * u1Oɖ߂vŖ߂肷Ă܂Ƃ(͂̃ubN}[N
 * \)sɑΏ
 * 
 * 1     06/10/07 1:08 Tsujimura543
 * VK쐬
 */

#include "bookey.h"
#include "bookeyDlg.h"
#include "DeleteBookmarkDialog4.h"
#include "ProceedingDialog.h"
#include "deleteBookmark.h"

#ifdef __cplusplus
extern "C" {
#endif
#include "myClip.h"
#include "delicious.h"
#include "blueDot.h"
#ifdef __cplusplus
}
#endif

#ifndef	lint
static char	*rcs_id =
"$Header: /comm/bookey/DeleteBlueDot.cpp 1     09/05/14 3:48 tsupo $";
#endif

void
DeleteBlueDotBookmark(
        const char       *username,
        const char       *password,
        bool             withQuery /* = true */,
        ProceedingDialog *dlg      /* = NULL */
    )
{
    CString title;
    CString text;

    if ( withQuery == false ) {
        title.LoadString(IDS_TTL_DELETE_ALL_BOOKMARKS);
        text.LoadString( IDS_TXT_DELETE_ALL_BOOKMARKS);
        int r = MessageBox( NULL,
                            text,   // {ɃubN}[NS폜Ă܂Ă\Ȃł?
                            title,  // ubN}[N폜mF
                            MB_YESNO|MB_ICONQUESTION );
        if ( r == IDNO )
            return;
    }

    CWaitCursor         cur;    // }EXJ[\v\
    BOOL                ret;
    ProceedingDialog    *pdlg;
    CBookeyApp          *pp = (CBookeyApp *)AfxGetApp();
    CString             bookmarkName;

    if ( dlg )
        pdlg = dlg;
    else {
        pdlg = new ProceedingDialog();
        pdlg->Create( IDD_PROCEEDING_DIALOG );
    }
    bookmarkName.LoadString( IDS_TGT_BLUEDOT );

    if ( (pp->m_bookmarkGotten == false)                   ||
         !(pp->m_myClip)                                   ||
         (pp->m_bookmarkName.Compare( bookmarkName ) != 0)    ) {
        // ubN}[N܂擾ĂȂꍇ
        if ( pp->m_myClip ) {
            pp->m_bookmarkGotten = false;
            pp->m_bookmarkName   = "";
            free( pp->m_myClip );
            pp->m_myClip = NULL;
        }

        /// ubN}[N擾
        pp->m_myClip = pp->m_blueDot.GetBookmarks( pp->m_numOfClips,
                                                   username, password );
        if ( !(pp->m_myClip) ) {
            pdlg->ShowWindow( SW_HIDE );
            title.LoadString(IDS_TTL_FAILURE_GET_BOOKMARKS);
            text.LoadString( IDS_TXT_FAILURE_GET_BOOKMARKS);
            MessageBox( NULL,
                        text,   // ubN}[N擾ł܂ł
                        title,  // ubN}[N擾s
                        MB_OK|MB_ICONWARNING );
            if ( !dlg )
                delete pdlg;
            return;
        }

        pp->m_bookmarkGotten = true;
        pp->m_bookmarkName   = bookmarkName;
    }

    // ubN}[N1Â폜
    BOOL    *deleted = new BOOL[pp->m_numOfClips];
    int     i;
    for ( i = 0; i < pp->m_numOfClips; i++ )
        deleted[i] = FALSE;
    for ( i = 0; i < pp->m_numOfClips; i++ ) {
        if ( deleted[i] == TRUE )
            continue;
        if ( withQuery ) {
            pdlg->ShowWindow( SW_HIDE );

            // ubN}[N\
            DeleteBookmarkDialog4   d;

            d.m_url     = pp->m_myClip[i].url;
            d.m_title   = pp->m_myClip[i].title;
            d.m_comment = pp->m_myClip[i].comment;
            d.m_tags    = pp->m_myClip[i].tags;
            d.m_enableToBackward = (i == 0) ? false : true;
            d.m_backToPrevious   = false;

            if ( i > 0 ) {
                int j = i - 1;
                while ( (j >= 0) && deleted[j] )
                    j--;
                if ( j < 0 )
                    d.m_enableToBackward = false;
            }

            int r = d.DoModal();
            if ( r == IDCANCEL )
                break;
            if ( d.m_backToPrevious ) {
                int j = i;
                while ( (--i > 0) && deleted[i] )
                    ;
                if ( deleted[i] == FALSE ) {
                    i--;
                    continue;
                }
                i = j;
            }
            if ( d.m_executeWithoutQuery == true ) {
                title.LoadString(IDS_TTL_DELETE_ALL);
                text.LoadString( IDS_TXT_DELETE_ALL);
                r = MessageBox( NULL,
                                text,   // c̃ubN}[NSCɍ폜Ă܂Ă\Ȃł?
                                title,  // ubN}[Nꊇ폜mF
                                MB_YESNO|MB_ICONQUESTION );
                if ( r == IDYES )
                    withQuery = false;
            }
            if ( d.m_execute == false )
                continue;

            pdlg->ShowWindow( SW_SHOWNORMAL );
        }

        text.LoadString(IDS_TXT_CONTINUE_DELETING);
        pdlg->ChangeDialogText( bookmarkName,
                                text ); // ubN}[N폜 cc
        ret = deleteEntryOnBlueDot( username, password, pp->m_myClip[i].url );
        if ( ret == FALSE ) {
            int r;
            CString title;
            CString text;

            title.LoadString(IDS_TTL_FAILURE_DELETE_BOOKMARKS);
            text.LoadString( IDS_TXT_FAILURE_DELETE_BOOKMARKS);
            r = MessageBox( NULL,
                            text,   // ubN}[N̍폜Ɏs܂    \r\n𑱍s܂?
                            title,  // ubN}[N폜s
                            MB_YESNO|MB_ICONWARNING );
            if ( r == IDYES )
                continue;
            break;
        }
        deleted[i] = TRUE;
    }

    // ubN}[Nj
    delete [] deleted;
    pp->m_bookmarkGotten = false;
    pp->m_bookmarkName   = "";
    free( pp->m_myClip );
    pp->m_myClip = NULL;

    if ( !dlg )
        delete pdlg;
}
