/*
 *  bludot.h
 *
 * History:
 * $Log: /comm/xmlRPC/bluedot.h $
 * 
 * 1     09/05/14 3:46 tsupo
 * (1) rh̃fBNg\𐮗
 * (2) VSST[o_ύX
 * 
 * 2     07/01/29 20:11 Tsujimura543
 * getNumberOfTagsOnBlueDot() ǉ
 * 
 * 1     06/10/06 21:56 Tsujimura543
 * VK쐬 (del.icio.us ݊ API)
 */

#ifndef __BLUE_DOT_H__
#define __BLUE_DOT_H__

/*
 *  Blue Dot: del.icio.us API
 */

/* tʓëꗗ̎擾 */
long
getListOfDatesOnBlueDot(
        const char      *userName,      /* (I) [U       */
        const char      *password,      /* (I) pX[h     */
        char            *tag,           /* (I) ^O           */
        long            *numOfDates,    /* (I) 擾 */
                                        /* (O) 擾 */
        DELICIOUS_DATES *dates          /* (O) 擾   */
    );

/* gĂ^Öꗗ̎擾 */
long
getListOfTagsOnBlueDot(
        const char     *userName,   /* (I) [U       */
        const char     *password,   /* (I) pX[h     */
        long           *numOfTags,  /* (I) 擾 */
                                    /* (O) 擾 */
        DELICIOUS_TAGS *tags        /* (O) 擾   */
    );

/* w肵tɓeGg̈ꗗ̎擾 */
long
getListOfPostsOnBlueDot(
        const char      *userName,  /* (I) [U                   */
        const char      *password,  /* (I) pX[h                 */
        const char      *tag,       /* (I)  (^O)            */
        const char      *dateTime,  /* (I)  (e)        */
                                    /*       yyyy-mm-ddThh:mm:ssZ` */
        const char      *targetUrl, /* (I)  (URL)             */
        long            *numOfPosts,/* (I) 擾             */
                                    /* (O) 擾             */
        DELICIOUS_POSTS *posts      /* (O) 擾               */
    );

/* ŋ߂̃Ggꗗ̎擾 */
long
getRecentPostsOnBlueDot(
        const char      *userName,  /* (I) [U        */
        const char      *password,  /* (I) pX[h      */
        const char      *tag,       /* (I)  (^O) */
        long            *numOfPosts,/* (I) 擾  */
                                    /* (O) 擾  */
        DELICIOUS_POSTS *posts      /* (O) 擾    */
    );

/* SGg̎擾 */
long
getAllPostsOnBlueDot(
        const char      *userName,  /* (I) [U        */
        const char      *password,  /* (I) pX[h      */
        const char      *tag,       /* (I)  (^O) */
        long            *numOfPosts,/* (I) 擾  */
                                    /* (O) 擾  */
        DELICIOUS_POSTS *posts      /* (O) 擾    */
    );

/* ŏIXV̎擾 */
long
getLastUpdateOnBlueDot(
        const char *userName,   /* (I) [U     */
        const char *password,   /* (I) pX[h   */
        char       *dateTime    /* (O) 擾 */
    );

/* Gg̓e(ubN}[N̒ǉo^) */
BOOL
postEntryOnBlueDot(
    const char      *userName,      /* (I) [U               */
    const char      *password,      /* (I) pX[h             */
    DELICIOUS_ENTRY *entry     );   /* (I) o^(ee) */


/* Gg̍폜 */
BOOL
deleteEntryOnBlueDot(
        const char *userName,   /* (I) [U                    */
        const char *password,   /* (I) pX[h                  */
        const char *url         /* (I) 폜Gg URL vf */
    );

/* ^O̕ύX */
BOOL
renameTagOnBlueDot(
        const char *userName,   /* (I) [U   */
        const char *password,   /* (I) pX[h */
        const char *oldTag,     /* (I) Â^O   */
        const char *newTag      /* (I) V^O */
    );

/*
 *  ǉ@\
 */

/* ubN}[N̎擾 */
long
getNumberOfBookmarksOnBlueDot(
        const char *userName,   /* (I) [U   */
        const char *password    /* (I) pX[h */
    );

/* ^O̎擾 */
long
getNumberOfTagsOnBlueDot(
        const char *userName,   /* (I) [U   */
        const char *password    /* (I) pX[h */
    );

/* Blue Dot  login */
int
loginBlueDot(
        const char *userName,   /* (I)   [U   */
        const char *password,   /* (I)   pX[h */
        char       *cookie      /* (I/O) NbL[   */
    );

#endif  /* __BLUE_DOT_H__ */
