/*
 *  deliciousApi.h
 *      del.icio.us API  del.icio.us ݊ API (Blue Dot API) ʏ
 *          written by H.Tsujimura  2 May 2005 / 6 Oct 2006
 *
 * History:
 * $Log: /comm/xmlRPC/deliciousApi.h $
 * 
 * 1     09/05/14 3:46 tsupo
 * (1) rh̃fBNg\𐮗
 * (2) VSST[o_ύX
 * 
 * 4     07/04/16 15:38 Tsujimura543
 * getAllPostsFromDeliciousXML ǉ
 * 
 * 3     07/01/24 15:44 Tsujimura543
 * removeTagOnDeliciousAPI() ǉ
 * 
 * 2     06/10/06 21:45 Tsujimura543
 * RgC
 * 
 * 1     06/10/06 21:07 Tsujimura543
 * delicious.c  del.icio.us(݊)API ubN}[NT[rXʏ
 * 𔲂oĕʃt@CƂēƗ
 */

#ifndef __DELICIOUS_API_H__
#define __DELICIOUS_API_H__

#include "xmlRPC.h"
#include "delicious.h"
#include <time.h>

/*
 *  del.icio.us (݊) API ʏ
 */

#ifndef	iskanji1
#define	iskanji1(s) \
    (((((short)s & 0xFF)>=0x81) && (((short)s & 0xFF)<=0x9f)) || \
     ((((short)s & 0xFF)>=0xe0) && (((short)s & 0xFF)<=0xfc)))
#endif

#define MAX_EXTENDED_LENGTH 170


typedef enum deliciousApiType   {
    DAPI_DELICIOUS,     /* del.icio.us */
    DAPI_BLUEDOT,       /* Blue Dot    */
}   DELICIOUS_API_TYPE;


/* 擾Gg̉͏                               */
/*      -- Gg擾֐QĂяo鋤ʊ֐ */
long
getPostsOnDelicious(
        const char      *url,
        const char      *userName,
        const char      *password,
        long            *numOfPosts,
        DELICIOUS_POSTS *posts 
    );

/*  tʓeꗗ̎擾 */
long
getListOfDatesOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌     */
        const char         *userName,   /* (I) [U       */
        const char         *password,   /* (I) pX[h     */
        char               *tag,        /* (I) ^O           */
        long               *numOfDates, /* (I) 擾 */
                                        /* (O) 擾 */
        DELICIOUS_DATES    *dates       /* (O) 擾   */
    );

/*  ^Oꗗ̎擾 */
long
getListOfTagsOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌     */
        const char         *userName,   /* (I) [U       */
        const char         *password,   /* (I) pX[h     */
        long               *numOfTags,  /* (I) 擾 */
                                        /* (O) 擾 */
        DELICIOUS_TAGS     *tags        /* (O) 擾   */
    );

/* w肵tɓeGg̈ꗗ̎擾 */
long
getListOfPostsOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,    /* (I) API 񋟌                 */
        const char         *userName,  /* (I) [U                   */
        const char         *password,  /* (I) pX[h                 */
        const char         *tag,       /* (I)  (^O)            */
        const char         *dateTime,  /* (I)  (e)        */
                                       /*       yyyy-mm-ddThh:mm:ssZ` */
        const char         *targetUrl, /* (I)  (URL)             */
        long               *numOfPosts,/* (I) 擾             */
                                       /* (O) 擾             */
        DELICIOUS_POSTS    *posts      /* (O) 擾               */
    );

/* ŋ߂̃Ggꗗ̎擾 */
long
getRecentPostsOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌      */
        const char         *userName,   /* (I) [U        */
        const char         *password,   /* (I) pX[h      */
        const char         *tag,        /* (I)  (^O) */
        long               *numOfPosts, /* (I) 擾  */
                                        /* (O) 擾  */
        DELICIOUS_POSTS    *posts       /* (O) 擾    */
    );

/* ŏIXV̎擾 */
long
getLastUpdateOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌   */
        const char         *userName,   /* (I) [U     */
        const char         *password,   /* (I) pX[h   */
        char               *dateTime    /* (O) 擾 */
    );

/* SGg̎擾 */
long
getAllPostsOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌      */
        const char         *userName,   /* (I) [U        */
        const char         *password,   /* (I) pX[h      */
        const char         *tag,        /* (I)  (^O) */
        long               *numOfPosts, /* (I) 擾  */
                                        /* (O) 擾  */
        DELICIOUS_POSTS    *posts       /* (O) 擾    */
    );

long
getAllPostsFromDeliciousXML(
        const char      *buf,           /* (I) 擾  */
        long            *numOfPosts,    /* (I) 擾  */
                                        /* (O) 擾  */
        DELICIOUS_POSTS *posts          /* (O) 擾    */
    );

/* ubN}[N̓e */
BOOL
postEntryOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌             */
        const char         *userName,   /* (I) [U               */
        const char         *password,   /* (I) pX[h             */
        DELICIOUS_ENTRY    *entry       /* (I) o^(ee) */
    );

/* ubN}[N̍폜 */
BOOL
deleteEntryOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌                  */
        const char         *userName,   /* (I) [U                    */
        const char         *password,   /* (I) pX[h                  */
        const char         *url         /* (I) 폜Gg URL vf */
    );

/* ^O̕ύX(u) */
BOOL
renameTagOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌 */
        const char         *userName,   /* (I) [U   */
        const char         *password,   /* (I) pX[h */
        const char         *oldTag,     /* (I) Â^O   */
        const char         *newTag      /* (I) V^O */
    );

/* ^O̍폜 */
BOOL
removeTagOnDeliciousAPI(
        DELICIOUS_API_TYPE apiType,     /* (I) API 񋟌     */
        const char         *userName,   /* (I) [U       */
        const char         *password,   /* (I) pX[h     */
        const char         *tag         /* (I) 폜Ώۂ̃^O */
    );

#endif  /* __DELICIOUS_API_H__ */
