//  $Header: /comm/xmlRPC/rakuten.h 1     09/05/14 3:46 tsupo $
/*! @file
 *  @brief for Rakuten Web Services
 *  @author tsujimura543
 *  @date $Date: 09/05/14 3:46 $
 *  @version $Revision: 1 $
 *  @note
 * History:
 * $Log: /comm/xmlRPC/rakuten.h $
 * 
 * 1     09/05/14 3:46 tsupo
 * (1) rh̃fBNg\𐮗
 * (2) VSST[o_ύX
 * 
 * 9     07/02/21 19:45 Tsujimura543
 * catalogSearchOnRakutenWebAPI ṕu\[gv̒`ǉ
 * 
 * 8     07/02/21 19:05 Tsujimura543
 * RAKUTEN_CATALOG \̂ catalogName  catalogCaption 
 * 
 * 7     07/02/21 19:03 Tsujimura543
 * RAKUTEN_ITEM \̂ itemName  itemCaption ̊i[̈eX
 * 
 * 6     07/02/20 22:32 Tsujimura543
 * catalogSearchOnRakutenWebAPI() ̈1(carrier)폜
 * 
 * 5     07/02/20 21:20 Tsujimura543
 * yVEFuT[rX̂AItemSearch  GenreSearch 
 * (͖mF)
 * 
 * 4     07/02/19 20:56 Tsujimura543
 * 2006N12JńuyVEFuT[rXvAPI\̂̒`(b)ǉ
 * 
 * 3     05/09/02 21:11 Tsujimura543
 * Rgǉ
 * 
 * 2     05/09/02 14:17 Tsujimura543
 * doxygen ɃRg
 * 
 * 1     05/05/18 21:44 Tsujimura543
 * ʊi[p\̂̒`p
 */

#ifndef __RAKUTEN_H__
#define __RAKUTEN_H__
#include "amazon.h"

/*
 * yVubNX salesranking
 *
 *  http://xml.affiliate.rakuten.co.jp/?type=&service=books&hash=AtBGCgID&genre=WR[h&num=
 *
 *   ex)
 *    http://xml.affiliate.rakuten.co.jp/?type=html&service=books&hash=0008a695.5601c7dd&genre=0&num=10
 *    http://xml.affiliate.rakuten.co.jp/?type=xml&service=books&hash=0008a695.5601c7dd&genre=0&num=10
 *
 *      
 *          html: HTML ŉ
 *          xml: XML ŉ
 *      WR[h
 *          0: 
 *          1: R~bNEWuiC
 *          2: wEAEEi
 *          3: G{E
 *          4: |EmtBNV
 *          5: obEVXeJ
 *          6: rWlXEoρEoc
 *          7: sEIsEAEghA
 *          8: w₪킩{
 *          9: zr[EX|[c
 *         10: CtX^C
 *         11: G^[eCg
 *         12: 发Ewp
 *         13: ʐ^WE^g
 *      
 *          1 ` 10 (10 傫Ȓlw肷 10 w肵̂Ƃ݂Ȃ)
 *
 *      :
 *          R[h html ̏ꍇAEUC-JP; xml ̏ꍇAUTF-8
 *
 *       (xml)
 *          <?xml version="1.0" encoding="UTF-8" standalone="yes" ?> 
 *          <RWS version="1.0.0" type="SalesRanking" service="yVubNX" date="2004/05/10">
 *          <item>
 *              <Isbn>4915512517</Isbn> 
 *              <SalesRank>1</SalesRank> 
 *              <Url>http://pt.afl.rakuten.co.jp/c/0008a695.5601c7dd/?url=http%3A%2F%2Fbooks.rakuten.co.jp%2FRBOOKS%2F0001654002%2F</Url> 
 *              <ProductName>y\z n[E|b^[ƕs̋Rmc</ProductName> 
 *              <Manufacturer>ÎR</Manufacturer> 
 *              <ImageUrlSmall>http://image.books.rakuten.co.jp/books/com/images/goods/91551251.jpg</ImageUrlSmall> 
 *              <ListPrice>4200</ListPrice> 
 *              <Authors>
 *                  <Author id="1" name="iDjD[O" /> 
 *              </Authors>
 *          </item>
 *          </RWS>
 */


/**
 *  \defgroup rakutenSearch uyVubNXvʊi[p\
 */
/** \defgroup rakutenTypeHtml ʊi[p\(RAKUTEN_TYPE_HTML p)
 *  \ingroup rakutenSearch
 */
/*@{*/
//! ʊi[p\(yʔ)
typedef struct rakutenSearchResultLite  {
    char    url[MAX_URLLENGTH];                    //!< iy[WURL
    char    productName[MAX_PRODUCTSNAME_LENGTH];  //!< iA
}   RAKUTEN_LITE, *RAKUTEN_LITE_t;
/*@}*/

/** \defgroup rakutenTypeXml ʊi[p\(RAKUTEN_TYPE_XML p)
 *  \ingroup rakutenSearch
 */
/*@{*/
//! ʊi[p\(dʔ)
typedef struct rakutenSearchResultHeavy {
    char    url[MAX_URLLENGTH];                    //!< iy[WURL
    char    isbn[MAX_NAMELEN];                     //!< ISBN
    char    productName[MAX_PRODUCTSNAME_LENGTH];  //!< iA
    char    authors[MAX_AUTHORINFO_LENGTH];        //!< ҁAҎ
    char    manufacturer[MAX_MANUFACTURER_LENGTH]; //!< sA
    char    imageURLsmall[MAX_URLLENGTH];          //!< ȉ摜URL
    char    listPrice[MAX_PRICE_LENGTH];           //!< 艿
    unsigned long   salesRank;                     //!< グ
}   RAKUTEN_HEAVY, *RAKUTEN_HEAVY_t;
/*@}*/


/** \defgroup rakutenWebAPI yVEFuT[rX ֘Ae`
 */
/*
 *  yVEFuT[rX
 */

/** \defgroup areaLength i[̈ő咷
 *  \ingroup rakutenWebAPI
 */
/*@{*/
#define RAKUTEN_VERSION_LEN 12      //!< uo[Wvő咷
#define RAKUTEN_DTIME_LEN   20      //!< uvő咷
#define RAKUTEN_OPE_LEN     24      //!< uvő咷
#define RAKUTEN_NAME_LEN    128     //!< u[J[vAuV[Yvő咷
#define RAKUTEN_STATMSG_LEN 1024    //!< usʃXe[^Xڍׁvő咷
/*@}*/

/** \defgroup sortOrder \[g
 *  \ingroup rakutenWebAPI
 */
/*@{*/
// item p
#define RAKUTEN_SORT_AFFRATE_ASCENDING  1   //!< AtBGCg() +affiliateRate
#define RAKUTEN_SORT_AFFRATE_DESCENDING 2   //!< AtBGCg(~) -affiliateRate
#define RAKUTEN_SORT_RVCNT_ASCENDING    3   //!< r[() +reviewCount
#define RAKUTEN_SORT_RVCNT_DESCENDING   4   //!< r[(~) -reviewCount
#define RAKUTEN_SORT_PRICE_ASCENDING    5   //!< i() +itemPrice
#define RAKUTEN_SORT_PRICE_DESCENDING   6   //!< i(~) -itemPrice
#define RAKUTEN_SORT_DTIME_ASCENDING    7   //!< iXV() +updateTimestamp
#define RAKUTEN_SORT_DTIME_DESCENDING   8   //!< iXV(~) -updateTimestamp

// catalog p
#define RAKUTEN_SORT_RDATE_ASCENDING    17  //!< J^Oo^() +registerDate
#define RAKUTEN_SORT_RDATE_DESCENDING   18  //!< J^Oo^(~) -registerDate
#define RAKUTEN_SORT_RLDATE_ASCENDING   19  //!< Â   +releaseDate
#define RAKUTEN_SORT_RLDATE_DESCENDING  20  //!< V -releaseDate
#define RAKUTEN_SORT_RVNUM_ASCENDING    21  //!< r[() +reviewNum
#define RAKUTEN_SORT_RVNUM_DESCENDING   22  //!< r[(~) -reviewNum

// item, catalog p
#define RAKUTEN_SORT_RANDOM_ORDER       33   //!< _ random
/*@}*/

/** \defgroup rakutenItem iʏi[p\
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! iʏ
typedef struct rakutenItem  {
    // i
    char    itemName[MAX_DESCRIPTION_LEN];      //!< i
    char    itemCode[MAX_KEYLENGTH];            //!< iR[h ( book:11918897)
    int     itemPrice;                          //!< ii
    char    itemCaption[MAX_CONTENT_SIZE];      //!< i
    char    itemUrl[MAX_URLLENGTH];             //!< iURL
    char    affiliateUrl[MAX_URLLENGTH];        //!< AtBGCgURL 
    BOOL    imageFlag;                          //!< i摜LtO
    char    smallImageUrl[MAX_URLLENGTH];       //!< i摜URL 64x64 
    char    mediumImageUrl[MAX_URLLENGTH];      //!< i摜URL 128x128 
    BOOL    availability;                       //!< ̔\tO
    BOOL    taxFlag;                            //!< ŃtO
    BOOL    postageFlag;                        //!< tO
    BOOL    creditCardFlag;                     //!< NWbgJ[hp\tO
    BOOL    shopOfTheYearFlag;                  //!< VbvIuUC[tO
    double  affiliateRate;                      //!< AtBGCgp
    char    startTime[RAKUTEN_DTIME_LEN];       //!< ̔Jn YYYY-MM-DD HH:MM`
    char    endTime[RAKUTEN_DTIME_LEN];         //!< ̔I YYYY-MM-DD HH:MM`
    int     reviewCount;                        //!< r[
    double  reviewAverage;                      //!< r[
    // X܏
    char    shopName[MAX_LOGICALLINELEN];       //!< Xܖ
    char    shopCode[MAX_KEYLENGTH];            //!< X܃R[h
    char    shopUrl[MAX_URLLENGTH];             //!< XURL
    // W
    int     genreId;                            //!< WID
}   RAKUTEN_ITEM;
/*@}*/

/** \defgroup rakutenCatalog J^Oi[p\
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! J^O
typedef struct rakutenCatalog   {
    // i
    char    catalogName[MAX_DESCRIPTION_LEN];   //!< J^O
    char    catalogCode[MAX_KEYLENGTH];         //!< J^OR[h
    char    modelNo[MAX_KEYLENGTH];             //!< ^
    char    makerName[RAKUTEN_NAME_LEN];        //!< [J[
    char    seriesName[RAKUTEN_NAME_LEN];       //!< V[Y
    char    onSaleDate[MAX_LOGICALLINELEN];     //!< 
    int     catalogPrice;                       //!< Wi (I[vîƂ -1)
    char    catalogCaption[MAX_CONTENT_SIZE];   //!< J^O
    char    catalogUrl[MAX_URLLENGTH];          //!< J^OURL
    BOOL    imageFlag;                          //!< J^O摜LtO
    char    smallImageUrl[MAX_URLLENGTH];       //!< J^O摜URL 64x64
    char    mediumImageUrl[MAX_URLLENGTH];      //!< J^O摜URL 128x128
    int     reviewCount;                        //!< r[
    // W
    int     genreId;                            //!< WID
}   RAKUTEN_CATALOG;
/*@}*/

/** \defgroup rautenGenre Wi[p\
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! J^O
typedef struct rautenGenre  {
    int     genreId;                        //!< WID
    char    genreName[MAX_LOGICALLINELEN];  //!< W
    int     genreLevel;                     //!< WKw
}   RAKUTEN_GENRE;
/*@}*/


/** \defgroup rakutenSearchRequest vi[p\ (ItemSearch, BookSearch, CDSearch, DVDSearch, CatalogSearchp)
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! vi[p\́E1 (2007-02-14)
typedef struct rakutenSearchRequest {
    // ʃp[^
    char    developerId[MAX_NAMELEN + 1];   //!< fxbp[ID
    char    affiliateId[MAX_KEYLENGTH];     //!< AtBGCgID
    char    operation[RAKUTEN_OPE_LEN];     //!< 
    // T[rXŗLp[^   -- ItemSearch, BookSearch, CDSearch, DVDSearch, CatalogSearch
    char    keyword[MAX_DESCRIPTION_LEN];   //!< L[[h
    char    version[RAKUTEN_VERSION_LEN];   //!< o[W
    char    shopCode[MAX_NAMELEN];          //!< VbvR[h (ItemSearcĥ)
    long    genreId;                        //!< WID
    char    catalogCode[MAX_KEYLENGTH];     //!< J^OR[h (ItemSearcĥ)
    int     hits;                           //!< 1y[W̎擾
    int     page;                           //!< 擾y[W (1ȏ100ȉ)
    int     sort;                           //!< \[g
    long    minPrice;                       //!< ŏi
    long    maxPrice;                       //!< ő剿i
    int     availability;                   //!< ̔\tO
    int     field;                          //!< tB[h
    int     carrier;                        //!< LA
    int     imageFlag;                      //!< i摜LtO
    int     releaseRange;                   //!<  (CatalogSearcĥ)
}   RAKUTEN_API_REQUEST;
/*@}*/  // BookSearch, CDSearch, DVDSearch ́uyVubNXv݂̂ΏۂƂȂ

/** \defgroup rakutenSearchResponse ʊi[p\ (ItemSearch, BookSearch, CDSearch, DVDSearchp)
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! ʊi[p\́E1 (2007-02-14)
typedef struct rakutenSearchResponse {
    char            status[MAX_NAMELEN];            //!< sʃXe[^X
    char            statusMsg[RAKUTEN_STATMSG_LEN]; //!< sʃXe[^Xڍ
    int             count;                          //!< ʂ̑i 
    int             page;                           //!< ݂̃y[Wԍ 
    int             first;                          //!< ʂ̉ڂ炩 
    int             last;                           //!< ʂ̉ڂ܂ł 
    int             hits;                           //!< xɕԋp鏤i 
    int             carrier;                        //!< LA (PC=0 or mobile=1)
    int             pageCount;                      //!< y[W (ő100)
    int             numOfItems;                     //!< 擾i̐
    RAKUTEN_ITEM    *item;                          //!< i + X܏ + W
}   RAKUTEN_API_RESPONSE;
/*@}*/

/** \defgroup rakutenSearchResponse1 ʊi[p\ (CatalogSearchp)
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! ʊi[p\́E1- (2007-02-14)
typedef struct rakutenSearchResponse1 {
    char            status[MAX_NAMELEN];            //!< sʃXe[^X
    char            statusMsg[RAKUTEN_STATMSG_LEN]; //!< sʃXe[^Xڍ
    int             count;                          //!< ʂ̑i 
    int             page;                           //!< ݂̃y[Wԍ 
    int             first;                          //!< ʂ̉ڂ炩 
    int             last;                           //!< ʂ̉ڂ܂ł 
    int             hits;                           //!< xɕԋp鏤i 
    int             carrier;                        //!< LA (PC=0 or mobile=1)
    int             pageCount;                      //!< y[W (ő100)
    int             numOfCatalogs;                  //!< 擾J^O̐
    RAKUTEN_CATALOG *catalog;                       //!< i + W
}   RAKUTEN_API_RESPONSE1;
/*@}*/

/** \defgroup rakutenSearchRequest2 vi[p\ (GenreSearchp)
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! vi[p\́E2 (2006-12-26)
typedef struct rakutenSearchRequest2 {
    // ʃp[^
    char    developerId[MAX_NAMELEN + 1];   //!< fxbp[ID
    char    affiliateId[MAX_KEYLENGTH];     //!< AtBGCgID
    char    operation[RAKUTEN_OPE_LEN];     //!< 
    // T[rXŗLp[^   -- GenreSearch
    long    genreId;                        //!< WID
    char    version[RAKUTEN_VERSION_LEN];   //!< o[W
    BOOL    genrePath;                      //!< WpX
}   RAKUTEN_API_REQUEST2;
/*@}*/

/** \defgroup rakutenSearchResponse2 ʊi[p\ (GenreSearchp)
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! ʊi[p\́E2 (2006-12-26)
typedef struct rakutenSearchResponse2 {
    char            status[MAX_NAMELEN];            //!< sʃXe[^X
    char            statusMsg[RAKUTEN_STATMSG_LEN]; //!< sʃXe[^Xڍ
    // eW
    int             numOfDepth;                     //!< [ge܂ł̐[
    RAKUTEN_GENRE   *parent;                        //!< eW / cW
    // W
    RAKUTEN_GENRE   current;                        //!< vŎw肵 genreId ɑΉW
    // qW
    int             numOfChilds;                    //!< qW
    RAKUTEN_GENRE   *child;                         //!< qW(݂ꍇ)
}   RAKUTEN_API_RESPONSE2;
/*@}*/


/** \defgroup rakutenSearchRequest3 vi[p\ (ItemCodeSearchp)
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! vi[p\́E3 (2007-02-14)
typedef struct rakutenSearchRequest3 {
    // ʃp[^
    char    developerId[MAX_NAMELEN + 1];   //!< fxbp[ID
    char    affiliateId[MAX_KEYLENGTH];     //!< AtBGCgID
    char    operation[RAKUTEN_OPE_LEN];     //!< 
    // T[rXŗLp[^   -- ItemCodeSearch
    char    itemCode[MAX_KEYLENGTH];        //!< iR[h ( book:11918897)
    char    version[RAKUTEN_VERSION_LEN];   //!< o[W
    int     carrier;                        //!< LA
}   RAKUTEN_API_REQUEST3;
/*@}*/

/** \defgroup rakutenSearchResponse3 ʊi[p\ (ItemCodeSearchp)
 *  \ingroup rakutenWebAPI
 */
/*@{*/
//! ʊi[p\́E3 (2007-02-14)
typedef struct rakutenSearchResponse3 {
    char            status[MAX_NAMELEN];            //!< sʃXe[^X
    char            statusMsg[RAKUTEN_STATMSG_LEN]; //!< sʃXe[^Xڍ
    int             carrier;                        //!< LA (PC=0 or mobile=1)
    RAKUTEN_ITEM    *item;                          //!< i + X܏ + W
}   RAKUTEN_API_RESPONSE3;
/*@}*/


// yViAPI       -- ItemSearch (version:2007-02-14)
RAKUTEN_API_RESPONSE    *
itemSearchOnRakutenWebAPI(
        const char *developerId,
        const char *affiliateId,
        const char *keyword,
        const char *shopCode,
        long       genreId,
        const char *catalogCode,
        int        hits,
        int        page,
        int        sort,
        long       minPrice,
        long       maxPrice,
        int        field,
        int        carrier,
        int        imageFlag
    );

RAKUTEN_API_RESPONSE    *
itemSearchOnRakutenWebAPIex( const RAKUTEN_API_REQUEST *p );


// yVWAPI   -- GenreSearch (version:2006-12-26)
RAKUTEN_API_RESPONSE2   *
genreSearchOnRakutenWebAPI(
        const char *developerId,
        const char *affiliateId,
        long       genreId,
        BOOL       genrePath
    );

RAKUTEN_API_RESPONSE2   *
genreSearchOnRakutenWebAPIex( const RAKUTEN_API_REQUEST2 *p );


// yViR[hAPI -- ItemCodeSearch (version:2007-02-14)
RAKUTEN_API_RESPONSE3   *
itemCodeSearchOnRakutenWebAPI(
        const char *developerId,
        const char *affiliateId,
        const char *itemCode,
        int        carrier
    );

RAKUTEN_API_RESPONSE3   *
itemCodeSearchOnRakutenWebAPIex( const RAKUTEN_API_REQUEST3 *p );


// yVЌAPI       -- BookSearch (version:2007-02-14)
RAKUTEN_API_RESPONSE    *
bookSearchOnRakutenWebAPI(
        const char *developerId,
        const char *affiliateId,
        const char *keyword,
        long       genreId,
        int        hits,
        int        page,
        int        sort,
        long       minPrice,
        long       maxPrice,
        int        field,
        int        carrier,
        int        imageFlag
    );

RAKUTEN_API_RESPONSE    *
bookSearchOnRakutenWebAPIex( const RAKUTEN_API_REQUEST *p );


// yVCDAPI         -- CDSearch (version:2007-02-14)
RAKUTEN_API_RESPONSE    *
cdSearchOnRakutenWebAPI(
        const char *developerId,
        const char *affiliateId,
        const char *keyword,
        long       genreId,
        int        hits,
        int        page,
        int        sort,
        long       minPrice,
        long       maxPrice,
        int        field,
        int        carrier,
        int        imageFlag
    );

RAKUTEN_API_RESPONSE    *
cdSearchOnRakutenWebAPIex( const RAKUTEN_API_REQUEST *p );


// yVDVDAPI        -- DVDSearch (version:2007-02-14)
RAKUTEN_API_RESPONSE    *
dvdSearchOnRakutenWebAPI(
        const char *developerId,
        const char *affiliateId,
        const char *keyword,
        long       genreId,
        int        hits,
        int        page,
        int        sort,
        long       minPrice,
        long       maxPrice,
        int        field,
        int        carrier,
        int        imageFlag
    );

RAKUTEN_API_RESPONSE    *
dvdSearchOnRakutenWebAPIex( const RAKUTEN_API_REQUEST *p );


// yVJ^OAPI   -- CatalogSearch (version:2007-02-14)
RAKUTEN_API_RESPONSE1   *
catalogSearchOnRakutenWebAPI(
        const char *developerId,
        const char *affiliateId,
        const char *keyword,
        long       genreId,
        int        hits,
        int        page,
        int        sort,
        long       minPrice,
        long       maxPrice,
        int        field,
        int        imageFlag,
        int        releaseRange
    );

RAKUTEN_API_RESPONSE1   *
catalogSearchOnRakutenWebAPIex( const RAKUTEN_API_REQUEST *p );


void
freeRakutenApiResponce( RAKUTEN_API_RESPONSE *p );

void
freeRakutenApiResponce1( RAKUTEN_API_RESPONSE1 *p );

void
freeRakutenApiResponce2( RAKUTEN_API_RESPONSE2 *p );

void
freeRakutenApiResponce3( RAKUTEN_API_RESPONSE3 *p );

#endif  /* __RAKUTEN_H__ */
