/*
 * Copyright (C) 2012 Varphone Wong <varphone@qq.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public Licens
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-
 *
 */

#ifndef LIBGCONTAINERS_GMUTEX_H
#define LIBGCONTAINERS_GMUTEX_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef HAVE_STDDEF_H
#include <stddef.h>
#endif

#ifndef GMUTEX_T_DEFINED
#define GMUTEX_T_DEFINED

#define GMUTEX_FLAG_COB     0x00000001              ///< Indicate the gmutex was create on buffer.
#define GMUTEX_SIZE			64

struct gallocator;

typedef void* gmutex_t;

gmutex_t gmutex_create(struct gallocator* allocator);
gmutex_t gmutex_create_on_buffer(void* buffer, size_t size);
void gmutex_destroy(gmutex_t mutex);

int gmutex_lock(gmutex_t mutex);
int gmutex_trylock(gmutex_t mutex);
int gmutex_unlock(gmutex_t mutex);

#endif

#endif

