/*
 * Copyright (C) 2012 Varphone Wong <varphone@qq.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public Licens
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-
 *
 */

#include "gmutex.h"

void test1(void)
{
	gmutex_t mtx = gmutex_create(0);
	for (int i=0; i<1000000; i++) {
		gmutex_lock(mtx);
		gmutex_unlock(mtx);
	}
	gmutex_destroy(mtx);
}

void test2(void)
{
	char buffer[GMUTEX_SIZE];
	gmutex_t mtx = gmutex_create_on_buffer(buffer, sizeof(buffer));
	for (int i=0; i<1000000; i++) {
		gmutex_lock(mtx);
		gmutex_unlock(mtx);
	}
	gmutex_destroy(mtx);
}

void test3(void)
{
	gmutex_destroy(0);
}

void test4(void)
{
	gmutex_lock(0);
}

void test5(void)
{
	gmutex_trylock(0);
}

void test6(void)
{
	gmutex_unlock(0);
}

int main(int argc, char** argv)
{
	test1();
	test2();
	test3();
	test4();
	test5();
	test6();
	return 0;
}

