/*
 * Copyright (C) 2012 Varphone Wong <varphone@qq.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public Licens
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-
 *
 */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "spool.h"

void test1(void)
{
	spool_t p = spool_create(40960, NULL);
	assert(p);
	for (int i = 0; i < 1000; i++) {
		spool_putfmt(p, "test1 line %d", i);
		spool_endl(p);
	}
	printf("length: %d\n", spool_length(p));
	printf("data: [%s]\n", spool_data(p));
	spool_destroy(p);
}

void test2(void)
{
	char buffer[40960];
	spool_t p = spool_create_on_buffer(buffer, sizeof(buffer));
	assert(p);
	for (int i = 0; i < 1000; i++) {
		spool_putfmt(p, "test2 line %d", i);
		spool_endl(p);
	}
	printf("length: %d\n", spool_length(p));
	printf("data: [%s]\n", spool_data(p));
	spool_destroy(p);
}

int main(int argc, char** argv)
{
	test1();
	test2();
	return 0;
}
