#pragma once

namespace vx
{

namespace codecvt
{
    inline std::wstring to_wide(const std::string& text)
    {
        // figure out how many wide characters we are going to get
	    std::wstring result(L"");
	    int len = MultiByteToWideChar(CP_ACP, 0, text.c_str(), text.length(), NULL, 0) ; 
        if (len <= 0)
            return result;
        // convert the narrow string to a wide string 
        // nb: slightly naughty to write directly into the string like this
        result.resize(len); 
        MultiByteToWideChar(CP_ACP, 0, text.c_str(), text.length(), 
		                    const_cast<wchar_t*>(result.c_str()) , len); 
        return result;
    }

    inline std::string to_narrow(const std::wstring& text)
    {
        // figure out how many narrow characters we are going to get 
        std::string result("");
	    int len = WideCharToMultiByte(CP_ACP, 0, text.c_str(), text.length(),
		    						  NULL, 0, NULL, NULL) ;
        if (len <= 0)
            return result;
        // convert the wide string to a narrow string
        // nb: slightly naughty to write directly into the string like this
        result.resize(len) ;
        WideCharToMultiByte(CP_ACP, 0, text.c_str(), text.length(), 
                            const_cast<char*>(result.c_str()), len, NULL, NULL); 
        return result; 
    }

    inline void to_lower(std::string& text)
    {
        std::transform(text.begin(), text.end(), text.begin(), ::tolower);
    }

    inline void to_upper(std::string& text)
    {
        std::transform(text.begin(), text.end(), text.begin(), ::toupper);
    }

        inline void to_lower(std::wstring& text)
    {
        std::transform(text.begin(), text.end(), text.begin(), ::tolower);
    }

    inline void to_upper(std::wstring& text)
    {
        std::transform(text.begin(), text.end(), text.begin(), ::toupper);
    }

}; // namespace vx::codecvt

}; // namespace vx