// Doubly Circular Linked List Implementation Using Dynamic Variables //

#include<stdio.h>
#include<stdlib.h>
#define TRUE 1
#define FALSE 0

typedef struct link {
                              int info;
                              struct link *right;
                              struct link *left;
                    }LINK; 
LINK *list;         // list points to the last node of the Linked List //
int count=0;
void pushs(int x);
int emptys(void);
LINK * getnode(void);
void inserts(int ,int );
int deletes(LINK *);
void freenode(LINK *);
int pops();
main(void)
{
   int ch,e,pos,temp=0,ct=1,end=FALSE;
   LINK *x;
   LINK *y;
   list=NULL;
   while(1)
   {
          system("cls"); 
          printf("\n\n\nDoubly Circular Linked List Implementation Using Dynamic Variables\n\n");
          printf("1. Insert Elements\n");
          printf("2. Delete Elements\n");
          printf("3. Display Elements\n");
          printf("4. Exit\n\n");
          printf("Enter Choice:");
          scanf("%d",&ch);
          switch(ch)
          {
              case 1:
                     printf("\nEnter Element:");
                     scanf("%d",&e);
                     if(emptys())
                                 pushs(e);
                     else
                     {
                                 printf("\nEnter Element Position:");
                                 scanf("%d",&pos);
                                 if(pos>count+1 || pos<=0)
                                                printf("\nIncorrect Position!");
                                 else
                                                inserts(e,pos); 
                                 fflush(stdin);
                                 getchar();                                
                     }           
                                  
                     break;
              case 2:
                     ct=1;
                     if(emptys())
                     {
                                printf("\nUnderflow!");
                                fflush(stdin);
                                getchar();  
                     }
                     else
                     {
                        printf("\nEnter Element to Delete:");
                        scanf("%d",&e);
                        x=list;               
                        while(list!=NULL && end == FALSE)   // When single node deleted list = NULL
                        {
                                  x = x->right;
                                  if(x->info==e)
                                  {
                                          if(x!=list->right)    // list.next is first node 
                                             temp = deletes(x); 
                                          else
                                             temp=pops();
                                          printf("\n%d Deleted at Position %d !",temp, ct);                                                                              
                                  }
                                  
                                  if(x==list)           
                                     end = TRUE;
                                  ct++;
                        }  
                        end = FALSE;
                        if(x==list && temp==0)
                               printf("\nElement Does Not Exist");
                        fflush(stdin);
                        getchar();      
                        
                     }          
                     
                     break;
              case 3:
                     x = list;
                     if(x!=NULL)
                                       printf("\nLinked List:");
                     while(end==FALSE && x!=NULL)
                     {
                            x = x->right;          
                            printf("%d->",x->info);                              
                            if(x==list)
                                       end = TRUE;
                     }
                     end = FALSE;
                     if(list==NULL)
                            printf("\nLinked List Empty!");    
                            fflush(stdin);
                            getchar();                                           
                     
                     break;
              case 4:
                     exit(0);        // returning 0 means successful 
          }
          
   }                 
}

int emptys(void)
{
    if(list==NULL)
                 return TRUE;
    else
                 return FALSE;    
}

void pushs(int x)
{
     LINK *p;
     p = getnode();
     p->info = x;
     p->right = p;
     p->left = p;
     list = p;   
}

LINK * getnode(void)
{
     LINK *p;
     count++;
     p = (LINK*)malloc(sizeof(LINK));
     return p;     
}

void inserts(int e,int pos)
{
     int i;
     LINK *x=list;
     LINK *p;
     {
           for(i=1;i<pos;i++)
           {
                              x = x->right;                
           }
          p = getnode();
          p->info = e;
          if(pos==count)
          {
                    p->right = x->right;
                    (x->right)->left = p;
                    x->right = p;
                    p->left = x;
                    list = p;
          }
          else
          {
                    p->right = x->right;
                    (x->right)->left = p;
                    p->left = x;
                    x->right = p;  
                            
          }
     }  
}

int deletes(LINK *y)
{
    int temp;
    (y->left)->right = y->right;
    (y->right)->left = y->left;
    temp = y->info;
    if(y==list)             //Last node is to be deleted 
               list = y->left;
    freenode(y);    
    return temp;
}

void freenode(LINK *x)
{
     free(x);   
     count--; 
}

int pops()
{
    int temp;
    LINK *x;
    x = list->right;    // first node
    temp = x->info;   
    if(list==x)                     // Single Node Deleted 
               list = NULL;
    else
    {
               list->right = x->right;  
               (x->right)->left = list;         
    }
    freenode(x);
    return temp;
}







