const char *get_ntstatus_name (long status)
{
	switch (status) {
	case 0x00000000: return "STATUS_SUCCESS";
	case 0x00000001: return "STATUS_WAIT_1";
	case 0x00000002: return "STATUS_WAIT_2";
	case 0x00000003: return "STATUS_WAIT_3";
	case 0x00000080: return "STATUS_ABANDONED_WAIT_0";
	case 0x000000BF: return "STATUS_ABANDONED_WAIT_63";
	case 0x000000C0: return "STATUS_USER_APC";
	case 0x00000100: return "STATUS_KERNEL_APC";
	case 0x00000101: return "STATUS_ALERTED";
	case 0x00000102: return "STATUS_TIMEOUT";
	case 0x00000103: return "STATUS_PENDING";
	case 0x00000104: return "STATUS_REPARSE";
	case 0x00000105: return "STATUS_MORE_ENTRIES";
	case 0x00000106: return "STATUS_NOT_ALL_ASSIGNED";
	case 0x00000107: return "STATUS_SOME_NOT_MAPPED";
	case 0x00000108: return "STATUS_OPLOCK_BREAK_IN_PROGRESS";
	case 0x00000109: return "STATUS_VOLUME_MOUNTED";
	case 0x0000010A: return "STATUS_RXACT_COMMITTED";
	case 0x0000010B: return "STATUS_NOTIFY_CLEANUP";
	case 0x0000010C: return "STATUS_NOTIFY_ENUM_DIR";
	case 0x0000010D: return "STATUS_NO_QUOTAS_FOR_ACCOUNT";
	case 0x0000010E: return "STATUS_PRIMARY_TRANSPORT_CONNECT_FAILED";
	case 0x00000110: return "STATUS_PAGE_FAULT_TRANSITION";
	case 0x00000111: return "STATUS_PAGE_FAULT_DEMAND_ZERO";
	case 0x00000112: return "STATUS_PAGE_FAULT_COPY_ON_WRITE";
	case 0x00000113: return "STATUS_PAGE_FAULT_GUARD_PAGE";
	case 0x00000114: return "STATUS_PAGE_FAULT_PAGING_FILE";
	case 0x00000115: return "STATUS_CACHE_PAGE_LOCKED";
	case 0x00000116: return "STATUS_CRASH_DUMP";
	case 0x00000117: return "STATUS_BUFFER_ALL_ZEROS";
	case 0x00000118: return "STATUS_REPARSE_OBJECT";
	case 0x00000119: return "STATUS_RESOURCE_REQUIREMENTS_CHANGED";
	case 0x00000120: return "STATUS_TRANSLATION_COMPLETE";
	case 0x00000121: return "STATUS_DS_MEMBERSHIP_EVALUATED_LOCALLY";
	case 0x00000122: return "STATUS_NOTHING_TO_TERMINATE";
	case 0x00000123: return "STATUS_PROCESS_NOT_IN_JOB";
	case 0x00000124: return "STATUS_PROCESS_IN_JOB";
	case 0x00000125: return "STATUS_VOLSNAP_HIBERNATE_READY";
	case 0x00000126: return "STATUS_FSFILTER_OP_COMPLETED_SUCCESSFULLY";
	case 0x00000127: return "STATUS_INTERRUPT_VECTOR_ALREADY_CONNECTED";
	case 0x00000128: return "STATUS_INTERRUPT_STILL_CONNECTED";
	case 0x00000129: return "STATUS_PROCESS_CLONED";
	case 0x0000012A: return "STATUS_FILE_LOCKED_WITH_ONLY_READERS";
	case 0x0000012B: return "STATUS_FILE_LOCKED_WITH_WRITERS";
	case 0x00000202: return "STATUS_RESOURCEMANAGER_READ_ONLY";
	case 0x00000367: return "STATUS_WAIT_FOR_OPLOCK";
	case 0x00010001: return "DBG_EXCEPTION_HANDLED";
	case 0x00010002: return "DBG_CONTINUE";
	case 0x001C0001: return "STATUS_FLT_IO_COMPLETE";
	case 0x40000000: return "STATUS_OBJECT_NAME_EXISTS";
	case 0x40000001: return "STATUS_THREAD_WAS_SUSPENDED";
	case 0x40000002: return "STATUS_WORKING_SET_LIMIT_RANGE";
	case 0x40000003: return "STATUS_IMAGE_NOT_AT_BASE";
	case 0x40000004: return "STATUS_RXACT_STATE_CREATED";
	case 0x40000005: return "STATUS_SEGMENT_NOTIFICATION";
	case 0x40000006: return "STATUS_LOCAL_USER_SESSION_KEY";
	case 0x40000007: return "STATUS_BAD_CURRENT_DIRECTORY";
	case 0x40000008: return "STATUS_SERIAL_MORE_WRITES";
	case 0x40000009: return "STATUS_REGISTRY_RECOVERED";
	case 0x4000000A: return "STATUS_FT_READ_RECOVERY_FROM_BACKUP";
	case 0x4000000B: return "STATUS_FT_WRITE_RECOVERY";
	case 0x4000000C: return "STATUS_SERIAL_COUNTER_TIMEOUT";
	case 0x4000000D: return "STATUS_NULL_LM_PASSWORD";
	case 0x4000000E: return "STATUS_IMAGE_MACHINE_TYPE_MISMATCH";
	case 0x4000000F: return "STATUS_RECEIVE_PARTIAL";
	case 0x40000010: return "STATUS_RECEIVE_EXPEDITED";
	case 0x40000011: return "STATUS_RECEIVE_PARTIAL_EXPEDITED";
	case 0x40000012: return "STATUS_EVENT_DONE";
	case 0x40000013: return "STATUS_EVENT_PENDING";
	case 0x40000014: return "STATUS_CHECKING_FILE_SYSTEM";
	case 0x40000015: return "STATUS_FATAL_APP_EXIT";
	case 0x40000016: return "STATUS_PREDEFINED_HANDLE";
	case 0x40000017: return "STATUS_WAS_UNLOCKED";
	case 0x40000018: return "STATUS_SERVICE_NOTIFICATION";
	case 0x40000019: return "STATUS_WAS_LOCKED";
	case 0x4000001A: return "STATUS_LOG_HARD_ERROR";
	case 0x4000001B: return "STATUS_ALREADY_WIN32";
	case 0x4000001C: return "STATUS_WX86_UNSIMULATE";
	case 0x4000001D: return "STATUS_WX86_CONTINUE";
	case 0x4000001E: return "STATUS_WX86_SINGLE_STEP";
	case 0x4000001F: return "STATUS_WX86_BREAKPOINT";
	case 0x40000020: return "STATUS_WX86_EXCEPTION_CONTINUE";
	case 0x40000021: return "STATUS_WX86_EXCEPTION_LASTCHANCE";
	case 0x40000022: return "STATUS_WX86_EXCEPTION_CHAIN";
	case 0x40000023: return "STATUS_IMAGE_MACHINE_TYPE_MISMATCH_EXE";
	case 0x40000024: return "STATUS_NO_YIELD_PERFORMED";
	case 0x40000025: return "STATUS_TIMER_RESUME_IGNORED";
	case 0x40000026: return "STATUS_ARBITRATION_UNHANDLED";
	case 0x40000027: return "STATUS_CARDBUS_NOT_SUPPORTED";
	case 0x40000028: return "STATUS_WX86_CREATEWX86TIB";
	case 0x40000029: return "STATUS_MP_PROCESSOR_MISMATCH";
	case 0x4000002A: return "STATUS_HIBERNATED";
	case 0x4000002B: return "STATUS_RESUME_HIBERNATION";
	case 0x4000002C: return "STATUS_FIRMWARE_UPDATED";
	case 0x4000002D: return "STATUS_DRIVERS_LEAKING_LOCKED_PAGES";
	case 0x4000002E: return "STATUS_MESSAGE_RETRIEVED";
	case 0x4000002F: return "STATUS_SYSTEM_POWERSTATE_TRANSITION";
	case 0x40000030: return "STATUS_ALPC_CHECK_COMPLETION_LIST";
	case 0x40000031: return "STATUS_SYSTEM_POWERSTATE_COMPLEX_TRANSITION";
	case 0x40000032: return "STATUS_ACCESS_AUDIT_BY_POLICY";
	case 0x40000033: return "STATUS_ABANDON_HIBERFILE";
	case 0x40000034: return "STATUS_BIZRULES_NOT_ENABLED";
	case 0x40000294: return "STATUS_WAKE_SYSTEM";
	case 0x40000370: return "STATUS_DS_SHUTTING_DOWN";
	case 0x40010001: return "DBG_REPLY_LATER";
	case 0x40010002: return "DBG_UNABLE_TO_PROVIDE_HANDLE";
	case 0x40010003: return "DBG_TERMINATE_THREAD";
	case 0x40010004: return "DBG_TERMINATE_PROCESS";
	case 0x40010005: return "DBG_CONTROL_C";
	case 0x40010006: return "DBG_PRINTEXCEPTION_C";
	case 0x40010007: return "DBG_RIPEXCEPTION";
	case 0x40010008: return "DBG_CONTROL_BREAK";
	case 0x40010009: return "DBG_COMMAND_EXCEPTION";
	case 0x40020056: return "RPC_NT_UUID_LOCAL_ONLY";
	case 0x400200AF: return "RPC_NT_SEND_INCOMPLETE";
	case 0x400A0004: return "STATUS_CTX_CDM_CONNECT";
	case 0x400A0005: return "STATUS_CTX_CDM_DISCONNECT";
	case 0x4015000D: return "STATUS_SXS_RELEASE_ACTIVATION_CONTEXT";
	case 0x40190034: return "STATUS_RECOVERY_NOT_NEEDED";
	case 0x40190035: return "STATUS_RM_ALREADY_STARTED";
	case 0x401A000C: return "STATUS_LOG_NO_RESTART";
	case 0x401B00EC: return "STATUS_VIDEO_DRIVER_DEBUG_REPORT_REQUEST";
	case 0x401E000A: return "STATUS_GRAPHICS_PARTIAL_DATA_POPULATED";
	case 0x401E0307: return "STATUS_GRAPHICS_MODE_NOT_PINNED";
	case 0x401E031E: return "STATUS_GRAPHICS_NO_PREFERRED_MODE";
	case 0x401E034B: return "STATUS_GRAPHICS_DATASET_IS_EMPTY";
	case 0x401E034C: return "STATUS_GRAPHICS_NO_MORE_ELEMENTS_IN_DATASET";
	case 0x401E0351: return "STATUS_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_PINNED";
	case 0x401E042F: return "STATUS_GRAPHICS_UNKNOWN_CHILD_STATUS";
	case 0x401E0437: return "STATUS_GRAPHICS_LEADLINK_START_DEFERRED";
	case 0x401E0439: return "STATUS_GRAPHICS_POLLING_TOO_FREQUENTLY";
	case 0x401E043A: return "STATUS_GRAPHICS_START_DEFERRED";
	case 0x40230001: return "STATUS_NDIS_INDICATION_REQUIRED";
	case 0x80000001: return "STATUS_GUARD_PAGE_VIOLATION";
	case 0x80000002: return "STATUS_DATATYPE_MISALIGNMENT";
	case 0x80000003: return "STATUS_BREAKPOINT";
	case 0x80000004: return "STATUS_SINGLE_STEP";
	case 0x80000005: return "STATUS_BUFFER_OVERFLOW";
	case 0x80000006: return "STATUS_NO_MORE_FILES";
	case 0x80000007: return "STATUS_WAKE_SYSTEM_DEBUGGER";
	case 0x8000000A: return "STATUS_HANDLES_CLOSED";
	case 0x8000000B: return "STATUS_NO_INHERITANCE";
	case 0x8000000C: return "STATUS_GUID_SUBSTITUTION_MADE";
	case 0x8000000D: return "STATUS_PARTIAL_COPY";
	case 0x8000000E: return "STATUS_DEVICE_PAPER_EMPTY";
	case 0x8000000F: return "STATUS_DEVICE_POWERED_OFF";
	case 0x80000010: return "STATUS_DEVICE_OFF_LINE";
	case 0x80000011: return "STATUS_DEVICE_BUSY";
	case 0x80000012: return "STATUS_NO_MORE_EAS";
	case 0x80000013: return "STATUS_INVALID_EA_NAME";
	case 0x80000014: return "STATUS_EA_LIST_INCONSISTENT";
	case 0x80000015: return "STATUS_INVALID_EA_FLAG";
	case 0x80000016: return "STATUS_VERIFY_REQUIRED";
	case 0x80000017: return "STATUS_EXTRANEOUS_INFORMATION";
	case 0x80000018: return "STATUS_RXACT_COMMIT_NECESSARY";
	case 0x8000001A: return "STATUS_NO_MORE_ENTRIES";
	case 0x8000001B: return "STATUS_FILEMARK_DETECTED";
	case 0x8000001C: return "STATUS_MEDIA_CHANGED";
	case 0x8000001D: return "STATUS_BUS_RESET";
	case 0x8000001E: return "STATUS_END_OF_MEDIA";
	case 0x8000001F: return "STATUS_BEGINNING_OF_MEDIA";
	case 0x80000020: return "STATUS_MEDIA_CHECK";
	case 0x80000021: return "STATUS_SETMARK_DETECTED";
	case 0x80000022: return "STATUS_NO_DATA_DETECTED";
	case 0x80000023: return "STATUS_REDIRECTOR_HAS_OPEN_HANDLES";
	case 0x80000024: return "STATUS_SERVER_HAS_OPEN_HANDLES";
	case 0x80000025: return "STATUS_ALREADY_DISCONNECTED";
	case 0x80000026: return "STATUS_LONGJUMP";
	case 0x80000027: return "STATUS_CLEANER_CARTRIDGE_INSTALLED";
	case 0x80000028: return "STATUS_PLUGPLAY_QUERY_VETOED";
	case 0x80000029: return "STATUS_UNWIND_CONSOLIDATE";
	case 0x8000002A: return "STATUS_REGISTRY_HIVE_RECOVERED";
	case 0x8000002B: return "STATUS_DLL_MIGHT_BE_INSECURE";
	case 0x8000002C: return "STATUS_DLL_MIGHT_BE_INCOMPATIBLE";
	case 0x8000002D: return "STATUS_STOPPED_ON_SYMLINK";
	case 0x80000288: return "STATUS_DEVICE_REQUIRES_CLEANING";
	case 0x80000289: return "STATUS_DEVICE_DOOR_OPEN";
	case 0x80000803: return "STATUS_DATA_LOST_REPAIR";
	case 0x80010001: return "DBG_EXCEPTION_NOT_HANDLED";
	case 0x80130001: return "STATUS_CLUSTER_NODE_ALREADY_UP";
	case 0x80130002: return "STATUS_CLUSTER_NODE_ALREADY_DOWN";
	case 0x80130003: return "STATUS_CLUSTER_NETWORK_ALREADY_ONLINE";
	case 0x80130004: return "STATUS_CLUSTER_NETWORK_ALREADY_OFFLINE";
	case 0x80130005: return "STATUS_CLUSTER_NODE_ALREADY_MEMBER";
	case 0x80190009: return "STATUS_COULD_NOT_RESIZE_LOG";
	case 0x80190029: return "STATUS_NO_TXF_METADATA";
	case 0x80190031: return "STATUS_CANT_RECOVER_WITH_HANDLE_OPEN";
	case 0x80190041: return "STATUS_TXF_METADATA_ALREADY_PRESENT";
	case 0x80190042: return "STATUS_TRANSACTION_SCOPE_CALLBACKS_NOT_SET";
	case 0x801B00EB: return "STATUS_VIDEO_HUNG_DISPLAY_DRIVER_THREAD_RECOVERED";
	case 0x801C0001: return "STATUS_FLT_BUFFER_TOO_SMALL";
	case 0x80210001: return "STATUS_FVE_PARTIAL_METADATA";
	case 0xC0000001: return "STATUS_UNSUCCESSFUL";
	case 0xC0000002: return "STATUS_NOT_IMPLEMENTED";
	case 0xC0000003: return "STATUS_INVALID_INFO_CLASS";
	case 0xC0000004: return "STATUS_INFO_LENGTH_MISMATCH";
	case 0xC0000005: return "STATUS_ACCESS_VIOLATION";
	case 0xC0000006: return "STATUS_IN_PAGE_ERROR";
	case 0xC0000007: return "STATUS_PAGEFILE_QUOTA";
	case 0xC0000008: return "STATUS_INVALID_HANDLE";
	case 0xC0000009: return "STATUS_BAD_INITIAL_STACK";
	case 0xC000000A: return "STATUS_BAD_INITIAL_PC";
	case 0xC000000B: return "STATUS_INVALID_CID";
	case 0xC000000C: return "STATUS_TIMER_NOT_CANCELED";
	case 0xC000000D: return "STATUS_INVALID_PARAMETER";
	case 0xC000000E: return "STATUS_NO_SUCH_DEVICE";
	case 0xC000000F: return "STATUS_NO_SUCH_FILE";
	case 0xC0000010: return "STATUS_INVALID_DEVICE_REQUEST";
	case 0xC0000011: return "STATUS_END_OF_FILE";
	case 0xC0000012: return "STATUS_WRONG_VOLUME";
	case 0xC0000013: return "STATUS_NO_MEDIA_IN_DEVICE";
	case 0xC0000014: return "STATUS_UNRECOGNIZED_MEDIA";
	case 0xC0000015: return "STATUS_NONEXISTENT_SECTOR";
	case 0xC0000016: return "STATUS_MORE_PROCESSING_REQUIRED";
	case 0xC0000017: return "STATUS_NO_MEMORY";
	case 0xC0000018: return "STATUS_CONFLICTING_ADDRESSES";
	case 0xC0000019: return "STATUS_NOT_MAPPED_VIEW";
	case 0xC000001A: return "STATUS_UNABLE_TO_FREE_VM";
	case 0xC000001B: return "STATUS_UNABLE_TO_DELETE_SECTION";
	case 0xC000001C: return "STATUS_INVALID_SYSTEM_SERVICE";
	case 0xC000001D: return "STATUS_ILLEGAL_INSTRUCTION";
	case 0xC000001E: return "STATUS_INVALID_LOCK_SEQUENCE";
	case 0xC000001F: return "STATUS_INVALID_VIEW_SIZE";
	case 0xC0000020: return "STATUS_INVALID_FILE_FOR_SECTION";
	case 0xC0000021: return "STATUS_ALREADY_COMMITTED";
	case 0xC0000022: return "STATUS_ACCESS_DENIED";
	case 0xC0000023: return "STATUS_BUFFER_TOO_SMALL";
	case 0xC0000024: return "STATUS_OBJECT_TYPE_MISMATCH";
	case 0xC0000025: return "STATUS_NONCONTINUABLE_EXCEPTION";
	case 0xC0000026: return "STATUS_INVALID_DISPOSITION";
	case 0xC0000027: return "STATUS_UNWIND";
	case 0xC0000028: return "STATUS_BAD_STACK";
	case 0xC0000029: return "STATUS_INVALID_UNWIND_TARGET";
	case 0xC000002A: return "STATUS_NOT_LOCKED";
	case 0xC000002B: return "STATUS_PARITY_ERROR";
	case 0xC000002C: return "STATUS_UNABLE_TO_DECOMMIT_VM";
	case 0xC000002D: return "STATUS_NOT_COMMITTED";
	case 0xC000002E: return "STATUS_INVALID_PORT_ATTRIBUTES";
	case 0xC000002F: return "STATUS_PORT_MESSAGE_TOO_LONG";
	case 0xC0000030: return "STATUS_INVALID_PARAMETER_MIX";
	case 0xC0000031: return "STATUS_INVALID_QUOTA_LOWER";
	case 0xC0000032: return "STATUS_DISK_CORRUPT_ERROR";
	case 0xC0000033: return "STATUS_OBJECT_NAME_INVALID";
	case 0xC0000034: return "STATUS_OBJECT_NAME_NOT_FOUND";
	case 0xC0000035: return "STATUS_OBJECT_NAME_COLLISION";
	case 0xC0000037: return "STATUS_PORT_DISCONNECTED";
	case 0xC0000038: return "STATUS_DEVICE_ALREADY_ATTACHED";
	case 0xC0000039: return "STATUS_OBJECT_PATH_INVALID";
	case 0xC000003A: return "STATUS_OBJECT_PATH_NOT_FOUND";
	case 0xC000003B: return "STATUS_OBJECT_PATH_SYNTAX_BAD";
	case 0xC000003C: return "STATUS_DATA_OVERRUN";
	case 0xC000003D: return "STATUS_DATA_LATE_ERROR";
	case 0xC000003E: return "STATUS_DATA_ERROR";
	case 0xC000003F: return "STATUS_CRC_ERROR";
	case 0xC0000040: return "STATUS_SECTION_TOO_BIG";
	case 0xC0000041: return "STATUS_PORT_CONNECTION_REFUSED";
	case 0xC0000042: return "STATUS_INVALID_PORT_HANDLE";
	case 0xC0000043: return "STATUS_SHARING_VIOLATION";
	case 0xC0000044: return "STATUS_QUOTA_EXCEEDED";
	case 0xC0000045: return "STATUS_INVALID_PAGE_PROTECTION";
	case 0xC0000046: return "STATUS_MUTANT_NOT_OWNED";
	case 0xC0000047: return "STATUS_SEMAPHORE_LIMIT_EXCEEDED";
	case 0xC0000048: return "STATUS_PORT_ALREADY_SET";
	case 0xC0000049: return "STATUS_SECTION_NOT_IMAGE";
	case 0xC000004A: return "STATUS_SUSPEND_COUNT_EXCEEDED";
	case 0xC000004B: return "STATUS_THREAD_IS_TERMINATING";
	case 0xC000004C: return "STATUS_BAD_WORKING_SET_LIMIT";
	case 0xC000004D: return "STATUS_INCOMPATIBLE_FILE_MAP";
	case 0xC000004E: return "STATUS_SECTION_PROTECTION";
	case 0xC000004F: return "STATUS_EAS_NOT_SUPPORTED";
	case 0xC0000050: return "STATUS_EA_TOO_LARGE";
	case 0xC0000051: return "STATUS_NONEXISTENT_EA_ENTRY";
	case 0xC0000052: return "STATUS_NO_EAS_ON_FILE";
	case 0xC0000053: return "STATUS_EA_CORRUPT_ERROR";
	case 0xC0000054: return "STATUS_FILE_LOCK_CONFLICT";
	case 0xC0000055: return "STATUS_LOCK_NOT_GRANTED";
	case 0xC0000056: return "STATUS_DELETE_PENDING";
	case 0xC0000057: return "STATUS_CTL_FILE_NOT_SUPPORTED";
	case 0xC0000058: return "STATUS_UNKNOWN_REVISION";
	case 0xC0000059: return "STATUS_REVISION_MISMATCH";
	case 0xC000005A: return "STATUS_INVALID_OWNER";
	case 0xC000005B: return "STATUS_INVALID_PRIMARY_GROUP";
	case 0xC000005C: return "STATUS_NO_IMPERSONATION_TOKEN";
	case 0xC000005D: return "STATUS_CANT_DISABLE_MANDATORY";
	case 0xC000005E: return "STATUS_NO_LOGON_SERVERS";
	case 0xC000005F: return "STATUS_NO_SUCH_LOGON_SESSION";
	case 0xC0000060: return "STATUS_NO_SUCH_PRIVILEGE";
	case 0xC0000061: return "STATUS_PRIVILEGE_NOT_HELD";
	case 0xC0000062: return "STATUS_INVALID_ACCOUNT_NAME";
	case 0xC0000063: return "STATUS_USER_EXISTS";
	case 0xC0000064: return "STATUS_NO_SUCH_USER";
	case 0xC0000065: return "STATUS_GROUP_EXISTS";
	case 0xC0000066: return "STATUS_NO_SUCH_GROUP";
	case 0xC0000067: return "STATUS_MEMBER_IN_GROUP";
	case 0xC0000068: return "STATUS_MEMBER_NOT_IN_GROUP";
	case 0xC0000069: return "STATUS_LAST_ADMIN";
	case 0xC000006A: return "STATUS_WRONG_PASSWORD";
	case 0xC000006B: return "STATUS_ILL_FORMED_PASSWORD";
	case 0xC000006C: return "STATUS_PASSWORD_RESTRICTION";
	case 0xC000006D: return "STATUS_LOGON_FAILURE";
	case 0xC000006E: return "STATUS_ACCOUNT_RESTRICTION";
	case 0xC000006F: return "STATUS_INVALID_LOGON_HOURS";
	case 0xC0000070: return "STATUS_INVALID_WORKSTATION";
	case 0xC0000071: return "STATUS_PASSWORD_EXPIRED";
	case 0xC0000072: return "STATUS_ACCOUNT_DISABLED";
	case 0xC0000073: return "STATUS_NONE_MAPPED";
	case 0xC0000074: return "STATUS_TOO_MANY_LUIDS_REQUESTED";
	case 0xC0000075: return "STATUS_LUIDS_EXHAUSTED";
	case 0xC0000076: return "STATUS_INVALID_SUB_AUTHORITY";
	case 0xC0000077: return "STATUS_INVALID_ACL";
	case 0xC0000078: return "STATUS_INVALID_SID";
	case 0xC0000079: return "STATUS_INVALID_SECURITY_DESCR";
	case 0xC000007A: return "STATUS_PROCEDURE_NOT_FOUND";
	case 0xC000007B: return "STATUS_INVALID_IMAGE_FORMAT";
	case 0xC000007C: return "STATUS_NO_TOKEN";
	case 0xC000007D: return "STATUS_BAD_INHERITANCE_ACL";
	case 0xC000007E: return "STATUS_RANGE_NOT_LOCKED";
	case 0xC000007F: return "STATUS_DISK_FULL";
	case 0xC0000080: return "STATUS_SERVER_DISABLED";
	case 0xC0000081: return "STATUS_SERVER_NOT_DISABLED";
	case 0xC0000082: return "STATUS_TOO_MANY_GUIDS_REQUESTED";
	case 0xC0000083: return "STATUS_GUIDS_EXHAUSTED";
	case 0xC0000084: return "STATUS_INVALID_ID_AUTHORITY";
	case 0xC0000085: return "STATUS_AGENTS_EXHAUSTED";
	case 0xC0000086: return "STATUS_INVALID_VOLUME_LABEL";
	case 0xC0000087: return "STATUS_SECTION_NOT_EXTENDED";
	case 0xC0000088: return "STATUS_NOT_MAPPED_DATA";
	case 0xC0000089: return "STATUS_RESOURCE_DATA_NOT_FOUND";
	case 0xC000008A: return "STATUS_RESOURCE_TYPE_NOT_FOUND";
	case 0xC000008B: return "STATUS_RESOURCE_NAME_NOT_FOUND";
	case 0xC000008C: return "STATUS_ARRAY_BOUNDS_EXCEEDED";
	case 0xC000008D: return "STATUS_FLOAT_DENORMAL_OPERAND";
	case 0xC000008E: return "STATUS_FLOAT_DIVIDE_BY_ZERO";
	case 0xC000008F: return "STATUS_FLOAT_INEXACT_RESULT";
	case 0xC0000090: return "STATUS_FLOAT_INVALID_OPERATION";
	case 0xC0000091: return "STATUS_FLOAT_OVERFLOW";
	case 0xC0000092: return "STATUS_FLOAT_STACK_CHECK";
	case 0xC0000093: return "STATUS_FLOAT_UNDERFLOW";
	case 0xC0000094: return "STATUS_INTEGER_DIVIDE_BY_ZERO";
	case 0xC0000095: return "STATUS_INTEGER_OVERFLOW";
	case 0xC0000096: return "STATUS_PRIVILEGED_INSTRUCTION";
	case 0xC0000097: return "STATUS_TOO_MANY_PAGING_FILES";
	case 0xC0000098: return "STATUS_FILE_INVALID";
	case 0xC0000099: return "STATUS_ALLOTTED_SPACE_EXCEEDED";
	case 0xC000009A: return "STATUS_INSUFFICIENT_RESOURCES";
	case 0xC000009B: return "STATUS_DFS_EXIT_PATH_FOUND";
	case 0xC000009C: return "STATUS_DEVICE_DATA_ERROR";
	case 0xC000009D: return "STATUS_DEVICE_NOT_CONNECTED";
	case 0xC000009E: return "STATUS_DEVICE_POWER_FAILURE";
	case 0xC000009F: return "STATUS_FREE_VM_NOT_AT_BASE";
	case 0xC00000A0: return "STATUS_MEMORY_NOT_ALLOCATED";
	case 0xC00000A1: return "STATUS_WORKING_SET_QUOTA";
	case 0xC00000A2: return "STATUS_MEDIA_WRITE_PROTECTED";
	case 0xC00000A3: return "STATUS_DEVICE_NOT_READY";
	case 0xC00000A4: return "STATUS_INVALID_GROUP_ATTRIBUTES";
	case 0xC00000A5: return "STATUS_BAD_IMPERSONATION_LEVEL";
	case 0xC00000A6: return "STATUS_CANT_OPEN_ANONYMOUS";
	case 0xC00000A7: return "STATUS_BAD_VALIDATION_CLASS";
	case 0xC00000A8: return "STATUS_BAD_TOKEN_TYPE";
	case 0xC00000A9: return "STATUS_BAD_MASTER_BOOT_RECORD";
	case 0xC00000AA: return "STATUS_INSTRUCTION_MISALIGNMENT";
	case 0xC00000AB: return "STATUS_INSTANCE_NOT_AVAILABLE";
	case 0xC00000AC: return "STATUS_PIPE_NOT_AVAILABLE";
	case 0xC00000AD: return "STATUS_INVALID_PIPE_STATE";
	case 0xC00000AE: return "STATUS_PIPE_BUSY";
	case 0xC00000AF: return "STATUS_ILLEGAL_FUNCTION";
	case 0xC00000B0: return "STATUS_PIPE_DISCONNECTED";
	case 0xC00000B1: return "STATUS_PIPE_CLOSING";
	case 0xC00000B2: return "STATUS_PIPE_CONNECTED";
	case 0xC00000B3: return "STATUS_PIPE_LISTENING";
	case 0xC00000B4: return "STATUS_INVALID_READ_MODE";
	case 0xC00000B5: return "STATUS_IO_TIMEOUT";
	case 0xC00000B6: return "STATUS_FILE_FORCED_CLOSED";
	case 0xC00000B7: return "STATUS_PROFILING_NOT_STARTED";
	case 0xC00000B8: return "STATUS_PROFILING_NOT_STOPPED";
	case 0xC00000B9: return "STATUS_COULD_NOT_INTERPRET";
	case 0xC00000BA: return "STATUS_FILE_IS_A_DIRECTORY";
	case 0xC00000BB: return "STATUS_NOT_SUPPORTED";
	case 0xC00000BC: return "STATUS_REMOTE_NOT_LISTENING";
	case 0xC00000BD: return "STATUS_DUPLICATE_NAME";
	case 0xC00000BE: return "STATUS_BAD_NETWORK_PATH";
	case 0xC00000BF: return "STATUS_NETWORK_BUSY";
	case 0xC00000C0: return "STATUS_DEVICE_DOES_NOT_EXIST";
	case 0xC00000C1: return "STATUS_TOO_MANY_COMMANDS";
	case 0xC00000C2: return "STATUS_ADAPTER_HARDWARE_ERROR";
	case 0xC00000C3: return "STATUS_INVALID_NETWORK_RESPONSE";
	case 0xC00000C4: return "STATUS_UNEXPECTED_NETWORK_ERROR";
	case 0xC00000C5: return "STATUS_BAD_REMOTE_ADAPTER";
	case 0xC00000C6: return "STATUS_PRINT_QUEUE_FULL";
	case 0xC00000C7: return "STATUS_NO_SPOOL_SPACE";
	case 0xC00000C8: return "STATUS_PRINT_CANCELLED";
	case 0xC00000C9: return "STATUS_NETWORK_NAME_DELETED";
	case 0xC00000CA: return "STATUS_NETWORK_ACCESS_DENIED";
	case 0xC00000CB: return "STATUS_BAD_DEVICE_TYPE";
	case 0xC00000CC: return "STATUS_BAD_NETWORK_NAME";
	case 0xC00000CD: return "STATUS_TOO_MANY_NAMES";
	case 0xC00000CE: return "STATUS_TOO_MANY_SESSIONS";
	case 0xC00000CF: return "STATUS_SHARING_PAUSED";
	case 0xC00000D0: return "STATUS_REQUEST_NOT_ACCEPTED";
	case 0xC00000D1: return "STATUS_REDIRECTOR_PAUSED";
	case 0xC00000D2: return "STATUS_NET_WRITE_FAULT";
	case 0xC00000D3: return "STATUS_PROFILING_AT_LIMIT";
	case 0xC00000D4: return "STATUS_NOT_SAME_DEVICE";
	case 0xC00000D5: return "STATUS_FILE_RENAMED";
	case 0xC00000D6: return "STATUS_VIRTUAL_CIRCUIT_CLOSED";
	case 0xC00000D7: return "STATUS_NO_SECURITY_ON_OBJECT";
	case 0xC00000D8: return "STATUS_CANT_WAIT";
	case 0xC00000D9: return "STATUS_PIPE_EMPTY";
	case 0xC00000DA: return "STATUS_CANT_ACCESS_DOMAIN_INFO";
	case 0xC00000DB: return "STATUS_CANT_TERMINATE_SELF";
	case 0xC00000DC: return "STATUS_INVALID_SERVER_STATE";
	case 0xC00000DD: return "STATUS_INVALID_DOMAIN_STATE";
	case 0xC00000DE: return "STATUS_INVALID_DOMAIN_ROLE";
	case 0xC00000DF: return "STATUS_NO_SUCH_DOMAIN";
	case 0xC00000E0: return "STATUS_DOMAIN_EXISTS";
	case 0xC00000E1: return "STATUS_DOMAIN_LIMIT_EXCEEDED";
	case 0xC00000E2: return "STATUS_OPLOCK_NOT_GRANTED";
	case 0xC00000E3: return "STATUS_INVALID_OPLOCK_PROTOCOL";
	case 0xC00000E4: return "STATUS_INTERNAL_DB_CORRUPTION";
	case 0xC00000E5: return "STATUS_INTERNAL_ERROR";
	case 0xC00000E6: return "STATUS_GENERIC_NOT_MAPPED";
	case 0xC00000E7: return "STATUS_BAD_DESCRIPTOR_FORMAT";
	case 0xC00000E8: return "STATUS_INVALID_USER_BUFFER";
	case 0xC00000E9: return "STATUS_UNEXPECTED_IO_ERROR";
	case 0xC00000EA: return "STATUS_UNEXPECTED_MM_CREATE_ERR";
	case 0xC00000EB: return "STATUS_UNEXPECTED_MM_MAP_ERROR";
	case 0xC00000EC: return "STATUS_UNEXPECTED_MM_EXTEND_ERR";
	case 0xC00000ED: return "STATUS_NOT_LOGON_PROCESS";
	case 0xC00000EE: return "STATUS_LOGON_SESSION_EXISTS";
	case 0xC00000EF: return "STATUS_INVALID_PARAMETER_1";
	case 0xC00000F0: return "STATUS_INVALID_PARAMETER_2";
	case 0xC00000F1: return "STATUS_INVALID_PARAMETER_3";
	case 0xC00000F2: return "STATUS_INVALID_PARAMETER_4";
	case 0xC00000F3: return "STATUS_INVALID_PARAMETER_5";
	case 0xC00000F4: return "STATUS_INVALID_PARAMETER_6";
	case 0xC00000F5: return "STATUS_INVALID_PARAMETER_7";
	case 0xC00000F6: return "STATUS_INVALID_PARAMETER_8";
	case 0xC00000F7: return "STATUS_INVALID_PARAMETER_9";
	case 0xC00000F8: return "STATUS_INVALID_PARAMETER_10";
	case 0xC00000F9: return "STATUS_INVALID_PARAMETER_11";
	case 0xC00000FA: return "STATUS_INVALID_PARAMETER_12";
	case 0xC00000FB: return "STATUS_REDIRECTOR_NOT_STARTED";
	case 0xC00000FC: return "STATUS_REDIRECTOR_STARTED";
	case 0xC00000FD: return "STATUS_STACK_OVERFLOW";
	case 0xC00000FE: return "STATUS_NO_SUCH_PACKAGE";
	case 0xC00000FF: return "STATUS_BAD_FUNCTION_TABLE";
	case 0xC0000100: return "STATUS_VARIABLE_NOT_FOUND";
	case 0xC0000101: return "STATUS_DIRECTORY_NOT_EMPTY";
	case 0xC0000102: return "STATUS_FILE_CORRUPT_ERROR";
	case 0xC0000103: return "STATUS_NOT_A_DIRECTORY";
	case 0xC0000104: return "STATUS_BAD_LOGON_SESSION_STATE";
	case 0xC0000105: return "STATUS_LOGON_SESSION_COLLISION";
	case 0xC0000106: return "STATUS_NAME_TOO_LONG";
	case 0xC0000107: return "STATUS_FILES_OPEN";
	case 0xC0000108: return "STATUS_CONNECTION_IN_USE";
	case 0xC0000109: return "STATUS_MESSAGE_NOT_FOUND";
	case 0xC000010A: return "STATUS_PROCESS_IS_TERMINATING";
	case 0xC000010B: return "STATUS_INVALID_LOGON_TYPE";
	case 0xC000010C: return "STATUS_NO_GUID_TRANSLATION";
	case 0xC000010D: return "STATUS_CANNOT_IMPERSONATE";
	case 0xC000010E: return "STATUS_IMAGE_ALREADY_LOADED";
	case 0xC000010F: return "STATUS_ABIOS_NOT_PRESENT";
	case 0xC0000110: return "STATUS_ABIOS_LID_NOT_EXIST";
	case 0xC0000111: return "STATUS_ABIOS_LID_ALREADY_OWNED";
	case 0xC0000112: return "STATUS_ABIOS_NOT_LID_OWNER";
	case 0xC0000113: return "STATUS_ABIOS_INVALID_COMMAND";
	case 0xC0000114: return "STATUS_ABIOS_INVALID_LID";
	case 0xC0000115: return "STATUS_ABIOS_SELECTOR_NOT_AVAILABLE";
	case 0xC0000116: return "STATUS_ABIOS_INVALID_SELECTOR";
	case 0xC0000117: return "STATUS_NO_LDT";
	case 0xC0000118: return "STATUS_INVALID_LDT_SIZE";
	case 0xC0000119: return "STATUS_INVALID_LDT_OFFSET";
	case 0xC000011A: return "STATUS_INVALID_LDT_DESCRIPTOR";
	case 0xC000011B: return "STATUS_INVALID_IMAGE_NE_FORMAT";
	case 0xC000011C: return "STATUS_RXACT_INVALID_STATE";
	case 0xC000011D: return "STATUS_RXACT_COMMIT_FAILURE";
	case 0xC000011E: return "STATUS_MAPPED_FILE_SIZE_ZERO";
	case 0xC000011F: return "STATUS_TOO_MANY_OPENED_FILES";
	case 0xC0000120: return "STATUS_CANCELLED";
	case 0xC0000121: return "STATUS_CANNOT_DELETE";
	case 0xC0000122: return "STATUS_INVALID_COMPUTER_NAME";
	case 0xC0000123: return "STATUS_FILE_DELETED";
	case 0xC0000124: return "STATUS_SPECIAL_ACCOUNT";
	case 0xC0000125: return "STATUS_SPECIAL_GROUP";
	case 0xC0000126: return "STATUS_SPECIAL_USER";
	case 0xC0000127: return "STATUS_MEMBERS_PRIMARY_GROUP";
	case 0xC0000128: return "STATUS_FILE_CLOSED";
	case 0xC0000129: return "STATUS_TOO_MANY_THREADS";
	case 0xC000012A: return "STATUS_THREAD_NOT_IN_PROCESS";
	case 0xC000012B: return "STATUS_TOKEN_ALREADY_IN_USE";
	case 0xC000012C: return "STATUS_PAGEFILE_QUOTA_EXCEEDED";
	case 0xC000012D: return "STATUS_COMMITMENT_LIMIT";
	case 0xC000012E: return "STATUS_INVALID_IMAGE_LE_FORMAT";
	case 0xC000012F: return "STATUS_INVALID_IMAGE_NOT_MZ";
	case 0xC0000130: return "STATUS_INVALID_IMAGE_PROTECT";
	case 0xC0000131: return "STATUS_INVALID_IMAGE_WIN_16";
	case 0xC0000132: return "STATUS_LOGON_SERVER_CONFLICT";
	case 0xC0000133: return "STATUS_TIME_DIFFERENCE_AT_DC";
	case 0xC0000134: return "STATUS_SYNCHRONIZATION_REQUIRED";
	case 0xC0000135: return "STATUS_DLL_NOT_FOUND";
	case 0xC0000136: return "STATUS_OPEN_FAILED";
	case 0xC0000137: return "STATUS_IO_PRIVILEGE_FAILED";
	case 0xC0000138: return "STATUS_ORDINAL_NOT_FOUND";
	case 0xC0000139: return "STATUS_ENTRYPOINT_NOT_FOUND";
	case 0xC000013A: return "STATUS_CONTROL_C_EXIT";
	case 0xC000013B: return "STATUS_LOCAL_DISCONNECT";
	case 0xC000013C: return "STATUS_REMOTE_DISCONNECT";
	case 0xC000013D: return "STATUS_REMOTE_RESOURCES";
	case 0xC000013E: return "STATUS_LINK_FAILED";
	case 0xC000013F: return "STATUS_LINK_TIMEOUT";
	case 0xC0000140: return "STATUS_INVALID_CONNECTION";
	case 0xC0000141: return "STATUS_INVALID_ADDRESS";
	case 0xC0000142: return "STATUS_DLL_INIT_FAILED";
	case 0xC0000143: return "STATUS_MISSING_SYSTEMFILE";
	case 0xC0000144: return "STATUS_UNHANDLED_EXCEPTION";
	case 0xC0000145: return "STATUS_APP_INIT_FAILURE";
	case 0xC0000146: return "STATUS_PAGEFILE_CREATE_FAILED";
	case 0xC0000147: return "STATUS_NO_PAGEFILE";
	case 0xC0000148: return "STATUS_INVALID_LEVEL";
	case 0xC0000149: return "STATUS_WRONG_PASSWORD_CORE";
	case 0xC000014A: return "STATUS_ILLEGAL_FLOAT_CONTEXT";
	case 0xC000014B: return "STATUS_PIPE_BROKEN";
	case 0xC000014C: return "STATUS_REGISTRY_CORRUPT";
	case 0xC000014D: return "STATUS_REGISTRY_IO_FAILED";
	case 0xC000014E: return "STATUS_NO_EVENT_PAIR";
	case 0xC000014F: return "STATUS_UNRECOGNIZED_VOLUME";
	case 0xC0000150: return "STATUS_SERIAL_NO_DEVICE_INITED";
	case 0xC0000151: return "STATUS_NO_SUCH_ALIAS";
	case 0xC0000152: return "STATUS_MEMBER_NOT_IN_ALIAS";
	case 0xC0000153: return "STATUS_MEMBER_IN_ALIAS";
	case 0xC0000154: return "STATUS_ALIAS_EXISTS";
	case 0xC0000155: return "STATUS_LOGON_NOT_GRANTED";
	case 0xC0000156: return "STATUS_TOO_MANY_SECRETS";
	case 0xC0000157: return "STATUS_SECRET_TOO_LONG";
	case 0xC0000158: return "STATUS_INTERNAL_DB_ERROR";
	case 0xC0000159: return "STATUS_FULLSCREEN_MODE";
	case 0xC000015A: return "STATUS_TOO_MANY_CONTEXT_IDS";
	case 0xC000015B: return "STATUS_LOGON_TYPE_NOT_GRANTED";
	case 0xC000015C: return "STATUS_NOT_REGISTRY_FILE";
	case 0xC000015D: return "STATUS_NT_CROSS_ENCRYPTION_REQUIRED";
	case 0xC000015E: return "STATUS_DOMAIN_CTRLR_CONFIG_ERROR";
	case 0xC000015F: return "STATUS_FT_MISSING_MEMBER";
	case 0xC0000160: return "STATUS_ILL_FORMED_SERVICE_ENTRY";
	case 0xC0000161: return "STATUS_ILLEGAL_CHARACTER";
	case 0xC0000162: return "STATUS_UNMAPPABLE_CHARACTER";
	case 0xC0000163: return "STATUS_UNDEFINED_CHARACTER";
	case 0xC0000164: return "STATUS_FLOPPY_VOLUME";
	case 0xC0000165: return "STATUS_FLOPPY_ID_MARK_NOT_FOUND";
	case 0xC0000166: return "STATUS_FLOPPY_WRONG_CYLINDER";
	case 0xC0000167: return "STATUS_FLOPPY_UNKNOWN_ERROR";
	case 0xC0000168: return "STATUS_FLOPPY_BAD_REGISTERS";
	case 0xC0000169: return "STATUS_DISK_RECALIBRATE_FAILED";
	case 0xC000016A: return "STATUS_DISK_OPERATION_FAILED";
	case 0xC000016B: return "STATUS_DISK_RESET_FAILED";
	case 0xC000016C: return "STATUS_SHARED_IRQ_BUSY";
	case 0xC000016D: return "STATUS_FT_ORPHANING";
	case 0xC000016E: return "STATUS_BIOS_FAILED_TO_CONNECT_INTERRUPT";
	case 0xC0000172: return "STATUS_PARTITION_FAILURE";
	case 0xC0000173: return "STATUS_INVALID_BLOCK_LENGTH";
	case 0xC0000174: return "STATUS_DEVICE_NOT_PARTITIONED";
	case 0xC0000175: return "STATUS_UNABLE_TO_LOCK_MEDIA";
	case 0xC0000176: return "STATUS_UNABLE_TO_UNLOAD_MEDIA";
	case 0xC0000177: return "STATUS_EOM_OVERFLOW";
	case 0xC0000178: return "STATUS_NO_MEDIA";
	case 0xC000017A: return "STATUS_NO_SUCH_MEMBER";
	case 0xC000017B: return "STATUS_INVALID_MEMBER";
	case 0xC000017C: return "STATUS_KEY_DELETED";
	case 0xC000017D: return "STATUS_NO_LOG_SPACE";
	case 0xC000017E: return "STATUS_TOO_MANY_SIDS";
	case 0xC000017F: return "STATUS_LM_CROSS_ENCRYPTION_REQUIRED";
	case 0xC0000180: return "STATUS_KEY_HAS_CHILDREN";
	case 0xC0000181: return "STATUS_CHILD_MUST_BE_VOLATILE";
	case 0xC0000182: return "STATUS_DEVICE_CONFIGURATION_ERROR";
	case 0xC0000183: return "STATUS_DRIVER_INTERNAL_ERROR";
	case 0xC0000184: return "STATUS_INVALID_DEVICE_STATE";
	case 0xC0000185: return "STATUS_IO_DEVICE_ERROR";
	case 0xC0000186: return "STATUS_DEVICE_PROTOCOL_ERROR";
	case 0xC0000187: return "STATUS_BACKUP_CONTROLLER";
	case 0xC0000188: return "STATUS_LOG_FILE_FULL";
	case 0xC0000189: return "STATUS_TOO_LATE";
	case 0xC000018A: return "STATUS_NO_TRUST_LSA_SECRET";
	case 0xC000018B: return "STATUS_NO_TRUST_SAM_ACCOUNT";
	case 0xC000018C: return "STATUS_TRUSTED_DOMAIN_FAILURE";
	case 0xC000018D: return "STATUS_TRUSTED_RELATIONSHIP_FAILURE";
	case 0xC000018E: return "STATUS_EVENTLOG_FILE_CORRUPT";
	case 0xC000018F: return "STATUS_EVENTLOG_CANT_START";
	case 0xC0000190: return "STATUS_TRUST_FAILURE";
	case 0xC0000191: return "STATUS_MUTANT_LIMIT_EXCEEDED";
	case 0xC0000192: return "STATUS_NETLOGON_NOT_STARTED";
	case 0xC0000193: return "STATUS_ACCOUNT_EXPIRED";
	case 0xC0000194: return "STATUS_POSSIBLE_DEADLOCK";
	case 0xC0000195: return "STATUS_NETWORK_CREDENTIAL_CONFLICT";
	case 0xC0000196: return "STATUS_REMOTE_SESSION_LIMIT";
	case 0xC0000197: return "STATUS_EVENTLOG_FILE_CHANGED";
	case 0xC0000198: return "STATUS_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT";
	case 0xC0000199: return "STATUS_NOLOGON_WORKSTATION_TRUST_ACCOUNT";
	case 0xC000019A: return "STATUS_NOLOGON_SERVER_TRUST_ACCOUNT";
	case 0xC000019B: return "STATUS_DOMAIN_TRUST_INCONSISTENT";
	case 0xC000019C: return "STATUS_FS_DRIVER_REQUIRED";
	case 0xC000019D: return "STATUS_IMAGE_ALREADY_LOADED_AS_DLL";
	case 0xC0000201: return "STATUS_NETWORK_OPEN_RESTRICTION";
	case 0xC0000202: return "STATUS_NO_USER_SESSION_KEY";
	case 0xC0000203: return "STATUS_USER_SESSION_DELETED";
	case 0xC0000204: return "STATUS_RESOURCE_LANG_NOT_FOUND";
	case 0xC0000205: return "STATUS_INSUFF_SERVER_RESOURCES";
	case 0xC0000206: return "STATUS_INVALID_BUFFER_SIZE";
	case 0xC0000207: return "STATUS_INVALID_ADDRESS_COMPONENT";
	case 0xC0000208: return "STATUS_INVALID_ADDRESS_WILDCARD";
	case 0xC0000209: return "STATUS_TOO_MANY_ADDRESSES";
	case 0xC000020A: return "STATUS_ADDRESS_ALREADY_EXISTS";
	case 0xC000020B: return "STATUS_ADDRESS_CLOSED";
	case 0xC000020C: return "STATUS_CONNECTION_DISCONNECTED";
	case 0xC000020D: return "STATUS_CONNECTION_RESET";
	case 0xC000020E: return "STATUS_TOO_MANY_NODES";
	case 0xC000020F: return "STATUS_TRANSACTION_ABORTED";
	case 0xC0000210: return "STATUS_TRANSACTION_TIMED_OUT";
	case 0xC0000211: return "STATUS_TRANSACTION_NO_RELEASE";
	case 0xC0000212: return "STATUS_TRANSACTION_NO_MATCH";
	case 0xC0000213: return "STATUS_TRANSACTION_RESPONDED";
	case 0xC0000214: return "STATUS_TRANSACTION_INVALID_ID";
	case 0xC0000215: return "STATUS_TRANSACTION_INVALID_TYPE";
	case 0xC0000216: return "STATUS_NOT_SERVER_SESSION";
	case 0xC0000217: return "STATUS_NOT_CLIENT_SESSION";
	case 0xC0000218: return "STATUS_CANNOT_LOAD_REGISTRY_FILE";
	case 0xC0000219: return "STATUS_DEBUG_ATTACH_FAILED";
	case 0xC000021A: return "STATUS_SYSTEM_PROCESS_TERMINATED";
	case 0xC000021B: return "STATUS_DATA_NOT_ACCEPTED";
	case 0xC000021C: return "STATUS_NO_BROWSER_SERVERS_FOUND";
	case 0xC000021D: return "STATUS_VDM_HARD_ERROR";
	case 0xC000021E: return "STATUS_DRIVER_CANCEL_TIMEOUT";
	case 0xC000021F: return "STATUS_REPLY_MESSAGE_MISMATCH";
	case 0xC0000220: return "STATUS_MAPPED_ALIGNMENT";
	case 0xC0000221: return "STATUS_IMAGE_CHECKSUM_MISMATCH";
	case 0xC0000222: return "STATUS_LOST_WRITEBEHIND_DATA";
	case 0xC0000223: return "STATUS_CLIENT_SERVER_PARAMETERS_INVALID";
	case 0xC0000224: return "STATUS_PASSWORD_MUST_CHANGE";
	case 0xC0000225: return "STATUS_NOT_FOUND";
	case 0xC0000226: return "STATUS_NOT_TINY_STREAM";
	case 0xC0000227: return "STATUS_RECOVERY_FAILURE";
	case 0xC0000228: return "STATUS_STACK_OVERFLOW_READ";
	case 0xC0000229: return "STATUS_FAIL_CHECK";
	case 0xC000022A: return "STATUS_DUPLICATE_OBJECTID";
	case 0xC000022B: return "STATUS_OBJECTID_EXISTS";
	case 0xC000022C: return "STATUS_CONVERT_TO_LARGE";
	case 0xC000022D: return "STATUS_RETRY";
	case 0xC000022E: return "STATUS_FOUND_OUT_OF_SCOPE";
	case 0xC000022F: return "STATUS_ALLOCATE_BUCKET";
	case 0xC0000230: return "STATUS_PROPSET_NOT_FOUND";
	case 0xC0000231: return "STATUS_MARSHALL_OVERFLOW";
	case 0xC0000232: return "STATUS_INVALID_VARIANT";
	case 0xC0000233: return "STATUS_DOMAIN_CONTROLLER_NOT_FOUND";
	case 0xC0000234: return "STATUS_ACCOUNT_LOCKED_OUT";
	case 0xC0000235: return "STATUS_HANDLE_NOT_CLOSABLE";
	case 0xC0000236: return "STATUS_CONNECTION_REFUSED";
	case 0xC0000237: return "STATUS_GRACEFUL_DISCONNECT";
	case 0xC0000238: return "STATUS_ADDRESS_ALREADY_ASSOCIATED";
	case 0xC0000239: return "STATUS_ADDRESS_NOT_ASSOCIATED";
	case 0xC000023A: return "STATUS_CONNECTION_INVALID";
	case 0xC000023B: return "STATUS_CONNECTION_ACTIVE";
	case 0xC000023C: return "STATUS_NETWORK_UNREACHABLE";
	case 0xC000023D: return "STATUS_HOST_UNREACHABLE";
	case 0xC000023E: return "STATUS_PROTOCOL_UNREACHABLE";
	case 0xC000023F: return "STATUS_PORT_UNREACHABLE";
	case 0xC0000240: return "STATUS_REQUEST_ABORTED";
	case 0xC0000241: return "STATUS_CONNECTION_ABORTED";
	case 0xC0000242: return "STATUS_BAD_COMPRESSION_BUFFER";
	case 0xC0000243: return "STATUS_USER_MAPPED_FILE";
	case 0xC0000244: return "STATUS_AUDIT_FAILED";
	case 0xC0000245: return "STATUS_TIMER_RESOLUTION_NOT_SET";
	case 0xC0000246: return "STATUS_CONNECTION_COUNT_LIMIT";
	case 0xC0000247: return "STATUS_LOGIN_TIME_RESTRICTION";
	case 0xC0000248: return "STATUS_LOGIN_WKSTA_RESTRICTION";
	case 0xC0000249: return "STATUS_IMAGE_MP_UP_MISMATCH";
	case 0xC0000250: return "STATUS_INSUFFICIENT_LOGON_INFO";
	case 0xC0000251: return "STATUS_BAD_DLL_ENTRYPOINT";
	case 0xC0000252: return "STATUS_BAD_SERVICE_ENTRYPOINT";
	case 0xC0000253: return "STATUS_LPC_REPLY_LOST";
	case 0xC0000254: return "STATUS_IP_ADDRESS_CONFLICT1";
	case 0xC0000255: return "STATUS_IP_ADDRESS_CONFLICT2";
	case 0xC0000256: return "STATUS_REGISTRY_QUOTA_LIMIT";
	case 0xC0000257: return "STATUS_PATH_NOT_COVERED";
	case 0xC0000258: return "STATUS_NO_CALLBACK_ACTIVE";
	case 0xC0000259: return "STATUS_LICENSE_QUOTA_EXCEEDED";
	case 0xC000025A: return "STATUS_PWD_TOO_SHORT";
	case 0xC000025B: return "STATUS_PWD_TOO_RECENT";
	case 0xC000025C: return "STATUS_PWD_HISTORY_CONFLICT";
	case 0xC000025E: return "STATUS_PLUGPLAY_NO_DEVICE";
	case 0xC000025F: return "STATUS_UNSUPPORTED_COMPRESSION";
	case 0xC0000260: return "STATUS_INVALID_HW_PROFILE";
	case 0xC0000261: return "STATUS_INVALID_PLUGPLAY_DEVICE_PATH";
	case 0xC0000262: return "STATUS_DRIVER_ORDINAL_NOT_FOUND";
	case 0xC0000263: return "STATUS_DRIVER_ENTRYPOINT_NOT_FOUND";
	case 0xC0000264: return "STATUS_RESOURCE_NOT_OWNED";
	case 0xC0000265: return "STATUS_TOO_MANY_LINKS";
	case 0xC0000266: return "STATUS_QUOTA_LIST_INCONSISTENT";
	case 0xC0000267: return "STATUS_FILE_IS_OFFLINE";
	case 0xC0000268: return "STATUS_EVALUATION_EXPIRATION";
	case 0xC0000269: return "STATUS_ILLEGAL_DLL_RELOCATION";
	case 0xC000026A: return "STATUS_LICENSE_VIOLATION";
	case 0xC000026B: return "STATUS_DLL_INIT_FAILED_LOGOFF";
	case 0xC000026C: return "STATUS_DRIVER_UNABLE_TO_LOAD";
	case 0xC000026D: return "STATUS_DFS_UNAVAILABLE";
	case 0xC000026E: return "STATUS_VOLUME_DISMOUNTED";
	case 0xC000026F: return "STATUS_WX86_INTERNAL_ERROR";
	case 0xC0000270: return "STATUS_WX86_FLOAT_STACK_CHECK";
	case 0xC0000271: return "STATUS_VALIDATE_CONTINUE";
	case 0xC0000272: return "STATUS_NO_MATCH";
	case 0xC0000273: return "STATUS_NO_MORE_MATCHES";
	case 0xC0000275: return "STATUS_NOT_A_REPARSE_POINT";
	case 0xC0000276: return "STATUS_IO_REPARSE_TAG_INVALID";
	case 0xC0000277: return "STATUS_IO_REPARSE_TAG_MISMATCH";
	case 0xC0000278: return "STATUS_IO_REPARSE_DATA_INVALID";
	case 0xC0000279: return "STATUS_IO_REPARSE_TAG_NOT_HANDLED";
	case 0xC0000280: return "STATUS_REPARSE_POINT_NOT_RESOLVED";
	case 0xC0000281: return "STATUS_DIRECTORY_IS_A_REPARSE_POINT";
	case 0xC0000282: return "STATUS_RANGE_LIST_CONFLICT";
	case 0xC0000283: return "STATUS_SOURCE_ELEMENT_EMPTY";
	case 0xC0000284: return "STATUS_DESTINATION_ELEMENT_FULL";
	case 0xC0000285: return "STATUS_ILLEGAL_ELEMENT_ADDRESS";
	case 0xC0000286: return "STATUS_MAGAZINE_NOT_PRESENT";
	case 0xC0000287: return "STATUS_REINITIALIZATION_NEEDED";
	case 0xC000028A: return "STATUS_ENCRYPTION_FAILED";
	case 0xC000028B: return "STATUS_DECRYPTION_FAILED";
	case 0xC000028C: return "STATUS_RANGE_NOT_FOUND";
	case 0xC000028D: return "STATUS_NO_RECOVERY_POLICY";
	case 0xC000028E: return "STATUS_NO_EFS";
	case 0xC000028F: return "STATUS_WRONG_EFS";
	case 0xC0000290: return "STATUS_NO_USER_KEYS";
	case 0xC0000291: return "STATUS_FILE_NOT_ENCRYPTED";
	case 0xC0000292: return "STATUS_NOT_EXPORT_FORMAT";
	case 0xC0000293: return "STATUS_FILE_ENCRYPTED";
	case 0xC0000295: return "STATUS_WMI_GUID_NOT_FOUND";
	case 0xC0000296: return "STATUS_WMI_INSTANCE_NOT_FOUND";
	case 0xC0000297: return "STATUS_WMI_ITEMID_NOT_FOUND";
	case 0xC0000298: return "STATUS_WMI_TRY_AGAIN";
	case 0xC0000299: return "STATUS_SHARED_POLICY";
	case 0xC000029A: return "STATUS_POLICY_OBJECT_NOT_FOUND";
	case 0xC000029B: return "STATUS_POLICY_ONLY_IN_DS";
	case 0xC000029C: return "STATUS_VOLUME_NOT_UPGRADED";
	case 0xC000029D: return "STATUS_REMOTE_STORAGE_NOT_ACTIVE";
	case 0xC000029E: return "STATUS_REMOTE_STORAGE_MEDIA_ERROR";
	case 0xC000029F: return "STATUS_NO_TRACKING_SERVICE";
	case 0xC00002A0: return "STATUS_SERVER_SID_MISMATCH";
	case 0xC00002A1: return "STATUS_DS_NO_ATTRIBUTE_OR_VALUE";
	case 0xC00002A2: return "STATUS_DS_INVALID_ATTRIBUTE_SYNTAX";
	case 0xC00002A3: return "STATUS_DS_ATTRIBUTE_TYPE_UNDEFINED";
	case 0xC00002A4: return "STATUS_DS_ATTRIBUTE_OR_VALUE_EXISTS";
	case 0xC00002A5: return "STATUS_DS_BUSY";
	case 0xC00002A6: return "STATUS_DS_UNAVAILABLE";
	case 0xC00002A7: return "STATUS_DS_NO_RIDS_ALLOCATED";
	case 0xC00002A8: return "STATUS_DS_NO_MORE_RIDS";
	case 0xC00002A9: return "STATUS_DS_INCORRECT_ROLE_OWNER";
	case 0xC00002AA: return "STATUS_DS_RIDMGR_INIT_ERROR";
	case 0xC00002AB: return "STATUS_DS_OBJ_CLASS_VIOLATION";
	case 0xC00002AC: return "STATUS_DS_CANT_ON_NON_LEAF";
	case 0xC00002AD: return "STATUS_DS_CANT_ON_RDN";
	case 0xC00002AE: return "STATUS_DS_CANT_MOD_OBJ_CLASS";
	case 0xC00002AF: return "STATUS_DS_CROSS_DOM_MOVE_FAILED";
	case 0xC00002B0: return "STATUS_DS_GC_NOT_AVAILABLE";
	case 0xC00002B1: return "STATUS_DIRECTORY_SERVICE_REQUIRED";
	case 0xC00002B2: return "STATUS_REPARSE_ATTRIBUTE_CONFLICT";
	case 0xC00002B3: return "STATUS_CANT_ENABLE_DENY_ONLY";
	case 0xC00002B4: return "STATUS_FLOAT_MULTIPLE_FAULTS";
	case 0xC00002B5: return "STATUS_FLOAT_MULTIPLE_TRAPS";
	case 0xC00002B6: return "STATUS_DEVICE_REMOVED";
	case 0xC00002B7: return "STATUS_JOURNAL_DELETE_IN_PROGRESS";
	case 0xC00002B8: return "STATUS_JOURNAL_NOT_ACTIVE";
	case 0xC00002B9: return "STATUS_NOINTERFACE";
	case 0xC00002C1: return "STATUS_DS_ADMIN_LIMIT_EXCEEDED";
	case 0xC00002C2: return "STATUS_DRIVER_FAILED_SLEEP";
	case 0xC00002C3: return "STATUS_MUTUAL_AUTHENTICATION_FAILED";
	case 0xC00002C4: return "STATUS_CORRUPT_SYSTEM_FILE";
	case 0xC00002C5: return "STATUS_DATATYPE_MISALIGNMENT_ERROR";
	case 0xC00002C6: return "STATUS_WMI_READ_ONLY";
	case 0xC00002C7: return "STATUS_WMI_SET_FAILURE";
	case 0xC00002C8: return "STATUS_COMMITMENT_MINIMUM";
	case 0xC00002C9: return "STATUS_REG_NAT_CONSUMPTION";
	case 0xC00002CA: return "STATUS_TRANSPORT_FULL";
	case 0xC00002CB: return "STATUS_DS_SAM_INIT_FAILURE";
	case 0xC00002CC: return "STATUS_ONLY_IF_CONNECTED";
	case 0xC00002CD: return "STATUS_DS_SENSITIVE_GROUP_VIOLATION";
	case 0xC00002CE: return "STATUS_PNP_RESTART_ENUMERATION";
	case 0xC00002CF: return "STATUS_JOURNAL_ENTRY_DELETED";
	case 0xC00002D0: return "STATUS_DS_CANT_MOD_PRIMARYGROUPID";
	case 0xC00002D1: return "STATUS_SYSTEM_IMAGE_BAD_SIGNATURE";
	case 0xC00002D2: return "STATUS_PNP_REBOOT_REQUIRED";
	case 0xC00002D3: return "STATUS_POWER_STATE_INVALID";
	case 0xC00002D4: return "STATUS_DS_INVALID_GROUP_TYPE";
	case 0xC00002D5: return "STATUS_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN";
	case 0xC00002D6: return "STATUS_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN";
	case 0xC00002D7: return "STATUS_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER";
	case 0xC00002D8: return "STATUS_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER";
	case 0xC00002D9: return "STATUS_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER";
	case 0xC00002DA: return "STATUS_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER";
	case 0xC00002DB: return "STATUS_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER";
	case 0xC00002DC: return "STATUS_DS_HAVE_PRIMARY_MEMBERS";
	case 0xC00002DD: return "STATUS_WMI_NOT_SUPPORTED";
	case 0xC00002DE: return "STATUS_INSUFFICIENT_POWER";
	case 0xC00002DF: return "STATUS_SAM_NEED_BOOTKEY_PASSWORD";
	case 0xC00002E0: return "STATUS_SAM_NEED_BOOTKEY_FLOPPY";
	case 0xC00002E1: return "STATUS_DS_CANT_START";
	case 0xC00002E2: return "STATUS_DS_INIT_FAILURE";
	case 0xC00002E3: return "STATUS_SAM_INIT_FAILURE";
	case 0xC00002E4: return "STATUS_DS_GC_REQUIRED";
	case 0xC00002E5: return "STATUS_DS_LOCAL_MEMBER_OF_LOCAL_ONLY";
	case 0xC00002E6: return "STATUS_DS_NO_FPO_IN_UNIVERSAL_GROUPS";
	case 0xC00002E7: return "STATUS_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED";
	case 0xC00002E8: return "STATUS_MULTIPLE_FAULT_VIOLATION";
	case 0xC00002E9: return "STATUS_CURRENT_DOMAIN_NOT_ALLOWED";
	case 0xC00002EA: return "STATUS_CANNOT_MAKE";
	case 0xC00002EB: return "STATUS_SYSTEM_SHUTDOWN";
	case 0xC00002EC: return "STATUS_DS_INIT_FAILURE_CONSOLE";
	case 0xC00002ED: return "STATUS_DS_SAM_INIT_FAILURE_CONSOLE";
	case 0xC00002EE: return "STATUS_UNFINISHED_CONTEXT_DELETED";
	case 0xC00002EF: return "STATUS_NO_TGT_REPLY";
	case 0xC00002F0: return "STATUS_OBJECTID_NOT_FOUND";
	case 0xC00002F1: return "STATUS_NO_IP_ADDRESSES";
	case 0xC00002F2: return "STATUS_WRONG_CREDENTIAL_HANDLE";
	case 0xC00002F3: return "STATUS_CRYPTO_SYSTEM_INVALID";
	case 0xC00002F4: return "STATUS_MAX_REFERRALS_EXCEEDED";
	case 0xC00002F5: return "STATUS_MUST_BE_KDC";
	case 0xC00002F6: return "STATUS_STRONG_CRYPTO_NOT_SUPPORTED";
	case 0xC00002F7: return "STATUS_TOO_MANY_PRINCIPALS";
	case 0xC00002F8: return "STATUS_NO_PA_DATA";
	case 0xC00002F9: return "STATUS_PKINIT_NAME_MISMATCH";
	case 0xC00002FA: return "STATUS_SMARTCARD_LOGON_REQUIRED";
	case 0xC00002FB: return "STATUS_KDC_INVALID_REQUEST";
	case 0xC00002FC: return "STATUS_KDC_UNABLE_TO_REFER";
	case 0xC00002FD: return "STATUS_KDC_UNKNOWN_ETYPE";
	case 0xC00002FE: return "STATUS_SHUTDOWN_IN_PROGRESS";
	case 0xC00002FF: return "STATUS_SERVER_SHUTDOWN_IN_PROGRESS";
	case 0xC0000300: return "STATUS_NOT_SUPPORTED_ON_SBS";
	case 0xC0000301: return "STATUS_WMI_GUID_DISCONNECTED";
	case 0xC0000302: return "STATUS_WMI_ALREADY_DISABLED";
	case 0xC0000303: return "STATUS_WMI_ALREADY_ENABLED";
	case 0xC0000304: return "STATUS_MFT_TOO_FRAGMENTED";
	case 0xC0000305: return "STATUS_COPY_PROTECTION_FAILURE";
	case 0xC0000306: return "STATUS_CSS_AUTHENTICATION_FAILURE";
	case 0xC0000307: return "STATUS_CSS_KEY_NOT_PRESENT";
	case 0xC0000308: return "STATUS_CSS_KEY_NOT_ESTABLISHED";
	case 0xC0000309: return "STATUS_CSS_SCRAMBLED_SECTOR";
	case 0xC000030A: return "STATUS_CSS_REGION_MISMATCH";
	case 0xC000030B: return "STATUS_CSS_RESETS_EXHAUSTED";
	case 0xC0000320: return "STATUS_PKINIT_FAILURE";
	case 0xC0000321: return "STATUS_SMARTCARD_SUBSYSTEM_FAILURE";
	case 0xC0000322: return "STATUS_NO_KERB_KEY";
	case 0xC0000350: return "STATUS_HOST_DOWN";
	case 0xC0000351: return "STATUS_UNSUPPORTED_PREAUTH";
	case 0xC0000352: return "STATUS_EFS_ALG_BLOB_TOO_BIG";
	case 0xC0000353: return "STATUS_PORT_NOT_SET";
	case 0xC0000354: return "STATUS_DEBUGGER_INACTIVE";
	case 0xC0000355: return "STATUS_DS_VERSION_CHECK_FAILURE";
	case 0xC0000356: return "STATUS_AUDITING_DISABLED";
	case 0xC0000357: return "STATUS_PRENT4_MACHINE_ACCOUNT";
	case 0xC0000358: return "STATUS_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER";
	case 0xC0000359: return "STATUS_INVALID_IMAGE_WIN_32";
	case 0xC000035A: return "STATUS_INVALID_IMAGE_WIN_64";
	case 0xC000035B: return "STATUS_BAD_BINDINGS";
	case 0xC000035C: return "STATUS_NETWORK_SESSION_EXPIRED";
	case 0xC000035D: return "STATUS_APPHELP_BLOCK";
	case 0xC000035E: return "STATUS_ALL_SIDS_FILTERED";
	case 0xC000035F: return "STATUS_NOT_SAFE_MODE_DRIVER";
	case 0xC0000361: return "STATUS_ACCESS_DISABLED_BY_POLICY_DEFAULT";
	case 0xC0000362: return "STATUS_ACCESS_DISABLED_BY_POLICY_PATH";
	case 0xC0000363: return "STATUS_ACCESS_DISABLED_BY_POLICY_PUBLISHER";
	case 0xC0000364: return "STATUS_ACCESS_DISABLED_BY_POLICY_OTHER";
	case 0xC0000365: return "STATUS_FAILED_DRIVER_ENTRY";
	case 0xC0000366: return "STATUS_DEVICE_ENUMERATION_ERROR";
	case 0xC0000368: return "STATUS_MOUNT_POINT_NOT_RESOLVED";
	case 0xC0000369: return "STATUS_INVALID_DEVICE_OBJECT_PARAMETER";
	case 0xC000036A: return "STATUS_MCA_OCCURED";
	case 0xC000036B: return "STATUS_DRIVER_BLOCKED_CRITICAL";
	case 0xC000036C: return "STATUS_DRIVER_BLOCKED";
	case 0xC000036D: return "STATUS_DRIVER_DATABASE_ERROR";
	case 0xC000036E: return "STATUS_SYSTEM_HIVE_TOO_LARGE";
	case 0xC000036F: return "STATUS_INVALID_IMPORT_OF_NON_DLL";
	case 0xC0000371: return "STATUS_NO_SECRETS";
	case 0xC0000372: return "STATUS_ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY";
	case 0xC0000373: return "STATUS_FAILED_STACK_SWITCH";
	case 0xC0000374: return "STATUS_HEAP_CORRUPTION";
	case 0xC0000380: return "STATUS_SMARTCARD_WRONG_PIN";
	case 0xC0000381: return "STATUS_SMARTCARD_CARD_BLOCKED";
	case 0xC0000382: return "STATUS_SMARTCARD_CARD_NOT_AUTHENTICATED";
	case 0xC0000383: return "STATUS_SMARTCARD_NO_CARD";
	case 0xC0000384: return "STATUS_SMARTCARD_NO_KEY_CONTAINER";
	case 0xC0000385: return "STATUS_SMARTCARD_NO_CERTIFICATE";
	case 0xC0000386: return "STATUS_SMARTCARD_NO_KEYSET";
	case 0xC0000387: return "STATUS_SMARTCARD_IO_ERROR";
	case 0xC0000388: return "STATUS_DOWNGRADE_DETECTED";
	case 0xC0000389: return "STATUS_SMARTCARD_CERT_REVOKED";
	case 0xC000038A: return "STATUS_ISSUING_CA_UNTRUSTED";
	case 0xC000038B: return "STATUS_REVOCATION_OFFLINE_C";
	case 0xC000038C: return "STATUS_PKINIT_CLIENT_FAILURE";
	case 0xC000038D: return "STATUS_SMARTCARD_CERT_EXPIRED";
	case 0xC000038E: return "STATUS_DRIVER_FAILED_PRIOR_UNLOAD";
	case 0xC000038F: return "STATUS_SMARTCARD_SILENT_CONTEXT";
	case 0xC0000401: return "STATUS_PER_USER_TRUST_QUOTA_EXCEEDED";
	case 0xC0000402: return "STATUS_ALL_USER_TRUST_QUOTA_EXCEEDED";
	case 0xC0000403: return "STATUS_USER_DELETE_TRUST_QUOTA_EXCEEDED";
	case 0xC0000404: return "STATUS_DS_NAME_NOT_UNIQUE";
	case 0xC0000405: return "STATUS_DS_DUPLICATE_ID_FOUND";
	case 0xC0000406: return "STATUS_DS_GROUP_CONVERSION_ERROR";
	case 0xC0000407: return "STATUS_VOLSNAP_PREPARE_HIBERNATE";
	case 0xC0000408: return "STATUS_USER2USER_REQUIRED";
	case 0xC0000409: return "STATUS_STACK_BUFFER_OVERRUN";
	case 0xC000040A: return "STATUS_NO_S4U_PROT_SUPPORT";
	case 0xC000040B: return "STATUS_CROSSREALM_DELEGATION_FAILURE";
	case 0xC000040C: return "STATUS_REVOCATION_OFFLINE_KDC";
	case 0xC000040D: return "STATUS_ISSUING_CA_UNTRUSTED_KDC";
	case 0xC000040E: return "STATUS_KDC_CERT_EXPIRED";
	case 0xC000040F: return "STATUS_KDC_CERT_REVOKED";
	case 0xC0000410: return "STATUS_PARAMETER_QUOTA_EXCEEDED";
	case 0xC0000411: return "STATUS_HIBERNATION_FAILURE";
	case 0xC0000412: return "STATUS_DELAY_LOAD_FAILED";
	case 0xC0000413: return "STATUS_AUTHENTICATION_FIREWALL_FAILED";
	case 0xC0000414: return "STATUS_VDM_DISALLOWED";
	case 0xC0000415: return "STATUS_HUNG_DISPLAY_DRIVER_THREAD";
	case 0xC0000416: return "STATUS_INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE";
	case 0xC0000417: return "STATUS_INVALID_CRUNTIME_PARAMETER";
	case 0xC0000420: return "STATUS_NTLM_BLOCKED";
	case 0xC0000423: return "STATUS_VERIFIER_STOP";
	case 0xC0000424: return "STATUS_INCOMPATIBLE_DRIVER_BLOCKED";
	case 0xC0000425: return "STATUS_HIVE_UNLOADED";
	case 0xC0000426: return "STATUS_COMPRESSION_DISABLED";
	case 0xC0000427: return "STATUS_FILE_SYSTEM_LIMITATION";
	case 0xC0000428: return "STATUS_INVALID_IMAGE_HASH";
	case 0xC0000429: return "STATUS_NOT_CAPABLE";
	case 0xC000042A: return "STATUS_REQUEST_OUT_OF_SEQUENCE";
	case 0xC000042B: return "STATUS_IMPLEMENTATION_LIMIT";
	case 0xC000042C: return "STATUS_ELEVATION_REQUIRED";
	case 0xC0000432: return "STATUS_BEYOND_VDL";
	case 0xC0000433: return "STATUS_ENCOUNTERED_WRITE_IN_PROGRESS";
	case 0xC0000434: return "STATUS_PTE_CHANGED";
	case 0xC0000435: return "STATUS_PURGE_FAILED";
	case 0xC0000440: return "STATUS_CRED_REQUIRES_CONFIRMATION";
	case 0xC0000441: return "STATUS_CS_ENCRYPTION_INVALID_SERVER_RESPONSE";
	case 0xC0000442: return "STATUS_CS_ENCRYPTION_UNSUPPORTED_SERVER";
	case 0xC0000443: return "STATUS_CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE";
	case 0xC0000444: return "STATUS_CS_ENCRYPTION_NEW_ENCRYPTED_FILE";
	case 0xC0000445: return "STATUS_CS_ENCRYPTION_FILE_NOT_CSE";
	case 0xC0000446: return "STATUS_INVALID_LABEL";
	case 0xC0000450: return "STATUS_DRIVER_PROCESS_TERMINATED";
	case 0xC0000451: return "STATUS_AMBIGUOUS_SYSTEM_DEVICE";
	case 0xC0000452: return "STATUS_SYSTEM_DEVICE_NOT_FOUND";
	case 0xC0000453: return "STATUS_RESTART_BOOT_APPLICATION";
	case 0xC0000500: return "STATUS_INVALID_TASK_NAME";
	case 0xC0000501: return "STATUS_INVALID_TASK_INDEX";
	case 0xC0000502: return "STATUS_THREAD_ALREADY_IN_TASK";
	case 0xC0000503: return "STATUS_CALLBACK_BYPASS";
	case 0xC0000700: return "STATUS_PORT_CLOSED";
	case 0xC0000701: return "STATUS_MESSAGE_LOST";
	case 0xC0000702: return "STATUS_INVALID_MESSAGE";
	case 0xC0000703: return "STATUS_REQUEST_CANCELED";
	case 0xC0000704: return "STATUS_RECURSIVE_DISPATCH";
	case 0xC0000705: return "STATUS_LPC_RECEIVE_BUFFER_EXPECTED";
	case 0xC0000706: return "STATUS_LPC_INVALID_CONNECTION_USAGE";
	case 0xC0000707: return "STATUS_LPC_REQUESTS_NOT_ALLOWED";
	case 0xC0000708: return "STATUS_RESOURCE_IN_USE";
	case 0xC0000709: return "STATUS_HARDWARE_MEMORY_ERROR";
	case 0xC000070A: return "STATUS_THREADPOOL_HANDLE_EXCEPTION";
	case 0xC000070B: return "STATUS_THREADPOOL_SET_EVENT_ON_COMPLETION_FAILED";
	case 0xC000070C: return "STATUS_THREADPOOL_RELEASE_SEMAPHORE_ON_COMPLETION_FAILED";
	case 0xC000070D: return "STATUS_THREADPOOL_RELEASE_MUTEX_ON_COMPLETION_FAILED";
	case 0xC000070E: return "STATUS_THREADPOOL_FREE_LIBRARY_ON_COMPLETION_FAILED";
	case 0xC000070F: return "STATUS_THREADPOOL_RELEASED_DURING_OPERATION";
	case 0xC0000710: return "STATUS_CALLBACK_RETURNED_WHILE_IMPERSONATING";
	case 0xC0000711: return "STATUS_APC_RETURNED_WHILE_IMPERSONATING";
	case 0xC0000712: return "STATUS_PROCESS_IS_PROTECTED";
	case 0xC0000713: return "STATUS_MCA_EXCEPTION";
	case 0xC0000714: return "STATUS_CERTIFICATE_MAPPING_NOT_UNIQUE";
	case 0xC0000715: return "STATUS_SYMLINK_CLASS_DISABLED";
	case 0xC0000716: return "STATUS_INVALID_IDN_NORMALIZATION";
	case 0xC0000717: return "STATUS_NO_UNICODE_TRANSLATION";
	case 0xC0000718: return "STATUS_ALREADY_REGISTERED";
	case 0xC0000719: return "STATUS_CONTEXT_MISMATCH";
	case 0xC000071A: return "STATUS_PORT_ALREADY_HAS_COMPLETION_LIST";
	case 0xC000071B: return "STATUS_CALLBACK_RETURNED_THREAD_PRIORITY";
	case 0xC000071C: return "STATUS_INVALID_THREAD";
	case 0xC000071D: return "STATUS_CALLBACK_RETURNED_TRANSACTION";
	case 0xC000071E: return "STATUS_CALLBACK_RETURNED_LDR_LOCK";
	case 0xC000071F: return "STATUS_CALLBACK_RETURNED_LANG";
	case 0xC0000720: return "STATUS_CALLBACK_RETURNED_PRI_BACK";
	case 0xC0000721: return "STATUS_CALLBACK_RETURNED_THREAD_AFFINITY";
	case 0xC0000800: return "STATUS_DISK_REPAIR_DISABLED";
	case 0xC0000801: return "STATUS_DS_DOMAIN_RENAME_IN_PROGRESS";
	case 0xC0000802: return "STATUS_DISK_QUOTA_EXCEEDED";
	case 0xC0000804: return "STATUS_CONTENT_BLOCKED";
	case 0xC0000805: return "STATUS_BAD_CLUSTERS";
	case 0xC0000806: return "STATUS_VOLUME_DIRTY";
	case 0xC0000901: return "STATUS_FILE_CHECKED_OUT";
	case 0xC0000902: return "STATUS_CHECKOUT_REQUIRED";
	case 0xC0000903: return "STATUS_BAD_FILE_TYPE";
	case 0xC0000904: return "STATUS_FILE_TOO_LARGE";
	case 0xC0000905: return "STATUS_FORMS_AUTH_REQUIRED";
	case 0xC0000906: return "STATUS_VIRUS_INFECTED";
	case 0xC0000907: return "STATUS_VIRUS_DELETED";
	case 0xC0000908: return "STATUS_BAD_MCFG_TABLE";
	case 0xC0009898: return "STATUS_WOW_ASSERTION";
	case 0xC000A000: return "STATUS_INVALID_SIGNATURE";
	case 0xC000A001: return "STATUS_HMAC_NOT_SUPPORTED";
	case 0xC000A010: return "STATUS_IPSEC_QUEUE_OVERFLOW";
	case 0xC000A011: return "STATUS_ND_QUEUE_OVERFLOW";
	case 0xC000A012: return "STATUS_HOPLIMIT_EXCEEDED";
	case 0xC000A013: return "STATUS_PROTOCOL_NOT_SUPPORTED";
	case 0xC000A080: return "STATUS_LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED";
	case 0xC000A081: return "STATUS_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR";
	case 0xC000A082: return "STATUS_LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR";
	case 0xC000A083: return "STATUS_XML_PARSE_ERROR";
	case 0xC000A084: return "STATUS_XMLDSIG_ERROR";
	case 0xC000A085: return "STATUS_WRONG_COMPARTMENT";
	case 0xC000A086: return "STATUS_AUTHIP_FAILURE";
	case 0xC0010001: return "DBG_NO_STATE_CHANGE";
	case 0xC0010002: return "DBG_APP_NOT_IDLE";
	case 0xC0020001: return "RPC_NT_INVALID_STRING_BINDING";
	case 0xC0020002: return "RPC_NT_WRONG_KIND_OF_BINDING";
	case 0xC0020003: return "RPC_NT_INVALID_BINDING";
	case 0xC0020004: return "RPC_NT_PROTSEQ_NOT_SUPPORTED";
	case 0xC0020005: return "RPC_NT_INVALID_RPC_PROTSEQ";
	case 0xC0020006: return "RPC_NT_INVALID_STRING_UUID";
	case 0xC0020007: return "RPC_NT_INVALID_ENDPOINT_FORMAT";
	case 0xC0020008: return "RPC_NT_INVALID_NET_ADDR";
	case 0xC0020009: return "RPC_NT_NO_ENDPOINT_FOUND";
	case 0xC002000A: return "RPC_NT_INVALID_TIMEOUT";
	case 0xC002000B: return "RPC_NT_OBJECT_NOT_FOUND";
	case 0xC002000C: return "RPC_NT_ALREADY_REGISTERED";
	case 0xC002000D: return "RPC_NT_TYPE_ALREADY_REGISTERED";
	case 0xC002000E: return "RPC_NT_ALREADY_LISTENING";
	case 0xC002000F: return "RPC_NT_NO_PROTSEQS_REGISTERED";
	case 0xC0020010: return "RPC_NT_NOT_LISTENING";
	case 0xC0020011: return "RPC_NT_UNKNOWN_MGR_TYPE";
	case 0xC0020012: return "RPC_NT_UNKNOWN_IF";
	case 0xC0020013: return "RPC_NT_NO_BINDINGS";
	case 0xC0020014: return "RPC_NT_NO_PROTSEQS";
	case 0xC0020015: return "RPC_NT_CANT_CREATE_ENDPOINT";
	case 0xC0020016: return "RPC_NT_OUT_OF_RESOURCES";
	case 0xC0020017: return "RPC_NT_SERVER_UNAVAILABLE";
	case 0xC0020018: return "RPC_NT_SERVER_TOO_BUSY";
	case 0xC0020019: return "RPC_NT_INVALID_NETWORK_OPTIONS";
	case 0xC002001A: return "RPC_NT_NO_CALL_ACTIVE";
	case 0xC002001B: return "RPC_NT_CALL_FAILED";
	case 0xC002001C: return "RPC_NT_CALL_FAILED_DNE";
	case 0xC002001D: return "RPC_NT_PROTOCOL_ERROR";
	case 0xC002001F: return "RPC_NT_UNSUPPORTED_TRANS_SYN";
	case 0xC0020021: return "RPC_NT_UNSUPPORTED_TYPE";
	case 0xC0020022: return "RPC_NT_INVALID_TAG";
	case 0xC0020023: return "RPC_NT_INVALID_BOUND";
	case 0xC0020024: return "RPC_NT_NO_ENTRY_NAME";
	case 0xC0020025: return "RPC_NT_INVALID_NAME_SYNTAX";
	case 0xC0020026: return "RPC_NT_UNSUPPORTED_NAME_SYNTAX";
	case 0xC0020028: return "RPC_NT_UUID_NO_ADDRESS";
	case 0xC0020029: return "RPC_NT_DUPLICATE_ENDPOINT";
	case 0xC002002A: return "RPC_NT_UNKNOWN_AUTHN_TYPE";
	case 0xC002002B: return "RPC_NT_MAX_CALLS_TOO_SMALL";
	case 0xC002002C: return "RPC_NT_STRING_TOO_LONG";
	case 0xC002002D: return "RPC_NT_PROTSEQ_NOT_FOUND";
	case 0xC002002E: return "RPC_NT_PROCNUM_OUT_OF_RANGE";
	case 0xC002002F: return "RPC_NT_BINDING_HAS_NO_AUTH";
	case 0xC0020030: return "RPC_NT_UNKNOWN_AUTHN_SERVICE";
	case 0xC0020031: return "RPC_NT_UNKNOWN_AUTHN_LEVEL";
	case 0xC0020032: return "RPC_NT_INVALID_AUTH_IDENTITY";
	case 0xC0020033: return "RPC_NT_UNKNOWN_AUTHZ_SERVICE";
	case 0xC0020034: return "EPT_NT_INVALID_ENTRY";
	case 0xC0020035: return "EPT_NT_CANT_PERFORM_OP";
	case 0xC0020036: return "EPT_NT_NOT_REGISTERED";
	case 0xC0020037: return "RPC_NT_NOTHING_TO_EXPORT";
	case 0xC0020038: return "RPC_NT_INCOMPLETE_NAME";
	case 0xC0020039: return "RPC_NT_INVALID_VERS_OPTION";
	case 0xC002003A: return "RPC_NT_NO_MORE_MEMBERS";
	case 0xC002003B: return "RPC_NT_NOT_ALL_OBJS_UNEXPORTED";
	case 0xC002003C: return "RPC_NT_INTERFACE_NOT_FOUND";
	case 0xC002003D: return "RPC_NT_ENTRY_ALREADY_EXISTS";
	case 0xC002003E: return "RPC_NT_ENTRY_NOT_FOUND";
	case 0xC002003F: return "RPC_NT_NAME_SERVICE_UNAVAILABLE";
	case 0xC0020040: return "RPC_NT_INVALID_NAF_ID";
	case 0xC0020041: return "RPC_NT_CANNOT_SUPPORT";
	case 0xC0020042: return "RPC_NT_NO_CONTEXT_AVAILABLE";
	case 0xC0020043: return "RPC_NT_INTERNAL_ERROR";
	case 0xC0020044: return "RPC_NT_ZERO_DIVIDE";
	case 0xC0020045: return "RPC_NT_ADDRESS_ERROR";
	case 0xC0020046: return "RPC_NT_FP_DIV_ZERO";
	case 0xC0020047: return "RPC_NT_FP_UNDERFLOW";
	case 0xC0020048: return "RPC_NT_FP_OVERFLOW";
	case 0xC0020049: return "RPC_NT_CALL_IN_PROGRESS";
	case 0xC002004A: return "RPC_NT_NO_MORE_BINDINGS";
	case 0xC002004B: return "RPC_NT_GROUP_MEMBER_NOT_FOUND";
	case 0xC002004C: return "EPT_NT_CANT_CREATE";
	case 0xC002004D: return "RPC_NT_INVALID_OBJECT";
	case 0xC002004F: return "RPC_NT_NO_INTERFACES";
	case 0xC0020050: return "RPC_NT_CALL_CANCELLED";
	case 0xC0020051: return "RPC_NT_BINDING_INCOMPLETE";
	case 0xC0020052: return "RPC_NT_COMM_FAILURE";
	case 0xC0020053: return "RPC_NT_UNSUPPORTED_AUTHN_LEVEL";
	case 0xC0020054: return "RPC_NT_NO_PRINC_NAME";
	case 0xC0020055: return "RPC_NT_NOT_RPC_ERROR";
	case 0xC0020057: return "RPC_NT_SEC_PKG_ERROR";
	case 0xC0020058: return "RPC_NT_NOT_CANCELLED";
	case 0xC0020062: return "RPC_NT_INVALID_ASYNC_HANDLE";
	case 0xC0020063: return "RPC_NT_INVALID_ASYNC_CALL";
	case 0xC0020064: return "RPC_NT_PROXY_ACCESS_DENIED";
	case 0xC0030001: return "RPC_NT_NO_MORE_ENTRIES";
	case 0xC0030002: return "RPC_NT_SS_CHAR_TRANS_OPEN_FAIL";
	case 0xC0030003: return "RPC_NT_SS_CHAR_TRANS_SHORT_FILE";
	case 0xC0030004: return "RPC_NT_SS_IN_NULL_CONTEXT";
	case 0xC0030005: return "RPC_NT_SS_CONTEXT_MISMATCH";
	case 0xC0030006: return "RPC_NT_SS_CONTEXT_DAMAGED";
	case 0xC0030007: return "RPC_NT_SS_HANDLES_MISMATCH";
	case 0xC0030008: return "RPC_NT_SS_CANNOT_GET_CALL_HANDLE";
	case 0xC0030009: return "RPC_NT_NULL_REF_POINTER";
	case 0xC003000A: return "RPC_NT_ENUM_VALUE_OUT_OF_RANGE";
	case 0xC003000B: return "RPC_NT_BYTE_COUNT_TOO_SMALL";
	case 0xC003000C: return "RPC_NT_BAD_STUB_DATA";
	case 0xC0030059: return "RPC_NT_INVALID_ES_ACTION";
	case 0xC003005A: return "RPC_NT_WRONG_ES_VERSION";
	case 0xC003005B: return "RPC_NT_WRONG_STUB_VERSION";
	case 0xC003005C: return "RPC_NT_INVALID_PIPE_OBJECT";
	case 0xC003005D: return "RPC_NT_INVALID_PIPE_OPERATION";
	case 0xC003005E: return "RPC_NT_WRONG_PIPE_VERSION";
	case 0xC003005F: return "RPC_NT_PIPE_CLOSED";
	case 0xC0030060: return "RPC_NT_PIPE_DISCIPLINE_ERROR";
	case 0xC0030061: return "RPC_NT_PIPE_EMPTY";
	case 0xC0040035: return "STATUS_PNP_BAD_MPS_TABLE";
	case 0xC0040036: return "STATUS_PNP_TRANSLATION_FAILED";
	case 0xC0040037: return "STATUS_PNP_IRQ_TRANSLATION_FAILED";
	case 0xC0040038: return "STATUS_PNP_INVALID_ID";
	case 0xC0040039: return "STATUS_IO_REISSUE_AS_CACHED";
	case 0xC00A0001: return "STATUS_CTX_WINSTATION_NAME_INVALID";
	case 0xC00A0002: return "STATUS_CTX_INVALID_PD";
	case 0xC00A0003: return "STATUS_CTX_PD_NOT_FOUND";
	case 0xC00A0006: return "STATUS_CTX_CLOSE_PENDING";
	case 0xC00A0007: return "STATUS_CTX_NO_OUTBUF";
	case 0xC00A0008: return "STATUS_CTX_MODEM_INF_NOT_FOUND";
	case 0xC00A0009: return "STATUS_CTX_INVALID_MODEMNAME";
	case 0xC00A000A: return "STATUS_CTX_RESPONSE_ERROR";
	case 0xC00A000B: return "STATUS_CTX_MODEM_RESPONSE_TIMEOUT";
	case 0xC00A000C: return "STATUS_CTX_MODEM_RESPONSE_NO_CARRIER";
	case 0xC00A000D: return "STATUS_CTX_MODEM_RESPONSE_NO_DIALTONE";
	case 0xC00A000E: return "STATUS_CTX_MODEM_RESPONSE_BUSY";
	case 0xC00A000F: return "STATUS_CTX_MODEM_RESPONSE_VOICE";
	case 0xC00A0010: return "STATUS_CTX_TD_ERROR";
	case 0xC00A0012: return "STATUS_CTX_LICENSE_CLIENT_INVALID";
	case 0xC00A0013: return "STATUS_CTX_LICENSE_NOT_AVAILABLE";
	case 0xC00A0014: return "STATUS_CTX_LICENSE_EXPIRED";
	case 0xC00A0015: return "STATUS_CTX_WINSTATION_NOT_FOUND";
	case 0xC00A0016: return "STATUS_CTX_WINSTATION_NAME_COLLISION";
	case 0xC00A0017: return "STATUS_CTX_WINSTATION_BUSY";
	case 0xC00A0018: return "STATUS_CTX_BAD_VIDEO_MODE";
	case 0xC00A0022: return "STATUS_CTX_GRAPHICS_INVALID";
	case 0xC00A0024: return "STATUS_CTX_NOT_CONSOLE";
	case 0xC00A0026: return "STATUS_CTX_CLIENT_QUERY_TIMEOUT";
	case 0xC00A0027: return "STATUS_CTX_CONSOLE_DISCONNECT";
	case 0xC00A0028: return "STATUS_CTX_CONSOLE_CONNECT";
	case 0xC00A002A: return "STATUS_CTX_SHADOW_DENIED";
	case 0xC00A002B: return "STATUS_CTX_WINSTATION_ACCESS_DENIED";
	case 0xC00A002E: return "STATUS_CTX_INVALID_WD";
	case 0xC00A002F: return "STATUS_CTX_WD_NOT_FOUND";
	case 0xC00A0030: return "STATUS_CTX_SHADOW_INVALID";
	case 0xC00A0031: return "STATUS_CTX_SHADOW_DISABLED";
	case 0xC00A0032: return "STATUS_RDP_PROTOCOL_ERROR";
	case 0xC00A0033: return "STATUS_CTX_CLIENT_LICENSE_NOT_SET";
	case 0xC00A0034: return "STATUS_CTX_CLIENT_LICENSE_IN_USE";
	case 0xC00A0035: return "STATUS_CTX_SHADOW_ENDED_BY_MODE_CHANGE";
	case 0xC00A0036: return "STATUS_CTX_SHADOW_NOT_RUNNING";
	case 0xC00A0037: return "STATUS_CTX_LOGON_DISABLED";
	case 0xC00A0038: return "STATUS_CTX_SECURITY_LAYER_ERROR";
	case 0xC00A0039: return "STATUS_TS_INCOMPATIBLE_SESSIONS";
	case 0xC00B0001: return "STATUS_MUI_FILE_NOT_FOUND";
	case 0xC00B0002: return "STATUS_MUI_INVALID_FILE";
	case 0xC00B0003: return "STATUS_MUI_INVALID_RC_CONFIG";
	case 0xC00B0004: return "STATUS_MUI_INVALID_LOCALE_NAME";
	case 0xC00B0005: return "STATUS_MUI_INVALID_ULTIMATEFALLBACK_NAME";
	case 0xC00B0006: return "STATUS_MUI_FILE_NOT_LOADED";
	case 0xC00B0007: return "STATUS_RESOURCE_ENUM_USER_STOP";
	case 0xC0130001: return "STATUS_CLUSTER_INVALID_NODE";
	case 0xC0130002: return "STATUS_CLUSTER_NODE_EXISTS";
	case 0xC0130003: return "STATUS_CLUSTER_JOIN_IN_PROGRESS";
	case 0xC0130004: return "STATUS_CLUSTER_NODE_NOT_FOUND";
	case 0xC0130005: return "STATUS_CLUSTER_LOCAL_NODE_NOT_FOUND";
	case 0xC0130006: return "STATUS_CLUSTER_NETWORK_EXISTS";
	case 0xC0130007: return "STATUS_CLUSTER_NETWORK_NOT_FOUND";
	case 0xC0130008: return "STATUS_CLUSTER_NETINTERFACE_EXISTS";
	case 0xC0130009: return "STATUS_CLUSTER_NETINTERFACE_NOT_FOUND";
	case 0xC013000A: return "STATUS_CLUSTER_INVALID_REQUEST";
	case 0xC013000B: return "STATUS_CLUSTER_INVALID_NETWORK_PROVIDER";
	case 0xC013000C: return "STATUS_CLUSTER_NODE_DOWN";
	case 0xC013000D: return "STATUS_CLUSTER_NODE_UNREACHABLE";
	case 0xC013000E: return "STATUS_CLUSTER_NODE_NOT_MEMBER";
	case 0xC013000F: return "STATUS_CLUSTER_JOIN_NOT_IN_PROGRESS";
	case 0xC0130010: return "STATUS_CLUSTER_INVALID_NETWORK";
	case 0xC0130011: return "STATUS_CLUSTER_NO_NET_ADAPTERS";
	case 0xC0130012: return "STATUS_CLUSTER_NODE_UP";
	case 0xC0130013: return "STATUS_CLUSTER_NODE_PAUSED";
	case 0xC0130014: return "STATUS_CLUSTER_NODE_NOT_PAUSED";
	case 0xC0130015: return "STATUS_CLUSTER_NO_SECURITY_CONTEXT";
	case 0xC0130016: return "STATUS_CLUSTER_NETWORK_NOT_INTERNAL";
	case 0xC0130017: return "STATUS_CLUSTER_POISONED";
	case 0xC0140001: return "STATUS_ACPI_INVALID_OPCODE";
	case 0xC0140002: return "STATUS_ACPI_STACK_OVERFLOW";
	case 0xC0140003: return "STATUS_ACPI_ASSERT_FAILED";
	case 0xC0140004: return "STATUS_ACPI_INVALID_INDEX";
	case 0xC0140005: return "STATUS_ACPI_INVALID_ARGUMENT";
	case 0xC0140006: return "STATUS_ACPI_FATAL";
	case 0xC0140007: return "STATUS_ACPI_INVALID_SUPERNAME";
	case 0xC0140008: return "STATUS_ACPI_INVALID_ARGTYPE";
	case 0xC0140009: return "STATUS_ACPI_INVALID_OBJTYPE";
	case 0xC014000A: return "STATUS_ACPI_INVALID_TARGETTYPE";
	case 0xC014000B: return "STATUS_ACPI_INCORRECT_ARGUMENT_COUNT";
	case 0xC014000C: return "STATUS_ACPI_ADDRESS_NOT_MAPPED";
	case 0xC014000D: return "STATUS_ACPI_INVALID_EVENTTYPE";
	case 0xC014000E: return "STATUS_ACPI_HANDLER_COLLISION";
	case 0xC014000F: return "STATUS_ACPI_INVALID_DATA";
	case 0xC0140010: return "STATUS_ACPI_INVALID_REGION";
	case 0xC0140011: return "STATUS_ACPI_INVALID_ACCESS_SIZE";
	case 0xC0140012: return "STATUS_ACPI_ACQUIRE_GLOBAL_LOCK";
	case 0xC0140013: return "STATUS_ACPI_ALREADY_INITIALIZED";
	case 0xC0140014: return "STATUS_ACPI_NOT_INITIALIZED";
	case 0xC0140015: return "STATUS_ACPI_INVALID_MUTEX_LEVEL";
	case 0xC0140016: return "STATUS_ACPI_MUTEX_NOT_OWNED";
	case 0xC0140017: return "STATUS_ACPI_MUTEX_NOT_OWNER";
	case 0xC0140018: return "STATUS_ACPI_RS_ACCESS";
	case 0xC0140019: return "STATUS_ACPI_INVALID_TABLE";
	case 0xC0140020: return "STATUS_ACPI_REG_HANDLER_FAILED";
	case 0xC0140021: return "STATUS_ACPI_POWER_REQUEST_FAILED";
	case 0xC0150001: return "STATUS_SXS_SECTION_NOT_FOUND";
	case 0xC0150002: return "STATUS_SXS_CANT_GEN_ACTCTX";
	case 0xC0150003: return "STATUS_SXS_INVALID_ACTCTXDATA_FORMAT";
	case 0xC0150004: return "STATUS_SXS_ASSEMBLY_NOT_FOUND";
	case 0xC0150005: return "STATUS_SXS_MANIFEST_FORMAT_ERROR";
	case 0xC0150006: return "STATUS_SXS_MANIFEST_PARSE_ERROR";
	case 0xC0150007: return "STATUS_SXS_ACTIVATION_CONTEXT_DISABLED";
	case 0xC0150008: return "STATUS_SXS_KEY_NOT_FOUND";
	case 0xC0150009: return "STATUS_SXS_VERSION_CONFLICT";
	case 0xC015000A: return "STATUS_SXS_WRONG_SECTION_TYPE";
	case 0xC015000B: return "STATUS_SXS_THREAD_QUERIES_DISABLED";
	case 0xC015000C: return "STATUS_SXS_ASSEMBLY_MISSING";
	case 0xC015000E: return "STATUS_SXS_PROCESS_DEFAULT_ALREADY_SET";
	case 0xC015000F: return "STATUS_SXS_EARLY_DEACTIVATION";
	case 0xC0150010: return "STATUS_SXS_INVALID_DEACTIVATION";
	case 0xC0150011: return "STATUS_SXS_MULTIPLE_DEACTIVATION";
	case 0xC0150012: return "STATUS_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY";
	case 0xC0150013: return "STATUS_SXS_PROCESS_TERMINATION_REQUESTED";
	case 0xC0150014: return "STATUS_SXS_CORRUPT_ACTIVATION_STACK";
	case 0xC0150015: return "STATUS_SXS_CORRUPTION";
	case 0xC0150016: return "STATUS_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE";
	case 0xC0150017: return "STATUS_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME";
	case 0xC0150018: return "STATUS_SXS_IDENTITY_DUPLICATE_ATTRIBUTE";
	case 0xC0150019: return "STATUS_SXS_IDENTITY_PARSE_ERROR";
	case 0xC015001A: return "STATUS_SXS_COMPONENT_STORE_CORRUPT";
	case 0xC015001B: return "STATUS_SXS_FILE_HASH_MISMATCH";
	case 0xC015001C: return "STATUS_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT";
	case 0xC015001D: return "STATUS_SXS_IDENTITIES_DIFFERENT";
	case 0xC015001E: return "STATUS_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT";
	case 0xC015001F: return "STATUS_SXS_FILE_NOT_PART_OF_ASSEMBLY";
	case 0xC0150020: return "STATUS_ADVANCED_INSTALLER_FAILED";
	case 0xC0150021: return "STATUS_XML_ENCODING_MISMATCH";
	case 0xC0150022: return "STATUS_SXS_MANIFEST_TOO_BIG";
	case 0xC0150023: return "STATUS_SXS_SETTING_NOT_REGISTERED";
	case 0xC0150024: return "STATUS_SXS_TRANSACTION_CLOSURE_INCOMPLETE";
	case 0xC0150025: return "STATUS_SMI_PRIMITIVE_INSTALLER_FAILED";
	case 0xC0150026: return "STATUS_GENERIC_COMMAND_FAILED";
	case 0xC0150027: return "STATUS_SXS_FILE_HASH_MISSING";
	case 0xC0190001: return "STATUS_TRANSACTIONAL_CONFLICT";
	case 0xC0190002: return "STATUS_INVALID_TRANSACTION";
	case 0xC0190003: return "STATUS_TRANSACTION_NOT_ACTIVE";
	case 0xC0190004: return "STATUS_TM_INITIALIZATION_FAILED";
	case 0xC0190005: return "STATUS_RM_NOT_ACTIVE";
	case 0xC0190006: return "STATUS_RM_METADATA_CORRUPT";
	case 0xC0190007: return "STATUS_TRANSACTION_NOT_JOINED";
	case 0xC0190008: return "STATUS_DIRECTORY_NOT_RM";
	case 0xC019000A: return "STATUS_TRANSACTIONS_UNSUPPORTED_REMOTE";
	case 0xC019000B: return "STATUS_LOG_RESIZE_INVALID_SIZE";
	case 0xC019000C: return "STATUS_REMOTE_FILE_VERSION_MISMATCH";
	case 0xC019000F: return "STATUS_CRM_PROTOCOL_ALREADY_EXISTS";
	case 0xC0190010: return "STATUS_TRANSACTION_PROPAGATION_FAILED";
	case 0xC0190011: return "STATUS_CRM_PROTOCOL_NOT_FOUND";
	case 0xC0190012: return "STATUS_TRANSACTION_SUPERIOR_EXISTS";
	case 0xC0190013: return "STATUS_TRANSACTION_REQUEST_NOT_VALID";
	case 0xC0190014: return "STATUS_TRANSACTION_NOT_REQUESTED";
	case 0xC0190015: return "STATUS_TRANSACTION_ALREADY_ABORTED";
	case 0xC0190016: return "STATUS_TRANSACTION_ALREADY_COMMITTED";
	case 0xC0190017: return "STATUS_TRANSACTION_INVALID_MARSHALL_BUFFER";
	case 0xC0190018: return "STATUS_CURRENT_TRANSACTION_NOT_VALID";
	case 0xC0190019: return "STATUS_LOG_GROWTH_FAILED";
	case 0xC0190021: return "STATUS_OBJECT_NO_LONGER_EXISTS";
	case 0xC0190022: return "STATUS_STREAM_MINIVERSION_NOT_FOUND";
	case 0xC0190023: return "STATUS_STREAM_MINIVERSION_NOT_VALID";
	case 0xC0190024: return "STATUS_MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION";
	case 0xC0190025: return "STATUS_CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT";
	case 0xC0190026: return "STATUS_CANT_CREATE_MORE_STREAM_MINIVERSIONS";
	case 0xC0190028: return "STATUS_HANDLE_NO_LONGER_VALID";
	case 0xC0190030: return "STATUS_LOG_CORRUPTION_DETECTED";
	case 0xC0190032: return "STATUS_RM_DISCONNECTED";
	case 0xC0190033: return "STATUS_ENLISTMENT_NOT_SUPERIOR";
	case 0xC0190036: return "STATUS_FILE_IDENTITY_NOT_PERSISTENT";
	case 0xC0190037: return "STATUS_CANT_BREAK_TRANSACTIONAL_DEPENDENCY";
	case 0xC0190038: return "STATUS_CANT_CROSS_RM_BOUNDARY";
	case 0xC0190039: return "STATUS_TXF_DIR_NOT_EMPTY";
	case 0xC019003A: return "STATUS_INDOUBT_TRANSACTIONS_EXIST";
	case 0xC019003B: return "STATUS_TM_VOLATILE";
	case 0xC019003C: return "STATUS_ROLLBACK_TIMER_EXPIRED";
	case 0xC019003D: return "STATUS_TXF_ATTRIBUTE_CORRUPT";
	case 0xC019003E: return "STATUS_EFS_NOT_ALLOWED_IN_TRANSACTION";
	case 0xC019003F: return "STATUS_TRANSACTIONAL_OPEN_NOT_ALLOWED";
	case 0xC0190040: return "STATUS_TRANSACTED_MAPPING_UNSUPPORTED_REMOTE";
	case 0xC0190043: return "STATUS_TRANSACTION_REQUIRED_PROMOTION";
	case 0xC0190044: return "STATUS_CANNOT_EXECUTE_FILE_IN_TRANSACTION";
	case 0xC0190045: return "STATUS_TRANSACTIONS_NOT_FROZEN";
	case 0xC0190046: return "STATUS_TRANSACTION_FREEZE_IN_PROGRESS";
	case 0xC0190047: return "STATUS_NOT_SNAPSHOT_VOLUME";
	case 0xC0190048: return "STATUS_NO_SAVEPOINT_WITH_OPEN_FILES";
	case 0xC0190049: return "STATUS_SPARSE_NOT_ALLOWED_IN_TRANSACTION";
	case 0xC019004A: return "STATUS_TM_IDENTITY_MISMATCH";
	case 0xC019004B: return "STATUS_FLOATED_SECTION";
	case 0xC019004C: return "STATUS_CANNOT_ACCEPT_TRANSACTED_WORK";
	case 0xC019004D: return "STATUS_CANNOT_ABORT_TRANSACTIONS";
	case 0xC019004E: return "STATUS_TRANSACTION_NOT_FOUND";
	case 0xC019004F: return "STATUS_RESOURCEMANAGER_NOT_FOUND";
	case 0xC0190050: return "STATUS_ENLISTMENT_NOT_FOUND";
	case 0xC0190051: return "STATUS_TRANSACTIONMANAGER_NOT_FOUND";
	case 0xC0190052: return "STATUS_TRANSACTIONMANAGER_NOT_ONLINE";
	case 0xC0190053: return "STATUS_TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION";
	case 0xC0190054: return "STATUS_TRANSACTION_NOT_ROOT";
	case 0xC0190055: return "STATUS_TRANSACTION_OBJECT_EXPIRED";
	case 0xC0190056: return "STATUS_COMPRESSION_NOT_ALLOWED_IN_TRANSACTION";
	case 0xC0190057: return "STATUS_TRANSACTION_RESPONSE_NOT_ENLISTED";
	case 0xC0190058: return "STATUS_TRANSACTION_RECORD_TOO_LONG";
	case 0xC0190059: return "STATUS_NO_LINK_TRACKING_IN_TRANSACTION";
	case 0xC019005A: return "STATUS_OPERATION_NOT_SUPPORTED_IN_TRANSACTION";
	case 0xC019005B: return "STATUS_TRANSACTION_INTEGRITY_VIOLATED";
	case 0xC01A0001: return "STATUS_LOG_SECTOR_INVALID";
	case 0xC01A0002: return "STATUS_LOG_SECTOR_PARITY_INVALID";
	case 0xC01A0003: return "STATUS_LOG_SECTOR_REMAPPED";
	case 0xC01A0004: return "STATUS_LOG_BLOCK_INCOMPLETE";
	case 0xC01A0005: return "STATUS_LOG_INVALID_RANGE";
	case 0xC01A0006: return "STATUS_LOG_BLOCKS_EXHAUSTED";
	case 0xC01A0007: return "STATUS_LOG_READ_CONTEXT_INVALID";
	case 0xC01A0008: return "STATUS_LOG_RESTART_INVALID";
	case 0xC01A0009: return "STATUS_LOG_BLOCK_VERSION";
	case 0xC01A000A: return "STATUS_LOG_BLOCK_INVALID";
	case 0xC01A000B: return "STATUS_LOG_READ_MODE_INVALID";
	case 0xC01A000D: return "STATUS_LOG_METADATA_CORRUPT";
	case 0xC01A000E: return "STATUS_LOG_METADATA_INVALID";
	case 0xC01A000F: return "STATUS_LOG_METADATA_INCONSISTENT";
	case 0xC01A0010: return "STATUS_LOG_RESERVATION_INVALID";
	case 0xC01A0011: return "STATUS_LOG_CANT_DELETE";
	case 0xC01A0012: return "STATUS_LOG_CONTAINER_LIMIT_EXCEEDED";
	case 0xC01A0013: return "STATUS_LOG_START_OF_LOG";
	case 0xC01A0014: return "STATUS_LOG_POLICY_ALREADY_INSTALLED";
	case 0xC01A0015: return "STATUS_LOG_POLICY_NOT_INSTALLED";
	case 0xC01A0016: return "STATUS_LOG_POLICY_INVALID";
	case 0xC01A0017: return "STATUS_LOG_POLICY_CONFLICT";
	case 0xC01A0018: return "STATUS_LOG_PINNED_ARCHIVE_TAIL";
	case 0xC01A0019: return "STATUS_LOG_RECORD_NONEXISTENT";
	case 0xC01A001A: return "STATUS_LOG_RECORDS_RESERVED_INVALID";
	case 0xC01A001B: return "STATUS_LOG_SPACE_RESERVED_INVALID";
	case 0xC01A001C: return "STATUS_LOG_TAIL_INVALID";
	case 0xC01A001D: return "STATUS_LOG_FULL";
	case 0xC01A001E: return "STATUS_LOG_MULTIPLEXED";
	case 0xC01A001F: return "STATUS_LOG_DEDICATED";
	case 0xC01A0020: return "STATUS_LOG_ARCHIVE_NOT_IN_PROGRESS";
	case 0xC01A0021: return "STATUS_LOG_ARCHIVE_IN_PROGRESS";
	case 0xC01A0022: return "STATUS_LOG_EPHEMERAL";
	case 0xC01A0023: return "STATUS_LOG_NOT_ENOUGH_CONTAINERS";
	case 0xC01A0024: return "STATUS_LOG_CLIENT_ALREADY_REGISTERED";
	case 0xC01A0025: return "STATUS_LOG_CLIENT_NOT_REGISTERED";
	case 0xC01A0026: return "STATUS_LOG_FULL_HANDLER_IN_PROGRESS";
	case 0xC01A0027: return "STATUS_LOG_CONTAINER_READ_FAILED";
	case 0xC01A0028: return "STATUS_LOG_CONTAINER_WRITE_FAILED";
	case 0xC01A0029: return "STATUS_LOG_CONTAINER_OPEN_FAILED";
	case 0xC01A002A: return "STATUS_LOG_CONTAINER_STATE_INVALID";
	case 0xC01A002B: return "STATUS_LOG_STATE_INVALID";
	case 0xC01A002C: return "STATUS_LOG_PINNED";
	case 0xC01A002D: return "STATUS_LOG_METADATA_FLUSH_FAILED";
	case 0xC01A002E: return "STATUS_LOG_INCONSISTENT_SECURITY";
	case 0xC01A002F: return "STATUS_LOG_APPENDED_FLUSH_FAILED";
	case 0xC01A0030: return "STATUS_LOG_PINNED_RESERVATION";
	case 0xC01B00EA: return "STATUS_VIDEO_HUNG_DISPLAY_DRIVER_THREAD";
	case 0xC01C0001: return "STATUS_FLT_NO_HANDLER_DEFINED";
	case 0xC01C0002: return "STATUS_FLT_CONTEXT_ALREADY_DEFINED";
	case 0xC01C0003: return "STATUS_FLT_INVALID_ASYNCHRONOUS_REQUEST";
	case 0xC01C0004: return "STATUS_FLT_DISALLOW_FAST_IO";
	case 0xC01C0005: return "STATUS_FLT_INVALID_NAME_REQUEST";
	case 0xC01C0006: return "STATUS_FLT_NOT_SAFE_TO_POST_OPERATION";
	case 0xC01C0007: return "STATUS_FLT_NOT_INITIALIZED";
	case 0xC01C0008: return "STATUS_FLT_FILTER_NOT_READY";
	case 0xC01C0009: return "STATUS_FLT_POST_OPERATION_CLEANUP";
	case 0xC01C000A: return "STATUS_FLT_INTERNAL_ERROR";
	case 0xC01C000B: return "STATUS_FLT_DELETING_OBJECT";
	case 0xC01C000C: return "STATUS_FLT_MUST_BE_NONPAGED_POOL";
	case 0xC01C000D: return "STATUS_FLT_DUPLICATE_ENTRY";
	case 0xC01C000E: return "STATUS_FLT_CBDQ_DISABLED";
	case 0xC01C000F: return "STATUS_FLT_DO_NOT_ATTACH";
	case 0xC01C0010: return "STATUS_FLT_DO_NOT_DETACH";
	case 0xC01C0011: return "STATUS_FLT_INSTANCE_ALTITUDE_COLLISION";
	case 0xC01C0012: return "STATUS_FLT_INSTANCE_NAME_COLLISION";
	case 0xC01C0013: return "STATUS_FLT_FILTER_NOT_FOUND";
	case 0xC01C0014: return "STATUS_FLT_VOLUME_NOT_FOUND";
	case 0xC01C0015: return "STATUS_FLT_INSTANCE_NOT_FOUND";
	case 0xC01C0016: return "STATUS_FLT_CONTEXT_ALLOCATION_NOT_FOUND";
	case 0xC01C0017: return "STATUS_FLT_INVALID_CONTEXT_REGISTRATION";
	case 0xC01C0018: return "STATUS_FLT_NAME_CACHE_MISS";
	case 0xC01C0019: return "STATUS_FLT_NO_DEVICE_OBJECT";
	case 0xC01C001A: return "STATUS_FLT_VOLUME_ALREADY_MOUNTED";
	case 0xC01C001B: return "STATUS_FLT_ALREADY_ENLISTED";
	case 0xC01C001C: return "STATUS_FLT_CONTEXT_ALREADY_LINKED";
	case 0xC01C0020: return "STATUS_FLT_NO_WAITER_FOR_REPLY";
	case 0xC01D0001: return "STATUS_MONITOR_NO_DESCRIPTOR";
	case 0xC01D0002: return "STATUS_MONITOR_UNKNOWN_DESCRIPTOR_FORMAT";
	case 0xC01D0003: return "STATUS_MONITOR_INVALID_DESCRIPTOR_CHECKSUM";
	case 0xC01D0004: return "STATUS_MONITOR_INVALID_STANDARD_TIMING_BLOCK";
	case 0xC01D0005: return "STATUS_MONITOR_WMI_DATABLOCK_REGISTRATION_FAILED";
	case 0xC01D0006: return "STATUS_MONITOR_INVALID_SERIAL_NUMBER_MONDSC_BLOCK";
	case 0xC01D0007: return "STATUS_MONITOR_INVALID_USER_FRIENDLY_MONDSC_BLOCK";
	case 0xC01D0008: return "STATUS_MONITOR_NO_MORE_DESCRIPTOR_DATA";
	case 0xC01D0009: return "STATUS_MONITOR_INVALID_DETAILED_TIMING_BLOCK";
	case 0xC01E0000: return "STATUS_GRAPHICS_NOT_EXCLUSIVE_MODE_OWNER";
	case 0xC01E0001: return "STATUS_GRAPHICS_INSUFFICIENT_DMA_BUFFER";
	case 0xC01E0002: return "STATUS_GRAPHICS_INVALID_DISPLAY_ADAPTER";
	case 0xC01E0003: return "STATUS_GRAPHICS_ADAPTER_WAS_RESET";
	case 0xC01E0004: return "STATUS_GRAPHICS_INVALID_DRIVER_MODEL";
	case 0xC01E0005: return "STATUS_GRAPHICS_PRESENT_MODE_CHANGED";
	case 0xC01E0006: return "STATUS_GRAPHICS_PRESENT_OCCLUDED";
	case 0xC01E0007: return "STATUS_GRAPHICS_PRESENT_DENIED";
	case 0xC01E0008: return "STATUS_GRAPHICS_CANNOTCOLORCONVERT";
	case 0xC01E0009: return "STATUS_GRAPHICS_DRIVER_MISMATCH";
	case 0xC01E0100: return "STATUS_GRAPHICS_NO_VIDEO_MEMORY";
	case 0xC01E0101: return "STATUS_GRAPHICS_CANT_LOCK_MEMORY";
	case 0xC01E0102: return "STATUS_GRAPHICS_ALLOCATION_BUSY";
	case 0xC01E0103: return "STATUS_GRAPHICS_TOO_MANY_REFERENCES";
	case 0xC01E0104: return "STATUS_GRAPHICS_TRY_AGAIN_LATER";
	case 0xC01E0105: return "STATUS_GRAPHICS_TRY_AGAIN_NOW";
	case 0xC01E0106: return "STATUS_GRAPHICS_ALLOCATION_INVALID";
	case 0xC01E0107: return "STATUS_GRAPHICS_UNSWIZZLING_APERTURE_UNAVAILABLE";
	case 0xC01E0108: return "STATUS_GRAPHICS_UNSWIZZLING_APERTURE_UNSUPPORTED";
	case 0xC01E0109: return "STATUS_GRAPHICS_CANT_EVICT_PINNED_ALLOCATION";
	case 0xC01E0110: return "STATUS_GRAPHICS_INVALID_ALLOCATION_USAGE";
	case 0xC01E0111: return "STATUS_GRAPHICS_CANT_RENDER_LOCKED_ALLOCATION";
	case 0xC01E0112: return "STATUS_GRAPHICS_ALLOCATION_CLOSED";
	case 0xC01E0113: return "STATUS_GRAPHICS_INVALID_ALLOCATION_INSTANCE";
	case 0xC01E0114: return "STATUS_GRAPHICS_INVALID_ALLOCATION_HANDLE";
	case 0xC01E0115: return "STATUS_GRAPHICS_WRONG_ALLOCATION_DEVICE";
	case 0xC01E0116: return "STATUS_GRAPHICS_ALLOCATION_CONTENT_LOST";
	case 0xC01E0200: return "STATUS_GRAPHICS_GPU_EXCEPTION_ON_DEVICE";
	case 0xC01E0300: return "STATUS_GRAPHICS_INVALID_VIDPN_TOPOLOGY";
	case 0xC01E0301: return "STATUS_GRAPHICS_VIDPN_TOPOLOGY_NOT_SUPPORTED";
	case 0xC01E0302: return "STATUS_GRAPHICS_VIDPN_TOPOLOGY_CURRENTLY_NOT_SUPPORTED";
	case 0xC01E0303: return "STATUS_GRAPHICS_INVALID_VIDPN";
	case 0xC01E0304: return "STATUS_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE";
	case 0xC01E0305: return "STATUS_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET";
	case 0xC01E0306: return "STATUS_GRAPHICS_VIDPN_MODALITY_NOT_SUPPORTED";
	case 0xC01E0308: return "STATUS_GRAPHICS_INVALID_VIDPN_SOURCEMODESET";
	case 0xC01E0309: return "STATUS_GRAPHICS_INVALID_VIDPN_TARGETMODESET";
	case 0xC01E030A: return "STATUS_GRAPHICS_INVALID_FREQUENCY";
	case 0xC01E030B: return "STATUS_GRAPHICS_INVALID_ACTIVE_REGION";
	case 0xC01E030C: return "STATUS_GRAPHICS_INVALID_TOTAL_REGION";
	case 0xC01E0310: return "STATUS_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE_MODE";
	case 0xC01E0311: return "STATUS_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET_MODE";
	case 0xC01E0312: return "STATUS_GRAPHICS_PINNED_MODE_MUST_REMAIN_IN_SET";
	case 0xC01E0313: return "STATUS_GRAPHICS_PATH_ALREADY_IN_TOPOLOGY";
	case 0xC01E0314: return "STATUS_GRAPHICS_MODE_ALREADY_IN_MODESET";
	case 0xC01E0315: return "STATUS_GRAPHICS_INVALID_VIDEOPRESENTSOURCESET";
	case 0xC01E0316: return "STATUS_GRAPHICS_INVALID_VIDEOPRESENTTARGETSET";
	case 0xC01E0317: return "STATUS_GRAPHICS_SOURCE_ALREADY_IN_SET";
	case 0xC01E0318: return "STATUS_GRAPHICS_TARGET_ALREADY_IN_SET";
	case 0xC01E0319: return "STATUS_GRAPHICS_INVALID_VIDPN_PRESENT_PATH";
	case 0xC01E031A: return "STATUS_GRAPHICS_NO_RECOMMENDED_VIDPN_TOPOLOGY";
	case 0xC01E031B: return "STATUS_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGESET";
	case 0xC01E031C: return "STATUS_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE";
	case 0xC01E031D: return "STATUS_GRAPHICS_FREQUENCYRANGE_NOT_IN_SET";
	case 0xC01E031F: return "STATUS_GRAPHICS_FREQUENCYRANGE_ALREADY_IN_SET";
	case 0xC01E0320: return "STATUS_GRAPHICS_STALE_MODESET";
	case 0xC01E0321: return "STATUS_GRAPHICS_INVALID_MONITOR_SOURCEMODESET";
	case 0xC01E0322: return "STATUS_GRAPHICS_INVALID_MONITOR_SOURCE_MODE";
	case 0xC01E0323: return "STATUS_GRAPHICS_NO_RECOMMENDED_FUNCTIONAL_VIDPN";
	case 0xC01E0324: return "STATUS_GRAPHICS_MODE_ID_MUST_BE_UNIQUE";
	case 0xC01E0325: return "STATUS_GRAPHICS_EMPTY_ADAPTER_MONITOR_MODE_SUPPORT_INTERSECTION";
	case 0xC01E0326: return "STATUS_GRAPHICS_VIDEO_PRESENT_TARGETS_LESS_THAN_SOURCES";
	case 0xC01E0327: return "STATUS_GRAPHICS_PATH_NOT_IN_TOPOLOGY";
	case 0xC01E0328: return "STATUS_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_SOURCE";
	case 0xC01E0329: return "STATUS_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_TARGET";
	case 0xC01E032A: return "STATUS_GRAPHICS_INVALID_MONITORDESCRIPTORSET";
	case 0xC01E032B: return "STATUS_GRAPHICS_INVALID_MONITORDESCRIPTOR";
	case 0xC01E032C: return "STATUS_GRAPHICS_MONITORDESCRIPTOR_NOT_IN_SET";
	case 0xC01E032D: return "STATUS_GRAPHICS_MONITORDESCRIPTOR_ALREADY_IN_SET";
	case 0xC01E032E: return "STATUS_GRAPHICS_MONITORDESCRIPTOR_ID_MUST_BE_UNIQUE";
	case 0xC01E032F: return "STATUS_GRAPHICS_INVALID_VIDPN_TARGET_SUBSET_TYPE";
	case 0xC01E0330: return "STATUS_GRAPHICS_RESOURCES_NOT_RELATED";
	case 0xC01E0331: return "STATUS_GRAPHICS_SOURCE_ID_MUST_BE_UNIQUE";
	case 0xC01E0332: return "STATUS_GRAPHICS_TARGET_ID_MUST_BE_UNIQUE";
	case 0xC01E0333: return "STATUS_GRAPHICS_NO_AVAILABLE_VIDPN_TARGET";
	case 0xC01E0334: return "STATUS_GRAPHICS_MONITOR_COULD_NOT_BE_ASSOCIATED_WITH_ADAPTER";
	case 0xC01E0335: return "STATUS_GRAPHICS_NO_VIDPNMGR";
	case 0xC01E0336: return "STATUS_GRAPHICS_NO_ACTIVE_VIDPN";
	case 0xC01E0337: return "STATUS_GRAPHICS_STALE_VIDPN_TOPOLOGY";
	case 0xC01E0338: return "STATUS_GRAPHICS_MONITOR_NOT_CONNECTED";
	case 0xC01E0339: return "STATUS_GRAPHICS_SOURCE_NOT_IN_TOPOLOGY";
	case 0xC01E033A: return "STATUS_GRAPHICS_INVALID_PRIMARYSURFACE_SIZE";
	case 0xC01E033B: return "STATUS_GRAPHICS_INVALID_VISIBLEREGION_SIZE";
	case 0xC01E033C: return "STATUS_GRAPHICS_INVALID_STRIDE";
	case 0xC01E033D: return "STATUS_GRAPHICS_INVALID_PIXELFORMAT";
	case 0xC01E033E: return "STATUS_GRAPHICS_INVALID_COLORBASIS";
	case 0xC01E033F: return "STATUS_GRAPHICS_INVALID_PIXELVALUEACCESSMODE";
	case 0xC01E0340: return "STATUS_GRAPHICS_TARGET_NOT_IN_TOPOLOGY";
	case 0xC01E0341: return "STATUS_GRAPHICS_NO_DISPLAY_MODE_MANAGEMENT_SUPPORT";
	case 0xC01E0342: return "STATUS_GRAPHICS_VIDPN_SOURCE_IN_USE";
	case 0xC01E0343: return "STATUS_GRAPHICS_CANT_ACCESS_ACTIVE_VIDPN";
	case 0xC01E0344: return "STATUS_GRAPHICS_INVALID_PATH_IMPORTANCE_ORDINAL";
	case 0xC01E0345: return "STATUS_GRAPHICS_INVALID_PATH_CONTENT_GEOMETRY_TRANSFORMATION";
	case 0xC01E0346: return "STATUS_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_SUPPORTED";
	case 0xC01E0347: return "STATUS_GRAPHICS_INVALID_GAMMA_RAMP";
	case 0xC01E0348: return "STATUS_GRAPHICS_GAMMA_RAMP_NOT_SUPPORTED";
	case 0xC01E0349: return "STATUS_GRAPHICS_MULTISAMPLING_NOT_SUPPORTED";
	case 0xC01E034A: return "STATUS_GRAPHICS_MODE_NOT_IN_MODESET";
	case 0xC01E034D: return "STATUS_GRAPHICS_INVALID_VIDPN_TOPOLOGY_RECOMMENDATION_REASON";
	case 0xC01E034E: return "STATUS_GRAPHICS_INVALID_PATH_CONTENT_TYPE";
	case 0xC01E034F: return "STATUS_GRAPHICS_INVALID_COPYPROTECTION_TYPE";
	case 0xC01E0350: return "STATUS_GRAPHICS_UNASSIGNED_MODESET_ALREADY_EXISTS";
	case 0xC01E0352: return "STATUS_GRAPHICS_INVALID_SCANLINE_ORDERING";
	case 0xC01E0353: return "STATUS_GRAPHICS_TOPOLOGY_CHANGES_NOT_ALLOWED";
	case 0xC01E0354: return "STATUS_GRAPHICS_NO_AVAILABLE_IMPORTANCE_ORDINALS";
	case 0xC01E0355: return "STATUS_GRAPHICS_INCOMPATIBLE_PRIVATE_FORMAT";
	case 0xC01E0356: return "STATUS_GRAPHICS_INVALID_MODE_PRUNING_ALGORITHM";
	case 0xC01E0357: return "STATUS_GRAPHICS_INVALID_MONITOR_CAPABILITY_ORIGIN";
	case 0xC01E0358: return "STATUS_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE_CONSTRAINT";
	case 0xC01E0359: return "STATUS_GRAPHICS_MAX_NUM_PATHS_REACHED";
	case 0xC01E035A: return "STATUS_GRAPHICS_CANCEL_VIDPN_TOPOLOGY_AUGMENTATION";
	case 0xC01E035B: return "STATUS_GRAPHICS_INVALID_CLIENT_TYPE";
	case 0xC01E035C: return "STATUS_GRAPHICS_CLIENTVIDPN_NOT_SET";
	case 0xC01E0400: return "STATUS_GRAPHICS_SPECIFIED_CHILD_ALREADY_CONNECTED";
	case 0xC01E0401: return "STATUS_GRAPHICS_CHILD_DESCRIPTOR_NOT_SUPPORTED";
	case 0xC01E0430: return "STATUS_GRAPHICS_NOT_A_LINKED_ADAPTER";
	case 0xC01E0431: return "STATUS_GRAPHICS_LEADLINK_NOT_ENUMERATED";
	case 0xC01E0432: return "STATUS_GRAPHICS_CHAINLINKS_NOT_ENUMERATED";
	case 0xC01E0433: return "STATUS_GRAPHICS_ADAPTER_CHAIN_NOT_READY";
	case 0xC01E0434: return "STATUS_GRAPHICS_CHAINLINKS_NOT_STARTED";
	case 0xC01E0435: return "STATUS_GRAPHICS_CHAINLINKS_NOT_POWERED_ON";
	case 0xC01E0436: return "STATUS_GRAPHICS_INCONSISTENT_DEVICE_LINK_STATE";
	case 0xC01E0438: return "STATUS_GRAPHICS_NOT_POST_DEVICE_DRIVER";
	case 0xC01E043B: return "STATUS_GRAPHICS_ADAPTER_ACCESS_NOT_EXCLUDED";
	case 0xC01E0500: return "STATUS_GRAPHICS_OPM_NOT_SUPPORTED";
	case 0xC01E0501: return "STATUS_GRAPHICS_COPP_NOT_SUPPORTED";
	case 0xC01E0502: return "STATUS_GRAPHICS_UAB_NOT_SUPPORTED";
	case 0xC01E0503: return "STATUS_GRAPHICS_OPM_INVALID_ENCRYPTED_PARAMETERS";
	case 0xC01E0505: return "STATUS_GRAPHICS_OPM_NO_PROTECTED_OUTPUTS_EXIST";
	case 0xC01E050B: return "STATUS_GRAPHICS_OPM_INTERNAL_ERROR";
	case 0xC01E050C: return "STATUS_GRAPHICS_OPM_INVALID_HANDLE";
	case 0xC01E050E: return "STATUS_GRAPHICS_PVP_INVALID_CERTIFICATE_LENGTH";
	case 0xC01E050F: return "STATUS_GRAPHICS_OPM_SPANNING_MODE_ENABLED";
	case 0xC01E0510: return "STATUS_GRAPHICS_OPM_THEATER_MODE_ENABLED";
	case 0xC01E0511: return "STATUS_GRAPHICS_PVP_HFS_FAILED";
	case 0xC01E0512: return "STATUS_GRAPHICS_OPM_INVALID_SRM";
	case 0xC01E0513: return "STATUS_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_HDCP";
	case 0xC01E0514: return "STATUS_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_ACP";
	case 0xC01E0515: return "STATUS_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_CGMSA";
	case 0xC01E0516: return "STATUS_GRAPHICS_OPM_HDCP_SRM_NEVER_SET";
	case 0xC01E0517: return "STATUS_GRAPHICS_OPM_RESOLUTION_TOO_HIGH";
	case 0xC01E0518: return "STATUS_GRAPHICS_OPM_ALL_HDCP_HARDWARE_ALREADY_IN_USE";
	case 0xC01E051A: return "STATUS_GRAPHICS_OPM_PROTECTED_OUTPUT_NO_LONGER_EXISTS";
	case 0xC01E051C: return "STATUS_GRAPHICS_OPM_PROTECTED_OUTPUT_DOES_NOT_HAVE_COPP_SEMANTICS";
	case 0xC01E051D: return "STATUS_GRAPHICS_OPM_INVALID_INFORMATION_REQUEST";
	case 0xC01E051E: return "STATUS_GRAPHICS_OPM_DRIVER_INTERNAL_ERROR";
	case 0xC01E051F: return "STATUS_GRAPHICS_OPM_PROTECTED_OUTPUT_DOES_NOT_HAVE_OPM_SEMANTICS";
	case 0xC01E0520: return "STATUS_GRAPHICS_OPM_SIGNALING_NOT_SUPPORTED";
	case 0xC01E0521: return "STATUS_GRAPHICS_OPM_INVALID_CONFIGURATION_REQUEST";
	case 0xC01E0580: return "STATUS_GRAPHICS_I2C_NOT_SUPPORTED";
	case 0xC01E0581: return "STATUS_GRAPHICS_I2C_DEVICE_DOES_NOT_EXIST";
	case 0xC01E0582: return "STATUS_GRAPHICS_I2C_ERROR_TRANSMITTING_DATA";
	case 0xC01E0583: return "STATUS_GRAPHICS_I2C_ERROR_RECEIVING_DATA";
	case 0xC01E0584: return "STATUS_GRAPHICS_DDCCI_VCP_NOT_SUPPORTED";
	case 0xC01E0585: return "STATUS_GRAPHICS_DDCCI_INVALID_DATA";
	case 0xC01E0586: return "STATUS_GRAPHICS_DDCCI_MONITOR_RETURNED_INVALID_TIMING_STATUS_BYTE";
	case 0xC01E0587: return "STATUS_GRAPHICS_DDCCI_INVALID_CAPABILITIES_STRING";
	case 0xC01E0588: return "STATUS_GRAPHICS_MCA_INTERNAL_ERROR";
	case 0xC01E0589: return "STATUS_GRAPHICS_DDCCI_INVALID_MESSAGE_COMMAND";
	case 0xC01E058A: return "STATUS_GRAPHICS_DDCCI_INVALID_MESSAGE_LENGTH";
	case 0xC01E058B: return "STATUS_GRAPHICS_DDCCI_INVALID_MESSAGE_CHECKSUM";
	case 0xC01E058C: return "STATUS_GRAPHICS_INVALID_PHYSICAL_MONITOR_HANDLE";
	case 0xC01E058D: return "STATUS_GRAPHICS_MONITOR_NO_LONGER_EXISTS";
	case 0xC01E05E0: return "STATUS_GRAPHICS_ONLY_CONSOLE_SESSION_SUPPORTED";
	case 0xC01E05E1: return "STATUS_GRAPHICS_NO_DISPLAY_DEVICE_CORRESPONDS_TO_NAME";
	case 0xC01E05E2: return "STATUS_GRAPHICS_DISPLAY_DEVICE_NOT_ATTACHED_TO_DESKTOP";
	case 0xC01E05E3: return "STATUS_GRAPHICS_MIRRORING_DEVICES_NOT_SUPPORTED";
	case 0xC01E05E4: return "STATUS_GRAPHICS_INVALID_POINTER";
	case 0xC01E05E5: return "STATUS_GRAPHICS_NO_MONITORS_CORRESPOND_TO_DISPLAY_DEVICE";
	case 0xC01E05E6: return "STATUS_GRAPHICS_PARAMETER_ARRAY_TOO_SMALL";
	case 0xC01E05E7: return "STATUS_GRAPHICS_INTERNAL_ERROR";
	case 0xC01E05E8: return "STATUS_GRAPHICS_SESSION_TYPE_CHANGE_IN_PROGRESS";
	case 0xC0210000: return "STATUS_FVE_LOCKED_VOLUME";
	case 0xC0210001: return "STATUS_FVE_NOT_ENCRYPTED";
	case 0xC0210002: return "STATUS_FVE_BAD_INFORMATION";
	case 0xC0210003: return "STATUS_FVE_TOO_SMALL";
	case 0xC0210004: return "STATUS_FVE_FAILED_WRONG_FS";
	case 0xC0210005: return "STATUS_FVE_FAILED_BAD_FS";
	case 0xC0210006: return "STATUS_FVE_FS_NOT_EXTENDED";
	case 0xC0210007: return "STATUS_FVE_FS_MOUNTED";
	case 0xC0210008: return "STATUS_FVE_NO_LICENSE";
	case 0xC0210009: return "STATUS_FVE_ACTION_NOT_ALLOWED";
	case 0xC021000A: return "STATUS_FVE_BAD_DATA";
	case 0xC021000B: return "STATUS_FVE_VOLUME_NOT_BOUND";
	case 0xC021000C: return "STATUS_FVE_NOT_DATA_VOLUME";
	case 0xC021000D: return "STATUS_FVE_CONV_READ_ERROR";
	case 0xC021000E: return "STATUS_FVE_CONV_WRITE_ERROR";
	case 0xC021000F: return "STATUS_FVE_OVERLAPPED_UPDATE";
	case 0xC0210010: return "STATUS_FVE_FAILED_SECTOR_SIZE";
	case 0xC0210011: return "STATUS_FVE_FAILED_AUTHENTICATION";
	case 0xC0210012: return "STATUS_FVE_NOT_OS_VOLUME";
	case 0xC0210013: return "STATUS_FVE_KEYFILE_NOT_FOUND";
	case 0xC0210014: return "STATUS_FVE_KEYFILE_INVALID";
	case 0xC0210015: return "STATUS_FVE_KEYFILE_NO_VMK";
	case 0xC0210016: return "STATUS_FVE_TPM_DISABLED";
	case 0xC0210017: return "STATUS_FVE_TPM_SRK_AUTH_NOT_ZERO";
	case 0xC0210018: return "STATUS_FVE_TPM_INVALID_PCR";
	case 0xC0210019: return "STATUS_FVE_TPM_NO_VMK";
	case 0xC021001A: return "STATUS_FVE_PIN_INVALID";
	case 0xC021001B: return "STATUS_FVE_AUTH_INVALID_APPLICATION";
	case 0xC021001C: return "STATUS_FVE_AUTH_INVALID_CONFIG";
	case 0xC021001D: return "STATUS_FVE_DEBUGGER_ENABLED";
	case 0xC021001E: return "STATUS_FVE_DRY_RUN_FAILED";
	case 0xC021001F: return "STATUS_FVE_BAD_METADATA_POINTER";
	case 0xC0210020: return "STATUS_FVE_OLD_METADATA_COPY";
	case 0xC0210021: return "STATUS_FVE_REBOOT_REQUIRED";
	case 0xC0210022: return "STATUS_FVE_RAW_ACCESS";
	case 0xC0210023: return "STATUS_FVE_RAW_BLOCKED";
	case 0xC0220001: return "STATUS_FWP_CALLOUT_NOT_FOUND";
	case 0xC0220002: return "STATUS_FWP_CONDITION_NOT_FOUND";
	case 0xC0220003: return "STATUS_FWP_FILTER_NOT_FOUND";
	case 0xC0220004: return "STATUS_FWP_LAYER_NOT_FOUND";
	case 0xC0220005: return "STATUS_FWP_PROVIDER_NOT_FOUND";
	case 0xC0220006: return "STATUS_FWP_PROVIDER_CONTEXT_NOT_FOUND";
	case 0xC0220007: return "STATUS_FWP_SUBLAYER_NOT_FOUND";
	case 0xC0220008: return "STATUS_FWP_NOT_FOUND";
	case 0xC0220009: return "STATUS_FWP_ALREADY_EXISTS";
	case 0xC022000A: return "STATUS_FWP_IN_USE";
	case 0xC022000B: return "STATUS_FWP_DYNAMIC_SESSION_IN_PROGRESS";
	case 0xC022000C: return "STATUS_FWP_WRONG_SESSION";
	case 0xC022000D: return "STATUS_FWP_NO_TXN_IN_PROGRESS";
	case 0xC022000E: return "STATUS_FWP_TXN_IN_PROGRESS";
	case 0xC022000F: return "STATUS_FWP_TXN_ABORTED";
	case 0xC0220010: return "STATUS_FWP_SESSION_ABORTED";
	case 0xC0220011: return "STATUS_FWP_INCOMPATIBLE_TXN";
	case 0xC0220012: return "STATUS_FWP_TIMEOUT";
	case 0xC0220013: return "STATUS_FWP_NET_EVENTS_DISABLED";
	case 0xC0220014: return "STATUS_FWP_INCOMPATIBLE_LAYER";
	case 0xC0220015: return "STATUS_FWP_KM_CLIENTS_ONLY";
	case 0xC0220016: return "STATUS_FWP_LIFETIME_MISMATCH";
	case 0xC0220017: return "STATUS_FWP_BUILTIN_OBJECT";
	case 0xC0220018: return "STATUS_FWP_TOO_MANY_CALLOUTS";
	case 0xC0220019: return "STATUS_FWP_NOTIFICATION_DROPPED";
	case 0xC022001A: return "STATUS_FWP_TRAFFIC_MISMATCH";
	case 0xC022001B: return "STATUS_FWP_INCOMPATIBLE_SA_STATE";
	case 0xC022001C: return "STATUS_FWP_NULL_POINTER";
	case 0xC022001D: return "STATUS_FWP_INVALID_ENUMERATOR";
	case 0xC022001E: return "STATUS_FWP_INVALID_FLAGS";
	case 0xC022001F: return "STATUS_FWP_INVALID_NET_MASK";
	case 0xC0220020: return "STATUS_FWP_INVALID_RANGE";
	case 0xC0220021: return "STATUS_FWP_INVALID_INTERVAL";
	case 0xC0220022: return "STATUS_FWP_ZERO_LENGTH_ARRAY";
	case 0xC0220023: return "STATUS_FWP_NULL_DISPLAY_NAME";
	case 0xC0220024: return "STATUS_FWP_INVALID_ACTION_TYPE";
	case 0xC0220025: return "STATUS_FWP_INVALID_WEIGHT";
	case 0xC0220026: return "STATUS_FWP_MATCH_TYPE_MISMATCH";
	case 0xC0220027: return "STATUS_FWP_TYPE_MISMATCH";
	case 0xC0220028: return "STATUS_FWP_OUT_OF_BOUNDS";
	case 0xC0220029: return "STATUS_FWP_RESERVED";
	case 0xC022002A: return "STATUS_FWP_DUPLICATE_CONDITION";
	case 0xC022002B: return "STATUS_FWP_DUPLICATE_KEYMOD";
	case 0xC022002C: return "STATUS_FWP_ACTION_INCOMPATIBLE_WITH_LAYER";
	case 0xC022002D: return "STATUS_FWP_ACTION_INCOMPATIBLE_WITH_SUBLAYER";
	case 0xC022002E: return "STATUS_FWP_CONTEXT_INCOMPATIBLE_WITH_LAYER";
	case 0xC022002F: return "STATUS_FWP_CONTEXT_INCOMPATIBLE_WITH_CALLOUT";
	case 0xC0220030: return "STATUS_FWP_INCOMPATIBLE_AUTH_METHOD";
	case 0xC0220031: return "STATUS_FWP_INCOMPATIBLE_DH_GROUP";
	case 0xC0220032: return "STATUS_FWP_EM_NOT_SUPPORTED";
	case 0xC0220033: return "STATUS_FWP_NEVER_MATCH";
	case 0xC0220034: return "STATUS_FWP_PROVIDER_CONTEXT_MISMATCH";
	case 0xC0220035: return "STATUS_FWP_INVALID_PARAMETER";
	case 0xC0220036: return "STATUS_FWP_TOO_MANY_SUBLAYERS";
	case 0xC0220037: return "STATUS_FWP_CALLOUT_NOTIFICATION_FAILED";
	case 0xC0220038: return "STATUS_FWP_INVALID_AUTH_TRANSFORM";
	case 0xC0220039: return "STATUS_FWP_INVALID_CIPHER_TRANSFORM";
	case 0xC0220100: return "STATUS_FWP_TCPIP_NOT_READY";
	case 0xC0220101: return "STATUS_FWP_INJECT_HANDLE_CLOSING";
	case 0xC0220102: return "STATUS_FWP_INJECT_HANDLE_STALE";
	case 0xC0220103: return "STATUS_FWP_CANNOT_PEND";
	case 0xC0230002: return "STATUS_NDIS_CLOSING";
	case 0xC0230004: return "STATUS_NDIS_BAD_VERSION";
	case 0xC0230005: return "STATUS_NDIS_BAD_CHARACTERISTICS";
	case 0xC0230006: return "STATUS_NDIS_ADAPTER_NOT_FOUND";
	case 0xC0230007: return "STATUS_NDIS_OPEN_FAILED";
	case 0xC0230008: return "STATUS_NDIS_DEVICE_FAILED";
	case 0xC0230009: return "STATUS_NDIS_MULTICAST_FULL";
	case 0xC023000A: return "STATUS_NDIS_MULTICAST_EXISTS";
	case 0xC023000B: return "STATUS_NDIS_MULTICAST_NOT_FOUND";
	case 0xC023000C: return "STATUS_NDIS_REQUEST_ABORTED";
	case 0xC023000D: return "STATUS_NDIS_RESET_IN_PROGRESS";
	case 0xC023000F: return "STATUS_NDIS_INVALID_PACKET";
	case 0xC0230010: return "STATUS_NDIS_INVALID_DEVICE_REQUEST";
	case 0xC0230011: return "STATUS_NDIS_ADAPTER_NOT_READY";
	case 0xC0230014: return "STATUS_NDIS_INVALID_LENGTH";
	case 0xC0230015: return "STATUS_NDIS_INVALID_DATA";
	case 0xC0230016: return "STATUS_NDIS_BUFFER_TOO_SHORT";
	case 0xC0230017: return "STATUS_NDIS_INVALID_OID";
	case 0xC0230018: return "STATUS_NDIS_ADAPTER_REMOVED";
	case 0xC0230019: return "STATUS_NDIS_UNSUPPORTED_MEDIA";
	case 0xC023001A: return "STATUS_NDIS_GROUP_ADDRESS_IN_USE";
	case 0xC023001B: return "STATUS_NDIS_FILE_NOT_FOUND";
	case 0xC023001C: return "STATUS_NDIS_ERROR_READING_FILE";
	case 0xC023001D: return "STATUS_NDIS_ALREADY_MAPPED";
	case 0xC023001E: return "STATUS_NDIS_RESOURCE_CONFLICT";
	case 0xC023001F: return "STATUS_NDIS_MEDIA_DISCONNECTED";
	case 0xC0230022: return "STATUS_NDIS_INVALID_ADDRESS";
	case 0xC023002A: return "STATUS_NDIS_PAUSED";
	case 0xC023002B: return "STATUS_NDIS_INTERFACE_NOT_FOUND";
	case 0xC023002C: return "STATUS_NDIS_UNSUPPORTED_REVISION";
	case 0xC023002D: return "STATUS_NDIS_INVALID_PORT";
	case 0xC023002E: return "STATUS_NDIS_INVALID_PORT_STATE";
	case 0xC023002F: return "STATUS_NDIS_LOW_POWER_STATE";
	case 0xC02300BB: return "STATUS_NDIS_NOT_SUPPORTED";
	case 0xC0232000: return "STATUS_NDIS_DOT11_AUTO_CONFIG_ENABLED";
	case 0xC0232001: return "STATUS_NDIS_DOT11_MEDIA_IN_USE";
	case 0xC0232002: return "STATUS_NDIS_DOT11_POWER_STATE_INVALID";
	case 0xC0360001: return "STATUS_IPSEC_BAD_SPI";
	case 0xC0360002: return "STATUS_IPSEC_SA_LIFETIME_EXPIRED";
	case 0xC0360003: return "STATUS_IPSEC_WRONG_SA";
	case 0xC0360004: return "STATUS_IPSEC_REPLAY_CHECK_FAILED";
	case 0xC0360005: return "STATUS_IPSEC_INVALID_PACKET";
	case 0xC0360006: return "STATUS_IPSEC_INTEGRITY_CHECK_FAILED";
	case 0xC0360007: return "STATUS_IPSEC_CLEAR_TEXT_DROP";
	default: return "UNKNOWN";
	}
}
