
/********************************
	Macors which inline assembly
 ********************************/
 
// Saves the value of esp to var
#define STORE_ESP(var) 	asm("movl %%esp, %0;" : "=r" ( var ))

// Loads the contents of var into esp
#define LOAD_ESP(var) 	asm("movl %0, %%esp;" : : "r" ( var ))

// Calls the function func
#define CALL(addr)		asm("call *%0;" : : "r" ( addr ))

// Pushes the contents of var to the stack
#define PUSH(var)		asm("movl %0, %%edi; push %%edi;" : : "r" ( var ))



#define MAX_UTHREADS 64

// Represents a ULT. 
// Feel free to extend this definition as needed.
typedef struct
{
	int tid;				// A unique thread ID within the process
	void *ss_sp;		// Stack base or pointer
	size_t ss_size;	// Stack size
	int priority;		// The priority of the thread 09 (0 is highest)
} uthread_t;

// A function that wraps the entry functipn of a thread.
// This is just a siggestion, fell free to modify it as needed.
void wrap_function(void (*entry)())
{
  entry();
  uthread_exit();
}

/********************************
	The API of the ULT package
 ********************************/
 
int uthread_create(void (*start_func)(), int priority);
void uthread_yield();
void uthread_exit();
int uthread_start_all();
int uthread_setpr(int priority);
int uthread_getpr();
uthread_t uthread_self();