
	      ____          _ ____      _  __
	     / __/_______  (_) __ \____| |/ /
	    / /_/ ___/ _ \/ / / / / ___/   / 
	   / __/ /  /  __/ / /_/ / /  /   |  
	  /_/ /_/   \___/_/\____/_/  /_/|_|  
	                                     
  Minimalistic plugin API for video effects - eXtended v.0.1
  ==========================================================

http://github.com/mojaves/tycho-plugins


Introduction
------------

Frei0rX (or equivalently spelled frei0rx) is a bare-minimum extension to
frei0r made in order to ease the porting of the transcode filters, and aimed
to the video processing.
Trying to catch up the spirit of frei0r, the extension is intentionally kept
minimal. Moreover, extra care is spent to ensure the backward compatibility
to frei0r.

See the frei0rx header file, include/frei0rx.h for the doxyfied complete
documentation.


API stability
-------------

frei0rX is not stable yet. This means the extensions are not stabilized
and they are subject to change. The two driving factors for the evolution
are

* to minimize the impact and the extent of such extensions, in order to
  ease as much as possible the chances of mainstream adoption.

* to maximize the backward compatibility.

Expect changes until the first stable release (1.0 or something like that).



YUV Planar support
------------------

* a new color model (set) is introduced, YUV420P.

* a new frame structure is provided.
	
The packed 32 bir colorspace allow the API to safely assume the memory
structure of the frame, given the constraints also required.
However, the planar structure cannot easily fit in this schema.
The bare-minimum extra information needed are the separate plane pointers
and the separate pitch (aka stride) sizes. And that is exactly
what the new frame structure provides.



Audio filtering support
-----------------------

The scope of frei0r is stretched as much as is needed to let the host
exploit it for audio filtering as well. This will likely be the most
contended extension.

The key point behind this extension is frei0r is simple and generic
enough to allow this extension without much (syntactic) pain.

the plugin info structure is thus extended with two new fields describing

* the expected content type for the plugin (audio or video, currently)

* the layout of the audio data, much like the color model information
  for the video data.


New functions and new data structures
-------------------------------------

All the extensions are implemented in terms of functions and data structures
with new symbols prefixed with 'f0rx_', overriding the frei0r ones.

An host willing to use the frei0rx extension should lookup the extended
symbols first, then fallback on the frei0r ones.

NOTE: a frei0rx compliant plugin MUST implement ALL of the extended
functions.

Backward compatibility
----------------------

Of course an audio frei0rx plugin cannot made backward compatible.

However, for video frei0rx plugins, full backward compatibility
is required. A frei0rx plugin MUST BE also a valid frei0r plugin.
A frei0rx plugin must be always correct and weel behaving with respect
of the API, and must use the extensions only to be faster.


#EOF

