#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>

#define FNAME "/home/suzuki/txt/test%d.txt"
#define FLNAMELEN 50
#define FNUM 10000
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>

suseconds_t tvdiff_usec(struct timeval *before,
                        struct timeval *after)
{
  suseconds_t before_usec = before->tv_usec + before->tv_sec * 1000000;
  suseconds_t after_usec = after->tv_usec + after->tv_sec * 1000000;
  return after_usec - before_usec;
}

int main(int argc, char *argv[])
{
  struct timeval tv0, tv1;
  int i;
  int fds[FNUM];
  char **fnames;
  char *f;
  mode_t perm=0777;
  int sumdiff = 0;
  fnames = malloc(sizeof(char *) * FNUM);
  for (i=0; i<FNUM; ++i) {
    fnames[i] = malloc(sizeof(char) * FLNAMELEN);
  }

  if (fnames == NULL) {
    perror("malloc");
    return 1;
  }
  for (i=0; i<FNUM; ++i) {
    /* "txt/test0.txt" .. "txt/test999.txt" */
    snprintf(fnames[i], FLNAMELEN, FNAME, i);
  }

  gettimeofday(&tv0, NULL);
  for (i=0; i<FNUM; ++i) {
    f = fnames[i];
    fds[i] = open(f, O_CREAT, perm);
    write(fds[i], "hello", 5);
  }
  gettimeofday(&tv1, NULL);

  for (i=0; i<FNUM; ++i) {
    close(fds[i]);
    free(fnames[i]);
  }
  free(fnames);
  sumdiff += tvdiff_usec(&tv0, &tv1);
  printf("  Sum diff: %d (usec) in %d loops\n", sumdiff, FNUM);
  printf("  Usec per one open: %0.3f (usec)\n", (double)sumdiff/FNUM);
  return 0;
}
